﻿/**
 * Created by zj on 2015/10/28 0028.
 * ����Ƭ
 */
var EffectSpecia = cc.Class.extend({
    ctor:function(){
        this.isActive = false;
        this.lastTime = 0;
        this.degree = 0;
        this.blendFunc = {src: cc.BLEND_SRC, dst: cc.BLEND_DST};
        this._CreateProgram();
    },

    _CreateProgram:function(){
        var program = Filter.GetSpeciaProgram();
        this.uniformDegree = program.getUniformLocationForName("u_degree");
        this.shaderProgram = program;
    },

    OnFrame:function(){
        var curTime = TimerUtil.GetTimer();
        if (this.lastTime == 0){
            this.lastTime = curTime;
        }

        if (curTime - this.lastTime > 100 ){
            this.lastTime = curTime;
            this.degree += 0.1;
            this.degree = this.degree > 1 ? 1 : this.degree;
        }
    },

    Active:function(active){
        this.isActive = active;
        this.lastTime = 0;
        this.degree = 0;
    },

    Dispose:function(){
        this.shaderProgram = null;
        this.uniformDegree = null;
    }
});