/**
 * 基于JSB原生的动画资源管理器
 * yq
 * 2016年4月9日
 * AssetsManager 
 */

var ResAnimationMgr = ResAnimationMgr || {
	
	/**
	 * 参数url: 目录直到文件名，(注意不包含后缀名)
	 * 参数callfun:回调函数callfun( SpriteFrame数组 ) 
	 **/
	LoadAnimatoin:function( url, callfun, datadir ){
		
		var plistName = url + ".plist";
		var imgName = url + ".png";
		
		LoadMgr.LoadCdnFile( plistName, function(){
			cc.loader.loadTxt( plistName, function( err, txt ){
				if ( err != null || !txt ){		//jsb不会报错 只会返回空字符串
					zz.Error( "Error LoadAnimationTxt! URL:" + plistName + " info:" + err );
					return;
				}

				var dict = cc.plistParser.parse( txt );

				LoadMgr.LoadCdnFile( imgName, function() {
					if ( !cc.spriteFrameCache.isSpriteFramesWithFileLoaded( plistName ) ){
						cc.spriteFrameCache.addSpriteFrames( plistName,  imgName );
					}

					var frameDict = dict["frames"];
					var animDict = dict["metadata"];
					var framesArr = [];
					for (var key in frameDict) {
						var oo = cc.spriteFrameCache.getSpriteFrame(key);
						if ( oo.getTexture() instanceof Object)
							framesArr.push(oo);
					}

					callfun.call( datadir,  {frames:framesArr, animmeta:animDict} );
					// cc.loader.loadImg( imgName, function (err, img) {
					// 	if (err != null) {
					// 		// 加载错误
					// 		zz.Error( "Error LoadAnimationTxt! URL:" + imgName + " info:" + err );
					// 		return;
					// 	} else {
					// 		var texture2d = new cc.Texture2D();
                    //
					// 		if (EngineCost.engieType == EngineCost.TYPE_WEB) {
					// 			texture2d.initWithElement(img);
					// 			texture2d.handleLoadedTexture();
					// 		}
					// 		else
					// 			texture2d = img;
                    //
					// 		if ( !cc.spriteFrameCache.isSpriteFramesWithFileLoaded( plistName ) ){
					// 			cc.spriteFrameCache.addSpriteFrames( plistName,  texture2d );
					// 		}
                    //
					// 		var frameDict = dict["frames"];
					// 		var animDict = dict["metadata"];
					// 		var framesArr = [];
					// 		for (var key in frameDict) {
					// 			var oo = cc.spriteFrameCache.getSpriteFrame(key);
					// 			if ( oo.getTexture() instanceof Object)
					// 				framesArr.push(oo);
					// 		}
                    //
					// 		callfun.call( datadir,  {frames:framesArr, animmeta:animDict} );
                    //
					// 	}
                    //});
				});
			} );
		});
	},
}