﻿/**
 * 文本显示
 */
var MUILabelTTF = cc.LabelTTF.extend( {
	_className:"MUILabelTTF",
	ctor:function(){
		this._super();
		this.setAnchorPoint( 0 , 0);
		this.SetSize( 11 );
	},
	//设置文本
	SetText:function (text){
		cc.LabelTTF.prototype.setString.call( this , text);
	},
	//设置字体
	SetFont:function( font ){
		cc.LabelTTF.prototype.setFontName.call( this , font );
	},
	//设置文本大小
	SetSize:function( size ){
		cc.LabelTTF.prototype.setFontSize.call( this , size );
	},
	//设置文本颜色
	SetColor:function ( color , alpha ){
		var a = color >> 24 & 0xff;
		var r = color >>16 & 0xff;
		var g = color >>8 & 0xff;
		var b = color & 0xff;
		if(alpha == null)
			a = 0xff;
		else if(!alpha)
			a = 0xff;
		var c = new cc.Color( r ,g , b , a );
		cc.LabelTTF.prototype.setFontFillColor.call( this, c );
	},
	//设置描边
	SetStroke:function ( color , size , alpha){
		var a = color >> 24 & 0xff;
		var r = color >>16 & 0xff;
		var g = color >>8 & 0xff;
		var b = color & 0xff;
		if(alpha == null)
			a = 0xff;
		else if(!alpha)
			a = 0xff;
		var c = new cc.Color( r ,g , b , a );
		cc.LabelTTF.prototype.enableStroke.call( this , c , size);
	},
	//设置文本显示大小 可以控制换行
	SetDimensions:function ( width , height){
		cc.LabelTTF.prototype.setDimensions.call( this , width , height);
	}
} );