﻿
/**
 * UI 解析类
 */
var UIParseUtil = UIParseUtil ||
		{
			ParsePanel:function (widget , json){
				this.WidgetAttributes(widget , json);

//		var clipEnabled = json["ClipAble"];
//		if(clipEnabled != null)
//		widget.setClippingEnabled(clipEnabled);

//		var colorType = getParam(json["ComboBoxIndex"], 0);
//		widget.setBackGroundColorType(colorType);

//		var bgColorOpacity = getParam(json["BackColorAlpha"], 255);
//		if(bgColorOpacity != null)
//		widget.setBackGroundColorOpacity(bgColorOpacity);
//		zz.Log( json );

				var backGroundScale9Enabled = json["Scale9Enable"];
				if(backGroundScale9Enabled != null)
					widget.setBackGroundImageScale9Enabled(backGroundScale9Enabled);

//		var opacity = getParam(json["Alpha"], 255);
//		widget.setOpacity(opacity);

				var bgtype = json.backgroundType;
				if(bgtype != -1){
					// var imgUrl;
					// var texture;
//			for(var key in json.images){

					// for(var i = 0; i < json.images.length; i++ ){
					// 	imgUrl = json.images[i];
					// 	texture = EngineMgr.uiMgr.GetResByUrl( imgUrl );
					// 	cc.spriteFrameCache.addSpriteFrame( texture , imgUrl);
					// }
					// // widget.setBackGroundImage(imgUrl, ccui.Widget.PLIST_TEXTURE);
					var url = json.images[0];
					EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
						widget.setBackGroundImage(url, ccui.Widget.PLIST_TEXTURE);
						if( backGroundScale9Enabled )
							widget.setBackGroundImageCapInsets(widget.getBackGroundImageCapInsets());
						else{
							var texture = EngineMgr.uiMgr.GetResByUrl(url);
							if( texture ){
								var textRect = texture.getRect();
								var sizeRect = new cc.rect( 0, 0, parseInt(json["Size"]["X"]), parseInt(json["Size"]["Y"]) );
								if( textRect.width != sizeRect.width || textRect.height != sizeRect.height ){
									widget.setBackGroundImageScale9Enabled(true);
									var scaleSize = new cc.rect(0, 0, textRect.width, textRect.height);
									widget.setBackGroundImageCapInsets( scaleSize );
								}
							}
						}
					}, widget);
				}
				var rect = json["backgroundRect"];
				if(backGroundScale9Enabled){
					var scale9OriginX = rect.x || 0;
					var scale9OriginY = rect.y || 0;
					var scale9Width = rect.width || 0;
					var scale9Height = rect.height || 0;

					widget.setBackGroundImageCapInsets(cc.rect(
						scale9OriginX, scale9OriginY, scale9Width, scale9Height
					));

					setContentSize(widget, json["Size"]);
				}else{
					if (!widget.isIgnoreContentAdaptWithSize()){
						setContentSize(widget, json["Size"]);
					}

				}
//		setLayoutBackground(widget, json["SingleColor"], json["FirstColor"], json["EndColor"]);
				setLayoutBackgroundVector(widget, json["ColorVector"]);
			},
			ParseImage:function (widget , json){
				var scale9Enabled = json["Scale9Enable"];
				var rect = json["backgroundRect"];
				var bgtype = json.backgroundType;
				if(bgtype != -1){
					// var imgUrl;
					// var texture;
					// for(var key in json.images){
					// 	imgUrl = json.images[key];
					// 	texture = EngineMgr.uiMgr.GetResByUrl( imgUrl );
					// 	cc.spriteFrameCache.addSpriteFrame( texture , imgUrl);
					// }
					// widget.loadTexture(imgUrl, ccui.Widget.PLIST_TEXTURE);
					EngineMgr.uiMgr.GetAsynResByUrl(json.images[0], function(){
						widget.loadTexture(json.images[0], ccui.Widget.PLIST_TEXTURE);
						if( scale9Enabled && rect ){
                            var scale9OriginX = rect.x || 0;
                            var scale9OriginY = rect.y || 0;
                            var scale9Width = rect.width || 0;
                            var scale9Height = rect.height || 0;
                            widget.setCapInsets(cc.rect(
                                scale9OriginX ,
                                scale9OriginY,
                                scale9Width,
                                scale9Height
                            ));
						}
					}, widget);
				}
				if(scale9Enabled && rect){
					widget.setScale9Enabled(true);
					widget.setUnifySizeEnabled(false);
					widget.ignoreContentAdaptWithSize(false);

					var scale9OriginX = rect.x || 0;
					var scale9OriginY = rect.y || 0;
					var scale9Width = rect.width || 0;
					var scale9Height = rect.height || 0;
					widget.setCapInsets(cc.rect(
						scale9OriginX ,
						scale9OriginY,
						scale9Width,
						scale9Height
					));
				} else
					setContentSize(widget, json["Size"]);

				this.WidgetAttributes(widget, json);
			},
			ParseButton:function (widget , json){
				var scale9Enabled = getParam(json["upTypeS9Enable"], false);
				//将要用的资源添加到UI缓存中
				if(json["upImages"] != null && json.upImages.length > 0){
					// this.LoadTextures( json.upImages );
					// widget.loadTextureNormal(json.upImages[0] , ccui.Widget.PLIST_TEXTURE);
					EngineMgr.uiMgr.GetAsynResByUrl(json.upImages[0], function(){
						widget.loadTextureNormal(json.upImages[0], ccui.Widget.PLIST_TEXTURE);
						if( scale9Enabled )
							widget.setCapInsetsNormalRenderer(widget.getCapInsetsNormalRenderer());
					}, widget);
				}
				if(json["downImages"] != null && json.downImages.length > 0){
					// this.LoadTextures( json.downImages );
					// widget.loadTexturePressed(json.downImages[0] , ccui.Widget.PLIST_TEXTURE);
					EngineMgr.uiMgr.GetAsynResByUrl(json.downImages[0], function(){
						widget.loadTexturePressed(json.downImages[0], ccui.Widget.PLIST_TEXTURE);
						if( scale9Enabled )
							widget.setCapInsetsPressedRenderer(widget.getCapInsetsPressedRenderer());
					}, widget);
				}else{
					// this.LoadTextures( json.upImages );
					// widget.loadTexturePressed(json.upImages[0] , ccui.Widget.PLIST_TEXTURE);
					EngineMgr.uiMgr.GetAsynResByUrl(json.upImages[0], function(){
						widget.loadTexturePressed(json.upImages[0], ccui.Widget.PLIST_TEXTURE);
						if( scale9Enabled )
							widget.setCapInsetsNormalRenderer(widget.getCapInsetsNormalRenderer());
					}, widget);
				}
				if(json["disableImages"] != null && json.disableImages.length > 0){
					// this.LoadTextures( json.disableImages );
					// widget.loadTextureDisabled(json.disableImages[0] , ccui.Widget.PLIST_TEXTURE);
					EngineMgr.uiMgr.GetAsynResByUrl(json.disableImages[0], function(){
						widget.loadTextureDisabled(json.disableImages[0], ccui.Widget.PLIST_TEXTURE);
						if( scale9Enabled )
							widget.setCapInsetsDisabledRenderer(widget.getCapInsetsDisabledRenderer());
					}, widget);
				}else {
					// this.LoadTextures( json.upImages );
					// widget.loadTextureDisabled(json.upImages[0] , ccui.Widget.PLIST_TEXTURE);
					EngineMgr.uiMgr.GetAsynResByUrl(json.upImages[0], function(){
						widget.loadTextureDisabled(json.upImages[0], ccui.Widget.PLIST_TEXTURE);
						if( scale9Enabled )
							widget.setCapInsetsNormalRenderer(widget.getCapInsetsNormalRenderer());
					}, widget);
				}
				if(scale9Enabled) {
					widget.setScale9Enabled(scale9Enabled);
				}

				var text = json["buttonText"];
				if(text != null)
					widget.setTitleText(text);

				var fontSize = json["textSize"];
				if(fontSize != null){
					widget.setTitleFontSize(fontSize);
				}else{
					widget.setTitleFontSize( 20 );
				}
				var fontName = json["FontName"];
				if(fontName != null)
					widget.setTitleFontName(fontName);

				var textColor = json["textColor"];
				if(textColor != null)
					widget.SetTitleTextColor(textColor);

				var displaystate = getParam(json["DisplayState"], true);
				widget.setBright(displaystate);
				widget.setEnabled(displaystate);

				var fontResource = json["FontResource"];
				if(fontResource != null){
					var path = fontResource["Path"];
					//resoutceType = fontResource["Type"];
					if(path != null){
						if (cc.sys.isNative) {
							fontName = cc.path.join(cc.loader.resPath, "", path);
						} else {
							fontName = path.match(/([^\/]+)\.(\S+)/);
							fontName = fontName ? fontName[1] : "";
						}
						widget.setTitleFontName(fontName);
					}
				}
				var label = widget.getTitleRenderer();
				if(label && json["ShadowEnabled"] && json["ShadowColor"] && label.enableShadow){
					label.enableShadow(
						getColor(json["ShadowColor"]),
						cc.size(getParam(json["ShadowOffsetX"], 2), getParam(json["ShadowOffsetY"], -2)),
						json["ShadowBlurRadius"] || 0
					);
				}
				if(label && json["OutlineEnabled"] && json["OutlineColor"] && label.enableStroke)
					label.enableStroke(getColor(json["OutlineColor"]), getParam(json["OutlineSize"], 1));
				this.WidgetAttributes(widget , json);
				//按钮强制注册 鼠标点击事件 需要在解析基础属性后设置
				widget.setTouchEnabled( true );

				if(scale9Enabled) {
					widget.setUnifySizeEnabled(false);
					widget.ignoreContentAdaptWithSize(false);
					var rect = json["upTypeRect"];
					var capInsets = cc.rect(
						rect.x || 0,
						rect.y || 0,
						rect.width || 0,
						rect.height || 0
					);
					widget.setCapInsets(capInsets);
				}
				var size = json["Size"];
				setContentSize(widget, size);
			},
			ParseLabel:function (widget , json){
				var touchScaleEnabled = json["TouchScaleChangeAble"];
				if(touchScaleEnabled != null)
					widget.setTouchScaleChangeEnabled(touchScaleEnabled);

				var fontSize = json["size"];
				if(fontSize != null && fontSize != 0)
					widget.SetFontSize(fontSize);
				else
					widget.SetFontSize( 20 );
				var fontName = json["FontName"];
				if(fontName != null)
					widget.SetFontName(fontName);

				var color = json["color"];
				if( color )
					widget.SetColor( color );

				var areaWidth = json["AreaWidth"];
				var areaHeight = json["areaHeight"];
				if(areaWidth && areaHeight)
					widget.setTextAreaSize(cc.size(areaWidth, areaHeight));

				var h_alignment = json["HorizontalAlignmentType"] || "HT_Left";
				switch(h_alignment){
					case "HT_Right":
						h_alignment = 2; break;
					case "HT_Center":
						h_alignment = 1; break;
					case "HT_Left":
					default:
						h_alignment = 0;
				}
				h_alignment = h_alignment || json["textalign"];
				widget.SetTextAlign(h_alignment);

				// 没用cocosstudio那套	垂直只能是上 --merlin
				// var v_alignment = json["VerticalAlignmentType"] || "VT_Top";
				// switch(v_alignment){
				// case "VT_Bottom":
				// 	v_alignment = 2; break;
				// case "VT_Center":
				// 	v_alignment = 1; break;
				// case "VT_Top":
				// default:
				// 	v_alignment = 0;
				// }
				// widget.setTextVerticalAlignment(v_alignment);

				var fontResource = json["FontResource"];
				if(fontResource != null){
					var path = fontResource["Path"];
					//resoutceType = fontResource["Type"];
					if(path != null){
						if (cc.sys.isNative) {
							fontName = cc.path.join(cc.loader.resPath, "", path);
						} else {
							fontName = path.match(/([^\/]+)\.(\S+)/);
							fontName = fontName ? fontName[1] : "";
						}
						widget.setFontName(fontName);
					}
				}

				if(json["OutlineEnabled"] && json["OutlineColor"] && widget.enableOutline)
					widget.enableOutline(getColor(json["OutlineColor"]), getParam(json["OutlineSize"], 1));

				if(json["ShadowEnabled"] && json["ShadowColor"] && widget.enableShadow)
					widget.enableShadow(
						getColor(json["ShadowColor"]),
						cc.size(getParam(json["ShadowOffsetX"], 2), getParam(json["ShadowOffsetY"], -2)),
						json["ShadowBlurRadius"] || 0
					);

				widget.ignoreContentAdaptWithSize(false);
				var isCustomSize = json["IsCustomSize"];
				if(isCustomSize != null)
					widget.ignoreContentAdaptWithSize(!isCustomSize);

				widget.setUnifySizeEnabled(false);

				var color = json["color"];
				if( color )
					widget.SetColor(color);

				this.WidgetAttributes(widget, json, widget.isIgnoreContentAdaptWithSize());
				var position = json["Position"];
				if (position != null)
				{
					var posY = position["Y"] || 0;
					widget.y = posY - 1;
					var posX = position["X"] || 0;
					widget.x = posX + 1;
				}

				widget.SetMultiline( json["multiline"] );

				var text = json["text"];
				if(text)
					widget.SetText(text);
				var htmlText = json["htmlText"];
				if(htmlText != null && htmlText != ""){
					//var reg = /<[^<]+>/g;
					//htmlText = htmlText.replace( reg , "");
					widget.SetHtmlText( htmlText );
				}
				// if( !json["multiline"] && v_alignment == 0 )		//超出都换行了 不换行的话就得自适应尺寸 要调整锚点为左上角 不然uiheight高度设置得不准确会有偏差 	--merlin
				// 	widget.ignoreContentAdaptWithSize(true);
			},
			ParseCheckBox:function (widget , json){
				this.WidgetAttributes(widget , json);
				var self =  this;
				var dataList = [
					//{name: "NormalBackFileData", handle: widget.loadTextureBackGround},
					//{name: "PressedBackFileData", handle: widget.loadTextureBackGroundSelected},
					//{name: "NodeNormalFileData", handle: widget.loadTextureFrontCross},
					//{name: "DisableBackFileData", handle: widget.loadTextureBackGroundDisabled},
					//{name: "NodeDisableFileData", handle: widget.loadTextureFrontCrossDisabled}
					{name: "checkupImages", handle: widget.loadTextureBackGround},
					{name: "checkupImages", handle: widget.loadTextureBackGroundSelected},
					{name: "uncheckupImages", handle: widget.loadTextureFrontCross},
					{name: "checkupImages", handle: widget.loadTextureBackGroundDisabled},
					{name: "uncheckupImages", handle: widget.loadTextureFrontCrossDisabled}
				];
				dataList.forEach(function(item){
					var arr = json[item.name];
					if(arr.length > 0){
						//	var url = arr[0];
						//	self.LoadTexture( url );
						//	item.handle.call(widget, url, ccui.Widget.PLIST_TEXTURE);
						EngineMgr.uiMgr.GetAsynResByUrl(arr[0], item.handle, widget);
					}
				});
				var selectedState = getParam(json["CheckedState"], false);
				widget.setSelected(selectedState);

				var displaystate = getParam(json["DisplayState"], true);
				widget.setBright(displaystate);
				widget.setEnabled(displaystate);

				if(json["buttonText"]){
					widget.SetText(json["buttonText"]);
					if(json["textColor"])
						widget.SetTextColor(json["textColor"]);
					if(json["textSize"])
						widget.SetTextFontSize(json["textColor"]);
				}

			},
			ParseEdit:function (widget , json){
                var size=json["Size"];
                var fontSize = getParam(json["FontSize"], 20);
                //字体大小改变的时候会变高所以只能读大小不能改变的话就不行不然就C++里面改下
                widget.initWithSizeAndBackgroundSprite(cc.size(size["X"],size["Y"]),new cc.Scale9Sprite());
                // 默认单行使其垂直居中,预先设置默认字，EditBoxImplCommon::placeInactiveLabels会导致界面都达不到预想结果
                widget.setPlaceHolder("请输入内容");
                widget.setInputMode(6);

				var passwordEnabled = json["PasswordEnable"];
				if(passwordEnabled){
                    widget.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
				}else{
                    widget.setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE);
				}
				var placeHolder = json["PlaceHolderText"];
				if(placeHolder != null)
					widget.setPlaceHolder(placeHolder);
//		/widget.setPlaceHolder("");
				if(fontSize != null)
					widget.setFontSize(fontSize);

				// var fontName = json["FontName"];
				// if(fontName != null)
				// 	widget.setFontName(fontName);

				var maxLengthEnabled = json["MaxLengthEnable"];
				if(maxLengthEnabled){
					widget.setMaxLength(maxLength);
				}

				//var isCustomSize = json["IsCustomSize"];
				this.WidgetAttributes(widget, json, true);

				var text = json["LabelText"];
				if(text != null)
					widget.setString(text);

				// var fontResource = json["FontResource"];
				// if(fontResource != null){
				// 	var path = fontResource["Path"];
				// 	//resoutceType = fontResource["Type"];
				// 	if(path != null){
				// 		if (cc.sys.isNative) {
				// 			fontName = cc.path.join(cc.loader.resPath, "", path);
				// 		} else {
				// 			fontName = path.match(/([^\/]+)\.(\S+)/);
				// 			fontName = fontName ? fontName[1] : "";
				// 		}
				// 		widget.setFontName(fontName);
				// 	}
				// }

				widget.setUnifySizeEnabled(false);
				widget.ignoreContentAdaptWithSize(true);

				var color = json["CColor"];
				if(color != null)
					widget.setFontColor(getColor(color));
			},
			ParseGrid:function (widget , json){
				this.WidgetAttributes(widget , json);
				var imgUrl = json.images[0];
                widget.background = widget.AddBgImage( imgUrl );
			},
			ParseGridGroup:function (widget , json){
				this.WidgetAttributes(widget , json);
				var bg = new cc.Sprite();
				widget.SetBgImage(bg);
				// if(json.images.length > 0){
				// 	var imgUrl = json.images[0];
				// 	var texture = EngineMgr.uiMgr.GetResByUrl( imgUrl );
				// 	cc.spriteFrameCache.addSpriteFrame( texture , imgUrl);
				// }
				// bg.initWithSpriteFrameName(imgUrl);
				EngineMgr.uiMgr.GetAsynResByUrl(json.images[0], bg.initWithSpriteFrameName, bg);
				bg.setAnchorPoint( cc.p(0.0, 0.0) );
			},
			ParseImageLabel:function (widget , json){
				var stringValue = json["text"];
				var itemWidth = json["itemWidth"];
				var itemHeight = json["itemHeight"];
				var align = json["align"];

				align = align || 0;
				widget.SetAlign(align);

				setContentSize(widget, json["Size"]);

				if(json["images"] && json["images"].length > 0)
				{
					var url = json["images"][0];
					widget.SetImageUrl(url);
					widget.SetText(stringValue);
				}
				this.WidgetAttributes(widget, json);
			},
			ParseProgressBar:function (widget , json){
				this.WidgetAttributes(widget , json);

				var bar = new ccui.LoadingBar();
				bar.setAnchorPoint( cc.p( 0, 0 ) );
				//这里有问题	cocos三宫进度条只能通过改变宫图宽高来调整进度 而不能使用遮罩的方式
				var barTypeS9Enable = json["barTypeS9Enable"];
				var barSize = { X:json.barWidth, Y:json.barHeight };

				var barType = json["barType"];
				if(barType != null && barType != -1){
					var url = json["barImages"][0];
					EngineMgr.uiMgr.GetAsynResByUrl(url, function(){

						var texture = EngineMgr.uiMgr.GetResByUrl(url);
						var textureRect  = texture.getRect();
						if(barTypeS9Enable || barSize.X != textureRect.width){
							bar.setScale9Enabled(true);
							var rect = json["barTypeRect"] || cc.rect();
							var scale9OriginX = rect.x || 0;
							var scale9OriginY = rect.y || 0;
							var scale9Width = rect.width || textureRect.width - 1;
							var scale9Height = rect.height || textureRect.height - 1;
							bar.setCapInsets(cc.rect(
								scale9OriginX, scale9OriginY, scale9Width, scale9Height
							));
							setContentSize(bar, barSize);
						}else if(!bar.isIgnoreContentAdaptWithSize()){
							setContentSize(bar, barSize);
						}

						bar.loadTexture( url, ccui.Widget.PLIST_TEXTURE );
						bar.setAnchorPoint( cc.p( 0, 0 ) );
					}, bar);
				}
				var barType = json["barChangeType"];	// 0单色	1拉伸		2遮罩	理论上都是2
				// widget.setDirection(0);		//默认朝左	barChangeType是宫图类型 不是反向	用到反向再加		--merlin

				var barWidth = getParam(json["barWidth"], 80);
				if(barWidth != null)
					bar.width=barWidth;
				var barHeight=getParam(json["barHeight"], 10);
				if(barHeight!=null)
					bar.height=barHeight;

				bar.x = (json["barX"] === undefined)?0 : json["barX"];
				bar.y = (json["barY"] === undefined)?0 : (json["Size"].Y - barHeight - json["barY"]);

				widget.SetBar( bar );
			},
			ParseScrollPanel:function (widget , json){
				this.WidgetAttributes(widget , json);

//				var clipEnabled = json["ClipAble"]||false;
//				widget.setClippingEnabled(clipEnabled);

				var colorType = getParam(json["ComboBoxIndex"], 0);
				widget.setBackGroundColorType(colorType);

				var bgColorOpacity = json["BackColorAlpha"];
				if(bgColorOpacity != null)
					widget.setBackGroundColorOpacity(bgColorOpacity);

				var backGroundScale9Enabled = json["Scale9Enable"];
				if(backGroundScale9Enabled){
					widget.setBackGroundImageScale9Enabled(true);
					var rect = json["backgroundRect"];
					var scale9OriginX = rect.x || 0;
					var scale9OriginY = rect.y || 0;
					var scale9Width = rect.width || 0;
					var scale9Height = rect.height || 0;
					widget.setBackGroundImageCapInsets(cc.rect(
						scale9OriginX, scale9OriginY, scale9Width, scale9Height
					));
					setContentSize(widget, json["Size"]);
				}else if(!widget.isIgnoreContentAdaptWithSize()){
					setContentSize(widget, json["Size"]);
				}

				setLayoutBackground(widget, json["SingleColor"], json["FirstColor"], json["EndColor"]);
				setLayoutBackgroundVector(widget, json["ColorVector"]);

//		var innerNodeSize = json["InnerNodeSize"];
//		var innerSize = cc.size(
//				innerNodeSize["Width"] || 0,
//				innerNodeSize["Height"] || 0
//		);
//		widget.setInnerContainerSize(innerSize);

				// var slider = new MUISlider();
				// if(json.hscroll){
				// 	widget.SetHSlider( slider );
				// 	slider.ParseJson( json.hSlider );
				// 	slider.Init();
				// }else if(json.wscroll){
				// 	widget.SetWSlider( slider );
				// 	slider.ParseJson( json.hSlider );
				// 	slider.Init();
				// }
				// widget.UpdatePanel();
			},
			ParseSlider:function (widget , json , isChild){
				this.WidgetAttributes(widget , json);
//		var widget = new MUISlider();
				if(isChild == null)
					widget._isChild = isChild;
				widget._type = json.type;

				var upBtnJson = GetButtonJson( 0 , [ json.btn1UpImage ] );
				var downBtnJson = GetButtonJson( 0 , [ json.btn2UpImage ] );
				var scrollBtnJson = GetButtonJson( json.cursorDownType , json.cursorUpImages , null , null , null , null , json.cursorUpS9Enable , json.cursorUpRect );
				var scrollBtnIconJson = GetImageJson(json.cursorUpbtn ? 0 : -1 , json.cursorUpbtn ? [ json.cursorUpbtn ] : [] );
				var bgImgJson = GetImageJson( 0 , json.images);
				var upBtn = new MUIButton();
				var downBtn = new MUIButton();
				var scrollBtn = new MUIButton();
				var scrollImg = new MUIImage();
				var bgImg = new MUIImage();

				upBtnJson["Size"] = null;
				downBtnJson["Size"] = null;
				scrollBtnJson["Size"] = null;
				scrollBtnIconJson["Size"] = null;
				bgImgJson["Size"] = null;


				upBtn.ignoreContentAdaptWithSize( true );
				downBtn.ignoreContentAdaptWithSize( true );
				scrollBtn.ignoreContentAdaptWithSize( true );
				scrollImg.ignoreContentAdaptWithSize( true );
				bgImg.ignoreContentAdaptWithSize( true );



				upBtn.ParseJson( upBtnJson );
				downBtn.ParseJson( downBtnJson );
				scrollBtn.ParseJson( scrollBtnJson );
				bgImg.ParseJson( bgImgJson );
				scrollImg.ParseJson( scrollBtnIconJson );

				upBtn.Init();
				downBtn.Init();
				scrollBtn.Init();
				bgImg.Init();
				scrollImg.Init();




				//upBtn.setContentSize( MMMMsize );
				//size = downBtn.GetNormalTextureSize();
				//downBtn.setContentSize( size );
				//var size = scrollBtn._normalTextureSize;
				//scrollBtn.setContentSize( size );
				//var size = scrollBtn.getContentSize();
				var size = cc.p(scrollBtn._contentSize, scrollBtn.uiHeight);
				if(this._type == "HSlider")
					widget_minHBarLen = size.height;
				else
					widget_minHBarLen = size.width;
//		size = scrollImg.getVirtualRendererSize();
//		scrollImg.setContentSize( size );
//		size = bgImg.getVirtualRendererSize();
//		bgImg.setContentSize( size );


				widget.addChild( bgImg );
				widget.addChild( upBtn );
				widget.addChild( downBtn );
				widget.addChild( scrollBtn );
				scrollBtn.addChild( scrollImg );

				widget._btnUp = upBtn;
				widget._btnDown = downBtn;
				widget._btnBar = scrollBtn;
				widget._btnBarImg = scrollImg;
				widget._bgImg = bgImg;

				widget.UpdatePanel();

			},
			LoadTextures:function (images){
				for(var key in images){
					var imgUrl = images[key];
					if(cc.spriteFrameCache.getSpriteFrame( imgUrl) == null)	{
						var texture = EngineMgr.uiMgr.GetResByUrl( imgUrl );
						cc.spriteFrameCache.addSpriteFrame( texture , imgUrl);
					}
				}
			},
			LoadTexture:function (imgUrl){
				if(cc.spriteFrameCache.getSpriteFrame( imgUrl) == null){
					var texture = EngineMgr.uiMgr.GetResByUrl( imgUrl );
					cc.spriteFrameCache.addSpriteFrame( texture , imgUrl);
				}
			},
			WidgetAttributes:function (widget , json , enableContent){
				widget.setCascadeColorEnabled(true);
				widget.setCascadeOpacityEnabled(true);

				widget.setUnifySizeEnabled(false);

				widget.ignoreContentAdaptWithSize(false);
				!enableContent && setContentSize(widget, json["Size"]);

				if(json.tipsId != null && json.tipsId != "")
				{
					UIComponentUtil.AddTipsComponent( widget );
					widget.SetTips( json.tipsId );
				}

				var name = json["Name"];
				if (name)
					widget.setName(name);
				var actionTag = json["ActionTag"] || 0;
				widget.setActionTag(actionTag);
				//现在这套应该没有component addComponent会导致启动update 先屏蔽掉
				// var extensionData = new ccs.ComExtensionData();
				// var customProperty = json["UserData"];
				// if(customProperty !== undefined)
				// 	extensionData.setCustomProperty(customProperty);
				// extensionData.setActionTag(actionTag);
				// if (widget.getComponent("ComExtensionData"))
				// 	widget.removeComponent("ComExtensionData");
				// widget.addComponent(extensionData);

//		var rotationSkewX = json["RotationSkewX"];
//		if (rotationSkewX)
//		widget.setRotationX(rotationSkewX);

//		var rotationSkewY = json["RotationSkewY"];
//		if (rotationSkewY)
//		widget.setRotationY(rotationSkewY);

				//var rotation = json["Rotation"];

				var flipX = json["FlipX"];
				if (flipX)
					widget.setFlippedX(true);

				var flipY = json["FlipY"];
				if (flipY)
					widget.setFlippedY(true);

				var zOrder = json["zOrder"];
				if (zOrder != null)
					widget.setLocalZOrder(zOrder);

				var visible = getParam(json["VisibleForFrame"], true);
				if(visible===false)
				widget.setVisible(false);

				var alpha = json["Alpha"];
				if (alpha != null)
					widget.setOpacity(alpha);

				widget.setTag(json["Tag"] || 0);

				if(json["TouchEnable"] != null){
					var touchEnabled = json["TouchEnable"] || false;
					widget.setTouchEnabled(touchEnabled);
				}

				var callBackType = json["CallBackType"];
				if (callBackType != null)
					widget.setCallbackType(callBackType);

				var callBackName = json["CallBackName"];
				if (callBackName)
					widget.setCallbackName(callBackName);

				var position = json["Position"];
				if (position != null)
				{
					var posY = position["Y"] || 0;
					// posY += 1;	//cocos与as的显示有偏差 初始化的时候处理下		--merlin	（应该只是文本的显示）
					widget.setPosition(position["X"] || 0, posY);
					widget.initX = position["X"] || 0;
					widget.initY = posY;
				}
				var scale = json["Scale"];
				if (scale != null) {
					var scaleX = getParam(scale["ScaleX"], 1);
					var scaleY = getParam(scale["ScaleY"], 1);
					widget.setScaleX(scaleX);
					widget.setScaleY(scaleY);
				}

				var anchorPoint = json["AnchorPoint"];
				if (anchorPoint != null)
					widget.setAnchorPoint(anchorPoint["ScaleX"] || 0, anchorPoint["ScaleY"] || 0);

				var color = json["CColor"];
				if (color != null)
					widget.setColor(getColor(color));

				// setLayoutComponent(widget, json);
				bindCallback(widget, json);
			}
		};
var bindCallback = function(widget, json){
	var callBackType = json["CallBackType"];
	var callBackName = json["CallBackName"];
	var callBack = function(e){
		if(typeof widget[callBackName] === "function")
			widget[callBackName](e);
	};
	if(callBackType === "Click"){
		widget.addClickEventListener(callBack);
	}else if(callBackType === "Touch"){
		widget.addTouchEventListener(callBack);
	}else if(callBackType === "Event"){
		widget.addCCSEventListener(callBack);
	}
};
var setLayoutComponent = function(widget, json){

	var layoutComponent = ccui.LayoutComponent.bindLayoutComponent(widget);
	if(!layoutComponent)
		return;

	var positionXPercentEnabled = json["PositionPercentXEnable"] || json["PositionPercentXEnabled"] || false;
	var positionYPercentEnabled = json["PositionPercentYEnable"] || json["PositionPercentYEnabled"] || false;
	var positionXPercent = 0,
		positionYPercent = 0,
		PrePosition = json["PrePosition"];
	if (PrePosition != null) {
		positionXPercent = PrePosition["X"] || 0;
		positionYPercent = PrePosition["Y"] || 0;
	}
	var sizeXPercentEnable = json["PercentWidthEnable"] || json["PercentWidthEnabled"]  || false;
	var sizeYPercentEnable = json["PercentHeightEnable"]|| json["PercentHeightEnabled"]  || false;
	var sizeXPercent = 0,
		sizeYPercent = 0,
		PreSize = json["PreSize"];
	if (PrePosition != null) {
		sizeXPercent = PreSize["X"] || 0;
		sizeYPercent = PreSize["Y"] || 0;
	}
	var stretchHorizontalEnabled = json["StretchWidthEnable"] || false;
	var stretchVerticalEnabled = json["StretchHeightEnable"] || false;
	var horizontalEdge = json["HorizontalEdge"];// = ccui.LayoutComponent.horizontalEdge.LEFT;
	var verticalEdge = json["VerticalEdge"]; // = ccui.LayoutComponent.verticalEdge.TOP;
	var leftMargin = json["LeftMargin"] || 0;
	var rightMargin = json["RightMargin"] || 0;
	var topMargin = json["TopMargin"] || 0;
	var bottomMargin = json["BottomMargin"] || 0;

	layoutComponent.setPositionPercentXEnabled(positionXPercentEnabled);
	layoutComponent.setPositionPercentYEnabled(positionYPercentEnabled);
	layoutComponent.setPositionPercentX(positionXPercent);
	layoutComponent.setPositionPercentY(positionYPercent);
	layoutComponent.setPercentWidthEnabled(sizeXPercentEnable);
	layoutComponent.setPercentHeightEnabled(sizeYPercentEnable);
	layoutComponent.setPercentWidth(sizeXPercent);
	layoutComponent.setPercentHeight(sizeYPercent);
	layoutComponent.setPercentWidthEnabled(sizeXPercentEnable || sizeYPercentEnable);
	layoutComponent.setStretchWidthEnabled(stretchHorizontalEnabled);
	layoutComponent.setStretchHeightEnabled(stretchVerticalEnabled);

	var horizontalEdgeType = ccui.LayoutComponent.horizontalEdge.NONE;
	if (horizontalEdge === "LeftEdge") {
		horizontalEdgeType = ccui.LayoutComponent.horizontalEdge.LEFT;
	} else if (horizontalEdge === "RightEdge") {
		horizontalEdgeType = ccui.LayoutComponent.horizontalEdge.RIGHT;
	} else if (horizontalEdge === "BothEdge") {
		horizontalEdgeType = ccui.LayoutComponent.horizontalEdge.CENTER;
	}
	layoutComponent.setHorizontalEdge(horizontalEdgeType);

	var verticalEdgeType = ccui.LayoutComponent.verticalEdge.NONE;
	if (verticalEdge === "TopEdge") {
		verticalEdgeType = ccui.LayoutComponent.verticalEdge.TOP;
	} else if (verticalEdge === "BottomEdge") {
		verticalEdgeType = ccui.LayoutComponent.verticalEdge.BOTTOM;
	} else if (verticalEdge === "BothEdge") {
		verticalEdgeType = ccui.LayoutComponent.verticalEdge.CENTER;
	}
	layoutComponent.setVerticalEdge(verticalEdgeType);

	layoutComponent.setTopMargin(topMargin);
	layoutComponent.setBottomMargin(bottomMargin);
	layoutComponent.setLeftMargin(leftMargin);
	layoutComponent.setRightMargin(rightMargin);

	layoutComponent.setVerticalEdge(verticalEdgeType);

	layoutComponent.setTopMargin(topMargin);
	layoutComponent.setBottomMargin(bottomMargin);
	layoutComponent.setLeftMargin(leftMargin);
	layoutComponent.setRightMargin(rightMargin);
};

var setLayoutBackground = function(layout, single, first, end){
	if( layout.getBackGroundColorType() === 2 ){
		first = first || {};
		end = end || {};
		layout.setBackGroundColor(getColor(first), getColor(end));
	}else{
		single = single || {};
		layout.setBackGroundColor(getColor(single));
	}
};

var setLayoutBackgroundVector = function(widget, vector){
	vector = vector || {};
	var x = vector["ScaleX"] || 0;
	var y = vector["ScaleY"] || 0;
	widget.setBackGroundColorVector(cc.p(x, y));
};

var getColor = function(json){
	if(!json) return;
	var r = json["R"] != null ? json["R"] : 255;
	var g = json["G"] != null ? json["G"] : 255;
	var b = json["B"] != null ? json["B"] : 255;
	var a = json["A"] != null ? json["A"] : 255;
	return cc.color(r, g, b, a);
};

var setContentSize = function(node, size){
	var x = 0;
	var y = 0;
	if(size){
		x = size["X"];
		y = size["Y"];
		node.setContentSize(cc.size(x, y));
	}
	node.uiWidth = x;
	node.uiHeight = y;
	node.initWidth = x;
	node.initHeight = y;
};
var getParam = function(value, dValue){
	if(value === undefined)
		return dValue;
	else
		return value;
};

var GetButtonJson = function ( upType , up , downType , down , disableType , disable , scale , rect){
	if(upType == null){
		upType = -1;
		up = [];
	}
	if(downType == null){
		downType = -1;
		down = [];
	}
	if(disableType == null){
		disableType = -1;
		disable = [];
	}

	var json = {
		"downType": -1,
		"downImages": [],
		"overType": -1,
		"childs": [],
		"disableType": -1,
		"id": "sliderbtn",
		"overImages": [],
		"type": "Button",
		"disableImages": [],
		"upType": 0,
		"backgroundType": -1,
		"AnchorPoint": {
			"ScaleY": 0,
			"ScaleX": 0
		},
		"upImages": [],
		"images": [],
		"Position": {
			"X": 0,
			"Y": 0
		},
		"bindData": {},
		"tipsId": "",
		"Size": {
			"X": 40,
			"Y": 40
		}
	};

	if(scale != null){
		json.upTypeS9Enable = true;
		json.upTypeRect = rect;
	}

	json.upType = upType;
	json.upImages = up;

	json.downType = downType;
	json.downImages = down;

	json.disableType = disableType;
	json.disableImages = disable;
	return json;
}

var GetImageJson = function (btype , images , scale , rect){
	if(scale == null){
		scale = false;
		rect = cc.rect(0, 0, 0, 0);
	}
	if(btype == null)
		btype = 0;
	var image = {
		"type": "Image",
		"backgroundType": 0,
		"AnchorPoint": {
			"ScaleY": 0,
			"ScaleX": 0
		},
		"childs": [],
		"id": "imgBG2",
		"images": [],
		"Position": {
			"X": 0,
			"Y": 0
		},
		"bindData": {},
		"tipsId": "",
		"Size": {
			"X": 100,
			"Y": 100
		},
		"Scale9Height": 1,
		"Scale9Width": 1,
		"Scale9Enable": true,
		"Scale9OriginX": 20,
		"Scale9OriginY": 20
	};
	image.backgroundType = btype;
	image.images = images;
	image.Scale9Enable = scale;
	image.Scale9OriginX = rect.x;
	image.Scale9OriginY = rect.y;
	image.Scale9Width = rect.width;
	image.Scale9Height = rect.height;
	return image;
}

