﻿var EnterGameMgr = EnterGameMgr || {
	// 登录资源加载成功
	bEnterResLoadReady:false,
	// 登录连接成功
	bEnterConnectLoginReady:false,
	bNeedInputServerIp:true,
	nFirstLoadMapId:0,

	oProgressPanel:null,
	
	isSingleGame:false,
	
	/// <summary>
	/// 加载默认动画
	/// </summary>
	LoadDefaultAnimation:function(){
		MAnimationMgr.PrepareDefualtAnimationRes();//new cc.CallFunc(this.DefaultAnimationLoadedCallback, this));
		this.DefaultAnimationLoadedCallback();
	},

	DefaultAnimationLoadedCallback:function(obj){
        Mgr.login.AddProgress();
        //这里要按照纹理从大到小一张张加载 减小加载时内存波动
		this._preloadUIArr = [];
		//this._preloadUIArr.push("public");
		// this._preloadUIArr.push("logn");
		this._preloadUIArr.push("other/zhujiemian");
		this._preloadUIArr.push("other/head");
		this._preloadUIArr.push("other/liaotian");
		this._preloadUIArr.push("other/touxian");
		this._LoadNextUI();
	},

	_LoadNextUI:function(){
		EngineMgr.uiMgr.LoadOtherRes(this._preloadUIArr.shift() , this);
	},

	Callback:function (){
		Mgr.login.AddProgress();
		if(this._preloadUIArr.length == 0){
			this._PreLoadIcon();
		}
		else{
			this._LoadNextUI();
		}
	},
	ErrCallback:function(){
		if(this._preloadUIArr.length == 0){
			this._PreLoadIcon();
		}
		else{
			this._LoadNextUI();
		}
	},

	_PreLoadIcon:function(){
		var self = this;
		EngineMgr.uiMgr.LoadIconRes("itemicon" , { Callback:function(){ self.LoadEnterGameResCallback(); },
												   ErrCallback:function(){ self.LoadEnterGameResCallback(); } });
	},
	
	LoadEnterGameResCallback:function(){
		Mgr.login.AddProgress();
//		Mgr.login.ShowLogin();
		this.SetResLoadReady();
	},

	SetResLoadReady:function SetResLoadReady(){
		this.bEnterResLoadReady = true;

		if( !this.isSingleGame )
		{
			this.CheckEnterScene();
		}
		else
		{
			// 这里就先测试写了
			this.SetConnectLoginReady(1011);
		}
		EngineMgr.uiMgr.InitMainPanel();
	},

	// ========================================================================================================
	// =========================================================================================== 连接服务器
	// ========================================================================================================
	ConnectServer:function(){
        this.loginTime = this.loginTime || 0;
        var now = TimerUtil.GetTimer();
        if( now < this.loginTime )
            return;
        this.loginTime = now + 3000;

		var ip = GameConfig.current.SERVER_IP;
		var port = GameConfig.current.SERVER_PORT;
		zz.Log("[Login] connectServer " + ip + " " + port.toString());
		
		var cbopen =  this.OnSocketConnectSuccess;
		var cberror = this.OnSocketConnectError;
		var cbclose = this.OnSocketClose;
		
		Mgr.msgMgr.Connect(ip, port, cbopen, cberror, cbclose);
	},

    Logout:function(){
        Mgr.msgMgr.CloseSocket(true);  //返回选服界面要关闭当前socket
        Mgr.msgMgr.CloseSocket(false);  //返回选服界面要关闭当前socket
		TimeTaskMgr.RemoveTaskByType(TimeTaskMgr.TYPE_SCENE);
        Mgr.sceneMap.ClearCurMap();
        Mgr.sceneObj.RemoveAllRoundObject();
		if( Mgr.mainPlayer )
			Mgr.sceneObj.DeleteObject(Mgr.mainPlayer.nGid);
        Mgr.sceneObj.oAllObjectHashList.Clear();
        Mgr.mainPlayer = null;
        Mgr.Reset();
		BtnGroupUtil.Init();
        this.bEnterResLoadReady = false;
        this.bEnterConnectLoginReady = false;

		Mgr.strong.ClearAll();

        Mgr.uiMgr.HidePanelByType( SettingPanelExt.PanelName);
        Mgr.uiMgr.HidePanelByType( ShortcutPanelExt.PanelName);
        Mgr.uiMgr.HidePanelByType( MiniMapPanelExt.PanelName);
        Mgr.uiMgr.HidePanelByType( RoleHeadPanelExt.PanelName);
		if( Mgr.map.miniMapPanel )
			Mgr.map.miniMapPanel._activityList = [];
		GameMain.oStageLayer.loadBg.setTexture("res/ui/image/load/bg2.jpg");
		GameMain.oStageLayer.loadBg.parts.visible = false;
        Mgr.uiMgr.ShowPanelByType(DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP).ShowDeluUI();
    },

	OnSocketConnectSuccess:function(s){
		zz.Log("[Login] onSocketConnectSuccess " + s);

		cc.log("LOGIN_TYPE  " + GameConfig.current.LOGIN_TYPE)
        switch(GameConfig.current.LOGIN_TYPE){
            case EnumLoginType.Normal:
                Mgr.login.SendReqLoginForPlatformMessage();
                break;
            case EnumLoginType.App:
                Mgr.login.SendReqLoginForAppMessage();
                break;
            case EnumLoginType.ShowLoginPanel:
            default:
                Mgr.login.SendReqLoginMessage( GameConfig.current.USER_NAME, GameConfig.current.PLATFORM, GameConfig.current.SERVER_ID );
                break;
        }
	},

	OnSocketConnectError:function(s){
		//现在只有一种情况就是 超时
		zz.Log("[Login] onSocketConnectError : " + s);
	},

	OnSocketClose:function(s){
		cc.error("[Login] OnSocketClose : " + s);
	},

	// ========================================================================================================
	// =========================================================================================== 进入场景检测
	// ========================================================================================================
	SetConnectLoginReady:function( mapid ){
		cc.log("SetConnectLoginReady+++++++++++++++++++++++");
		this.nFirstLoadMapId = mapid;
		this.bEnterConnectLoginReady = true;
		// EngineMgr.uiMgr.ShowPanelByType(MinimapPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
		if( this.bEnterResLoadReady )
			this.CheckEnterScene();
		else
			EnterGameMgr.LoadDefaultAnimation();
	},

	CheckEnterScene:function(){
		cc.log("bEnterResLoadReady"+this.bEnterResLoadReady);
		cc.log("bEnterConnectLoginReady"+this.bEnterConnectLoginReady);

		if (this.bEnterConnectLoginReady && this.bEnterResLoadReady){
			//Mgr.uiMgr.hidePanel<LoginProgressPanelExt>();
			Mgr.sceneMap.DoChangeMap(this.nFirstLoadMapId, -1);
		}
	}
};