var CustomControl = CustomControl || {
	_handBgImg:null,//摇杆背景图
	_handImg:null,//摇杆
	_offSetX:50,//X方向偏移
	_offSetY:50,
	_speed:1,//移动速度
	_startPos:cc.p(0,0),//触摸起点
	_originPos:cc.p(0,0),//触摸原始起点（不变）
	_baseOriginPos:cc.p(0,0),
	_rangeRect:null,//摇杆移动范围
	_isMoving:false,//是否正在移动
	_angle:0,//角度
	_radius:0,//弧度
	_actionType:0,
	_direction:0,
	_startRolePos:null,
	_shortPanel:null,
	_timerId:0,
	isWaitRunSuccess:false,

    _touchedInThis:false,
	Init:function(parent)
	{
		this._shortPanel = parent;
		//初始化
		this._Zinit();
		//添加技能图标
		this._AddSkillControlIco();
	},
	//初始化摇杆，角色
	_Zinit:function()
	{
		var self = this;
		this._handBgImg = this._shortPanel.handBgImg;
		// this._handBgImg.visible = false;
		this._baseOriginPos = this._handBgImg.getPosition();
		this._rangeRect = cc.rect(0,0,this._handBgImg.width, this._handBgImg.height);

		this._handImg = this._shortPanel.hightLightHandImg;
		this._handImg.x = this._handBgImg.width/2;;
		this._handImg.y = this._handBgImg.height/2;;
		this._originPos = cc.p(this._handImg.getPosition());
		// this._handBgImg.setTouchEnabled(true);
		// this._handBgImg.addTouchEventListener(function(target,state)
		// {
		// 	self._HandleTouchEvent(target,state,self);
		// });
		// this._hightLightHandImg.visible = false;
		this._speed = 4;/*Mgr.mainPlayer.oMoveRule._moveSpeed;*/
		this._handImg.setAnchorPoint(0.5,0.5);
	},

    /// 获取点击到this的标记。用于吞掉场景地图寻路。
    CheckTouchInAndRemark:function(mark){
        var temp = this._touchedInThis;
        if(mark) this._touchedInThis = false;
        return temp;
    },

	//触摸事件处理
	_HandleTouchEvent:function(target, state,self,pos)
	{
		if(!Mgr.mainPlayer )
			return;
		if ( state == ccui.Widget.TOUCH_BEGAN )
		{
			self._handBgImg.stopAllActions();
			self._handImg.stopAllActions();
			self._startPos = target.getTouchBeganPosition();
			var posMove01 = self._handImg.parent.convertToNodeSpace(self._startPos);
			var distance = cc.pDistance(cc.p(self._handBgImg.width/2,self._handBgImg.height/2), cc.p(posMove01.x,posMove01.y));
			//if ( distance <= self._rangeRect.width/2-1 )
			{
				self._handImg.setPosition(posMove01);
				self._handImg.setPosition(this._originPos.x,this._originPos.y);
				//self._hightLightHandImg.visible = true;
				//this._handBgImg.visible = true;
				self._startRolePos = Mgr.mainPlayer.getPosition();
				self._HandleRoleMove();
				self._startTime = Date.now();
				self._timerId = TimerUtil.TimeUpdate( this.update, this, 0.1 );
			}
            this._touchedInThis = true;
		}
		else if ( state == ccui.Widget.TOUCH_MOVED )
		{
			this._isMoving = true;
			var posMove = target.getTouchMovePosition();
			if(pos)
			{
				posMove = pos;
			}
			var target = this._handImg;
			var posMove01 = this._handImg.parent.convertToNodeSpace(posMove);
			var radius = Math.atan2(posMove01.y - this._originPos.y,posMove01.x - this._originPos.x);
			var p = cc.p(Math.cos(radius),Math.sin(radius));
			var distance  = this._GetRangePosition(posMove01.x, posMove01.y,p);
			cc.pMultIn(p, distance);
			var angle = radius/Math.PI*180;//(-180, 180)
			this._angle = angle;
			this._radius = radius;
            target.setPosition(p.x+this._originPos.x,p.y+this._originPos.y);
		}
		else if ( state == ccui.Widget.TOUCH_ENDED || state == ccui.Widget.TOUCH_CANCELED )
		{
			self.ResetHandleBgPosition();
		}
	},
	_initPos:null,
	InitHandlePosition:function(pos)
	{
		this._initPos = pos;
	},
	HandleMoving:function(pos)
	{
		if( this._initPos ){
			this._handBgImg.visible = true;
			this._handImg.visible = true;
			this._handBgImg.setPosition(cc.p(this._initPos.x-this._handBgImg.width/2,this._initPos.y-this._handBgImg.height/2));
			this._HandleTouchEvent(this._handBgImg,0,this,this._initPos);
			this._initPos = null;
		}
		this._HandleTouchEvent(this._handBgImg,1,this,pos);
	},
	ResetHandleBgPosition:function()
	{
		var self = this;
		this._handBgImg.setPosition(this._baseOriginPos);
		self._isMoving = false;
		var target = self._handImg;
		target.setPosition(self._originPos);
		//Mgr.mainPlayer.SetStateShow(EnumActionType.STAND,this._direction);
		// this._handBgImg.visible = false;
		// self._hightLightHandImg.visible = false;
		if( self._timerId ){
			TimerUtil.ClearTimeUpdate( self._timerId, this );
			self._timerId = 0;
		}

		if( !Mgr.mainPlayer.CheckState( EnumActionType.MOVEMOMENT ) && !Mgr.mainPlayer.CheckState( EnumActionType.JUMP ) && !Mgr.mainPlayer.CheckState( EnumActionType.JUMP_FLY ) && Mgr.sceneAction.oCtrlObject == Mgr.mainPlayer){
			Mgr.mainPlayer.TryDoStand();
			Mgr.map.SendReqPlayerStopMessage();
		}
	},
	//处理摇杆移动范围
	_GetRangePosition:function(xx, yy,p)
	{
		var distance = cc.pDistance(cc.p(this._handBgImg.width/2,this._handBgImg.height/2), cc.p(xx,yy));
		if ( distance <= this._rangeRect.width/2 )
		{
			return distance;
		}
		else if(distance > this._rangeRect.width/2+65)
		{
			var speed = 10;
			this._handBgImg.x+= p.x*speed;
			this._handBgImg.y+= p.y*speed;
		}
		return this._rangeRect.width/2;
	},

	update:function()
	{
		//控制角色移动
		if ( this._isMoving )
		{
			this._HandleDirection(this._angle, this._radius);
		}
		var now = Date.now();
		// if( Mgr.mainPlayer.nHorseModelId <= 0 && now - this._startTime > 1000 ){
		// 	Mgr.resline.EquipResline(EnumResline.HORSE);
		// 	this._startTime = now;
		// }
		//方向未变继续移动要加个cd
		if( now - this._lastMoveTime < 600 )
			return;
		this._HandleRoleMove();
	},
	//移动方向处理
	_HandleDirection:function(angle,radius)
	{
		var actionType = EnumActionType.RUN,dir = 0;
		var gap = 22.5;
		if ( angle >= -gap && angle <= gap )//右方
		{
			dir = 2;
		}
		else if ( angle > gap && angle < gap*3 )//右上方
		{
			dir = 1;
		}
		else if ( angle >= gap*3 && angle < gap*5 )//上方
		{
			dir = 0;
		}
		else if ( angle >= gap*5 && angle < gap*7 )//左上方
		{
			dir = 7;
		}
		else if ( angle >= gap*7 || angle < -gap*7 )//左方
		{
			dir = 6;
		}
		else if ( angle > -gap*7 && angle < -gap*5 )//左下方
		{
			dir = 5;
		}
		else if ( angle >= -gap*5 && angle < -gap*3 )//下方
		{
			dir = 4;
		}
		else if ( angle >= -gap*3 && angle < -gap)//右下方
		{
			dir = 3;
		}
		this._actionType = actionType;
		if ( this._direction != dir || this.isWaitRunSuccess )	//移动太频繁会失败， 只有成功了才不进行移动，这样及时性会好很多		--merlin
		{
			this.isWaitRunSuccess = true;
			this._direction  = dir;
			this._HandleRoleMove();
		}
	},
	_lastMoveTime:0,
	_HandleRoleMove:function()
	{
		if( !Mgr.mainPlayer )
			return;
		if ( !this._isMoving ){return;}

		Mgr.mainPlayer.SetActiveState();
		Mgr.mainPlayer.oCtrlAutoFight.ClearLockAutoAttackTarget();
		this._lastMoveTime = TimerUtil.GetTimer();
		var dirArrx = [0, 1, 1, 1, 0, -1, -1, -1];
		var dirArry = [1, 1, 0, -1, -1, -1, 0, 1];
		var dstpt = Mgr.mainPlayer.GetGridPt();
		var step = 6;
		var xx = dirArrx[this._direction]*step;
		var yy = dirArry[this._direction]*step;
		dstpt = cc.p(dstpt.x + xx, dstpt.y - yy);
		dstpt.x = Math.max( 0, dstpt.x );
		dstpt.x = Math.min( Mgr.sceneMap.oMapGrid.nGridWMax - 1, dstpt.x );
		dstpt.y = Math.max( 0, dstpt.y );
		dstpt.y = Math.min( Mgr.sceneMap.oMapGrid.nGridHMax - 1, dstpt.y );
		var oCtrlObject = Mgr.sceneAction.oCtrlObject;
		if (oCtrlObject && oCtrlObject.IsCanDoRun()) {
			oCtrlObject.oCtrlAutoPath.StopAutoPath();
			oCtrlObject.oCtrlAutoPath.RunToPt(dstpt,null,false);
			Mgr.player.ShowShortChatState();
		}
	},
	//添加技能图标
	_AddSkillControlIco:function()
	{
		this._skillBtn = this._shortPanel.skillArry;
		var self = this;
		for(var i = 0; i <this._skillBtn.length;i++)
		{
            (function(i){
                self._skillBtn[i].addTouchEventListener(function(target,state)
                {
                    self._HandleSkillEvent(target,state, i+1);
                    if ( state == ccui.Widget.TOUCH_BEGAN )
                    {
                    	var zoomScale = target.getZoomScale();
                        var action = cc.scaleTo(0.05, 1 + zoomScale, 1 + zoomScale);
                        target.background.runAction(action);
                        if(target.cdImg.cdscale)
                        	target.cdImg.runAction(cc.scaleTo(0.05, target.cdImg.cdscale + zoomScale, target.cdImg.cdscale + zoomScale));
                    	if(target.cdImg.isCd)
                    		return;
                        var url = "";
                        if(i == 0)
                            url = "res/animation/effect/ui/998";
                        else
                            url = "res/animation/effect/ui/997";
                        var clickSkill = new MAnimationObject();
                        target.addChild(clickSkill, 2);
                        target.clickSkill = clickSkill;
                        clickSkill.x = target.uiWidth/2;
                        clickSkill.y = target.uiHeight/2;
                        clickSkill.CallbackAnimationPlayEnd  = function(){
                            clickSkill.Dispose();
                        };
                        clickSkill.sResUrlBase = url;
                        clickSkill.DoAction("stand", 4);
                    }
                    else if(state == ccui.Widget.TOUCH_ENDED || state == ccui.Widget.TOUCH_CANCELED){
                        var action = cc.scaleTo(0.05, 1, 1);
                        target.background.runAction(action);
						if(target.cdImg.cdscale)
                        	target.cdImg.runAction(cc.scaleTo(0.05, target.cdImg.cdscale, target.cdImg.cdscale));
					}
                });
            })(i);
		}
		var btnTab = this._shortPanel.btnTab;
		btnTab.addTouchEventListener(function(target,state)
		{
			self._HandleTabEvent(target,state);
		});
	},
	_HandleSkillEvent:function(target, state, type)
	{
		if ( state != ccui.Widget.TOUCH_ENDED ){return;}
		if(!target.data) return;

		if( !Mgr.mainPlayer.CanSetState( EnumActionType.ATTACK ) )
			return;
		
		var skillId;
		if( type == 1 ){
			if( Mgr.mainPlayer.IsActionAttacking() )
				return;
			skillId = Mgr.mainPlayer.oCtrlAutoFight.GetAutoBaseSkillId();
		}
		else{
			var skillModelData  = target.data.Model();
			skillId = skillModelData.q_skillID;
		}

		// var skillPublicData = target.data.PublicModel();
		if(!target.cdImg.isCd) {
			var tar = Mgr.sceneObj.FindObject(Mgr.map.nCurtargetgid);
			if( !tar )
				tar = Mgr.sceneObj.GetNearestMonster();

			if( tar && tar instanceof SceneFightObject ){
				Mgr.map.SelTarget(tar);
				
				Mgr.mainPlayer.oCtrlAutoFight.SetLockAutoAttackTarget(tar, skillId);
				return;
			}

			// FightUtil.DoSkillEffectUser(Mgr.mainPlayer, null, skillModelData, this._direction, type);
			Mgr.map.SendReqPlayerStopMessage();
			Mgr.fight.SendReqAttackVentToGameMessage( skillId );
		}
	},

	_HandleTabEvent:function (target, state) {
		if ( state != ccui.Widget.TOUCH_ENDED ){return;}
		// var fightCtrl = Mgr.mainPlayer.oCtrlAutoFight;
		var tar = Mgr.sceneObj.SelNeerMonster();
		if(tar)
			Mgr.map.SelTarget(tar);
	}
}
