var Q_attribute_rise = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 物品ID_强化等级 */
        self.q_id = data.ReadString();
        /** 最大可强化等级 */
        self.q_max_level_rise = data.ReadInt();
        /** 属性类型 */
        self.q_attribute = data.ReadString();
        /** 消耗材料ID */
        self.q_up_item_id = data.ReadInt();
        /** 消耗材料数量 */
        self.q_up_item_num = data.ReadInt();
        /** 强化成功率（百分比分子） */
        self.q_success = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_attribute_rise.list = Q_attribute_rise.list|| [];
	/** 配置数据索引*/
	Q_attribute_rise.map = Q_attribute_rise.map || {};
	
	/** 设置配置数据*/
	Q_attribute_rise.SetData = Q_attribute_rise.SetData || function( data ){

		var list = Q_attribute_rise.list;
		var map = Q_attribute_rise.map;

		Q_attribute_rise.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_attribute_rise();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_attribute_rise.GetList = Q_attribute_rise.GetList || function(){
		return Q_attribute_rise.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_attribute_rise.Get = Q_attribute_rise.Get || function( id ){
		return Q_attribute_rise.map[ id ];
	};
})();