var Q_attribute_rise_add = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 物品ID_强化等级 */
        self.q_id = data.ReadString();
        /** 最大可强化等级 */
        self.q_max_level_rise = data.ReadInt();
        /** 强化增加生命值 */
        self.q_max_hp = data.ReadInt();
        /** 强化增加攻击力 */
        self.q_attack = data.ReadInt();
        /** 强化增加防御力 */
        self.q_defence = data.ReadInt();
        /** 强化增加命中值 */
        self.q_hit = data.ReadInt();
        /** 强化增加闪避值 */
        self.q_dodge = data.ReadInt();
        /** 强化增加暴击值 */
        self.q_crit = data.ReadInt();
        /** 强化增加抗暴值 */
        self.q_antiCrit = data.ReadInt();
        /** 消耗材料ID */
        self.q_up_item_id = data.ReadInt();
        /** 消耗材料数量 */
        self.q_up_item_num = data.ReadInt();
        /** 所需银两 */
        self.q_up_gold_num = data.ReadInt();
        /** 强化成功率（百分比分子） */
        self.q_success = data.ReadInt();
        /** 消耗的真气值 */
        self.q_zhenqi = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_attribute_rise_add.list = Q_attribute_rise_add.list|| [];
	/** 配置数据索引*/
	Q_attribute_rise_add.map = Q_attribute_rise_add.map || {};
	
	/** 设置配置数据*/
	Q_attribute_rise_add.SetData = Q_attribute_rise_add.SetData || function( data ){

		var list = Q_attribute_rise_add.list;
		var map = Q_attribute_rise_add.map;

		Q_attribute_rise_add.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_attribute_rise_add();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_attribute_rise_add.GetList = Q_attribute_rise_add.GetList || function(){
		return Q_attribute_rise_add.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_attribute_rise_add.Get = Q_attribute_rise_add.Get || function( id ){
		return Q_attribute_rise_add.map[ id ];
	};
})();