var Q_blood_bead = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 万灵血珠类型编号（与活跃度一样） */
        self.q_id = data.ReadInt();
        /** 任务类型说明 */
        self.q_introduce = data.ReadString();
        /** 次数 */
        self.q_time = data.ReadInt();
        /** 显示所需人物等级 */
        self.q_level = data.ReadInt();
        /** 显示所需完成任务 */
        self.q_quest = data.ReadInt();
        /** 完成1次次数获得的剑池经验 */
        self.q_exp = data.ReadInt();
        /** 标题美术资源编号 */
        self.q_name_artistic = data.ReadInt();
        /** TIPS描述 */
        self.q_tips = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_blood_bead.list = Q_blood_bead.list|| [];
	/** 配置数据索引*/
	Q_blood_bead.map = Q_blood_bead.map || {};
	
	/** 设置配置数据*/
	Q_blood_bead.SetData = Q_blood_bead.SetData || function( data ){

		var list = Q_blood_bead.list;
		var map = Q_blood_bead.map;

		Q_blood_bead.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_blood_bead();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_blood_bead.GetList = Q_blood_bead.GetList || function(){
		return Q_blood_bead.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_blood_bead.Get = Q_blood_bead.Get || function( id ){
		return Q_blood_bead.map[ id ];
	};
})();