var Q_boss_world = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** BOSSID */
        self.q_boss_id = data.ReadInt();
        /** 排序 */
        self.q_order = data.ReadInt();
        /** BOSS面板显示类型(0：不显示，1：世界野外BOSS，2：地宫BOSS  3：地宫VIP 4：BOSS之家） */
        self.q_boss_type = data.ReadInt();
        /** 是否计入排行数量(1：计入，0：否） */
        self.q_link = data.ReadInt();
        /** 奖励的货币类型 */
        self.q_reward_type = data.ReadInt();
        /** 基础奖励积分 */
        self.q_point_base = data.ReadInt();
        /** 伤害分配积分 */
        self.q_point = data.ReadInt();
        /** 最后一击额外奖励 */
        self.q_final_bonus = data.ReadString();
        /** 刷新地图 */
        self.q_appear_map = data.ReadInt();
        /** 寻路坐标X */
        self.q_appear_x = data.ReadInt();
        /** 寻路坐标Y */
        self.q_appear_y = data.ReadInt();
        /** 传送地图 */
        self.q_transfer_map = data.ReadInt();
        /** 传送坐标X */
        self.q_transfer_x = data.ReadInt();
        /** 传送坐标Y */
        self.q_transfer_y = data.ReadInt();
        /** BOSS的描述文本 */
        self.q_introduce = data.ReadString();
        /** BOSS名称美术资源 */
        self.q_name_art = data.ReadInt();
        /** BOSS底图资源 */
        self.q_map_art = data.ReadInt();
        /** 展示用BOSS造型 */
        self.q_show_boss = data.ReadInt();
        /** 击杀BOSS伤害排名前3名玩家奖励 */
        self.q_goods = data.ReadString();
        /** 活动参与奖励 */
        self.q_activity_reward = data.ReadString();
        /** 击杀BOSS最后一击幸运奖励 */
        self.q_the_last_hit = data.ReadString();
        /** 帮会领地可分配奖励 */
        self.q_guild_drop = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_boss_world.list = Q_boss_world.list|| [];
	/** 配置数据索引*/
	Q_boss_world.map = Q_boss_world.map || {};
	
	/** 设置配置数据*/
	Q_boss_world.SetData = Q_boss_world.SetData || function( data ){

		var list = Q_boss_world.list;
		var map = Q_boss_world.map;

		Q_boss_world.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_boss_world();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_boss_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_boss_world.GetList = Q_boss_world.GetList || function(){
		return Q_boss_world.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_boss_world.Get = Q_boss_world.Get || function( id ){
		return Q_boss_world.map[ id ];
	};
})();