var Q_buff = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** BUFF编号（类型编号*1000+N） */
        self.q_buff_id = data.ReadInt();
        /** BUFF名称 */
        self.q_buff_name = data.ReadString();
        /** 获得BUFF时向获得者发送提示信息 */
        self.q_effect_prompt = data.ReadString();
        /** 作用目标（1自己，2目标，3自己与目标，4自己和队友,5主人） */
        self.q_target = data.ReadInt();
        /** 获得BUFF时向施加者发送提示信息 */
        self.q_user_prompt = data.ReadString();
        /** BUFF广播类型（0隐藏式BUFF，1显示给自己知道的BUFF，2在地图同步给周围玩家的BUFF , 3其他玩家选中后,前端请求查看的BUFF） */
        self.q_cast_type = data.ReadInt();
        /** 损益类型（0无所谓，1正面BUFF，2负面BUFF,3不受内力盾影响） */
        self.q_effect_type = data.ReadInt();
        /** （0不显示，1正面BUFF，2负面BUFF） */
        self.q_show_type = data.ReadInt();
        /** 若为负面BUFF，是否可被BUFF类型：203类型清除(0:可，1：不能） */
        self.q_clear_type = data.ReadInt();
        /** 效果类型 */
        self.q_action_type = data.ReadInt();
        /** 效果添加成功几率（本处填万分比的分子） */
        self.q_trigger_prob = data.ReadInt();
        /** 效果作用数值（允许负值） */
        self.q_effect_value = data.ReadInt();
        /** 效果作用比例（本处填万分比的分子）（允许负值） */
        self.q_effect_ratio = data.ReadInt();
        /** 效果的总持续时间（单位：秒）（填-1为永久生效） */
        self.q_effect_time = data.ReadInt();
        /** 效果的总容量 */
        self.q_effect_maxvalue = data.ReadInt();
        /** 效果分次作用间隔时间（单位：毫秒） */
        self.q_effect_cooldown = data.ReadInt();
        /** 效果重复选项（1效果叠加，2效果替换，3容量叠加(属性,层数）,4时间叠加，5重复无效） */
        self.q_overlay = data.ReadInt();
        /** 叠加次数上限（-1为无限） */
        self.q_overlay_maxcount = data.ReadInt();
        /** 替换类型（类型相同的才会替换） */
        self.q_replace_type = data.ReadInt();
        /** ）替换层级（高层级的将可替换低层级 */
        self.q_replace_level = data.ReadInt();
        /** 获得者死亡或下线后是否清除（0不清除，1清除，2切换地图清除，3仅下线清除） */
        self.q_effect_dieordown_clear = data.ReadInt();
        /** 施加者死亡或下线后是否清除（0不清除，1清除） */
        self.q_user_dieordown_clear = data.ReadInt();
        /** 获得BUFF特效编号 */
        self.q_small_ico = data.ReadString();
        /** BUFF图标（36*36） */
        self.q_ico = data.ReadString();
        /** 显示于BUFF获得者身上的状态SWF动画编号（尺寸：24*24） */
        self.q_swf = data.ReadString();
        /** 鼠标TIPS界面上的描述信息（支持Html） */
        self.q_tips = data.ReadString();
        /** BUFF加属性，格式【格式:攻击：X,防御:X,闪避:X,魔法攻击:X,魔法防御:X,暴击:X,闪避:X,最大生命值:X,最大魔法:X,魔法攻击比例:X,无视防御比例:X,吸血比例:X,能量消耗降低:X,圣神伤害:X】 */
        self.q_attribute = data.ReadString();
        /** BUFF参数，技能ID、技能ID */
        self.q_Bonus_skill = data.ReadString();
        /** 下线是否计时（0不是，1是） */
        self.q_Line_time = data.ReadInt();
        /** 触发几率(万分比) */
        self.q_trigger_probability = data.ReadInt();
        /** 是否受VIP时间加成（1是，0否） */
        self.q_vip_bonus = data.ReadInt();
        /** 脚本BUFFID */
        self.q_script_id = data.ReadInt();
        /** 针对目标（1玩家） */
        self.q_target_type = data.ReadInt();
        /** 拥有BUFF者是否变色（0否，1是） */
        self.q_colour = data.ReadInt();
        /** 是否加成战斗力（1加成，0不加成） */
        self.q_fihgt = data.ReadInt();
        /** 关联buff技能（填技能ID） */
        self.q_other = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_buff.list = Q_buff.list|| [];
	/** 配置数据索引*/
	Q_buff.map = Q_buff.map || {};
	
	/** 设置配置数据*/
	Q_buff.SetData = Q_buff.SetData || function( data ){

		var list = Q_buff.list;
		var map = Q_buff.map;

		Q_buff.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_buff();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_buff_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_buff.GetList = Q_buff.GetList || function(){
		return Q_buff.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_buff.Get = Q_buff.Get || function( id ){
		return Q_buff.map[ id ];
	};
})();