var Q_cloak_up = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 披风编号 */
        self.q_modelID = data.ReadString();
        /** 披风名称 */
        self.q_name = data.ReadString();
        /** 是否是最高等阶(0:不是；1：是） */
        self.q_ismax = data.ReadInt();
        /** 进阶操作所需人物等级 */
        self.q_up_figure_level = data.ReadInt();
        /** 披风等级上限 */
        self.q_level_max = data.ReadInt();
        /** 开启的总技能格子数 */
        self.q_skill_num = data.ReadInt();
        /** 进阶每次消耗银两数量 */
        self.q_up_gold_num = data.ReadInt();
        /** 进阶消耗材料ID */
        self.q_up_item_id = data.ReadInt();
        /** 每次消耗材料数量 */
        self.q_up_item_num = data.ReadInt();
        /** 祝福值是否指定时间重置（0:不重置，1：重置） */
        self.q_isreset = data.ReadInt();
        /** 进阶成功所需进阶次数min */
        self.q_up_num_min = data.ReadInt();
        /** 进阶成功所需进阶次数max */
        self.q_up_num_max = data.ReadInt();
        /** 服务器端计算用进阶成功几率（万分比） */
        self.q_up_probability = data.ReadInt();
        /** 客户端显示用成功率 */
        self.q_up_clientshow_rate = data.ReadInt();
        /** 每次失败增加祝福值区间min */
        self.q_blessnum_min = data.ReadInt();
        /** 每次失败增加祝福值区间max */
        self.q_blessnum_max = data.ReadInt();
        /** 祝福值上限值 */
        self.q_blessnum_limit = data.ReadInt();
        /** 每次失败增加人物经验 */
        self.q_up_fail_addexp = data.ReadInt();
        /** 进阶成功是否全服公告（0不公告，1公告） */
        self.q_notice = data.ReadInt();
        /** 元宝升阶自动购买的道具对应的序列号【绑定元宝，元宝】  PS: 一定要绑定元宝在前 */
        self.q_shop_data = data.ReadString();
        /** 替代进阶道具  [道具ID,道具ID2] */
        self.q_replace_item = data.ReadString();
        /** 本阶升到下一阶返还道具ID */
        self.q_return_item = data.ReadInt();
        /** 强化道具使用数量上限[[道具ID,使用上限],[道具ID,使用上限]] */
        self.q_intensify_item = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_cloak_up.list = Q_cloak_up.list|| [];
	/** 配置数据索引*/
	Q_cloak_up.map = Q_cloak_up.map || {};
	
	/** 设置配置数据*/
	Q_cloak_up.SetData = Q_cloak_up.SetData || function( data ){

		var list = Q_cloak_up.list;
		var map = Q_cloak_up.map;

		Q_cloak_up.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_cloak_up();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_modelID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_cloak_up.GetList = Q_cloak_up.GetList || function(){
		return Q_cloak_up.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_cloak_up.Get = Q_cloak_up.Get || function( id ){
		return Q_cloak_up.map[ id ];
	};
})();