var Q_disguise_upgrade = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 易容ID_等阶_星级 */
        self.q_indexes = data.ReadString();
        /** 易容ID */
        self.q_id = data.ReadInt();
        /** 等阶 */
        self.q_level = data.ReadInt();
        /** 星级 */
        self.q_star = data.ReadInt();
        /** 是否满阶（0：否，1：是） */
        self.q_max = data.ReadInt();
        /** 头像品质（1：绿，2：蓝，3：紫，4：橙，5：红） */
        self.q_default = data.ReadInt();
        /** 进阶材料 */
        self.q_item_upgrade = data.ReadInt();
        /** 数量 */
        self.q_item_num = data.ReadInt();
        /** 成功率（万分比分子） */
        self.q_probability = data.ReadInt();
        /** 对应的技能等级 */
        self.q_skill = data.ReadInt();
        /** 技能说明文本 */
        self.q_skill_int = data.ReadString();
        /** 星级额外属性 */
        self.q_attribute = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_disguise_upgrade.list = Q_disguise_upgrade.list|| [];
	/** 配置数据索引*/
	Q_disguise_upgrade.map = Q_disguise_upgrade.map || {};
	
	/** 设置配置数据*/
	Q_disguise_upgrade.SetData = Q_disguise_upgrade.SetData || function( data ){

		var list = Q_disguise_upgrade.list;
		var map = Q_disguise_upgrade.map;

		Q_disguise_upgrade.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_disguise_upgrade();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_indexes)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_disguise_upgrade.GetList = Q_disguise_upgrade.GetList || function(){
		return Q_disguise_upgrade.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_disguise_upgrade.Get = Q_disguise_upgrade.Get || function( id ){
		return Q_disguise_upgrade.map[ id ];
	};
})();