var Q_ghost_story = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 副本ID */
        self.q_id = data.ReadInt();
        /** 副本类型 */
        self.q_zone_type = data.ReadInt();
        /** 副本名字 */
        self.q_zone_name = data.ReadString();
        /** 挑战所需通关的前置副本 */
        self.q_pre_story = data.ReadInt();
        /** 基础副本ID */
        self.q_base_id = data.ReadInt();
        /** 所需转生等级 */
        self.q_reincarnation = data.ReadInt();
        /** 层级 */
        self.q_level_id = data.ReadInt();
        /** 免费通关次数 */
        self.q_free_num = data.ReadInt();
        /** 每天可通关次数限制 */
        self.q_challenge_num = data.ReadInt();
        /** 购买1次所需的元宝 */
        self.q_reset_cost = data.ReadInt();
        /** 推荐战斗力 */
        self.q_ability = data.ReadInt();
        /** 关联的怪物要配置AI 44,地图存在的怪物及坐标[[id1,x,y],[id2,x,y],[id3,x,y]]  */
        self.q_map_boss = data.ReadString();
        /** 通关所需击杀的怪物 */
        self.q_kill_boss = data.ReadString();
        /** 副本描述 */
        self.q_introduce = data.ReadString();
        /** 怪物描述 */
        self.q_introduce_monster = data.ReadString();
        /** 展示掉落道具 */
        self.q_item_show = data.ReadString();
        /** 通关奖励 */
        self.q_reward = data.ReadString();
        /** 首次通关奖励 */
        self.q_first_reward = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_ghost_story.list = Q_ghost_story.list|| [];
	/** 配置数据索引*/
	Q_ghost_story.map = Q_ghost_story.map || {};
	
	/** 设置配置数据*/
	Q_ghost_story.SetData = Q_ghost_story.SetData || function( data ){

		var list = Q_ghost_story.list;
		var map = Q_ghost_story.map;

		Q_ghost_story.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_ghost_story();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_ghost_story.GetList = Q_ghost_story.GetList || function(){
		return Q_ghost_story.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_ghost_story.Get = Q_ghost_story.Get || function( id ){
		return Q_ghost_story.map[ id ];
	};
})();