var Q_godevil = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 战印编号 */
        self.q_id = data.ReadInt();
        /** 战印名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 战印界面战印名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 是否可被攻击(0不允许，1允许） */
        self.q_hit = data.ReadInt();
        /** 被攻击最大损失血量（无论是什么攻击都仅扣除1滴血） */
        self.q_hp_lose = data.ReadInt();
        /** 战印头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 战印面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用战印造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 战印特效 */
        self.q_effect = data.ReadInt();
        /** 战印描述文本 */
        self.q_introduce = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_godevil.list = Q_godevil.list|| [];
	/** 配置数据索引*/
	Q_godevil.map = Q_godevil.map || {};
	
	/** 设置配置数据*/
	Q_godevil.SetData = Q_godevil.SetData || function( data ){

		var list = Q_godevil.list;
		var map = Q_godevil.map;

		Q_godevil.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_godevil();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_godevil.GetList = Q_godevil.GetList || function(){
		return Q_godevil.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_godevil.Get = Q_godevil.Get || function( id ){
		return Q_godevil.map[ id ];
	};
})();