var Q_illusion = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 类型_幻化ID（注意不能超过127） */
        self.q_id = data.ReadString();
        /** 幻化名字 */
        self.q_name = data.ReadString();
        /** 幻化所需的前置ID */
        self.q_need_id = data.ReadInt();
        /** 幻化面板显示顺序 (-1 是不显示） */
        self.q_order = data.ReadInt();
        /** 幻化类型（100：披风幻化 101 坐骑幻化  102 跟宠 103光翼幻化 104 王者造型 ） */
        self.q_type = data.ReadInt();
        /** 展示类型（是否展示给其他玩家  0：不   1：展示) */
        self.q_show_player = data.ReadInt();
        /** 头像资源编号 */
        self.q_head = data.ReadInt();
        /** 展示资源编号 */
        self.q_show = data.ReadInt();
        /** 激活类型(1:充值（首冲），2：VIP，3：道具激活    4：任务激活） */
        self.q_activate_type = data.ReadInt();
        /** 激活条件 [激活道具，激活道具所需数量]，若为VIP激活，则直接填写VIP等级，若为任务激活，直接填写任务ID */
        self.q_activate_need = data.ReadString();
        /** 激活的技能 */
        self.q_skill = data.ReadInt();
        /** 魔仆属性丹使用  [[道具ID，道具数量]] */
        self.q_item_use = data.ReadString();
        /** 属性类型 */
        self.q_attribute = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_illusion.list = Q_illusion.list|| [];
	/** 配置数据索引*/
	Q_illusion.map = Q_illusion.map || {};
	
	/** 设置配置数据*/
	Q_illusion.SetData = Q_illusion.SetData || function( data ){

		var list = Q_illusion.list;
		var map = Q_illusion.map;

		Q_illusion.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_illusion();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_illusion.GetList = Q_illusion.GetList || function(){
		return Q_illusion.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_illusion.Get = Q_illusion.Get || function( id ){
		return Q_illusion.map[ id ];
	};
})();