var Q_kylin_skills = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 麒麟臂技能编号_技能等级 */
        self.q_id = data.ReadString();
        /** 技能ID */
        self.q_skillId = data.ReadInt();
        /** 技能等级 */
        self.q_level = data.ReadInt();
        /** 技能书ID（用于激活技能） */
        self.q_item = data.ReadInt();
        /** 被吞噬提供经验 */
        self.q_addexp = data.ReadInt();
        /** 升级所需经验 */
        self.q_exp = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_kylin_skills.list = Q_kylin_skills.list|| [];
	/** 配置数据索引*/
	Q_kylin_skills.map = Q_kylin_skills.map || {};
	
	/** 设置配置数据*/
	Q_kylin_skills.SetData = Q_kylin_skills.SetData || function( data ){

		var list = Q_kylin_skills.list;
		var map = Q_kylin_skills.map;

		Q_kylin_skills.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_kylin_skills();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_kylin_skills.GetList = Q_kylin_skills.GetList || function(){
		return Q_kylin_skills.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_kylin_skills.Get = Q_kylin_skills.Get || function( id ){
		return Q_kylin_skills.map[ id ];
	};
})();