var Q_magic_remove = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 资源线类型1坐骑2骑兵3美人4光翼5祥云6腰甲7凶戮8焚神9恶屠10煞佛11天使12恶魔 */
        self.q_modelID = data.ReadString();
        /** 生命值 */
        self.q_maxHp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defense = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        /** 技能名字 */
        self.q_skill_name = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_magic_remove.list = Q_magic_remove.list|| [];
	/** 配置数据索引*/
	Q_magic_remove.map = Q_magic_remove.map || {};
	
	/** 设置配置数据*/
	Q_magic_remove.SetData = Q_magic_remove.SetData || function( data ){

		var list = Q_magic_remove.list;
		var map = Q_magic_remove.map;

		Q_magic_remove.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_magic_remove();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_modelID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_magic_remove.GetList = Q_magic_remove.GetList || function(){
		return Q_magic_remove.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_magic_remove.Get = Q_magic_remove.Get || function( id ){
		return Q_magic_remove.map[ id ];
	};
})();