var Q_magical = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 神兵编号 */
        self.q_modelID = data.ReadInt();
        /** 神兵名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 场景中使用神兵造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 神兵面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 神兵头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 神兵文本描述介绍 */
        self.q_introduce = data.ReadString();
        /** 神兵最大可升星级 */
        self.q_level_max = data.ReadInt();
        /** 激活最低星级 */
        self.q_level_initial = data.ReadInt();
        /** 激活所需碎片 */
        self.q_activate_soul_need = data.ReadInt();
        /** 激活,升星所需灵魂碎片(升到2星所需碎片数量|升到3星所需碎片数量|升到4星所需碎片数量|升到5星所需碎片数量） */
        self.q_up_soul_need = data.ReadString();
        /** 对应的灵魂碎片ID */
        self.q_soulID = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_magical.list = Q_magical.list|| [];
	/** 配置数据索引*/
	Q_magical.map = Q_magical.map || {};
	
	/** 设置配置数据*/
	Q_magical.SetData = Q_magical.SetData || function( data ){

		var list = Q_magical.list;
		var map = Q_magical.map;

		Q_magical.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_magical();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_modelID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_magical.GetList = Q_magical.GetList || function(){
		return Q_magical.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_magical.Get = Q_magical.Get || function( id ){
		return Q_magical.map[ id ];
	};
})();