var Q_medal = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 索引 */
        self.q_id = data.ReadString();
        /** 勋章ID */
        self.q_medal = data.ReadInt();
        /** 勋章等级 */
        self.q_level = data.ReadInt();
        /** 是否本阶最高级 */
        self.q_ismax = data.ReadInt();
        /** 战魂对应的资源编号 */
        self.q_art = data.ReadString();
        /** 升级所需的战魂 */
        self.q_soul = data.ReadInt();
        /** 银两升级（每点战魂所需的银两值） */
        self.q_replace_silver = data.ReadInt();
        /** 真气升级（每点战魂所需的真气两值） */
        self.q_replace_energy = data.ReadInt();
        /** 生命值 */
        self.q_max_hp = data.ReadInt();
        /** 攻击力 */
        self.q_attack = data.ReadInt();
        /** 防御力 */
        self.q_defence = data.ReadInt();
        /** 命中值 */
        self.q_hit = data.ReadInt();
        /** 闪避值 */
        self.q_dodge = data.ReadInt();
        /** 暴击值 */
        self.q_crit = data.ReadInt();
        /** 抗暴值 */
        self.q_antiCrit = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_medal.list = Q_medal.list|| [];
	/** 配置数据索引*/
	Q_medal.map = Q_medal.map || {};
	
	/** 设置配置数据*/
	Q_medal.SetData = Q_medal.SetData || function( data ){

		var list = Q_medal.list;
		var map = Q_medal.map;

		Q_medal.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_medal();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_medal.GetList = Q_medal.GetList || function(){
		return Q_medal.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_medal.Get = Q_medal.Get || function( id ){
		return Q_medal.map[ id ];
	};
})();