var Q_qq_quest = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** id */
        self.q_id = data.ReadInt();
        /** 条件（1:等级，2：通关单人副本,3：通关多人副本  4:坐骑升到指定阶  5:3个基础技能升到4级 6：通关虚空之门  ） */
        self.q_condition_type = data.ReadInt();
        /** 条件对应的值 */
        self.q_condition_num = data.ReadInt();
        /** 邮件内容 */
        self.q_int = data.ReadString();
        /** 领取道具 */
        self.q_reward = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_qq_quest.list = Q_qq_quest.list|| [];
	/** 配置数据索引*/
	Q_qq_quest.map = Q_qq_quest.map || {};
	
	/** 设置配置数据*/
	Q_qq_quest.SetData = Q_qq_quest.SetData || function( data ){

		var list = Q_qq_quest.list;
		var map = Q_qq_quest.map;

		Q_qq_quest.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_qq_quest();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_qq_quest.GetList = Q_qq_quest.GetList || function(){
		return Q_qq_quest.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_qq_quest.Get = Q_qq_quest.Get || function( id ){
		return Q_qq_quest.map[ id ];
	};
})();