var Q_scene_monster_area = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 刷怪编号 */
        self.q_id = data.ReadInt();
        /** 刷怪地图编号 */
        self.q_mapid = data.ReadInt();
        /** 怪物ID */
        self.q_monster_model = data.ReadInt();
        /** 刷怪数量 */
        self.q_monster_num = data.ReadInt();
        /** 刷新中心点X（格子坐标） */
        self.q_center_x = data.ReadInt();
        /** 刷新中心点Y（格子坐标） */
        self.q_center_y = data.ReadInt();
        /** 刷新半径（格子数量） */
        self.q_radius = data.ReadInt();
        /** 重生时间脱离怪物数据库控制变更为：0本规则不启用， >0则为变更后的重生时间，单位：秒 */
        self.q_relive = data.ReadInt();
        /** 攻击类型脱离怪物数据库控制变更为：0本规则不启用，1变更为被动攻击类怪物，2变更为主动攻击类怪物 */
        self.q_attack = data.ReadInt();
        /** 巡逻间隔 */
        self.q_patrol_time = data.ReadInt();
        /** 巡逻几率 */
        self.q_patrol_pro = data.ReadInt();
        /** 是否隐藏 */
        self.q_whether_display = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_scene_monster_area.list = Q_scene_monster_area.list|| [];
	/** 配置数据索引*/
	Q_scene_monster_area.map = Q_scene_monster_area.map || {};
	
	/** 设置配置数据*/
	Q_scene_monster_area.SetData = Q_scene_monster_area.SetData || function( data ){

		var list = Q_scene_monster_area.list;
		var map = Q_scene_monster_area.map;

		Q_scene_monster_area.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_scene_monster_area();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_scene_monster_area.GetList = Q_scene_monster_area.GetList || function(){
		return Q_scene_monster_area.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_scene_monster_area.Get = Q_scene_monster_area.Get || function( id ){
		return Q_scene_monster_area.map[ id ];
	};
})();