var Q_story = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 副本ID */
        self.q_id = data.ReadInt();
        /** 挑战所需通关的前置副本 */
        self.q_pre_story = data.ReadInt();
        /** 基础副本ID */
        self.q_base_id = data.ReadInt();
        /** 层级 */
        self.q_level_id = data.ReadInt();
        /** 每天可通关次数限制 */
        self.q_challenge_num = data.ReadInt();
        /** 每天可购买次数 */
        self.q_num_buy = data.ReadInt();
        /** 购买所需消耗元宝 */
        self.q_cost_buy = data.ReadString();
        /** 关联的怪物要配置AI 44,地图存在的怪物及坐标[[id1,x,y],[id2,x,y],[id3,x,y]]  */
        self.q_map_boss = data.ReadString();
        /** 副本描述 */
        self.q_introduce = data.ReadString();
        /** 怪物描述 */
        self.q_introduce_monster = data.ReadString();
        /** 展示掉落道具 */
        self.q_item_show = data.ReadString();
        /** 通关奖励 */
        self.q_reward = data.ReadString();
        /** 首次通关奖励 */
        self.q_first_reward = data.ReadString();
        /** 扫荡所需掉落的怪物   [怪物ID，怪物ID] */
        self.q_drop_monsterid = data.ReadString();
        /** 副本通关条件  ( 1：波数  2：BOSS） [类型，条件] */
        self.q_succeed_type = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_story.list = Q_story.list|| [];
	/** 配置数据索引*/
	Q_story.map = Q_story.map || {};
	
	/** 设置配置数据*/
	Q_story.SetData = Q_story.SetData || function( data ){

		var list = Q_story.list;
		var map = Q_story.map;

		Q_story.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_story();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_story.GetList = Q_story.GetList || function(){
		return Q_story.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_story.Get = Q_story.Get || function( id ){
		return Q_story.map[ id ];
	};
})();