var Q_target = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 等级（自动寻找最高级别的挂机点） */
        self.q_level = data.ReadInt();
        /** 地图ID */
        self.q_mapid = data.ReadInt();
        /** 目标点怪物id[[怪物ID1],[怪物ID2],[怪物ID3]]，与坐标点对应 */
        self.q_monsterid = data.ReadString();
        /** 目标点坐标：X坐标，Y坐标[[x,y],[x,y][x,y][x,y][x,y]] */
        self.q_target = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_target.list = Q_target.list|| [];
	/** 配置数据索引*/
	Q_target.map = Q_target.map || {};
	
	/** 设置配置数据*/
	Q_target.SetData = Q_target.SetData || function( data ){

		var list = Q_target.list;
		var map = Q_target.map;

		Q_target.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_target();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_level)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_target.GetList = Q_target.GetList || function(){
		return Q_target.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_target.Get = Q_target.Get || function( id ){
		return Q_target.map[ id ];
	};
})();