var Q_title = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 称号ID */
        self.q_id = data.ReadInt();
        /** 标签页 */
        self.q_subfield = data.ReadInt();
        /** 标签页名称 */
        self.q_subfield_name = data.ReadString();
        /** 平台标示(37,xunlei) */
        self.q_web = data.ReadString();
        /** 称号名称 =CONCATENATE("<font color=""#df2505"">",D211,"</font>") */
        self.q_name = data.ReadString();
        /** 头衔资源类型（0：图片，1：特效） */
        self.q_art_type = data.ReadInt();
        /** 称号资源编号（场景特效及面板暂时资源编号命名一致） */
        self.q_art = data.ReadString();
        /** 称号描述 */
        self.q_introduce = data.ReadString();
        /** 激活条件[ [类型，目标值], [类型，目标值]]类型需与程序确定 */
        self.q_activate = data.ReadString();
        /** 激活所需道具ID [[道具ID，道具数量]] */
        self.q_activate_item = data.ReadString();
        /** 每次激活时限(秒)【-1为永久激活】 */
        self.q_time = data.ReadInt();
        /** 对应的活动 类型（对应q_system_activity表里的ID） */
        self.q_system_activity = data.ReadInt();
        /** 对应的活动过期类型（1：每次活动开启时过期，2：每次活动结束后过期） */
        self.q_past_type = data.ReadInt();
        /** 是否心情头衔 */
        self.q_is_mood = data.ReadInt();
        /** 经验加成（万分比分子） */
        self.q_exp = data.ReadInt();
        /** 属性类型 */
        self.q_attribute = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_title.list = Q_title.list|| [];
	/** 配置数据索引*/
	Q_title.map = Q_title.map || {};
	
	/** 设置配置数据*/
	Q_title.SetData = Q_title.SetData || function( data ){

		var list = Q_title.list;
		var map = Q_title.map;

		Q_title.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_title();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_title.GetList = Q_title.GetList || function(){
		return Q_title.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_title.Get = Q_title.Get || function( id ){
		return Q_title.map[ id ];
	};
})();