var Q_tujian = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 图鉴ID_图鉴等级 */
        self.q_id = data.ReadString();
        /** 主标签类型（1：野外图鉴，2：跨服图鉴） */
        self.q_main_type = data.ReadInt();
        /** 子标签页ID */
        self.q_second_type = data.ReadInt();
        /** 显示所需等级 */
        self.q_show_level = data.ReadInt();
        /** 怪物展示美术资源 */
        self.q_monster_show = data.ReadInt();
        /** 道具ID */
        self.q_item = data.ReadInt();
        /** 道具数量 */
        self.q_num = data.ReadInt();
        /** 怪物ID */
        self.q_monster_id = data.ReadInt();
        /** 自动寻路信息（地图ID，X，Y） */
        self.q_position = data.ReadString();
        /** 属性 */
        self.q_attribute = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_tujian.list = Q_tujian.list|| [];
	/** 配置数据索引*/
	Q_tujian.map = Q_tujian.map || {};
	
	/** 设置配置数据*/
	Q_tujian.SetData = Q_tujian.SetData || function( data ){

		var list = Q_tujian.list;
		var map = Q_tujian.map;

		Q_tujian.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_tujian();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_tujian.GetList = Q_tujian.GetList || function(){
		return Q_tujian.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_tujian.Get = Q_tujian.Get || function( id ){
		return Q_tujian.map[ id ];
	};
})();