﻿/**
 * 	战斗属性
 */
var EnumAttribute  = EnumAttribute || {
	ATTACK: 1,			// 基础攻击力
	DEFEND: 2,			// 基础防御力
	CRIT: 3,			// 基础暴击值
	ANTI_CRIT: 4,		// 抗暴击
	DODGE: 5,			// 基础闪避值
	HIT: 6,			// 基础命中值
	MAX_BASEHP: 7,		// 基础生命上限
	ATTACK_SPEED: 8,	// 基础攻击速度
	MOVE_SPEED: 9,	// 基础移动速度
	HOLY_DAMAGE: 10,	//神圣伤害
	DAMAGE_BONUS: 11,	// 伤害加成
	DAMAGE_REDUCE: 12,	// 伤害减免
	AUTO_RECOVER_HP: 13,//自动回复hp
	CRIT_DAMAGE_BONUS: 14,	//暴击伤害加成比例
	CRIT__REDUCE: 15,	//暴击减免比例
	EXP_BONUS: 16,		//经验加成
	SKILL_BONUS:17,     //技能伤害加成
	BRILLIANT_DAMAGE:18,	//神武伤害

	ATTACK_PERCENT:30,		//攻击总比例
	DEFEND_PERCENT:31,		//防御总比例
	CRIT_PERCENT:32,		//暴击总比例
	ANTI_CRIT_PERCENT:33,	//抗暴总比例
	DODGE_PERCENT:34,		//闪避总比例
	HIT_PERCENT:35,			//命中总比例
	MAXHP_PERCENT:36,		//最大血量总比例
	ATTACK_SPEED_PERCENT:37,//攻击速度总比例
	MOVE_SPEED_PERCENT:38,	//移动速度总比例

	PALSY_PERCENT: 50,		//麻痹万分比
	ANTI_PALSY_PERCENT: 51,//抗麻痹万分比
};
/*
	基础属性
 */
var EnumBaseAttribute = EnumBaseAttribute || {
	HP:1,			//当前血量
	LEVEL:2,		//当前等级
	NUQI:3,		//当前怒气
};
/*
	货币类型
 */
var EnumMoney = EnumMoney || {
	GOLD:-1,			//充值元宝
	BIND_GOLD:-2,		//元宝
	EXP:-3,				//经验
	PRESTIGE:-4,		//声望
    GONGXUN:-5,			//功勋
	TIME_GOLD:-6,		//限时元宝
	GUILDDEVOTE:-7,     ///帮会贡献度
    HONOR:-8,			//荣誉
	XUNBAO_SCORE:-10,   //寻宝积分(武林庆典)
	CRYSTAL:-12,		//水晶_货币
	LUCKY_GOLD:-19,     //幸运积分
	EXCHANGE:509011,		//红色装备兑换券
};