﻿var AchievementModMgr = AchievementModMgr || cc.Class.extend({ 
	_achievementHash:null,//成就q_achievement Hash,按类型
	_achievementTypePointHash:null,//成就总点数hash
	_achievementCanGetRawardHash:null,//可领奖hash
	achievementTypeNowPointHash:null,//成就总当前点数hash(不包含总成就的)
	achievementTypeNowValueHash:null,//成就类型完成度hash
	rewardAchievementIds:null,//已领奖成就id
	allAchievementTypeNowPoint:0,
	achievementpanel:null,
	achievementMainPanel:null,
	_isinitCanGetRaward:false,
	_rawardStrHash:null,
	ctor:function() {	
	},
	
	/**
	 * [q_type1,q_type2]
	 * [type1vlue1,type1vlue2]
	 * [type2vlue1,type2vlue2]
	 */
	InitHash:function () {
		this._achievementHash = new HashMap();
		this._achievementTypePointHash = new HashMap();
		var list = Q_achievement.GetList();
		for(var i = 0; i < list.length; i++){
			if( !this._achievementHash.Get( list[i].q_subfield ) ){
					var tempArr = new Array();
					this._achievementHash.Put( list[i].q_subfield, tempArr );
					var tempArr2 = new Array();
					this._achievementHash.Get( list[i].q_subfield ).push(tempArr2);
			}
			if( this._achievementHash.Get( list[i].q_subfield )[0].indexOf( list[i].q_smaller_subfield ) == -1 ){
				this._achievementHash.Get( list[i].q_subfield )[0].push( list[i].q_smaller_subfield );
				var tempArr3 = new Array();
				this._achievementHash.Get( list[i].q_subfield ).push(tempArr3);
			}
			var valueIndex = this._achievementHash.Get( list[i].q_subfield )[0].indexOf( list[i].q_smaller_subfield );
			this._achievementHash.Get( list[i].q_subfield )[ valueIndex + 1 ].push( list[i] );
			
			if( list[i].q_subfield != 1 ){
				if( !this._achievementTypePointHash.Get( list[i].q_subfield ) ){
					this._achievementTypePointHash.Put( list[i].q_subfield, list[i].q_num );
				}else{
					this._achievementTypePointHash.Put( list[i].q_subfield, this._achievementTypePointHash.Get( list[i].q_subfield ) + list[i].q_num );
				}
				if( !this._achievementTypePointHash.Get( 1 ) ){
					this._achievementTypePointHash.Put( 1, list[i].q_num );
				}else{
					this._achievementTypePointHash.Put( 1, this._achievementTypePointHash.Get( 1 ) + list[i].q_num );
				}
			}
		}
	},
	
	InitCanGetRawardHash:function () {
		var list = Q_achievement.GetList();
		for(var i = 0; i < list.length; i++){
			this._UpdataGetRawardHash(list[i]);
		}
	},
	
	AchievementHash:function () {
		if( !this._achievementHash ){
			this.InitHash();
		}
		return this._achievementHash;
	},
	
	AchievementTypePointHash:function () {
		if( !this._achievementTypePointHash ){
			this.InitHash();
		}
		return this._achievementTypePointHash;
	},
	
	AchievementCanGetRawardHash:function () {
		if( !this._achievementCanGetRawardHash ){
			this._achievementCanGetRawardHash = new HashMap();
		}
		return this._achievementCanGetRawardHash;
	},
	
	//检测是否有可领取奖励
	CheckCanGetRaward:function(id){
		var data1 = Q_achievement.Get(id);
		var typeNum1 = 0;
		if(Mgr.achievement.achievementTypeNowValueHash && Mgr.achievement.achievementTypeNowValueHash.Get(data1.q_type))
			typeNum1 = Mgr.achievement.achievementTypeNowValueHash.Get(data1.q_type);
		var canGetRaward1 = (this.rewardAchievementIds.indexOf( data1.q_id ) == -1 && typeNum1 >= data1.q_value);
		return canGetRaward1;
	},
	
	_UpdataGetRawardHash:function(data){
		if( !this.AchievementCanGetRawardHash().Get( data.q_subfield ) ){
			var tempArr = new Array();
			this.AchievementCanGetRawardHash().Put( data.q_subfield, tempArr );
			var tempArr2 = new Array();
			this.AchievementCanGetRawardHash().Get( data.q_subfield ).push(tempArr2);
		}
		if( this.AchievementCanGetRawardHash().Get( data.q_subfield )[0].indexOf( data.q_smaller_subfield ) == -1 ){
			this.AchievementCanGetRawardHash().Get( data.q_subfield )[0].push( data.q_smaller_subfield );
			var tempArr3 = new Array();
			this.AchievementCanGetRawardHash().Get( data.q_subfield ).push(tempArr3);
		}
		var objArr = this.AchievementHash().Get(data.q_subfield)[data.q_smaller_subfield];
		var canGetRaward = this.CheckCanGetRaward(data.q_id);
//		for(var j = 0; j < objArr.length; j++){
//			if(this.CheckCanGetRaward(objArr[j].q_id)){
//				canGetRaward = true
//				break;
//			}
//		}
		var valueIndex = this.AchievementCanGetRawardHash().Get( data.q_subfield )[0].indexOf( data.q_smaller_subfield );
		var idIndex = this.AchievementCanGetRawardHash().Get( data.q_subfield )[ valueIndex + 1 ].indexOf(data.q_id);
		if(idIndex == -1){
			this.AchievementCanGetRawardHash().Get( data.q_subfield )[ valueIndex + 1 ].push( data.q_id );
			this.AchievementCanGetRawardHash().Get( data.q_subfield )[ valueIndex + 1 ].push( canGetRaward );
		}else{
			this.AchievementCanGetRawardHash().Get( data.q_subfield )[ valueIndex + 1 ][idIndex+1] = canGetRaward;
		}
		

	},
	
	HaveRawardCanGet:function(type){
		if(type == -1){
			for(var k = 0; k < this.AchievementCanGetRawardHash().Values().length; k++){
				var arr = this.AchievementCanGetRawardHash().Values()[k];
				for(var i = 0; i < arr[0].length; i++){
					var tempArr = arr[arr[0][i]];
					for(var j = 0; j < tempArr.length; j++){
						if(tempArr[j] == true){
							return true;
						}
					}
				}
			}
		}else{
			var arr = this.AchievementCanGetRawardHash().Get( type );
			if(arr == null)
				return false;
			for(var i = 0; i < arr[0].length; i++){
				var tempArr = arr[arr[0][i]];
				for(var j = 0; j < tempArr.length; j++){
					if(tempArr[j] == true){
						return true;
					}
				}
			}
		}
		
		return false;
	},
	
	HaveRawardCanGetBySubBtn:function(type, subtype){
		var arr = this.AchievementCanGetRawardHash().Get( type );
		if(!arr)
			return false;
		var index = arr[0].indexOf(subtype);
		if(index == -1)
			return false;
		var canGet = false;
		for(var i = 0; i < arr[index+1].length; i++){
			if(arr[index+1][i] == true){
				canGet = true;
				break;
			}
		}
		return canGet;
	},
	
	GetRawardArrById:function(id,qraward){
		if(!this._rawardStrHash)
			this._rawardStrHash = new HashMap();
		if(!this._rawardStrHash.Get(id))
		{
			this._rawardStrHash.Put(id, JSON.parse( qraward ));
		}
		return this._rawardStrHash.Get(id);
	},

	RecvResSendAchievementDataInfoMessage:function(msg) {	
		if( !this.achievementTypeNowPointHash ){
			this.achievementTypeNowPointHash = new HashMap();
		}
		this.achievementTypeNowPointHash.Clear();
		this.rewardAchievementIds = msg.rewardAchievementIds;
		for( var i = 0; i < this.rewardAchievementIds.length; i++ ){
			var data = Q_achievement.Get( this.rewardAchievementIds[i] );
			if( !this.achievementTypeNowPointHash.Get( data.q_subfield ) ){
				this.achievementTypeNowPointHash.Put( data.q_subfield, data.q_num );
			}else{
				this.achievementTypeNowPointHash.Put( data.q_subfield, this.achievementTypeNowPointHash.Get( data.q_subfield ) + data.q_num );
			}
		}
		
		if( !this.achievementTypeNowValueHash ){
			this.achievementTypeNowValueHash = new HashMap();
		}
		var list = msg.achievementDataInfo;
		for( i = 0; i < list.length; i++ ){
			this.achievementTypeNowValueHash.Put(list[i].achievementType, list[i].value);
		}
		
		if(!this._isinitCanGetRaward){
			this.InitCanGetRawardHash();
			this._isinitCanGetRaward = false;
		}
		
		// Mgr.player.shortPanel.imgChengjiuWarn.setVisible(this.HaveRawardCanGet(-1));
        UIUtil.SetRedTipVisible(Mgr.player.shortPanel.imgChengjiuWarn, this.HaveRawardCanGet(-1));
		var panel = EngineMgr.uiMgr.GetPanelByType(AchievementPanelExt.PanelName);
		if(panel)
            panel.UpdateBtnWarn();
	},

	RecvResSendFinishAchievementMessage:function(msg) {	
		//这里后面可以处理下，收到达成新成就的消息，按钮上显示个小红点什么的
		if(Mgr.uiMgr.IsPanelShow( this.achievementpanel )){
			this.SendReqSendAchievementDataInfoMessage();
		}
		Mgr.uiMgr.ShowPanelByType(AchievementFrameExt.PanelName);
		Mgr.uiMgr.GetPanelByType(AchievementFrameExt.PanelName).SetData(msg.achievementId);

		for( var i = 0; i < msg.achievementId.length; i++ ){
			var data = Q_achievement.Get( msg.achievementId[i] );
			// if( !this.achievementTypeNowPointHash.Get( data.q_subfield ) ){
			// 	this.achievementTypeNowPointHash.Put( data.q_subfield, data.q_num );
			// }else{
			// 	this.achievementTypeNowPointHash.Put( data.q_subfield, this.achievementTypeNowPointHash.Get( data.q_subfield ) + data.q_num );
			// }
			this._UpdataGetRawardHash(data);
		}

		if(Mgr.uiMgr.IsPanelShow( this.achievementpanel )){
//			this.achievementpanel.UpdataCellByAchievementId( msg.achievementId );
			this.achievementpanel.UpdataBtnCanGetRawardShow();
			this.achievementpanel.UpdataCell();
		}
		// Mgr.player.shortPanel.imgChengjiuWarn.setVisible(this.HaveRawardCanGet(-1));
        UIUtil.SetRedTipVisible(Mgr.player.shortPanel.imgChengjiuWarn, this.HaveRawardCanGet(-1));
        var panel = EngineMgr.uiMgr.GetPanelByType(AchievementPanelExt.PanelName);
        if(panel)
            panel.UpdateBtnWarn();
	},

	RecvResSendGetAchievementAwardMessage:function(msg) {
		this.rewardAchievementIds.push(msg.achievementId);
		var data = Q_achievement.Get( msg.achievementId );
		if( !this.achievementTypeNowPointHash.Get( data.q_subfield ) ){
			this.achievementTypeNowPointHash.Put( data.q_subfield, data.q_num );
		}else{
			this.achievementTypeNowPointHash.Put( data.q_subfield, this.achievementTypeNowPointHash.Get( data.q_subfield ) + data.q_num );
		}
		this._UpdataGetRawardHash(data);
		cc.log("get reward:   " + JSON.stringify(msg));
		if(this.achievementMainPanel){
			this.achievementMainPanel.RefreshCellAndMain(msg.achievementId);
		}
		// Mgr.player.shortPanel.imgChengjiuWarn.setVisible(this.HaveRawardCanGet(-1));
        UIUtil.SetRedTipVisible(Mgr.player.shortPanel.imgChengjiuWarn, this.HaveRawardCanGet(-1));
        var panel = EngineMgr.uiMgr.GetPanelByType(AchievementPanelExt.PanelName);
        if(panel)
            panel.UpdateBtnWarn();
	},
	
	RecvResAchievementPointToClientMessage:function(msg) {	
		this.allAchievementTypeNowPoint = msg.achievementPoint;
	},
	
	RecvResAchievementChangeToClientMessage:function(msg) {	
		this.achievementTypeNowValueHash.Put(msg.achievementDataInfo.achievementType, msg.achievementDataInfo.value);
		if(Mgr.uiMgr.IsPanelShow( this.achievementpanel )){
			this.achievementpanel.UpdataCell();
		}
	},

	SendReqSendAchievementDataInfoMessage:function() {	
		var msg = new ReqSendAchievementDataInfoMessage();
		Mgr.msgMgr.Send( msg );
	},

	SendReqSendGetAchievementAwardMessage:function(achievementId) {	
		var msg = new ReqSendGetAchievementAwardMessage();
		msg.achievementId = achievementId;
		Mgr.msgMgr.Send( msg );
	},

	GetAchieveItemInfoList:function(data){
		var list = [];
		for(var i = 0; i < data.length; i++){

		}
	},
});