var AchievementListExt = AchievementList.extend ( {
	_className:"AchievementListExt",
	data:null,
	ctor:function(){
		this._super();
	},
	
	Init:function(){
		AchievementList.prototype.Init.call( this );
		this.setTouchEnabled(false)

		var self = this;
		this.btnGet.addClickEventListener(function (event){
			Mgr.achievement.SendReqSendGetAchievementAwardMessage(self.data.q_id);
		});
	},

	SetData:function (data) {
		this.data = data;
		this.labName.SetText(this.data.q_name);
		this.labCue.SetText(this.data.q_introduce + TextUtil.FormatStr( "({@}/{@})", [ 0, this.data.q_value ] ));
        if( this.data.q_num > 0 ){
            this.imgIcon.setVisible(true);
            this.labNumber.setVisible(true);
            this.labNumber.SetText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ this.data.q_num ] ));
        }else{
            this.imgIcon.setVisible(false);
            this.labNumber.setVisible(false);
        }

        UIUtil.LoadImage(this.imgIcon1, "other/chengjiu/iamge/icon/" + data.q_type + ".png");
		if( this.data.q_reward ) {
            var rewardArr = Mgr.achievement.GetRawardArrById(this.data.q_id, this.data.q_reward);
            var item = ItemUtil.ItemIdToItem(rewardArr[0].mod, rewardArr[0].num, rewardArr[0].bind);
            GridUtil.SetItemGrid(this.gridItem, item);
        }
		this.Update();
	},

	Update:function () {
		var typeNum = 0;
		if(Mgr.achievement.achievementTypeNowValueHash && Mgr.achievement.achievementTypeNowValueHash.Get(this.data.q_type))
			typeNum = Mgr.achievement.achievementTypeNowValueHash.Get(this.data.q_type);
		this.labCue.SetText(this.data.q_introduce + TextUtil.FormatStr( "({@}/{@})", [ Math.min(typeNum, this.data.q_value), this.data.q_value ] ));
		if( Mgr.achievement.rewardAchievementIds.indexOf( this.data.q_id) != -1 ){//已领奖
			this.imgBg2.setVisible(true);
			this.imgList.setVisible(false);
			this.imgYilingqu.setVisible(true);
			this.btnGet.setVisible(false);
			this.imgWeidacheng.setVisible(false);
		}else{
            this.imgBg2.setVisible(false);
            this.imgList.setVisible(true);
			this.imgYilingqu.setVisible(false);
			if( typeNum >= this.data.q_value ){//可领奖
				this.imgWeidacheng.setVisible(false);
				this.btnGet.setVisible(true);
			}else{
				this.imgWeidacheng.setVisible(true);
				this.btnGet.setVisible(false);
			}
		}
	}
} );
AchievementListExt.PanelName = "AchievementListExt";
PanelClassDic["AchievementListExt"] = AchievementListExt;
