var ArmorModMgr = ArmorModMgr || cc.Class.extend({
		_isOpen:false,
		isOldedTime:false,//过时
		_zhanjiaData:null,
		_isAllMax:false,
		ctor:function() {
		},

        RecvResArmorActiveClientMessage:function(msg){
            // 接到次消息触发光羽解锁流程
            var main = BtnGroupUtil.M_ROLE;
            var sub = BtnGroupUtil.ROLE_ARMOR;

            BtnGroupUtil.SetFunctionOpen(main,sub);
            BtnGroupUtil.OnNewFuncOpened(main, sub);
            BtnGroupUtil.ShowNewFuncCue1(main, sub, true);
        },
		RecvResArmorDataInfoToClientMessage:function(msg) {
			this.isOpen = true;
			this._zhanjiaData = msg.armorDataInfo;
			var isOverTime = this.JugementZhanjiaOverTime( msg.armorDataInfo );
			if ( !isOverTime )
			{
				this.isOldedTime = false;
			}
			else
			{
				this.isOldedTime = true;
			}
			var panel = this.GetZhanjiaPanel();
			if(panel&&!isOverTime)
			{
				panel.SetZhanjiaData(msg.armorDataInfo);
			}
			else if(panel)
			{
				panel.InitLabZhanjiaCue();
			}
			var panel02 = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName);
			if(panel02)
			{
				panel02.UpDataZhanjiaWarn();
			}
			var guangyuid = this._zhanjiaData.showModelId;
			this._RefreshGuangyuRes(guangyuid,Mgr.player.mainPlayer.sid);
		},
		RecvResArmorCuilianResultToClientMessage:function(msg) {
			if(msg.result)
			{
				Mgr.tips.ShowNotice( "淬炼成功" );
			}
			Mgr.armor.SendReqArmorDataInfoToGameMessage();
		},

		RecvResArmorChangeShowClientMessage:function(msg) {
			this._RefreshGuangyuRes(msg.showModelId,msg.playerId);
			if(msg.playerId.toGID() == Mgr.player.mainPlayer.sid.toGID())
			{
				var panel = this.GetZhanjiaPanel();
				if(panel)
				{
					panel.PutOnData(msg);
				}
			}
		},
		_RefreshGuangyuRes:function(showModelId,playerId)
		{
			Mgr.player.mainPlayer.armorShowId = showModelId;
			var player = Mgr.sceneObj.FindObject(playerId.toGID());
			if( player ){
				player.UpdateGuangyuId(showModelId);
				player.RefreshShowBody();
			}
		},
		// 请求战甲信息 //
		SendReqArmorDataInfoToGameMessage:function(msg) {
			var msg = new ReqArmorDataInfoToGameMessage();
			Mgr.msgMgr.Send(msg);
		},
		// 请求战甲淬炼 //
		SendReqArmorCuilianToGameMessage:function(itemModelId,itemNum) {
			var msg = new ReqArmorCuilianToGameMessage();
			msg.itemModelId = itemModelId;
			msg.itemNum = itemNum;
			Mgr.msgMgr.Send(msg);
		},
		// 请求战甲穿戴 //
		SendReqArmorChangeShowToGameMessage:function(showModelId) {
			var msg = new ReqArmorChangeShowToGameMessage();
			msg.showModelId = showModelId;
			Mgr.msgMgr.Send(msg);
		},
		GetZhanjiaPanel:function(){
			var playerPanel = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName );
			if( playerPanel )
				return playerPanel.zanjiaPanel
			return null;
		},
		//玩家自己的战甲过期
		ZhanjiaOverTime:function(){
			var pid = Mgr.player.mainPlayer.sid;
			var obj = Mgr.sceneObj.FindObject(pid.toGID());
			if( obj ){
				obj.UpdateZhanjiaId(0);
				obj.RefreshShowBody();
			}
		},
		JugementZhanjiaOverTime:function(data){
			var time = Q_global.Get(1012).q_string_value;
			time=time.substring(1,time.length-1);
			var array=time.split(",");
			var serverTime = Mgr.login.GetServerTime()/1000;
			var jhTime = (data.activateTime + Number(array[0]));
			var cTime =  jhTime- serverTime;
			if(data.activateTime == -1 )
			{
				return false;
			}
			return cTime > 0 ? false : true;
		},
		JugementZhanjiaToolsEnough:function(_maxTagArr)
		{
			var backpackItemIds = Mgr.backpack.backpackVO.GetItemInfoHash().Values();
			var str = Q_global.Get(1011).q_string_value;
			str=str.substring(1,str.length-1);
			var array=str.split(",");
			var isHave = false;
			for(var i = 0; i < array.length; i++ )
			{
				var isMax = this.CheckIsMax(array[i]);
				for(var j = 0; j < backpackItemIds.length; j++)
				{
					if(array[i] == backpackItemIds[j].itemModelId&&!isMax)
					{
						isHave = true;
						break;
					}
				}
			}
			if(_maxTagArr)
			{
				for(var i = 0; i < _maxTagArr.length; i++)
				{
					if(!_maxTagArr[i].visible)
					{
						this._isAllMax = false;
						break;
					}
					else if(i == _maxTagArr.length-1)
					{
						this._isAllMax = true;
					}
				}
				if(!isHave && !this._isAllMax)
				{
					Mgr.tips.ShowNotice( "淬炼材料不足" );
				}
				if(this._isAllMax)
				{
					Mgr.tips.ShowNotice( "淬炼已满" );
				}
			}
			if(this._isAllMax)
			{
				isHave = false;
			}
			return isHave;
		},
		CheckIsMax:function(itemModleId)
		{
			if(!this._zhanjiaData){return false;}
			var limitNum = Q_item.Get(itemModleId).q_item_limit;
			var attList = this._zhanjiaData.attList;
			for(var i = 0; i < attList.length; i++)
			{
				if(attList[i] == itemModleId && attList[i+1] >= limitNum)
				{
					return true;
				}
			}
			return false;
		},
	});


 Object.defineProperty(ArmorModMgr.prototype, 'isOpen', {
    get: function () {  return this._isOpen; },
    set : function (val) {
        this._isOpen = val;
        if(val) BtnGroupUtil.SetFunctionOpen(BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_ARMOR);
    },
 });














