var BackGridListExt = BackGridList.extend ( {
	_className:"BackGridListExt",
	gridList:null,
	parentPanel:null,
	ctor:function(){
		this._super();
		this.gridList=[];
	},
	Init:function(){
		BackGridList.prototype.Init.call( this );
		var self=this;
		for ( var i = 1; i < 6; i++ ) {
			var grid = new GridItem();
			grid.ParseJson(this.grid1.jsonobj);
			grid.Init();
			grid.InitGrid(GridTypeEnum.BACKPACK, i);
			grid.addClickEventListener(function (target) {
				if(!self.parentPanel){
					return;
				}
                self.parentPanel.SetItemShow(target.GetItem());
                self.parentPanel.ShowDianji(target);
            });
			grid.x=this["grid"+i].x;
			grid.y=this["grid"+i].y;
			this.gridList[i-1]=grid;
			this.removeChild(this["grid"+i]);
			this.addChild( grid );
		}
		this.setSwallowTouches(false);
	},	
	SetData:function(idx){
		var num=idx*5;
		var backinfo = Mgr.backpack.gridNumInfo;
		var gNum = backinfo.GetOpendNum() + backinfo.GetLockNum();
        var itemLists=this.parentPanel.itemLists;
		//没有打开的放后面
		var index=num;
		for (var k = 0; k < 5; k++,index++) {
			this.gridList[k].setVisible(true);
			this.gridList[k].SetItemInfo(null, GridTypeEnum.BACKPACK,true);
            if(this.gridList[k].index)
			{
				Mgr.backpack.showHash.Remove( this.gridList[k].index);
			}
            this.gridList[k].index=index;
            Mgr.backpack.showHash.Put( this.gridList[k].index,this.gridList[k]);
			if(this.parentPanel.gridTag==this.gridList[k]){
                this.parentPanel.HideEffect();
			}
			if(index==this.parentPanel.showIndex){
                this.parentPanel.ShowDianji(this.gridList[k]);
			}
			if(num<backinfo.GetOpendNum()) {
				this.gridList[k].SetOpenType( GridOpenTypeEnum.opened, GridTypeEnum.BACKPACK);
				// var item=null;
				// if(infoVO.sortIndex==0)
				//     item = itemLists.Get(num++);
				// else
				// 	item = itemLists[num++];
				var item = itemLists.Get(num++);
				if (item) {
					if(!Q_item.Get(item.itemModelId)){
                        cc.log("不存在的物品");
                        continue;
					}
					this.gridList[k].q_id = item.itemModelId;
					this.gridList[k].SetItemInfo(item, GridTypeEnum.BACKPACK, Mgr.backpack.showLock);
					if (this.parentPanel.imgItemshow.visible == false) {
                        this.parentPanel.SetItemShow(item);
                        this.parentPanel.ShowDianji(this.gridList[k]);
                    }
                    GridUtil.AddFightTag(item,this.gridList[k]);
				}
			}
			else if(num<gNum){
				//未打开的
				this.gridList[k].SetOpenType( GridOpenTypeEnum.locked, GridTypeEnum.BACKPACK);
				this.gridList[k].SetGridText( "未开启");
			}
			else {
				this.gridList[k].setVisible(false);
			}
		}
	},
	SetParent:function(panel){
		this.parentPanel=panel;
	},
	ClearGridId:function(){
		for( var i = 0, len = this.gridList.length; i < len; i++ ){
			if(this.gridList[i].index){
				Mgr.backpack.showHash.Remove( this.gridList[i].index);
				this.gridList[i].index = -1;
			}
		}
	}
} );
BackGridListExt.PanelName = "BackGridListExt";
PanelClassDic["BackGridListExt"] = BackGridListExt;
