﻿

var BackpackInfoVO = cc.Class.extend({
    SORT_CD:10,
    /** 排序 筛选物品类型 1装备 2药品 3辅助 4其他 全部0**/
    sortIndex:0,
    _cellnum:0,
    //计时index
    _timerSortcd:0,
    _timercount:0,
    /**背包整理逻辑*/
    BeginSort:function(){
        // TimerUtil.ClearTimeUpdate( this._timerSortcd, this );
        if ( this._timerSortcd == 0 )
        {
            this._timercount = 0;
            this._timerSortcd = TimerUtil.TimeUpdate( this._SortTimerHandler, this, 1 );
            cc.log("_timerSortcd:" + this._timerSortcd);
        }
    },
    _SortTimerHandler:function()
    {
        var backpack = Mgr.backpack.GetBackpackPanel();
        var warehouse = Mgr.uiMgr.GetPanelByType(WarehouseMainExt.PanelName);
        if( backpack == null )
        {
            ToolBase.LogError("能走到这里真奇妙！");
            return;
        }
        var str = TextUtil.ConectParam( "{1}秒", [(this.GetSortCD() - this._timercount).toString()] );
        backpack.btnZhengli.setTitleText( str );
        if(warehouse){ warehouse.btnZhengli.setTitleText(str); }

        if( this.GetSortCD() - this._timercount <= 0 )
        {
            cc.log("_timerSortcd:" + this._timerSortcd);
            TimerUtil.ClearTimeUpdate( this._timerSortcd, this );
            this._timerSortcd = 0;

            backpack.UpdateSortBtn();
            backpack.btnZhengli.setTitleText( backpack.btnZhengli.GetText() );
            if(warehouse){ warehouse.btnZhengli.setTitleText(warehouse.btnZhengli.GetText()); }
        }
        this._timercount++;
    },
    GetEnableSort:function()
    {
        var backpack = Mgr.backpack.GetBackpackPanel();
        if ( backpack == null )
            return this._timerSortcd == 0;

        return (this._timerSortcd == 0 && backpack.GetQuickState() == 0);
    },
    GetSortTime:function(){
        var backpack = Mgr.backpack.GetBackpackPanel();
        if ( backpack == null )
        {
            ToolBase.LogError("包包呢？！");
            return;
        }

        if ( backpack.GetQuickState() != 0 )
            return "当前状态无法进行整理";
        return TextUtil.ConectParam( "{1}秒之后可以进行整理", [(this.GetSortCD() - this._timercount).toString()] );
    },
    GetSortCD:function(){
        return this.SORT_CD;// * ( Mgr.messageMgr.isCrossSocket ? 2 : 1 );
    },
    //背包整理逻辑END
    GetItemFenLei:function (){
        var a  = this.GetItemInfoHash().Values();

        // // 1 2 3 其它则相反
        // for (var i = 0; i < a.length; i++){
        // 	re.push(a[i]);
        // }
        if (this.sortIndex == 0){
            return a;
        }
        //re = re.concat();
        // re = re.sort(this.compareFunction);
        // re=[];
        var re = [];
        for(var i=0;i<a.length;++i){
            var model = a[i].GetModel();
            if ( this.sortIndex != 0 && !this.IsFront(model ? model.q_type : -1,model? model.q_location : 0))
            {
                continue;
            }
            re.push(a[i]);
        }
        return re;
    },
    GetItemInfoHash:function (){
        return Mgr.backpack.backpackVO.GetItemInfoHash();
    },
    IsFront:function( type, location ){
        switch(this.sortIndex)
        {
            case EnumItemType.All:
                return true;
            case EnumItemType.Equip:
                if ( ItemUtil.IsEquip(type) )
                    return true;
                break;
            case EnumItemType.Drug:
                if (type == this.sortIndex)
                    return true;
                break;
            case EnumItemType.MATERIAL:
                if (type == this.sortIndex)
                    return true;
                break;
            case EnumItemType.Handbook:
                if (type == this.sortIndex)
                    return true;
                break;
            case EnumItemType.GEM:
                if (type == this.sortIndex )
                    return true;
                break;
            case EnumItemType.GIFT:
                if (type == this.sortIndex )
                    return true;
                break;
            case EnumItemType.SkillBook:
                if (type == this.sortIndex||type==22 )
                    return true;
                break;
            case -1:
                // if ( !ItemUtil.IsEquip(type) )
                // {
                // 	if (type != EnumItemType.Drug)
                // 	{
                // 		if (type != EnumItemType.MATERIAL)
                // 		{
                // 			return true;
                // 		}
                // 	}
                // }
                break;
            default:
        }
        return false;
    }

});


BackpackInfoVO.TIME_INCROSS = 5;
BackpackInfoVO.TIME_UNCROSS = 5;