var BankModMgr = BankModMgr || cc.Class.extend({

	weekInvestpanel:null,

	ctor:function() {	
	},

	RecvResBankMonthInfoToClientMessage:function(msg) {
		cc.log("------------- 返回给前端玩家投资月卡信息------------- " + JSON.stringify(msg));
		var panel = Mgr.uiMgr.GetPanelByType( TaijiPanelExt.PanelName );
		if ( panel ) {
            if(msg.buyMonthTime > 0) {
                // var second = Mgr.login.GetServerTime()/1000 - 5 * 3600;
                var second = Mgr.login.GetServerTime()/1000;
                var day = second / 3600 / 24;
                this.enDays = day - msg.buyMonthTime;
                if ( this.enDays <= 0 ) {// 后推5小时,需补齐
                    this.enDays = 0;
                } else {
                    this.enDays += 1;
                }
                var list = this.GetSortMonthList(msg);
                var isEnable = false;
                for(var i = 0, len = list.length; i < len; i++){
                    var item = list[i];
                    if(item.status == InvestTypeEnum.INVEST_STATUS_ENGET){
                        isEnable = true;
                        break;
                    }
                }
                Mgr.map.miniMapPanel.UpdateVipWarn(isEnable);
                panel.UpdateMonthWarn(isEnable);
            }
            var page = panel.changwanPanel;
            if (page)
                page.SetData(msg);
		}
	},

	RecvResBankLevelInfoToClientMessage:function(msg) {
		cc.log("------------- 返回给前端玩家投资等级信息------------- " + JSON.stringify(msg));
		var panel = Mgr.uiMgr.GetPanelByType( TaijiPanelExt.PanelName );
		if ( panel ) {
		    panel.goldInvestEnd = false;
		    panel.UpdateTouziBtn();
			if(msg.buyLevelGold > 0){
				var list = this.GetSortInvestList(msg);
				var isEnable = false;
				for(var i = 0, len = list.length; i < len; i++){
					var item = list[i];
					if(item.status == InvestTypeEnum.INVEST_STATUS_ENGET){
						isEnable = true;
						break;
					}
				}
				cc.log("enable     " + isEnable);
                Mgr.map.miniMapPanel.UpdateVipWarn(isEnable);
				panel.UpdateGoldWarn(isEnable);
			}
			var page = panel.touziPanel;
			if (page)
				page.SetData(msg);
		}
	},

    GetSortInvestList:function (msg) {
        // sort
        var _sortList = [];
        var list = Q_investment.GetList();
        for ( var i = 0; i != list.length; i++ ) {
            var map = this.GetItemParam( list[i], msg);
            _sortList.push(map);
        }
        return _sortList;
    },

    // 获取相关item参数
    GetItemParam:function (info, msg) {
        // 实际领取金额
        var _realGetValue = 0;
        for ( var i = 0; i != msg.levels.length; i++ ) {
            if ( msg.levels[i] == info.q_level) {
                _realGetValue = msg.getLevelGold[i];
                break;
            }
        }

        // 应该领取金额(取第一档)
        var array = JSON.parse( info.q_reward );
        var _testGetValue = parseInt(array[0]);

        // statues
        var _status = null;
        if ( msg.buyLevelGold > 0 ) {
            if ( Mgr.player.mainPlayer.attributeData.level >= info.q_level ) {
                if ( _testGetValue == _realGetValue )
                    _status = InvestTypeEnum.INVEST_STATUS_GETED;
                else
                    _status = InvestTypeEnum.INVEST_STATUS_ENGET;
            }
            else
                _status = InvestTypeEnum.INVEST_STATUS_UNREACH;
        }
        else {
            _status = InvestTypeEnum.INVEST_STATUS_UNREACH;
        }
        // else if ( this.msgDate.buyLevelGold < this.investGold )
        // 	_status = InvestTypeEnum.INVEST_STATUS_UNREACH;
        // else if ( this.msgDate.buyLevelGold > this.investGold ) {
        // 	_status = InvestTypeEnum.INVEST_STATUS_LOSE;
        // }

        return { info:info, realGet:_realGetValue, testGet:_testGetValue, status:_status };
    },

    GetSortMonthList:function (msg) {
        var _sortList = [];
        var days = JSON.parse(Q_global.Get( 1141 ).q_string_value)[1];
        for ( var i = 0; i <= days; i++ ) {
            var status = this._GetItemStatus(i, msg);
            _sortList.push({ day:i, status:status });
        }
        return _sortList;
    },

    //判断数字的第X位是否是大于0的
    _OperatorsSame:function( num, pos) {
        return (num & (1 << (pos))) > 0;
    },

    // get item status
    _GetItemStatus:function ( order, msg) {
        if ( msg.buyMonthTime ) {
            if ( this._OperatorsSame( msg.flage, order ) ) {  // 已领取
                return InvestTypeEnum.INVEST_STATUS_GETED;
            }
            else {
                if ( order <= this.enDays )  // 能够领取
                    return InvestTypeEnum.INVEST_STATUS_ENGET;
                else
                    return InvestTypeEnum.INVEST_STATUS_UNREACH;
            }
        }
        else
            return InvestTypeEnum.INVEST_STATUS_UNREACH;
    },
	//add-12-12
    RecvResBankWeekInfoToClientMessage:function (msg) {
        var panel = Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName);
		if(msg.indexDay > msg.getRwardNum){
            panel.UpdateInvestWarn(true);
		}
		else{
            panel.UpdateInvestWarn(false);
		}
		if(this.weekInvestpanel){
            this.weekInvestpanel.RefreshPanel(msg)
		}
    },

    RecvResBankAdvanceInfoToClientMessage:function (msg) {

    },
	SendReqBankInfoToGameMessage:function(type) {
		cc.log("------------- 前端请求玩家投资信息 -------------");
		var msg = new ReqBankInfoToGameMessage();
		msg.type = type;
		Mgr.msgMgr.Send(msg);
	},

	SendReqBankBuyMonthToGameMessage:function() {
		cc.log("------------- 请求购买月卡投资 -------------");
		var msg = new ReqBankBuyMonthToGameMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqBankMonthAwardToGameMessage:function(day) {
		cc.log("------------- 请求领取月卡投资返利 -------------");
		var msg = new ReqBankMonthAwardToGameMessage();
		msg.day = day;
		Mgr.msgMgr.Send(msg);
	},

	SendReqBankBuyLevelToGameMessage:function(gold) {
		cc.log("------------- 请求购买等级投资 -------------");
		var msg = new ReqBankBuyLevelToGameMessage();
		msg.gold = gold;
		Mgr.msgMgr.Send(msg);
	},

	SendReqBankLevelAwardToGameMessage:function(level) {
		cc.log("------------- 请求领取等级返利 -------------");
		var msg = new ReqBankLevelAwardToGameMessage();
		msg.level = level;
		Mgr.msgMgr.Send(msg);
	},

    SendReqBankBuyWeekToGameMessage:function() {
        cc.log("------------- 请求购买周礼包投资 -------------");
        var msg = new ReqBankBuyWeekToGameMessage();
        Mgr.msgMgr.Send(msg);
    },

    SendReqBankWeekAwardToGameMessage:function() {
        cc.log("------------- 请求领取周礼包投资奖励 -------------");
        var msg = new ReqBankWeekAwardToGameMessage();
        Mgr.msgMgr.Send(msg);
    },
});