var ChatQipaoExt = ChatQipao.extend ( {
	_className:"ChatQipaoExt",
	Callback:null,
	msgInfo:null,
	isPlayerSelf:false,
	_oldHeight:72,
	_HorOffset:6,
	ctor:function(msg,lineHeight){
		this._super();
		this.pName = msg.name;
		this.chatText = msg.chatText;
		this.msgInfo = msg;
        this.lineHeight = lineHeight || 30;
	},
	Init:function()
	{
		ChatQipao.prototype.Init.call(this);
        this.imgDengji.SetAlign(LableAlign.CENTER);

//		this.labCue.setLocalZOrder(100);
		this.labName.setLocalZOrder(100);
		this.labTxt.visible = false;
		this.setContentSize(cc.size(this.width+20,this.height));
		this._SetInformation();
		this._SetBaseProperty();
		this.setTouchEnabled(true);
		this.setSwallowTouches(false);
		this.imgQipao.setTouchEnabled(true);
		this.imgQipao.setSwallowTouches(false);
	},
	_SetInformation:function()
	{
		var data = this.msgInfo;
		if(Mgr.chat.JugementYuyingInfo(data))
		{
			this.yyData = JSON.parse(data.extraResInfo.hyperInfos[0].clientUseText);
			this.btnVoice.visible = true;
			this.labVoice.SetString(this.yyData.audiotime/1000+"'");
			this.btnVoice.SetContentSize(20*this.yyData.audiotime/1000+40,this.btnVoice.height);
			this.imgCue.x = this.btnVoice.width;
			this.labVoice.x = this.imgCue.x//-this.labVoice.width-5;
			var info = this._GetItemInfo();
			data = info;
			this._ChangeChanelBg(data);
			if(data.playerId.toGID() == Mgr.player.mainPlayer.sid.toGID())
			{
				this.imgCue.visible = false;
			}
			if(info.chatText.length < 1)
			{
				this.imgQipao.visible = false;
				//this._ResetSize(-this.imgQipao.height+20);
				//return;
			}
			//这里还缺一个wifi和4G的环境判断TODO
			if(Mgr.plugset.IsAutoPlayYuyingOnWifi(data.type) || Mgr.plugset.IsAutoPlayYuyingOnFourG(data.type))
			{
				this._PlaySoundInfo();
			}
		}
		else
		{
			this.btnVoice.visible = false;
		}
        this._ChangeChanelBg(data);
        this.SetInfoInit(data);


        // 头像
        var avatar = ChatUtil.getAvatarByData(data);
        EngineMgr.uiMgr.GetAsynResByUrl(avatar, function(){
            this.imgHead.loadTexture(avatar,ccui.Widget.PLIST_TEXTURE);
        }, this);

	},
	_SetBaseProperty:function()
	{
//		this.labCue.SetColor(EnumFontFormat.COMMON_COLOR07);
		this.labName.SetFontSize(EnumFontFormat.FONTSIZE_NORMAL);
		this.setTouchEnabled(false);
	},
	_HandleButton:function(data)
	{
		var self = this;
		this.btnVoice.addClickEventListener(function()
		{
			self._PlaySoundInfo();
		});
		this.imgHead.addTouchEventListener(function(target,state)
		{
			if ( state == ccui.Widget.TOUCH_ENDED )
			{
				self._ShowOperationMenu(data);
			}
		});
	},
	_PlaySoundInfo:function()
	{
		this.imgCue.visible = false;
		//yaya.stopPlay();
		Mgr.gameSoundMgr.ResumeSound();
		//yaya.playOnline(this.yyData.url);
	},
	Callback:function(data)
	{
		if(Mgr.chat.curChatChannel == EnumChatChannelType.WORLD)
		{
			return;
		}
		Mgr.chat.Callback(data);
	},
	SetInfoInit:function(data)
	{
		var self = this;
		this.imgQipao.setAnchorPoint(0,1);
		var msg = data;

        // 创建聊天内容
        var richText = ChatUtil.createRichText(msg);
        richText.setAnchorPoint(0,1);
        richText.SetDimensions(320);
        richText.SetFixedHeight(this.lineHeight);
        richText.UpdateView();
        richText.x = 20;
        this.imgQipao.addChild(richText);
        this.richText = richText;

        var gap = richText.height + 16 - this._oldHeight ;

        this._SetScale9Bg(gap+5, gap, data);

        richText.y = this.imgQipao.height - 8;

		this.imgQipao.y = this.labName.y;
		this.labName.SetString(msg.name);
        this.imgDengji.SetString(msg.extraResInfo.sendlevel || 0);

		this.imgHead.setTouchEnabled(true);
		if(Mgr.chat.JugementYuyingInfo(this.msgInfo))
		{
			this.imgQipao.y-=(this.btnVoice.height+2);
		}
	},
	_SetScale9Bg:function(gap,sizeGap,data)
	{
		var qipaoWidth = this.richText.width + 30;
		var rect1 = cc.rect(0,0,Math.max(qipaoWidth,100),Math.max(this.imgQipao.height + gap,66));
		var rect2 = cc.rect(23,30,2,2);
		var self = this;
		var imageRes = "other/liaotian/image/duihuakuang_huang.png";
		this._JugementPlayerChat(data);
        if ( this.isPlayerSelf ){
            imageRes = "other/liaotian/image/duihuakuang_lv.png";
            rect2 = cc.rect(10,30,2,2);
        }

		EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
			//self.imgHead.loadTexture("other/liaotian/btn/biaoqing_btn.png",ccui.Widget.PLIST_TEXTURE);
			self.imgQipao.loadTexture(imageRes,ccui.Widget.PLIST_TEXTURE);
			self.imgQipao.setContentSize(cc.size(rect1.width,rect1.height));
			self.imgQipao.setCapInsets(rect2)
			self._ResetSize(sizeGap,data);
			self.SetInfo(data);
		}, this);
	},
	SetInfo:function(data)
	{
		if(this.labName.y < 71)
		{
			//this.labName.y += 71-this.labName.y;
		}
		if(this._JugementPlayerChat(data))
		{
			this._PlayerChatLayoutUI(data);
			this.x -= this._HorOffset;
		}
		else
		{
			this.x = this._HorOffset;
		}
	},
	//判断是否是玩家自己发言
	_JugementPlayerChat:function(data)
	{
		if(data.playerId.toGID() == Mgr.player.mainPlayer.sid.toGID() )
		{
			this.isPlayerSelf = true;
			//if(this.msgInfo.type == EnumChatChannelType.WORLD || this.msgInfo.type == EnumChatChannelType.PRIVATE)
			//{
			//	return true;
			//}
		}
		else
		{
			this.isPlayerSelf = false;
		}
		return this.isPlayerSelf;
	},
	_PlayerChatLayoutUI:function(data)
	{
		var gap = 60;
//		this.imgQipao.scaleX = - 1;
        this.imgQipao.setAnchorPoint(cc.p(1,1));
		this.btnVoice.scaleX = - 1;
		this.gridHead.x = this.width - this.gridHead.width - 19;
		this.imgBiaoqian.x = this.gridHead.x - this.imgBiaoqian.width - 20;
		this.labName.setAnchorPoint( 1 , this.labName.anchorY );
		if(this.imgBiaoqian.visible)
		{
			this.labName.x = this.imgBiaoqian.x - 20;
		}
		else
		{
			this.labName.x = this.gridHead.x-22;
		}
		this.labName.SetTextAlign( 2 );
		this.imgQipao.x = this.gridHead.x - 0;
		this.btnVoice.x = this.gridHead.x - 0;
		this.labVoice.scaleX = - 1;
		this.labVoice.x += this.labVoice.width/2;
		this.richText.x = 8;
	},
	_ChangeChanelBg:function(data)
	{
		this._HandleButton(data);
		var self = this;
        var bg = ChatUtil.getChannelBgName(data.type);
        if(bg){
            self.imgBiaoqian.visible = true;
            EngineMgr.uiMgr.GetAsynResByUrl(bg, function(){
                self.imgBiaoqian.loadTexture(bg,ccui.Widget.PLIST_TEXTURE);
            }, this);
        }else{
            self.imgBiaoqian.visible = false;


        }

//		this.labCue.SetString(resObj.chanelLabel);
//		this.labCue.setPosition((this.imgBiaoqian.width-this.labCue.width>>1)-2,this.labCue.y-1);
//		EngineMgr.uiMgr.GetAsynResByUrl(resObj.resUrl, function(){
//			self.imgBiaoqian.loadTexture(resObj.resUrl,ccui.Widget.PLIST_TEXTURE);
//		}, this);
		if(data.type == EnumChatChannelType.PRIVATE)
		{
			this.labName.SetColor(EnumFontFormat.COMMON_COLOR03);
			this.imgBiaoqian.visible = false;
			this.labName.x -= this.imgBiaoqian.width+10;
		}
		else
		{
			this.labName.SetColor(EnumFontFormat.CHAT_NAME);
		}
	},

	_ResetSize:function(height,data)
	{
		if(Mgr.chat.JugementYuyingInfo(this.msgInfo))
		{
			height += (this.btnVoice.height + 2);
		}
		//if ( height < 0 )
		//{
		//	if(data.type == EnumChatChannelType.PRIVATE)
		//	{
		//		this.setContentSize(645,this.height);
		//	}
		//	return;
		//}
		if(data.type == EnumChatChannelType.PRIVATE)
		{
			this.setContentSize(705,this.height+height);
		}
		else
		{
			this.setContentSize(this.width,this.height+height);
		}
		//if(height>0)
		{
			this.gridHead.y+=height;
			this.imgBiaoqian.y+= height;
			this.labName.y+=height;
			this.btnVoice.y+=height;
			this.imgQipao.y+=height;
		}
//		var lc = cc.LayerColor.create(cc.color(Math.random()*255,0,0,255),this.width,this.height);
//		this.addChild(lc,-1);
	},
	_ShowOperationMenu:function(data)
	{
		var self = this;
		if(data.playerId.toGID() != Mgr.player.mainPlayer.sid.toGID())
		{
			Mgr.player.SendReqPlayerBriefMessage([data.playerId],EnumBriefType.HEAD_MENUE);
			var pos = this.imgHead.getWorldPosition();
			EngineMgr.uiMgr.ShowHidePanelByType(MenuPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
			Mgr.uiMgr.GetPanelByType(MenuPanelExt.PanelName).SetInformation(data,pos);
			Mgr.uiMgr.HidePanelByType(MenuPanelExt.PanelName);
		}
	},
	_GetItemInfo:function()
	{
		var data = this.msgInfo;
		var info = {
			playerId:data.playerId, // 玩家ID
			name:data.name, // 玩家名字
			type:data.type, // 聊天类型
			chatText:this.yyData.text, // 聊天内容
			targetPlayerId:data.targetPlayerId, // 聊天目标id
			extraResInfo:{
				"__instanceId": 19681,
				"targetPlayerName": null,
				"viplevel": 0,
				"guildOfficial": 0,
				"plamtVip": 0,
				"domain": 0,
				"hyperInfos": [

				],
				"itemInfos": [

				]}
		}
		return info;
	}
} );
ChatQipaoExt.PanelName = "ChatQipaoExt";
PanelClassDic["ChatQipaoExt"] = ChatQipaoExt;
