var LianXuChongZhiExt = LianXuChongZhi.extend ( {
	_className:"LianXuChongZhiExt",

	cellPanel:null,
	cellList:null,
	totalNum:null,
	activityList:null,

	ctor:function(){
		this._super();
	},

	Init:function () {
		LianXuChongZhi.prototype.Init.call(this);
		var panel = Mgr.uiMgr.GetPanelByType(ActivitiesBackGroundExt.PanelName);
		this.buttonList = [];
		this.parentPanel = panel;

		if(!this.cellPanel){
			var tableView = new cc.TableView(this,cc.size(this.imgContent.uiWidth, this.imgContent.uiHeight));
			tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
			tableView.setDelegate(this);
			tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
			tableView.uiWidth=this.imgContent.uiWidth;
			tableView.uiHeight=this.imgContent.uiHeight;
			this.cellPanel=tableView;
			this.imgContent.addChild(tableView);
		}
	},

	SetActivityList:function (infoList, isOpen) {
		this.activityList = infoList;

		this.UpdateActivityInfo(isOpen);
	},

	UpdateActivityInfo:function(isOpen){

		var vo = this.activityList[0];
		switch( vo.subPanelType ){
			case EnumActivityType.S_NEW_SINGLE_RECHARGE:
				this.cellList = Mgr.dailyactivity.GetGradeInfoById(vo.activityId);
				break;
			default:
				this.cellList = ActivityUtil.GetListByCorrelation(this.activityList);
				break;
		}
		this.totalNum = this.cellList.length;
		if( this.totalNum > 0 ){
			UIUtil.ConnectLabelHtmlText(this.labTime, [TimeUtil.GetDateStr(vo.endTime)]);
		}
		if( isOpen ){
			this.cellPanel.reloadData();
		}
		else{
			this.ReloadData();
		}
	},

	UpdateSingleActivity:function(info){
		this.UpdateActivityInfo(false);     //有的不会发简要信息 直接重刷吧
	},

	ReloadData:function(){
		for( var i = 0, len = this.cellList.length; i < len; i++ ){
			var cell = this.cellPanel.cellAtIndex(i);
			if( cell && cell.item ){
				cell.item.SetData( this.cellList[i] );
			}
		}
	},

	OnHide:function () {
	},

	tableCellSizeForIndex: function (table, idx) {
		return cc.size(794,115);
	},
	tableCellAtIndex: function (table, idx) {
		var item = new LianXuChongZhiListExt();
		var ac = this.cellList[idx];
		var cell = table.dequeueCell();
		if (!cell) {
			cell=cc.Sprite();
			item.LoadPanel();
			item.setTouchEnabled(false);
			cell.item = item;
			cell.addChild(item);
		}
		cell.item.SetData(ac);
		return cell;
	},
	numberOfCellsInTableView: function (table) {
		return this.totalNum;
	}
} );
LianXuChongZhiExt.PanelName = "LianXuChongZhiExt";
PanelClassDic["LianXuChongZhiExt"] = LianXuChongZhiExt;
