var ZaJinDanExt = ZaJinDan.extend ( {
	_className:"ZaJinDanExt",
	_eggArr:null,
	_fengArr:null,
	ctor:function(){
		this._super();
	},

	Init:function(){
		ZaJinDan.prototype.Init.call(this);

		Mgr.dailyactivity.eventEggInfo.add(this.OnEggInfo, this);
		Mgr.dailyactivity.eventEggResult.add(this.OnEggResult, this);
		this.imgDaChui.setAnchorPoint(1, 0);
		this.imgDaChui.visible = false;
		this._eggArr = [this.imgJinDan1, this.imgJinDan2, this.imgJinDan3];
		this._fengArr = [this.imgFeng1, this.imgFeng2, this.imgFeng3];
		var self = this;
		this.imgDaChui.x += this.imgDaChui.uiWidth;
		var offX = this.imgDaChui.x - this.imgJinDan1.x;
		for( var i = 0; i < this._eggArr.length; i++ ){
			this._eggArr[i].touchEnabled = true;
			this._fengArr[i].visible = false;
			(function(i){
				self._eggArr[i].addClickEventListener(function(){
					self.imgDaChui.x = self._eggArr[i].x + offX;
					self.PlaySmash(i);
				});
			}(i));
		}
		this.btn1.addClickEventListener(function(){
			OpenFuncUtil.OpenRecharge();
		});
	},

	isPlaying:false,
	PlaySmash:function(i){
		if( this.isPlaying || !this.eggInfo )
			return;

		if( this.eggInfo.surplusNum <= 0 ){
			Mgr.tips.ShowNotice("幸运锤子数量不足");
			return;
		}

		if( this.eggInfo.indexs.indexOf(i) >= 0 ){
			Mgr.tips.ShowNotice("金蛋已砸开，请选择其他金蛋");
			return;
		}

		this.isPlaying = true;
		this.imgDaChui.rotation = 90;
		this.imgDaChui.visible = true;
		var hitAction = cc.rotateTo(0.2, -20);
		this.imgDaChui.runAction(cc.sequence(hitAction, cc.callFunc(function() {
			this.isPlaying = false;
			this.imgDaChui.visible = false;
			this._fengArr[i].visible = true;
			Mgr.dailyactivity.SendReqSmashEggToGameMessage(i);
		}.bind(this))));
	},

	SetActivityList:function(infoList, isOpen){
		this.activityList = infoList;
		this.UpdateActivityInfo(isOpen);
		if( isOpen )
			Mgr.dailyactivity.SendReqSmashEggInfoToGameMessage();
	},

	UpdateActivityInfo:function(isOpen){
		this.UpdateSingleActivity(this.activityList[0]);
	},

	UpdateSingleActivity:function(info){
		UIUtil.ConnectLabelHtmlText( this.labTime, [info.durationStr] );
	},

	OnEggInfo:function(info){
		this.eggInfo = info;
		for( var i = 0; i < this._fengArr.length; i++ ){
			this._fengArr[i].visible = false;
		}
		for( var i = 0; i < this.eggInfo.indexs.length; i++ ){
			this._fengArr[this.eggInfo.indexs[i]].visible = true;
		}
		var total = Q_global.Get(1501).q_int_value;
		UIUtil.ConnectLabelHtmlText( this.labShengYu, [info.surplusNum] );
		UIUtil.ConnectLabelHtmlText( this.labShengYu1, [total - info.totalNum] );
	},

	OnEggResult:function(result){
		if( this.eggInfo ){
			this.eggInfo.indexs.push(result.indexs);
			this.eggInfo.indexReward.push(result.reward);
		}
	},

	OnHide:function(){
		Mgr.dailyactivity.eventEggInfo.remove(this.OnEggInfo, this);
		Mgr.dailyactivity.eventEggResult.remove(this.OnEggResult, this);
	}
} );
ZaJinDanExt.PanelName = "ZaJinDanExt";
PanelClassDic["ZaJinDanExt"] = ZaJinDanExt;
