var LeiChongListExt = LeiChongList.extend ( {
	_className:"LeiChongListExt",
    awardList:null,
	ctor:function(){
		this._super();
	},

    Init:function () {
	    var self = this;
        LeiChongList.prototype.Init.call(this);
        this.btnGet.addClickEventListener(function (target) {
            if(self.detail.status == 1){
                Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.detail.activityId, 1);
            }
        });
        this.btnGet.setSwallowTouches(false);
    },

    SetData:function (info) {
        this.ClearImgList();
        this.awardList = [];

        this.detail = info;
        var now = 0;
        var need = 0;
        // if(info.subPanelType == 1){
        //     now = info.special[0].beanInfo.conditionNum[0];
        //     need = info.special[0].beanInfo.condition[0];
        // }else if(info.subPanelType == 4){
        //     now = info.special[0].beanInfo.gold;
        //     need = info.special[0].beanInfo.need;
        // }else if(info.subPanelType == 6){
        //     if(info.activityId == 418){
        //         now = info.special[0].beanInfo.gold;
        //         need = info.special[0].beanInfo.need;
        //     }else {
        //         now = info.special[0].beanInfo.day;
        //         need = info.special[0].beanInfo.needDay;
        //     }
        // }
        var isEmail = info.GetFlagValue("email");
        this.btnGet.setVisible(isEmail == null);
        this.labJiangli.setVisible(isEmail != null);
        this.labCue1.visible = false;
        this.labCue.SetHtmlText(info.introduction);
        // this.labCue1.SetHtmlText(TextUtil.FormatStr(this.labCue1.GetHtmlText(),[now, need]));
        var awards = info.GetRewardList();
        if( awards ){
            for(var i = 0, len = awards.length; i < len; i++){
                var grid = new MUIGrid();
                grid.ParseJson(this.gridAward.jsonobj);
                grid.Init();
                GridUtil.SetItemGrid(grid, awards[i]);
                this.imgList.addChild(grid);
                this.awardList.push(grid);
                grid.setSwallowTouches(false);
            }
        }
        this.SetGridPos();
        this.SetButtonStatus(info.status);
    },

    SetButtonStatus:function (status) {
        switch (status){
            case 0:
                this.btnGet.setTitleText("已领取");
                Filter.GrayScale(this.btnGet);
                break;
            case 1:
                this.btnGet.setTitleText("领奖");
                Filter.UnGray(this.btnGet);
                break;
            case 2:
                this.btnGet.setTitleText("领奖");
                Filter.GrayScale(this.btnGet);
                break;
        }
    },

    SetGridPos:function () {
        for(var i = 0, len = this.awardList.length; i < len; i++){
            var grid = this.awardList[i];
            grid.x = this.gridAward.x + (this.gridAward.uiWidth + 2) * i;
        }
    },

    ClearImgList:function () {
        if(this.awardList && this.awardList.length > 0){
            for(var i = 0; i < this.awardList.length; i++){
                var grid = this.awardList[i];
                this.imgList.removeChild(grid);
            }
        }
    },
} );
LeiChongListExt.PanelName = "LeiChongListExt";
PanelClassDic["LeiChongListExt"] = LeiChongListExt;
