var ShenZhuangFenJieMainExt = (function(){

    var Class = ShenZhuangFenJieMain.extend ( {
        _className:"ShenZhuangFenJieMainExt",
        ctor:function(){
            this._super();
        },

        Init:function(){
            this._super();


            var size = this.imgContent.getContentSize();
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(ccui.ScrollView.DIR_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            //tableView.setTouchEnabled(false);
            tableView.reloadData();

            this.imgContent.addChild(tableView);
            this.tableView = tableView;

            var self = this;
            this.btnHuiShou.addClickEventListener(function(){
                var itemIds = [];
                self.data.forEach(function(v){
                    itemIds.push(v.itemId);
                })

                Mgr.refining.SendReqUpOrDismantlrEquipMessage(1,0,itemIds);
            });
        },

        OnShow:function(){
            GameEventMgr.AddEventListener(this,EnumEventType.GAME_REFINING_RESULT,function(){
                this.SetData();
            })
            this._super();
        },

        OnHide:function(){
            GameEventMgr.RemoveEventListener(this);
            this._super();
        },

        SetData:function(itemType) {
            itemType = itemType || this._itemType;
            this._itemType = itemType;

            var array = [];
            var items = Mgr.backpack.GetItems();
            items.forEach(function(v){
                if(DuanzaoUtil.IsShenZhuang(v.itemModelId)){
                    array.push(v);
                }
            })

            this.data = array;
            this.tableView.reloadData();
        },

        tableCellSizeForIndex:function(sender,index){
            // 加点间距
            return cc.size(sender.width,114);
        },

        tableCellAtIndex:function(sender,index){
            var cell = sender.dequeueCell();
            if (!cell) {
                cell = new cc.TableViewCell();
            }

            if(!cell.item1){
                cell.item1 = new ShenZhuangFenJieListsExt();
                cell.item1.LoadPanel();
                cell.addChild(cell.item1);
            }
            if(!cell.item2){
                cell.item2 = new ShenZhuangFenJieListsExt();
                cell.item2.LoadPanel();
                cell.item2.x = sender.width / 2;
                cell.addChild(cell.item2);
            }

            cell.item1.SetData(this.data[index * 2]);
            cell.item2.SetData(this.data[index * 2 + 1]);

            return cell;
        },

        numberOfCellsInTableView:function(sender){
            return this.data ? Math.ceil(this.data.length / 2) : 0;
        },

    } );

    return Class;
})();
ShenZhuangFenJieMainExt.PanelName = "ShenZhuangFenJieMainExt";
PanelClassDic["ShenZhuangFenJieMainExt"] = ShenZhuangFenJieMainExt;
