﻿var EnumEquipPos = EnumEquipPos ||{
		/**
		 * 武器
		 */
		EQUIP_WEAPONS:0,
		/**
		 * 衣服
		 */
		EQUIP_CLOTHES:1,
		/**
		 * 左手镯
		 */
		EQUIP_BRACELET_LEFT:2,
		/**
		 * 腰带
		 */
		EQUIP_BELT:3,
		/**
		 * 护腿
		 */
		EQUIP_HUTUI:4,
		/**
		 * 鞋子
		 */
		EQUIP_SHOES:5,
		/**
		 * 护符左
		 */
		EQUIP_HUFU_LEFT:6,
		/**
		 * 护符右
		 */
		EQUIP_HUFU_RIGHT:7,
		/**
		 * 左戒指
		 */
		EQUIP_RING_LEFT:8,
		/**
		 * 右戒指
		 */
		EQUIP_RING_RIGHT:9,
		/**
		 * 帽子
		 */
		EQUIP_HEADDRESS:2,
		/**
		 * 右手镯
		 */
		EQUIP_BRACELET_RIGHT:5,
		/**
		 * 项链
		 */
		EQUIP_NECKLACE:8,

        /**
         * 宝物·倚天
         */
        EQUIP_YITIAN:10,
        /**
         * 宝物·屠龙
         */
        EQUIP_TULONG:11,
        /**
         * 宝物·太极
         */
        EQUIP_TAIJI:12,
        /**
         * 宝物·乾坤
         */
        EQUIP_QIANKUN:13,
		// /**
		//  * 勋章
		//  */
		// EQUIP_MEDAL:11,
		// /**
		//  * 特戒(战神诀没有特戒装备)
		//  */
		// EQUIP_GEM:12,
		// /**
		//  *时装
		//  */
		// EQUIP_FASHION:13,
		/**
		 *玉佩
		 */
		EQUIP_JADE:14,
		/**
		 *宝石
		 */
		EQUIP_GEMSTONE:15,

		// 鞍具
		MountSaddle : 20,
		// 蹬具
		MountStirrup : 21,
		// 缰绳
		MountRein : 22,
		// 蹄铁
		MountFoot : 23,

		/**
		 * 是否左右手镯
		 * @param type
		 * @return
		 *
		 */
		IsBracelet:function (type)
		{
			return type == EnumEquipPos.EQUIP_BRACELET_LEFT ||
				type == EnumEquipPos.EQUIP_BRACELET_RIGHT;
		},

		/**
		 * 是否左右戒指
		 * @param type
		 * @return
		 *
		 */
		IsRing:function(type)
		{
			return type == EnumEquipPos.EQUIP_RING_LEFT ||
				type == EnumEquipPos.EQUIP_BRACELET_RIGHT;
		},
	}
