///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//TemporaryFashionInfo 临时时装info

// 请求消息
//177201,ReqFashionPanel 请求打开时装面板
//177202,ReqActivateFashion 请求激活时装
//177203,ReqWearFashion 请求穿戴时装
//177204,ReqHiddenFashion 请隐藏时装

// 接收消息
//177101,ResFashionPanel 时装面板消息


var TemporaryFashionInfo = cc.Class.extend({
	ctor:function(){
		this.fashionId = 0; // 时装id
        this.overdueTime = 0; // 过期剩余时间
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.fashionId);
        _buf.WriteVarInt(this.overdueTime);
	},
	
	reading:function( _buf ){
		this.fashionId = _buf.ReadVarInt();
        this.overdueTime = _buf.ReadVarInt();
	},
});
////////////////////
// 时装面板消息 //
////////////////////
var ResFashionPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.fashions = []; // 拥有的时装 int
        this.waerFashions = []; // 已经穿戴的时装 int
        this.temproaryFashions = []; // 临时时装信息 TemporaryFashionInfo
        this.hidden = 0; // 位运算 第一位表示角色时装 第二位表示武器时装
	},

	getId:function(){
		return 177101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.fashions.length );
        for (var i = 0; i < this.fashions.length; i++) {
            _buf.WriteVarInt(this.fashions[i]);
        }
        _buf.WriteShort( this.waerFashions.length );
        for (var i = 0; i < this.waerFashions.length; i++) {
            _buf.WriteVarInt(this.waerFashions[i]);
        }
        _buf.WriteShort( this.temproaryFashions.length );
        for (var i = 0; i < this.temproaryFashions.length; i++) {
            _buf.WriteBean(this.temproaryFashions[i]);
        }
        _buf.WriteVarInt(this.hidden);
	},
	
	reading:function( _buf ){
        var fashions_length = _buf.ReadShort();
        for (var i = 0; i < fashions_length; i++) {
            this.fashions[i] = _buf.ReadVarInt();
        }
        var waerFashions_length = _buf.ReadShort();
        for (var i = 0; i < waerFashions_length; i++) {
            this.waerFashions[i] = _buf.ReadVarInt();
        }
        var temproaryFashions_length = _buf.ReadShort();
        for (var i = 0; i < temproaryFashions_length; i++) {
            this.temproaryFashions[i] = _buf.ReadBean(TemporaryFashionInfo);
        }
        this.hidden = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.fasion.RecvResFashionPanelMessage(this);
	},

});
////////////////////
// 请求打开时装面板 //
////////////////////
var ReqFashionPanelMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 177201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求激活时装 //
////////////////////
var ReqActivateFashionMessage = cc.Class.extend( {
	ctor:function(){
		this.fashionId = 0; // 时装id
	},

	getId:function(){
		return 177202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.fashionId);
	},
	
	reading:function( _buf ){
        this.fashionId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求穿戴时装 //
////////////////////
var ReqWearFashionMessage = cc.Class.extend( {
	ctor:function(){
		this.fashionId = 0; // 时装id
	},

	getId:function(){
		return 177203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.fashionId);
	},
	
	reading:function( _buf ){
        this.fashionId = _buf.ReadVarInt();
	},

});
////////////////////
// 请隐藏时装 //
////////////////////
var ReqHiddenFashionMessage = cc.Class.extend( {
	ctor:function(){
		this.hidden = 0; // 是否隐藏时装显示（1是 0否）
	},

	getId:function(){
		return 177204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.hidden);
	},
	
	reading:function( _buf ){
        this.hidden = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(177101, ResFashionPanelMessage);

