﻿var FightpowerModMgr = FightpowerModMgr || cc.Class.extend({

    fightPower: 0,

    ctor: function() {},

    SendReqFightPowerToServerMessage: function() {
        Mgr.msgMgr.Send(new ReqFightPowerToServerMessage());
    },

    RecvResFightPowerToClientMessage: function(msg) {
        if (msg.playerId.toGID() == Mgr.player.mainPlayer.sid.toGID()) {
            var oldPower = this.fightPower;
            this.fightPower = msg.fightPower;
            if (oldPower < this.fightPower && oldPower != 0) {
                var addPower = this.fightPower - oldPower;
                Mgr.tips.ShowFightpowerChange(addPower);
            }
            Mgr.player.UpdateFightPower(); //Mgr.promptMgr.showFightPowerChange( tempPower, power );
            var panel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName)
            if (panel) {
                panel.FightPowerChange();
            }
        }
    },
    GetFightPower: function(str) {
        str = str || "";

        var power = 0;
        str = str.substring(1, str.length - 1);
        var array = str.split(",");
        for (var i = 0; i < array.length; ++i) {
            if (array[i] && array[i].length != 0) {
                array[i] = array[i].split(":");
                power += Mgr.attributeMgr.GetAttributeRate(array[i][0]) * array[i][1];
            }
        }
        return power;
    },
    GetFightPowerExt: function(str,perMap) {
            str = str || "";

            var power = 0;
            str = str.substring(1, str.length - 1);
            var array = str.split(",");
            for (var i = 0; i < array.length; ++i) {
                if (array[i] && array[i].length != 0) {
                    array[i] = array[i].split(":");

                    if(perMap && perMap[array[i][0]]){
                        power += Mgr.attributeMgr.GetAttributeRate(array[i][0]) * array[i][1] * (1 + perMap[array[i][0]] / 10000.0);
                    }else{
                        power += Mgr.attributeMgr.GetAttributeRate(array[i][0]) * array[i][1];
                    }
                }
            }
            return power;
        }
});