var LevelGiftMainExt = LevelGiftMain.extend ( {
	_className:"LevelGiftMainExt",

    _vScrollView:null,
    _frameList:[],
    _height:null,

	ctor:function(){
		this._super();
	},

    Init:function(){
        LevelGiftMain.prototype.Init.call(this);
        this.InitView();
    },

    InitView:function(){
        if(!this._vScrollView){
            this._vScrollView = new ccui.ScrollView();
            this._vScrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._vScrollView.setTouchEnabled(true);					//触摸开启
            this._vScrollView.inertiaScrollEnabled = true; 			//滚动惯性
            this._vScrollView.setScrollBarEnabled(false);				//滚动条
            this._vScrollView.setBounceEnabled(true);					//边界回弹
            // this._vScrollView.setScrollBarAutoHideTime(1);
            this.imgBg.addChild(this._vScrollView);
        }
    },

    ShowFrame:function(giftId){
        this._giftId = giftId;
        if(!this._timer4update){
            this._timer4update = TimerUtil.SetTimeout(this,this._ShowFrame,100);
        }else{
            //cc.log("重复刷新")
        }
    },
    // 又是两个消息触发了同一个事情
    _ShowFrame:function(){
        this._timer4update = null;

        var giftId = this._giftId;

        //this.ClearVScrollView();
        var list = Q_upgrade.GetList();
        var level = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);

        var indexList = [];
        for(var i = 0; i < list.length; i++){
            indexList.push(i);
        }
        var rewardedMark = {};
        for(var i=0;i!=giftId.length;++i){
            rewardedMark[giftId[i]] = true;
        }
        /// 添加排序，方便快速领奖
        indexList.sort(function(a,b){
            var aa = list[a];
            var bb = list[b];
            if(rewardedMark[aa.q_id] && rewardedMark[bb.q_id]){
                if(aa.q_level > level && bb.q_level > level){
                    return aa.q_level - bb.q_level;
                }else{
                    return aa.q_level > level ? 1 : -1;
                }
            }else{
                return rewardedMark[aa.q_id] ? 1 : -1
            }
        });

        for(var i = 0; i < list.length; i++){
            var k = indexList[i]

            if(!this._frameList[i]){
                var btnCall = new FulidatingLevelListExt();
                btnCall.LoadPanel();
                btnCall.x = 0;
                btnCall.y = btnCall.uiHeight*(list.length-i-1);

                this._height = btnCall.uiHeight;

                this._frameList.push(btnCall);
                this._vScrollView.addChild(btnCall);
            }
            this._frameList[i].SetData(list[k].q_id, list[k].q_level, list[k].q_reward);
            if(list[k].q_level > level)
                this._frameList[i].IsLevel(true);
            else
                this._frameList[i].IsLevel(false);

            if(rewardedMark[list[k].q_id])
                this._frameList[i].IsAward(true);
        }
        this._vScrollView.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
        this._vScrollView.setInnerContainerSize(cc.size(this.imgBg.uiWidth, list.length * this._height));
    },

    OnShow:function(){
        Mgr.weal.levelGiftPanel = this;
        Mgr.weal.SendReqUpGradeInfoToGameMessage();
        // this.ShowFrame();
    },

    OnHide:function(){
        this._super();
        Mgr.weal.levelGiftPanel = null;
    }
} );
LevelGiftMainExt.PanelName = "LevelGiftMainExt";
PanelClassDic["LevelGiftMainExt"] = LevelGiftMainExt;
