var ZaixianMainExt = ZaixianMain.extend ( {
	_className:"ZaixianMainExt",

    onlinetime:0,
    infos:null,
    resInfos:null,
    timerId:null,

    isOpen:false,

	_hour:0,
	_minute:0,
	_second:0,

    _curTime:null,
    _passTime:null,
    _diff:null,

    _time1:0,
    _time2:0,
    _time3:0,
    _time4:0,

    _comItem:null,
    _comItem1:null,
    _comItem2:null,
    _comItem3:null,


    _grid:null,
    _imgBox:null,


    _is_5_receive:false,
    _is_30_receive:false,
    _is_60_receive:false,
    _is_120_receive:false,

    rollBox1:null,
    rollBox2:null,

    moveUp:null,

    rolllist:null,

    timeId:-1,

    _listView:null,
    itemList:[],
    _height:null,


	ctor:function(){
		this._super();
		this.infos = [];
		this.resInfos = [];
		//this._comItem = [];
        this._time1 = 60*5;
        this._time2 = 60*30;
        this._time3 = 60*60;
        this._time4 = 60*120;
	},

	Init:function(){
        ZaixianMain.prototype.Init.call(this);
        // this._grid = [this.gridAward, this.gridAward1,this.gridAward2,this.gridAward3];
        // this._imgBox = [this.imgBox, this.imgBox1, this.imgBox2, this.imgBox3];
        // // this._imgBox = [this.img1, this.img2, this.img3, this.img4];
        // this._img = [this.img1, this.img2, this.img3, this.img4];
        // this._timeLab = [this.labTimeA, this.labTimeB, this.labTimeC, this.labTimeD];
        //
        // this.btnGp.addClickEventListener(function (){
        //     Mgr.sign.SendReqGetOnlineRewardsToGameMessage();
        // });
        //
        // this.SetClipping(this.imgBox, this.gridAward);
        // this.SetClipping(this.imgBox1, this.gridAward1);
        // this.SetClipping(this.imgBox2, this.gridAward2);
        // this.SetClipping(this.imgBox3, this.gridAward3);
        //
        // this.imgGet.setVisible(false);
        // this.imgGet1.setVisible(false);
        // this.InitGetTip();
		this.InitView();
		this.InitItem();
	},

    InitView:function(){
        if(!this._listView){
            this._listView = new ccui.ListView();
            this._listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._listView.setTouchEnabled(true);					//触摸开启
            this._listView.inertiaScrollEnabled = false; 			//滚动惯性
            this._listView.setScrollBarEnabled(false);				//滚动条
            this._listView.setBounceEnabled(true);					//边界回弹
            this.imgBg.addChild(this._listView);
        }
    },

    InitItem:function(){
        var _height;
        var list = Q_online.GetList();
        for(var i = 0; i < list.length; i++){
            if (!this.itemList[i]) {
                // cell=cc.Sprite();
                var item = new ZaiXianListExt();
                item.LoadPanel();
                _height = item.uiHeight;
                this.itemList.push(item);
                this._listView.pushBackCustomItem(item);
            }
            this.itemList[i].SetData(list[i]);
        }
        this._listView.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
        this._listView.setInnerContainerSize(cc.size(this.imgBg.uiWidth, list.length * _height));
    },

    InitGetTip:function(){
	    for(var i = 0; i != this._imgBox.length; i++){
            var icon1 = new MUIImage();
            icon1.ParseJson(this.imgGet.jsonobj);
            icon1.Init();
            icon1.setPosition(this.imgGet.getPosition());
            icon1.setVisible(false);
            this._imgBox[i].addChild(icon1, 10);
            this._imgBox[i].imgGet = icon1;

            var icon2 = new MUIImage();
            icon2.ParseJson(this.imgGet1.jsonobj);
            icon2.Init();
            icon2.setPosition(this.imgGet1.getPosition());
            icon2.setVisible(false);
            this._imgBox[i].addChild(icon2, 10);
            this._imgBox[i].imgGet1 = icon2;
        }
    },

    RefrechTip:function(){
        var receiveType = Mgr.sign.ReceiveType = [Mgr.sign._is_5_receive, Mgr.sign._is_30_receive, Mgr.sign._is_60_receive, Mgr.sign._is_120_receive];
        for(var i =0; i != receiveType.length; i++ ){
            switch(receiveType[i]){
                case ReceiveType.CANT_RECEIVE :
                    // this._imgBox[i].imgGet.setVisible(false);
                    // this._imgBox[i].imgGet1.setVisible(false);
                    // this._timeLab[i].setVisible(true);
                    this.itemList[i].imgGet.visible = false;
                    this.itemList[i].btnGet.visible = false;
                    this.itemList[i].imgNo.visible = true;
                    break;
                case ReceiveType.WAIT_RECEIVE :
                    // this._imgBox[i].imgGet.setVisible(false);
                    // this._imgBox[i].imgGet1.setVisible(true);
                    // this._timeLab[i].setVisible(false);
                    this.itemList[i].imgGet.visible = false;
                    this.itemList[i].btnGet.visible = true;
                    this.itemList[i].imgNo.visible = false;
                    break;
                case ReceiveType.BE_RECEIVE :
                    // this._imgBox[i].imgGet.setVisible(true);
                    // this._imgBox[i].imgGet1.setVisible(false);
                    // this._timeLab[i].setVisible(false);
                    this.itemList[i].imgGet.visible = true;
                    this.itemList[i].btnGet.visible = false;
                    this.itemList[i].imgNo.visible = false;
                    break;
            }
        }
    },

	SetData:function(onlinetime, infos){
	    this.onlinetime = onlinetime;
	    this.infos = infos;
        this._curTime = Mgr.login.GetServerTime();
        this._passTime = this._curTime;
        this.isOpen = true;
		this._hour = parseInt(this.onlinetime/3600);
		this._minute = parseInt(this.onlinetime/60)%60;
		this._second = this.onlinetime%60;


        this._time1 = 60*5 - this.onlinetime;
        this._time2 = 60*30 - this.onlinetime;
        this._time3 = 60*60 - this.onlinetime;
        this._time4 = 60*120 - this.onlinetime;
        
        // this.progJindutiao.setPercent(this.onlinetime/(60*5)*100);
        // this.progJindutiao1.setPercent(this.onlinetime/(60*30)*100);
        // this.progJindutiao2.setPercent(this.onlinetime/(60*60)*100);
        // this.progJindutiao3.setPercent(this.onlinetime/(60*120)*100);


        // this.imglabNum.SetString(this._hour);
        // this.imglabNum1.SetString(this._minute);
        // this.imglabNum2.SetString(this._second);
        var str = "";
        if(this._hour){
            str = this._hour + "小时" + this._minute + "分" + this._second + "秒";
        }
        else if(this._minute){
            str = this._minute + "分" + this._second + "秒";
        }
        else if(this._second){
            str = this._second + "秒";
        }
        UIUtil.ConnectLabelHtmlText( this.labCue1, [str] );
        // this.InitGrid();
	},

    OnShow:function(){
        Mgr.sign.SendReqOpenOnlineRewardsToGameMessage();
    },

    InitGrid:function(){
        for(var i = 0; i!= this._grid.length; i++){
            this._grid[i].setVisible(false);
            this._imgBox[i].setVisible(true);
        }

        for(var i = 0;i!= this.infos.length; i++){
            switch(this.infos[i].timetype){
                case 300:
                    this.img1.setVisible(false);
                    this.imgBox.imgGet.setVisible(true);
                    this.ShowGrid(this._comItem, this.infos[i], this.gridAward, this.imgBox, true);
                    break;
                case 1800:
                    this.img2.setVisible(false);
                    this.imgBox1.imgGet.setVisible(true);
                    this.ShowGrid(this._comItem1, this.infos[i], this.gridAward1, this.imgBox1, true);
                    break;
                case 3600:
                    this.img3.setVisible(false);
                    this.imgBox2.imgGet.setVisible(true);
                    this.ShowGrid(this._comItem2, this.infos[i], this.gridAward2, this.imgBox2, true);
                    break;
                case 7200:
                    this.img4.setVisible(false);
                    this.imgBox3.imgGet.setVisible(true);
                    this.ShowGrid(this._comItem3, this.infos[i], this.gridAward3, this.imgBox3, true);
                    break;
                default:
                    break;
            }
        }
    },

	Update:function(onlineTime){
        this.onlinetime = Math.round(onlineTime);

        this._hour = parseInt(this.onlinetime/3600);
        this._minute = parseInt(this.onlinetime/60)%60;
        this._second = this.onlinetime%60;


        // this._time1 = 60*5 - this.onlinetime;
        // this._time2 = 60*30 - this.onlinetime;
        // this._time3 = 60*60 - this.onlinetime;
        // this._time4 = 60*120 - this.onlinetime;

        // this.progJindutiao.setPercent(this.onlinetime/(60*5)*100);
        // this.progJindutiao1.setPercent(this.onlinetime/(60*30)*100);
        // this.progJindutiao2.setPercent(this.onlinetime/(60*60)*100);
        // this.progJindutiao3.setPercent(this.onlinetime/(60*120)*100);

        // this.imglabNum.SetString(this._hour);
        // this.imglabNum1.SetString(this._minute);
        // this.imglabNum2.SetString(this._second);
        var str = "";
        if(this._hour){
            str = this._hour + "小时" + this._minute + "分" + this._second + "秒";
        }
        else if(this._minute){
            str = this._minute + "分" + this._second + "秒";
        }
        else if(this._second){
            str = this._second + "秒";
        }
        UIUtil.ConnectLabelHtmlText( this.labCue1, [str] );
        // this.labTimeA.SetHtmlText(this.CountDown(this._time1));
        // this.labTimeB.SetHtmlText(this.CountDown(this._time2));
        // this.labTimeC.SetHtmlText(this.CountDown(this._time3));
        // this.labTimeD.SetHtmlText(this.CountDown(this._time4));
	},

    CountDown:function(time){
	    var hour = 0;
        var minute = 0;
        var second = 0;

	    time > 3600 ? parseInt(time/3600) >= 10 ? hour = parseInt(time/3600) : hour = "0" + parseInt(time/3600) : hour = "00";
	    time > 60 ? parseInt(time/60)%60 >= 10 ? minute =  parseInt(time/60)%60 : minute = "0" +  parseInt(time/60)%60 : minute = "00";
        time > 0 ? time%60 >= 10 ? second = time%60 : second = "0" + time%60:second ="00";
	    return hour + ":" + minute + ":" + second;
    },

    InitBoxItem:function(){
        // for(var i = 0;i!= this.infos.length; i++){
        //     if(this.infos[i].timetype == 300){
        //         this.imgBox.loadTexture(ResUrl.GetItemIconKey(this.infos[i].itemModelid), ccui.Widget.PLIST_TEXTURE);
        //     }else if(this.infos[i].timetype == 1800){
        //         this.imgBox1.loadTexture(ResUrl.GetItemIconKey(this.infos[i].itemModelid), ccui.Widget.PLIST_TEXTURE);
        //     }else if(this.infos[i].timetype == 3600){
        //         this.imgBox2.loadTexture(ResUrl.GetItemIconKey(this.infos[i].itemModelid), ccui.Widget.PLIST_TEXTURE);
        //     }else if(this.infos[i].timetype == 7200){
        //         this.imgBox3.loadTexture(ResUrl.GetItemIconKey(this.infos[i].itemModelid), ccui.Widget.PLIST_TEXTURE);
        //     }
        // }
    },

    ParabolaTo:function(t, startPoint, endPoint, height, angle){
        var radian = angle*Math.PI/180.0;
        // 第一个控制点为抛物线左半弧的中点
        var q1x = startPoint.x + (endPoint.x - startPoint.x) / 4.0;
        var q1 = cc.p(q1x, height + startPoint.y + Math.cos(radian) * q1x);
        // 第二个控制点为整个抛物线的中点
        var q2x = startPoint.x + (endPoint.x - startPoint.x)/2.0;
        var q2 = cc.p(q2x, height + startPoint.y + Math.cos(radian) * q2x);

        var bezier2 = [q1, q2, endPoint];
        return cc.bezierTo(t,bezier2).easing(cc.easeInOut(t));
    },

    FallDown:function(id){
        var fallSprite = new cc.Sprite();
        fallSprite.initWithSpriteFrameName(ResUrl.GetItemIconKey(id));
        this.addChild(fallSprite);
        fallSprite.setPosition(this.btnGp.getPosition());

        var endx = this.getPositionX() + this.getParent().getPositionX() + this.getParent().getParent().getPositionX();
        var endy = this.getPositionY() + this.getParent().getPositionY() + this.getParent().getParent().getPositionY();

        var parabola = this.ParabolaTo(1.5, this.btnGp.getPosition(), cc.p(-endx , -endy), 40, 20);
        var scale = cc.scaleTo(1.5, 0.2);
        var spawn = cc.Spawn(parabola, scale);

        var callback = new cc.CallFunc(this._ClearFall,fallSprite);
        var seqeunce = cc.Sequence(spawn, callback);
        fallSprite.runAction(seqeunce);
    },

    _ClearFall:function(fallSprite){
        fallSprite.stopAllActions();
        if(fallSprite)
            fallSprite.removeFromParent(true);
        fallSprite = null;
    },

    ShowGrid:function(comitem, iteminfo, grid, img, visible){
        grid.setVisible(true);
        var itemdata = Q_item.Get(iteminfo.itemModelid);
        var item = ItemUtil.ItemIdToItem(iteminfo.itemModelid, iteminfo.itemnum, itemdata.q_bind);

        if(comitem == null){
            comitem = new TaskRewardsGridCon();
            comitem.x = grid.x;
            comitem.y = grid.y;
            img.addChild(comitem, 1);
        }
        comitem.Clear();
        comitem.AddComItem(item,grid);
        comitem.Layout(grid.uiWidth, grid.uiHeight, grid.uiWidth, grid.uiHeight );
        grid.comitem = comitem;
        grid.visible = visible;
        grid.comitem.visible = visible;
    },

    PrintResInfos:function(resInfos){
        this.resInfos = resInfos;
	    for(var i = 0;i!= this.resInfos.length; i++){
            this.FallDown(this.resInfos[i].itemModelid);
            switch(this.resInfos[i].timetype){
                case 300:
                    this.img1.setVisible(false);
                    this.ShowGrid(this._comItem, this.resInfos[i], this.gridAward, this.imgBox, false);
                    this.RollBox(this.imgBox, this.gridAward, this.resInfos[i].itemModelid);
                    break;
                case 1800:
                    this.img2.setVisible(false);
                    this.ShowGrid(this._comItem1, this.resInfos[i], this.gridAward1, this.imgBox1, false);
                    this.RollBox(this.imgBox1, this.gridAward1, this.resInfos[i].itemModelid);
                    break;
                case 3600:
                    this.img3.setVisible(false);
                    this.ShowGrid(this._comItem2, this.resInfos[i], this.gridAward2, this.imgBox2, false);
                    this.RollBox(this.imgBox2, this.gridAward2, this.resInfos[i].itemModelid);
                    break;
                case 7200:
                    this.img4.setVisible(false);
                    this.ShowGrid(this._comItem3, this.resInfos[i], this.gridAward3, this.imgBox3, false);
                    this.RollBox(this.imgBox3, this.gridAward3, this.resInfos[i].itemModelid);
                    break;
                default:
                    break;
            }
        }
        this.timeId = TimerUtil.TimeUpdate(this.UpdateRollBox, this, 0.01);
        TimerUtil.SetTimeout(this, this.StopRoll, 2000);
    },

    SetClipping:function(img, grid){
        var drawNode = new cc.DrawNode();
        // var grid = img.grid;

        drawNode.drawRect(
            cc.p(grid.x, grid.y), // 起点
            cc.p(grid.x + grid.width, grid.y + grid.height), // 起点的对角点
            cc.color(255,255, 255, 255), // 填充颜色
            1, // 线粗
            cc.color(255,255, 255, 255) // 线颜色
        );
        var clip = new cc.ClippingNode();
        clip.setStencil(drawNode);
        clip.setInverted(false);
        img.addChild(clip);
        img.clip = clip;
    },

    RollBox:function(img, grid, itemid){
        // var grid = img.grid;
        if(grid.rollBox1 == null || grid.rollBox2 == null){
            for(var i = 1; i != 4; i++){
                var rollbox = new GridItem();
                rollbox.ParseJson( grid.jsonobj );
                rollbox.Init();
                rollbox.retain();
                rollbox.x = grid.x;
                rollbox.y = grid.y - grid.height*(i-1);
                img.clip.addChild(rollbox);
                grid["rollbox" + i] = rollbox;
            }
        }
        for(var i = 1; i != 4; i++){
            var icon = ItemUtil.GetItemIcon(itemid);
            icon.x = (grid.uiWidth - icon.width) / 2;
            icon.y = (grid.uiHeight - icon.height) / 2;
            grid["rollbox" + i].SetGridIcon(icon);
        }
    },

    UpdateRollBox:function(){
        for(var i = 0;i!= this.resInfos.length; i++){
            switch(this.resInfos[i].timetype){
                case 300:
                    this.RollUp(this.gridAward);
                    break;
                case 1800:
                    this.RollUp(this.gridAward1);
                    break;
                case 3600:
                    this.RollUp(this.gridAward2);
                    break;
                case 7200:
                    this.RollUp(this.gridAward3);
                    break;
                default:
                    break;
            }
        }
    },

    RollUp:function(grid){
        for(var i = 1; i != 4; i++){
            if(!grid["rollbox" + i])
                break;
            grid["rollbox" + i].y += 2;
            if(grid["rollbox" + i].y > 2*grid["rollbox" + i].height)
                grid["rollbox" + i].y = -grid["rollbox" + i].height;
        }
    },

    ClearRoll:function(grid){
        for(var i = 1; i != 4; i++){
            grid["rollbox" + i].removeFromParent();
            grid["rollbox" + i] = null;
        }
    },

    StopRoll:function(){
        TimerUtil.ClearTimeUpdate(this.timeId, this);
        Mgr.sign.SendReqOpenOnlineRewardsToGameMessage();
        this.timeId = -1;
        for(var i = 0;i!= this.resInfos.length; i++){
            switch(this.resInfos[i].timetype){
                case 300:
                    this.gridAward.visible = true;
                    this.gridAward.comitem.visible = true;
                    this.ClearRoll(this.gridAward);
                    break;
                case 1800:
                    this.gridAward1.visible = true;
                    this.gridAward1.comitem.visible = true;
                    this.ClearRoll(this.gridAward1);
                    break;
                case 3600:
                    this.gridAward2.visible = true;
                    this.gridAward2.comitem.visible = true;
                    this.ClearRoll(this.gridAward2);
                    break;
                case 7200:
                    this.gridAward3.visible = true;
                    this.gridAward3.comitem.visible = true;
                    this.ClearRoll(this.gridAward3);
                    break;
                default:
                    break;
            }
        }
    },

    OnHide:function(){
        this._super();
        this.isOpen = false;
	},

} );
ZaixianMainExt.PanelName = "ZaixianMainExt";
PanelClassDic["ZaixianMainExt"] = ZaixianMainExt;
