var TaijiMainExt = TaijiMain.extend ( {
	_className:"TaijiMainExt",
	_activeItemHash:null,
	_activeRawardItemArr:null,
	_activeRawardItemWaveArr:null,
	_startRewardIndex:0,
	_scrollRewardView:null,
	_rewardCellNum:7,//显示cell个数
	cellH:0,
	_rawardWaveArr:null,
	_isShowpanel:true,//是onshow的时候
	_listLen:0,//活动总条数
	_pageView:null,
	_layer:-1,
	_uiModel:null,
	_layoutHash:null,
	_canUp:0,
	_curPageIndex:0,
	_progTime:0,
	_waerId:-1,
	_curShowLayer:0,
	ctor:function(){
		this._super();
	},
	
	Init:function(){
		TaijiMain.prototype.Init.call( this );
		this.btnLeft.setLocalZOrder(1);
		this.btnRight.setLocalZOrder(1);

		this.labName.width =this.labName.uiWidth = 100;
        // 初始化
        var config = Mgr.gossip.GetDailyReward();
        var total = Mgr.gossip.GetDailyExpTotal();
        var width = ((359 - 49 * 2) - config.length * 54) / (config.length - 1);
        var grids = [this.gridZhuangBei];
        var labels = [this.labJinDu1];
        this.imgGet.visible = false;
        this.imgGet1.visible = false;

		this.imgJiangLi.visible = false;

        this.grids = grids;
        this.labels = labels;

        var x = this.gridZhuangBei.x;
        var x1 = this.imgJindutiaoDaily.x;
        var width1 = this.imgJindutiaoDaily.width;
        for(var i=0;i!=config.length;++i){
            var v = config[i];
            var grid = grids[i];
            if(!grid){
                grid = this.gridZhuangBei.Clone();
                this.gridZhuangBei.parent.addChild(grid);
                grids[i] = grid;
            }
            grid.x = x;
            grid.Clean();
            if(!grid.imgGet){
            	var imgGet = new MUIImage();
                imgGet.ParseJson(this.imgGet.jsonobj);
                imgGet.Init();

                imgGet.x = x - 3;
                this.imgBg.addChild(imgGet, 1000000);
                imgGet.setTouchEnabled(true);
                (function(i){
                    imgGet.addClickEventListener(function(){
                        Mgr.gossip.SendReqGossipRewardMessage(grids[i].value);
                    });
                })(i);
                grid.imgGet = imgGet;

                var imgGet1 = new MUIImage();
                imgGet1.ParseJson(this.imgGet1.jsonobj);
                imgGet1.Init();
                imgGet1.x = x - 3;
                this.imgBg.addChild(imgGet1, 1000000);
                imgGet1.setTouchEnabled(true);
                grid.imgGet1 = imgGet1;
                // grid.labelGet = label;
                // label.SetFontSize(23);
                // label.setContentSize(cc.size(grid.uiWidth, grid.uiHeight));
                // label.SetText(TextUtil.AddColor("领取", "76fd56"));
                // label.x = -2;
                // label.y = grid.uiWidth/3;

                // var blink = cc.Blink(0.4, 1);
                // label.runAction(cc.repeatForever(blink));
			}

            var value = v[0];
            var rewards = v[1];
            grid.value = i;

            if(rewards[0]){
                var item = {};
                item.itemModelId = rewards[0].mod;
                item.itemNum = rewards[0].num;
                item.itemBind = rewards[0].bind;
                GridUtil.SetItemGrid(grid,item);
            }

            var label = labels[i];
            if(!label){
                label = this.labJinDu1.clone();
                this.labJinDu1.parent.addChild(label);
            }
            label.SetText(value);
            label.x = x1 + width1 * value / total - label._textWidth - 10;

            x += width + 54;
        }
	},

	RegisterListeners:function(){
		var self = this;
		this._pageView.addCCSEventListener(function (sender, type) {
			self.UpdateProgBar();
		});
		
		this._scrollRewardView.addCCSEventListener(function () {
			self.UpdateProgBar();
		});
		this.btnLeft.addClickEventListener(function () {
			self.OnLeftHandler();
		} );
		this.btnRight.addClickEventListener(function () {
			self.OnRightHandler();
		} );
		
		this.btnLevelUp.addClickEventListener(function () {
			if(self._canUp == 1)
				Mgr.gossip.SendReqGossipLevelUpMessage();
			else if(self._canUp == 0)
				Mgr.tips.ShowNotice("VIP经验不足，请前往右边获取经验！");
			else if(self._canUp == 2)
				Mgr.tips.ShowNotice("已满级！");
		} );

		this.btnHuanhua.addClickEventListener(function () {
			Mgr.gossip.SendReqGossipVitalityFightToGameMessage(Mgr.gossip.GetIdbyShowId(self._curShowLayer));
		} );
	},

	InitPanel:function(){
		this.InitPageView();
		this.InitItems();
		this.RegisterListeners();
		this._layoutHash = new HashMap();
	},

	InitPageView:function(){
		this._scrollRewardView = ccui.ScrollView();
		this._scrollRewardView.setDirection(ccui.ScrollView.DIR_VERTICAL);
		this._scrollRewardView.setTouchEnabled(true);
		this._scrollRewardView.inertiaScrollEnabled=false;
		this._scrollRewardView.setScrollBarEnabled(false);
		this._scrollRewardView.setBounceEnabled(true);
        this._scrollRewardView.setSize(cc.size(this.imgContect.width, this.imgContect.height));
		this.imgContect.addChild(this._scrollRewardView);

		this._pageView = ccui.PageView();
		this._pageView.setTouchEnabled(true);
		this.imgModel.addChild(this._pageView);
		this._pageView.x = -300;
		this._pageView.setContentSize(800, this.imgModel.height);
	},

	InitItems:function(){
		this._activeItemHash = new HashMap();
		// var activeList = Mgr.dataMgr.GetZoneList().sort(this.ShortZoneData);
		// var length = activeList.length;
		var activeData = null;

		var activeList = Q_taijizhidian_type.GetList().concat();
		activeList.sort(this.SortData);
		this._listLen = activeList.length;
		this._rawardWaveArr = [];
		this._activeRawardItemArr = [];
		this._activeRawardItemWaveArr = [];
		for( var i = 0; i < this._listLen; i++ )
		{
			activeData = activeList[ i ];
			this._rawardWaveArr.push(activeData.q_id);
			var activeItem = this._GetRawardCell(this._rawardWaveArr[i],true);
			activeItem.InitData( activeData.q_id );
			activeItem.y = (this._listLen - i - 1) * activeItem.uiHeight;
			activeItem.x = 0;
			this._activeItemHash.Put( activeData.q_id, activeItem );
			this.cellH = activeItem.height;
		}

		this._scrollRewardView.setInnerContainerSize(cc.size(this.imgBg.width, this._activeItemHash.Values().length * activeItem.height));
	},

	SortData:function(p1, p2){
        var info1 = Mgr.gossip.GetGossipTaskInfo(p1.q_id);
        var info2 = Mgr.gossip.GetGossipTaskInfo(p2.q_id);

        var finished1 = info1 && info1.count >= info1.countMax;
        var finished2 = info2 && info2.count >= info2.countMax;

        if(finished1 && finished2){
            return p1.q_order - p2.q_order;
        }

        return finished1 ? 1 : 0;
	},

	_GetRawardCell:function (wave, right) {
		var rawardcell = null;
		if( this._activeRawardItemWaveArr.length >= (this._rewardCellNum+2) ){
			if(right){
				rawardcell = this._activeRawardItemArr.shift();
				this._activeRawardItemWaveArr.shift();
			}else{
				rawardcell = this._activeRawardItemArr.pop();
				this._activeRawardItemWaveArr.pop();
			}
		}else{
			var cell = new TaijiFrameExt();
			cell.LoadPanel();
			cell.retain();
			this._scrollRewardView.addChild(cell);
			rawardcell = cell;
		}
		if(right){
			this._activeRawardItemArr.push(rawardcell);
			this._activeRawardItemWaveArr.push(wave);
		}else{
			this._activeRawardItemArr.unshift(rawardcell);
			this._activeRawardItemWaveArr.unshift(wave);
		}
		return rawardcell;
	},

	UpdateData:function(beadLevel, beadExp, waerLevel){
		this.UpdateLevel(beadLevel, waerLevel);
		this.UpdataCellShow();
	},
	
	UpdateLevel:function(beadLevel, waerLevel){
		this.SetLayer(beadLevel, waerLevel);
		this.UpdateExp();
		this.labDengji.SetHtmlText(TextUtil.FormatStr( "VIP{1}", [ beadLevel ] ));
		this.labName.SetHtmlText(TextUtil.FormatStr( "VIP{1}", [ beadLevel ] ));
		var nextLv = 0;
		var curData = Q_taijizhidian.Get(beadLevel);
        var curTypeArray = Mgr.gossip.GetAttackAdd(curData.q_base_attack_add);
		var rolem = Q_character.Get( Mgr.player.mainPlayer.attributeData.level );
		var fightpower = 0;
		if (rolem && curTypeArray.array){
			fightpower = parseInt(Mgr.fightpower.GetFightPower(rolem.q_attribute) * curTypeArray.array[0][1] / 10000);
		}
		this.imglabNumber.SetText(fightpower);
		var nextData = Q_taijizhidian.Get(beadLevel+1);
        var nextTypeArray = Mgr.gossip.GetAttackAdd(nextData.q_base_attack_add);
        var str = curTypeArray.array
            ? TextUtil.FormatStr( "<font color=\"#3a2707 \">{@}</font><font color=\"#853d07\">{@}%</font>",
                [ Mgr.resline.GetNameByType(curTypeArray.type) + "属性", curTypeArray.array[0][1]/100 ] )
            : "";
		if( nextData ){
			nextLv = beadLevel+1;
			this.labDengji1.SetHtmlText(TextUtil.FormatStr( "VIP{1}", [ nextLv ] ));
			this.labDengji1.setVisible(true);
//			this.labCue1.setVisible(true);
//			this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ nextData.q_base_attack_add/100, nextData.q_id ] ));
            str += nextTypeArray.array
                 ? TextUtil.FormatStr( "<font color=\"#853d07\">→{@}%</font><font color=\"#3a2707 \">({@}级获取)</font>", [ nextTypeArray.array[0][1]/100, nextData.q_id ] )
                 : ""
            // 幻化下一级的奖励
            // var rewards = JSON.parse(nextData.q_reward);
            // var grids = [this.grid1,this.grid11];
            // var j = 0;
            // for(var i=0;i!=rewards.length;++i){
            //     grids[j].Clean();
            //     if(rewards[i]){
            //         if(rewards[i].job && rewards[i].job != Mgr.player.mainPlayer.job)
            //             continue;
            //         var item = {};
            //         item.itemModelId = rewards[i].mod;
            //         item.itemNum = rewards[i].num;
            //         item.itemBind = rewards[i].bind;
            //         GridUtil.SetItemGrid(grids[j],item);
            //     }
            //     j++;
            // }
		}else{
			this.labDengji1.setVisible(false);
            this.imgJiangLi.setVisible(false);
//			this.labCue1.setVisible(false);
		}
		this.labCue.SetHtmlText(str);
	},
	
	UpdateExp:function(){
		var beadExp = Mgr.gossip.taijiExp;
		var curData = Q_taijizhidian.Get(this._layer);
		this.labNumber.SetHtmlText(TextUtil.FormatStr( this.labNumber.GetHtmlText(), [ beadExp, curData.q_exp ] ));
		this.imgJindutiao2.setPercent( curData.q_exp == 0 ? 100: beadExp / curData.q_exp * 100 );

		if(beadExp >= curData.q_exp)
			if(curData.q_exp == 0){
				this.btnLevelUp.setTitleText("满级");
				this._canUp = 2;
			}else
				this._canUp = 1;
		else{
			this._canUp = 0;
		}
//		if( beadExp >= curData.q_exp){
//			Filter.UnGray(this.btnLevelUp);
//			this.btnLevelUp.addClickEventListener(function () {
//				Mgr.gossip.SendReqGossipLevelUpMessage();
//			} );
//		}else{
//			Filter.GrayScale(this.btnLevelUp);
//			this.btnLevelUp.addClickEventListener(null);
//		}
        // 更新每日经验进度
        var total = Mgr.gossip.GetDailyExpTotal();
        var cur = Mgr.gossip.dailyExp;
        this.imgJindutiaoDaily.setPercent( cur / total * 100 );
        UIUtil.ConnectLabelHtmlText(this.labJinDu,[cur,total]);

        for(var i = 0; i < this.grids.length; i++){
            for(var j = 0; j < Mgr.gossip.gossipRewardIds.length; j++){
                if(i == Mgr.gossip.gossipRewardIds[j]){
                    this.grids[i].isGet = true;
                }
            }
        }
        /// 满足的标记
        var config = Mgr.gossip.GetDailyReward();
        for(var k=0;k!=config.length;++k){
            var v = config[k];
            var value = v[0];
            // if(value <= cur){
            //     Filter.GrayScale(this.grids[k]);
            // }else{
            //     Filter.UnGray(this.grids[k]);
            // }
            for(var i = 0; i < this.grids.length; i++){
                if(k == this.grids[i].value){
                    if(this.grids[i].isGet){
                        Filter.GrayScale(this.grids[i]);
                        this.grids[i].imgGet.visible = false;
                        this.grids[i].imgGet1.visible = true;
                    }else{
                        this.grids[i].imgGet1.visible = false;
                        Filter.UnGray(this.grids[i]);
                        if(value <= cur)
                        	this.grids[i].imgGet.visible = true;
                        else
                            this.grids[i].imgGet.visible = false;
                    }
                }
            }
        }
	},
	
	UpdataCellShow:function(){
		var oldBeginIndex = this._rawardWaveArr.indexOf(this._activeRawardItemWaveArr[0]);
        this._rawardWaveArr = this._rawardWaveArr.sort((a,b)=>{
            var p1 = Q_taijizhidian_type.Get(a);
            var p2 = Q_taijizhidian_type.Get(b);
            return this.SortData(p1,p2);
        });

		for(var i = 0; i < this._activeRawardItemWaveArr.length; i++){
			this._activeRawardItemWaveArr[i] = this._rawardWaveArr[ oldBeginIndex + i ];
			this._activeRawardItemArr[i].InitData( this._activeRawardItemWaveArr[i] );
			this._activeRawardItemArr[i].UpdateState();
		}
	},

	ShortGossipIds:function(p1,p2) {
		if( Mgr.gossip.gossipRewardIds.indexOf(p1) != -1 ){
			if( Mgr.gossip.gossipRewardIds.indexOf(p2) != -1 ){
				if (p1 < p2)
					return -1;
				else if (p1 == p2)
					return 0;
				else return 1;
			}else{
				return 1
			}
		}
		if( Mgr.gossip.gossipRewardIds.indexOf(p2) != -1 ){
			return -1;
		}
		if (p1 < p2)
			return -1;
		else if (p1 == p2)
			return 0;
		else return 1;
	},

	GetUIModel:function( showLayer )
	{
		var info = Mgr.player.mainPlayer;
		var uiModel = new UIModel(SceneObjUtil.GetBodyIdByInfo(info));
		for( var i = 0; i < info.playerResLineInfo.length; i++ ){
			var resline = info.playerResLineInfo[i];
			if( resline.type == EnumResline.GUANGWU ){
				uiModel.AddWeapon(SceneObjUtil.GetGodWeaponResId(info.showIllusionInfo, true) || resline.modelid, info.nJobId);
				break;
			}
		}
		if( showLayer )
			uiModel.AddTaiChi(showLayer);
		uiModel.x = 600;
		uiModel.y = 160;
		return uiModel;
	},

	//之前带参self调用时出现undefined问题，所有取消掉参数直接用this代替
	UpdataBtnState:function () {
		var page = this._pageView.getCurrentPageIndex();
		if(page == -1)
			page = 0;
		if(page <= 0){
			this.btnLeft.setVisible(false);
		}else{
			this.btnLeft.setVisible(true);
		}
		if(page >=  (this._layoutHash.Values().length-1)){
			this.btnRight.setVisible(false);
		}else{
			this.btnRight.setVisible(true);
		}
	},
	
	SetLayer:function(layer, waerLevel){
		var curData = Q_taijizhidian.Get(layer);
		var curDataOld = Q_taijizhidian.Get(this._layer);
		var showlayer = curData ? curData.q_show : 0;
		var showlayerOld = (curDataOld ? curDataOld.q_show : -1);
		var length = showlayer - showlayerOld;
		var beginNum = showlayerOld + 1;
		for( var i = 0; i < length; i++ )
		{
			var layout = new ccui.Layout();
			layout.setContentSize(800, this.imgModel.height);
			layout.y = 0;
			layout.x = (beginNum + i) * this.imgModel.width;
			this._pageView.addPage(layout);
			this._layoutHash.Put( beginNum + i, layout );
		}
		if(waerLevel){
			var waerData = Q_taijizhidian.Get(waerLevel);
			this._waerId = waerData.q_show;
		}
        if(this._waerId != -1 && this._waerId != this._pageView.getCurrentPageIndex())
            this._pageView.setCurrentPageIndex(this._waerId);
		else
			this._pageView.setCurrentPageIndex(this._layoutHash.Size() - 1);
		if( this._uiModel )
			this._uiModel.Dispose();
		this._uiModel = this.GetUIModel( this._pageView.getCurrentPageIndex() );
		this._layoutHash.Get(this._pageView.getCurrentPageIndex()).addChild(this._uiModel);

		if( this._pageView.getCurrentPageIndex() == 0 ){
			this.imgHuanhua1.setVisible(false);
			this.btnHuanhua.setVisible(false);
		}
		else if(this._waerId == this._pageView.getCurrentPageIndex()){
			this.imgHuanhua1.setVisible(true);
			this.btnHuanhua.setVisible(false);
		}else{
			this.imgHuanhua1.setVisible(false);
			this.btnHuanhua.setVisible(true);
		}

		this._curShowLayer = showlayer;
		this._layer = layer;
		TimerUtil.SetTimeout(this, this.UpdataBtnState,200);
	},

	OnLeftHandler:function(){
		if( this._pageView.getCurrentPageIndex() == -1 )
			this._pageView.setCurrentPageIndex(0);
		if( this._pageView.getCurrentPageIndex() > 0)
			this._pageView.scrollToPage(this._pageView.getCurrentPageIndex()-1);
		else
			return;
	},

	OnRightHandler:function(){
		if( this._pageView.getCurrentPageIndex() == -1 )
			this._pageView.setCurrentPageIndex(0);
		if( this._pageView.getCurrentPageIndex() <  (this._layoutHash.Values().length-1)){
			this._pageView.scrollToPage(this._pageView.getCurrentPageIndex()+1);
		}
		else
			return;
	},

	UpdateProgBar:function(){
		if( new Date().getTime() - this._progTime < 100 || this._pageView.getCurrentPageIndex() == -1 )
			return;
		this._progTime = new Date().getTime();
		if( this._curPageIndex != this._pageView.getCurrentPageIndex() && this._curPageIndex >= 0 ){
			if( this._uiModel )
				this._uiModel.Dispose();

			var curShowLayer = this._pageView.getCurrentPageIndex();
			this._uiModel = this.GetUIModel( curShowLayer );
			this._layoutHash.Get(this._pageView.getCurrentPageIndex()).addChild(this._uiModel);
			this._curShowLayer = curShowLayer;
			if( curShowLayer == 0 ){
				this.imgHuanhua1.setVisible(false);
				this.btnHuanhua.setVisible(false);
			}else if(this._waerId == curShowLayer){
				this.imgHuanhua1.setVisible(true);
				this.btnHuanhua.setVisible(false);
			}else{
				this.imgHuanhua1.setVisible(false);
				this.btnHuanhua.setVisible(true);
			}
		}
		this.UpdataBtnState();
		this._curPageIndex = this._pageView.getCurrentPageIndex();
	},

	OnShow:function(){
		this._isShowpanel = true;
		Mgr.gossip.SendReqGossipInfoMessage();
	},

	OnHide:function(){
		this._super();
		this._isShowpanel = false;
		if( this._uiModel )
			this._uiModel.Dispose();
		this._uiModel = null;
	}
} );
TaijiMainExt.PanelName = "TaijiMainExt";
PanelClassDic["TaijiMainExt"] = TaijiMainExt;
