var TaijiZhaohueiFrameExt = TaijiZhaohueiFrame.extend ( {
	_className:"TaijiZhaohueiFrameExt",
	_id:0,
	_rawardCon:null,
	_itemMid:0,
	_itemNum:0,
	_isGray:false,
	ctor:function(){
		this._super();
	},

	Init:function(){
		TaijiZhaohueiFrame.prototype.Init.call( this );
		
		UIUtil.UIRemoveSelf(this.gridItem)
//		this.gridItem.setVisible(false);
//		this.labMoney.EnableOutline(EnumFontFormat.COMMON_COLOR11,1);
	},

	SetActivity:function(info){
		this._id = info.type;
		var data = Q_resources_recovery.Get(this._id);
		this.labName.SetHtmlText(TextUtil.FormatStr( this.labName.GetHtmlText(), [ data.q_name ] ));
//		this.labCue.SetHtmlText(TextUtil.FormatStr( this.labCue.GetHtmlText(), [ info.count ] ));
		if(info.count > 0){
			if(this._isGray){
				Filter.UnGray(this.imgFrame);
				this._isGray = false;
				this.btnZhaohuei.setVisible(true);
			}
			this.imgCue.setVisible(false);
		}else if(!this._isGray){
			Filter.GrayScale(this.imgFrame);
			this._isGray = true;
			this.btnZhaohuei.setVisible(false);
			this.imgCue.setVisible(true);
		}

		var itemArr = null;
		if( Mgr.gossip.taijiPanel.findPanel._costType == 0 ){
			if(data.q_reward_silver)
				itemArr = JSON.parse(data.q_reward_silver);
			this.imgGold1.setVisible(false);
			this.labMoney.setVisible(false);
			this.imgDi.visible = false;
//			this.labMoney.SetHtmlText(TextUtil.FormatStr( this.labMoney.GetHtmlText(), [ "免费" ] ));
			if(info.exp > 0){
				this.labCue1.setVisible(true);
				this.imgIcon.setVisible(true);				
				this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ TextUtil.FormatNum(parseInt(info.exp/2)) + "+" ] ));
			}else{
				this.labCue1.setVisible(false);
				this.imgIcon.setVisible(false);

				if(itemArr == null && Q_item.Get(data.q_show_item)){
					var obj = new Object();
					obj.mod = data.q_show_item;
					obj.num = 1;
					obj.bind = 1;
					itemArr = [obj];
				}
			}
		}else{
			if(data.q_reward_gold)
				itemArr = JSON.parse(data.q_reward_gold);
			this.imgGold1.setVisible(true);
			this.labMoney.setVisible(true);
            this.imgDi.visible = true;
			this.labMoney.SetHtmlText(TextUtil.FormatStr( this.labMoney.GetHtmlText(), [ data.q_cost_gold*info.count ] ));
			if(info.exp > 0){
				this.labCue1.setVisible(true);
				this.imgIcon.setVisible(true);	
				this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ TextUtil.FormatNum(info.exp) + "+" ] ));
			}else{
				this.labCue1.setVisible(false);
				this.imgIcon.setVisible(false);

                if(itemArr == null && Q_item.Get(data.q_show_item)){
                    var obj = new Object();
                    obj.mod = data.q_show_item;
                    obj.num = 1;
                    obj.bind = 1;
                    itemArr = [obj];
                }
			}
		}

		if( itemArr && itemArr.length > 0 ){
			if(this._rawardCon == null){
				this._rawardCon = new TaskRewardsGridCon();
				this._rawardCon.x = this.imgIcon.x;
				this._rawardCon.y = this.gridItem.y;
				this.imgFrame.addChild(this._rawardCon);
			}

			if( this._itemMid != parseInt(itemArr[0].mod) || this._itemNum != parseInt(itemArr[0].num) ){
				var item = ItemUtil.ItemIdToItem(parseInt(itemArr[0].mod),parseInt(itemArr[0].num)*info.count,parseInt(itemArr[0].bind));
				this._rawardCon.Clear();
				this._rawardCon.AddComItem(item,this.gridItem,ResUrl.ITEM_SIZE_60);
				this._rawardCon.Layout( this.gridItem.uiWidth, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
				this._itemMid = parseInt(itemArr[0].mod);
				this._itemNum = parseInt(itemArr[0].num);
				this._rawardCon.setVisible(true);
			}
		}else{
			if(this._rawardCon && this._rawardCon.parent != null){
				this._rawardCon.Clear();
				this._rawardCon.setVisible(false);
			}
		}

		var self = this;
		this.btnZhaohuei.addClickEventListener(function () {
			if(Mgr.gossip.taijiPanel.findPanel._costType > Mgr.mainPlayer.attributeData.Allgold()){
				// Mgr.tips.ShowNotice("元宝不足");
				AlertExt.NoEnoughGold(Mgr.gossip.taijiPanel.findPanel._costType - Mgr.mainPlayer.attributeData.Allgold());
			}
			else
				Mgr.offlineres.SendReqGetOfflineResZoneBackMessage(self._id,Mgr.gossip.taijiPanel.findPanel._costType);
		});
	},
	
	Dispose:function(){
		if(this._rawardCon)
			this._rawardCon.Clear();
		this._itemMid = 0;
		this.btnZhaohuei.addClickEventListener(null);
	}
} );
TaijiZhaohueiFrameExt.PanelName = "TaijiZhaohueiFrameExt";
PanelClassDic["TaijiZhaohueiFrameExt"] = TaijiZhaohueiFrameExt;
