var GuildDatiAwardPanelExt = GuildDatiAwardPanel.extend ( {
	_className:"GuildDatiAwardPanelExt",
    timerId:0,

    time:null,

    rankingList:null,

	ctor:function(){
		this._super();
	},

    Init:function(){
        GuildDatiAwardPanel.prototype.Init.call( this );

        this.labOne.visible = false;
        this.labTwo.visible = false;
        this.labThree.visible = false;
        this.rankingList = [this.labOne, this.labTwo, this.labThree];
    },

    onEnter:function(){
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
        if (this.timerId)
            TimerUtil.ClearTimeUpdate(this.timerId, this);
    },

    InitView:function(){
        var activeInfo = Mgr.majorevents.activityHash.Get(EnumZoneActiveType.TYPE_GUILD);
        if(activeInfo){
            var endTime = activeInfo.startTime + activeInfo.endTime - Mgr.login.GetServerTime()/1000;
            this.SetTime(endTime);
        }
    },

    RefreshRanking:function(info){
        var i = 0;
        for(; i< info.length; i++){
            this.rankingList[i].visible = true;
            if(i < 3)
                UIUtil.ConnectLabelHtmlText(this.rankingList[i], [info[i].playerName+" (" + info[i].num + ")"]);
            else
                break;
        }
        for(; i < 3; i++){
            this.rankingList[i].visible = false;
        }
    },

    UpdateView:function(){
    },

    SetTime:function(time){
        this.time = time + Mgr.login.GetServerTime()/1000;
    },

    OnTimer:function(){
        if(this.time){
            var time = Math.ceil(this.time - Mgr.login.GetServerTime()/1000);
            if(time > 0)
                this.labTime.SetText(TextUtil.SecondToHMS2(time));
            else
                this.labTime.SetText(TextUtil.SecondToHMS2(0));
        }
    },
} );
GuildDatiAwardPanelExt.PanelName = "GuildDatiAwardPanelExt";
PanelClassDic["GuildDatiAwardPanelExt"] = GuildDatiAwardPanelExt;
