var GuildListExt = GuildList.extend ( {
	_className:"GuildListExt",

	// 链表三件套
	_listView : null,
	_itemList:null,
	_curSelectItem:null,
	_curSelectId:null,

	_itemsHash:null,
	_sortList:null,
	_guildnum:null,
	_tempList:null,

	_applyIndex:0,

	ctor:function(){
		this._super();
		this._tempList = [];
		this._sortList = [];
		this._itemList = [];
		this._itemsHash = new HashMap();
	},
	Init:function() {
		var self = this;
		GuildList.prototype.Init.call(this);
		this._InitParam();

		this.btnApply.addClickEventListener(function (event){
			if ( !self._curSelectId || self._curSelectId.IsZero() ) {
				Mgr.tips.ShowNotice("请选择一个帮会");
				return;
			}

			for( var i = 0, len = Mgr.guild.appliedGuildList.length; i < len; i++ ){
				if ( self._curSelectId.Equal(Mgr.guild.appliedGuildList[i]) ) {
					Mgr.tips.ShowNotice("已经提交申请，请勿重复");
					return;
				}
			}

			var info;
			for(var i = 0, len = self._sortList.length; i < len; i++){
				var guild = self._sortList[i];
				if(guild.guildId.Equal(self._curSelectId)){
					info = guild;
					break;
				}
			}
			var guildC = Q_guild.Get(info.level);
			cc.assert(null != guildC, "Q_guild Item can't be nil!  level: " + info.level);
			if (info.memberNum >= guildC.q_member) {
				Mgr.tips.ShowNotice("申请失败，帮会人数已达上限");
				return;
			}

			var id = self._curSelectId;
			Mgr.guild.SendReqGuildApplyAddMessage(id);
		});
		this.btnQuicly.addClickEventListener(function (event){
            self._applyIndex = 0;
			self._AutoApplyGuild();
		});
		this.btnCeate.addClickEventListener(function (event){
			EngineMgr.uiMgr.ShowHidePanelByType( CreateGuildPanelExt.PanelName );
		});
		this.btnFind.addClickEventListener(function (event){
			self._FindProbable();
		});
	},

	_InitParam:function () {
		this.btnApply.setVisible(false);
		this.btnQuicly.setVisible(false);
		this.btnCeate.setVisible(false);
		this.imgEditBg.setVisible(false);
		this.edite.setVisible(false);
		this.btnFind.setVisible(false);

		// listView
		// var list = new ccui.ListView();
		// list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		// list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		// list.setContentSize(cc.size(this.imgBg1.width, this.imgBg1.height));
		// list.setTouchEnabled(true);
		// list.setBounceEnabled(true);
		// list.setScrollBarEnabled(false);
		// list.setItemsMargin(0);
		// list.setAnchorPoint(0, 0);
		// list.setPosition(0,0);
		// list.addEventListener(this._SelectedItemEvent);
		// this.imgBg1.addChild(list);
		// this._listView = list;

		//tableview
        var tableView = new cc.TableView(this,cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
        tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
        tableView.setDelegate(this);
        tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
        tableView.x=this.imgBg1.x;
        tableView.y=this.imgBg1.y;
        tableView.uiWidth=this.imgBg1.uiWidth;
        tableView.uiHeight=this.imgBg1.uiHeight;
        this.removeChild(this.imgBg1);
        this.imgBg1=tableView;
        this.addChild(tableView);
        this._listView = tableView;

		// edit
		this.edite.setPlaceHolder( "请输入帮会名称" );
		this.edite.setMaxLength(5);
		this.edite.setDelegate(this);
		this.edite.setTextColor(UIUtil.GetCCColor(0x853d07));
	},

	// editBoxReturn: function (editBox) {
	// 	var self = this;
	// 	if (this.edite == editBox) {
	// 		if ( editBox.getString() == "" ) {
	// 			self._listView.removeAllItems();
	// 			self._LaodItems();
	// 		}
	// 	}
	// },

	_AutoApplyGuild:function(){
        var list = this._GetEnableApply();
        if ( list.length <= 0 ) {
            Mgr.tips.ShowNotice("没有符合加入条件的帮会");
            return;
        }
        if( this._applyIndex < list.length && Mgr.mainPlayer.guildId.IsZero() ){
            Mgr.guild.SendReqGuildApplyAddMessage(list[this._applyIndex].guildId);
            this._applyIndex++;
            TimerUtil.SetTimeout( this, this._AutoApplyGuild, 500);
		}
	},

	CallBackProp:function () {
		this._SetButtonState();
		//this._LaodItems();
		this.InitItems();
	},

	// _LaodItems:function () {
	// 	var listMap = Mgr.guild.guildMap;
	// 	var sortV = listMap.Values();
	// 	sortV.sort(this._SortFunc1);
    //
	// 	var i;
	// 	var boo = false;
	// 	this._itemsHash.Clear();
	// 	for ( i = 0; i != sortV.length; i++ ) {
	// 		var item;
	// 		if ( i < this._itemList.length )
	// 			item = this._itemList[i];
	// 		else {
	// 			item = new GuildListItemExt();
	// 			item.LoadPanel();
	// 			item.retain();
	// 			this._itemList.push(item);
	// 		}
	// 		boo = !boo;
	// 		item.SetData( sortV[i], i+1, boo );
	// 		if (this._listView.getIndex(item) == -1)
	// 			this._AddItem(item);
    //
	// 		this._itemsHash.Put(sortV[i].guildId, item);
	// 	}
	// 	for ( ;i < this._itemList.length; i++ ) {
	// 		var item = this._itemList[i];
	// 		if ( item.parent )
	// 			item.removeFromParent();
	// 	}
    //
	// 	// select
	// 	this._ResetSelectItem();
	// 	if ( this._curSelectItem ) {
	// 		this._curSelectItem.SetSelect(true);
	// 	}
	// },

	InitItems:function () {
        var listMap = Mgr.guild.guildMap;
        this._itemsHash = listMap;
        var sortV = listMap.Values();
        sortV.sort(this._SortFunc1);
        this._sortList = sortV;
        this._guildnum = sortV.length;
		this.imgBg1.reloadData();
    },

	BrushGuildAppliedMark:function (id) {
		var item = this._itemsHash.Get(id);
		if ( item ) {
			item.SetAppliedMark(false);
		}
	},

	// _ResetSelectItem:function ( ) {
	// 	if ( this._curSelectItem ) {
	// 		var memberMap = Mgr.guild.guildMap;
	// 		var guildId = this._curSelectItem._info.guildId;
	// 		if ( !memberMap.ContainsKey( guildId ) )
	// 			this._curSelectItem = null;
	// 	}
	// },

	_GetEnableApply:function () {
		var list = [];
		var items = this._sortList;
		for ( var i = 0; i != items.length; i++ ) {
			var info = items[i];
			var guildC = Q_guild.Get(info.level);
			cc.assert(null != guildC, "Q_guild Item can't be nil!  level: " + info.level);
			if (info.memberNum < guildC.q_member)
				list.push(info);
		}

		// 按战力排序
		list.sort(function(a,b){return b.memberFightPower - a.memberFightPower;})
		return list;
	},

	// _SelectedItemEvent: function (sender, type) {
	// 	switch (type) {
	// 		case ccui.ListView.ON_SELECTED_ITEM_END:
	// 			var parent = sender.parent.parent;
	// 			if ( parent._curSelectItem != null) {
	// 				parent._curSelectItem.SetSelect(false);
	// 				parent._curSelectItem = null;
	// 			}
    //
	// 			var idx = sender.getCurSelectedIndex();
	// 			var itemSelect = sender.getItem(idx);
	// 			itemSelect.SetSelect(true);
	// 			parent._curSelectItem = itemSelect;
	// 			break;
    //
	// 		default:
	// 			break;
	// 	}
	// },

	_SortFunc1:function(a, b) {
		// 按战力排序
		if (a.memberFightPower < b.memberFightPower) {
			return 1;
		}
		else if ( a.memberFightPower == b.memberFightPower ) {
			if ( a.level < b.level ) {
				return 1;
			}
			else if ( a.level == b.level ) {
				if (a.memberNum < b.memberNum) {
					return 1;
				}
				else if ( a.memberNum == b.memberNum ) {
					if (a.createTime > b.createTime) {
						return 1;
					}
				}
			}
		}
		return 0;
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	// 模糊查询
	_FindProbable:function () {
		var str = this.edite.GetText();
		if ( str == "" ) {
			Mgr.tips.ShowNotice("请输入帮会名");
			return;
		}

		// 提取存在key值的帮会列表
		var findItems = [];
		var items = this._itemsHash.Values();
		for (var i = 0; i != items.length; i++ ) {
			var info = items[i];
			if ( info.guildName.indexOf(str) != -1 )
				findItems.push(items[i]);
		}
		if ( findItems.length <= 0 ) {
			Mgr.tips.ShowNotice("查询不到该帮会");
			return;
		}

		// 排序模糊列表
		findItems.sort(this._SortFunc2.bind(this));

		// set list
		//this._listView.removeAllItems();
		var boo = false;
		for (var i = 0; i != findItems.length; i++ ) {
			this._AddItem(findItems[i]);
			boo = !boo;
			findItems[i].SetFloorColor(boo);
		}
	},

	_SortFunc2:function(item1, item2) {
		// 模糊查询列表排序
		var a = item1.GetData();
		var b = item2.GetData();
		var key = this.edite.GetText();
		if (a.guildName.indexOf(key) > b.guildName.indexOf(key)) {
			return 1;
		}
		else if ( a.guildName.indexOf(key) == b.guildName.indexOf(key) ) {
			if ( a.guildName.length > b.guildName.length ) {
				return 1;
			}
		}
		return 0;
	},

	_SetButtonState:function () {
		var ifGuild = !Mgr.player.mainPlayer.guildId.IsZero();
		this.btnApply.setVisible(!ifGuild);
		this.btnQuicly.setVisible(!ifGuild);
		this.btnCeate.setVisible(!ifGuild);
	},

	OnShow:function () {
		Mgr.guild.SendReqGuildGetGuildListMessage();
	},

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(1034,60);
    },
    tableCellAtIndex: function (table, idx) {
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item=new GuildListItemExt();
            item.LoadPanel();
            item.setSwallowTouches(false);
            item.SetData(this._sortList[idx], idx + 1, (idx % 2) == 0);
            cell.item=item;
            cell.addChild(item);
        }else {
        	cell.item.SetData(this._sortList[idx], idx + 1, (idx % 2) == 0);
		}

		if(this._curSelectId){
            cell.item.imgXuanzhong.visible = cell.item._info.guildId.Equal(this._curSelectId);
		}
        return cell;
    },
    tableCellTouched:function (table,cell) {
		cc.log("touched     " + cell.item._info.guildId);
		if(this._curSelectItem){
			this._curSelectItem.imgXuanzhong.visible = false;
		}
        cell.item.imgXuanzhong.visible = true;
        this._curSelectItem = cell.item;
        this._curSelectId = cell.item._info.guildId;
    },
    numberOfCellsInTableView: function (table) {
        return this._guildnum;
    }
} );
GuildListExt.PanelName = "GuildListExt";
PanelClassDic["GuildListExt"] = GuildListExt;
