var GuildListItemExt = GuildListItem.extend ( {
	_className:"GuildListItemExt",

	_info:null,
	_imgSortList:null,
	_isApplied:null,

	ctor:function(){
		this._super();
	},
	Init:function() {
		var self = this;
		GuildListItem.prototype.Init.call(this);
		this.imgXuanzhong.visible = false;
		this._imgSortList = [this.imgSort1, this.imgSort2, this.imgSort3];
	},

	// 底板黄红交替
	SetFloorColor:function (boo) {
		this.imgbghong.setVisible(boo);
		this.imgbgHuang.setVisible(!boo);
	},

	SetData:function (data, sortId, boo) {
		this.Clear();

		this._info = data;

		this.SetFloorColor(boo);

		// sort
		if ( sortId > 0 && sortId <= 3 )
			this._imgSortList[sortId-1].setVisible(true);
		else if (sortId > 3)
			this.labSort.SetString(sortId);
		else
			cc.assert(sortId >= 0, "sortId < 0: " + sortId);

		// name
		this.labName.SetString(data.guildName);
		this.labName1.SetString(data.bangZhuName);

		// lv
		this.labLevel.SetString(data.level);

		// player num
		var str = data.memberNum;
		this.labNum.SetString(str);

		// fight
		this.labFight.SetString(data.memberFightPower + "万");

		// is applied
		this.SetAppliedMark(false);
		var list = Mgr.guild.appliedGuildList;
		for (var i = 0; i != list.length; i++) {
			if ( list[i].Equal(data.guildId) ) {
				this.SetAppliedMark(true);
				break;
			}
		}
	},

	SetAppliedMark:function (boo) {
		this.imgApplied.visible = boo;
		this._isApplied = boo;
	},

	GetData:function () {
		return this._info;
	},

	IsApplied:function () {
		return this._isApplied;
	},

	SetSelect:function (sel) {
		this.imgbgguang.setVisible(sel);
	},

	Clear:function () {
		this.imgbghong.setVisible(false);
		this.imgbgHuang.setVisible(false);
		this.imgbgguang.setVisible(false);
		this.imgSort1.setVisible(false);
		this.imgSort2.setVisible(false);
		this.imgSort3.setVisible(false);
		this.imgApplied.visible = false;
		this.labSort.SetString("");
		this.labName.SetString("");
		this.labName1.SetString("");
		this.labLevel.SetString("");
		this.labNum.SetString("");
		this.labFight.SetString("");
	},
} );
GuildListItemExt.PanelName = "GuildListItemExt";
PanelClassDic["GuildListItemExt"] = GuildListItemExt;
