var PaiHangApplyListExt = PaiHangApplyList.extend ( {
	_className:"PaiHangApplyListExt",
	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
	},

	Init:function () {
		PaiHangApplyList.prototype.Init.call(this);

		this.myIndex = -1;
		var self = this;
		this.btnClose.addClickEventListener(function (sender) {
			Mgr.uiMgr.HidePanel(self);
        });

        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            this.cellPanel=tableView;
            this.imgBg1.addChild(tableView);
        }
    },

	SetData:function (data) {
        var allRankInfos = [];
        for(var i = 0; i < data.length; i++) {
            var rankInfos = data[i].special[0].beanInfo.rankInfos;
            if(rankInfos && rankInfos.length > 0){
                allRankInfos = allRankInfos.concat(rankInfos);
            }
        }
        this.rankInfos = allRankInfos;
        this.totalNum = allRankInfos.length;
        for(var k = 0; k < this.totalNum; k++){
            var rankInfo = allRankInfos[k];
            if(rankInfo.playerid.toGID() == Mgr.player.mainPlayer.sid.toGID()){
                this.myIndex = k+1;
                break;
            }
        }
        if(this.myIndex > 0){
            UIUtil.ConnectLabelHtmlText(this.labPaiming1, [this.myIndex]);
        }else {
            this.labPaiming1.SetHtmlText("<font color=\"#3a2707\">我的排名：<font color=\"#dc143c\">未上榜");
        }

        this.cellPanel.reloadData();
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(856,53);
    },
    tableCellAtIndex: function (table, idx) {
        var data = this.rankInfos[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item = new PaiHangListItemExt();
            item.LoadPanel();
            item.setTouchEnabled(false);
            cell.item = item;
            cell.addChild(item);
        }
        cell.item.SetData(data, idx);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
} );
PaiHangApplyListExt.PanelName = "PaiHangApplyListExt";
PanelClassDic["PaiHangApplyListExt"] = PaiHangApplyListExt;
