var PaiHangMainExt = PaiHangMain.extend ( {
	_className:"PaiHangMainExt",
	ctor:function(){
		this._super();
	},

	Init:function () {
		PaiHangMain.prototype.Init.call(this);

        this.imglab1.y += 7;
        this.imglab1.x += 10;
        this.imglab2.y += 7;
        this.imglab2.x += 10;
        this.imglab3.y += 7;
        this.imgHead.x -= 10;
        this.imgHead.y -= 10;
        this.labName.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
        this.labName2.setVisible(false);
		this.imgZhanshi.setVisible(false);
		this.gridList = [this.grid1];

        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgContent.uiWidth, this.imgContent.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            this.cellPanel=tableView;
            this.imgContent.addChild(tableView);
        }

        var self = this;
        this.labChakan.setTouchEnabled(true);
        this.labChakan.addTouchEventListener(function (sender, type) {
			if(type == ccui.Widget.TOUCH_ENDED){
				var panel = Mgr.uiMgr.ShowPanelByType(PaiHangApplyListExt.PanelName);
				panel.SetData(self.activityList);
			}
        });
    },

    SetActivityList:function (infoList, isOpen) {
        this.activityList = infoList;
        this.totalNum = this.activityList.length - 1;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
		var special = this.activityList[0];
		if(!this._timer){
            var leftTime = special.endTime - parseInt(Mgr.login.GetServerTime()/1000);
            var timeArr = TimeUtil.SecondToDHMS4(leftTime);
            this.imglab1.SetText(timeArr[0]);
            this.imglab2.SetText(timeArr[1]);
            this.imglab3.SetText(timeArr[2]);
			this._timer = TimerUtil.TimeUpdate(function () {
                leftTime--;
				var timeArr = TimeUtil.SecondToDHMS4(leftTime);
				this.imglab1.SetText(timeArr[0]);
				this.imglab2.SetText(timeArr[1]);
				this.imglab3.SetText(timeArr[2]);
            }, this, 1, leftTime);
		}

		var rankInfo = special.special[0].beanInfo.rankInfos;
		if(rankInfo && rankInfo.length > 0){
            this.imgHead.setVisible(true);
            this.imgWenhao.setVisible(false);
            this.imgXuwei.setVisible(false);
            this.labName.setVisible(true);
            UIUtil.LoadImage( this.imgHead, ResUrl.GetPlayerHeadUrl(rankInfo[0].job), false, false, false, false);
            UIUtil.ConnectLabelHtmlText(this.labName, [rankInfo[0].playername]);
        }else {
            this.imgHead.setVisible(false);
            this.imgWenhao.setVisible(true);
            this.imgXuwei.setVisible(true);
            this.labName.setVisible(false);
        }
		var rewards = special.GetRewardList();
        for(var i = 0; i < rewards.length; i++){
            if(!this.gridList[i]){
                var grid = UIUtil.CloneUI(this.grid1);
                this.imgPaihang.addChild(grid);
                this.gridList[i] = grid;
            }
            var grid = this.gridList[i];
            GridUtil.SetItemGrid(grid, rewards[i]);
        }

        this.ResetGridPos();
		this.cellPanel.reloadData();
    },

	ResetGridPos:function () {
        var width = this.imgPaihang.uiWidth;
        var offset = (width - this.gridList.length * this.grid1.uiWidth) / 2;

       	for(var i = 0; i < this.gridList.length; i++){
       		var grid = this.gridList[i];
            grid.x = offset + (this.grid1.uiWidth + 5) * i;
		}
    },

    UpdateSingleActivity:function(info){
        for(var i = 0; i < this.activityList.length; i++){
            var ac = this.activityList[i];
            if(ac.activityId == info.activityId){
                this.activityList[i] = info;
                break;
            }
        }

        for(var i = 0; i < this.totalNum; i++){
            var cell = this.cellPanel.cellAtIndex(i);
            if(cell){
                var item = cell.item;
                if(item && item._data.activityId == info.activityId){
                    item.SetData(info, i + 1);
                    break;
                }
            }
        }
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(513,114);
    },
    tableCellAtIndex: function (table, idx) {
        var data = this.activityList[idx + 1];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item = new XiaoHaoMainExt();
            item.LoadPanel();
            item.setTouchEnabled(false);
            cell.item = item;
            cell.addChild(item);
        }
        cell.item.SetData(data, idx + 1);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
} );
PaiHangMainExt.PanelName = "PaiHangMainExt";
PanelClassDic["PaiHangMainExt"] = PaiHangMainExt;
