///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//188201,ReqKreedInfoToGame 请求打开魔域面板
//188202,ReqOpenKreedToGame 请求开启魔域副本
//188203,ReqKreedAwardToGame 请求领取魔域副本通关奖励

// 接收消息
//188101,ResSendKreedInfoToClient 发送魔域面板信息
//188102,ResKreedChargeInfoToClient 发送魔副本域跟踪面板信息
//188103,ResKreedZoneClearanceToClient 返回前端魔域副本通关


////////////////////
// 发送魔域面板信息 //
////////////////////
var ResSendKreedInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 今日开启的挑战类型1是火（银两副本），2是冰（真气副本）
        this.changenum = 0; // 剩余挑战次数
        this.toplv = 0; // 当前已通过的最高层
	},

	getId:function(){
		return 188101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.changenum);
        _buf.WriteVarInt(this.toplv);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.changenum = _buf.ReadVarInt();
        this.toplv = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.kreed.RecvResSendKreedInfoToClientMessage(this);
	},

});
////////////////////
// 发送魔副本域跟踪面板信息 //
////////////////////
var ResKreedChargeInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 挑战类型1是火（银两副本），2是冰（真气副本）
        this.leftnum = 0; // 剩余怪物数量
        this.totalnum = 0; // 总的数量
        this.zonemodelId = 0; // 副本id
        this.remandtime = 0; // 本次挑战剩余时间
	},

	getId:function(){
		return 188102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.leftnum);
        _buf.WriteVarInt(this.totalnum);
        _buf.WriteVarInt(this.zonemodelId);
        _buf.WriteVarInt(this.remandtime);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.leftnum = _buf.ReadVarInt();
        this.totalnum = _buf.ReadVarInt();
        this.zonemodelId = _buf.ReadVarInt();
        this.remandtime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.kreed.RecvResKreedChargeInfoToClientMessage(this);
	},

});
////////////////////
// 返回前端魔域副本通关 //
////////////////////
var ResKreedZoneClearanceToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本模组ID
        this.time = 0; // 通关用时
	},

	getId:function(){
		return 188103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
        _buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.kreed.RecvResKreedZoneClearanceToClientMessage(this);
	},

});
////////////////////
// 请求打开魔域面板 //
////////////////////
var ReqKreedInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 188201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求开启魔域副本 //
////////////////////
var ReqOpenKreedToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 挑战类型1是火（银两副本），2是冰（真气副本）
        this.zoneModelId = 0; // 副本的modelid
	},

	getId:function(){
		return 188202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.zoneModelId);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.zoneModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求领取魔域副本通关奖励 //
////////////////////
var ReqKreedAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelId = 0; // 副本ID
	},

	getId:function(){
		return 188203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
	},
	
	reading:function( _buf ){
        this.zoneModelId = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(188101, ResSendKreedInfoToClientMessage);
MESSAGE_POOL.Add(188102, ResKreedChargeInfoToClientMessage);
MESSAGE_POOL.Add(188103, ResKreedZoneClearanceToClientMessage);

