var LuckydrawModMgr = LuckydrawModMgr || cc.Class.extend({
	type:null,
	num:null,
	index:null,
	xunBaoPanel:null,
	xingYunPanel:null,
    guangwuPanel:null,

	ctor:function() {	
	},

	RecvResLuckyDrawInfoGameToClientMessage:function(msg) {
		cc.log("收到抽奖面板信息" + JSON.stringify(msg));
		if ( msg.luckyDrawType == EnumLucky.GODBOX ) {
            Mgr.uiMgr.ShowPanelByType(ShenjiBoxPanelExt.PanelName).SetData(msg.records);
        }else if(msg.luckyDrawType == EnumLucky.RECHARGEOPENDRAW){
            this.__RECHARGEOPENDRAW = msg;
			var panel = Mgr.dailyactivity._panelHash.Get(1);
			if (panel && panel._curSubKey == 10){
				panel.childPanel.RefreshPanel(msg);
			}
		}else if(msg.luckyDrawType == EnumLucky.FIND){
        	if(this.xunBaoPanel){
        		this.xunBaoPanel.ShowLogByType(this.xunBaoPanel.logType, msg, null);
        		this.xunBaoPanel.RefreshPanel();
			}
		}else if(msg.luckyDrawType == EnumLucky.GUANGWU) {
            if (this.guangwuPanel) {
                var type = this.guangwuPanel._curType;
                this.guangwuPanel.RefreshRecord(null, msg);
                this.guangwuPanel.panelMgr[type].OnShow(this.guangwuPanel._infoList.Get(type));
            }
        }
	},

	RecvResLuckyDrawResultGameToClientMessage:function(msg) {
		cc.log("收到抽奖结果" + JSON.stringify(msg));
		this.type = msg.luckyDrawType;
        this.itemList=msg.items;
		if(msg.luckyDrawType==EnumLucky.FIND) {
            if(this.xunBaoPanel){
            	this.xunBaoPanel.RefreshPanel();
			}
			var panel=EngineMgr.uiMgr.ShowPanelByType(IncomePanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
			if(panel){
                panel.ShowEffect();
			}
		}
		else if ( msg.luckyDrawType == EnumLucky.GODBOX ) {
			Mgr.tips.ShowNotice("本次抽奖花费88元宝");
			this.SendReqLuckyDrawInfoClientToGameMessage(EnumLucky.GODBOX);
		}else if(msg.luckyDrawType == EnumLucky.RECHARGEOPENDRAW){
			var panel = Mgr.dailyactivity._panelHash.Get(1);
            if(panel){
            	panel.childPanel.DoEffectAction(msg.items);
			}
            // Mgr.uiMgr.GetPanelByType(ActivitiesBackGroundExt.PanelName).childPanel.DoEffectAction(msg.items);
		}else if(msg.luckyDrawType == EnumLucky.SPINWIN){
			if(this.xingYunPanel){
				this.xingYunPanel.luckyDrawPanel.ShowEffect(msg.items);
			}
		}else if(msg.luckyDrawType == EnumLucky.GUANGWU){
            if(this.guangwuPanel)
                this.guangwuPanel.GetRecord(msg.items);
        }
		//this.items = []; // 奖励物品信息列表 ItemInfo
		//this.luckyDrawType = 0; // 抽奖类型
	},

	RecvResShenJiBoxLuckyDrawRecordToClinetMessage:function (msg) {
		cc.log("---- 返回个人抽奖记录 ---- " + JSON.stringify(msg));
		if ( msg.luckyDrawType == EnumLucky.GODBOX )
			Mgr.uiMgr.ShowPanelByType(ShenjiBoxPanelExt.PanelName).SetData( msg.records );

        if(msg.luckyDrawType == EnumLucky.GUANGWU && this.guangwuPanel)
            this.guangwuPanel.RefreshRecord(msg);
        else if(msg.luckyDrawType == EnumLucky.FIND && this.xunBaoPanel){
            this.xunBaoPanel.ShowLogByType(this.xunBaoPanel.logType, null, msg);
            this.xunBaoPanel.RefreshPanel();
		}
	},

    RecvResPrizePoolEnetrYanbaoNumToClinetMessage:function(msg){
        cc.log("=========发送奖池元宝数量=======")
        if(msg.luckyDrawType == EnumLucky.GUANGWU && this.guangwuPanel)
            this.guangwuPanel.RefreshGoldNum(msg.prizePoolEnetrYanbaoNum);
    },

	SendReqLuckyDrawInfoClientToGameMessage:function(type) {
		cc.log("抽奖面板信息");
		var msg = new ReqLuckyDrawInfoClientToGameMessage();
		msg.luckyDrawType = type;
		Mgr.msgMgr.Send( msg );
	},

	SendReqLuckyDrawPerformClientToGameMessage:function(type, num) {
		cc.log("我要抽奖");
		var msg = new ReqLuckyDrawPerformClientToGameMessage();
		msg.luckyDrawType = type; // 抽奖类型
		msg.num = num; // 抽奖次数
		Mgr.msgMgr.Send( msg );
	},

    RecvResLuckyDrawRouletteInfoGameToClientMessage:function (msg) {
		cc.log("鸿运转盘面板信息");
		if(!this.xingYunPanel){
			cc.log("err panel is not define");
		}
		this.xingYunPanel._data = msg;
		if(this.xingYunPanel.luckyDrawPanel){
            this.xingYunPanel.luckyDrawPanel.SetData(msg);
		}
    },

	RecvResLuckyDrawOwnNumsToClinetMessage:function()
	{

	}
});
var EnumLucky = EnumLucky || {
		FIND:1,           	//寻宝
 		GODBOX:2,         	//神机宝箱
		GODCOST:3,			//幸运抽奖
		RECHARGEOPENDRAW:4, //开服活动充值幸运抽奖
		RECHARGEDRAW:5, 	//充值抽奖
    	GUANGWU:7,			//光武抽奖(武林庆典)
		SPINWIN:21,         //幸运转盘（鸿运转盘）
	};