///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//PlayerInfo 角色信息类(在地图上显示)
//MonsterInfo 怪物信息类
//PetInfo 宠物信息类
//DropGoodsInfo 掉落物品信息
//NpcInfo NPC信息
//EffectInfo 场景效果信息
//GridCoordinate 格子坐标
//ShowEffectInfo 自定义特效展示（通用）
//DoubleRepairInfo 双修信息

// 请求消息
//101201,ReqRunning 玩家跑步信息(目前已经修改成215方案)
//101202,ReqJump 玩家跳跃信息
//101203,ReqStartBlock 开始格挡
//101204,ReqStopBlock 停止格挡
//101205,ReqPlayerStop 停止移动
//101206,ReqChangeMapByMove 切换地图
//101207,ReqLoadFinishForChangeMap 切换地图加载完成
//101208,ReqEnterMap 进入地图请求
//101209,ReqNpcTrans NPC传送
//101210,ReqGoldMapTrans 传送到地图传送点入口处
//101211,ReqGetLines 获取地图当前线数量
//101212,ReqSelectLine 选线
//101213,ReqChangeDirect 变换方方向
//101214,ReqMonsterInfo 请求怪物信息
//101215,ReqNewRunning 玩家跑步信息(新)
//101216,ReqSmallFlyShoes 定点传送可跨地图
//101217,ReqTaskMoveToGame 任务特殊传送
//101218,ReqJumpTrans 请求跳跃传送点
//101219,ReqSameMapFlyMove 请求同地图内飞行
//101220,ReqReturnToPreviousMap 请求退出当前地图回到前一张地图

// 接收消息
//101101,ResRoundPlayer 周围玩家
//101102,ResRoundMonster 周围怪物
//101103,ResRoundGoods 周围掉落物品
//101104,ResRoundPet 周围宠物
//101105,ResRoundPlayerDisappear 周围消失角色
//101106,ResRoundMonsterDisappear 周围消失怪物
//101107,ResRoundGoodsDisappear 周围消失物品
//101108,ResRoundPetDisappear 周围消失宠物
//101109,ResSetPosition 角色坐标修正
//101110,ResRunPositions 角色跑步坐标广播
//101111,ResMonsterRunPositions 怪物跑步坐标广播
//101112,ResPlayerJumpPositions 角色跳跃坐标广播
//101113,ResStartBlock 开始格挡
//101114,ResStopBlock 停止格挡
//101115,ResMonsterStop 怪物停止移动
//101116,ResPlayerStop 玩家停止移动
//101117,ResChangeMap 切换地图返回
//101118,ResWeaponChange 武器换装
//101119,ResArmorChange 装备换装
//101120,ResEnterMap 切换地图返回
//101121,ResPetStop 宠物停止移动
//101122,ResPetRunPositions 宠物跑步度座标
//101123,ResPlayerRunEnd 玩家跑步结束
//101124,ResSendLines 发送当前线数量
//101125,ResRoundObjects 周围情况变化
//101126,ResChangeMapFailed 切换地图失败
//101127,ResChangeDirect 变换方面
//101128,ResChangePosition 角色改变坐标
//101129,ResRoundNpc 周围NPC
//101130,ResRoundNpcDisappear 周围消失NPC
//101131,ResRoundEffect 周围效果
//101132,ResRoundEffectDisappear 周围消失效果
//101133,ResPetJumpPositions 角色跳跃坐标广播
//101134,ResPetTranMove 宠物传送
//101135,ResJumpSetPosition 角色跳跃坐标修正
//101136,ResDynamicgrids 动态格子列表
//101137,ResNewRunPositions 新的角色跑步坐标广播
//101138,ResChangeSex 角色改变性别，可见范围内广播
//101139,ResMoveSpeedCorrectionPercent 移动速度修正万分比参数
//101140,ResShowEffectToClient 特效展示
//101141,ResDoubleRepairInfosToClient 双修人员信息
//101142,ResTaskMoveToClient 任务移动 剧情用
//101143,ResRoundPlayerFashion 广播玩家时装Id
//101144,ResRoundPlayerChangeName 广播玩家改变名字
//101145,ResRoundPlayerChangeJob 广播玩家改变职业
//101146,ResNPCRunPositions NPC跑步坐标广播
//101147,ResMomentMove 瞬间移动
//101148,ResRoundJumpTrans 传送点跳跃广播
//101149,ResMonsterJumpPositions 怪物跳跃广播
//101150,ResMonsterRefreshSpecialEffects 怪物刷新特效 duang
//101701,ResSynPlayerPosition 玩家当前坐标
//101702,ResSynMonsterPosition 怪物当前坐标
//101703,ResMapBlocks 阻挡点信息


var PlayerInfo = cc.Class.extend({
	ctor:function(){
		this.personId = null; // 角色Id
        this.viplevel = 0; // vip等级
        this.name = null; // 角色名字
        this.level = 0; // 角色等级
        this.x = 0; // 角色所在X
        this.y = 0; // 角色所在Y
        this.hp = 0; // 角色HP
        this.maxHp = 0; // 角色最大HP
        this.serverKey = 0; // serverKey
        this.speed = 0; // 角色速度
        this.state = 0; // 角色状态
        this.job = 0; // 玩家职业
        this.curFashion = []; // 时装Id int
        this.webname = null; // 平台标识
        this.dir = 0; // 人物面对方向
        this.positions = []; // 跑步坐标集合 Position
        this.team = null; // 队伍ID
        this.guildid = null; // 帮派ID
        this.guildName = null; // 帮派名称
        this.killnum = 0; // 杀人数量,0是白色名字,2个以下是黄色名字,3个以上是红色
        this.isGreyname = 0; // 是否灰名,0不是灰,,大于0灰色时间(灰色优先级高于白色和黄色)
        this.buffs = []; // buff集合 BuffInfo
        this.useTitleModel = 0; // 穿戴的称号modelid
        this.spouseName = null; // 配偶名字
        this.platformVip = 0; // 平台VIP等级
        this.domain = 0; // 腾讯渠标识
        this.faction = 0; // 阵营编号（阵营对战模式使用）
        this.playerResLineInfo = []; // 通用资源线简要信息列表 PlayerResLineInfo
        this.disguiseId = 0; // 当前展示的易容ID
        this.armorShowId = 0; // 当前展示的战甲ID
        this.gossipLevel = 0; // 穿戴的太极阵等级
        this.headTitleId = 0; // 头衔modelId
        this.fightpower = 0; // 战斗力
        this.reincarnatelv = 0; // 当前转生等级
        this.showIllusionInfo = []; // 幻化系统的外显 ShowIllusionInfo
        this.marryExteriorId = 0; // 当前展示的结婚造型modelid
        this.innateModel = 0; // 萌化外显model
        this.aureoleId = 0; // 婚姻光环外显ID
        this.marriageId = null; // 婚姻ID
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteByte(this.viplevel);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
        _buf.WriteVarLong(this.hp);
        _buf.WriteVarLong(this.maxHp);
        _buf.WriteVarInt(this.serverKey);
        _buf.WriteVarInt(this.speed);
        _buf.WriteVarInt(this.state);
        _buf.WriteByte(this.job);
        _buf.WriteUShort( this.curFashion.length );
        for (var i = 0; i < this.curFashion.length; i++) {
            _buf.WriteVarInt(this.curFashion[i]);
        }
        _buf.WriteString(this.webname);
        _buf.WriteByte(this.dir);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteBean(this.positions[i]);
        }
        _buf.WriteLong(this.team);
        _buf.WriteLong(this.guildid);
        _buf.WriteString(this.guildName);
        _buf.WriteByte(this.killnum);
        _buf.WriteByte(this.isGreyname);
        _buf.WriteUShort( this.buffs.length );
        for (var i = 0; i < this.buffs.length; i++) {
            _buf.WriteBean(this.buffs[i]);
        }
        _buf.WriteVarInt(this.useTitleModel);
        _buf.WriteString(this.spouseName);
        _buf.WriteByte(this.platformVip);
        _buf.WriteByte(this.domain);
        _buf.WriteByte(this.faction);
        _buf.WriteUShort( this.playerResLineInfo.length );
        for (var i = 0; i < this.playerResLineInfo.length; i++) {
            _buf.WriteBean(this.playerResLineInfo[i]);
        }
        _buf.WriteByte(this.disguiseId);
        _buf.WriteByte(this.armorShowId);
        _buf.WriteVarInt(this.gossipLevel);
        _buf.WriteByte(this.headTitleId);
        _buf.WriteVarLong(this.fightpower);
        _buf.WriteVarInt(this.reincarnatelv);
        _buf.WriteUShort( this.showIllusionInfo.length );
        for (var i = 0; i < this.showIllusionInfo.length; i++) {
            _buf.WriteBean(this.showIllusionInfo[i]);
        }
        _buf.WriteVarInt(this.marryExteriorId);
        _buf.WriteVarInt(this.innateModel);
        _buf.WriteVarInt(this.aureoleId);
        _buf.WriteLong(this.marriageId);
	},

	reading:function( _buf ){
		this.personId = _buf.ReadLong();
        this.viplevel = _buf.ReadByte();
        this.name = _buf.ReadString();
        this.level = _buf.ReadVarInt();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
        this.hp = _buf.ReadVarLong();
        this.maxHp = _buf.ReadVarLong();
        this.serverKey = _buf.ReadVarInt();
        this.speed = _buf.ReadVarInt();
        this.state = _buf.ReadVarInt();
        this.job = _buf.ReadByte();
        var curFashion_length = _buf.ReadUShort();
        for (var i = 0; i < curFashion_length; i++) {
            this.curFashion[i] = _buf.ReadVarInt();
        }
        this.webname = _buf.ReadString();
        this.dir = _buf.ReadByte();
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadBean(Position);
        }
        this.team = _buf.ReadLong();
        this.guildid = _buf.ReadLong();
        this.guildName = _buf.ReadString();
        this.killnum = _buf.ReadByte();
        this.isGreyname = _buf.ReadByte();
        var buffs_length = _buf.ReadUShort();
        for (var i = 0; i < buffs_length; i++) {
            this.buffs[i] = _buf.ReadBean(BuffInfo);
        }
        this.useTitleModel = _buf.ReadVarInt();
        this.spouseName = _buf.ReadString();
        this.platformVip = _buf.ReadByte();
        this.domain = _buf.ReadByte();
        this.faction = _buf.ReadByte();
        var playerResLineInfo_length = _buf.ReadUShort();
        for (var i = 0; i < playerResLineInfo_length; i++) {
            this.playerResLineInfo[i] = _buf.ReadBean(PlayerResLineInfo);
        }
        this.disguiseId = _buf.ReadByte();
        this.armorShowId = _buf.ReadByte();
        this.gossipLevel = _buf.ReadVarInt();
        this.headTitleId = _buf.ReadByte();
        this.fightpower = _buf.ReadVarLong();
        this.reincarnatelv = _buf.ReadVarInt();
        var showIllusionInfo_length = _buf.ReadUShort();
        for (var i = 0; i < showIllusionInfo_length; i++) {
            this.showIllusionInfo[i] = _buf.ReadBean(ShowIllusionInfo);
        }
        this.marryExteriorId = _buf.ReadVarInt();
        this.innateModel = _buf.ReadVarInt();
        this.aureoleId = _buf.ReadVarInt();
        this.marriageId = _buf.ReadLong();
	},
});
var MonsterInfo = cc.Class.extend({
	ctor:function(){
		this.monsterId = null; // 怪物Id
        this.monsterModelId = 0; // 怪物模板Id
        this.monsterName = null; // 怪物名字
        this.monsterRes = null; // 怪物资源造型
        this.monsterIcon = null; // 怪物头像造型
        this.friend = 0; // 怪物敌对类型 0-全体玩家敌对， 1-全体玩家友好， 2-帮派敌对
        this.friendPara = null; // 怪物敌对参数
        this.level = 0; // 怪物等级
        this.mapId = 0; // 怪物所在地图
        this.x = 0; // 怪物所在X
        this.y = 0; // 怪物所在Y
        this.hp = 0; // 怪物HP
        this.maxHp = 0; // 怪物最大HP
        this.speed = 0; // 怪物速度
        this.dir = 0; // 怪物面对方向
        this.positions = []; // 跑步坐标集合 byte
        this.hprate = 0; // 血量倍率
        this.buffs = []; // buff集合 BuffInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteVarInt(this.monsterModelId);
        _buf.WriteString(this.monsterName);
        _buf.WriteString(this.monsterRes);
        _buf.WriteString(this.monsterIcon);
        _buf.WriteByte(this.friend);
        _buf.WriteString(this.friendPara);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.mapId);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
        _buf.WriteVarLong(this.hp);
        _buf.WriteVarLong(this.maxHp);
        _buf.WriteVarInt(this.speed);
        _buf.WriteByte(this.dir);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteByte(this.positions[i]);
        }
        _buf.WriteByte(this.hprate);
        _buf.WriteUShort( this.buffs.length );
        for (var i = 0; i < this.buffs.length; i++) {
            _buf.WriteBean(this.buffs[i]);
        }
	},

	reading:function( _buf ){
		this.monsterId = _buf.ReadLong();
        this.monsterModelId = _buf.ReadVarInt();
        this.monsterName = _buf.ReadString();
        this.monsterRes = _buf.ReadString();
        this.monsterIcon = _buf.ReadString();
        this.friend = _buf.ReadByte();
        this.friendPara = _buf.ReadString();
        this.level = _buf.ReadVarInt();
        this.mapId = _buf.ReadVarInt();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
        this.hp = _buf.ReadVarLong();
        this.maxHp = _buf.ReadVarLong();
        this.speed = _buf.ReadVarInt();
        this.dir = _buf.ReadByte();
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadByte();
        }
        this.hprate = _buf.ReadByte();
        var buffs_length = _buf.ReadUShort();
        for (var i = 0; i < buffs_length; i++) {
            this.buffs[i] = _buf.ReadBean(BuffInfo);
        }
	},
});
var PetInfo = cc.Class.extend({
	ctor:function(){
		this.petId = null; // 宠物唯一Id
        this.petModelId = 0; // 宠物模板Id
        this.ownerId = null; // 所有者ID
        this.ownerName = null; // 所有者名称
        this.level = 0; // 宠物等级
        this.x = 0; // 宠物所在X
        this.y = 0; // 宠物所在Y
        this.hp = 0; // 宠物HP
        this.maxHp = 0; // 宠物最大HP
        this.speed = 0; // 宠物速度
        this.dir = 0; // 宠物面对方向
        this.positions = []; // 跑步坐标集合 byte
        this.buffs = []; // buff集合 BuffInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.petId);
        _buf.WriteVarInt(this.petModelId);
        _buf.WriteLong(this.ownerId);
        _buf.WriteString(this.ownerName);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
        _buf.WriteVarInt(this.hp);
        _buf.WriteVarInt(this.maxHp);
        _buf.WriteVarInt(this.speed);
        _buf.WriteByte(this.dir);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteByte(this.positions[i]);
        }
        _buf.WriteUShort( this.buffs.length );
        for (var i = 0; i < this.buffs.length; i++) {
            _buf.WriteBean(this.buffs[i]);
        }
	},

	reading:function( _buf ){
		this.petId = _buf.ReadLong();
        this.petModelId = _buf.ReadVarInt();
        this.ownerId = _buf.ReadLong();
        this.ownerName = _buf.ReadString();
        this.level = _buf.ReadVarInt();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
        this.hp = _buf.ReadVarInt();
        this.maxHp = _buf.ReadVarInt();
        this.speed = _buf.ReadVarInt();
        this.dir = _buf.ReadByte();
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadByte();
        }
        var buffs_length = _buf.ReadUShort();
        for (var i = 0; i < buffs_length; i++) {
            this.buffs[i] = _buf.ReadBean(BuffInfo);
        }
	},
});
var DropGoodsInfo = cc.Class.extend({
	ctor:function(){
		this.dropGoodsId = null; // 物品Id
        this.itemModelId = 0; // 物品模板Id
        this.num = 0; // 数量
        this.ownerId = null; // 所有者ID 无主为0
        this.dropTime = 0; // 掉落时间(秒)
        this.intensify = 0; // 强化等级
        this.attributs = 0; // 扩展属性数量
        this.x = 0; // 坐标X
        this.y = 0; // 坐标Y
	},

	writing:function( _buf ){
		_buf.WriteLong(this.dropGoodsId);
        _buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.num);
        _buf.WriteLong(this.ownerId);
        _buf.WriteVarInt(this.dropTime);
        _buf.WriteByte(this.intensify);
        _buf.WriteByte(this.attributs);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
	},

	reading:function( _buf ){
		this.dropGoodsId = _buf.ReadLong();
        this.itemModelId = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.ownerId = _buf.ReadLong();
        this.dropTime = _buf.ReadVarInt();
        this.intensify = _buf.ReadByte();
        this.attributs = _buf.ReadByte();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
	},
});
var NpcInfo = cc.Class.extend({
	ctor:function(){
		this.npcId = null; // NPCID
        this.npcModelId = 0; // NPC模型ID
        this.npcName = null; // NPC名字
        this.npcRes = null; // NPC资源造型
        this.npcIcon = null; // NPC头像造型
        this.x = 0; // 坐标X
        this.y = 0; // 坐标Y
        this.hp = 0; // NPC当前HP
        this.maxHp = 0; // NPC最大HP
        this.state = 0; // NPC状态
        this.speed = 0; // NPC速度
        this.dir = 0; // NPC面对方向
        this.positions = []; // NPC跑步坐标集合 byte
	},

	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
        _buf.WriteVarInt(this.npcModelId);
        _buf.WriteString(this.npcName);
        _buf.WriteString(this.npcRes);
        _buf.WriteString(this.npcIcon);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
        _buf.WriteVarInt(this.hp);
        _buf.WriteVarInt(this.maxHp);
        _buf.WriteByte(this.state);
        _buf.WriteVarInt(this.speed);
        _buf.WriteByte(this.dir);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteByte(this.positions[i]);
        }
	},

	reading:function( _buf ){
		this.npcId = _buf.ReadLong();
        this.npcModelId = _buf.ReadVarInt();
        this.npcName = _buf.ReadString();
        this.npcRes = _buf.ReadString();
        this.npcIcon = _buf.ReadString();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
        this.hp = _buf.ReadVarInt();
        this.maxHp = _buf.ReadVarInt();
        this.state = _buf.ReadByte();
        this.speed = _buf.ReadVarInt();
        this.dir = _buf.ReadByte();
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadByte();
        }
	},
});
var EffectInfo = cc.Class.extend({
	ctor:function(){
		this.effectId = null; // EffectID
        this.effectModelId = 0; // Effect模型ID
        this.type = 0; // 播放类型(0-1次 1-不停)
        this.x = 0; // 坐标X
        this.y = 0; // 坐标Y
        this.play = 0; // 播放时间(秒)
        this.target = null; // 对象
	},

	writing:function( _buf ){
		_buf.WriteLong(this.effectId);
        _buf.WriteVarInt(this.effectModelId);
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
        _buf.WriteVarInt(this.play);
        _buf.WriteLong(this.target);
	},

	reading:function( _buf ){
		this.effectId = _buf.ReadLong();
        this.effectModelId = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
        this.play = _buf.ReadVarInt();
        this.target = _buf.ReadLong();
	},
});
var GridCoordinate = cc.Class.extend({
	ctor:function(){
		this.x = 0; // 坐标X
        this.y = 0; // 坐标Y
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
	},

	reading:function( _buf ){
		this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
	},
});
var ShowEffectInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 类型，1地面效果，2人物效果，3怪物效果，4掉血
        this.id = null; // 怪物ID或者玩家ID
        this.effectid = 0; // 特效ID，和前端定
        this.x = 0; // 坐标X，像素
        this.y = 0; // 坐标Y，像素
        this.param = 0; // 数值参数
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteLong(this.id);
        _buf.WriteVarInt(this.effectid);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
        _buf.WriteVarInt(this.param);
	},

	reading:function( _buf ){
		this.type = _buf.ReadByte();
        this.id = _buf.ReadLong();
        this.effectid = _buf.ReadVarInt();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
        this.param = _buf.ReadVarInt();
	},
});
var DoubleRepairInfo = cc.Class.extend({
	ctor:function(){
		this.sourceid = null; // 玩家ID
        this.targetid = null; // 玩家ID
	},

	writing:function( _buf ){
		_buf.WriteLong(this.sourceid);
        _buf.WriteLong(this.targetid);
	},

	reading:function( _buf ){
		this.sourceid = _buf.ReadLong();
        this.targetid = _buf.ReadLong();
	},
});
////////////////////
// 周围玩家 //
////////////////////
var ResRoundPlayerMessage = cc.Class.extend( {
	ctor:function(){
		this.player = null; // 周围玩家信息
	},

	getId:function(){
		return 101101;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.player);
	},

	reading:function( _buf ){
        this.player = _buf.ReadBean(PlayerInfo);
	},

	action:function(){
		Mgr.map.RecvResRoundPlayerMessage(this);
	},

});
////////////////////
// 周围怪物 //
////////////////////
var ResRoundMonsterMessage = cc.Class.extend( {
	ctor:function(){
		this.monster = null; // 周围怪物信息
	},

	getId:function(){
		return 101102;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.monster);
	},

	reading:function( _buf ){
        this.monster = _buf.ReadBean(MonsterInfo);
	},

	action:function(){
		Mgr.map.RecvResRoundMonsterMessage(this);
	},

});
////////////////////
// 周围掉落物品 //
////////////////////
var ResRoundGoodsMessage = cc.Class.extend( {
	ctor:function(){
		this.goods = null; // 周围掉落物品信息
	},

	getId:function(){
		return 101103;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.goods);
	},

	reading:function( _buf ){
        this.goods = _buf.ReadBean(DropGoodsInfo);
	},

	action:function(){
		Mgr.map.RecvResRoundGoodsMessage(this);
	},

});
////////////////////
// 周围宠物 //
////////////////////
var ResRoundPetMessage = cc.Class.extend( {
	ctor:function(){
		this.pet = null; // 周围宠物信息
	},

	getId:function(){
		return 101104;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.pet);
	},

	reading:function( _buf ){
        this.pet = _buf.ReadBean(PetInfo);
	},

	action:function(){
		Mgr.map.RecvResRoundPetMessage(this);
	},

});
////////////////////
// 周围消失角色 //
////////////////////
var ResRoundPlayerDisappearMessage = cc.Class.extend( {
	ctor:function(){
		this.playerIds = []; // 消失角色列表 long
	},

	getId:function(){
		return 101105;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.playerIds.length );
        for (var i = 0; i < this.playerIds.length; i++) {
            _buf.WriteLong(this.playerIds[i]);
        }
	},

	reading:function( _buf ){
        var playerIds_length = _buf.ReadUShort();
        for (var i = 0; i < playerIds_length; i++) {
            this.playerIds[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.map.RecvResRoundPlayerDisappearMessage(this);
	},

});
////////////////////
// 周围消失怪物 //
////////////////////
var ResRoundMonsterDisappearMessage = cc.Class.extend( {
	ctor:function(){
		this.monstersIds = []; // 消失怪物列表 long
	},

	getId:function(){
		return 101106;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.monstersIds.length );
        for (var i = 0; i < this.monstersIds.length; i++) {
            _buf.WriteLong(this.monstersIds[i]);
        }
	},

	reading:function( _buf ){
        var monstersIds_length = _buf.ReadUShort();
        for (var i = 0; i < monstersIds_length; i++) {
            this.monstersIds[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.map.RecvResRoundMonsterDisappearMessage(this);
	},

});
////////////////////
// 周围消失物品 //
////////////////////
var ResRoundGoodsDisappearMessage = cc.Class.extend( {
	ctor:function(){
		this.goodsIds = []; // 消失物品列表 long
	},

	getId:function(){
		return 101107;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.goodsIds.length );
        for (var i = 0; i < this.goodsIds.length; i++) {
            _buf.WriteLong(this.goodsIds[i]);
        }
	},

	reading:function( _buf ){
        var goodsIds_length = _buf.ReadUShort();
        for (var i = 0; i < goodsIds_length; i++) {
            this.goodsIds[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.map.RecvResRoundGoodsDisappearMessage(this);
	},

});
////////////////////
// 周围消失宠物 //
////////////////////
var ResRoundPetDisappearMessage = cc.Class.extend( {
	ctor:function(){
		this.petIds = []; // 消失宠物列表 long
	},

	getId:function(){
		return 101108;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.petIds.length );
        for (var i = 0; i < this.petIds.length; i++) {
            _buf.WriteLong(this.petIds[i]);
        }
	},

	reading:function( _buf ){
        var petIds_length = _buf.ReadUShort();
        for (var i = 0; i < petIds_length; i++) {
            this.petIds[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.map.RecvResRoundPetDisappearMessage(this);
	},

});
////////////////////
// 角色坐标修正 //
////////////////////
var ResSetPositionMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 修正坐标
	},

	getId:function(){
		return 101109;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResSetPositionMessage(this);
	},

});
////////////////////
// 角色跑步坐标广播 //
////////////////////
var ResRunPositionsMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 人物当前坐标
        this.positions = []; // 跑步坐标集合 byte
	},

	getId:function(){
		return 101110;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteByte(this.positions[i]);
        }
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadByte();
        }
	},

	action:function(){
		Mgr.map.RecvResRunPositionsMessage(this);
	},

});
////////////////////
// 怪物跑步坐标广播 //
////////////////////
var ResMonsterRunPositionsMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 怪物Id
        this.position = null; // 当前坐标
        this.positions = []; // 跑步坐标集合 byte
	},

	getId:function(){
		return 101111;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteBean(this.position);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteByte(this.positions[i]);
        }
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadByte();
        }
	},

	action:function(){
		Mgr.map.RecvResMonsterRunPositionsMessage(this);
	},

});
////////////////////
// 角色跳跃坐标广播 //
////////////////////
var ResPlayerJumpPositionsMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.state = 0; // 角色状态
        this.time = 0; // 跳跃剩余时间
        this.positions = []; // 跳跃坐标集合 Position
	},

	getId:function(){
		return 101112;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteByte(this.state);
        _buf.WriteVarInt(this.time);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteBean(this.positions[i]);
        }
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.state = _buf.ReadByte();
        this.time = _buf.ReadVarInt();
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadBean(Position);
        }
	},

	action:function(){
		Mgr.map.RecvResPlayerJumpPositionsMessage(this);
	},

});
////////////////////
// 开始格挡 //
////////////////////
var ResStartBlockMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
	},

	getId:function(){
		return 101113;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
	},

	action:function(){
		Mgr.map.RecvResStartBlockMessage(this);
	},

});
////////////////////
// 停止格挡 //
////////////////////
var ResStopBlockMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
	},

	getId:function(){
		return 101114;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
	},

	action:function(){
		Mgr.map.RecvResStopBlockMessage(this);
	},

});
////////////////////
// 怪物停止移动 //
////////////////////
var ResMonsterStopMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 角色Id
        this.position = null; // 修正坐标
	},

	getId:function(){
		return 101115;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResMonsterStopMessage(this);
	},

});
////////////////////
// 玩家停止移动 //
////////////////////
var ResPlayerStopMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 修正坐标
	},

	getId:function(){
		return 101116;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResPlayerStopMessage(this);
	},

});
////////////////////
// 切换地图返回 //
////////////////////
var ResChangeMapMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 切换地图类型
        this.mapId = 0; // 地图Id
	},

	getId:function(){
		return 101117;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteVarInt(this.mapId);
	},

	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.mapId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.map.RecvResChangeMapMessage(this);
	},

});
////////////////////
// 武器换装 //
////////////////////
var ResWeaponChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.weaponId = 0; // 武器模板Id
        this.weaponStreng = 0; // 武器等级
        this.expandlevel = 0; // 扩展属性：1橙色装备(紫色装备后的扩展) 2神装
	},

	getId:function(){
		return 101118;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteVarInt(this.weaponId);
        _buf.WriteByte(this.weaponStreng);
        _buf.WriteByte(this.expandlevel);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.weaponId = _buf.ReadVarInt();
        this.weaponStreng = _buf.ReadByte();
        this.expandlevel = _buf.ReadByte();
	},

	action:function(){
		Mgr.map.RecvResWeaponChangeMessage(this);
	},

});
////////////////////
// 装备换装 //
////////////////////
var ResArmorChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.armorId = 0; // 衣服模板Id
	},

	getId:function(){
		return 101119;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteVarInt(this.armorId);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.armorId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.map.RecvResArmorChangeMessage(this);
	},

});
////////////////////
// 切换地图返回 //
////////////////////
var ResEnterMapMessage = cc.Class.extend( {
	ctor:function(){
		this.line = 0; // 所在线
        this.pos = null; // 坐标
	},

	getId:function(){
		return 101120;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.line);
        _buf.WriteBean(this.pos);
	},

	reading:function( _buf ){
        this.line = _buf.ReadVarInt();
        this.pos = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResEnterMapMessage(this);
	},

});
////////////////////
// 宠物停止移动 //
////////////////////
var ResPetStopMessage = cc.Class.extend( {
	ctor:function(){
		this.petId = null; // 宠物Id
        this.position = null; // 修正坐标
	},

	getId:function(){
		return 101121;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.petId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.petId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResPetStopMessage(this);
	},

});
////////////////////
// 宠物跑步度座标 //
////////////////////
var ResPetRunPositionsMessage = cc.Class.extend( {
	ctor:function(){
		this.petId = null; // 宠物Id
        this.position = null; // 当前坐标
        this.positions = []; // 跑步坐标集合 byte
	},

	getId:function(){
		return 101122;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.petId);
        _buf.WriteBean(this.position);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteByte(this.positions[i]);
        }
	},

	reading:function( _buf ){
        this.petId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadByte();
        }
	},

	action:function(){
		Mgr.map.RecvResPetRunPositionsMessage(this);
	},

});
////////////////////
// 玩家跑步结束 //
////////////////////
var ResPlayerRunEndMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 修正坐标
	},

	getId:function(){
		return 101123;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResPlayerRunEndMessage(this);
	},

});
////////////////////
// 发送当前线数量 //
////////////////////
var ResSendLinesMessage = cc.Class.extend( {
	ctor:function(){
		this.lines = []; // 线列表 int
	},

	getId:function(){
		return 101124;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.lines.length );
        for (var i = 0; i < this.lines.length; i++) {
            _buf.WriteVarInt(this.lines[i]);
        }
	},

	reading:function( _buf ){
        var lines_length = _buf.ReadUShort();
        for (var i = 0; i < lines_length; i++) {
            this.lines[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.map.RecvResSendLinesMessage(this);
	},

});
////////////////////
// 周围情况变化 //
////////////////////
var ResRoundObjectsMessage = cc.Class.extend( {
	ctor:function(){
		this.player = []; // 周围玩家信息 PlayerInfo
        this.playerIds = []; // 消失角色列表 long
        this.monster = []; // 周围怪物信息 MonsterInfo
        this.monstersIds = []; // 消失怪物列表 long
        this.goods = []; // 周围掉落物品信息 DropGoodsInfo
        this.goodsIds = []; // 消失物品列表 long
        this.npcs = []; // NPC信息 NpcInfo
        this.npcid = []; // 消失的NPC long
        this.Effect = []; // 周围效果信息 EffectInfo
        this.effectid = []; // 消失的效果信息 long
	},

	getId:function(){
		return 101125;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.player.length );
        for (var i = 0; i < this.player.length; i++) {
            _buf.WriteBean(this.player[i]);
        }
        _buf.WriteUShort( this.playerIds.length );
        for (var i = 0; i < this.playerIds.length; i++) {
            _buf.WriteLong(this.playerIds[i]);
        }
        _buf.WriteUShort( this.monster.length );
        for (var i = 0; i < this.monster.length; i++) {
            _buf.WriteBean(this.monster[i]);
        }
        _buf.WriteUShort( this.monstersIds.length );
        for (var i = 0; i < this.monstersIds.length; i++) {
            _buf.WriteLong(this.monstersIds[i]);
        }
        _buf.WriteUShort( this.goods.length );
        for (var i = 0; i < this.goods.length; i++) {
            _buf.WriteBean(this.goods[i]);
        }
        _buf.WriteUShort( this.goodsIds.length );
        for (var i = 0; i < this.goodsIds.length; i++) {
            _buf.WriteLong(this.goodsIds[i]);
        }
        _buf.WriteUShort( this.npcs.length );
        for (var i = 0; i < this.npcs.length; i++) {
            _buf.WriteBean(this.npcs[i]);
        }
        _buf.WriteUShort( this.npcid.length );
        for (var i = 0; i < this.npcid.length; i++) {
            _buf.WriteLong(this.npcid[i]);
        }
        _buf.WriteUShort( this.Effect.length );
        for (var i = 0; i < this.Effect.length; i++) {
            _buf.WriteBean(this.Effect[i]);
        }
        _buf.WriteUShort( this.effectid.length );
        for (var i = 0; i < this.effectid.length; i++) {
            _buf.WriteLong(this.effectid[i]);
        }
	},

	reading:function( _buf ){
        var player_length = _buf.ReadUShort();
        for (var i = 0; i < player_length; i++) {
            this.player[i] = _buf.ReadBean(PlayerInfo);
        }
        var playerIds_length = _buf.ReadUShort();
        for (var i = 0; i < playerIds_length; i++) {
            this.playerIds[i] = _buf.ReadLong();
        }
        var monster_length = _buf.ReadUShort();
        for (var i = 0; i < monster_length; i++) {
            this.monster[i] = _buf.ReadBean(MonsterInfo);
        }
        var monstersIds_length = _buf.ReadUShort();
        for (var i = 0; i < monstersIds_length; i++) {
            this.monstersIds[i] = _buf.ReadLong();
        }
        var goods_length = _buf.ReadUShort();
        for (var i = 0; i < goods_length; i++) {
            this.goods[i] = _buf.ReadBean(DropGoodsInfo);
        }
        var goodsIds_length = _buf.ReadUShort();
        for (var i = 0; i < goodsIds_length; i++) {
            this.goodsIds[i] = _buf.ReadLong();
        }
        var npcs_length = _buf.ReadUShort();
        for (var i = 0; i < npcs_length; i++) {
            this.npcs[i] = _buf.ReadBean(NpcInfo);
        }
        var npcid_length = _buf.ReadUShort();
        for (var i = 0; i < npcid_length; i++) {
            this.npcid[i] = _buf.ReadLong();
        }
        var Effect_length = _buf.ReadUShort();
        for (var i = 0; i < Effect_length; i++) {
            this.Effect[i] = _buf.ReadBean(EffectInfo);
        }
        var effectid_length = _buf.ReadUShort();
        for (var i = 0; i < effectid_length; i++) {
            this.effectid[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.map.RecvResRoundObjectsMessage(this);
	},

});
////////////////////
// 切换地图失败 //
////////////////////
var ResChangeMapFailedMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 101126;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

	action:function(){
		Mgr.map.RecvResChangeMapFailedMessage(this);
	},

});
////////////////////
// 变换方面 //
////////////////////
var ResChangeDirectMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.dir = 0; // 人物面对方向
	},

	getId:function(){
		return 101127;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteByte(this.dir);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.dir = _buf.ReadByte();
	},

	action:function(){
		Mgr.map.RecvResChangeDirectMessage(this);
	},

});
////////////////////
// 角色改变坐标 //
////////////////////
var ResChangePositionMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 改变坐标
	},

	getId:function(){
		return 101128;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResChangePositionMessage(this);
	},

});
////////////////////
// 周围NPC //
////////////////////
var ResRoundNpcMessage = cc.Class.extend( {
	ctor:function(){
		this.npc = null; // 周围NPC信息
	},

	getId:function(){
		return 101129;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.npc);
	},

	reading:function( _buf ){
        this.npc = _buf.ReadBean(NpcInfo);
	},

	action:function(){
		Mgr.map.RecvResRoundNpcMessage(this);
	},

});
////////////////////
// 周围消失NPC //
////////////////////
var ResRoundNpcDisappearMessage = cc.Class.extend( {
	ctor:function(){
		this.npcids = []; // 消失NPC列表 long
	},

	getId:function(){
		return 101130;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.npcids.length );
        for (var i = 0; i < this.npcids.length; i++) {
            _buf.WriteLong(this.npcids[i]);
        }
	},

	reading:function( _buf ){
        var npcids_length = _buf.ReadUShort();
        for (var i = 0; i < npcids_length; i++) {
            this.npcids[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.map.RecvResRoundNpcDisappearMessage(this);
	},

});
////////////////////
// 周围效果 //
////////////////////
var ResRoundEffectMessage = cc.Class.extend( {
	ctor:function(){
		this.Effect = null; // 周围效果信息
	},

	getId:function(){
		return 101131;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.Effect);
	},

	reading:function( _buf ){
        this.Effect = _buf.ReadBean(EffectInfo);
	},

	action:function(){
		Mgr.map.RecvResRoundEffectMessage(this);
	},

});
////////////////////
// 周围消失效果 //
////////////////////
var ResRoundEffectDisappearMessage = cc.Class.extend( {
	ctor:function(){
		this.effectid = []; // 消失效果列表 long
	},

	getId:function(){
		return 101132;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.effectid.length );
        for (var i = 0; i < this.effectid.length; i++) {
            _buf.WriteLong(this.effectid[i]);
        }
	},

	reading:function( _buf ){
        var effectid_length = _buf.ReadUShort();
        for (var i = 0; i < effectid_length; i++) {
            this.effectid[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.map.RecvResRoundEffectDisappearMessage(this);
	},

});
////////////////////
// 角色跳跃坐标广播 //
////////////////////
var ResPetJumpPositionsMessage = cc.Class.extend( {
	ctor:function(){
		this.petId = null; // 侍宠Id
        this.state = 0; // 跳跃状态 0 一跳  1 二跳
        this.time = 0; // 跳跃剩余时间
        this.positions = []; // 跳跃坐标集合 只有两个元素 起点 终点 Position
	},

	getId:function(){
		return 101133;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.petId);
        _buf.WriteByte(this.state);
        _buf.WriteVarInt(this.time);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteBean(this.positions[i]);
        }
	},

	reading:function( _buf ){
        this.petId = _buf.ReadLong();
        this.state = _buf.ReadByte();
        this.time = _buf.ReadVarInt();
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadBean(Position);
        }
	},

	action:function(){
		Mgr.map.RecvResPetJumpPositionsMessage(this);
	},

});
////////////////////
// 宠物传送 //
////////////////////
var ResPetTranMoveMessage = cc.Class.extend( {
	ctor:function(){
		this.petId = null; // 侍宠Id
        this.position = null; // 坐标
	},

	getId:function(){
		return 101134;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.petId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.petId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResPetTranMoveMessage(this);
	},

});
////////////////////
// 角色跳跃坐标修正 //
////////////////////
var ResJumpSetPositionMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 修正坐标
	},

	getId:function(){
		return 101135;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResJumpSetPositionMessage(this);
	},

});
////////////////////
// 动态格子列表 //
////////////////////
var ResDynamicgridsMessage = cc.Class.extend( {
	ctor:function(){
		this.grids = []; // 格子坐标列表 GridCoordinate
        this.type = 0; // 格子类型，0取消阻挡，1变成阻挡禁止跳跃
        this.all = 0; // 是否全部都存在
	},

	getId:function(){
		return 101136;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.grids.length );
        for (var i = 0; i < this.grids.length; i++) {
            _buf.WriteBean(this.grids[i]);
        }
        _buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.all);
	},

	reading:function( _buf ){
        var grids_length = _buf.ReadUShort();
        for (var i = 0; i < grids_length; i++) {
            this.grids[i] = _buf.ReadBean(GridCoordinate);
        }
        this.type = _buf.ReadVarInt();
        this.all = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.map.RecvResDynamicgridsMessage(this);
	},

});
////////////////////
// 新的角色跑步坐标广播 //
////////////////////
var ResNewRunPositionsMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 人物当前坐标
        this.positions = []; // 跑步坐标集合 Position
	},

	getId:function(){
		return 101137;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteBean(this.positions[i]);
        }
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadBean(Position);
        }
	},

	action:function(){
		Mgr.map.RecvResNewRunPositionsMessage(this);
	},

});
////////////////////
// 角色改变性别，可见范围内广播 //
////////////////////
var ResChangeSexMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.weapon = 0; // 武器模板id
        this.armor = 0; // 衣服模板id
        this.avatar = 0; // 头像模板id
        this.sex = 0; // 角色性别 1-男 2-女
	},

	getId:function(){
		return 101138;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteVarInt(this.weapon);
        _buf.WriteVarInt(this.armor);
        _buf.WriteVarInt(this.avatar);
        _buf.WriteByte(this.sex);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.weapon = _buf.ReadVarInt();
        this.armor = _buf.ReadVarInt();
        this.avatar = _buf.ReadVarInt();
        this.sex = _buf.ReadByte();
	},

	action:function(){
		Mgr.map.RecvResChangeSexMessage(this);
	},

});
////////////////////
// 移动速度修正万分比参数 //
////////////////////
var ResMoveSpeedCorrectionPercentMessage = cc.Class.extend( {
	ctor:function(){
		this.percent = 0; // 修正的万分比
	},

	getId:function(){
		return 101139;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.percent);
	},

	reading:function( _buf ){
        this.percent = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.map.RecvResMoveSpeedCorrectionPercentMessage(this);
	},

});
////////////////////
// 特效展示 //
////////////////////
var ResShowEffectToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.showeffectinfo = null; // 特效信息
	},

	getId:function(){
		return 101140;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.showeffectinfo);
	},

	reading:function( _buf ){
        this.showeffectinfo = _buf.ReadBean(ShowEffectInfo);
	},

	action:function(){
		Mgr.map.RecvResShowEffectToClientMessage(this);
	},

});
////////////////////
// 双修人员信息 //
////////////////////
var ResDoubleRepairInfosToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.doubleRepairInfos = []; // 双修人员信息 DoubleRepairInfo
	},

	getId:function(){
		return 101141;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.doubleRepairInfos.length );
        for (var i = 0; i < this.doubleRepairInfos.length; i++) {
            _buf.WriteBean(this.doubleRepairInfos[i]);
        }
	},

	reading:function( _buf ){
        var doubleRepairInfos_length = _buf.ReadUShort();
        for (var i = 0; i < doubleRepairInfos_length; i++) {
            this.doubleRepairInfos[i] = _buf.ReadBean(DoubleRepairInfo);
        }
	},

	action:function(){
		Mgr.map.RecvResDoubleRepairInfosToClientMessage(this);
	},

});
////////////////////
// 任务移动 剧情用 //
////////////////////
var ResTaskMoveToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.taskmodel = 0; // 任务modelId
        this.position = null; // 改变坐标
	},

	getId:function(){
		return 101142;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.taskmodel);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.taskmodel = _buf.ReadVarInt();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResTaskMoveToClientMessage(this);
	},

});
////////////////////
// 广播玩家时装Id //
////////////////////
var ResRoundPlayerFashionMessage = cc.Class.extend( {
	ctor:function(){
		this.pid = null; // 玩家Id
        this.fashionId = []; // 时装编号 int
	},

	getId:function(){
		return 101143;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.pid);
        _buf.WriteUShort( this.fashionId.length );
        for (var i = 0; i < this.fashionId.length; i++) {
            _buf.WriteVarInt(this.fashionId[i]);
        }
	},

	reading:function( _buf ){
        this.pid = _buf.ReadLong();
        var fashionId_length = _buf.ReadUShort();
        for (var i = 0; i < fashionId_length; i++) {
            this.fashionId[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.map.RecvResRoundPlayerFashionMessage(this);
	},

});
////////////////////
// 广播玩家改变名字 //
////////////////////
var ResRoundPlayerChangeNameMessage = cc.Class.extend( {
	ctor:function(){
		this.pid = null; // 玩家Id
        this.name = null; // 改变后名字
	},

	getId:function(){
		return 101144;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.pid);
        _buf.WriteString(this.name);
	},

	reading:function( _buf ){
        this.pid = _buf.ReadLong();
        this.name = _buf.ReadString();
	},

	action:function(){
		Mgr.map.RecvResRoundPlayerChangeNameMessage(this);
	},

});
////////////////////
// 广播玩家改变职业 //
////////////////////
var ResRoundPlayerChangeJobMessage = cc.Class.extend( {
	ctor:function(){
		this.pid = null; // 玩家Id
        this.job = 0; // 玩家职业
	},

	getId:function(){
		return 101145;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.pid);
        _buf.WriteByte(this.job);
	},

	reading:function( _buf ){
        this.pid = _buf.ReadLong();
        this.job = _buf.ReadByte();
	},

	action:function(){
		Mgr.map.RecvResRoundPlayerChangeJobMessage(this);
	},

});
////////////////////
// NPC跑步坐标广播 //
////////////////////
var ResNPCRunPositionsMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = null; // npcId
        this.position = null; // 当前坐标
        this.positions = []; // 跑步坐标集合 byte
	},

	getId:function(){
		return 101146;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
        _buf.WriteBean(this.position);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteByte(this.positions[i]);
        }
	},

	reading:function( _buf ){
        this.npcId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadByte();
        }
	},

	action:function(){
		Mgr.map.RecvResNPCRunPositionsMessage(this);
	},

});
////////////////////
// 瞬间移动 //
////////////////////
var ResMomentMoveMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 目的坐标
	},

	getId:function(){
		return 101147;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResMomentMoveMessage(this);
	},

});
////////////////////
// 传送点跳跃广播 //
////////////////////
var ResRoundJumpTransMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.position = null; // 目的坐标
	},

	getId:function(){
		return 101148;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResRoundJumpTransMessage(this);
	},

});
////////////////////
// 怪物跳跃广播 //
////////////////////
var ResMonsterJumpPositionsMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 怪物id
        this.time = 0; // 跳跃剩余时间
        this.positions = []; // 跳跃坐标集合 Position
	},

	getId:function(){
		return 101149;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteVarInt(this.time);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteBean(this.positions[i]);
        }
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.time = _buf.ReadVarInt();
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadBean(Position);
        }
	},

	action:function(){
		Mgr.map.RecvResMonsterJumpPositionsMessage(this);
	},

});
////////////////////
// 怪物刷新特效 duang //
////////////////////
var ResMonsterRefreshSpecialEffectsMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterInfo = null; // 怪物
        this.start = null; // 起跳点
        this.type = 0; // 1是从起跳点跳进来
        this.parm = 0; // 参数  起跳速度啥的
	},

	getId:function(){
		return 101150;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.monsterInfo);
        _buf.WriteBean(this.start);
        _buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.parm);
	},

	reading:function( _buf ){
        this.monsterInfo = _buf.ReadBean(MonsterInfo);
        this.start = _buf.ReadBean(Position);
        this.type = _buf.ReadVarInt();
        this.parm = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.map.RecvResMonsterRefreshSpecialEffectsMessage(this);
	},

});
////////////////////
// 玩家跑步信息(目前已经修改成215方案) //
////////////////////
var ReqRunningMessage = cc.Class.extend( {
	ctor:function(){
		this.position = null; // 当前坐标
        this.positions = []; // 跑步坐标集合 byte
        this.force = 0; // 是否后端强制
        this.test = 0; // 检测
	},

	getId:function(){
		return 101201;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.position);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteByte(this.positions[i]);
        }
        _buf.WriteByte(this.force);
        _buf.WriteByte(this.test);
	},

	reading:function( _buf ){
        this.position = _buf.ReadBean(Position);
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadByte();
        }
        this.force = _buf.ReadByte();
        this.test = _buf.ReadByte();
	},

});
////////////////////
// 玩家跳跃信息 //
////////////////////
var ReqJumpMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 跳跃类型
        this.positions = []; // 跳跃坐标集合 Position
        this.force = 0; // 是否后端强制
        this.test = 0; // 检测
	},

	getId:function(){
		return 101202;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteBean(this.positions[i]);
        }
        _buf.WriteByte(this.force);
        _buf.WriteByte(this.test);
	},

	reading:function( _buf ){
        this.type = _buf.ReadByte();
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadBean(Position);
        }
        this.force = _buf.ReadByte();
        this.test = _buf.ReadByte();
	},

});
////////////////////
// 开始格挡 //
////////////////////
var ReqStartBlockMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 101203;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 停止格挡 //
////////////////////
var ReqStopBlockMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 101204;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 停止移动 //
////////////////////
var ReqPlayerStopMessage = cc.Class.extend( {
	ctor:function(){
		this.position = null; // 修正坐标
	},

	getId:function(){
		return 101205;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.position = _buf.ReadBean(Position);
	},

});
////////////////////
// 切换地图 //
////////////////////
var ReqChangeMapByMoveMessage = cc.Class.extend( {
	ctor:function(){
		this.line = 0; // 切换线路
        this.tranId = 0; // 传送点Id
	},

	getId:function(){
		return 101206;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.line);
        _buf.WriteVarInt(this.tranId);
	},

	reading:function( _buf ){
        this.line = _buf.ReadVarInt();
        this.tranId = _buf.ReadVarInt();
	},

});
////////////////////
// 切换地图加载完成 //
////////////////////
var ReqLoadFinishForChangeMapMessage = cc.Class.extend( {
	ctor:function(){
		this.width = 0; // 屏幕宽度
        this.height = 0; // 屏幕高度
	},

	getId:function(){
		return 101207;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.width);
        _buf.WriteVarInt(this.height);
	},

	reading:function( _buf ){
        this.width = _buf.ReadVarInt();
        this.height = _buf.ReadVarInt();
	},

});
////////////////////
// 进入地图请求 //
////////////////////
var ReqEnterMapMessage = cc.Class.extend( {
	ctor:function(){
		this.width = 0; // 屏幕宽度
        this.height = 0; // 屏幕高度
	},

	getId:function(){
		return 101208;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.width);
        _buf.WriteVarInt(this.height);
	},

	reading:function( _buf ){
        this.width = _buf.ReadVarInt();
        this.height = _buf.ReadVarInt();
	},

});
////////////////////
// NPC传送 //
////////////////////
var ReqNpcTransMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = 0; // NPC序号
        this.mapId = 0; // 地图序号
        this.pos = null; // 坐标
	},

	getId:function(){
		return 101209;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.npcId);
        _buf.WriteVarInt(this.mapId);
        _buf.WriteBean(this.pos);
	},

	reading:function( _buf ){
        this.npcId = _buf.ReadVarInt();
        this.mapId = _buf.ReadVarInt();
        this.pos = _buf.ReadBean(Position);
	},

});
////////////////////
// 传送到地图传送点入口处 //
////////////////////
var ReqGoldMapTransMessage = cc.Class.extend( {
	ctor:function(){
		this.mapId = 0; // 地图序号
	},

	getId:function(){
		return 101210;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.mapId);
	},

	reading:function( _buf ){
        this.mapId = _buf.ReadVarInt();
	},

});
////////////////////
// 获取地图当前线数量 //
////////////////////
var ReqGetLinesMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 101211;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 选线 //
////////////////////
var ReqSelectLineMessage = cc.Class.extend( {
	ctor:function(){
		this.line = 0; // 线编号
	},

	getId:function(){
		return 101212;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.line);
	},

	reading:function( _buf ){
        this.line = _buf.ReadVarInt();
	},

});
////////////////////
// 变换方方向 //
////////////////////
var ReqChangeDirectMessage = cc.Class.extend( {
	ctor:function(){
		this.dir = 0; // 人物面对方向
	},

	getId:function(){
		return 101213;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.dir);
	},

	reading:function( _buf ){
        this.dir = _buf.ReadByte();
	},

});
////////////////////
// 请求怪物信息 //
////////////////////
var ReqMonsterInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 怪物唯一ID
	},

	getId:function(){
		return 101214;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
	},

});
////////////////////
// 玩家跑步信息(新) //
////////////////////
var ReqNewRunningMessage = cc.Class.extend( {
	ctor:function(){
		this.position = null; // 当前坐标
        this.positions = []; // 跑步坐标集合 Position
        this.force = 0; // 是否后端强制
        this.test = 0; // 检测
	},

	getId:function(){
		return 101215;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.position);
        _buf.WriteUShort( this.positions.length );
        for (var i = 0; i < this.positions.length; i++) {
            _buf.WriteBean(this.positions[i]);
        }
        _buf.WriteByte(this.force);
        _buf.WriteByte(this.test);
	},

	reading:function( _buf ){
        this.position = _buf.ReadBean(Position);
        var positions_length = _buf.ReadUShort();
        for (var i = 0; i < positions_length; i++) {
            this.positions[i] = _buf.ReadBean(Position);
        }
        this.force = _buf.ReadByte();
        this.test = _buf.ReadByte();
	},

});
////////////////////
// 定点传送可跨地图 //
////////////////////
var ReqSmallFlyShoesMessage = cc.Class.extend( {
	ctor:function(){
		this.autoGold = 0; // 是否自动扣除元宝（0否1是）
        this.mapModel = 0; // 目的地图model
        this.mapLine = 0; // 目的地图线（0是自动分配线路）
        this.position = null; // 目的坐标坐标
	},

	getId:function(){
		return 101216;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.autoGold);
        _buf.WriteVarInt(this.mapModel);
        _buf.WriteVarInt(this.mapLine);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.autoGold = _buf.ReadByte();
        this.mapModel = _buf.ReadVarInt();
        this.mapLine = _buf.ReadVarInt();
        this.position = _buf.ReadBean(Position);
	},

});
////////////////////
// 任务特殊传送 //
////////////////////
var ReqTaskMoveToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.taskModelID = 0; // 任务modelID
        this.type = 0; // 类型0通用 1特殊
	},

	getId:function(){
		return 101217;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.taskModelID);
        _buf.WriteByte(this.type);
	},

	reading:function( _buf ){
        this.taskModelID = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 请求跳跃传送点 //
////////////////////
var ReqJumpTransMessage = cc.Class.extend( {
	ctor:function(){
		this.transId = 0; // 传送点Id
	},

	getId:function(){
		return 101218;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.transId);
	},

	reading:function( _buf ){
        this.transId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求同地图内飞行 //
////////////////////
var ReqSameMapFlyMoveMessage = cc.Class.extend( {
	ctor:function(){
		this.position = null; // 目的坐标坐标
	},

	getId:function(){
		return 101219;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.position = _buf.ReadBean(Position);
	},

});
////////////////////
// 请求退出当前地图回到前一张地图 //
////////////////////
var ReqReturnToPreviousMapMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 101220;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 玩家当前坐标 //
////////////////////
var ResSynPlayerPositionMessage = cc.Class.extend( {
	ctor:function(){
		this.position = null; // 修正坐标
	},

	getId:function(){
		return 101701;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResSynPlayerPositionMessage(this);
	},

});
////////////////////
// 怪物当前坐标 //
////////////////////
var ResSynMonsterPositionMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 角色Id
        this.position = null; // 修正坐标
	},

	getId:function(){
		return 101702;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteBean(this.position);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.map.RecvResSynMonsterPositionMessage(this);
	},

});
////////////////////
// 阻挡点信息 //
////////////////////
var ResMapBlocksMessage = cc.Class.extend( {
	ctor:function(){
		this.blocks = []; // 阻挡点集合 int
	},

	getId:function(){
		return 101703;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.blocks.length );
        for (var i = 0; i < this.blocks.length; i++) {
            _buf.WriteVarInt(this.blocks[i]);
        }
	},

	reading:function( _buf ){
        var blocks_length = _buf.ReadUShort();
        for (var i = 0; i < blocks_length; i++) {
            this.blocks[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.map.RecvResMapBlocksMessage(this);
	},

});
// 接收消息注册
MESSAGE_POOL.Add(101101, ResRoundPlayerMessage);
MESSAGE_POOL.Add(101102, ResRoundMonsterMessage);
MESSAGE_POOL.Add(101103, ResRoundGoodsMessage);
MESSAGE_POOL.Add(101104, ResRoundPetMessage);
MESSAGE_POOL.Add(101105, ResRoundPlayerDisappearMessage);
MESSAGE_POOL.Add(101106, ResRoundMonsterDisappearMessage);
MESSAGE_POOL.Add(101107, ResRoundGoodsDisappearMessage);
MESSAGE_POOL.Add(101108, ResRoundPetDisappearMessage);
MESSAGE_POOL.Add(101109, ResSetPositionMessage);
MESSAGE_POOL.Add(101110, ResRunPositionsMessage);
MESSAGE_POOL.Add(101111, ResMonsterRunPositionsMessage);
MESSAGE_POOL.Add(101112, ResPlayerJumpPositionsMessage);
MESSAGE_POOL.Add(101113, ResStartBlockMessage);
MESSAGE_POOL.Add(101114, ResStopBlockMessage);
MESSAGE_POOL.Add(101115, ResMonsterStopMessage);
MESSAGE_POOL.Add(101116, ResPlayerStopMessage);
MESSAGE_POOL.Add(101117, ResChangeMapMessage);
MESSAGE_POOL.Add(101118, ResWeaponChangeMessage);
MESSAGE_POOL.Add(101119, ResArmorChangeMessage);
MESSAGE_POOL.Add(101120, ResEnterMapMessage);
MESSAGE_POOL.Add(101121, ResPetStopMessage);
MESSAGE_POOL.Add(101122, ResPetRunPositionsMessage);
MESSAGE_POOL.Add(101123, ResPlayerRunEndMessage);
MESSAGE_POOL.Add(101124, ResSendLinesMessage);
MESSAGE_POOL.Add(101125, ResRoundObjectsMessage);
MESSAGE_POOL.Add(101126, ResChangeMapFailedMessage);
MESSAGE_POOL.Add(101127, ResChangeDirectMessage);
MESSAGE_POOL.Add(101128, ResChangePositionMessage);
MESSAGE_POOL.Add(101129, ResRoundNpcMessage);
MESSAGE_POOL.Add(101130, ResRoundNpcDisappearMessage);
MESSAGE_POOL.Add(101131, ResRoundEffectMessage);
MESSAGE_POOL.Add(101132, ResRoundEffectDisappearMessage);
MESSAGE_POOL.Add(101133, ResPetJumpPositionsMessage);
MESSAGE_POOL.Add(101134, ResPetTranMoveMessage);
MESSAGE_POOL.Add(101135, ResJumpSetPositionMessage);
MESSAGE_POOL.Add(101136, ResDynamicgridsMessage);
MESSAGE_POOL.Add(101137, ResNewRunPositionsMessage);
MESSAGE_POOL.Add(101138, ResChangeSexMessage);
MESSAGE_POOL.Add(101139, ResMoveSpeedCorrectionPercentMessage);
MESSAGE_POOL.Add(101140, ResShowEffectToClientMessage);
MESSAGE_POOL.Add(101141, ResDoubleRepairInfosToClientMessage);
MESSAGE_POOL.Add(101142, ResTaskMoveToClientMessage);
MESSAGE_POOL.Add(101143, ResRoundPlayerFashionMessage);
MESSAGE_POOL.Add(101144, ResRoundPlayerChangeNameMessage);
MESSAGE_POOL.Add(101145, ResRoundPlayerChangeJobMessage);
MESSAGE_POOL.Add(101146, ResNPCRunPositionsMessage);
MESSAGE_POOL.Add(101147, ResMomentMoveMessage);
MESSAGE_POOL.Add(101148, ResRoundJumpTransMessage);
MESSAGE_POOL.Add(101149, ResMonsterJumpPositionsMessage);
MESSAGE_POOL.Add(101150, ResMonsterRefreshSpecialEffectsMessage);
MESSAGE_POOL.Add(101701, ResSynPlayerPositionMessage);
MESSAGE_POOL.Add(101702, ResSynMonsterPositionMessage);
MESSAGE_POOL.Add(101703, ResMapBlocksMessage);

