var BiaoBaiEffectPanelExt = MUIPanel.extend({
    _className: "BiaoBaiEffectPanelExt",
    ctor: function(parent) {
        this._super();
        this.modelPanelType = 2
        this.ignoreTouch = true
    },
    Init: function(parent){
        var labTitle = new MUILabel();
        labTitle.setAnchorPoint(cc.p(0.5,0.5))
        labTitle.x = 0;
        labTitle.y = -100;
        labTitle.SetFontSize(30);
        labTitle.SetColor("0xffffff");
        this.addChild(labTitle);

        this.labTitle = labTitle
    },
    OnShow: function(parent) {
        this._super();

//        this.parent.setTouchEnabled(false)
    },
    OnHide: function(parent) {
        this._super();
    },
    SetData:function(data){
        if(this.$animation) this.$animation.removeFromParent()

        var config = {
            50002 : "res/animation/effect/ui/confession/jiupin/jiupin",//香槟
            50003 : "res/animation/effect/ui/confession/huojian/huojian",//火箭
            50004 : "res/animation/effect/ui/confession/chuan/chuan",//游艇
        }
        var file = config[data.itemModel]
        if(file){
            //TODO 添加动画
            LoadMgr.LoadSkeletonAnimation(
                file
                , this
                , LoadPriority_Common,
                {
                    complete:function( data ){
                        var spineBoy = sp.SkeletonAnimation.createWithJsonFile(
                            data.json
                           ,data.atlas
                        );

                        spineBoy.setAnimation(0, 'newAnimation', false);
                        spineBoy.setCompleteListener(index=>{
                            this.labTitle.stopAllActions()
                             this.labTitle.runAction(cc.sequence(
                                cc.fadeOut(0.2)
                                ,cc.callFunc(_=>{
                                    EngineMgr.uiMgr.HidePanel(this)
                                })
                             ))
                        });
                        this.addChild(spineBoy, -1);
                        this.$animation = spineBoy;
                    }
                }
            );
        }

        /// 描述
        var itemC = Q_item.Get(data.itemModel)
        this.labTitle.stopAllActions()
        this.labTitle.setCascadeOpacityEnabled(true)
        this.labTitle.setOpacity(0)
        this.labTitle.runAction(cc.sequence(
            cc.fadeIn(0.5)
            ,cc.delayTime(2)
            ,cc.fadeOut(0.2)
            ,cc.callFunc(_=>EngineMgr.uiMgr.HidePanel(this))
        ))
        this.labTitle.SetText(TextUtil.FormatStr(
            "<f c='#ffdd00'>{@}<f c='#ffffff'>向<f c='#ffdd00'>{@}<f c='#ffffff'>赠送了<f c='#00ddff'>{@}",[
            data.senderName
            , data.reciverName
            , itemC.q_name
        ]))
    },
    PanelName:function(){
        return this._className;
    },
})

BiaoBaiEffectPanelExt.PanelName = "BiaoBaiEffectPanelExt";
PanelClassDic["BiaoBaiEffectPanelExt"] = BiaoBaiEffectPanelExt;
