var WoYaoBiaoBaiExt = WoYaoBiaoBai.extend ( {
    _className:"WoYaoBiaoBaiExt",
    ctor:function(){
        this._super();
        this.modelPanelType = 2
    },
    Init:function(){
        this._super();

        this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));
        this.btnShuaXin.addClickEventListener(this.OnChoose.bind(this));
        this.btnTongyi.addClickEventListener(this.OnConfirm.bind(this));
        this.sbtn1.addTouchEventListener(function(sender, type) {
            if (type == ccui.Widget.TOUCH_ENDED) {
                sender.SetButtonState((sender.GetState() == "check")?"uncheck":"check")
            }
        });

        this.editCue.setFontColor(cc.color(0x85,0x3d,0x07))
        this.editCue.setPlaceholderFontColor(cc.color(0xA6, 0xA6, 0xA6))
        this.editCue.setFontSize(22)
        this.editCue.setPlaceholderFontSize(22)
        this.editCue.setMaxLength(30)
        this.editCue.setPlaceHolder("点击输入文字，不超过30字")
        this.editCue.setDelegate(this);
        this.editCue.setOpacity(0);
        this.editCue.setCascadeOpacityEnabled(true);

        /// 初始化道具选择
        var globalC = Q_global.Get(20009)
        var arr = JSON.parse(globalC.q_string_value) || []
        var imgContent = this.imgContent
        var widthX = imgContent.width / arr.length
        this.dataArr = arr
        this.gridArr = Array.from(arr,(v,k)=>{
            let c = new BiaoBaiFrameltem1Ext()
            c.LoadPanel();
            c.setAnchorPoint(cc.p(0.5,0.5))
            imgContent.addChild(c)
            c.x = widthX * k + widthX / 2
            c.y = imgContent.height / 2
            c.SetData(v)
            c.addClickEventListener(this.OnItemSelected.bind(this,v))
            return c
        })
        this.$config = arr;
    },

    OnShow:function(){
        this._super();

        GameEventMgr.AddEventListener(this,new ResMarriageResInfoToClientMessage().getId(),function(){
            this.OnItemSelected(this.data || this.$config[0])
        })

        this.OnItemSelected(this.data || this.$config[0])
        this.OnChosen()

        /// 重置
        this.editCue.string = ""
        this.editBoxTextChanged(this.editCue)
    },
    OnHide:function(){
        this._super();
        GameEventMgr.RemoveEventListener(this);
    },
    OnItemSelected:function(data){
        this.data = data

        var index = this.dataArr.findIndex(v=>v[0]==data[0])
        this.gridArr.forEach((v,k)=>{
            v.SetSelected(k == index)
            v.scale = k == index ? 1 : 0.9
        })

        var itemId = data[0]

        var itemC = Q_item.Get(itemId)
        var amount = Mgr.backpack.GetItemNumber(itemC.q_id)
        var item = ItemUtil.ItemIdToItem(itemC.q_id, 1, 0);
        GridUtil.SetItemGrid(this.grid1,item)
        UIUtil.ConnectLabelHtmlText(this.labXiaoHao1,[itemC.q_name,amount])

        this.$itemConfig = data
    },
    OnChoose:function(){
        var p = EngineMgr.uiMgr.ShowPanelByType(BiaoBaiFrameExt.PanelName)
        if(p) p.SetCallback(this.OnChosen.bind(this))
    },
    OnChosen:function(data){
        this.$chosenTarget = data;

        if(data){
            this.labName.visible = true
            this.imghead.visible = true
            UIUtil.ConnectLabelHtmlText(this.labName,[data.name])
            UIUtil.LoadImage(this.imghead, ResUrl.GetPlayerHeadUrl(data.icon));
        }else{
            this.labName.visible = false
            this.imghead.visible = false
        }
    },
    OnConfirm:function(){
        if(!this.$chosenTarget){
            Mgr.tips.ShowNotice("请选择表白对象!");
            return
        }
        if(this.editCue.string == ""){
            Mgr.tips.ShowNotice("请输入内容!");
            return
        }

        var playerId = this.$chosenTarget.playerId
        var itemId = this.$itemConfig[0]
        var content = this.editCue.string

        var itemC = Q_item.Get(itemId)
        var amount = Mgr.backpack.GetItemNumber(itemC.q_id)

        if(amount == 0){
            /// 自动购买
            let auto = this.sbtn1.GetState() == "check"

            ShopUtil.QuickBuyItem(itemId,auto,_=>{
                Mgr.marriage.SendReqConfessionToPlayerMessage(
                    playerId
                    , itemId
                    , content
                    )
            },info=>{
                if(info == "钱不够"){
                    Mgr.uiMgr.ShowPanelByType(ChongZhiExt.PanelName);
                    return true
                }
            })
            return
        }

        Mgr.marriage.SendReqConfessionToPlayerMessage(
            playerId
            , itemId
            , content
            )
    },
    editBoxEditingDidBegin:function(sender){
        this.labCue.visible = false
    },
    editBoxEditingDidEnd:function(sender){
        this.labCue.visible = true
    },
    editBoxTextChanged: function (editBox, text) {
        var self = this;
        var ediText = editBox.getString();
        if (self.editCue == editBox) {
            if ( ediText != "" ) {
                self.labCue.SetString( ediText );
                self.labCue.SetColor(0x853d07)
            }else{
                self.labCue.SetString( "点击输入文字，不超过30字" );
                self.labCue.SetColor(0xA6A6A6)
            }
        }
    },
} );
WoYaoBiaoBaiExt.PanelName = "WoYaoBiaoBaiExt";
PanelClassDic["WoYaoBiaoBaiExt"] = WoYaoBiaoBaiExt;
