var YuYuePanelExt = (function(){
    var Cell = cc.TableViewCell.extend({
        ctor:function(){
            this._super();
        },
        SetData:function(){
            if(!this.container){
                let c = new YuYuePanelListExt();
                c.LoadPanel();
                this.addChild(c)
                this.container = c
            }

            this.container.SetData.apply(this.container,arguments)
        },
        SetSelected:function(){
            if(this.container) this.container.SetSelected.apply(this.container,arguments)
        },
    })
    return YuYuePanel.extend({
        _className:"YuYuePanelExt",
        ctor:function(){
            this._super();
            this.modelPanelType = 2
        },
        Init:function(){
            this._super();

            this.btnWenHao.addClickEventListener(_=>{
                AlertTipsExt.Show(
                    "1.每对夫妻每天只可开启<font color='#0900d1'>一次<font color='#3a2707'>婚宴,可以选择免费开启普通婚宴,或者消耗元宝开启高级婚宴.\n"
                    + "2.婚宴可以邀请<font color='#0900d1'>全服玩家<font color='#3a2707'>参与,享用并获得奖励.\n"
                    + "3.玩家可在婚宴中可以进行<font color='#0900d1'>吃宴席<font color='#3a2707'>活动.\n"
                    + "4.趁着人多,快来开启今天的婚宴吧.\n"
                );
            })

            this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));
            this.btn1.addClickEventListener(this.OnReqOrder.bind(this));

            /// tab tableView
            var size = this.imgontent.getContentSize();
            var contentSize = cc.size(size.width, this.CELL_HEIGHT * 5)
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(ccui.ScrollView.DIR_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.reloadData();

            this.imgontent.addChild(tableView);
            this.tableView = tableView;
        },
        OnShow:function(){
            this._super()

            this.UpdateView()
            this.ReloadData()

            GameEventMgr.AddEventListener(this,new ResWeddinginfoToClientMessage().getId(),this.OnResWeddinginfoToClientMessage.bind(this))
            GameEventMgr.AddEventListener(this,new ResWeddingOrderSuccessToClientMessage().getId(),this.OnResWeddingOrderSuccessToClientMessage.bind(this))

            Mgr.wedding.SendReqWeddinginfoToGameMessage()

            ///定时刷新
            var interval = 300
            var date = Mgr.login.GetServerDate();
            this.$timer = TimerUtil.SetTimeout(this,function(){
                Mgr.wedding.SendReqWeddinginfoToGameMessage()
                this.$timer = TimerUtil.TimeUpdate(function(){
                    Mgr.wedding.SendReqWeddinginfoToGameMessage()
                },this ,interval ,cc.REPEAT_FOREVER )
            },(interval - (date.getMinutes()*60 + date.getSeconds())%interval + 1) * 1000)
        },
        OnHide:function(){
            this._super()

            GameEventMgr.RemoveEventListener(this);
            if(this.$timer) TimerUtil.ClearTimeUpdate(this.$timer)
        },
        OnReqOrder:function(){
            var data = this.data[this.$selectedIndex]
            var serverTime = Mgr.login.GetServerDate();

            switch(data.status){
                case 2:{
                    Mgr.tips.ShowNotice("该场次婚宴已经结束！");
                } return
                case 1:{
                    EngineMgr.uiMgr.HidePanel(this)
                    MarriageUtil.GoForHunyan()
               } return
            }

            var MW = Mgr.wedding.GetMyWeddingInfo()
            if(MW){
                Mgr.tips.ShowNotice("您或您的配偶已经预约了婚宴！");
                return
            }

            var p = Mgr.uiMgr.ShowPanelByType(HunYanPanelExt.PanelName);
            if(p) p.SetData(this.data[this.$selectedIndex].index)
            ///
            EngineMgr.uiMgr.HidePanel(this)
        },
        OnResWeddingOrderSuccessToClientMessage:function(){
            Mgr.wedding.SendReqWeddinginfoToGameMessage()
        },
        OnResWeddinginfoToClientMessage:function(){
            this.ReloadData()
        },

        OnTabSelected:function(index){
            var data = this.data[index]
            if(data.wedding){
                this.imgTiao.visible = true
                this.imgVsDi.visible = true

                UIUtil.ConnectLabelHtmlText(this.labName,[data.wedding.playerA])
                UIUtil.ConnectLabelHtmlText(this.labName1,[data.wedding.playerB])

                UIUtil.LoadImage(this.imgHead1, ResUrl.GetSmallPlayerHeadUrl(data.wedding.jobA),false,true);
                UIUtil.LoadImage(this.imgHead2, ResUrl.GetSmallPlayerHeadUrl(data.wedding.jobB),false,true);

                UIUtil.LoadImage(this.imgName,"other/hunyan/word/names/" + data.wedding.type + ".png",false,false,null,false);
            }else{
                this.imgTiao.visible = false
                this.imgVsDi.visible = false
            }

            switch(data.status){
                case 2:
                    Filter.GrayScale(this.btn1)
                    this.btn1.setTitleText("马上预约")
                    break
                case 1:
                    this.btn1.setTitleText("点击前往")
                    Filter.UnGray(this.btn1)
                    break
                default:
                     Filter.UnGray(this.btn1)
                    this.btn1.setTitleText("马上预约")
                    break
            }
        },
        ReloadData:function(){
            var globalC = Q_global.Get(20016)

            var data = JSON.parse(globalC.q_string_value)

            var serverTime = Mgr.login.GetServerDate();
            data = data.map(v=>v.map(vv=>{
                let t = new Date(serverTime)
                t.setHours(Math.floor(vv / 100))
                t.setMinutes(vv % 100)
                return t
            }))

            var weddingInfo = Mgr.wedding.GetWeddingInfo()
            data = data.map((v,k)=>{
                let index = k;
                let wedding = weddingInfo && weddingInfo.WeddingInfolist.find(v=>v.index == index + 1)

                let status = 0
                let sort = 0
                /// 过期
                if(v[1] < serverTime){
                    status = 2;
                    sort = 5;
                } else if(v[0] < serverTime){
                    /// 进行中
                    status = 1;
                    sort = wedding ? 1 : 5
                }else{
                    /// 没到时间
                    let MW = Mgr.wedding.GetMyWeddingInfo()
                    sort = wedding ?
                        ((MW && MW.marriageId.Equal(wedding .marriageId)) ? 0 : 4)
                        : 2;
                }

                return {
                    status : status,
                    sort : sort,
                    start : v[0],
                    end : v[1],
                    index : index,
                    wedding : wedding,
                }
            })

            data.sort(function(a,b){
                return a.sort - b.sort
            })

            this.data = data
            this.$selectedIndex = 0
            this.OnTabSelected(0)
            this.tableView.reloadData()
        },
        UpdateView:function(){
            var marriageInfo = Mgr.marriage.GetMarriageInfo()
            var MW = Mgr.wedding.GetMyWeddingInfo()

            UIUtil.ConnectLabelHtmlText(this.labName11,[MW ? 0 : 1])

            var globalC = Q_global.Get(20021)
            var arr = JSON.parse(globalC.q_string_value)

            var item = ItemUtil.ItemConfigToItem(arr[0]);
            GridUtil.SetItemGrid(this.grid1, item);
        },
        tableCellTouched: function(sender, cell) {
            var c = sender.cellAtIndex(this.$selectedIndex)
            if(c) c.SetSelected(false)

            cell.SetSelected(true)
            var index = cell.getIdx()
            this.$selectedIndex = index;
            this.OnTabSelected(index)
        },
        tableCellSizeForIndex:function(sender,index){
            return cc.size(sender.width,55);
        },
        tableCellAtIndex:function(sender,index){
            var cell = sender.dequeueCell();
            if (!cell) {
                cell = new Cell();
            }

            cell.SetData(this.data[index],index);
            cell.SetSelected(index == this.$selectedIndex);
            return cell;
        },

        numberOfCellsInTableView:function(sender){
            return this.data ? this.data.length : 0;
        },
    } );
})()
YuYuePanelExt.PanelName = "YuYuePanelExt";
PanelClassDic["YuYuePanelExt"] = YuYuePanelExt;
