var QiYuePanelExt = QiYuePanel.extend ( {
	_className:"QiYuePanelExt",
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
	},

	Init:function(){
		this._super();
		this.btnClose.addClickEventListener(()=>{
			Mgr.uiMgr.HidePanel(this);
		});

		this.btnZf.addClickEventListener(()=>{
			AlertExt.Show("是否花费888元宝，为你的挚爱购买一份七天的祝福？", TipsEnum.BUTTON_SURE_AND_FALSE, {
				_onFunc:function(){
					Mgr.marriage.SendReqBuyGiftMessage();
				},
			});
		});

		this.btnSend.addClickEventListener(()=>{
			var extraReqInfo = new ExtraReqInfo();
			extraReqInfo.targetPlayerName = Mgr.marriage.GetMarriageInfo().targetName;
			Mgr.chat.ReqChatRequestMessage(EnumChatChannelType.PRIVATE, "给我一份爱情契约嘛，么么哒", extraReqInfo);
			Mgr.tips.ShowNotice("已向对方撒娇！");
		});

		this.btnLq.addClickEventListener(()=>{
			Mgr.marriage.SendReqGetGiftMessage(this._curDay + 1);
		});

		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg3Con.width, this.imgBg3Con.height));
		list.setTouchEnabled(true);
		list.setScrollBarEnabled(false)
		list.setBounceEnabled(true);
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.setPosition(0,0);

		this.img4.x += 1;

		this.imgBg3Con.addChild(list);
		this._listView = list;

		for( let i = 0; i < 7; i++ ){
			this["sbtnDay" + ( i + 1 )].addClickEventListener(((i)=>{ return ()=>{ this.SetData(i)}})(i));
		}
		this._rewards = ItemUtil.ParseReward(Q_global.Get(20008).q_string_value);
		this._goldArr = [];
        var totalGold = 0;
        for( var m = 0; m < this._rewards.length; m++ ){
            var arr = this._rewards[m];
            for( var j = 0; j < arr.length; j++ ){
                var item = arr[j];
                if( item.itemModelId == 221 ){		//1元宝道具
                    totalGold += item.itemNum;
					this._goldArr.push( item.itemNum );
                }
				else if( m == this._rewards.length - 1 ){
					if( item.job && item.job != Mgr.mainPlayer.nJobId ){
						this.titleData = Mgr.title.GetTitleByItemId(item.itemModelId);
					}
				}
            }
        }
        UIUtil.ConnectLabelHtmlText( this.labDN1, [totalGold]);
	},

	OnShow:function(){
		this._super();
		Mgr.marriage.onGiftInfo.add( this.UpdateData, this );
		this.UpdateData();
		this.ShowTitle(true);
	},

	OnHide:function(){
		this._super();
		Mgr.marriage.onGiftInfo.remove( this.UpdateData, this );
		this.ShowTitle(false);
	},

	UpdateData:function(){
		this.UpdateRecord();
		var index = Math.min(Math.max(0, this.getDay), 6);
		this["sbtnDay" + ( index + 1 )].SetButtonState("check", true);
		this.SetData(index);
		this.btnSend.visible = Mgr.marriage.giftState < 0;
	},

	UpdateRecord:function(){
		this._listView.removeAllChildren();
		var arr = Mgr.marriage.giftRecord;
		var getTime = 0;
		for( var i = 0; i < arr.length; i++ ){
			var item = new GuMaiJiLuExt();
			item.LoadPanel();
			item.y = i*item.uiHeight;
			item.sbtnList.SetButtonState(i%2?"check":"uncheck");
			item.sbtnList.touchEnabled = false;
			var isSelf = arr[i].playerId.Equal(Mgr.player.mainPlayer.sid);
			if( !getTime && isSelf )
				getTime = arr[i].time;
			item.sbtnList.SetText(isSelf ? "伴侣为你购买了爱情契约" : "你为挚爱送上了七天祝福");
			this._listView.pushBackCustomItem(item);
		}

		if( getTime == 0 ){
			this.getDay = -1;
			return;
		}
		var date = Mgr.login.GetServerDate();
		var getDate = new Date();
		getDate.setFullYear(parseInt(getTime/10000));
		getDate.setMonth(parseInt(getTime/100)%100 - 1);
		getDate.setDate(getTime%100);
		getDate.setHours(0);
		getDate.setMinutes(0);
		getDate.setSeconds(0);
		this.getDay = Math.floor((date.getTime() - getDate.getTime()) / 86400000);
	},

	SetData:function(index){
		this._curDay = index;
		UIUtil.ConnectLabelHtmlText( this.labDN, [this._goldArr[index]]);
		UIUtil.ConnectLabelHtmlText( this.labDay, [index + 1]);
		var isGot = Mgr.marriage.giftState >> index & 0x1;
		(isGot || this.getDay < index ? Filter.GrayScale(this.btnLq) : Filter.UnGray(this.btnLq));
		this.btnLq.visible = !isGot;	//已领取隐藏按钮
	},

	ShowTitle:function(value){
		if( this.titleEff ){
			this.titleEff.Dispose();
			this.titleEff = null;
		}
		if( value ){
			var eff = EffectUtil.GetShowEffect(this.titleData.q_art, EffectUtil.ENUM_TYPE_UI, true ,-1);
			eff.x = 130;
			eff.y = 58;
			this.imgCh.addChild(eff);
			this.titleEff = eff;
		}
	}
} );
QiYuePanelExt.PanelName = "QiYuePanelExt";
PanelClassDic["QiYuePanelExt"] = QiYuePanelExt;
