var WorldBossFrameExt = WorldBossFrame.extend ( {
	_className:"WorldBossFrameExt",
	boss:null,
	ctor:function(){
		this._super();
	},
	Init:function(){
		WorldBossFrame.prototype.Init.call( this );
		this.setSwallowTouches(false);
	},
	SetData:function(idx)
	{
		var list=Mgr.monster.worldPublicBossList.Values();
		if(Mgr.monster.bossPanel.type==1)
		{
			list=Mgr.monster.worldBossList.Values();
		}
		if(list.length == 0)
		{
			return;
		}
		this.boss=list[idx];
        var boss = Q_monster.Get(list[idx].monsterModelId);
		var time=list[idx].status;
        var url="other/shijieboss/image/da/"+boss.q_head_resid + ".png";
		var Bg=this.imgModel;
		EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
			Bg.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
		}, Bg);
		if(time==0)
		{
			this.labTime.SetString("可击杀");
			Filter.UnGray(this.imgDikuang);
		}
        else if(time == -1){
            this.labTime.SetString("已击杀");
            Filter.GrayScale(this.imgDikuang);
        }
		else
		{
			this.labTime.SetString(TimeUtil.SecondToDHMS2(time));
			Filter.GrayScale(this.imgDikuang);
		}
		this.labName.SetString(boss.q_name+"Lv."+boss.q_grade);
	},
	UpdateTime:function()
	{
		var map=Mgr.monster.worldPublicBossList;
		if(Mgr.monster.bossPanel.type==1)
		{
			map=Mgr.monster.worldBossList;
		}
		if(map.Size() == 0)
		{
			return;
		}
		var boss = map.Get(this.boss.monsterModelId);
		var time=boss.status;
		if(time==0)
		{
			this.labTime.SetString("可击杀");
			Filter.UnGray(this.imgDikuang);
		}
        else if(time == -1){
            this.labTime.SetString("已击杀");
            Filter.GrayScale(this.imgDikuang);
        }
		else
		{
			this.labTime.SetString(TimeUtil.SecondToDHMS2(time));
			Filter.GrayScale(this.imgDikuang);
		}
	}
} );
WorldBossFrameExt.PanelName = "WorldBossFrameExt";
PanelClassDic["WorldBossFrameExt"] = WorldBossFrameExt;
