var WorldBossMainExt = WorldBossMain.extend ( {
	_className:"WorldBossMainExt",
	headView:null,
	lastOne:null,
	gridList:null,
	cellNum:0,
    isDianji:false,
	cellList:null,
	cCell:null,
    _curSelectItem:null,
	countY:375,
    modelView:null,
    timerId:null,
    prevuiousIdex:null,
	ctor:function(){
		this._super();
	},
	Init:function()
    {
		WorldBossMain.prototype.Init.call( this );
        this._InitProperty();
        this._InitGridList();
        this._HandleButton();
        this.imgModel.visible = false;
        this.imgTips.visible =false;
        this.labCue.setTouchEnabled(true);
        var self = this;
        this.labCue.addTouchEventListener(function(sender, type){
            if ( type == ccui.Widget.TOUCH_BEGAN )
            {
            }
            else if ( type == ccui.Widget.TOUCH_ENDED )
            {
                if(self.imgTips.visible)
                    self.imgTips.visible = false;
                else
                    self.imgTips.visible = true;
            }
            else if ( type == ccui.Widget.TOUCH_CANCELED )
            {
            }
        })
	},
    _InitProperty:function()
    {
        this.labJieshu.setVisible(false);
        this.setSwallowTouches(false);
        this.cellList=[];
        this.labName.x-=10;
        this.labLook.SetString("刷新提醒");
        this.imgBg2.setVisible(false);
        this.imgBg1.setVisible(true);
        //那些BOSS的头像_scrollview
        this.headView = new ccui.ScrollView();
        this.headView.setSize(480,400);
        this.headView.setScrollBarEnabled(false);
        this.headView.setBounceEnabled(true);
        this.headView.setPosition(16,20);
        // this.headView.addEventListener(this._SelectedItemEvent);
        this.imgBg.addChild(this.headView);

    },

    _SelectedItemEvent:function(sender, type){
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent.parent;
                if (parent._curSelectItem != null) {
                    parent._curSelectItem.sbtn2.SetButtonState("uncheck");
                    parent._curSelectItem = null;
                }


                var idx = sender.getCurSelectedIndex();
                var itemSelect = sender.getItem(idx);
                this.cIdx = idx;
                // parent.ChooseCell(idx);
                // itemSelect.SetSelect(true);
                parent._curSelectItem = itemSelect;
                parent._curSelectItem.sbtn2.SetButtonState("check");
                break;
            default:
                break;
        }
    },

    _InitGridList:function()
    {
        this.gridList=[this.gridItem];
        for(var i=1;i<8;++i)
        {
            this.gridList[i]=this.gridItem.Clone();
            this.gridList[i].x=i%4*92+this.gridItem.x;
            if(i<4)
            {
                this.gridList[i].y=this.gridItem.y;
            }
            else
            {
                this.gridList[i].y=this.gridItem.y-94;
            }
            this.imgBg11.addChild( this.gridList[i]);
            this.gridList[i].setTouchEnabled(true);
        }
        this.gridItem.setTouchEnabled(true);
    },
    _HandleButton:function()
    {
        var self=this;
        this.sbtnGouxuan.addClickEventListener(function()
        {
            var info=null;
            if(Mgr.monster.bossPanel.type==1)
            {
                info= Mgr.monster.worldBossList.Get(self._curSelectItem.boss.monsterModelId);
            }
            else
            {
                info=Mgr.monster.worldPublicBossList.Get(self._curSelectItem.boss.monsterModelId);
            }
            if(self.sbtnGouxuan.GetState()=="check")
            {
                Mgr.monster.concernBossList.Put(info.monsterModelId,info);
            }
            else
            {
                Mgr.monster.concernBossList.Remove(info.monsterModelId);
            }
            var value=Mgr.monster.concernBossList.Keys().join(",");
            Mgr.client.SendCustomMsg(EnumCustomMsgKey.BOSSCARE,value);
        });
        this.btnBox.addClickEventListener(function()
        {
            if(self.cellNum != 0)
            {
                self._ShowMonsterModel(false);
            }
        });
        this.btnBox1.addClickEventListener(function()
        {
            if(self.cellNum != 0 )
            {
                self._ShowMonsterModel(true);
            }
        });
    },
    _ShowMonsterModel:function(bool)
    {
        this.imgBg1.visible = bool;
        this.imgBg2.visible = !bool;
    },
	Update:function(){
        this.UpdateHead();
	},
	SetInfo:function () {
        // if(!this.cCell.boss)
        if(!this._curSelectItem.boss)
        {
            this.ChooseCell(0);
        }
        // var boss = this.cCell.boss;
        var boss =  this._curSelectItem.boss;
        if(Mgr.monster.concernBossList.Get(boss.monsterModelId))
        {
            this.sbtnGouxuan.SetButtonState("check");
        }
        else
        {
            this.sbtnGouxuan.SetButtonState("uncheck");
        }
        var q_monster = Q_monster.Get(boss.monsterModelId);
        this.labName.SetString(q_monster.q_name);
        var q_boos=Q_boss_world.Get(boss.monsterModelId);
        if(Mgr.mainPlayer.attributeData.level-q_monster.q_grade>Q_global.Get(1046).q_int_value)
        {
            this.labCue111.setVisible(true);
        }
        else
        {
            this.labCue111.setVisible(false);
        }

        // var url="模型路径"+q_boos.q_show_boss;           //有了再加
        // var Bg=this.imgModel;
        // EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
        //     Bg.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
        // }, Bg);
        var monsterDrb = Q_monster_dropprob.Get(boss.monsterModelId);
        if(monsterDrb)
        {
            var items = JSON.parse(Q_monster_dropprob.Get(boss.monsterModelId).q_drop_show);
            // items=items.split(";");
            for(var i=0;i<8;++i)
            {
                if(items[i])
                {
                    this.gridList[i].setVisible(true);
                    // cc.log("========"  + items[i].mod)
                    // var itemIcon = ItemUtil.GetItemIcon(items[i], 3);
                    // itemIcon.x = ( this.gridList[i].uiWidth - itemIcon.width) / 2;
                    // itemIcon.y = ( this.gridList[i].uiHeight - itemIcon.height) / 2;
                    // this.gridList[i].SetGridIcon(itemIcon);
                    // this.gridList[i].itemModel=items[i];
                    var coinInfo = {};
                    coinInfo.itemModelId = items[i].mod;
                    coinInfo.itemNum = items[i].num;
                    // coinInfo.itemBind = items[i].isbind;
                    GridUtil.SetItemGrid(this.gridList[i], coinInfo);
                }
                else
                {
                    this.gridList[i].setVisible(false);
                }
            }
        }
        Mgr.monster.bossPanel.boss=boss;
        // this.imgBg2.setVisible(false);
        // this.imgBg1.setVisible(true);
    },

    ShowModel:function(cell, showId){
	    if(!this.modelView){
            this.modelView = new MAnimationObject();
            this.imgBg1.addChild(this.modelView);
            this.modelView.setPosition(cc.p(this.imgModel.uiWidth/2 + this.imgModel.x, 53));
        }
        this.modelView.sCurActionName = null;
        var monster = Q_boss_world.Get(this._curSelectItem.boss.monsterModelId);
        this.modelView.sResUrlBase = "res/animation/monster/" + monster.q_show_boss;
        this.modelView.DoAction("stand", 4);
    },

	ChooseCell:function (idx) {
        if(this._curSelectItem){
            this._curSelectItem.sbtn2.SetButtonState("uncheck");
            this._curSelectItem.imgName.SetButtonState("uncheck");
            this._curSelectItem.btnRight.visible = false;
            this.prevuiousIdex = this.cIdx;
            this._curSelectItem = null;
        }
        this.cIdx=idx;
        this._curSelectItem = this.cellList[idx];
        this._curSelectItem.btnRight.visible = true;
        this._curSelectItem.sbtn2.SetButtonState("check");
        this._curSelectItem.imgName.SetButtonState("check");
        this.ShowModel();
		// for(var i=0;i<this.cellNum;++i){
         //    this.cellList[i].setVisible(true);
		// }
		// this.cCell.y=this.cellList[idx].y-8;
        // this.cCell.SetData(idx);
		// this.cellList[idx].setVisible(false);
		this.SetInfo();
    },
    UpdateHead:function () {
        if(Mgr.monster.bossPanel.type==1)
        {
			this.cellNum=Mgr.monster.worldBossList.Size();
		}
		else
        {
			this.cellNum=Mgr.monster.worldPublicBossList.Size();
		}
        for(var i=0;i<this.cellList.length;++i)
        {
            this.cellList[i].setVisible(false);
        }
        if(this.cellNum == 0)
        {
            this._ClearBaseData();
            return;
        }
        Mgr.monster.bossPanel.btnGo.visible = true;
        this._ShowMonsterModel(false);
        // this.cCell.visible = true;
		var countY=this.cellNum*120+280;
		this.countY=countY;
		this.headView.setInnerContainerSize(cc.size(480,countY));
        countY-=250;
        var self = this;
		for(var i=0;i<this.cellNum;++i)
        {
            var cell=this.cellList[i];
            if(!cell)
            {
                cell=new WorldBossFrame1Ext();
                cell.LoadPanel();
                cell.SetData(i);
                cell.y=countY;
                cell.x=-10;
                countY-=120;
                (function(i){
                    cell.addClickEventListener(function () {
                        self.scrollToIndex(i);
                    });
                })(i);
                this.headView.addChild(cell);
                this.cellList[i]=cell;
            }
            cell.SetData(i);
            cell.setVisible(true);
		}
        var self = this;
        this.headView.addCCSEventListener(function (sender, type) {
            switch(type){
                case ccui.ScrollView.EVENT_CONTAINER_MOVED:
                    self.UpdateScroll();
                    break;
                case ccui.ScrollView.EVENT_AUTOSCROLL_ENDED:
                    self.prevuiousIdex = self.cIdx;
                    break;
            }
        });
        this.ChooseCell(0);
    },
    _ClearBaseData:function()
    {
        // this.cCell.visible = false;
        this.labName.SetString("");
        // Mgr.monster.bossPanel.labCue.SetString("");
        this.imgBg1.visible = false;
        this.imgBg2.visible = false;
        // Mgr.monster.bossPanel.btnGo.visible = false;
    },
    scrollToIndex:function (idx) {
		var pp=this.countY-400;  //extra size
        if(!this.cellList[idx])
        {
            this.cellList[idx] = this.cellList[0];
        }
		var y=this.countY-this.cellList[idx].y-250;  //bottom size   180 is distance to top
		var prent=y/pp;
        this.headView.scrollToPercentVertical(prent*100,0.5,true);
    },
	OnFrame:function(){
		// this.cCell.UpdateTime();
        // this.cCell._curSelectItem();
		for(var i=0;i<this.cellNum;++i){
			var cell=this.cellList[i];
			cell.UpdateTime(i);
		}
	},
    UpdateScroll:function () {
		for(var i=0;i<this.cellNum;++i)
        {
			var pos=this.cellList[i].getWorldPosition();
			if(pos.y>250&&pos.y<355)
            {
				if(this.cIdx!=i)
                {
                    this.ChooseCell(i);
                }
				break;
			}
		}
    },
    OnHide:function () {
        // TimerUtil.ClearTimeUpdate(this.timerId,this);
    },
    OnShow:function () {
        // this.timerId = TimerUtil.TimeUpdate(this.UpdateScroll,this,0.2);
    }
} );
WorldBossMainExt.PanelName = "WorldBossMainExt";
PanelClassDic["WorldBossMainExt"] = WorldBossMainExt;
