var WorldBossPanelExt = WorldBossPanel.extend ( {
	_className:"WorldBossPanelExt",
	modelPanelType:MUIPanelModelType.BLUR,
	isShowTween:true,
	bossList:null,
	boss:null,
	type:1,                  //1本服 2 跨服
	cPanel:null,

	erenguPanel:null,
    vip4ErenguPanel:null,
    vip10ErenguPanel:null,
	zhujiantianxiaPanel:null,

    num:0,

    btnInfo:null,

    curShowPanel:null,
    panelList:null,
    showType:null,
    panelMgr:null,

	selcetPanel:null,
    btnList:null,

	ctor:function(){
		this._super();
		Mgr.monster.bossPanel=this;
		this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -27;
        this.panelMgr = [];
        this.btnInfo = [];
	},
	Init:function(){
		WorldBossPanel.prototype.Init.call( this );
        // this.labCue1.visible=false;
        this.btnList = [this.sbtnWordboss, this.sbtnJindi, this.sbtnJilu, this.sbtnBosshome, this.sbtnErengu, this.sbtnZhujiantianxia];
        this.btnInfo = [{btn:this.sbtnWordboss, type:BosssPanelType.WORLDBOSS},
                        // {btn:this.sbtnErengu, type:BosssPanelType.WORLDBOSS},
                        {btn:this.sbtnErengu1, type:BosssPanelType.VIP4ERENGU},
                        {btn:this.sbtnErengu2, type:BosssPanelType.VIP10ERENGU},
                        {btn:this.sbtnZhujiantianxia, type:BosssPanelType.ZHUJIANTIANXIA},
                        ];
		this._InitProperty();
		this._HandleButton();
        this.imgBg.setTouchEnabled(false);
	},
	_InitProperty:function()
	{
		this.sbtnBosshome.buttonText.SetString("跨服BOSS");
        this.sbtnZhujiantianxia.setPosition(this.sbtnErengu1.getPosition());
		this.sbtnErengu1.setPosition(this.sbtnBosshome.getPosition());
        this.sbtnErengu2.setPosition(this.sbtnErengu.getPosition());
        this.imglabNum.SetString(4);
        this.imglabNum1.SetString(7);
        this.removeChild(this.sbtnErengu);
		this.removeChild(this.sbtnJindi);
		this.removeChild(this.sbtnJilu);
		this.removeChild(this.sbtnBosshome);

		this.ChangePanel(BosssPanelType.WORLDBOSS);
	},
	_HandleButton:function()
	{
		var self=this;
		this.btnClose.addClickEventListener(function(){
			EngineMgr.uiMgr.HidePanelByType( WorldBossPanelExt.PanelName );
		});
		this.btnGo.addClickEventListener(function(){
			if(!self.boss && self.showType == BosssPanelType.WORLDBOSS){
				return;
			}
			else if(!self.boss && (self.showType == BosssPanelType.ERENGU ||self.showType == BosssPanelType.ZHUJIANTIANXIA)){
                Mgr.tips.ShowNotice("活动未开启");
                // return;
			}
            switch(self.showType){
                case BosssPanelType.WORLDBOSS:// 世界·boss
                    var config = Q_boss_world.Get(self.boss.monsterModelId);
                    if (config) {
                        var gridpt = new cc.p(config.q_appear_x, config.q_appear_y);
                        Mgr.map.SendReqGoldMapTransMessage(config.q_appear_map);
                        Mgr.mainPlayer.oCtrlAutoPath.targetMapId = config.q_appear_map;
                        Mgr.mainPlayer.oCtrlAutoPath.targetPos = gridpt;
                        Mgr.mainPlayer.oCtrlAutoPath.autoMapParam = AutoPathParam.CreateAutoFight();
                        // Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(config.q_appear_map, gridpt, AutoPathParam.CreateAutoFight());
                    }
                    Mgr.monster.curWorldBossInfo = self.boss;
                    EngineMgr.uiMgr.HidePanelByType( WorldBossPanelExt.PanelName );
                    break;
                case BosssPanelType.ERENGU:// 旧恶人谷
                    // Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(1006, cc.p(44,20));
                    var activeInfo = Mgr.majorevents.activityHash.Get(EnumZoneActiveType.TYPE_ERENGU);
                    if(activeInfo && activeInfo.status == 1){
                        Mgr.zone.SendReqZoneEnterToGameMessage(16001);
                        EngineMgr.uiMgr.HidePanelByType( WorldBossPanelExt.PanelName );
                    }
                    else
                        Mgr.tips.ShowNotice("活动未开启");
                    break;
                case BosssPanelType.ZHUJIANTIANXIA:// 逐渐天下
                    var activeInfo = Mgr.majorevents.activityHash.Get(EnumZoneActiveType.TYPE_ZHUJIANTIANXIA);
                    if(activeInfo && activeInfo.status == 1){
                        // Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(1003, cc.p(56,96));
                        Mgr.map.SendReqGoldMapTransMessage(1003);
                        EngineMgr.uiMgr.HidePanelByType( WorldBossPanelExt.PanelName );
                    }
                    else
                        Mgr.tips.ShowNotice("活动未开启");
                    break;
                case BosssPanelType.VIP4ERENGU:// vip4 恶人谷
                    Mgr.map.SendReqGoldMapTransMessage(50001);
                    EngineMgr.uiMgr.HidePanelByType( WorldBossPanelExt.PanelName );
                    break;
                case BosssPanelType.VIP10ERENGU:// vip10 恶人谷
                    Mgr.map.SendReqGoldMapTransMessage(50002);
                    EngineMgr.uiMgr.HidePanelByType( WorldBossPanelExt.PanelName );
                    break;
            }
		});

		// this.sbtnWordboss.addClickEventListener(this.ShowWoldBoss.bind(this));
		// this.sbtnBosshome.addClickEventListener(function(){
         //    self.cPanel.visible = true;
         //    if(self.zhujiantianxiaPanel)
         //        self.zhujiantianxiaPanel.visible = false;
         //    if(self.erenguPanel)
         //        self.erenguPanel.visible = false;
         //    self.labCue.visible = true;
		// 	self.type=2;
		// 	self.boss=null;
		// 	self.labCue.SetString("跨服BOSS挑战不受限制");
		// 	self.labCue1.visible=false;
		// 	self.cPanel.Update();
		// });

        // this.sbtnErengu.addClickEventListener(this.ShowErengu.bind(this));
        // this.sbtnErengu1.addClickEventListener(this.ShowVip4Erengu.bind(this));
        // this.sbtnErengu2.addClickEventListener(this.ShowVip10Erengu.bind(this));
        // this.sbtnZhujiantianxia.addClickEventListener(this.ShowZhujian.bind(this));

        var self = this;
        for(var i = 0; i < this.btnInfo.length; i++){
            (function(i){
                self.btnInfo[i].btn.addClickEventListener(function () {
                    self.ChangePanel(self.btnInfo[i].type);
                });
            })(i);
        }
	},

    ChangePanel:function(type){
	    // cc.log("=====ChangePanel=========" + type)
        if(this.showPanel){
            this.showPanel.visible = false;
            this.showPanel.OnHide();
            // this.removeChild(this.showPanel);
            this.showPanel = null;
        }

        switch(type){
            case BosssPanelType.WORLDBOSS:// 世界·boss
                if(!this.panelMgr[type]){
                    var panel = new WorldBossMainExt();
                    panel.LoadPanel();
                    panel.OnShow();
                    this.imgBg.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                UIUtil.ConnectLabelHtmlText(this.panelMgr[type].labCue1111,[Mgr.monster.killBossNum, Q_global.Get(1156).q_int_value]);
                break;
            case BosssPanelType.ERENGU:// 旧恶人谷
                if(!this.panelMgr[type]){
                    var panel = new ERenGuMainExt();
                    panel.LoadPanel();
                    panel.OnShow();
                    this.imgBg.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                break;
            case BosssPanelType.ZHUJIANTIANXIA:// 逐渐天下
                if(!this.panelMgr[type]){
                    var panel = new ZhuJianTianXiaMainExt();
                    panel.LoadPanel();
                    panel.OnShow();
                    this.imgBg.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                break;
            case BosssPanelType.VIP4ERENGU:// vip4 恶人谷
                if(!this.panelMgr[type]){
                    var panel = new ErenguBossMainExt(4);
                    panel.LoadPanel();
                    panel.OnShow();
                    this.imgBg.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                break;
            case BosssPanelType.VIP10ERENGU:// vip10 恶人谷
                if(!this.panelMgr[type]){
                    var panel = new ErenguBossMainExt(7);
                    panel.LoadPanel();
                    panel.OnShow();
                    this.imgBg.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                break;
        }

        this.showType = type;
        this.showPanel = this.panelMgr[type];
        if(this.showPanel)
            this.showPanel.visible = true;
    },

    ShowWoldBoss:function(){
        this.cPanel.visible = true;
        if(this.zhujiantianxiaPanel)
            this.zhujiantianxiaPanel.visible = false;
        if(this.erenguPanel)
            this.erenguPanel.visible = false;
        if(this.vip4ErenguPanel)
            this.vip4ErenguPanel.visible = false;
        if(this.vip10ErenguPanel)
            this.vip10ErenguPanel.visible = false;
        this.labCue.visible = true;
        this.type=1;
        this.boss=null;
        this.labCue.SetString("本服 BOSS 每日可挑战三次，每日凌晨 5 点重置");
        this.labCue1.visible=true;
        this.labCue2.visible=true;
        this.cPanel.Update();
        this.selcetPanel = this.cPanel;
        this.SetButtonState(this.sbtnWordboss);
    },

    ShowErengu:function(){
        this.type=3;
        this.boss=null;
        // this.labCue.SetString("跨服BOSS挑战不受限制");
        this.labCue1.visible=false;
        this.labCue2.visible=false;
        this.labCue.visible = false;
        // self.cPanel.Update();
        if(!this.erenguPanel){
            this.erenguPanel = new ERenGuMainExt();
            this.erenguPanel.LoadPanel();
            this.imgBg.addChild(this.erenguPanel);
        }
        this.erenguPanel.OnShow();
        this.cPanel.visible = false;
        if(this.zhujiantianxiaPanel)
            this.zhujiantianxiaPanel.visible = false;
        this.erenguPanel.visible = true;
        this.selcetPanel = this.erenguPanel;
        this.SetButtonState(this.sbtnErengu);
    },

    ShowVip4Erengu:function(){
        this.type=5;
        this.boss=null;
        this.labCue1.visible=false;
        this.labCue2.visible=false;
        this.labCue.visible = false;
        // self.cPanel.Update();
        if(!this.vip4ErenguPanel){
            this.vip4ErenguPanel = new ErenguBossMainExt(4);
            this.vip4ErenguPanel.LoadPanel();
            this.imgBg.addChild(this.vip4ErenguPanel);
        }
        this.vip4ErenguPanel.OnShow();
        this.cPanel.visible = false;
        if(this.zhujiantianxiaPanel)
            this.zhujiantianxiaPanel.visible = false;
        if(this.vip10ErenguPanel)
            this.vip10ErenguPanel.visible = false;
        this.vip4ErenguPanel.visible = true;
        this.selcetPanel = this.vip4ErenguPanel;
        this.SetButtonState(this.sbtnErengu1);
    },

    ShowVip10Erengu:function(){
        this.type=6;
        this.boss=null;
        this.labCue1.visible=false;
        this.labCue2.visible=false;
        this.labCue.visible = false;
        // self.cPanel.Update();
        if(!this.vip10ErenguPanel){
            this.vip10ErenguPanel = new ErenguBossMainExt(10);
            this.vip10ErenguPanel.LoadPanel();
            this.imgBg.addChild(this.vip10ErenguPanel);
        }
        this.vip10ErenguPanel.OnShow();
        this.cPanel.visible = false;
        if(this.zhujiantianxiaPanel)
            this.zhujiantianxiaPanel.visible = false;
        if(this.vip4ErenguPanel)
            this.vip4ErenguPanel.visible = false;
        this.vip10ErenguPanel.visible = true;
        this.selcetPanel = this.vip10ErenguPanel;
        this.SetButtonState(this.sbtnErengu2);
    },

    ShowZhujianShowZhujian:function(){
        this.type=4;
        this.boss=null;
        // self.labCue.SetString("跨服BOSS挑战不受限制");
        this.labCue1.visible = false;
        this.labCue2.visible=false;
        this.labCue.visible = false;
        // self.cPanel.Update();
        if(!this.zhujiantianxiaPanel){
            this.zhujiantianxiaPanel = new ZhuJianTianXiaMainExt();
            this.zhujiantianxiaPanel.LoadPanel();
            this.imgBg.addChild(this.zhujiantianxiaPanel);
        }
        this.cPanel.visible = false;
        if(this.erenguPanel)
            this.erenguPanel.visible = false;
        if(this.vip4ErenguPanel)
            this.vip4ErenguPanel.visible = false;
        if(this.vip10ErenguPanel)
            this.vip10ErenguPanel.visible = false;
        this.zhujiantianxiaPanel.visible = true;
        this.selcetPanel = this.zhujiantianxiaPanel;
        this.SetButtonState(this.sbtnZhujiantianxia);
    },

    SetButtonState:function (btn) {
        for(var i = 0, len = this.btnList.length; i < len; i++){
            var button = this.btnList[i];
            if(btn == button){
                button.SetButtonState("check");
            }else {
                button.SetButtonState("uncheck");
            }
        }
    },

    SetNum:function (num) {
	    this.num = num;
	    if(this.panelMgr[BosssPanelType.WORLDBOSS])
            UIUtil.ConnectLabelHtmlText(this.panelMgr[BosssPanelType.WORLDBOSS].labCue1111,[num, Q_global.Get(1156).q_int_value]);
    },

	OnShow:function(){
		this.boss=null;
        // if(this.type == 1){
        //     this.ShowWoldBoss();
        //     Mgr.monster.showType = 0;
        // }
        // else if(this.type == 3){
        //     this.ShowErengu();
        //     Mgr.monster.showType = 0;
        // }
        // else if(this.type == 4){
        //     this.ShowZhujian();
        //     Mgr.monster.showType = 0;
        // }
        // else if(this.type == 5){
        //     this.ShowVip4Erengu();
        //     Mgr.monster.showType = 0;
        // }
        // else if(this.type == 6){
        //     this.ShowVip10Erengu();
        //     Mgr.monster.showType = 0;
        // }
        Mgr.monster.SendReqQueryBossListMessage(0);
        if(this.showPanel.Update)
            this.showPanel.Update();
        this.showPanel.OnShow();
	},
	OnHide:function () {
        this.showPanel.OnHide();
    }
} );
WorldBossPanelExt.PanelName = "WorldBossPanelExt";
PanelClassDic["WorldBossPanelExt"] = WorldBossPanelExt;
