var PlayerPanelExt = PlayerPanel.extend ( {
	_className:"PlayerPanelExt",
	_reslineType:0,
	_equipPanel:null,
	zanjiaPanel:null,
	shenbingPanel:null,
	_btnArr:null,
	_btnPosArr:null,
	_btnTextArr:[],
	_titleArr:[],
	_currentPanel:null,
	_reslinePanelDic:[],
	normalColor:"0xDED8C7",
	selectedColor:"0xFFFFFF",
	_btnStates:[ MUICheckBox.STATE_CHECK , MUICheckBox.STATE_UNCHECK],
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = 10;
		this._equipGetExt = null;

        /// 注册新功能开放监听
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_PLAYER);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_ARMOR);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_RIDE);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_GUANGWU);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_DRAGON);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_WUXUE);
        // BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_SHNEBING);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_JINJIE,BtnGroupUtil.JINJIE_HOURSE);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_JINJIE,BtnGroupUtil.JINJIE_GUANGWU);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_JINJIE,BtnGroupUtil.JINJIE_FAQI);

        // BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_SHUTONG,BtnGroupUtil.SHUTONG_JIANGQIAO);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_SHUTONG,BtnGroupUtil.SHUTONG_JIAOYING);
	},
	Init:function(){
		var self = this;
		PlayerPanel.prototype.Init.call( this );
		this._reslineType = -1;
		this.imgWarn.visible = false;
		this.SetPendantMovie(this.imgGuajian);
		this._SetBaseProperty();
		this.btnClose.addClickEventListener(function (event){
			Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataRoleWarn();
			// 弹出祝福面板
			if ( Mgr.resline._CheckZhuFu(self._reslineType) ) {
				Mgr.uiMgr.ShowPanelByType( ZhufuzhiInfoExt.PanelName ).SetData(self._reslineType, function () {
					EngineMgr.uiMgr.HidePanel( self );
					if(self._equipGetExt)
					{
						self._equipGetExt.visible = false;
					}
				});
			}
			else {
				EngineMgr.uiMgr.HidePanel( self );
				if(self._equipGetExt)
				{
					self._equipGetExt.visible = false;
				}
			}
		});
		this.UpdataWarn();
	},
	OnHide:function()
	{
		this._super();
		if( this._currentPanel ){
			this._currentPanel.OnHide();
			this._currentPanel.visible = false;
		}
	},
	_SetBaseProperty:function()
	{
		this.imgTitleSt.visible = false;
		this.sbtnShenbing.visible = false;
		this.sbtnJianling.visible = false;
		this.sbtnJianzhao.visible = false;
		this.imgJianling.visible = false;
		this.imgJianzhao.visible = false;

        // this._titleArr = [this.imgRole,this.imgGuangyu,this.imgZuoqi,this.imgFaqi,this.imgGuangwu,this.imgWuxve,this.imgTitleSt, this.imgJiaoyin];
        // this._btnTextArr = [this.labRole,this.labGuangyu,this.labZuoqi,this.labFaqi,this.labGuangwu, this.labWuxve, this.labShenbing, this.labJiaoyin];
        this._titleArr = [this.imgRole,this.imgGuangyu,this.imgZuoqi,this.imgFaqi,this.imgGuangwu,this.imgWuxve,this.imgJiaoyin];
        this._btnTextArr = [this.labRole,this.labGuangyu,this.labZuoqi,this.labFaqi,this.labGuangwu, this.labWuxve, this.labJiaoyin];
		this._btnPosArr = [
			this.sbtnRole.getPosition(),
			this.sbtnGuangyu.getPosition(),
			this.sbtnZuoqi.getPosition(),
			this.sbtnFaqi.getPosition(),
			this.sbtnGuangwu.getPosition(),
            this.sbtnWuxve.getPosition(),
            this.sbtnShenbing.getPosition(),
            this.sbtnJiaoyin.getPosition(),
			// this.sbtnJianling.getPosition(),
            // this.sbtnJianzhao.getPosition(),
		];
		this._btnArr = [
			{type:-1, btn:this.sbtnRole},
			{type:0, btn:this.sbtnGuangyu},
			{type:EnumResline.HORSE, btn:this.sbtnZuoqi},
			{type:EnumResline.DRAGON, btn:this.sbtnFaqi},
			{type:EnumResline.GUANGWU, btn:this.sbtnGuangwu},
            {type:EnumResline.WUXUE, btn:this.sbtnWuxve},
            {type:EnumResline.STEP, btn:this.sbtnJiaoyin},
		];
		for (var i = 0; i < this._btnArr.length; i++ )
		{
			var self = this;
			this._btnArr[i].btn.type = this._btnArr[i].type;
			this._btnArr[i].btn.addTouchEventListener(function(target,state)
			{
				if(state == ccui.Widget.TOUCH_ENDED)
				{
					if ( Mgr.resline._CheckZhuFu(self._reslineType) ) {    // 弹出祝福面板
						Mgr.uiMgr.ShowPanelByType( ZhufuzhiInfoExt.PanelName ).SetData(self._reslineType, function () {
							self.ChangePage(target.type);
						});
					}
					else
						self.ChangePage(target.type);
				}
			});
			if ( this._btnArr[i].btn.parent ) {
				this._btnArr[i].btn.retain();
				this._btnArr[i].btn.removeFromParent();
			}
		}
	},

	ChangePage:function(reslineType)
	{
        this.imgTitleSt.visible = false;
		if( reslineType == this._reslineType )
			return;
		
		for (var i = 0; i < this._btnArr.length; i++ )
		{
			if(this._btnArr[i].type == reslineType)
			{
				this._btnArr[i].btn.SetButtonState("check");
				this._btnTextArr[i].SetColor(EnumFontFormat.COMMON_COLOR01);
				this._titleArr[i].visible = true;
			}
			else
			{
				this._btnArr[i].btn.SetButtonState("uncheck");
				this._btnTextArr[i].SetColor(EnumFontFormat.COMMON_COLOR06);
				this._titleArr[i].visible = false;
			}
		}

		if( this._currentPanel ){
			this._currentPanel.visible = false;
			this._currentPanel.OnHide();
		}
		this._reslineType = reslineType;
		switch (reslineType)
		{
			case -1://角色
			{
				this._ShowEquipInfo();
				this._currentPanel = this._equipPanel;
				break;
			}
			case 0://战甲
			{
				this.ShowZanjiaInfo();
				this._currentPanel = this.zanjiaPanel;
				break;
			}
            case -2://神兵
            {
                this.ShowShenBing();
                this._currentPanel = this.shenbingPanel;
                break;
            }
			default :
			{
				this._ShowResline(reslineType);
				this._currentPanel = this._reslinePanelDic[reslineType];
				break;
			}
		}
		this._currentPanel.OnShow();
		this._currentPanel.visible = true;
	},
	IsResline:function( value ){
		return this._reslineType == value;
	},

	_ShowEquipInfo:function (){
		if(this._equipPanel == null){
			this._equipPanel = new EquipPanelExt();
			this._equipPanel.LoadPanel();
			this._equipPanel.retain();
			this._equipPanel.x = 0;
			this._equipPanel.y = 0;
			this.imgBg.addChild( this._equipPanel );
		}
	},
	ShowZanjiaInfo:function (){
		if(this.zanjiaPanel == null){
			this.zanjiaPanel = new ZhanjiaMainExt();
			this.zanjiaPanel.LoadPanel();
			this.zanjiaPanel.retain();
			this.imgBg.addChild( this.zanjiaPanel );
		}
	},
	ShowShenBing:function(){
		if(this.shenbingPanel == null){
			this.shenbingPanel = new ShenBingMainExt();
			this.shenbingPanel.LoadPanel();
            this.imgBg.addChild( this.shenbingPanel );
		}
        this.shenbingPanel.OnShow();
	},
	_ShowResline:function ( index ){
		if( this._reslinePanelDic[index] == null ){
			var reslinepanel = new RidePanelExt();
			reslinepanel.InitReslineType(index);
			reslinepanel.LoadPanel();
			reslinepanel.retain();
			reslinepanel.x = 0;
			reslinepanel.y = 0;
			this._reslinePanelDic[index] = reslinepanel;
			this.imgBg.addChild( this._reslinePanelDic[index] );
		}
	},

	OnNewFuncOpened:function(main,sub){
        this._ReposBtns();
    },
    OnNewFuncOpenedAndChangePanel:function(main,sub){
        if(!main || ! sub) return;
        var type = -2;
        switch(main){
            case BtnGroupUtil.M_ROLE:
                switch(sub){
                    case BtnGroupUtil.ROLE_PLAYER: type = -1;break;
                    case BtnGroupUtil.ROLE_ARMOR:  type = 0;break;
                    case BtnGroupUtil.ROLE_RIDE: type = EnumResline.HORSE;break;
                    case BtnGroupUtil.ROLE_GUANGWU: type = EnumResline.GUANGWU;break;
                    case BtnGroupUtil.ROLE_DRAGON: type = EnumResline.DRAGON;break;
                    case BtnGroupUtil.ROLE_WUXUE: type = EnumResline.WUXUE;break;
                    case BtnGroupUtil.ROLE_SHNEBING: type = -2;
                    Mgr.godarm.SendReqGodArmDataInfoToGameMessage(0);
                    break;
                }
                break;
            case BtnGroupUtil.M_JINJIE:
                switch(sub){
                    case BtnGroupUtil.JINJIE_HOURSE: type = EnumResline.HORSE;break;
                    case BtnGroupUtil.JINJIE_GUANGWU: type = EnumResline.GUANGWU;break;
                    case BtnGroupUtil.JINJIE_FAQI: type = EnumResline.DRAGON;break;
                }
                break;
            case BtnGroupUtil.M_SHUTONG:
                switch(sub){
                    // case BtnGroupUtil.SHUTONG_JIANGQIAO: type = EnumResline.SCABBARD;break;
                    case BtnGroupUtil.SHUTONG_JIAOYING: type = EnumResline.STEP;break;
                }
                break;
        }
        if(type == -2) return;
        this.ChangePage(type);
    },

	_RepanelType:function (showType,openTyps) {
		var type = null;
		if ( openTyps.length == 0 )
			return type;

		for ( var i = 0; i != openTyps.length; i++ ) {
			if ( openTyps[i] == showType ){
				type = showType;
				break;
			}
		}
		if ( type == null ) {
			type = openTyps[0];
		}
		return type;
	},

	/**按钮重排*/
	_ReposBtns:function(){
		var buttons = [];
		var types = [];
		for (var i = 0; i < this._btnArr.length; i++ ) {
			var type = this._btnArr[i].type;
			// 移除
			if ( this._btnArr[i].btn.parent )
				this._btnArr[i].btn.removeFromParent();

			var main = type <= 0 ? BtnGroupUtil.M_ROLE : BtnGroupUtil.M_JINJIE;
			var sub;
			if ( type == -1 )
				sub = BtnGroupUtil.ROLE_PLAYER;
			else if ( type == 0 )
				sub = BtnGroupUtil.ROLE_ARMOR;
			else if ( type == EnumResline.HORSE )
				sub = BtnGroupUtil.JINJIE_HOURSE;
			else if ( type == EnumResline.GUANGWU )
				sub = BtnGroupUtil.JINJIE_GUANGWU;
			else if ( type == EnumResline.DRAGON )
				sub = BtnGroupUtil.JINJIE_FAQI;
            else if ( type == EnumResline.WUXUE ){
                main = BtnGroupUtil.M_ROLE;
                sub = BtnGroupUtil.ROLE_WUXUE;
			}
            else if ( type == EnumResline.STEP ){
                main = BtnGroupUtil.M_SHUTONG;
                sub = BtnGroupUtil.SHUTONG_JIAOYING;
            }

            if (BtnGroupUtil.IsFunctionOpen(main, sub))
			{
			 	buttons.push(this._btnArr[i].btn);
				types.push(this._btnArr[i].type);
			}
		}
		for (var i = 0; i < buttons.length; i++ ) {
			buttons[i].setPosition(this._btnPosArr[i]);
			this.addChild(buttons[i]);
		}
		return types;
	},
	OnShow:function(){
		var list = this._ReposBtns();
		this._reslineType = this._RepanelType(this._reslineType, list);
		if ( this._reslineType == null ) {
			Mgr.tips.ShowNotice("没有开放功能");
			return;
		}
		this._reslineType = -2;
		this.ChangePage(-1);
        this.UpdataWarn();
	},

	UpdataWarn:function (type) {
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			var _type = this._btnArr[i].type;
			var _button = this._btnArr[i].btn;
			if ( type == undefined ||  _type == type ) {
				// main
				this.SetButtonWarn(_button, Mgr.player.IsMarkBySubType( _type ));

				// sub
				var page = this._reslinePanelDic[_type];
				if ( page && page.visible && page.UpdataWarn )
					page.UpdataWarn();
			}
		}
	},

	SetButtonWarn:function ( widget, warn ) {
		if ( !widget.warn ) {
			var icon = new MUIImage();
			icon.ParseJson(this.imgWarn.jsonobj);
			icon.Init();
			icon.setPosition(this.imgWarn.getPosition());
			widget.addChild(icon);
			widget.warn = icon
		}
		widget.warn.visible = warn;
	},
} );
PlayerPanelExt.PanelName = "PlayerPanelExt";
PanelClassDic["PlayerPanelExt"] = PlayerPanelExt;
