var RidePanelExt = RidePanel.extend ( {
	_className:"RidePanelExt",
	_buyPanelAdvice:{},
	_reslineType:0,
	_mgr:null,
	_starVec:null,
	_upPanelX:0,
	_upPanelY:0,
	_gridVec:null,

	_uiModel:null,
	_jiaoyinModel:null, // 脚印单独处理
    sSteepEffs:null,
	_timerId:-1,
	_movetime:0,

	_isAutoBuyItem:false,
	_needItemNum:0,
	_needItemID:0,
	_needBuyIds:{},
	_hasNum:0,

	_timerUpdateId:0,

	_psyMid:0,
	_modelID:0,

	_visible:null,

	_timerNum:0,
	_restTime:0,

	_timerNum1:-1,
	_actionTarget01:null,
	_actionTarget02:null,
	ctor:function(){
		this._super();
		this._visible = true;
		this.sSteepEffs = [];
	},
	InitReslineType:function( value ){
		this._reslineType = value;

		this._mgr = Mgr.resline.GetMgrByType(value);
		this._mgr.SetPanel( this );

		// MCUtil.removeSelf(imgStar1);
		this._starVec = new Array();

		this._upPanelX = this.uiWidth;
		this._upPanelY = 0;

		// removeTips = new ReslineSkillTips();
		// gridBtnVec = Vector.<TextButton>([ btnkaiqi1, btnkaiqi2, btnkaiqi3, btnkaiqi4, btnkaiqi5, btnkaiqi6, btnkaiqi7, btnkaiqi8, btnkaiqi9, btnkaiqi10 ]);
		// _zhufuzhiTips = new GeneralSystemZhuFuZHiTips();
	},
	Init:function(){

		this._super();
		this.btnQuxiao.visible = false;
		this.imgLock.visible = false;
		this.labLevel.visible = false;

		this.labAttack.visible = false;
		this.labDef.visible = false;
		this.labHp.visible = false;
		this.labNumber.visible = false;
		this.imgUpAttr.visible = false;
		this.imgTeampAttr.visible = false;
        this.labEquipName.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
        this.labEquipName1.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
		//remove
		//this.imgBg2.removeChild(this.labMoney);
		this.gridEquip.removeChild(this.labJihuo);
		this.btnUp.removeFromParent();

        this.gridEquip5.InitGrid(GridTypeEnum.EQUIPWARED);
        this.gridEquip6.InitGrid(GridTypeEnum.EQUIPWARED);
        this.gridEquip7.InitGrid(GridTypeEnum.EQUIPWARED);
        this.gridEquip8.InitGrid(GridTypeEnum.EQUIPWARED);

		this.warnList = [this.img1, this.img11, this.img111, this.img1111];
		for(var i = 0; i < this.warnList.length; i++){
			this.warnList[i].setLocalZOrder(105);
			this.warnList[i].setVisible(false);
		}

		//根据type设置对应资源线显示
		// imgRuMoQianNengDan.background.setImage( UIUtil.getAsynBitmapNew( mgr.getfluctuateUrl(), imgRuMoQianNengDan.background ) as GuiBitmap );
		// imgRuMoHuanHuaDan.background.setImage( UIUtil.getAsynBitmapNew( mgr.getPotentialUrl(), imgRuMoHuanHuaDan.background ) as GuiBitmap );
		switch( this._reslineType )
		{
			case EnumResline.GIANT:
				break;
			case EnumResline.TATTOO:
				// this.sbtnHide.visible = false;
				// UIUtil.setBackgroundComnent( imgSkill.background, "other/resline/skillname/" + _reslineType.toString() + "/skillname.png" );
				break;
			default:
				// UIUtil.setBackgroundComnent( imgSkill.background, "other/resline/skillname/" + _reslineType.toString() + "/skillname.png" );
				break;
		}

		this.RegisterListeners();
	},
	RegisterListeners:function(){
		//reg
		var self = this;
		this.btnGo.addClickEventListener( function(e){
			self._reqStageUp();
		} );
		this.btnZidong.addClickEventListener( function(e){
			self._autoStageUpHandler();
		});
		this.btnQuxiao.addClickEventListener( function(e){
			self.stopAutoStageUp();
		});
		this.labItem.addClickEventListener( function(e){
			self.needItemHandler();
		} );
		this.sbtnGouxuan.addClickEventListener( function(e){
			self._chooseAutoHandler();
		} );
		this.btnDown.addClickEventListener( function(e){
			self._useHandler();
		} );
		this.btnLift.addClickEventListener( function(e){
			self.leftHandler();
		} );
		this.btnRight.addClickEventListener(function(e){
			self.rightHandler();
		}  );

		this.btn1.addClickEventListener(function(e){
			Mgr.uiMgr.ShowPanelByType(QiannengdanTipsExt.PanelName).SetData(self._reslineType);
		}  );

		this.btn2.addClickEventListener(function(e){
			Mgr.uiMgr.ShowPanelByType(HuanhuadanTipsExt.PanelName).SetData(self._reslineType);
		}  );

		this.btnWenhao.addClickEventListener(function(e){
			Mgr.uiMgr.ShowPanelByType( ZhufuzhiInfoExt.PanelName ).SetData(self._reslineType);
		}  );

		this.labItem.setTouchEnabled(true);
		this.labItem.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);
				Mgr.uiMgr.ShowPanelByType(RidepanelGetRouteExt.PanelName);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});
	},

	GetBtnGouXuanState:function(){
		return this.sbtnGouxuan.GetState();
	},

	/**
	 * 开始自动进阶
	 * */
	_autoStageUpHandler:function(event)
	{
		this._timerUpdateId = TimerUtil.TimeUpdate( this._autoTimerHandler, this, 0.3 );
		this.btnGo.visible = false;
		this.btnZidong.visible = false;
		this.btnQuxiao.visible = true;
	},
	/**
	 * 停止自动进阶
	 **/
	stopAutoStageUp:function()
	{
		if ( this._timerUpdateId != 0 )
			TimerUtil.ClearTimeUpdate(this._timerUpdateId, this);
		this._timerUpdateId = 0;
		this.btnGo.visible = true;
		this.btnZidong.visible = true;
		this.btnQuxiao.visible = false;
	},
	/**
	 * 单次升阶请求
	 * */
	_reqStageUp:function(isAuto)
	{
		isAuto = arguments[0]?arguments[0]:0;
		var self = this;
		var psychicData = Q_resline_up.Get( this._reslineType + "_" + this._mgr.GetCurReslineDataInfo().reslineModelId + "_" + this._mgr.GetStars() );
		var mainData = Mgr.mainPlayer.attributeData;
		if ( psychicData.q_up_figure_level > mainData.level )
		{
			Mgr.tips.ShowNotice( TextUtil.ConectParam( "需求等级：{1}", [ psychicData.q_up_figure_level ] ) );
			return;
		}
		if ( psychicData.q_ismax == 1 )
		{
			Mgr.tips.ShowNotice("最高阶了，无法继续进阶");
			return;
		}
		if(psychicData.q_replace_item)
			var firstItemArr = JSON.parse(psychicData.q_replace_item);
		var isUseFirstItem = false;
		var itemNum;
		for( var i = 0; i < firstItemArr.length; i++ )
		{
			itemNum = Mgr.backpack.GetItemNumber( firstItemArr[i], true );
			if( itemNum >= this._needItemNum )
			{
				isUseFirstItem = true;
				break;
			}
		}
		if( !isUseFirstItem )
			itemNum = Mgr.backpack.GetItemNumber( this._needItemID, true );
		if ( itemNum < this._needItemNum )
		{
			var item = Q_item.Get( this._needItemID );
			if( this._isAutoBuyItem )
			{
				var myGold = Mgr.mainPlayer.attributeData.Allgold();
				var myBindGold = Mgr.mainPlayer.attributeData.AllBindGold();

				var dexNum = this._needItemNum - itemNum;

				var shortMoney = true;
				var costType = EnumMoney.GOLD;
				var bind_shopvos = Mgr.shop.GetShopItemVoDatas(this._needBuyIds.bindGold_id, EnumShopType.BINDGOLD_SHOP);
				if ( bind_shopvos.length > 0 ) {
					var needMoney = bind_shopvos[0].price * dexNum
					if ( needMoney <= myBindGold ) {
						shortMoney = false;
						costType = EnumMoney.BIND_GOLD;
					}
				}

				if ( shortMoney ) {  // 绑定元宝不足
					var shopvos = Mgr.shop.GetShopItemVoDatas(this._needBuyIds.gold_id, EnumShopType.GOLD_SHOP);
					if ( shopvos.length > 0 ) {
						var needMoney = shopvos[0].price * dexNum
						if ( needMoney <= myGold ) {
							costType = EnumMoney.GOLD;
							shortMoney = false;
						}
					}
				}

				if ( shortMoney ) {
                    if(shopvos.length > 0){
                        Mgr.uiMgr.ShowPanelByType(RechargeCueExt.PanelName).SetData(shopvos[0], dexNum);
                    }else{
                        Mgr.tips.ShowNotice("老板儿说不卖这个东西!!!");
                    }
					// Mgr.tips.ShowNotice("元宝不足!!!");
					this.stopAutoStageUp();
					return;
				}
				this._mgr.SendReqReslineStratumUpToGameMessage( costType, 1 );
				return;


				//test
				if( !this._buyPanelAdvice )
				{
					Mgr.tips.ShowNotice("进阶失败，还需要" + (this._needItemNum - itemNum) + "个" + item.q_name);
					this.stopAutoStageUp();
					return;
				}
				var useCur = this._buyPanelAdvice.useCurrency;
				var goldNeed = 0;
				for( var j = shopvos[0].actualPrice.length - 1; j >= 0; j-- )
				{
					goldNeed = 0;
					if( this._mgr.GetLayer() >= Mgr.backpack.GetSuperUpLayer() )
					{
						if( shopvos[0].moneyType[ j ] == useCur && shopvos[0].moneyType[ j ] == EnumItemId.BIND_GOLD && shopvos[0].actualPrice[ j ]*(this._needItemNum*Mgr.backpack.GetSuperUpNum() - itemNum) < Mgr.mainPlayer.attributeData.AllBindGold() )
						{
							goldNeed++;
						}
						if( shopvos[0].moneyType[ j ] == useCur && shopvos[0].moneyType[ j ] == EnumItemId.GOLD && shopvos[0].actualPrice[ j ]*(this._needItemNum*Mgr.backpack.GetSuperUpNum() - itemNum) < Mgr.mainPlayer.attributeData.Allgold() )
						{
							goldNeed++;
						}
						if( goldNeed > 0 )
						{
							this._mgr.SendReqReslineStratumUpToGameMessage( useCur, 2 );
							return;
						}
					}
					goldNeed = 0;
					if( shopvos[0].moneyType[ j ] == useCur && shopvos[0].moneyType[ j ] == EnumItemId.BIND_GOLD && shopvos[0].actualPrice[ j ]*(this._needItemNum - itemNum) > Mgr.mainPlayer.attributeData.AllBindGold() )
					{
						goldNeed++;
					}
					if( shopvos[0].moneyType[ j ] == useCur && shopvos[0].moneyType[ j ] == EnumItemId.GOLD && shopvos[0].actualPrice[ j ]*(this._needItemNum - itemNum) > Mgr.mainPlayer.attributeData.Allgold() )
					{
						goldNeed++;
					}
					if( goldNeed == 1 )
					{
						this.stopAutoStageUp();
						var itemUse = Q_item.Get(useCur);
						Mgr.tips.ShowNotice("进阶失败，还需要" + (shopvos[0].actualPrice[ j ]*(this._needItemNum - itemNum)) + itemUse.q_name +"购买" + (needItemNum - itemNum) + "个" + item.q_name);
						return;
					}
				}
				this._mgr.SendReqReslineStratumUpToGameMessage( useCur, 1 );
				return;
			}
			else
			{
				var itemName = "未知物品";
				if( item )
					itemName = item.q_name;
				Mgr.tips.ShowNotice("进阶失败，还需要" + (this._needItemNum - itemNum) + "个" + itemName);
				shopvos = Mgr.shop.GetShopItemVoDatas(this._needItemID, ShopUtil.SHOP_TYPE_MALL);
				this._showItemBuyPanel( shopvos, this._needItemNum );
				this.stopAutoStageUp();
				return;
			}
		}
		if( this._mgr.GetLayer() >= Mgr.backpack.GetSuperUpLayer()  && itemNum >= this._needItemNum*Mgr.backpack.GetSuperUpNum() )
			this._mgr.SendReqReslineStratumUpToGameMessage( 0, 2 );
		else
			this._mgr.SendReqReslineStratumUpToGameMessage();
	},
	_autoTimerHandler:function(){
		this._reqStageUp(1);
	},
	needItemHandler:function()
	{
		var shopvos = Mgr.shop.GetShopItemVoDatas(this._needItemID, ShopUtil.GOLD_SHOP);//Vector.<ShopItemVo>
		var showBuyNum = this._needItemNum;
		if( this._hasNum < this._needItemNum )
			showBuyNum = this._needItemNum - this._hasNum;
		this._showItemBuyPanel( shopvos, showBuyNum );
	},
	_chooseAutoHandler:function(){
		var state = this.sbtnGouxuan.GetState();
		this._isAutoBuyItem = ( state == "check" );
		this._UpDataRidepanelWarn(this._reslineType)
	},
	_useHandler:function(){
		if( Mgr.mainPlayer.CheckState(EnumActionType.WATERRUN) || Mgr.mainPlayer.CheckState(EnumActionType.WATERSTAND) )
		{
			Mgr.tips.ShowNotice("很抱歉，游泳区域不能骑马");
			return;
		}
		var mid = -1, modelId = 0;
		if ( this._reslineType == EnumResline.HORSE )
			modelId = Mgr.mainPlayer.nHorseModelId;
		else if ( this._reslineType == EnumResline.DRAGON )
			modelId = Mgr.mainPlayer.nWingModelId;
		else if ( this._reslineType == EnumResline.GUANGWU )
			modelId = Mgr.mainPlayer.nWeaponModelId;
		else if ( this._reslineType == EnumResline.SHUTONG )
			modelId = Mgr.mainPlayer.nShutongModelId;
        else if ( this._reslineType == EnumResline.STEP )
            modelId = Mgr.mainPlayer.nSteepModelId;
		else if ( this._reslineType == EnumResline.BAOQI ) {
			if ( Mgr.mainPlayer.sShutongGid > 0 ) {
				var pet = Mgr.sceneObj.FindObject(Mgr.mainPlayer.sShutongGid);
				if (pet)
					modelId = pet.nHorseModelId;
			}
		}

		if ( modelId == 0 || (modelId != 0 && ( this._mgr.GetModeIdByLayer( this._mgr.curShowLayer ) != this._mgr.GetEquipModelId() )) )//装备
			mid = this._mgr.GetModeIdByLayer( this._mgr.curShowLayer );
		else//卸下
			mid = -this._mgr.GetEquipModelId();

		this._mgr.SendReqReslineIllusionToGameMessage( mid );
	},
	OnShow:function (){
		this._mgr.SendReqSendReslineInfoToGameMessage( 0 );
	},
	OnHide:function(){
		this._super();
		this.stopAutoStageUp();
		this._clearUiModel();
		// clearEquipGrid();
		// clearSkillGrid();
		this._ResetSelectBox();
	},
	//勾选框复位
	_ResetSelectBox:function(){
		this.sbtnGouxuan.SetButtonState(MUICheckBox.STATE_UNCHECK);
		this._isAutoBuyItem = false;
		this._UpDataRidepanelWarn(this._reslineType);
	},
	_UpDataRidepanelWarn:function (reslineType) {
        // // 资源线
        // if ( reslineType == EnumResline.SHUTONG || reslineType ==  EnumResline.BAOQI)
			// Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataShutongWarn(false, reslineType);
        // else
			// Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).UpDataRoleWarn(false, this._reslineType);
	},

	/**
	 * @param	shopvos	Vector.<ShopItemVo>
	 * @param	itemNum	int
	 * */
	_showItemBuyPanel:function( shopvos, itemNum )
	{
		return;
		if( !this._buyPanelAdvice )
		{
			this._buyPanelAdvice = {};//new BuyPanelAdviceExt()先这样写，看看这块怎么变再说
			this._buyPanelAdvice.x = this._upPanelX;
			this._buyPanelAdvice.y = this._upPanelY;
		}
		// if( !buypanelMask )
		// {
		// 	buypanelMask = new Sprite();
		// }
		// buypanelMask.graphics.beginFill( 0 );
		// buypanelMask.graphics.drawRect( 0, 0, 580, _buyPanelAdvice.uiHeight );
		// buypanelMask.graphics.endFill();
		// buypanelMask.x = upPanelX;
		// buypanelMask.y = _buyPanelAdvice.y;
		// addChild( buypanelMask );
		// _buyPanelAdvice.mask = buypanelMask;
		// this._buyPanelAdvice.setBuyDataByServerInfo(ShopUtil.SHOP_TYPE_MALL, shopvos[0]);
		this._buyPanelAdvice.buyNum =  itemNum;
		for( var j = shopvos[0].actualPrice.length - 1; j >= 0; j-- )
		{
			if( shopvos[0].moneyType[ j ] == EnumItemId.BIND_GOLD && shopvos[0].actualPrice[ j ] <= Mgr.mainPlayer.attributeData.AllBindGold() )
			{
				this._buyPanelAdvice.useCurrency = EnumItemId.BIND_GOLD;
				break;
			}
			else if( shopvos[0].moneyType[ j ] == EnumItemId.GOLD && shopvos[0].actualPrice[ j ] <= Mgr.mainPlayer.attributeData.Allgold() )
			{
				this._buyPanelAdvice.useCurrency = EnumItemId.GOLD;
				break;
			}
		}
		// _buyPanelAdvice.onShow();
		// addChild(_buyPanelAdvice);
		// TweenMax.to(_buyPanelAdvice,0.3,{startAt:{x:buypanelMask.x - _buyPanelAdvice.uiWidth,alpha:0},x:buypanelMask.x ,alpha:1,ease:Circ.easeOut});
	},
	/**
	 * 升阶返回特效
	 */
	ShowStageUpEffect:function( isSuccess, addBless )
	{
		addBless = addBless!=null?addBless:1;
		var nowData = Q_resline_up.Get( this._reslineType + "_" + this._mgr.GetCurReslineDataInfo().reslineModelId + "_" + this._mgr.GetStars() );
		if( !isSuccess )
		{
			if( nowData )
			{
				if( nowData.q_up_fail_addexp )
				{
					var locpos = cc.p( this.progJindutiao.x + this.progJindutiao.width/2, this.progJindutiao.y + 20 );
					var pos = UIUtil.LocalToGlobel( this.imgBg2, locpos );
					Mgr.tips.ShowNotice( TextUtil.ConectParam( "祝福值+{1},经验+{2}", [addBless, nowData.q_up_fail_addexp] ), TipsEnum.TYPE_UP_HIDE, pos );
				}
				else
				{
					var locpos = cc.p( this.progJindutiao.x + this.progJindutiao.width/2, this.progJindutiao.y + 20 );
					var pos = UIUtil.LocalToGlobel( this.imgBg2, locpos );
					Mgr.tips.ShowNotice( TextUtil.ConectParam( "祝福值+{1}", [addBless] ), TipsEnum.TYPE_UP_HIDE, pos );
				}
			}
		}
		else
		{
			this.showInfo();
			// Mgr.activityPanelMgr.reqActivitiesInfoMsg();//升级了先刷下活动哎呀
			this.stopAutoStageUp();
			this._ResetSelectBox();
			// hideBuyPanel();
		}
	},
	showInfo:function(){
		this._showModel( this._mgr.curShowLayer, true );
		this.UpdateBtnState();
		this._showActiveInfo();
		this.UpdateBlessing(true);
		this._updataGrid();
		this._showAttribute(this._mgr.curShowLayer, this._mgr.GetCurShowStars() );
		this.ShowTeampAttribute(this._mgr.curShowLayer, this._mgr.GetCurShowStars());
	},
	_showActiveInfo:function(){
		var showkey = this._reslineType + "_" + Math.max(this._mgr.curShowLayer, 1) + "_" + this._mgr.GetCurShowStars();
		var psychicData = Q_resline_up.Get( showkey );
		for( var i = 0; i < this._starVec.length; i++ )
		{
			// this._starVec[ i ].visible = true;
			// if( i < this._mgr.GetStars() )
			// 	this._starVec[ i ].filters = [];
			// else
			// 	this._starVec[ i ].filters = [ FilterUtil.getGrayFilter() ];
		}

		var attList = this._mgr.GetCurReslineDataInfo().attList;
		if ( attList == null )
		{
			// imgRuMoQianNengDan.visible = false;
			// imgRuMoHuanHuaDan.visible = false;
			return;
		}

		this.labName.SetText( psychicData.q_name + " " + TextUtil.GetHtmlStr( TextUtil.GetReslineLayerName( this._mgr.curShowLayer ), "#853d07" ) );

		var potentialDanId = 0;
		var potentialDanMaxMun = 0;
		var fluctuateDanId = 0;
		var fluctuateDanMaxNum = 0;
		var danArr = this._mgr.GetDanDataArr();
		if(danArr.length > 0)
		{
			potentialDanId = danArr[0][0];
			potentialDanMaxMun = danArr[0][1];
			fluctuateDanId = danArr[1][0];
			fluctuateDanMaxNum = danArr[1][1];
		}
		if( potentialDanMaxMun == 0 || potentialDanId == 0)
		{
			this.btn1.visible = false;
		}
		else
		{
			this.btn1.visible = true;
            var mgr = Mgr.resline.GetMgrByType(this._reslineType);
            var danArr = mgr.GetDanDataArr();
            var numArr = mgr.GetDanNumArr();
            var mid = danArr[0][0];
            var ownNum =  Mgr.backpack.GetItemNumber( mid, true );
			this.imgCue1.visible = ownNum > 0 && numArr[0] < danArr[0][1];
			this.labNum3.SetText(ownNum);
		}
		if( fluctuateDanMaxNum == 0 || fluctuateDanId == 0)
		{
			this.btn2.visible = false;
		}
		else
		{
			this.btn2.visible = true;
            var mgr = Mgr.resline.GetMgrByType(this._reslineType);
            var danArr = mgr.GetDanDataArr();
            var numArr = mgr.GetDanNumArr();
            var mid = danArr[1][0];
            var ownNum =  Mgr.backpack.GetItemNumber( mid, true );
            this.imgCue2.visible = ownNum > 0 && numArr[1] < danArr[1][1];
            this.labNum2.SetText(ownNum);
		}

		// 刷新丹药面板
		var panel = Mgr.uiMgr.GetPanelByType(QiannengdanTipsExt.PanelName);
		if ( Mgr.uiMgr.IsPanelShow(panel) )
			panel.SetData(this._reslineType);

		var panel = Mgr.uiMgr.GetPanelByType(HuanhuadanTipsExt.PanelName);
		if ( Mgr.uiMgr.IsPanelShow(panel) )
			panel.SetData(this._reslineType);
	},

	_updateNeedItem:function(){
		var mgr = Mgr.resline.GetMgrByType(this._reslineType);
		if( !mgr.GetCurReslineDataInfo() || mgr.GetCurReslineDataInfo().reslineModelId == 0 )
			return;
		var psychicData = Q_resline_up.Get( this._reslineType + "_" + mgr.GetCurReslineDataInfo().reslineModelId + "_" + mgr.GetStars() );
		var firstItemArr = JSON.parse(psychicData.q_replace_item);
		var isUseFirstItem = false;
		this._hasNum = 0;
		this._needItemNum = psychicData.q_up_item_num;
		this._needItemID = psychicData.q_up_item_id;
		var array = JSON.parse(psychicData.q_shop_data);
		this._needBuyIds = {gold_id:parseInt(array[1]), bindGold_id:parseInt(array[0])};
		for( var i = 0; i < firstItemArr.length; i++ )
		{
			this._hasNum = Mgr.backpack.GetItemNumber( firstItemArr[i], true );
			if( this._hasNum >= this._needItemNum )
			{
				isUseFirstItem = true;
				break;
			}
		}
		if( !isUseFirstItem )
		{
			this._hasNum = Mgr.backpack.GetItemNumber( psychicData.q_up_item_id, true );
		}
		var color = ( this._hasNum < psychicData.q_up_item_num ) ? ColorUtil.SYS_RED : ColorUtil.SYS_GREEN;
		var itemName = Q_item.Get( psychicData.q_up_item_id ).q_name;
		//TextUtil.GetHtmlStr( "<u>" + itemName + "</u>x" + psychicData.q_up_item_num, color )
		UIUtil.ConnectLabelHtmlText(this.labItem, [itemName + "x" + psychicData.q_up_item_num])
		this.labItem.SetColor(color);
	},
	_updataGrid:function()
	{
		var psychicData = Q_resline_up.Get( this._reslineType + "_" + Math.max(this._mgr.GetCurReslineDataInfo().reslineModelId,1) + "_" + this._mgr.GetStars() );
		var openArr = [];
		if(psychicData.q_remove)
			openArr = JSON.parse(psychicData.q_remove);

		//初始化技能grid
		this._gridVec = [ this.gridEquip, this.gridEquip2, this.gridEquip3, this.gridEquip4, this.gridEquip5, this.gridEquip6 ];
		var check = this._gridVec;
		var skills = this._mgr.GetSkillArray();
		for ( var i = 0; i < skills.length; i++)
		{
			if ( this._gridVec.length <= i )
				break;

			var grid = this._gridVec[i];
			var skillid = skills[i][1];
			var reslineVo = new Object();
			reslineVo.reslinetype = this._reslineType;
			reslineVo.reslinelayer = skills[i][0];
			var lv = this._mgr.GetSysSkillLev( skillid );
			GridUtil.SetSkillGridByMID( GridInteractionType.RESLINESKILLSHOW,grid, skillid, lv, reslineVo );
			this._CheckSkillUp(grid,lv);
			if ( lv > 0 ) {
				Filter.UnGray(grid);
                var curGradeId = skillid + "_" + lv;
                var needInfo = Q_resline_skills.Get(curGradeId);
                if(Mgr.backpack.GetItemNumber(needInfo.q_item) >= needInfo.q_item_num && lv < 10){
                    if(!grid.lv){
                        var lvLabel = new MUILabel();
                        lvLabel.ParseJson(this.labLevel.jsonobj);
                        lvLabel.Init();
                        lvLabel.EnableOutline();
                        grid.addChild(lvLabel);
                        lvLabel.setLocalZOrder(grid.getLocalZOrder() + 10);
                        grid.lv = lvLabel;
					}
					this.warnList[i].setVisible(true);
					grid.lv.visible = true;
				}else {
                	this.warnList[i].setVisible(false);
                    if(grid.lv){
                    	grid.lv.visible = false;
					}
				}
				// lock
				if ( grid.lock )
					grid.lock.visible = false;
			}
			else {
				Filter.GrayScale(grid);

				// lock
				if ( !grid.lock ) {
					var icon = new MUIImage();
					icon.ParseJson(this.imgLock.jsonobj);
					icon.Init();
					icon.setPosition(this.imgLock.getPosition());
					grid.addChild(icon, 2, 30);
					grid.lock = icon;
				}
				grid.lock.visible = true;
			}
            grid.background.setPosition(grid.uiWidth / 2, grid.uiHeight / 2);
		}
		//初始化装备grid
		this._gridVec1 = [this.gridEquip8, this.gridEquip7, this.gridEquip5, this.gridEquip6 ];
		this._gridLab = [this.labEquipName111, this.labEquipName11, this.labEquipName, this.labEquipName1];

		var equips = this._mgr._equips;
		for ( var i = 0; i < equips.length; i++)
		{
			if ( this._gridVec1.length <= i )
				break;

			var item = equips[i];
            var grid = this._gridVec1[i];
            var lab = this._gridLab[i];
            grid.gridData = null;
            grid.Clean();
            lab.visible = true;
			if ( item && item.itemModelId > 0 ) {
				GridUtil.SetItemGrid(grid,item);
				lab.visible = false;
			}
		}
        // var addFunc = function (nn) {
        //     nn.InitGrid(GridTypeEnum.EQUIPWARED);
        //     nn.setTouchEnabled(true);
        //     nn.addClickEventListener(function (target) {
        //         if(!target.gridData){
        //             return;
        //         }
        //         ItemUtil.ShowTips(target.gridData,target.gridType);
        //     })
        // };
        // for (var i = 0; i < this._gridVec1.length; ++i) {
        //     addFunc(this._gridVec1[i]);
        // }
		//设置需要填充资源线名字的地方
		var reslinename = this._mgr.GetResLineName();
		UIUtil.ConnectLabelHtmlText( this.labSkill, [reslinename] );
		UIUtil.ConnectLabelHtmlText( this.labSkill1, [reslinename] );
		UIUtil.ConnectLabelHtmlText( this.labCue1, [reslinename] );
        var equipName = this._mgr.GetResLineEquipName();
		this.labEquipName111.SetText(equipName[0]);
        this.labEquipName11.SetText(equipName[1]);
        this.labEquipName.SetText(equipName[2]);
        this.labEquipName1.SetText(equipName[3]);


		for( var i = 0; i < this._gridVec.length; i++ )
		{
			// if( openArr.indexOf(i+1) != -1 )
			// {
			// 	// this._gridVec[i].filters = [];
			// 	// gridBtnVec[i].visible = true;
			// }
			// else
			// {
			// 	this._gridVec[i].filters = [ FilterUtil.getGrayFilter() ];
			// 	gridBtnVec[i].visible = false;
			// }
			// this._gridVec[i].setTips(_reslineType.toString(),i+1,removeTips);
		}
		// updataGridBtn();
	},
	//
	//检测当前技能是否可以升级
	_CheckSkillUp:function(grid,lv)
	{
		if(!grid)
			return;
		grid.isSkillUp = lv > 0 && lv < 10;
	},
	//TODO
	//技能升级
	RequireSkillUp:function()
	{
		var data = {};
		var type = type ? type : 0;
		Mgr.resline.SendReqReslineSkillUpByModelidToGameMessage(data.reslinetype,data.skillmid,type);
	},
	UpdateBtnState:function () {
		var str;
		if ( this._mgr.GetEquipModelId() != 0 && this._mgr.curShowLayer == this._mgr.GetEquipModelId() ) {
			if (this._reslineType == EnumResline.HORSE)
				str = "休息";
			else
				str = "隐藏";
		}
		else if ( this._mgr.GetLastEquipModelId() != this._mgr.curShowLayer )
			str = "幻化";
		else {
			if ( this._reslineType == EnumResline.HORSE )
				str = "骑乘";
			else
				str = "穿戴";
		}


		//左右按钮先这样加一下，后面改成设置滤镜
		this.btnRight.setTouchEnabled( this._mgr.curShowLayer <= this._mgr.GetLayer() && this._mgr.GetLayer() + 1 <= this._mgr.GetMaxLayer() );
		this.btnLift.setTouchEnabled( this._mgr.curShowLayer > 1 );
		this.btnDown.setTitleText( str );
		if(this._reslineType == EnumResline.WUXUE || this._reslineType == EnumResline.ZHAOSHI)
            this.btnDown.visible = false;
		else
			this.btnDown.visible = ( this._mgr.curShowLayer <= this._mgr.GetLayer() );
	},
	UpdateBlessing:function(force){
		if(this._mgr.GetMaxModelId() == 0)
			return;

		if ( force )
		{
			if( this._mgr.GetMaxModelId() == this._mgr.GetMaxLayer() && this._mgr.GetStars() == this._mgr.GetMaxstarByLayer(this._mgr.GetMaxModelId()) )
			{
			}
			else if( this._mgr.GetMaxModelId() == 0 )
			{
			}
			else
			{
			}
		}

		// 检测是否满级
		var nextModelId = this._mgr.GetMaxModelId() + 1;
		var next_showkey = this._reslineType + "_" + nextModelId + "_" + this._mgr.GetStars().toString();
		var next_beltUp = Q_resline_up.Get( next_showkey );
		if ( next_beltUp ) {
			this.imgBg2.visible = true;
			this.imgBg21.visible = false;

			var limitNum = 0;
			var showkey = this._reslineType + "_" + this._mgr.GetMaxModelId();
			var beltBasicData = Q_resline.Get( showkey );
			showkey = beltBasicData.q_id.toString() + "_" + this._mgr.GetStars().toString();
			var beltUp = Q_resline_up.Get( showkey );
			limitNum = beltUp.q_blessnum_limit;

			// labJindu.htmlText = this._mgr.nowBlessnum;
			var setValue = this._mgr.nowBlessnum / limitNum;
			var str = this._mgr.nowBlessnum.toString() + "/" + limitNum.toString();
			this.labRate.SetString(str);
			this.progJindutiao.setScaleX( setValue );
			this._updateNeedItem();

			// labCue2
			if ( beltUp.q_reset_time > 0 ){
				//this.btnWenhao.visible = true;

				// 移除定时器
				if (this._timerNum != 0) {
					TimerUtil.ClearTimeUpdate(this._timerNum, this);
					this._timerNum = 0;
					this._restTime = 0;
				}

				if ( this._mgr.nowBlessnum > 0 ) {
					this._restTime = Math.floor( (this._mgr.clearDate - Mgr.login.GetServerTime())/1000 );
					this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
					this.OnTimer();
				}
				else {
					this.labCue2.SetHtmlText("本阶进阶祝福值会被清空");
				}
			}
			else {
				//this.btnWenhao.visible = false;
				this.labCue2.SetHtmlText("本阶祝福值不会被清空");
			}
		}
		else {  // 满级
			this.imgBg2.visible = false;
			this.imgBg21.visible = true;
		}
	},

	OnTimer:function () {
		this._restTime--;
		if ( this._restTime <= 0 )
		{
			this._restTime = 0;
			TimerUtil.ClearTimeUpdate(this._timerNum, this);
			this._timerNum = 0;
		}
		var second = this._restTime;
		var H =  Math.floor(second/3600);
		var M = Math.floor(second/60%60);
		var S = Math.floor(second%60);
		this.labCue2.SetHtmlText(UIUtil._ConectParam("祝福值清空倒计时：{@}:{@}:{@}",[H,M,S]));
	},

	/***
	 * 显示下一阶属性战力
	 * @param layer
	 * @param stars
	 * @constructor
	 */
	ShowNextAttribute:function (layer, stars) {
		this.imgTeampAttr.visible = false;
		this.imgUpAttr.visible = true;

		// 最大阶
		layer = layer + 1;
		var key = this._reslineType + "_" + layer + "_" + stars;
		var q_resline_up = Q_resline_up.Get( key );
		if ( !q_resline_up) {
			this.imgUpAttr.visible = false;
		}
		else {
			// fight
			var attInfos = this._mgr.GetAttribute( 0, layer, stars, this._mgr.GetDanDataArr(layer, stars), this._mgr.GetDanNumArr() );
			var addPower = Mgr.fight.GetAttrsPowerList(attInfos);
			this.labNum.SetString( addPower );

			var attHash = this._mgr.GetAtt( 0, layer, stars, this._mgr.GetDanDataArr(layer, stars), this._mgr.GetDanNumArr() );
			var attackV = attHash.Get(EnumAttribute.ATTACK);
			UIUtil.ConnectLabelHtmlText(this.labNum1, [attackV])

			var DefV = attHash.Get(EnumAttribute.DEFEND);
			UIUtil.ConnectLabelHtmlText(this.labNum11, [DefV])

			var hpV = attHash.Get(EnumAttribute.MAX_BASEHP);
			UIUtil.ConnectLabelHtmlText(this.labNum111, [hpV])
		}

		this.imgUpAttr.opacity = 255;
		TimerUtil.ClearTimeout(this._timerNum1);
		this._timerNum1 = -1;

		var self = this;
		var OnGetReward = function () {
			TimerUtil.ClearTimeout(self._timerNum1);
			self._timerNum1 = -1;
			var Out = cc.fadeOut(0.5);
			self.imgUpAttr.runAction(cc.sequence(Out, cc.callFunc(self._OnTrace, self) ));
		};
		this._timerNum1 = TimerUtil.SetTimeout(this, OnGetReward, 3000);
	},

	_OnTrace:function () {
		this.ShowTeampAttribute(this._mgr.curShowLayer, this._mgr.GetCurShowStars());
	},

	ShowTeampAttribute:function (layer, stars) {
		this.imgTeampAttr.visible = true;
		this.imgUpAttr.visible = false;

		var key = this._reslineType + "_" + layer + "_" + stars;
		var resline_addition = Q_resline_addition.Get( key );
		if ( !resline_addition || this._mgr.nowBlessnum <= 0 )
			this.imgTeampAttr.visible = false;
		else {
			var jsonData = JSON.parse(ParseUtil.FormatFastJsonStr(resline_addition.q_attribute_temp));
			for (var keyStr in jsonData) {
				var _type = parseInt(keyStr);
				var _value = parseInt(jsonData[keyStr])* this._mgr.advanceNum;

				if( EnumAttribute.ATTACK == _type ) {
					UIUtil.ConnectLabelHtmlText(this.labTeampG, [_value])
				}
				else if ( EnumAttribute.DEFEND == _type ) {
					UIUtil.ConnectLabelHtmlText(this.labTeampF, [_value])
				}
				else if ( EnumAttribute.MAX_BASEHP == _type ) {
					UIUtil.ConnectLabelHtmlText(this.labTeampX, [_value])
				}
			}

			// action
			this.imgTeampAttr.opacity = 0;
			var In = cc.fadeIn(0.5);
			this.imgTeampAttr.runAction(In);
		}
	},

	/**
	 * 属性战力
	 * */
	_showAttribute:function( layer, stars ){
		var psychicData = Q_resline_up.Get( this._reslineType + "_" + layer + "_" + stars );
		if( !psychicData )
			return;

		var attHash = this._mgr.GetAtt( 0, layer, stars, this._mgr.GetDanDataArr(layer, stars), this._mgr.GetDanNumArr() );
		var attackV = attHash.Get(EnumAttribute.ATTACK);
		this.labGongji.setVisible( attackV != 0 );
		this.labAttack.setVisible( attackV != 0 );
		this.labAttack.SetHtmlText("+" + attackV);

		var hpV = attHash.Get(EnumAttribute.MAX_BASEHP);
		this.labShengming.setVisible( hpV != 0 );
		this.labHp.setVisible( hpV != 0 );
		this.labHp.SetHtmlText("+" + hpV);

		var DefV = attHash.Get(EnumAttribute.DEFEND);
		this.labFangyu.setVisible( DefV != 0 );
		this.labDef.setVisible( DefV != 0 );
		this.labDef.SetHtmlText("+" + DefV);

		var attInfos = this._mgr.GetAttribute( 0, layer, stars, this._mgr.GetDanDataArr(layer, stars), this._mgr.GetDanNumArr() );
		var addPower = Mgr.fight.GetAttrsPowerList(attInfos);
		this.labNumber.SetString( addPower );
		this.labNumber.setVisible(  true );

		//






		// var lastAttrHash = this._mgr.GetLastAtt();
		// if ( lastAttrHash ) {
		// 	var lastAttackV = lastAttrHash.Get(EnumAttribute.ATTACK);
		// 	var lastDefV = lastAttrHash.Get(EnumAttribute.DEFEND);
		// 	var lastHpV = lastAttrHash.Get(EnumAttribute.MAX_BASEHP);
		//
		// 	var addAttack = attackV - lastAttackV;
		// 	var addDef = DefV - lastDefV;
		// 	var addHp = hpV - lastHpV;
		//
		// 	var lastPower = this._mgr.GetLastFighting();
		// 	var addPower = addPower - lastPower;
		//
		// 	//this.ShowAddAttr(addAttack, addDef, addHp, addPower);
		// }

		// mingzhong_label.setVisible( attArr[5] != 0 );
		// Nummingzhong_label.setVisible( attArr[5] != 0 );
		// Nummingzhong_label.SetHtmlText("+" + attArr[5]);
		//
		// sanbi_label.setVisible( attArr[4] != 0 );
		// Numsanbi_label1.setVisible( attArr[4] != 0 );
		// Numsanbi_label1.SetHtmlText("+" + attArr[4]);
		//
		// renxing_label1.setVisible( attArr[6] != 0 );
		// Numrenxing_label1.setVisible( attArr[6] != 0 );
		// Numrenxing_label1.SetHtmlText("+" + attArr[6]);
		//
		// baoji_label.setVisible( attArr[3] != 0 );
		// Numbaoji_label.setVisible( attArr[3] != 0 );
		// Numbaoji_label.SetHtmlText("+" + attArr[3]);

		// var imgs;
		// while( this._starCon.numChildren )
		// {
		// 	imgs = starCon.removeChildAt(0) as Image;
		// 	if ( imgs != null )
		// 		imgs.filters = null;
		// }

		var maxStars = this._mgr.GetMaxstarByLayer(layer);
		var startX = this.progJindutiao.uiWidth*.5//((this.progJindutiao.uiWidth - imgStar1.initX) - StarWidth*maxStars)*.5;
		for ( var i = 0; i < maxStars; i ++ )
		{
			// imgs = imgStar1.clone();
			// imgs.y = 0;
			// imgs.x = startX + StarWidth*i;
			// if ( i >= level )
			// 	imgs.filters = [ FilterUtil.getGrayFilter() ];
			// else
			// 	imgs.filters = null;
			// starCon.addChild(imgs);
		}

//			imgYaoJiaName.background.setImage( UIUtil.getAsynBitmapNew( _mgr.getNameUrl( layer ), imgYaoJiaName.background ) as GuiBitmap );
// 		MCUtil.removeAllChild( imgZuoqiNameBg );
// 		if ( _reslineType != EnumPlayerPanel.SHOW_TYPE_RESLINE )
// 		{
// 			var bmpName:GuiBitmap = UIUtil.getAsynBitmapNew( _mgr.getNameUrl( layer ) ) as GuiBitmap;
// 			imgZuoqiNameBg.addChild( bmpName );
// 			if( bmpName.isLoaded )
// 			{
// 				bmpName.x = (imgZuoqiNameBg.uiWidth - bmpName.width)*.5;
// 				bmpName.y = (imgZuoqiNameBg.uiHeight - bmpName.height)*.5;
// 			}
// 			else
// 			{
// 				bmpName.addEventListener(GuiEvent.BITMAP_LOAD_OK_EVENT, function onheadMbTitleComplete():void{
// 				bmpName.x = (imgZuoqiNameBg.uiWidth - bmpName.width)*.5;
// 				bmpName.y = (imgZuoqiNameBg.uiHeight - bmpName.height)*.5;
// 				bmpName.removeEventListener(GuiEvent.BITMAP_LOAD_OK_EVENT, onheadMbTitleComplete);
// 			});
// 			}
// 		}
// 		else
// 			imgZuoqiNameBg.addChild(imgYaoJiaName);
//
		// this.imgLv.background.setImage( UIUtil.GetAsynImageByUrl( _mgr.getLayerUrl( layer ), imgJieshu.background ) as GuiBitmap );
// 		if( level == 0 )
// 			imgStarNum.visible = false;
// 		else
// 		{
// 			imgStarNum.visible = true;
// 			imgStarNum.background.setImage( UIUtil.getAsynBitmapNew( _mgr.getStarUrl( level ), imgStarNum.background ) as GuiBitmap );
// 		}
	},
	_showModel:function( showLayer ){
		if(this._reslineType == EnumResline.STEP){
            if(!this._jiaoyinModel){
                var jiaoyinModel = new MAnimationGroup();
                this._jiaoyinModel = jiaoyinModel;
                // var url = SceneObjUtil.GetUIModelUrl(Mgr.player.mainPlayer.job, EnumResline.PLAYER);
                this._jiaoyinModel.SetResUrlNoAction("res/animation/player/" + Mgr.player.mainPlayer.job);
                this._jiaoyinModel.DoAction("walk", 2);
                this._jiaoyinModel.x = -300;
                this._jiaoyinModel.y = -50;
                this.imgModel.addChild(this._jiaoyinModel);
                var anction = cc.MoveTo(2, cc.p(300, -50));
                var forever = cc.RepeatForever(cc.sequence([
                    anction,
                    cc.callFunc(function(){
                        jiaoyinModel.x = -300;
					}, this)
                ]));
                this._jiaoyinModel.runAction(forever);

                if(this._timerId){
                    TimerUtil.ClearTimeUpdate(this._timerId, this);
                    this._timerId = -1;
                }
                this._showSteep(showLayer);

                // var url = SceneObjUtil.GetUIModelUrl(showLayer, this._reslineType);
                // this._jiaoyinModel.AddBindPart(url,[],{"walk": "stand"});
			}
			else{
                if(this._timerId){
                    TimerUtil.ClearTimeUpdate(this._timerId, this);
                    this._timerId = -1;
                }
                this._showSteep(showLayer);
			}
		}
		else{
            if(this._timerId){
                TimerUtil.ClearTimeUpdate(this._timerId, this);
                this._timerId = -1;
			}
            if( !this._uiModel ){
                this._uiModel = new UIModel(showLayer, this._reslineType);
                this.imgModel.addChild(this._uiModel);
            }
            else{
                this._uiModel.SetModelId(showLayer);
            }
		}
	},

	_showSteep:function(showLayer){
        this.jiaoyinOldPosX = this._jiaoyinModel.x;
        this.count = 0;
        var self = this;
        if(!this._timerId)
            TimerUtil.ClearTimeUpdate(this._timerId, this);
        this._timerId = TimerUtil.TimeUpdate(function(){
            var x = self._jiaoyinModel.x - self.jiaoyinOldPosX;
            if(x < 0)
            	x = 0;
            this.count+=x;
            if(this.count > 80){ // 80像素刷一个脚印
                for(var i = 0; i < 10; i++){
                    var url = SceneObjUtil.GetUIModelUrl(showLayer, EnumResline.STEP);
                    if(!this.sSteepEffs[i]){
                        var effect = new MAnimationObject();
                        effect.sResUrlBase = url;
                        effect.DoAction("stand");
                        effect.x = self._jiaoyinModel.x;
                        effect.y = self._jiaoyinModel.y;
                        this.imgModel.addChild(effect, -1);
                        this.sSteepEffs.push(effect);
                        break;
                    }
                    else if(!this.sSteepEffs[i]._isForever && this.sSteepEffs[i]._playEnd){
                        this.sSteepEffs[i].sCurActionName = null;
                        this.sSteepEffs[i].sResUrlBase = url;
                        this.sSteepEffs[i].x = self._jiaoyinModel.x;
                        this.sSteepEffs[i].y = self._jiaoyinModel.y;
                        this.sSteepEffs[i].DoAction("stand");
                        break;
                    }
                }
                this.count-=80;
            }
            self.jiaoyinOldPosX = self._jiaoyinModel.x;
        }, this, 0.01);

	},

	_clearUiModel:function(){
		if( this._uiModel )
			this._uiModel.Dispose();
		this._uiModel = null;
        if(this._timerId){
            TimerUtil.ClearTimeUpdate(this._timerId, this);
            this._timerId = -1;
        }
	},
	/**
	 * 切换效果
	 * */
	rightHandler:function ()
	{
		this._doMove();
	},

	leftHandler:function ()
	{
		this._doMove(true);
	},
	_doMove:function ( moveleft ) {//upstate:1是升阶状态；-1是返回；2是升阶成功
		var time = TimerUtil.GetTimer();
		if ( time - this._movetime <= 100 )//设定的0.1秒移动
			return false;

		this._movetime = time;

		moveleft = moveleft?moveleft:false;

		if ( moveleft )
		{
			if ( this._mgr.curShowLayer <= 1 )
				return false;

			this._mgr.curShowLayer--;
		}
		else
		{
			if ( this._mgr.curShowLayer >= this._mgr.GetMaxLayer())
				return false;

			this._mgr.curShowLayer++;
		}

		this.showInfo();
	}
} );
RidePanelExt.PanelName = "RidePanelExt";
PanelClassDic["RidePanelExt"] = RidePanelExt;
