var RidepanelGetRouteExt = RidepanelGetRoute.extend ( {
	_className:"RidepanelGetRouteExt",
	modelPanelType:2,
	isClosePanel:true,
	ctor:function(){
		this._super();
	},

	Init:function() {
		RidepanelGetRoute.prototype.Init.call(this);

		var self = this;
		this.btnClose.addClickEventListener(function (event) {
			EngineMgr.uiMgr.HidePanel(self);
		});
		this.btnOk.addClickEventListener(function (event) {
			EngineMgr.uiMgr.HidePanel(self);
		});

		this._SetRouteLink();
	},

	_SetRouteLink:function () {
		var self = this;
		// 进阶副本
		this.labCue1.setTouchEnabled(true);
		this.labCue1.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);
				Mgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName).ChangeView(EnumZoneType.TYPE_JJ);
				Mgr.uiMgr.HidePanel(self);
				Mgr.uiMgr.HidePanelByType(PlayerPanelExt.PanelName);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});

		// 日常活动
		this.labCue11.setTouchEnabled(true);
		this.labCue11.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);
				Mgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName).ChangeView(EnumZoneType.TYPE_JY);
				Mgr.uiMgr.HidePanel(self);
				Mgr.uiMgr.HidePanelByType(PlayerPanelExt.PanelName);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});

		// 商城购买
		this.labCue111.setTouchEnabled(true);
		this.labCue111.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);
				Mgr.uiMgr.ShowPanelByType(ShopMainExt.PanelName);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});
	},
} );
RidepanelGetRouteExt.PanelName = "RidepanelGetRouteExt";
PanelClassDic["RidepanelGetRouteExt"] = RidepanelGetRouteExt;
