var RechargeRebatePanelExt = RechargeRebatePanel.extend ( {
	_className:"RechargeRebatePanelExt",

	// 链表三件套
	_listView : null,
	_itemList:null,
	_curSelectItem:null,

	ctor:function(){
		this._super();
		this._itemList = [];
	},

	Init:function() {
		var self = this;
		RechargeRebatePanel.prototype.Init.call(this);

		this._InitParam();
	},

	_InitPosition:function () {
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function () {
		this._InitPosition();

		this._CreateListView();
	},

	_CreateListView:function () {
		// listView
		var list = new ccui.ScrollView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setContentSize(cc.size(this.imgContent.width, this.imgContent.height));
		list.setTouchEnabled(true);
		list.setInertiaScrollEnabled(true);
		list.setScrollBarEnabled(false);
		list.setBounceEnabled(true);
		this.imgContent.addChild(list);
		this._listView = list;
	},

	_LaodItems:function () {

		var activityList = ActivityUtil.GetActivityList(EnumActivityKey.M_REAL_DOUBLE_RECHARGE, 1);
		if( !activityList ){
			return;
		}
		activityList = Mgr.dailyactivity.GetGradeInfoById(activityList[0].activityId);
		// sort
		var _total_row = 0;
		for ( var i = 0; i != activityList.length; i++ ) {
			var item;
			if ( i < this._itemList.length )
				item = this._itemList[i];
			else {
				item = new RechargeRebateItemExt();
				item.LoadPanel();
				item.retain();
				this._itemList.push(item);
				this._listView.addChild(item);
			}
			item.SetData(activityList[i],i,activityList.length);

			// pos
			item.setAnchorPoint(0,1);
			var line = i % 4;
			var row = parseInt(i/4);
			_total_row = parseInt(activityList.length/4);
			if ( activityList.length % 4 > 0 )
				_total_row += 1;
			row = _total_row - row;
			var pos_x = (item.width + 2)*line;
			var pos_y = (item.height + 2)*row;
			item.x = pos_x;
			item.y = pos_y;
		}

		// set InnerContainerSize size
		var innerContainerHeght = (item.height + 2)*_total_row
		this._listView.setInnerContainerSize(cc.size(this.imgBg1.width, (item.height + 2)*_total_row));

		// 超出范围才可滑动
		if ( this._listView.getContentSize().height >= innerContainerHeght )
			this._listView.setTouchEnabled(false);
		else
			this._listView.setTouchEnabled(true);
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	OnShow:function () {
		this._LaodItems();
	},
} );
RechargeRebatePanelExt.PanelName = "RechargeRebatePanelExt";
PanelClassDic["RechargeRebatePanelExt"] = RechargeRebatePanelExt;
