///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ReslineDataInfo 资源线基本数据信息

// 请求消息
//214201,ReqSendReslineInfoToGame 请求资源线信息
//214202,ReqReslineAddToGame 请求资源线激活
//214203,ReqReslineStratumUpToGame 请求资源线升阶（星）
//214204,ReqReslineIllusionToGame 请求切换资源线
//214205,ReqReslinekDevourToGame 请求资源线吞噬或关闭吞噬
//214206,ReqReslineSkillUpByModelidToGame 请求技能升级
//214207,ReqReslineExtendToGame 其他请求操作通用消息
//214208,ReqReslineCuilianToGame 请求资源线淬炼结

// 接收消息
//214101,ResSendReslineAllInfoToClient 发送整个资源线数据信息 
//214102,ResSendReslineInfoToClient 发送单个资源线信息
//214103,ResReslineIllusionToClient 发送当前资源线ID给地图周围的玩家(改变外观)
//214104,ResReslineUpResultToClient 发送升阶（星）结果信息
//214105,ResReslineAddToClient 资源线激活消息
//214106,ResReslineEquipSkillInfoToClient 发送资源线技能信息
//214107,ResReslineCuilianResultToClient 发送资源线淬炼结果信息


var ReslineDataInfo = cc.Class.extend({
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.equips = []; // 装备列表(4个格子,空的是itemid为0) ItemInfo
        this.euipSkillInfo = []; // 已穿戴技能信息 SkillInfo
        this.reslineStar = 0; // 资源线星级
        this.level = 0; // 资源线等级
        this.exp = 0; // 资源线当前经验
        this.skillBoxNum = 0; // 当前开启的技能格子数 
        this.rideReslineModelId = 0; // 携带的当前资源线ID
        this.reslineModelId = 0; // 资源线当前最大阶数 
        this.attList = []; // 吃的属性丹数量列表(顺序依次是潜能丹，幻化丹) int
        this.advanceTime = 0; // 本阶第一次进阶操作时间（秒） 
        this.devourList = []; // 吞噬所加属性的编号（对应吞噬表的ID） int
        this.advanceNum = 0; // 资源线升阶次数
        this.cuilianExp = 0; // 当前淬炼经验值
        this.cuilianLv = 0; // 当前淬炼等级
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteShort( this.equips.length );
        for (var i = 0; i < this.equips.length; i++) {
            _buf.WriteBean(this.equips[i]);
        }
        _buf.WriteShort( this.euipSkillInfo.length );
        for (var i = 0; i < this.euipSkillInfo.length; i++) {
            _buf.WriteBean(this.euipSkillInfo[i]);
        }
        _buf.WriteByte(this.reslineStar);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.exp);
        _buf.WriteVarInt(this.skillBoxNum);
        _buf.WriteVarInt(this.rideReslineModelId);
        _buf.WriteVarInt(this.reslineModelId);
        _buf.WriteShort( this.attList.length );
        for (var i = 0; i < this.attList.length; i++) {
            _buf.WriteVarInt(this.attList[i]);
        }
        _buf.WriteVarInt(this.advanceTime);
        _buf.WriteShort( this.devourList.length );
        for (var i = 0; i < this.devourList.length; i++) {
            _buf.WriteVarInt(this.devourList[i]);
        }
        _buf.WriteVarInt(this.advanceNum);
        _buf.WriteVarInt(this.cuilianExp);
        _buf.WriteVarInt(this.cuilianLv);
	},
	
	reading:function( _buf ){
		this.reslineType = _buf.ReadVarInt();
        var equips_length = _buf.ReadShort();
        for (var i = 0; i < equips_length; i++) {
            this.equips[i] = _buf.ReadBean(ItemInfo);
        }
        var euipSkillInfo_length = _buf.ReadShort();
        for (var i = 0; i < euipSkillInfo_length; i++) {
            this.euipSkillInfo[i] = _buf.ReadBean(SkillInfo);
        }
        this.reslineStar = _buf.ReadByte();
        this.level = _buf.ReadVarInt();
        this.exp = _buf.ReadVarInt();
        this.skillBoxNum = _buf.ReadVarInt();
        this.rideReslineModelId = _buf.ReadVarInt();
        this.reslineModelId = _buf.ReadVarInt();
        var attList_length = _buf.ReadShort();
        for (var i = 0; i < attList_length; i++) {
            this.attList[i] = _buf.ReadVarInt();
        }
        this.advanceTime = _buf.ReadVarInt();
        var devourList_length = _buf.ReadShort();
        for (var i = 0; i < devourList_length; i++) {
            this.devourList[i] = _buf.ReadVarInt();
        }
        this.advanceNum = _buf.ReadVarInt();
        this.cuilianExp = _buf.ReadVarInt();
        this.cuilianLv = _buf.ReadVarInt();
	},
});
////////////////////
// 发送整个资源线数据信息  //
////////////////////
var ResSendReslineAllInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineDataInfos = []; // 资源线基本数据信息 ReslineDataInfo
	},

	getId:function(){
		return 214101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.reslineDataInfos.length );
        for (var i = 0; i < this.reslineDataInfos.length; i++) {
            _buf.WriteBean(this.reslineDataInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var reslineDataInfos_length = _buf.ReadShort();
        for (var i = 0; i < reslineDataInfos_length; i++) {
            this.reslineDataInfos[i] = _buf.ReadBean(ReslineDataInfo);
        }
	},

	action:function(){
		Mgr.resline.RecvResSendReslineAllInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个资源线信息 //
////////////////////
var ResSendReslineInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.reslineDataInfo = null; // 单个资源线基本数据信息
	},

	getId:function(){
		return 214102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteBean(this.reslineDataInfo);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.reslineDataInfo = _buf.ReadBean(ReslineDataInfo);
	},

	action:function(){
		Mgr.resline.RecvResSendReslineInfoToClientMessage(this);
	},

});
////////////////////
// 发送当前资源线ID给地图周围的玩家(改变外观) //
////////////////////
var ResReslineIllusionToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.playerId = null; // 玩家ID
        this.reslineModelid = 0; // 资源线ID
        this.devourList = []; // 吞噬所加属性的编号（对应吞噬表的ID） int
	},

	getId:function(){
		return 214103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteLong(this.playerId);
        _buf.WriteShort(this.reslineModelid);
        _buf.WriteShort( this.devourList.length );
        for (var i = 0; i < this.devourList.length; i++) {
            _buf.WriteVarInt(this.devourList[i]);
        }
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
        this.reslineModelid = _buf.ReadShort();
        var devourList_length = _buf.ReadShort();
        for (var i = 0; i < devourList_length; i++) {
            this.devourList[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.resline.RecvResReslineIllusionToClientMessage(this);
	},

});
////////////////////
// 发送升阶（星）结果信息 //
////////////////////
var ResReslineUpResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.isSuccess = 0; // 本次升阶（星）是否成功(1表示成功0表示失败)
        this.exp = 0; // 本次升阶（星）后的祝福值
        this.advanceNum = 0; // 资源线升阶次数
	},

	getId:function(){
		return 214104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteByte(this.isSuccess);
        _buf.WriteVarInt(this.exp);
        _buf.WriteVarInt(this.advanceNum);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.isSuccess = _buf.ReadByte();
        this.exp = _buf.ReadVarInt();
        this.advanceNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.resline.RecvResReslineUpResultToClientMessage(this);
	},

});
////////////////////
// 资源线激活消息 //
////////////////////
var ResReslineAddToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
	},

	getId:function(){
		return 214105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.resline.RecvResReslineAddToClientMessage(this);
	},

});
////////////////////
// 发送资源线技能信息 //
////////////////////
var ResReslineEquipSkillInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.euipSkillInfo = []; // 资源线技能信息 SkillInfo
	},

	getId:function(){
		return 214106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteShort( this.euipSkillInfo.length );
        for (var i = 0; i < this.euipSkillInfo.length; i++) {
            _buf.WriteBean(this.euipSkillInfo[i]);
        }
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        var euipSkillInfo_length = _buf.ReadShort();
        for (var i = 0; i < euipSkillInfo_length; i++) {
            this.euipSkillInfo[i] = _buf.ReadBean(SkillInfo);
        }
	},

	action:function(){
		Mgr.resline.RecvResReslineEquipSkillInfoToClientMessage(this);
	},

});
////////////////////
// 发送资源线淬炼结果信息 //
////////////////////
var ResReslineCuilianResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.isSuccess = 0; // 本次淬炼是否成功(1表示成功0表示失败)
        this.cuilianExp = 0; // 本次淬炼后的经验值
        this.cuilianLv = 0; // 当前资源线淬炼等级
	},

	getId:function(){
		return 214107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteByte(this.isSuccess);
        _buf.WriteVarInt(this.cuilianExp);
        _buf.WriteVarInt(this.cuilianLv);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.isSuccess = _buf.ReadByte();
        this.cuilianExp = _buf.ReadVarInt();
        this.cuilianLv = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.resline.RecvResReslineCuilianResultToClientMessage(this);
	},

});
////////////////////
// 请求资源线信息 //
////////////////////
var ReqSendReslineInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.reslineModelid = 0; // 资源线ID(0表示发送所有资源线列表)
	},

	getId:function(){
		return 214201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteByte(this.reslineModelid);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.reslineModelid = _buf.ReadByte();
	},

});
////////////////////
// 请求资源线激活 //
////////////////////
var ReqReslineAddToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
	},

	getId:function(){
		return 214202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求资源线升阶（星） //
////////////////////
var ReqReslineStratumUpToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.autoUp = 0; // 是否自动购买进阶 （星）（1是自动购买普通进阶 0 是不自动 2是自动购买超级进阶）
        this.costType = 0; // 自动购买升阶（星）的时候选择消耗类型(0表示元宝和绑定元宝，-1表示元宝，-5表示绑定元宝)
	},

	getId:function(){
		return 214203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteByte(this.autoUp);
        _buf.WriteByte(this.costType);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.autoUp = _buf.ReadByte();
        this.costType = _buf.ReadByte();
	},

});
////////////////////
// 请求切换资源线 //
////////////////////
var ReqReslineIllusionToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.reslineModelid = 0; // 资源线ID(0表示隐藏)
	},

	getId:function(){
		return 214204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.reslineType);
        _buf.WriteShort(this.reslineModelid);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadByte();
        this.reslineModelid = _buf.ReadShort();
	},

});
////////////////////
// 请求资源线吞噬或关闭吞噬 //
////////////////////
var ReqReslinekDevourToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.resourseType = 0; // 吞噬所加属性的编号（对应吞噬表的ID)
	},

	getId:function(){
		return 214205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteByte(this.resourseType);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.resourseType = _buf.ReadByte();
	},

});
////////////////////
// 请求技能升级 //
////////////////////
var ReqReslineSkillUpByModelidToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.type = 0; // 类型（0为普通升级消耗一本书，1为一键升级消耗每次最多50本）
        this.skillModelId = 0; // 技能ID
	},

	getId:function(){
		return 214206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.skillModelId);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
        this.skillModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 其他请求操作通用消息 //
////////////////////
var ReqReslineExtendToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
        this.opType = 0; // 操作类型（比如升阶 升技能 切换外显 这些操作都可以）
        this.parameters = null; // 操作参数（前后端自己定义解析格式）
	},

	getId:function(){
		return 214207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
        _buf.WriteByte(this.opType);
        _buf.WriteString(this.parameters);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
        this.opType = _buf.ReadByte();
        this.parameters = _buf.ReadString();
	},

});
////////////////////
// 请求资源线淬炼结 //
////////////////////
var ReqReslineCuilianToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.reslineType = 0; // 资源线类型
	},

	getId:function(){
		return 214208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reslineType);
	},
	
	reading:function( _buf ){
        this.reslineType = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(214101, ResSendReslineAllInfoToClientMessage);
MESSAGE_POOL.Add(214102, ResSendReslineInfoToClientMessage);
MESSAGE_POOL.Add(214103, ResReslineIllusionToClientMessage);
MESSAGE_POOL.Add(214104, ResReslineUpResultToClientMessage);
MESSAGE_POOL.Add(214105, ResReslineAddToClientMessage);
MESSAGE_POOL.Add(214106, ResReslineEquipSkillInfoToClientMessage);
MESSAGE_POOL.Add(214107, ResReslineCuilianResultToClientMessage);

