
var ReslineModMgr = ReslineModMgr || cc.Class.extend({
		_reslineMgrHash:null,
		_resPanelHash:null,
		firstUrl:null,
		ctor:function()
		{
			this._reslineMgrHash = new HashMap();
			this._resPanelHash = new HashMap();
		},

		SetListToHash:function(reslineinfolist)
		{
			var key;
			var resLineModelId = new HashMap();
			for ( key in reslineinfolist)
			{
				resLineModelId.Put( reslineinfolist[key].type, reslineinfolist[key].modelid );
			}
			return resLineModelId;
		},
		GetResPanel:function( reslinetype )
		{
			if ( this._resPanelHash.Get(reslinetype) != null )
				return this._resPanelHash.Get(reslinetype);
			return null;
		},
		IsShowPanel:function ( reslinetype )
		{
			//  (书童单独分出来了，所以这得分开处理)
			var panel;
			if ( reslinetype == EnumResline.SHUTONG || reslinetype == EnumResline.BAOQI || reslinetype == EnumResline.JIANLING || reslinetype == EnumResline.ZHAOSHI ) {
				panel = Mgr.uiMgr.GetPanelByType( ShuTongPanelExt.PanelName );
			}
			else {
				panel = Mgr.uiMgr.GetPanelByType( PlayerPanelExt.PanelName )
			}
			if ( panel && Mgr.uiMgr.IsPanelShow(panel) && panel.IsResline( reslinetype ) )
				return true;
			else
				return false;
		},
		_CheckZhuFu:function (reslineType) {
			if ( reslineType == EnumResline.HORSE || reslineType == EnumResline.DRAGON
				|| reslineType == EnumResline.GUANGWU || reslineType == EnumResline.SHUTONG
				|| reslineType == EnumResline.BAOQI )
			{
				var reslineMgr = Mgr.resline.GetMgrByType(reslineType);
				var q_base = Q_resline_up.Get( reslineType + "_" + reslineMgr.GetLayer() + "_" + reslineMgr.GetStars() );
				if ( q_base && q_base.q_reset_time > 0 && reslineMgr.nowBlessnum > 0 )
					return true;
			}
			return false;
		},
		GetGeneralSystemSkillLev:function(reslinetype, q_skillId)
		{
			return this.GetMgrByType(reslinetype).GetSysSkillLev(q_skillId);
		},
		GetSkillArr:function( reslinetype )
		{
			return this.GetMgrByType(reslinetype).GetSkillArray();
		},
		GetAttList:function(reslinetype)
		{
			var reslineDataInfo = this.GetMgrByType( reslinetype ).GetCurReslineDataInfo();
			if ( reslineDataInfo == null )
				return [];
			return reslineDataInfo.attList;
		},
		GetLevel:function(reslinetype)
		{
			return this.GetMgrByType( reslinetype ).level;
		},
		GetBaseData:function (reslinetype, mid)
		{
			return Q_resline.Get( reslinetype + "_" + id );
		},
		GetBaseUpData:function(reslinetype, id)
		{
			return Q_resline_up.Get(reslinetype+ "_" + id);
		},
		GetBaseAdditionData:function(reslinetype, nextid)
		{
			return Q_resline_addition.Get(reslinetype.toString() + "_" + nextid);
		},
		 GetMgrByType:function(reslinetype)
		{
			if ( this._reslineMgrHash.Get(reslinetype) == null )
			{
				var mgr = new SubReslineMgr();
				mgr.SetReslineType(reslinetype);
				switch ( reslinetype )
				{
					case EnumResline.GIANT:
						mgr.potentialUrl = "other/juese/zuoqi/image/icon/lvjurenqiannengdan.png";
						mgr.fluctuateUrl = "other/juese/zuoqi/image/icon/lvjurenhuanhuadan.png";
						break;
					default:
						mgr.potentialUrl = "other/juese/zuoqi/image/icon/" + reslinetype + "/qiannengdan.png";
						mgr.fluctuateUrl = "other/juese/zuoqi/image/icon/" + reslinetype + "/huanhuadan.png";
						break;
				}

				this._reslineMgrHash.Put( reslinetype, mgr );
			}
			else
			{
				mgr = this._reslineMgrHash.Get(reslinetype);
			}

			return mgr;
		},

		//整个资源线数据信息
		RecvResSendReslineAllInfoToClientMessage:function(msg) {
			for ( var i = 0; i < msg.reslineDataInfos.length; i ++ )
			{
				var type = msg.reslineDataInfos[i].reslineType;
				if(type == EnumResline.HORSE){
                    this.firstUrl = "res/animation/parts/mounts/"+msg.reslineDataInfos[i].level+"/down"
				}
				// 面板
				var mgr = this.GetMgrByType( type );

				var reslineModeId = msg.reslineDataInfos[i].rideReslineModelId;
				if ( reslineModeId < 0 )
					msg.reslineDataInfos[i].rideReslineModelId = 0;
				mgr._lastEquipModel = Math.abs(reslineModeId);
				mgr.RecAllInfoToClient( msg.reslineDataInfos[i] );

				// 资源线
				Mgr.mainPlayer.UpdateReslineModelid( type, msg.reslineDataInfos[i].rideReslineModelId);
				Mgr.mainPlayer.RefreshResline(type);
			}
		},
		//单个资源线信息
		RecvResSendReslineInfoToClientMessage:function(msg) {
			cc.log("RecvResSendReslineInfoToClientMessage");
			var mgr = this.GetMgrByType( msg.reslineType );
			var reslineModeId = msg.reslineDataInfo.rideReslineModelId;
			if ( reslineModeId < 0 )
				msg.reslineDataInfo.rideReslineModelId = 0;
			mgr._lastEquipModel = Math.abs(reslineModeId);
			mgr.RecAllInfoToClient(msg.reslineDataInfo);
		},
		//收到当前资源线ID给地图周围的玩家(改变外观)
		RecvResReslineIllusionToClientMessage:function(msg) {
			// var reslineInfo = Mgr.player.mainPlayer.playerResLineInfo;
			// for(var i = 0, len = reslineInfo.length; i < len; i++){
			// 	var resline = reslineInfo[i];
			// 	if(resline.type == msg.reslineType){
			// 		resline.modelid = msg.reslineModelid;
			// 	}else
			// 		{
			// 			reslineInfo.push({type:msg.reslineType, modelid:msg.reslineModelid});
			// 		}
			// }
			this.GetMgrByType(msg.reslineType).recReslineIllusionToClient(msg);
		},
		//进阶结果
		RecvResReslineUpResultToClientMessage:function(msg) {
			cc.log("RecvResReslineUpResultToClientMessage");
			var mgr = this.GetMgrByType( msg.reslineType );
			mgr.advanceNum = msg.advanceNum;
			var stagePanel = mgr.GetReslineMainPanel();
			var isPanelShow = this.IsShowPanel(msg.reslineType);
			if ( msg.isSuccess == 1 ) // 成功
			{
				if( isPanelShow )
				{
					//进来必然有
					stagePanel.ShowStageUpEffect( true );
					// stagePanel.showSkillActiveEffect();
				}
				var baseData = this.GetBaseUpData( msg.reslineType, mgr.GetLayer() + "_" + mgr.GetStars().toString() );
				if ( baseData != null )
				{
					var stars = this.GetTarStars(msg.reslineType);
					var info , html;
					if ( stars > 0 ) {
						html = "恭喜您，{1}进阶成功至【{2} {3}星】";
						info = TextUtil.ConectParam(html , [ this.GetNameByType(msg.reslineType), baseData.q_name,stars.toString() ] );
					}
					else {
						html = "恭喜您，{1}进阶成功至【{2}】";
						info = TextUtil.ConectParam(html , [ this.GetNameByType(msg.reslineType), baseData.q_name ] );
					}
					Mgr.tips.ShowNotice(info);
					if( stagePanel )
						stagePanel.showInfo();
				}

				if ( stagePanel )
				{
					stagePanel.stopAutoStageUp();
					stagePanel.UpdateBlessing(true);
					// 显示下一阶属性
					stagePanel.ShowNextAttribute(mgr.curShowLayer, mgr.GetCurShowStars());
				}

				this.SendReqReslineIllusionToGameMessage( msg.reslineType, mgr.GetLayer() );

				// 升阶成功panel
				var panel = Mgr.uiMgr.ShowPanelByType(JinJieMainExt.PanelName);
				panel.SetData(msg.reslineType);
			}
			else
			{
				var addBless = msg.exp - mgr.nowBlessnum;
				mgr.nowBlessnum = msg.exp;
				if( isPanelShow )
				{
					stagePanel.ShowStageUpEffect( false, addBless );
					stagePanel.UpdateBlessing();
					// 显示下一阶属性
					stagePanel.ShowNextAttribute(mgr.curShowLayer, mgr.GetCurShowStars());
				}
				else {
					stagePanel.stopAutoStageUp();
				}

				// Mgr.taskPanelMgr.updateTaskTrackOperation(EnumOperationType.TYPE_GIANT_BLESSVALUE+(msg.reslineType-EnumPlayerPanel.SHOW_TYPE_RESLINE)*2, mgr.nowBlessnum > 0);
			}
		},

		GetNameByType:function( reslinetype ){
			var type = BtnGroupUtil.M_ROLE;
			var subType;
			if ( reslinetype == EnumResline.HORSE )
				subType = BtnGroupUtil.ROLE_RIDE;
			else if ( reslinetype == EnumResline.GUANGWU )
				subType = BtnGroupUtil.ROLE_GUANGWU;
			else if ( reslinetype == EnumResline.DRAGON )
				subType = BtnGroupUtil.ROLE_DRAGON;
			else if ( reslinetype == EnumResline.SHUTONG ) {
				type = BtnGroupUtil.M_SHUTONG;
				subType = BtnGroupUtil.SHUTONG_SHUTONG;
			}
			else if ( reslinetype == EnumResline.BAOQI ) {
				type = BtnGroupUtil.M_SHUTONG;
				subType = BtnGroupUtil.SHUTONG_RIDE;
			}
			else if ( reslinetype == EnumResline.WUXUE ) {
				subType = BtnGroupUtil.ROLE_WUXUE;
			}
			else if ( reslinetype == EnumResline.STEP ) {
				type = BtnGroupUtil.M_SHUTONG;
				subType = BtnGroupUtil.SHUTONG_JIAOYING;
			}
            else if ( reslinetype == EnumResline.ZHAOSHI ) {
                type = BtnGroupUtil.M_SHUTONG;
                subType = BtnGroupUtil.SHUTONG_JIANZHAO;
            }
            else if ( reslinetype == EnumResline.JIANLING ) {
                type = BtnGroupUtil.M_SHUTONG;
                subType = BtnGroupUtil.SHUTONG_JIANLING;
            }

			var q_func = Q_newfunc.Get( BtnGroupUtil.toKey(type, subType) );
			var reslinename = "资源线" + type;
			if ( q_func != null )
				reslinename = q_func.q_string_name;
			return reslinename;
		},

		GetTarStars:function(reslineType)
		{
			return this.GetMgrByType( reslineType ).GetStars();
		},

		RecvResReslineAddToClientMessage:function(msg) {
			this.GetMgrByType(msg.reslineType).RecReslineAddToClient();
		},

		RecvResReslineEquipSkillInfoToClientMessage:function(msg) {
			this.GetMgrByType(msg.reslineType).RecReslineEquipSkillInfoToClient(msg.euipSkillInfo);
			var playerPanel = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName);
			var shuTongPanel = Mgr.uiMgr.GetPanelByType(ShuTongPanelExt.PanelName);
			var panel = Mgr.uiMgr.GetPanelByType(JiNengShengJiExt.PanelName);
			if(Mgr.uiMgr.IsPanelShow(playerPanel)){
				playerPanel._reslinePanelDic[msg.reslineType].showInfo();
			}

			if(Mgr.uiMgr.IsPanelShow(shuTongPanel)){
				if( shuTongPanel.showType == msg.reslineType )
					shuTongPanel.showPanel.showInfo();
			}

			if(Mgr.uiMgr.IsPanelShow(panel)){
				if(panel._skillLv < 9){
                    panel.SetData({skillParameter:{reslinetype:msg.reslineType},skillmid:panel._skillMid, skilllv:panel._skillLv + 1});
				}else {
					Mgr.uiMgr.HidePanel(panel);
				}
			}
		},
		/**请求资源线信息*/
		SendReqSendReslineInfoToGameMessage:function(reslinetype, modelId) {
			this.GetMgrByType(reslinetype).SendReqSendReslineInfoToGameMessage(modelId);
		},
		/**激活资源线*/
		SendReqReslineAddToGameMessage:function(reslinetype) {
			this.GetMgrByType(reslinetype).SendReqReslineAddToGameMessage();
		},
		/**请求资源线升级*/
		SendReqReslineStratumUpToGameMessage:function(reslinetype, costType, isAuto) {
			costType = arguments[1] ? arguments[1] : 0;
			isAuto = arguments[2] ? arguments[2] : 0;
			this.GetMgrByType(reslinetype).SendReqReslineStratumUpToGameMessage(costType, isAuto);
		},
		/**请求切换资源线*/
		SendReqReslineIllusionToGameMessage:function(reslineType, modelid) {
			this.GetMgrByType(reslineType).SendReqReslineIllusionToGameMessage(modelid);
		},
		/**请求资源线吞噬或关闭吞噬*/
		SendReqReslinekDevourToGameMessage:function(resourseType) {
			this.GetMgrByType(reslineType).SendReqReslinekDevourToGameMessage(resourseType);
		},
		/**请求资源线技能升级*/
		SendReqReslineSkillUpByModelidToGameMessage:function(reslineType,skillid, type) {
			this.GetMgrByType(reslineType).SendReqReslineSkillUpByModelidToGameMessage(skillid, type);
		},
		/**其他请求操作通用消息(没用到)*/
		SendReqReslineExtendToGameMessage:function(optype, parameters) {
			this.GetMgrByType(reslineType).SendReqReslineExtendToGameMessage(optype, parameters);
		},
		GetResTypeByEquipType:function (eType) {
            switch (eType) {
                case EnumItemType.MountEquip:
                    return EnumResline.HORSE;
                case EnumItemType.BaoQiEquip:
                    return EnumResline.BAOQI;
                    break;
                case EnumItemType.GirlEquip:
                    return EnumResline.SHUTONG;
                case EnumItemType.FaqiEquip:
                    return EnumResline.DRAGON;
                case EnumItemType.GuangWuEquip:
                    return EnumResline.GUANGWU;
				case EnumItemType.EQUIP_MARTIALARTS:
					return EnumResline.WUXUE;
				case EnumItemType.EQUIP_STEP:
					return EnumResline.STEP;
				case EnumItemType.EQUIP_ZHAOSHI:
					return EnumResline.ZHAOSHI;
				case  EnumItemType.EQUIP_JIANLING:
					return EnumResline.JIANLING;
            }
        },

		UnEquipResline:function(type){
			type = type || EnumResline.HORSE;
			var sub_mgr = this.GetMgrByType(type);
			var mid = sub_mgr.GetEquipModelId();
			if( mid > 0 )
				sub_mgr.SendReqReslineIllusionToGameMessage(-mid);

			if(type == EnumResline.HORSE){
				var panel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName);
				panel.sbtnZuoqi.SetButtonState("uncheck");
			}
		},

		EquipResline:function(type){
			type = type || EnumResline.HORSE;
			var sub_mgr = this.GetMgrByType(type);
			var mid = sub_mgr.GetEquipModelId();
			if( mid < 0 )
				sub_mgr.SendReqReslineIllusionToGameMessage(-mid);
			else if( mid == 0 ){
				mid = sub_mgr.GetLayer();
				if( mid > 0 )
					sub_mgr.SendReqReslineIllusionToGameMessage(mid);
			}

            if(type == EnumResline.HORSE){
                var panel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName);
                panel.sbtnZuoqi.SetButtonState("check");
            }
		}
	});