var TuojiguaMainExt = TuojiguaMain.extend ( {
	_className:"TuojiguaMainExt",
	_vScrollView:null,
	_vGap:12,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
	},
	
	Init: function () {
		TuojiguaMain.prototype.Init.call(this);
		this.InitPageView();
		UIUtil.UIRemoveSelf(this.imgB11);
		UIUtil.UIRemoveSelf(this.labCue3);
		UIUtil.UIRemoveSelf(this.labCue4);

		this.btnClose.addClickEventListener(function () {
			EngineMgr.uiMgr.HidePanelByType(TuojiguaMainExt.PanelName);
		});
		this.btnYep.addClickEventListener(function () {
			EngineMgr.uiMgr.HidePanelByType(TuojiguaMainExt.PanelName);
		});
		
		this.btnSeting.addClickEventListener(function () {
			//这里打开挂机设置面板
			EngineMgr.uiMgr.ShowPanelByType(SettingPanelExt.PanelName).ChangePanel(SetTypeEnum.SETTING_HOOK);
		});
	},

	InitPageView:function(){
		this._vScrollView = ccui.ScrollView();
		this._vScrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
		this._vScrollView.setTouchEnabled(true);
		this._vScrollView.inertiaScrollEnabled=false;
		this._vScrollView.setScrollBarEnabled(false);
		this._vScrollView.setBounceEnabled(true);
		this._vScrollView.y = this.imgB11.y + this._vGap - this.imgB11.uiHeight;
		this.addChild(this._vScrollView);
		this._vScrollView.setSize(cc.size(this.uiWidth, this.imgB11.uiHeight+this._vGap*2));
	},
	
	SetInfo:function(pluginTime,remainTime,exp,items){
		this.labCue.SetText(TextUtil.FormatStr( this.labCue.GetHtmlText(), [ TextUtil.SecondToHMS2( pluginTime ), TextUtil.SecondToHMS2( remainTime ) ] ));
		this.labCue1.SetText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ Mgr.player.mainPlayer.attributeData.level ] ));
		this.labCue2.SetText(TextUtil.FormatStr( this.labCue2.GetHtmlText(), [ exp ] ));
		for(var i = 0; i < items.length; i++){
			var iteminfo = items[i];
			var q_item = Q_item.Get(iteminfo.itemModelId);
			var nameStr = q_item.q_name + "x" + iteminfo.num;
			var color = ItemUtil.GetNameColorById(q_item.q_id);
			if (color)
				nameStr = TextUtil.AddColor(nameStr,parseInt(color[0]).toString(16));

			var img = new MUIImage();
			img.ParseJson( this.imgB11.jsonobj );
			img.Init();
			img.x = this.imgB11.initX;
			img.y = i*(this._vGap+img.uiHeight)+this._vGap;
			this._vScrollView.addChild(img);

			var itemLab = new MUILabel();
			itemLab.ParseJson( this.labCue3.jsonobj );
			itemLab.Init();
			itemLab.x = this.labCue3.initX;
			itemLab.y = img.y-1;
			itemLab.SetText(nameStr);
			this._vScrollView.addChild(itemLab);
		}
		if( i > 0 )
			this._vScrollView.setInnerContainerSize(cc.size(this.uiWidth, i*(this._vGap+img.uiHeight)+this._vGap ));
	},
	
	OnHide: function () {
		cc.log("脱机挂面板关闭");
	}
} );
TuojiguaMainExt.PanelName = "TuojiguaMainExt";
PanelClassDic["TuojiguaMainExt"] = TuojiguaMainExt;
