var BuyPanelExt = BuyPanel.extend ( {
	_className:"BuyPanelExt",
	goods:null,
	buyNums:1,
	isDown:false,                //是不是持续按下的状态
	updateId:null,
	downTime:0,
	aOrS:0,                     //按下的是哪一个按钮
	maxNum:0,
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.ALPHABLACK;
		this.layoutCom.layoutType = MLLAYOUT_C;
	},
	Init:function() {
		var self = this;
		Mgr.shop.buyPanel=this;
		BuyPanel.prototype.Init.call(this);
		self.btnClose.addClickEventListener(function (event) {
			self.Close();
		});

		var scale = 0.5;
		this.imgGold.ignoreContentAdaptWithSize(true);
		this.imgGold.scale = scale;
		this.imgGold1.ignoreContentAdaptWithSize(true);
		this.imgGold1.scale = scale;
		this.imgGold11.ignoreContentAdaptWithSize(true);
		this.imgGold11.scale = scale;
		this.imgGold2.ignoreContentAdaptWithSize(true);
		this.imgGold2.scale = scale;

		var ee=new MUINumberEdit();
		ee.jsonobj=this.labBuyNums.jsonobj;
		ee.Init();
		this.imgList.removeChild(this.labBuyNums);
		this.imgList.addChild(ee);
		this.labBuyNums=ee;

		self.labBuyNums.setString(self.buyNums);
		// self.labBuyNums.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC );
		self.labBuyNums.setDelegate(this);
		self.labBuyNums.setPlaceHolder(1);

		self.btnJia.addTouchEventListener(function (event,target) {
			if(target==2) {
				if(self.updateId)
					self.TouchEnd();
				if (self.buyNums < self.maxNum) {
					self.buyNums++;
					self.labBuyNums.setString(self.buyNums);
				}
				self._UpDateMoney();
				if(self.buyNums>=self.maxNum){
					Mgr.tips.ShowNotice("货币不足或者达到单次最大购买量");
				}
			}
			//如果是点下去没起来就开一个时间表
			if(target==0){
				self.GetMaxNum();
				self.isDown=true;
				self.aOrS=1;
				self.updateId = TimerUtil.TimeUpdate(self.OnFrame,self,1);
			}
			if(target==3){
				self.TouchEnd();
			}
		});

		self.btnJian.addTouchEventListener(function (event,target) {
			if(target==2) {
				if(self.updateId)
					self.TouchEnd();
				if (self.buyNums > 1) {
					self.buyNums--;
					self.labBuyNums.setString(self.buyNums);
				}
				if(self.buyNums<=1){
					Mgr.tips.ShowNotice("购买数量必须大于0");
				}
				self._UpDateMoney();
			}
			if(target==0){
				self.GetMaxNum();
				self.isDown=true;
				self.aOrS=-1;
				self.updateId = TimerUtil.TimeUpdate(self.OnFrame,self,1);
			}
			if(target==3){
				self.TouchEnd();
			}
		});

		this.btnMax.addClickEventListener(function () {
			self.labBuyNums.setString(self.maxNum);
			self.buyNums=self.maxNum;
			self._UpDateMoney();
		});

		self.btnBuy.addClickEventListener(function (event) {
			if(self.buyNums<1){
				Mgr.tips.ShowNotice("购买数量必须大于1");
				return;
			}
			var newGoods = self.goods;
			self.GetMaxNum();
			var moneyType = self.GetMoneyType();
			var money=ShopUtil.GetMoneyByShop(moneyType);
			var need = parseInt(self.labMoney11.GetString());
			cc.log("======btnBuy====" + need + "   "  + "   " + moneyType + "  "+ money + "  " + Mgr.mainPlayer.attributeData.GetAttribute(EnumMoney.TIME_GOLD, AttributeData.Money));
			if(need > money){
				if( self.goods.shopNum == 1 ){
					AlertExt.NoEnoughGold(need - money);
					EngineMgr.uiMgr.HidePanelByType(BuyPanelExt.PanelName);
				}
				else{
					Mgr.tips.ShowNotice("货币不足");
				}
				return;
			}
			EngineMgr.uiMgr.HidePanelByType(BuyPanelExt.PanelName);
			Mgr.shop.SendReqBuyItemMessage(
				newGoods.shopNum,
				newGoods.itemModelId,
				newGoods.shopItemId,
				newGoods.shopItemSid,
				newGoods.moneyInfo,
				ShopUtil.GetMoneyTypeByShop(moneyType),
				self.buyNums);
			self.buyNums = 1;
			self.labBuyNums.setString(self.buyNums);
		});


		this.labMoney1.setTouchEnabled(true);
		this.imgGold2.setTouchEnabled(true);
		this.labMoney111.setTouchEnabled(true);
		this.imgGold1.setTouchEnabled(true);

		var handler1 = function(){
			this.sbtnGold2.SetButtonState("check",true);
			this.GetMaxNum();
			this.buyNums = Math.min(this.buyNums,this.maxNum);
			this.labBuyNums.setString(this.buyNums);
		}.bind(this);
		var handler2 = function(){
			this.sbtnGold3.SetButtonState("check",true);
			this.GetMaxNum();
			this.buyNums = Math.min(this.buyNums,this.maxNum);
			this.labBuyNums.setString(this.buyNums)
		}.bind(this);
		this.labMoney1.addClickEventListener(handler1);
		this.imgGold2.addClickEventListener(handler1);
		this.sbtnGold2.addClickEventListener(handler1);
		this.labMoney111.addClickEventListener(handler2);
		this.imgGold1.addClickEventListener(handler2);
		this.sbtnGold3.addClickEventListener(handler2);
	},
	GetMoneyType:function(){
		if(this.goods.shopNum == EnumShopType.GOLD_SHOP){
			return this.sbtnGold2.GetState() == "check" ? EnumShopType.GOLD_SHOP
				: EnumShopType.BINDGOLD_SHOP;
		}else{
			return this.goods.shopNum;
		}
	},

	Close:function(){
		this.buyNums = 1;
		this.labBuyNums.setString(this.buyNums);
		EngineMgr.uiMgr.HidePanelByType(BuyPanelExt.PanelName);
	},

	editBoxTextChanged :function(){
		var ediText = this.labBuyNums.getString();
		if(ediText==""){
			this.labBuyNums.setString(1);
			return;
		}
		Mgr.shop.buyPanel.buyNums=parseInt(ediText);
		if(!Mgr.shop.buyPanel.buyNums){
			Mgr.shop.buyPanel.buyNums=1;
		}
		if(this.buyNums>this.maxNum){
			this.buyNums=this.maxNum;
			this.labBuyNums.setString(this.buyNums);
			return;
		}
		Mgr.shop.buyPanel._UpDateMoney();
	},
	SetData:function(goods){
		//getgoods
		this.goods=goods;
		this.type = goods.shopNum;

		this.GetMaxNum();
		//name
		this.labName.SetString(goods.name);
		//danjia
		this.labMoney.SetString(Math.ceil(goods.price));
		this.labMoney11.SetString(this.buyNums * Math.ceil(goods.price));
		//moneyType
		var imageRes = ShopUtil.GetImageRes(goods.shopNum);
		this.imgGold.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
		this.imgGold11.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);


		this.sbtnGold2.SetButtonState("uncheck",true);
		this.sbtnGold2.SetButtonState("check",true);
		if( goods.shopNum == EnumShopType.GOLD_SHOP){
			this.sbtnGold3.visible = true;
			this.labMoney111.visible = true;
			this.imgGold1.visible = true;
			this.sbtnGold2.setTouchEnabled(true);

			this.imgGold1.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
			this.imgGold2.loadTexture("public/image/chongzhiyuanbao.png", ccui.Widget.PLIST_TEXTURE);
			this.imgGold2.scale = 0.8;

			this.labMoney1.SetString("充值元宝");
		}else{
			this.sbtnGold3.visible = false;
			this.labMoney111.visible = false;
			this.imgGold1.visible = false;
			this.sbtnGold2.setTouchEnabled(false);

			this.imgGold2.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
			this.imgGold2.scale = 0.5;

			var moneyType = ShopUtil.GetMoneyTypeByShop(goods.shopNum);
			var moneyName = ShopUtil.GetMoneyNameByType(moneyType) || "";
			this.labMoney1.SetString(moneyName);
		}

		GridUtil.SetItemGrid(this.gridItem,goods);
	},
	TouchEnd:function(){
		if(this.updateId)
			TimerUtil.ClearTimeUpdate(this.updateId,this);
		this.updateId=null;
		this.downTime=0;
		this.isDown=false;
	},
	GetMaxNum:function(){
		var moneyType = this.GetMoneyType();
		var money=ShopUtil.GetMoneyByShop(moneyType);
		var param = JSON.parse(this.goods.item.parameters);
		this.maxNum= Math.floor(money/this.goods.price);

		if(this.maxNum>this.goods.labOverlapNum)
			this.maxNum=this.goods.labOverlapNum;
		if(param && this.maxNum > param.SHOP_SELL_NUM){
			this.maxNum = param.SHOP_SELL_NUM;
		}
        if(this.maxNum==0)
            this.maxNum=1;
	},

	OnFrame:function(){
		if(this.downTime<1){
			this.downTime++;
			return;
		}
		this.buyNums+=this.aOrS*5;
		if(this.buyNums<0)
			this.buyNums=0;
		if(this.buyNums>this.maxNum)
			this.buyNums=this.maxNum;
		this.labBuyNums.setString(this.buyNums);                      //在安卓上的时候监听的是Label应该这样才对
	},
	_UpDateMoney:function(){
		this.labMoney11.SetString(this.buyNums * Math.ceil(this.goods.price));
	}
} );
BuyPanelExt.PanelName = "BuyPanelExt";
PanelClassDic["BuyPanelExt"] = BuyPanelExt;
