///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ShortCutBarInfo 快捷信息类

// 请求消息
//119201,ReqShortCutBarHandle 快捷键操作

// 接收消息
//119101,ResShortCutInfo 发送快捷栏信息
//119102,ResShortCutBarAdd 增加快捷栏
//119103,ResShortCutBarRemove 删除快捷栏


var ShortCutBarInfo = cc.Class.extend({
	ctor:function(){
		this.shortCutBarType = 0; // 快捷栏类型
        this.modelId = 0; // 快捷对象模板
        this.position = 0; // 快捷位置
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.shortCutBarType);
        _buf.WriteVarInt(this.modelId);
        _buf.WriteVarInt(this.position);
	},
	
	reading:function( _buf ){
		this.shortCutBarType = _buf.ReadVarInt();
        this.modelId = _buf.ReadVarInt();
        this.position = _buf.ReadVarInt();
	},
});
////////////////////
// 发送快捷栏信息 //
////////////////////
var ResShortCutInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.shortCutBarList = []; // 快捷信息列表 ShortCutBarInfo
	},

	getId:function(){
		return 119101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.shortCutBarList.length );
        for (var i = 0; i < this.shortCutBarList.length; i++) {
            _buf.WriteBean(this.shortCutBarList[i]);
        }
	},
	
	reading:function( _buf ){
        var shortCutBarList_length = _buf.ReadShort();
        for (var i = 0; i < shortCutBarList_length; i++) {
            this.shortCutBarList[i] = _buf.ReadBean(ShortCutBarInfo);
        }
	},

	action:function(){
		Mgr.shortcutbar.RecvResShortCutInfoMessage(this);
	},

});
////////////////////
// 增加快捷栏 //
////////////////////
var ResShortCutBarAddMessage = cc.Class.extend( {
	ctor:function(){
		this.shortCutBarInfo = null; // 快捷信息
	},

	getId:function(){
		return 119102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.shortCutBarInfo);
	},
	
	reading:function( _buf ){
        this.shortCutBarInfo = _buf.ReadBean(ShortCutBarInfo);
	},

	action:function(){
		Mgr.shortcutbar.RecvResShortCutBarAddMessage(this);
	},

});
////////////////////
// 删除快捷栏 //
////////////////////
var ResShortCutBarRemoveMessage = cc.Class.extend( {
	ctor:function(){
		this.position = 0; // 快捷位置
	},

	getId:function(){
		return 119103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.position);
	},
	
	reading:function( _buf ){
        this.position = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.shortcutbar.RecvResShortCutBarRemoveMessage(this);
	},

});
////////////////////
// 快捷键操作 //
////////////////////
var ReqShortCutBarHandleMessage = cc.Class.extend( {
	ctor:function(){
		this.handleType = 0; // 操作类型(0 增 1删 2移)
        this.shortCutBarType = 0; // 快捷栏类型
        this.modelId = 0; // 快捷对象模板
        this.handledPosition = 0; // 被操作的位置
        this.tarPosition = 0; // 目标位置
	},

	getId:function(){
		return 119201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.handleType);
        _buf.WriteVarInt(this.shortCutBarType);
        _buf.WriteVarInt(this.modelId);
        _buf.WriteVarInt(this.handledPosition);
        _buf.WriteVarInt(this.tarPosition);
	},
	
	reading:function( _buf ){
        this.handleType = _buf.ReadByte();
        this.shortCutBarType = _buf.ReadVarInt();
        this.modelId = _buf.ReadVarInt();
        this.handledPosition = _buf.ReadVarInt();
        this.tarPosition = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(119101, ResShortCutInfoMessage);
MESSAGE_POOL.Add(119102, ResShortCutBarAddMessage);
MESSAGE_POOL.Add(119103, ResShortCutBarRemoveMessage);

