var CangKuPanelExt = CangKuPanel.extend ( {
	_className:"CangKuPanelExt",
    scrPan:null,
    itemHs:null,
    gridNum:0,
    showGrid:null,
    showNum:null,
    ctor:function(){
        this._super();
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
        this.isShowTween = true;
        this.itemHs=new HashMap();
        Mgr.store.findGoldPanel=this;
        this.layoutCom.layoutType = MLLAYOUT_C;
    },
    Init:function(){
        CangKuPanel.prototype.Init.call( this );
        this.imgXiaoguo.retain();        //一只存着
        this.imgXiaoguo.x=0;
        this.imgXiaoguo.y=0;
        this.setTouchEnabled(true);
        var tableView = new cc.TableView(this,cc.size(756, 433));
        tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
        tableView.setDelegate(this);
        tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
        this.scrPan=tableView;
        this.img1.addChild(tableView);
        tableView.reloadData();
        var self=this;
        this.btnClose.addClickEventListener(function(){
            EngineMgr.uiMgr.HidePanelByType(CangKuPanelExt.PanelName);
        });
        this.btn1.visible = false;
        // this.btn1.addClickEventListener(function(){
        //     if(Mgr.store.choose) {
        //         if (Mgr.backpack.GetEmptyGrid())
        //             Mgr.store.SendReqStoreToBagMessage(Mgr.store.choose.itemId, 0, EnumStore.LUCKY);
        //          else
        //             Mgr.tips.ShowNotice( "角色背包剩余空间不足，无法取出");
        //     }else {
        //         Mgr.tips.ShowNotice( "选择要取出的道具");
        //     }
        // });
        this.btn11.addClickEventListener(function(){
            Mgr.store.choose=null;
            Mgr.store.SendReqStoreClearUpMessage(EnumStore.LUCKY);
        });
        this.btn2.addClickEventListener(function(){
            if(Mgr.backpack.GetEmptyGrid()>self.itemHs.Values().length) {
                Mgr.store.SendReqGetOutStoreAllItemsMessage(EnumStore.LUCKY);
            }
            else Mgr.tips.ShowNotice( "角色背包剩余空间不足，无法取出");
            //全部取出
        });
    },
    ClearItem:function(){
        this.itemHs.Clear();
        this.scrPan.reloadData();
    },
    SetData:function(gridNum,items){
        this.gridNum=gridNum;
        this.itemHs=ItemUtil.ArrangeItem(items,true);
        this.scrPan.reloadData();
    },
    ShowEffect:function (gg) {
        this.imgXiaoguo.setVisible(true);
        this.imgXiaoguo.removeFromParent();
        gg.addChild(this.imgXiaoguo,1000);
        this.showGrid=gg;
        this.showNum=gg.nn;
    },
    HideEffect:function () {
        this.imgXiaoguo.setVisible(false);
    },
    UpdateItemById:function (id) {
        if( !Mgr.uiMgr.IsPanelShow( this ) )
            return;
        var item = this.GetItemById(id);
        if(!item)
            return;
        var grid =  Mgr.store.showHash.Get( item.gridId-1);
        if(grid){
            grid.SetItemInfo(null, GridTypeEnum.BACKPACK,true);
            grid.SetItemInfo(item, GridTypeEnum.BACKPACK, Mgr.backpack.showLock);
        }
        if( Mgr.store.choose.gridId== item.gridId){
            Mgr.store.choose=item;
        }
    },
    GetItemById:function (id) {
        var list=this.itemHs.Values();
        for(var i=0;i<list.length;++i){
            if(list[i].itemId.hexValue==id.hexValue){
                return list[i];
            }
        }
        return null;
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(852,96);
    },
    tableCellAtIndex: function (table, idx) {
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item=new StoreGridListExt();
            item.LoadPanel();
            item.SetParent(this);
            item.SetData(idx);
            cell.item=item;
            cell.addChild(item);
        } else {
            cell.item.SetData(idx);
        }
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return Math.ceil(this.gridNum/8);
    }
} );
CangKuPanelExt.PanelName = "CangKuPanelExt";
PanelClassDic["CangKuPanelExt"] = CangKuPanelExt;
