var SwordModMgr = SwordModMgr || cc.Class.extend({ 
	_zoneId:8001,
	_curlayer:0,
	_myscore:0,
	_bindGoldNum:0,
	_killPlayerScore:0,
	_killMonsterScore:0,
	_layerScores:null,
	_dirPicHash:null,
	_picShowIndex:-1,
	_timerNum:0,
	ctor:function() {	
	},
	
	InitScore:function(){
		var tempStr = Q_global.Get(1030).q_string_value;
		var scoreArr = JSON.parse(tempStr);
		this._killPlayerScore = scoreArr[0];
		this._killMonsterScore = scoreArr[1];
	},
	
	BeginShowArrow:function(){
		if( this._timerNum == 0 )
			this._timerNum = TimerUtil.TimeUpdate(this._UpdataArrowShow, this, 1);
	},
	
	HideShowArrow:function(){
		TimerUtil.ClearTimeUpdate(this._timerNum, this);
		this._timerNum = 0;
		
		for (var i = 0; i < this._dirPicHash.Values().length; i++) {
			UIUtil.UIRemoveSelf(this._dirPicHash.Values()[i]);
		}
		this._dirPicHash.Clear();
	},

		IsShowArrow:function () {
			return this._timerNum != 0;
		},
	
	_UpdataArrowShow:function(){
		if(Mgr.sword.IsInZoneMap()){//华山论剑副本要显示其他玩家方向箭头
			if(this._dirPicHash == null)
				this._dirPicHash = new HashMap();
			var playerList = Mgr.sceneObj.oRoundPlayerList.oHashList.aList;
			var len = Math.min(playerList.length, 5);
			var hashLen = this._dirPicHash.Values().length;
			var nearArr = new Array();//距离mainplayer最近的玩家
			var disArr = new Array();
			for (var i = 0; i < playerList.length; i++) {
				if(nearArr.length < len){
					nearArr.push(playerList[i]);
					disArr.push(ToolMap.CalcDistanceRect( Mgr.mainPlayer.GetGridPt(), playerList[i].GetGridPt()));
				}else{
					for(var j = 0; j < nearArr.length; j++){
						var dis = ToolMap.CalcDistanceRect( Mgr.mainPlayer.GetGridPt(), playerList[i].GetGridPt());
						if(disArr[j] > dis){//取最近的玩家
							nearArr[j] = playerList[i];
							disArr[j] = dis;
						}
					}
				}
			}
			for (i = 0; i < nearArr.length; i++) {
				var player = nearArr[i];
				var dir = ToolMap.CalcDir( Mgr.mainPlayer.GetGridPt(), player.GetGridPt());
				if(this._dirPicHash.Get(i) == null){
					var dirPic = cc.Sprite();
					var showPic = cc.Sprite( EngineMgr.uiMgr.GetResByUrl("public/image/jiantou.png") );
					dirPic.addChild(showPic);
					showPic.y = 150;
					this._dirPicHash.Put(i,dirPic);
				}
				cc.log("this._dirPicHash.Get(i):"+this._dirPicHash.Get(i));
				this._dirPicHash.Get(i).setRotation(ToolMap.GetAngle360( Mgr.mainPlayer.GetGridPt().x, Mgr.mainPlayer.GetGridPt().y, player.GetGridPt().x, player.GetGridPt().y));
				if( i > this._picShowIndex )
					Mgr.mainPlayer.addChild(this._dirPicHash.Get(i));
			}
			this._picShowIndex = i-1;
			for (i; i < hashLen; i++) {
				UIUtil.UIRemoveSelf(this._dirPicHash.Get(i));
			}
		}
	},
	
	IsInZoneMap:function () {
		if( Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_SWORD )
			return true;
		else
			return false;
	},
	
	GetNeedScore:function(){
		if(this._layerScores == null)
			this._layerScores = JSON.parse(Q_global.Get(1031).q_string_value);
		return this._layerScores[this._curlayer - 1];
	},

    GetNeedSkill:function(){
        if(this._layerScores == null)
            this._layerScores = JSON.parse(Q_global.Get(1031).q_string_value);
        return this._layerScores[this._curlayer - 1];
    },

	GetKillOneScore:function(){
		if(this._killPlayerScore == 0)
			this.InitScore();
		return this._killPlayerScore;
	},
	
	GetKillMonsterScore:function(){
		if(this._killMonsterScore == 0)
			this.InitScore();
		return this._killMonsterScore;
	},
	
	GetBindGold:function(){
		if(this._bindGoldNum == 0)
			this._bindGoldNum = Q_global.Get(1032).q_int_value;
		return this._bindGoldNum;
	},

	NeedKillPlayerNum:function(){
//		return Math.ceil((this.GetNeedScore() - this._myscore)/this.GetKillOneScore());
		return (this.GetNeedSkill() - this._mykillNums);
	},

	RecvResSendSwordZoneOpenMessage:function(msg) {	
		if(!this.IsInZoneMap()){//没在活动地图
			Mgr.activeMark.Show(EnumZoneActiveType.TYPE_SWORD);
		}
	},
	
	RecvResSwordZonePanelInfoMessage:function(msg) {
		if( msg.layer == this._curlayer+1 ){
			Mgr.uiMgr.ShowPanelByType(XiayiguanCueExt.PanelName);
			Mgr.uiMgr.GetPanelByType(XiayiguanCueExt.PanelName).SetLayer(msg.layer);
		}
		// cc.log("======RecvResSwordZonePanelInfoMessage=======" + JSON.stringify(msg))
		this._curlayer = msg.layer;
		this._myscore = msg.score;
		this._mykillNums = msg.killNums;
		this.npcOwnerId = msg.npcOwnerId;
		this.npcOwnerName = msg.npcOwnerName;
		this.wangzheScore = msg.wangzheScore;

//		if(!Mgr.task._taskTrackPanel.isShowActive){
//			Mgr.task._taskTrackPanel.ShowRightPanel(true);
//			Mgr.task._taskTrackPanel.ShowActiveData();
//		}
//		Mgr.task._taskTrackPanel.UpdataSwordInfo(msg.score, msg.layer, msg.wangzheName, msg.wangzheScore);
		Mgr.task._taskTrackPanel.UpdateView(msg.score, msg.layer, msg.wangzheName, msg.wangzheScore);
	},

    RecvResSwordZoneSuccessInfoMessage:function(msg) {
		if(msg.layer < 7){
            var panel = Mgr.uiMgr.ShowPanelByType(WendingCueExt.PanelName);
            if(panel) panel.SetSwordZoneInfo(msg.layer);
		}
		else if(this.npcOwnerId.toGID() == Mgr.player.mainPlayer.sid.toGID()){
            var panel = Mgr.uiMgr.ShowPanelByType(ExpFubenWinExt.PanelName);
            if(panel) panel.SetInfo(msg.layer);
		}
    },

	SendReqEnterSwordZoneMessage:function() {	
		var msg = new ReqEnterSwordZoneMessage();
		Mgr.msgMgr.Send( msg );
	},

		SendReqEnterSwordZoneNextLayerMessage:function() {
			var msg = new ReqEnterSwordZoneNextLayerMessage();
			Mgr.msgMgr.Send( msg );
		}
});