var TeamHanhuaExt = TeamHanhua.extend ( {
	_className:"TeamHanhuaExt",

	_listView:null,
	_buttons:null,
	_types:null,

	_curType:0,
	// type
	freedom:1,  // 自由喊话，


	ctor:function(){
		this._super();
		this._buttons = {};
	},

	Init:function() {
		var self = this;
		TeamHanhua.prototype.Init.call(this);
		this.InitParam();

		this.listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			onTouchBegan: function (touch, event) {
				if ( self.visible )
					Mgr.uiMgr.HidePanel(self);
				return true;
			},
			onTouchMoved: function (touch, event) {
			},
			onTouchEnded: function (touch, event) {
			}
		});
		cc.eventManager.addListener( this.listener ,this);
	},

	InitParam:function () {
		this.btnCue.visible = false;
		this._types = [EnumChatChannelType.WORLDSINGLE,EnumChatChannelType.FACTION];
		this._CreateListView();
	},

	_CreateListView:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg.width, this.imgBg.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.setItemsMargin(2);
		//list.setAnchorPoint(0, 0);
		//list.setPosition(0,0);
		//list.addEventListener(this._SelectedItemEvent);
		this.imgBg.addChild(list);
		this._listView = list;
		this.LoadList();
	},

	LoadList:function () {
		this._listView.removeAllItems();
		for ( var i = 0; i != this._types.length; i++ ) {
			this.Contain(this._types[i]);
		}
	},

	Contain:function (type) {
		var button = this._buttons[type];
		if ( !button ) {
			button = new MUIButton();
			button.ParseJson(this.btnCue.jsonobj);
			button.Init();
			button.retain();
			button.type = type;
			button.setTitleText( this.GetNameByType(type) );
			button.addClickEventListener(this._CallBackFunc);
			this._buttons[type] = button;
		}
		if ( !button.getParent() )
			this._listView.pushBackCustomItem(button);
	},

	GetNameByType:function (type) {
		var name = "未知名称"
		if (type == EnumChatChannelType.WORLDSINGLE)
			name = "世界频道"
		else if (type == EnumChatChannelType.FACTION)
			name = "帮会频道"
		return name;
	},

	_CallBackFunc:function (event) {
		var _channel;
		switch (event.type) {
			case EnumChatChannelType.WORLD:
				cc.log("world")
				_channel = EnumChatChannelType.WORLD;
				break;
			case EnumChatChannelType.FACTION:
				cc.log("guild")
				_channel = EnumChatChannelType.FACTION
				break;
		}
		var leaderName = Mgr.player.mainPlayer.name;
		var str =  "自由组队，不限等级";
		var itemreq = new HyperInfo();
		itemreq.hyperType = EnumLinkType.TEAM_APPLY;
		itemreq.params_ =  Mgr.team.teamInfo.teamId.toString();
		itemreq.index = str.length;
		itemreq.clientUseText = "[申请入队]";

		var extraReqInfo = new ExtraReqInfo();
		extraReqInfo.hyperInfos.push( itemreq );

		str += itemreq.clientUseText;
		Mgr.chat.SendChantMsg(_channel, str ,extraReqInfo);

		Mgr.uiMgr.HidePanelByType(TeamHanhuaExt.PanelName);
	},

	OnShow:function () {
		this.LoadList();
	},
} );
TeamHanhuaExt.PanelName = "TeamHanhuaExt";
PanelClassDic["TeamHanhuaExt"] = TeamHanhuaExt;
