var BoxTaskPanelExt = BoxTaskPanel.extend ( {
	_className:"BoxTaskPanelExt",
    href:0,
	ctor:function(parent,taskTrackPanel){
		this._super();
        this.taskTrackPanel = taskTrackPanel;
	},

    Init:function(){
        BoxTaskPanel.prototype.Init.call( this );
        this.imgBg.setTouchEnabled(true);
        var self = this;
        this.imgBg.addTouchEventListener(function (sender, type) {
            if (type == ccui.Widget.TOUCH_ENDED) {
                // sender.
                if(self.href == 0)
                    self.href = 1
                else
                    self.href = 0;
                self.OnHyperlink(self.href);
            }
        });
    },

    InitView:function(){
        // 掌门斗宝
        if(MasterBucketUtil.CheckActivityIsOpen()){
            this.data = MasterBucketUtil.CheckActivityIsOpen();
            this.labFB.SetText("[活动] ");
            this.labName.SetText("掌门斗宝");
            // this.labKill.SetText(TextUtil.AddColor("挑战目标", "0xfeff02"));
            this.InitLabel();
            this.UpdateView();
            return;
        }
	},

    InitLabel:function(){
        this.labKill1.SetText("宝箱: " + TextUtil.AddColor("<u>" + "东集市掌门宝箱" + "</u>", "2ed515"));
        this.labKill2.SetText("宝箱: " + TextUtil.AddColor("<u>" + "西集市掌门宝箱" + "</u>", "2ed515"));
        // this.listView.setSize(cc.size(this.imgBg2.uiWidth, this.labTarget0.uiHeight*2));
        // this.listView.setInnerContainerSize(cc.size(this.imgBg2.uiWidth, this.labTarget0.uiHeight*2));
        // this.imgLine1.y = this.lineY + this.labTarget0.uiHeight;

        // this.labGather.SetText("今日采集:");
    },

    UpdateView:function(){
        this.data = MasterBucketUtil.CheckActivityIsOpen();
        var gatherNum = MasterBucketUtil.GetGatherCount();
        UIUtil.ConnectLabelHtmlText(this.labKill3, [gatherNum[0], gatherNum[1]]);
    },

    OnHyperlink:function(href){
        MasterBucketUtil.AutoPath2ActivityRange(href);
    },

    OnTimer:function(){
        // 达到上限后不再显示
        var gatherNum = MasterBucketUtil.GetGatherCount();
        if(gatherNum[0] >= gatherNum[1]){
            this.taskTrackPanel.HideOtherTrack();
            return;
        }

        // 如果在活动范围内才显示
        var inArea = MasterBucketUtil.CheckPlayerInActivityMapArea();
        if(this.bInArea == null || this.bInArea != inArea){
            this.bInArea = inArea;
            if(inArea) this.taskTrackPanel.ShowOtherTrack();
            else this.taskTrackPanel.HideOtherTrack();
        }

        var leftTime = 0;
        if(this.data) {
            var curTime = Mgr.login.GetServerTime() / 1000;
            leftTime = Math.max(this.data.startTime + this.data.endTime - curTime,0);;
        }
        this.labTime.SetText(TextUtil.SecondToHMS2(leftTime));
    },

    onEnter:function(){
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
        if (this.timerId)
            TimerUtil.ClearTimeUpdate(this.timerId, this);
    },
} );
BoxTaskPanelExt.PanelName = "BoxTaskPanelExt";
PanelClassDic["BoxTaskPanelExt"] = BoxTaskPanelExt;
