var ErenguBossFrameExt = ErenguBossFrame.extend ( {
	_className:"ErenguBossFrameExt",

	index:null,
	bossInfo:null,
    bossType:null,
    vip:null,

	ctor:function(){
		this._super();
	},

    Init:function(){
        ErenguBossMain.prototype.Init.call( this );

        this.btnRight.visible = false;
        this.sbtn2.setTouchEnabled(false);
        this.imgName.setTouchEnabled(false);

        this.sbtn2.SetButtonState("uncheck");
        this.imgName.SetButtonState("uncheck");
    },

    SetData:function(idx, info, vip){
	    this.vip = vip;
		this.index = idx;
        var boss = Q_monster.Get(info.monsterModelId);
        this.bossInfo = info;
        var time=info.status;
        var url1="other/shijieboss/image/touxiang3/"+boss.q_head_resid + ".png";
        this.sbtn2._stateImages["uncheckup"].SetData(url1, false);
        var url2="other/shijieboss/image/touxiang3/0"+boss.q_head_resid + ".png";
        this.sbtn2._stateImages["checkup"].SetData(url2, false);

        this.bossType = time;

        if(time == 0){
            this.labTime.SetString(TextUtil.AddColor("可击杀", "76fd56"));
            Filter.UnGray(this.imgDikuang);
        }
        else if(time == -1){
            this.labTime.SetString(TextUtil.AddColor("已击杀", "ff4949"));
            Filter.GrayScale(this.imgDikuang);
        }
        else{
            this.labTime.SetString(TimeUtil.SecondToDHMS2(time));
            Filter.GrayScale(this.imgDikuang);
        }

        this.imgName.SetText(boss.q_name+"Lv."+boss.q_grade);
	},

    SetSelect:function(bool){
		if(bool){
            this.sbtn2.SetButtonState("check");
            this.imgName.SetButtonState("check");
            this.btnRight.visible = true;
        }
		else{
            this.sbtn2.SetButtonState("uncheck");
            this.imgName.SetButtonState("uncheck");
            this.btnRight.visible = false;
        }
	},

    UpdateTime:function(){
	    var list = null;
        if(this.vip == 4){
            list = Mgr.monster.vip4ErenguBossList;
        }
        else{
            list = Mgr.monster.vip10ErenguBossList;
        }
        if(!list[this.index] || list[this.index].status == this.bossType)
            return;
        var time= list[this.index].status;
        if(time==0){
            this.labTime.SetString(TextUtil.AddColor("可击杀", "76fd56"));
            Filter.UnGray(this);
        }
        else if(time == -1){
            this.labTime.SetString(TextUtil.AddColor("已击杀", "ff4949"));
            Filter.GrayScale(this);
        }
        else{
            this.labTime.SetString(TimeUtil.SecondToDHMS2(time));
            Filter.GrayScale(this);
        }
    },

} );
ErenguBossFrameExt.PanelName = "ErenguBossFrameExt";
PanelClassDic["ErenguBossFrameExt"] = ErenguBossFrameExt;
