var ChenghaoTipsPanelExt = ChenghaoTipsPanel.extend ( {
	_className:"ChenghaoTipsPanelExt",
	modelPanelType:2,
	isClosePanel:true,
	showModel:null,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
	},
	Init:function()
	{
		ChenghaoTipsPanel.prototype.Init.call(this);
		this.imgTitle1.visible = false;
		var self = this;
		this.setSwallowTouches(true);
		this.btnClose.addClickEventListener(function()
		{
			EngineMgr.uiMgr.HidePanel(self);
		});
	},
	UpdateInformation:function(data)
	{
		var name = TextUtil.RemoveHTMLTag(data.q_name);
		this.labName.SetString(name);
		this.labCue.SetString(data.q_introduce);
		// this.labTimeCue.visible = false;
		// if(data.q_time>0)
		// {
		// 	this.labTimeCue.visible = true;
		// 	var time = TimeUtil.SecondToDHMS(data.q_time);
		// 	this.labTimeCue.SetString(time);
		// }
		if(this.showModel){
            SkillEffect.Delete(this.showModel);
		}
        this.showModel = EffectUtil.GetShowEffect(data.q_art, EffectUtil.ENUM_TYPE_UI, true ,-1);
        this.showModel.x = this.imgChenghao.uiWidth / 2;
        this.showModel.y = this.imgChenghao.uiHeight / 2;
        this.imgChenghao.addChild(this.showModel);
		this._SetData(data.q_attribute);
	},
	_SetData:function(str)
	{
		str = str.substring( 1 , str.length - 1 );
		var array = str.split( "," );
		for (var i = 0; i < array.length; ++ i)
		{
			array[i] = array[i].split( ":" );
			switch (array[i][0])
			{
				case "1":
					this.labGongji1.SetString("+" + array[i][1] );
					break;
				case "2":
					this.labFangyu1.SetString("+" + array[i][1] );
					break;
				case "7":
					this.labHp1.SetString("+" + array[i][1] );
					break;
					defend:break;
			}
		}
	},
} );
ChenghaoTipsPanelExt.PanelName = "ChenghaoTipsPanelExt";
PanelClassDic["ChenghaoTipsPanelExt"] = ChenghaoTipsPanelExt;
