var SlippingTipsPanelExt = SlippingTipsPanel.extend ( {
	_className:"SlippingTipsPanelExt",

	_timeOutId:-1,

	_type:0,//FloatingText.TYPE_STATIC
	_offX:0,
	_offY:0,
	_item:null,
	ctor:function () {
		this._super();
		this.LoadPanel();
	},
	SetItem:function(item)
	{
		this._item = item;
	},
	SetData:function( html, type, where ){
		this._type = type;

		var result = html; //UIUtil.GetTextByHtmlText( html );
		this.labCue.SetString(result);
		if(this._item)
		{
			this.labCue.opacity = 0;
			this.labCue.addChild(this._item);
		}

		if ( type == TipsEnum.TYPE_MARQUEE ) {
			if( !this.initMarquee ){
				// 布局
				var sz = cc.director.getWinSize();
				this.x = sz.width * 0.2;
				this.y = sz.height * 0.8;
				this.uiWidth = sz.width * 0.6;
				this.setContentSize( this.uiWidth, this.uiHeight );

				// 遮罩
				var shape = new cc.DrawNode();
				var rectangle = [];
				rectangle[0] = cc.p(30, 0);
				rectangle[1] = cc.p(this.uiWidth - 60, 0);
				rectangle[2] = cc.p(this.uiWidth - 60, this.uiHeight);
				rectangle[3] = cc.p(30, this.uiHeight);
				var green = cc.color(0, 255, 0, 255);
				shape.drawPolygon(rectangle,4, green, 0, green);
				shape.setPosition(0,0);

				var clipper = new cc.ClippingNode();
				clipper.stencil = shape;
				clipper.setPosition(0,0);
				this.addChild( clipper );

				this.labCue.retain();
				this.labCue.removeFromParent();
				clipper.addChild(this.labCue);
				this.labCue.release();
				this.labCue.SetUISize( this.labCue._textWidth, this.labCue.uiHeight );
				this.labCue.y = (this.uiHeight - this.labCue.height)/2 - (this.labCue.height - this.labCue._textHeight)/2;
				this.initMarquee = true;
			}
		}
		else {
			// panel pos
			var pt;
			if (where != undefined && where.x != undefined && where.y != undefined) {
				pt = where;
			}
			else if (typeof where === "DisplayObject") {
				var loc = cc.p(where.width / 2, where.height / 2);
				pt = UIUtil.LocalToGlobel(where, loc);
				// pt = dis.localToGlobal(new Point(dis.width / 2, dis.height / 2));
			}
			else {
				var sz = cc.director.getWinSize();
				pt = cc.p(sz.width / 2, sz.height / 2);
			}

			// lable pos
			this.labCue.x = 30;
			// 纵向坐标导出错误修订
			this.labCue.y = (this.uiHeight - this.labCue.height) / 2 - (this.labCue.height - this.labCue._textHeight) / 2;
			this.labCue.SetUISize( this.labCue._textWidth, this.labCue.uiHeight );
			this.uiWidth = this.labCue.x + this.labCue._textWidth + 30;
			this.setContentSize(this.uiWidth, this.uiHeight);

			this._offX = this.x = pt.x;
			this._offY = this.y = pt.y;
		}

		this.setTouchEnabled(false);
		this._beginShow();
	},

	/**
	 * 开始显示
	 */
	_beginShow:function()
	{
		this.stopAllActions();
		if (this._type == TipsEnum.TYPE_TOUCH)
		{
			this.x = -this.uiWidth/2 + this._offX;
			this.y = this.uiHeight + this._offY - 100;
			this.setOpacity(0);

			var func1 = cc.moveBy(1, cc.p( 0, 40));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);

			var fadeout = cc.FadeTo.create(0.5, 255);
			this.runAction(cc.RepeatForever.create(cc.Sequence.create(fadeout))); // 显隐
			this.runAction(action);
		}
		else if (this._type == TipsEnum.TYPE_TOUCH_UP_HIDE)
		{
			this.x = -this.uiWidth/2 + this._offX;
			this.y = this.uiHeight/2 + this._offY;
			this.setOpacity(255);

			var func1 = cc.moveBy(2.5, cc.p( 0, 40));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);

			var fadeout = cc.FadeTo.create(0.5, 255*0.6);
			this.runAction(cc.RepeatForever.create(cc.Sequence.create(fadeout))); // 显隐
			this.runAction(action);
		}
		else if (this._type == TipsEnum.TYPE_TOUCH_UP)
		{
			this.x = -this.uiWidth / 2 + this._offX;
			this.y = this.uiHeight + this._offY;

			var func1 = cc.moveBy(1.5, cc.p( 0, 40));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);
			this.runAction(action);
		}
		else if (this._type == TipsEnum.TYPE_STATIC)
		{
			this.x = -this.uiWidth / 2 + this._offX;
			this.y = this.uiHeight + this._offY;

			var func1 = cc.moveBy(2, cc.p( 0, 70));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);
            action.setTag(9527);
			this.setOpacity(255);
			this.runAction(action);
		}
		else if (this._type == TipsEnum.TYPE_UP_HIDE)
		{
			this.x = -this.uiWidth / 2 + this._offX;
			this.y = this.uiHeight + this._offY;

			var func1 = cc.moveBy(1.5, cc.p( 0, 40));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);
			this.setOpacity(255);
			this.runAction(action);
		}
		else if ( this._type == TipsEnum.TYPE_UPLEFT_HIDE )
		{
			this.x = -this.uiWidth / 2 + this._offX;
			this.y = this.uiHeight + this._offY;

			var func1 = cc.moveBy(1.5, cc.p( -85, 85));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);
			this.runAction(action);
		}
		else if ( this._type == TipsEnum.TYPE_ROLE_CENTER )
		{
			this.x = 0;
			this.y = 0;
			if ( Mgr.mainPlayer != null )
			{
				var playerPt = MapUtil.getObjectVScreenPt(Mgr.mainPlayer );
				this.x = playerPt.x - ( this.uiWidth / 2 );
				this.y = playerPt.y;
			}

			var func1 = cc.moveBy(3, cc.p( 0, 40));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);

			var fadeout = cc.FadeTo.create(3, 255*0.4);
			this.runAction(cc.RepeatForever.create(cc.Sequence.create(fadeout))); // 显隐
			this.runAction(action);
		}
		else if ( this._type == TipsEnum.TYPE_UPRIGHT_HIDE)
		{
			this.x = -this.uiWidth / 2 + this._offX;
			this.y = this.uiHeight + this._offY;

			var func1 = cc.moveBy(3, cc.p( 40, 40));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);

			var fadeout = cc.FadeTo.create(3, 255*0.4);
			this.runAction(cc.RepeatForever.create(cc.Sequence.create(fadeout))); // 显隐
			this.runAction(action);
		}
		else if ( this._type == TipsEnum.TYPE_BOTTOM_HIDE )
		{
			this.x = (ToolBase.GetWinWidth() - this.uiWidth)*.5;
			this.y = ToolBase.GetWinHeight()*0.5;
			this.setOpacity(0);

			var fadeout = cc.FadeTo.create(0.5, 255);
			var func1 = cc.RepeatForever.create(cc.Sequence.create(fadeout));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);

			this.runAction(action);
		}
		else if ( this._type == TipsEnum.TYPE_MARQUEE )   // 跑马灯
		{
			this.labCue.x = this.uiWidth;
			var movedis = this.uiWidth + this.labCue.uiWidth; //移动距离
			var func1 = cc.moveBy( 10, cc.p(-movedis, 0));
			var action = cc.sequence(
				func1,
				cc.callFunc( this._showComplete.bind(this) )
			);
			this.labCue.runAction(action);
		}
	},
	/**
	 * 显示结束
	 */
	_showComplete:function()
	{
		var self = this;
		switch( this._type )
		{
			case TipsEnum.TYPE_TOUCH:
				
			case TipsEnum.TYPE_BOTTOM_HIDE:
				this._timeOutId = TimerUtil.SetTimeout( this, self._hideShow, 3000, self);
				break;
			case TipsEnum.TYPE_MARQUEE:
				if ( Mgr.tips.marqueeStrArr.length > 0 ) {
					// 重置 marquee
					var tips = Mgr.tips.marqueeStrArr.shift();
					this.SetData(tips, TipsEnum.TYPE_MARQUEE);
				}
				else {
					self._hideShow(self);
					Mgr.tips.marqueePanel = null;
				}
				break;
			case TipsEnum.TYPE_STATIC:
			default:
				self._hideShow(self);
				break;
		}
	},
	/**
	 * 开始隐藏
	 *
	 */
	_hideShow:function( tar )
	{
		var tweenParam = {};

		if (tar._type == TipsEnum.TYPE_TOUCH)
		{
			var func1 = cc.moveBy(1, cc.p( 0, -100));
			var action = cc.sequence(
				func1,
				cc.callFunc( tar._hideComplete.bind(tar) )
			);

			var fadeout = cc.FadeTo.create(1, 0);
			tar.runAction(cc.RepeatForever.create(cc.Sequence.create(fadeout))); // 显隐
			tar.runAction(action);
		}
		else if (tar._type == TipsEnum.TYPE_TOUCH_UP_HIDE)
		{
			var fadeout = cc.FadeTo.create(1, 0);
			var action = cc.sequence(
				fadeout,
				cc.callFunc( tar._hideComplete.bind(tar) )
			);
			tar.runAction(action);
		}
		else if (tar._type == TipsEnum.TYPE_TOUCH_UP)
		{
			var fadeout = cc.FadeTo.create(0.5, 0);
			var action = cc.sequence(
				fadeout,
				cc.callFunc( tar._hideComplete.bind(tar) )
			);
			tar.runAction(action);
		}
		else if (tar._type == TipsEnum.TYPE_STATIC || tar._type == TipsEnum.TYPE_UP_HIDE)
		{
			var fadeout = cc.FadeTo.create(1, 0);
			var action = cc.sequence(
				fadeout,
				cc.callFunc( tar._hideComplete.bind(tar) )
			);
			tar.runAction(action);
		}
		else
		{
			tar._hideComplete();
		}
	},
	/**
	 * 隐藏结束
	 *
	 */
	_hideComplete:function ()
	{
		this.destory();
	},
	destory:function()
	{
		this.stopAllActions();
		UIUtil.UIRemoveSelf(this);
		TimerUtil.ClearTimeout(this._timeOutId);
		this._timeOutId = -1;
		if(this._type != TipsEnum.TYPE_MARQUEE){
			Mgr.tips.slippingPool.Recycle(this);
		}
		//this.loadTexture(this.jsonobj.images[0], ccui.Widget.PLIST_TEXTURE);
		//FloatingText.GetlistHash().Remove(this.gid);
	},

	OnRecycle:function(){
	},
	OnRevert:function(){
	},
	Dispose:function() {
	},
} );
SlippingTipsPanelExt.PanelName = "SlippingTipsPanelExt";
PanelClassDic["SlippingTipsPanelExt"] = SlippingTipsPanelExt;
