var DuiBiList1Ext = DuiBiList1.extend({
    _className: "DuiBiList1Ext",

    data: null,
    expanded: false,
    callback: null,
    ctor: function() {
        this._super();
    },

    Init: function() {
        DuiBiList1.prototype.Init.call(this);

        this.btnCue.addClickEventListener(function(event) {
            if (this.callback) {
                this.callback();
            }
        }.bind(this));

        this.btnTisheng1.addClickEventListener(function(event) {
            FightPowerUtils.OpenPanel(this.data.main, this.data.sub);
        }.bind(this));
    },
    UpdateView: function(data, callback) {
        this.data = data;
        this.callback = callback;

        var powerMax = Math.max(data.powerSelf, data.powerOther);

        this.labNumber3.SetText("战力：" + data.powerOther);
        this.labNumber4.SetText("战力：" + data.powerSelf);
        this.progJindutiao3.setPercent(powerMax == 0 || isNaN(powerMax) ? 0 : 100 * data.powerOther / powerMax);
        this.progJindutiao4.setPercent(powerMax == 0 || isNaN(powerMax) ? 0 : 100 * data.powerSelf / powerMax);

        this.height = this.expanded ? 200 : 50;
    },
    UpdateExpanded:function(expanded){
        this.btnCue.setTitleText((expanded ? "- " : "+ ") + (this.data.name || ""));
    },
});
DuiBiList1Ext.PanelName = "DuiBiList1Ext";
PanelClassDic["DuiBiList1Ext"] = DuiBiList1Ext;