var TujianMonsterFrameExt = TujianMonsterFrame.extend ( {
	_className:"TujianMonsterFrameExt",
	flyArr:null,//[地图id,x,y]
	tujianinfo:null,
	tujianType:0,
	tujianId:0,
	itemId:0,
	activeItemNum:0,
	// _clipper:null,
	// mask:null,
	type:0,//0不可升级 1可升级 2已满级
	ctor:function(){
		this._super();
	},

	SetData:function (qtujian) {
		this.tujianinfo = null;
		// this.SetMask();

		this.itemId = qtujian.q_item;
		this.tujianType = qtujian.q_main_type;

		var monster = Q_monster.Get( qtujian.q_monster_id );
		if( monster ){
			this.labName.SetHtmlText(TextUtil.FormatStr( this.labName.GetHtmlText(), [ monster.q_name ] ));
		}
		
		var imageRes = "other/tujianxitong/image/boss/"+qtujian.q_monster_show+".png";
		var self=this;
		EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
			self.imgIcon.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
		}, self.imgIcon);
		
		this.flyArr = JSON.parse( qtujian.q_position );

//		this.labShuxing.setVisible(false);
//		this.labShuxing1.setVisible(false);
		var lvArr = qtujian.q_id.split("_");

		var nextqtujian = Q_tujian.Get(lvArr[0] + "_1");
		var attArr = this._GetAttributeStr(nextqtujian);
		this.labShuxing.SetHtmlText( attArr[0] );
		this.labShuxing1.SetHtmlText( "+" + attArr[1] );
		
		this.tujianId = lvArr[0];
		this.labDengji.SetHtmlText(TextUtil.FormatStr( this.labDengji.GetHtmlText(), [ lvArr[1] ] ));
		var nextqtujian = Q_tujian.Get(lvArr[0] + "_" + (parseInt(lvArr[1])+1));
		if( nextqtujian ){
			this.labDengji1.SetHtmlText(TextUtil.FormatStr( this.labDengji1.GetHtmlText(), [ parseInt(lvArr[1])+1 ] ));
			this.labDengji1.setVisible(true);
			this.activeItemNum = parseInt(nextqtujian.q_num);
		}else{
			this.labDengji1.setVisible(false);
		}
		
		if( Mgr.backpack.GetItemNumber(this.itemId) >= this.activeItemNum ){
			this.imgTanhao.setVisible(true);
		}else{
			this.imgTanhao.setVisible(false);
		}

		this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ "0/" + nextqtujian.q_num ] ));
		// this.SetPressBarLen(0);
		this.progJindutiao.setPercent(0);

		this.imgWeijihuo.setVisible(true);
//		this.imgFeixie.setVisible(false);
//		Filter.GrayScale(this);

		this.UpdataBtn();

		var self = this;
		this.btnJihuo.addClickEventListener(function () {
			Mgr.tujian.SendReqTujianUpToGameMessage(self.tujianType, self.tujianId);
		});
		this.btnUp.addClickEventListener(function () {
			if(self.type == 0)
				Mgr.tips.ShowNotice("材料不足！");
			else if(self.type == 1)
				Mgr.tujian.SendReqTujianUpToGameMessage(self.tujianType, self.tujianId);
		});
		var posArr = JSON.parse(qtujian.q_position);
		var monsterPos = cc.p(posArr[1], posArr[2]);
		this.imgFeixie.setTouchEnabled(true);
		this.imgModel.addClickEventListener(function () {//目前还没有怪物资源，以后加上
			Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(posArr[0], monsterPos, AutoPathParam.CreateAutoFight());
			var mapdata = Q_map.Get(posArr[0]);
			if(Mgr.player.mainPlayer.attributeData.level >= mapdata.q_map_min_level)
				EngineMgr.uiMgr.HidePanelByType( TujianPanelExt.PanelName );
		});
		this.imgFeixie.addClickEventListener(function () {
			Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(posArr[0], monsterPos, AutoPathParam.CreateAutoFight());
			var mapdata = Q_map.Get(posArr[0]);
			if(Mgr.player.mainPlayer.attributeData.level >= mapdata.q_map_min_level)
				EngineMgr.uiMgr.HidePanelByType( TujianPanelExt.PanelName );
		});
	},

	SetInfo:function(info){
		var lv = info ? info.level : 0;
		var qtujian = Q_tujian.Get(this.tujianId + "_" + lv);
		var lvArr = qtujian.q_id.split("_");
		var nextqtujian = Q_tujian.Get(lvArr[0] + "_" + (parseInt(lvArr[1])+1));
		var haveNum = Mgr.backpack.GetItemNumber(this.itemId);
		var nowper = (info ? info.nums : 0 );
		if( nextqtujian ){
			// this.SetPressBarLen(Math.min(nowper / nextqtujian.q_num, 1) * 100);
			this.progJindutiao.setPercent(Math.min(nowper / nextqtujian.q_num, 1) * 100);
			this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ haveNum + "/" + nextqtujian.q_num ] ));
		}
		if( !info )
			return;
		this.tujianinfo = info;

		if(info.level > 0){
			//Filter.UnGray(this);
			this.imgWeijihuo.setVisible(false);
//			this.imgFeixie.setVisible(true);
			var attArr = this._GetAttributeStr(qtujian);
			this.labShuxing.SetHtmlText( attArr[0] );
			this.labShuxing1.SetHtmlText( "+" + attArr[1] );
//			this.labShuxing.setVisible(true);
//			this.labShuxing1.setVisible(true);
		}
		this.UpdataBtn();

		this.tujianId = lvArr[0];
		this.labDengji.SetHtmlText(TextUtil.FormatStr( this.labDengji.GetHtmlText(), [ lvArr[1] ] ));
		if( nextqtujian ){
			this.labDengji1.SetHtmlText(TextUtil.FormatStr( this.labDengji1.GetHtmlText(), [ parseInt(lvArr[1])+1 ] ));
			this.labDengji1.setVisible(true);
			this.activeItemNum = parseInt(nextqtujian.q_num);

//			this.btnUp.setVisible(true);
			this.labCue1.setVisible(true);
//			this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ haveNum + "/" + nextqtujian.q_num ] ));
//			this.SetPressBarLen(Math.min(haveNum / nextqtujian.q_num, 1) * 100);
			Filter.UnGray(this.btnUp);
			this.btnUp.setTitleText("升级");
			if( (lv == 0 && haveNum >= this.activeItemNum) || haveNum > 0 ){
				this.imgTanhao.setVisible(true);				
				this.type = 1;
			}
			else{
				this.imgTanhao.setVisible(false);
				this.type = 0;
			}
		}else{
			this.labDengji1.setVisible(false);

//			this.labCue1.setVisible(false);
//			this.btnUp.setVisible(false);
// 			this.SetPressBarLen(100);
			Math.min(100);
			Filter.GrayScale(this.btnUp);
			this.btnUp.setTitleText("已满级");
			this.type = 2;
			this.imgTanhao.setVisible(false);
		}
	},

	UpdataBtn:function () {
		if(!this.tujianinfo || this.tujianinfo.level == 0 ){
			this.btnUp.setVisible(false);
			this.btnJihuo.setVisible(true);
			Filter.GrayScale(this.imgBg);
		}else{
			this.btnUp.setVisible(true);
			this.btnJihuo.setVisible(false);
//			this.imgTanhao.setVisible(false);
			Filter.UnGray(this.imgBg);
		}
	},

	// SetMask:function(){
	// 	UIUtil.UIRemoveSelf(this.imgJindutiao2);
	// 	this.mask = new cc.DrawNode();
	// 	var rectangle = [];
	// 	rectangle[0] = cc.p(0, 0);
	// 	rectangle[1] = cc.p(0, 0);
	// 	rectangle[2] = cc.p(0, this.imgJindutiao2.height);
	// 	rectangle[3] = cc.p(0, this.imgJindutiao2.height);
	// 	this.mask.drawPolygon(rectangle,4, cc.color(0,0,0), 0, cc.color(0,0,0));
	// 	this._clipper = new cc.ClippingNode();   //创建裁剪节点ClippingNode对象  不带模板
	// 	this._clipper.setInverted(false);         //显示被模板裁剪下来的底板内容。默认为false 显示被剪掉部分。
	// 	this._clipper.setStencil(this.mask);        //设置遮罩
	// 	this._clipper.setAlphaThreshold(0);    //设置绘制底板的Alpha值为0
	// 	this._clipper.alphaThreshold = 0.5;
	// 	this.imgJindutiao1.addChild(this._clipper, this.imgJindutiao2.getLocalZOrder());
	// 	this._clipper.addChild(this.imgJindutiao2);
	// },
//
// 	SetPressBarLen:function (num) {
// 		this.mask.clear();
// 		var rectangle = [];
// 		rectangle[0] = cc.p(0, 0);
// 		rectangle[1] = cc.p(this.imgJindutiao2.uiWidth * num / 100, 0);
// 		rectangle[2] = cc.p(this.imgJindutiao2.uiWidth * num / 100, this.imgJindutiao2.height);
// 		rectangle[3] = cc.p(0, this.imgJindutiao2.height);
// 		this.mask.drawPolygon(rectangle,4, cc.color(0,0,0), 0, cc.color(0,0,0));
// //		this.mask.drawRect(cc.p(0,0),cc.p(this.imgJindutiao2.uiWidth * num / 100,this.imgJindutiao2.uiHeight),cc.color(0,0,0));
// 	},

	_GetAttributeStr:function (propObj) {
		var str = ParseUtil.FormatFastJsonStr(propObj.q_attribute);
		var jsonData = JSON.parse(str);
		var array = [];
		for ( var keyStr in jsonData )
		{
			array.push( [parseInt(keyStr), parseInt(jsonData[keyStr])] );
		}

		if ( array[0][0] == EnumAttribute.MAX_BASEHP ) {
			str = "气血：";
		}
		else if ( array[0][0] == EnumAttribute.ATTACK ){
			str = "攻击：";
		}
		else if ( array[0][0] == EnumAttribute.DEFEND ) {
			str = "防御：";
		}
		else if ( array[0][0] == EnumAttribute.HIT ) {
			str = "命中：";
		}
		else if ( array[0][0] == EnumAttribute.DODGE ) {
			str = "闪避：";
		}
		else if ( array[0][0] == EnumAttribute.CRIT ) {
			str = "暴击：";
		}
		else if ( array[0][0] == EnumAttribute.ANTI_CRIT ) {
			str = "抗暴击：";
		}

		return [str, array[0][1]];
	}
} );
TujianMonsterFrameExt.PanelName = "TujianMonsterFrameExt";
PanelClassDic["TujianMonsterFrameExt"] = TujianMonsterFrameExt;
