var TujianPanelExt = TujianPanel.extend ( {
	_className:"TujianPanelExt",
	_vScrollView:null,
	_hScrollView:null,
	_btnHash:null,
	_cellHash:null,
	curVType:0,
	curHType:0,
	_curMapBtn:null,
	_btnH:0,
	_cellW:0,
	_mainBtnArr:null,
	_btnTypeArr:null,
	_monsterCellArr:null,
	_monsterCellIndex:0,
	_cellNum:3,
	_startIndex:0,
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
	},
	
	Init:function(){
		TujianPanel.prototype.Init.call( this );
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -28;
		Mgr.tujian.tujianpanel = this;

//		UIUtil.UIRemoveSelf(this.imgTanhao);

		this._btnHash = new HashMap();
		this._cellHash = new HashMap();
		this.InitPageView();
		
		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanelByType( TujianPanelExt.PanelName );
		});
		
		var self = this;
		this._hScrollView.addCCSEventListener(function () {
			self.UpdateProgBar(self);
		});
		this.btnleft.addClickEventListener(function () {
			self.OnLeftHandler();
		} );
		this.btnright.addClickEventListener(function () {
			self.OnRightHandler();
		} );

		this._mainBtnArr = [ this.sbtnYewain, this.sbtnKuafu ];
		this._btnTypeArr = [ EnumTujianType.TYPE_YW, EnumTujianType.TYPE_KF ];
		var self = this;
		for( var i = 0; i < this._mainBtnArr.length; i++ ){
			(function(j){
				self._mainBtnArr[j].addClickEventListener(function (event){
					self._OnMainTypeChange( self._mainBtnArr[j] );
				});
			})(i)
		}
	},

	InitPageView:function(){
		this._vScrollView = ccui.ScrollView();
		this._vScrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
		this._vScrollView.setTouchEnabled(true);
		this._vScrollView.inertiaScrollEnabled=false;
		this._vScrollView.setScrollBarEnabled(false);
		this._vScrollView.setBounceEnabled(true);
		this.imgBg1.addChild(this._vScrollView);

		this._hScrollView = ccui.ScrollView();
		this._hScrollView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
		this._hScrollView.setTouchEnabled(true);
		this._hScrollView.inertiaScrollEnabled=false;
		this._hScrollView.setScrollBarEnabled(false);
		this._hScrollView.setBounceEnabled(true);
		this._hScrollView.setClippingType(ccui.Layout.CLIPPING_SCISSOR);
		this.imgBg2.addChild(this._hScrollView);
	},
	
	UpdateProgBar:function(self){
		self._startIndex = -(self._hScrollView.getInnerContainerPosition().x)/self._cellW;
		self.UpdataBtnState();
	},
	
	UpdataBtnState:function () {
		if(this._cellHash.Values().length <= this._cellNum)
		{
			this.btnleft.setVisible(false);
			this.btnright.setVisible(false);
			return;
		}
		if(this._startIndex <= 0){
			this.btnleft.setVisible(false);
		}else{
			this.btnleft.setVisible(true);
		}
		if(this._startIndex >= (this._cellHash.Values().length-this._cellNum)){
			this.btnright.setVisible(false);
		}else{
			this.btnright.setVisible(true);
		}
	},

	OnLeftHandler:function(){
		this._startIndex = Math.min(Math.ceil(this._startIndex), this._cellHash.Values().length-this._cellNum);
		if( this._startIndex > 0)
			this._startIndex--;
		else
			return;
		this._hScrollView.scrollToPercentHorizontal(this._startIndex/(this._cellHash.Values().length-this._cellNum)*100, 0.5, true);
	},

	OnRightHandler:function(){
		this._startIndex = Math.max(Math.floor(this._startIndex), 0);
		if( this._startIndex < (this._cellHash.Values().length-this._cellNum))
			this._startIndex++;
		else
			return;
		this._hScrollView.scrollToPercentHorizontal(this._startIndex/(this._cellHash.Values().length-this._cellNum)*100, 0.5, true);
	},

	_OnMainTypeChange:function (btn) {
		if( btn == this.sbtnYewain ){
			this.ShowBtnCell(EnumTujianType.TYPE_YW);
		}else if( btn == this.sbtnKuafu ){
			this.ShowBtnCell(EnumTujianType.TYPE_KF);
		}
	},

	ShowBtnCell:function (type) {
		this.curVType = type;
		this.ClearVScrollView();
		var list = Mgr.tujian.TujianHash().Keys().sort(this.SortTujianBtnById);
		var num = 0;
		var firstId = "";
		for( var i = 0; i < list.length; i++ ){
			if(parseInt( list[i].split("_")[0] ) == type){
				var btnCell = new TujianMapFrameExt();
				btnCell.LoadPanel();
				btnCell.retain();
				btnCell.SetData(list[i]);
				btnCell.x = 0;
				btnCell.y = btnCell.uiHeight * num;
				this._vScrollView.addChild(btnCell);
				this._btnHash.Put(list[i], btnCell);
				this._btnH = btnCell.uiHeight;
				firstId = Mgr.tujian.TujianHash().Get(list[i])[0].q_second_type;
				num++;
			}
		}
		this._vScrollView.setSize(cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
		this._vScrollView.setInnerContainerSize(cc.size(this.imgBg1.uiWidth, this._btnHash.Values().length * this._btnH ));

		this.ShowMonsterCell(firstId,true);
//		this._ShowOrHideListview();
	},

//	_ShowOrHideListview:function()
//	{
//		for ( var i = 0; i < this._mainBtnArr.length; i++ )
//		{
//			if ( this.curVType == this._btnTypeArr[i] )
//			{
//				this._mainBtnArr[i].SetTextColor(EnumFontFormat.BTN_SELECT_COLOR);
//				this._mainBtnArr[i].SetTextFontSize(EnumFontFormat.CHANNEL_FONTSIZE);
//				this._mainBtnArr[i].SetEnableOutline(EnumFontFormat.BTN_SELECT_MIAOBIAN_COLOR,EnumFontFormat.MIAOBIAN_SIZE);
////				this._mainBtnArr[i].buttonText.setPositionY((this._mainBtnArr[i].height - this._mainBtnArr[i].buttonText.GetHeight()) * 0.5);
//			}
//			else
//			{
//				this._mainBtnArr[i].SetTextColor(EnumFontFormat.BTN_NORMAL_COLOR);
//				this._mainBtnArr[i].SetTextFontSize(EnumFontFormat.CHANNEL_FONTSIZE);
//				this._mainBtnArr[i].SetEnableOutline(EnumFontFormat.BTN_NORMAL_MIAOBIAN_COLOR,EnumFontFormat.MIAOBIAN_SIZE);
////				this._mainBtnArr[i].buttonText.setPositionY((this._mainBtnArr[i].height - this._mainBtnArr[i].buttonText.GetHeight()) * 0.5 - 5);
//			}
//		}
//	},
	
	SortTujianBtnById:function( p1, p2 ){
		var arr1 = p1.split("_");
		var arr2 = p2.split("_");
		if (arr1[1] < arr2[1])
			return 1;
		else if (arr2[1] < arr1[1])
			return -1;

		return 0;
	},

	ClearVScrollView:function () {
		var list = this._btnHash.Keys();
		for( var i = 0; i < list.length; i++ ){
			this._btnHash.Get(list[i]).OnHide();
			UIUtil.UIRemoveSelf( this._btnHash.Get(list[i]) );
			this._btnHash.Remove(list[i]);
		}
	},

	ShowMonsterCell:function (type,isChangeMain) {
		if(!isChangeMain && type == this.curHType)
			return;
		if(this._curMapBtn){
			this._curMapBtn.SetShowSelect(false);
		}
		this._btnHash.Get(this.curVType + "_" + type).SetShowSelect(true);
		this._curMapBtn = this._btnHash.Get(this.curVType + "_" + type);
		this.curHType = type;
		this.ClearHScrollView();
		var list = Mgr.tujian.TujianHash().Get(this.curVType + "_" + type).sort(this.SortTujianCellById);
		var num = 0;
		this._monsterCellIndex = 0;
		for( var i = 0; i < list.length; i++ ){
			var monsterCell = this._GetMonsterFrameExt();//每次new一个会卡，只好new了存起来填充数据，关面板的时候再释放
			//monsterCell.LoadPanel();
			//monsterCell.retain();
			monsterCell.SetData( list[i] );
			monsterCell.x = monsterCell.uiWidth * i;
			monsterCell.y = 0;
			this._hScrollView.addChild(monsterCell);
			this._cellHash.Put(list[i].q_id, monsterCell);
			this._cellW = monsterCell.uiWidth;
		}
		this._hScrollView.setSize(cc.size(this._cellW*this._cellNum, this.imgBg2.uiHeight));
		this._hScrollView.setInnerContainerSize(cc.size(this._cellHash.Values().length * this._cellW, this.imgBg2.uiHeight ));
		
		this.UpdataInfo();
		this.UpdataBtnState();
	},

	_GetMonsterFrameExt:function () {
		if( !this._monsterCellArr ){
			this._monsterCellArr = new Array();
		}
		if( this._monsterCellArr.length <= this._monsterCellIndex ){
			var monsterCell = new TujianMonsterFrameExt();
			monsterCell.LoadPanel();
			monsterCell.retain();
			this._monsterCellArr.push(monsterCell);
		}
		return this._monsterCellArr[ this._monsterCellIndex++ ];
	},
	
	SortTujianCellById:function( p1, p2 ){
		if (p1.q_show_level < p1.q_show_level)
			return -1;
		else if (p1.q_show_level < p1.q_show_level)
			return 1;

		return 0;
	},

	ClearHScrollView:function () {
		var list = this._cellHash.Keys();
		for( var i = 0; i < list.length; i++ ){
			this._cellHash.Get(list[i]).OnHide();
			UIUtil.UIRemoveSelf( this._cellHash.Get(list[i]) );
			this._cellHash.Remove(list[i]);
		}
	},
	
	UpdataInfo:function () {
		if(!Mgr.tujian.tujianMonsterInfoHash)
			return;
		var list = this._cellHash.Values();
		for(var i = 0; i < list.length; i++){
			list[i].SetInfo(Mgr.tujian.tujianMonsterInfoHash.Get(list[i].tujianId));
		}
		list = this._btnHash.Values();
		for(i = 0; i < list.length; i++){
			list[i].UpdataShowJihuo();
		}
		this.UpdataShowJihuo();
	},

	UpdataOneInfo:function (info) {
		if(this._cellHash.Get(info.tujianId + "_" + 0))
			this._cellHash.Get(info.tujianId + "_" + 0).SetInfo(info);
		var list = this._btnHash.Values();
		for(i = 0; i < list.length; i++){
			list[i].UpdataShowJihuo();
		}
		this.UpdataShowJihuo();
	},

	UpdataShowJihuo:function () {
		var needShowYW = false;
		var needShowKF = false;
		var list = Mgr.tujian.TujianHash().Values();
		for( var i = 0; i < list.length; i++ ){
			var tempArr = list[i];
			for( var j = 0; j < tempArr.length; j++ ){
				var qtujian = tempArr[j];
				var canJihuoArr = Mgr.tujian.canJihuoHash.Get(qtujian.q_id);
				if(canJihuoArr && canJihuoArr[0]){
					if( parseInt(canJihuoArr[1]) == EnumTujianType.TYPE_YW ){
						needShowYW = true;
					}else if( parseInt(canJihuoArr[1]) == EnumTujianType.TYPE_KF ){
						needShowKF = true;
					}
					if( needShowYW && needShowKF )
						break;
				}
			}
		}

		this.imgTanhao.setVisible(needShowYW);
		this.imgTanhao1.setVisible(needShowKF);
	},
	
	OnShow:function(){
		this.sbtnYewain.SetButtonState("check");
		this.sbtnKuafu.SetButtonState("uncheck");
		this.ShowBtnCell(EnumTujianType.TYPE_YW);
		Mgr.tujian.SendReqTujianInfoToGameMessage(EnumTujianType.TYPE_YW);
	},
	
	OnHide:function(){
		this._super();
		this._monsterCellArr.length = 0;
	}
} );
TujianPanelExt.PanelName = "TujianPanelExt";
PanelClassDic["TujianPanelExt"] = TujianPanelExt;
