﻿var WealModMgr = WealModMgr || cc.Class.extend({

	levelGiftPanel:null,
	levelWarn:null,
	canFeedBack:false,
	firstRechargheInfo:null,
	isGettedRechargeReward:false,

	ctor:function() {	
	},

	RecvResUpGradeInfoToGameMessage:function(msg) {
        this._rewardedArr = msg.giftId;
        if (this.levelGiftPanel)
            this.levelGiftPanel.ShowFrame(msg.giftId);

        var list = Q_upgrade.GetList();
        this.levelWarn = false;
        for (var i = 0; i < list.length; i++){
        	if(msg.giftId.indexOf(list[i].q_id) < 0 && list[i].q_level <= Mgr.player.mainPlayer.attributeData.level)
                this.levelWarn = true;
		}
        var panel = Mgr.uiMgr.GetPanelByType( MiniMapPanelExt.PanelName );
        if ( panel )
            panel.UpdataFuliWarn(FuliTypeEnum.TYPE_LEVEL);
	},

	RecvResGetLandInfoToGameMessage:function(msg) {
        var minipanel = Mgr.uiMgr.GetPanelByType( MiniMapPanelExt.PanelName );
		if(minipanel)
            minipanel.UpdataQiriWarn(msg.landDay, msg.giftId);
        var panel = EngineMgr.uiMgr.GetPanelByType(QiridengluPanelExt.PanelName);
		if(panel)
        	panel.SetData(msg.landDay, msg.giftId);
	},

	RecvResUpGradeRewardToClinetMessage:function(msg) {
        this._rewardedArr.push(msg.giftId);
        if(this.levelGiftPanel)
            this.levelGiftPanel.ShowFrame(this._rewardedArr);
	},
	RecvResFirstRechargeInfoToClientMessage:function(msg) {
		this.firstRechargheInfo = msg;

		if( Mgr.uiMgr.IsPanelShowByName(MeiRiYiYuanExt.PanelName) ){
			var panel = Mgr.uiMgr.GetPanelByType(MeiRiYiYuanExt.PanelName);
			panel.UpdatePanel();
		}

		var data = Q_first_charge.Get(this.firstRechargheInfo.day);
		if( data ){
			var goldArr = JSON.parse( data.q_recharge );
			if( this.firstRechargheInfo.receiveAwards.indexOf(goldArr[0]) == -1 ){
				this.isGettedRechargeReward = false;
				Mgr.map.miniMapPanel.UpdateMRWarn(this.firstRechargheInfo.rechargeGold >= goldArr[0]);
			}
			else{
				this.isGettedRechargeReward = true;
				Mgr.map.miniMapPanel.UpdateMRWarn(false);
			}
		}
		Mgr.map.miniMapPanel.UpdateActivityButton( Mgr.map.miniMapPanel._activityList);
	},

	RecvResGetLandRewardToClinetMessage:function(msg) {
		cc.log("---RecvResGetLandRewardToClinetMessage---");
        var panel = EngineMgr.uiMgr.GetPanelByType(QiridengluPanelExt.PanelName);
        panel.GetGift(msg.giftId);
	},
    RecvResFeedBackToClinetMessage:function(msg){
		cc.log("-----------意见反馈信息--------------");
		this.canFeedBack = msg.submit;
		var panel = Mgr.uiMgr.GetPanelByType(FulidatingPanelExt.PanelName);
		if(panel){
            panel.showType = null
            panel.OnShow();
		}
	},

	SendReqUpGradeInfoToGameMessage:function() {
        var msg = new ReqUpGradeInfoToGameMessage();
        Mgr.msgMgr.Send(msg);
	},

	SendReqUpGradeRewardToGameMessage:function(giftId) {
		cc.log("请求领取等级成长礼包" + giftId);
        var msg = new ReqUpGradeRewardToGameMessage();
        msg.giftId = giftId;
        Mgr.msgMgr.Send(msg);
	},

	SendReqGetLandInfoToGameMessage:function() {
    	Mgr.msgMgr.Send(new ReqGetLandInfoToGameMessage());
	},

	SendReqGetLandRewardToGameMessage:function(giftId, type) {
    	var msg = new ReqGetLandRewardToGameMessage();
    	msg.giftId = giftId;	// 七日登陆礼包ID
    	msg.type = type;		// 类型:0请求领取普通七日礼包,1请求领取登录器七日礼包
    	Mgr.msgMgr.Send(msg);
	},

	SendReqFeedBackToGameMessage:function(satisfied, context){
    	var msg = new ReqFeedBackToGameMessage();
    	msg.satisfied = satisfied;
    	msg.context = context;
        Mgr.msgMgr.Send(msg);
	},

	SendReqFirstRechargeAwardToGameMessage:function(day, gold){
		var msg = new ReqFirstRechargeAwardToGameMessage();
		msg.day = day;
		msg.gold = gold;
		Mgr.msgMgr.Send(msg);
	}
});