var GuangWuXuanShangExt = GuangWuXuanShang.extend ( {
	_className:"GuangWuXuanShangExt",

    _btnList:null,

	ctor:function(){
		this._super();
	},

    Init:function () {
        GuangWuXuanShang.prototype.Init.call(this);

        this.lab1.SetFontSize(18);
        this.lab2.SetFontSize(18);
        this.lab11.SetFontSize(18);

        this._btnList = [
            {btn: this.btnlingQu, lable: this.lab1,   img:this.imgYiJiSha,  showItem:this.labSuiPian,  itemImg:this.imgIcon, tip:this.imgDian},
            {btn: this.btnlingQu1, lable: this.lab11, img:this.imgYiJiSha1, showItem:this.labSuiPian1, itemImg:this.imgIcon1, tip:this.imgDian1},
            {btn: this.btnlingQu2, lable: this.lab2,  img:this.imgYiJiSha2, showItem:this.labSuiPian2, itemImg:this.imgIcon2, tip:this.imgDian2},
        ];
        this.bossIdList = JSON.parse(Q_global.Get(1154).q_string_value);
        var self = this;
        for(var i = 0; i < this._btnList.length; i++){
            self._btnList[i].btn.setTitleText("追缉");
            self._btnList[i].img.visible = false;
            var info = JSON.parse(Q_monster_dropprob.Get(self.bossIdList[i]).q_drop_show);
            self._btnList[i].showItem.SetText(Q_item.Get(info[0].mod).q_name + "X" + info[0].num);
            (function(i){
                EngineMgr.uiMgr.GetAsynResByUrl(ResUrl.GetItemIconKey(info[0].mod), function(){
                    self._btnList[i].itemImg.loadTexture(ResUrl.GetItemIconKey(info[0].mod), ccui.Widget.PLIST_TEXTURE);
                }, self._btnList[i].itemImg);
                self._btnList[i].btn.addClickEventListener(function (sender) {
                    Mgr.monster.curWorldBossInfo = self._bossMap.Get(self.bossIdList[i]);
                    var info = Q_boss_world.Get(self.bossIdList[i]);
                    Mgr.map.SendReqGoldMapTransMessage(info.q_appear_map);
                });
            })(i);
        }
    },

    OnShow:function(info){
	    this._data = info;
	    Mgr.monster.SendReqQueryBossListMessage(0, 5);
    },

    RefreshPanel:function(bossMap){
        this._bossMap = bossMap;
        
        for(var i = 0; i < this.bossIdList.length; i++){
            var info = this._bossMap.Get(this.bossIdList[i]);
            if(info){
                var btn = this._btnList[i];
                if(info.status == -1){
                    btn.img.setVisible(false);
                    btn.btn.setVisible(true);
                    btn.tip.setVisible(false);
                    btn.lable.SetText("已击杀");
                    Filter.GrayScale(btn.btn);
                    btn.btn.setTouchEnabled(false);
                }else if(info.status == 0){
                    btn.img.setVisible(false);
                    btn.btn.setVisible(true);
                    btn.tip.setVisible(true);
                    btn.lable.SetText("已刷新");
                    Filter.UnGray(btn.btn);
                    btn.btn.setTouchEnabled(true);
                }else {
                    btn.img.setVisible(false);
                    btn.btn.setVisible(true);
                    btn.tip.setVisible(false);
                    Filter.UnGray(btn.btn);
                    btn.btn.setTouchEnabled(true);

                    (function(btn){
                        if(!btn._timer){
                            var leftTime = info.status;
                            var str = TimeUtil.SecondToDHMS2(leftTime);
                            btn.lable.SetText("刷新时间：" + str);
                            btn._timer = TimerUtil.TimeUpdate(function () {
                                leftTime--;
                                var str = TimeUtil.SecondToDHMS2(leftTime);
                                btn.lable.SetText("刷新时间：" + str);
                            },this, 1, leftTime);
                        }
                    })(btn);
               }
            }
        }
    }
} );
GuangWuXuanShangExt.PanelName = "GuangWuXuanShangExt";
PanelClassDic["GuangWuXuanShangExt"] = GuangWuXuanShangExt;
