var WuLinQingDianPanelExt = WuLinQingDianPanel.extend ( {
	_className:"WuLinQingDianPanelExt",

    centerX:null,
    centerY:null,

    _height:null,

    _itemList:null,
    _infoList:null,

    showPanel:null,
    panelMgr:[],

    timeId:-1,
    _IsRotate:false,

    _lastAngle:0,

	ctor:function(){
		this._super();
		this._infoList = new HashMap();

        this.modelPanelType = MUIPanelModelType.BLUR;
	},

    Init:function () {
        WuLinQingDianPanel.prototype.Init.call(this);
        this.layoutCom.layoutType = MLLAYOUT_C;
        // this.layoutCom.layoutOffy = -28;
        this._curType = 10;

        var self = this;

        this.centerX = this.imgGrids.x + this.imgGrids.uiWidth/2;
        this.centerY = this.imgGrids.y + this.imgGrids.uiHeight/2;
        this.imgZhen.x = this.imgZhen.x + this.imgZhen.uiWidth/2;
        this.imgZhen.setAnchorPoint(cc.p(0.5, -(this.imgZhen.y - this.centerY)/this.imgZhen.uiHeight));
        this.imgZhen.y = this.centerY;

        var costInfo = Q_lucky_draw_total.Get(7);
        var costItemInfo = JSON.parse(costInfo.q_item);
        var costPriceInfo = JSON.parse(costInfo.q_currency_cost);

        this.imglabNumBer.y += 4;
        this.imglabNumBer.SetText(costItemInfo[0][2]);
        this.imglabNum.SetText(costPriceInfo[0][2]);

        // this.imglabNumBer1.SetText(costItemInfo[1][2]);
        // this.imglabNum1.SetText(costPriceInfo[1][2]);
        //
        // this.imglabNumBer2.SetText(costItemInfo[2][2]);
        // this.imglabNum2.SetText(costPriceInfo[2][2]);
        this.grid3.setVisible(false);
        this.grid5.setVisible(false);
        this.grid7.setVisible(false);
        this.imgJueBan.setVisible(false);
        this.imgZheKou.setVisible(false);
        this.labTime.x -= 50;

        this._gridList = [
            {grid: this.grid1, angle: 0},
            {grid: this.grid2, angle: 315},
            {grid: this.grid3, angle: 270},
            {grid: this.grid4, angle: 225},
            {grid: this.grid5, angle: 180},
            {grid: this.grid6, angle: 135},
            {grid: this.grid7, angle: 90},
            {grid: this.grid8, angle: 45}
        ];

        this._itemList = [
            {btn: this.sbtn1, subPanelType: 10, title:"消耗排行",},
            {btn: this.sbtn2, subPanelType: 55, title:"庆典悬赏",},
            {btn: this.sbtn3, subPanelType: 5, title:"积分兑换",},
            {btn: this.sbtn4, subPanelType: 16, title:"抽奖记录",},
            {btn: this.sbtn5, subPanelType: 0, title:"",}
        ];

        for(var i = 0; i < this._itemList.length; i++){
            this._itemList[i].btn.visible = false;
            this._itemList[i].btn.SetButtonState("uncheck");

            (function(i){
                self._itemList[i].btn.addClickEventListener(function (sender) {
                    self.ChangePanel(self._itemList[i].subPanelType);
                });
            })(i);
        }

        this.imgQiu.setTouchEnabled(true);
        this.imgQiu.addTouchEventListener(function(sender,type)
        {
            if ( type == ccui.Widget.TOUCH_ENDED )
            {
                if(self._IsRotate){
                    Mgr.tips.ShowNotice("正在抽奖,请稍后");
                    return;
                }
                self.StartLuckyDraw(1);
            }
        });

        this.btnChouQu1.addClickEventListener(function (sender) {
            if(self._IsRotate){
                Mgr.tips.ShowNotice("正在抽奖,请稍后");
                return;
            }
            self.StartLuckyDraw(10);
        });

        this.btnChouQu2.addClickEventListener(function (sender) {
            if(self._IsRotate){
                Mgr.tips.ShowNotice("正在抽奖,请稍后");
                return;
            }
            self.StartLuckyDraw(50);
        });

        this.btnClose.addClickEventListener(function (sender) {
            Mgr.uiMgr.HidePanel(self);
        });

        this.InitReward();
    },

    InitReward:function(){
	    var rewardList = JSON.parse(Q_global.Get(1144).q_string_value);
	    var rewardGridList = [this.grid1, this.grid8, this.grid6, this.grid4, this.grid2];
	    for(var i = 0; i < rewardList.length; i++){
	        if(rewardGridList[i]){
                rewardGridList[i].Id = rewardList[i].mod;
                rewardGridList[i].itemNum = rewardList[i].num;
                var coinInfo = {};
                coinInfo.itemModelId = rewardList[i].mod;
                coinInfo.itemNum = rewardList[i].num;
                GridUtil.SetItemGrid(rewardGridList[i], coinInfo);
            }
        }
        var goldList = JSON.parse(Q_global.Get(1153).q_string_value);
        var rewardGoldList = [this.grid7, this.grid5, this.grid3];
        for(var i = 0; i < goldList.length; i++){
            if(rewardGoldList[i]){
                rewardGoldList[i].Id = goldList[i][0];
                rewardGoldList[i].itemNum = goldList[i][1];
            }
        }
    },

    OnShow:function () {
        Mgr.luckydraw.SendReqLuckyDrawInfoClientToGameMessage(EnumLucky.GUANGWU);
        Mgr.luckydraw.guangwuPanel = this;
    },

    GetRecord:function(items){
	    if(items.length == 1){
	        for(var i = 0; i < this._gridList.length; i++){
	            if(this._gridList[i].grid.Id == items[0].mod){
                    this.RotateTo(this._gridList[i].angle);
                    return;
                }
            }
        }
        this.RotateTo(315);
    },

    RotateTo:function(angle){
        this.imgZhen.stopAllActions();
	    var rotate = new cc.RotateTo(3, 1080 + angle + 360);
	    var rotate_ease_out = rotate.easing(cc.easeOut(3));

	    var self = this;
        var action = cc.sequence([rotate_ease_out,
            new cc.CallFunc(function(){
                var panel=EngineMgr.uiMgr.ShowPanelByType(IncomePanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                if(panel){
                    panel.ShowEffect();
                }
                self._IsRotate = false;
            }, this)
        ]);

        self._IsRotate = true;
        this.imgZhen.runAction(action);
    },

    StartLuckyDraw:function (num) {
        Mgr.luckydraw.index = num;

        var costInfo = Q_lucky_draw_total.Get(7);
        var costItemInfo = JSON.parse(costInfo.q_item);
        var costPriceInfo = JSON.parse(costInfo.q_currency_cost);
        var holdNum = Mgr.backpack.GetItemNumber(costItemInfo[0][1]);
        var q_item = Q_item.Get(costItemInfo[0][1]);
        if(holdNum < num){
            var panel = Mgr.uiMgr.ShowPanelByType(GouMaiPanelExt.PanelName);
            panel.AddCallBack(()=>{
                var acs = this._infoList.Get(10);
                var reqIds = [];
                if(acs){
                    for(var i = 0; i < acs.length; i++){
                        reqIds.push(acs[i].activityId);
                    }
                    Mgr.dailyactivity.SendReqDailyActivitiesDetailedInfoMessage(reqIds);
                }
            });
            panel.BuyCard(costItemInfo[0][1], num - holdNum);
        }else {
            Mgr.luckydraw.SendReqLuckyDrawPerformClientToGameMessage(EnumLucky.GUANGWU, num);
        }
    },

    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        isOpen = isOpen || false;
        this.mainPanelKey = mainPanelKey;
        this.UpdateActivityInfo(isOpen);
    },

    RefreshRecord:function(personInfo, allInfo){
	    cc.log("=======RefreshRecord======" + this.panelMgr[16])
        if(personInfo)
            this.personInfo = personInfo;
	    if(allInfo)
	        this.allInfo = allInfo;
        if(this.panelMgr[16]){
            this.panelMgr[16].RefreshList();
        }
    },

    RefreshGoldNum:function(num){
        if(num){
            this.imglabNum1.SetText(num);
            var self = this;
            TimerUtil.SetTimeout(this, function(){
                var pos = self.imgHongDi.uiWidth/2 -  (self.imgJiangChi.uiWidth + self.imglabNum1._getWidth() + self.imgYuanBao11.uiWidth)/2;
                self.imgJiangChi.x = pos;
                self.imglabNum1.x = self.imgJiangChi.uiWidth + pos;
                self.imgYuanBao11.x = self.imglabNum1._getWidth() + self.imgJiangChi.uiWidth + pos;
            }, 100 );
        }
        else
            this.imglabNum1.SetText(0);
    },

    RefreshZone:function(info){
	    cc.log("========RefreshZone=======" + this.panelMgr[55])
        if(this.panelMgr[55]){
            this.panelMgr[55].RefreshPanel(info);
        }
    },

    UpdateActivityInfo:function(isOpen){
        var list = Mgr.dailyactivity.GetActivityByKey(this.mainPanelKey);
        this.activityList = list;
        this.UpdatePanel(list);
    },

    UpdateSingleActivity:function (ac) {
        if(this._curType == 5){
            this.panelMgr[5].UpdateSingleCell(ac);
        }
    },

    UpdatePanel:function(info){
        this._infoList.Clear();
        for(var i = 0; i < this._itemList.length; i++){
            for(var j = 0, len = info.length; j < len; j++){
                if(info[j].subPanelType == this._itemList[i].subPanelType){
                    if(!this._infoList.Get(this._itemList[i].subPanelType))
                        this._infoList.Put(this._itemList[i].subPanelType, []);
                    this._infoList.Get(this._itemList[i].subPanelType).push(info[j]);
                    this._itemList[i].btn.visible = true;
                    this._itemList[i].btn.SetText(this._itemList[i].title);
                    this._itemList[i].btn.AddPossitionOffset(0, 10);
                }
            }
        }

        this.ChangePanel(this._curType);
        this.endTime = info[0].endTime;

        UIUtil.ConnectLabelHtmlText(this.labTime,[info[0].durationStr]);
        // this.UpdateTime();
        // this.timeId = TimerUtil.TimeUpdate(this.UpdateTime, this, 1);
    },


    ChangePanel:function(type){
        this._curType = type;

        for(var i = 0; i != this._itemList.length; i++){
            if(this._itemList[i].subPanelType == type)
                this._itemList[i].btn.SetButtonState("check");
            else
                this._itemList[i].btn.SetButtonState("uncheck");
        }

        if(this.showPanel){
            this.showPanel.visible = false;
            this.showPanel.OnHide();
            this.showPanel = null;
        }

        switch(type){
            case 5:
                if(!this.panelMgr[type]){
                    var panel = new JiFenDuiHuanExt();
                    panel.LoadPanel();
                    this.imgContent.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                this.panelMgr[type].OnShow(this._infoList.Get(type));
                break;
            case 10:
                if(!this.panelMgr[type]){
                    var panel = new XiaoHaoPaiHangExt();
                    panel.LoadPanel();
                    this.imgContent.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                this.panelMgr[type].OnShow(this._infoList.Get(type));
                break;
            case 16:
                if(!this.panelMgr[type]){
                    var panel = new JiLuFrameExt();
                    panel.LoadPanel();
                    this.imgContent.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                this.panelMgr[type].OnShow(this._infoList.Get(type));
                break;
            case 55:
                if(!this.panelMgr[type]){
                    var panel = new GuangWuXuanShangExt();
                    panel.LoadPanel();
                    this.imgContent.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                this.panelMgr[type].OnShow(this._infoList.Get(type));
                break;
            default:
                break;
        }

        this.showType = type;
        this.showPanel = this.panelMgr[type];
        if(this.showPanel){
            this.showPanel.setVisible(true);
        }
    },

    // UpdateTime:function(){
    //     var leftTime = this.endTime - parseInt(Mgr.login.GetServerTime() / 1000);
    //
    //     var arr = TimeUtil.SecondToDHMS3(leftTime);
    //     var str = "";
    //     if(arr.length > 3){
    //         str  = arr[0] + "天";
    //         str += arr[1] + "时";
    //         str += arr[2] + "分";
    //         str += arr[3] + "秒";
    //     }
    //     else{
    //         str = TimeUtil.SecondToDHMS2(leftTime);
    //     }
    //
    //     UIUtil.ConnectLabelHtmlText(this.labTime,[str]);
    // },

    OnHide:function(){
        if(this.timeId)
            TimerUtil.ClearTimeUpdate(this.timeId, this);
    },
} );
WuLinQingDianPanelExt.PanelName = "WuLinQingDianPanelExt";
PanelClassDic["WuLinQingDianPanelExt"] = WuLinQingDianPanelExt;
