var XiaoHaoPaiHangExt = XiaoHaoPaiHang.extend ( {
	_className:"XiaoHaoPaiHangExt",
	ctor:function(){
		this._super();
	},

	Init:function () {
		XiaoHaoPaiHang.prototype.Init.call(this);
		this.myIndex = -1;
		this.myCost = 0;
    },

	OnShow:function (data) {
        this._data = data;
        this.totalNum = data.length;
        this.myCost = data[0].special[1].beanInfo.gold;
		var allRankInfos = [];
		for(var i = 0; i < this.totalNum; i++) {
            var rankInfos = data[i].special[0].beanInfo.rankInfos;
            if(rankInfos && rankInfos.length > 0){
                allRankInfos = allRankInfos.concat(rankInfos);
			}
        }

		for(var k = 0; k < allRankInfos.length; k++){
			var rankInfo = allRankInfos[k];
			if(rankInfo.playerid.toGID() == Mgr.player.mainPlayer.sid.toGID()){
				this.myIndex = k+1;
				break;
			}
		}

		UIUtil.ConnectLabelHtmlText(this.labTime1, [this.myCost]);
        if(this.myIndex > 0){
            UIUtil.ConnectLabelHtmlText(this.labTime11, [this.myIndex]);
        }else {
            this.labTime11.SetHtmlText("<font color=\"#3a2707\">当前排名：<font color=\"#dc143c\">未上榜");
        }

        var need = data[0].GetFlagValue("gold");
        UIUtil.ConnectLabelHtmlText(this.labNeed, [need]);

        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgContent.uiWidth, this.imgContent.uiHeight + 5));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.setTouchEnabled(true);
            this.cellPanel=tableView;
            this.imgContent.addChild(tableView);
        }

        this.cellPanel.reloadData();
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(663, 111);
    },
    tableCellAtIndex: function (table, idx) {
        var data = this._data[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item = new XiaoHaoPaiHangListExt();
            item.LoadPanel();
            item.setTouchEnabled(false);
            cell.item = item;
            cell.addChild(item);
        }
        cell.item.SetData(data, idx);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
} );
XiaoHaoPaiHangExt.PanelName = "XiaoHaoPaiHangExt";
PanelClassDic["XiaoHaoPaiHangExt"] = XiaoHaoPaiHangExt;
