var XingYunZhuanPanMainExt = XingYunZhuanPanMain.extend ( {
	_className:"XingYunZhuanPanMainExt",
	_index:1,
	_runTimes:4,
	_isDrawAll:false,
	_isDoEffect:true,
	ctor:function(){
		this._super();
	},

	Init:function () {
		XingYunZhuanPanMain.prototype.Init.call(this);

		this.gridArr = [this.grid1];
		this.labCue1.SetFontSize(18);
		this.labCue1.SetTextAlign(cc.TEXT_ALIGNMENT_CENTER);
		this.imgCover.removeFromParent();
		this.addChild(this.imgCover);
        this.imgCover.x = this.img1.x;
        this.imgCover.y = this.img1.y;

        this.isOpenShoping = false;
		var self = this;
		this.btnShangCheng.addClickEventListener(function (sender) {
			self.isOpenShoping = true;
            //这里请求一下积分商城的活动详细信息
            var infos = self.parentPanel.GetInfosByTabKey(2);
            var reqIds = [];
            for(var i = 0, len = infos.length; i < len; i++){
                reqIds.push(infos[i].activityId);
            }
            Mgr.dailyactivity.SendReqDailyActivitiesDetailedInfoMessage(reqIds);
        });
		
		this.btnGouMai.addClickEventListener(function (sender) {
			if(self._isRunning){
				return;
			}

			self.StartLuckyDraw();
        });

		this.labGouMai.setTouchEnabled(true);
		this.labGouMai.addTouchEventListener(function (sender, type) {
			if(type == ccui.Widget.TOUCH_ENDED){
				var panel = Mgr.uiMgr.ShowPanelByType(GouMaiPanelExt.PanelName);
				panel.BuyCard(1001, 1);
			}
        });

		this.sbtnGouxuan.addClickEventListener(function (sender) {
            var state = sender.GetState();
            self._isDrawAll = state == "check";
        });

        this.sbtn1.addClickEventListener(function (sender) {
            var state = sender.GetState();
            self._isDoEffect = state == "uncheck";
        });
    },

	SetData:function (info) {
		this._data = info;

		if(this._isDrawAll){
			this.sbtnGouxuan.SetButtonState("check")
		}else {
			this.sbtnGouxuan.SetButtonState("uncheck")
		}

		if(this._isDoEffect){
			this.sbtn1.SetButtonState("uncheck");
		}else {
            this.sbtn1.SetButtonState("check");
		}
		if(info.freeLuckyDrawNums > 0){
			this.labCue2.SetText("当前免费次数：" + info.freeLuckyDrawNums);
		}else {
            this.labCue2.SetText("鸿运龙卡剩余：" + Mgr.backpack.GetItemNumber(1001));
		}
        // UIUtil.ConnectLabelHtmlText(this.labCue2, [info.freeLuckyDrawNums + Mgr.backpack.GetItemNumber(1001)]);
		UIUtil.ConnectLabelHtmlText(this.labCue, [info.score]);
        var gold = Mgr.mainPlayer.attributeData.GetAttribute(EnumMoney.LUCKY_GOLD, AttributeData.Money);
        UIUtil.ConnectLabelHtmlText(this.labShuZi, [gold]);

		if(!this._timer){
			var leftTime = info.freeLuckyDrawTime - parseInt(Mgr.login.GetServerTime() / 1000);
            var str = TimeUtil.SecondToDHMS2(leftTime);
            UIUtil.ConnectLabelHtmlText(this.labCue1, ["(免费倒计时：" + str+")"]);
			this._timer = TimerUtil.TimeUpdate(function () {
				leftTime--;
				if(leftTime <= 0){
                    this.labCue2.SetText("当前免费次数：" + (this._data.freeLuckyDrawNums + 1));
				}
				var str = TimeUtil.SecondToDHMS2(leftTime);
				UIUtil.ConnectLabelHtmlText(this.labCue1, ["(免费倒计时：" + str+")"]);
            }, this, 1, leftTime);
		}

		var items = info.drawItems;
		for(var i = 0; i < items.length; i++){
			if(!this.gridArr[i]){
				var grid = UIUtil.CloneUI(this.grid1);
                if(grid.parent){
                    grid.removeFromParent();
				}
				var index = i+1;
				this["img" + index].addChild(grid);
                this.gridArr.push(grid);
			}

			var grid = this.gridArr[i];
			var item = ItemUtil.ItemIdToItem(items[i].itemModelId, items[i].num);
			GridUtil.SetItemGrid(grid, item);
		}
    },

    StartLuckyDraw:function () {
        var total = Mgr.backpack.GetItemNumber(1001) + this._data.freeLuckyDrawNums;

        if(total > 0){
            var drawNum = 1;
            if(this._isDrawAll){
                drawNum = Math.min(50, total);
            }
            Mgr.luckydraw.index = drawNum;
            Mgr.luckydraw.SendReqLuckyDrawPerformClientToGameMessage(EnumLucky.SPINWIN, drawNum);
        }else {
            var panel = Mgr.uiMgr.ShowPanelByType(GouMaiPanelExt.PanelName);
            panel.BuyCard(1001, 1);
        }
    },

	UpdateLuckyNum:function () {
        if(this._data.freeLuckyDrawNums > 0){
            this.labCue2.SetText("当前免费次数：" + info.freeLuckyDrawNums);
        }else {
            this.labCue2.SetText("鸿运龙卡剩余：" + Mgr.backpack.GetItemNumber(1001));
        }
    },

    ShowEffect:function (rewards) {
		if(!this._isDoEffect || this._isDrawAll) {//全部抽取不做动画
			var panel = Mgr.uiMgr.ShowPanelByType(IncomePanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
			panel.ShowEffect();
			return;
		};

		var reward = rewards[0];
		var index = 0;
		var items = this._data.drawItems;
		for(var i = 0, len = items.length;i < len; i++){
			if(items[i].itemModelId == reward.mod && items[i].num == reward.num){
				index = i + 1;
				break;
			}
		}

        var before = [0,0.4,0.3,0.2,0.1];
        var interval = 0.03;
        var after = [1,0.8,0.6,0.5,0.4,0.3,0.2,0.1];
        var step = items.length * this._runTimes + index - this._index;
        var temp = 1;
        var doAction = function () {
            if(!sys.isObjectValid(this)) return;
			this._isRunning = true;
			this.btnGouMai.setTouchEnabled(false);

            var dt = 0;
            if (temp < before.length) dt = before[temp];
            if (temp > step - after.length) dt = after[step - temp];
            dt = dt || interval;

            var tex = (temp + this._index) % items.length;
            tex = tex || items.length;
            this.imgCover.x = this["img" + tex].x;
            this.imgCover.y = this["img" + tex].y;

            temp++;
            if(temp <= step){
            	TimerUtil.SetTimeout(this, doAction, dt * 1000);
			}else {
				this._isRunning = false;
                this._index = index;
                this.btnGouMai.setTouchEnabled(true);
                var panel = Mgr.uiMgr.ShowPanelByType(IncomePanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                panel.ShowEffect();
			}
        }
        doAction.call(this);
    },
} );
XingYunZhuanPanMainExt.PanelName = "XingYunZhuanPanMainExt";
PanelClassDic["XingYunZhuanPanMainExt"] = XingYunZhuanPanMainExt;
