var JingyanBoxExt = JingyanBox.extend ( {
	_className:"JingyanBoxExt",
	_zonedata:null,
	_canGet:false,
	rawardIndex:-1,
	ctor:function(){
		this._super();
	},

	InitData:function (zonedata, num) {
		this.rawardIndex = num;
		this._zonedata = zonedata;
		this.labCue2.SetText(TextUtil.FormatStr( this.labCue2.GetHtmlText(), [ this._zonedata.q_id ] ));
		var self = this;
		this.addClickEventListener(function () {
			if(self._canGet){
				Mgr.zone.SendReqExpFirstRewardToGameMessage(self._zonedata.q_id);
			}
		});
	},

	UpdateState:function () {
		this._canGet = false;
		if(Mgr.zone.jingyanFristRewardWave.indexOf(this._zonedata.q_id) != -1){//已領取
			this.imgGet.setVisible(true);
			var imageRes = "other/danrenfuben/image/baoxiang_kai.png";
			var self=this;
			EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
				self.imgBox.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
			}, self.imgBox);
			Filter.UnGray(this.imgBox);
		}else{
			this.imgGet.setVisible(false);
			var imageRes = "other/danrenfuben/image/baoxiang_guan.png";
			var self=this;
			EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
				self.imgBox.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
                if(Mgr.zone.jingyanMaxWave >= self._zonedata.q_id){//可領取
                        Filter.UnGray(self.imgBox);
                    }else{//不可領取
                        Filter.UnGray(self.imgBox);
                        Filter.GrayScale(self.imgBox);
                    }
			}, self.imgBox);
			if(Mgr.zone.jingyanMaxWave >= this._zonedata.q_id){//可領取
				Filter.UnGray(this.imgBox);
				this._canGet = true;
			}else{//不可領取
				Filter.GrayScale(this.imgBox);
			}
		}
	},
	
	IsGetRaward:function(){
		if(Mgr.zone.jingyanFristRewardWave.indexOf(this._zonedata.q_id) != -1){//已領取
			return true;
		}else{
			if(Mgr.zone.jingyanMaxWave >= this._zonedata.q_id){//可領取
				return true;
			}else{//不可領取
				return false;
			}
		}
	}
} );
JingyanBoxExt.PanelName = "JingyanBoxExt";
PanelClassDic["JingyanBoxExt"] = JingyanBoxExt;
