var FBAwardMainExt = FBAwardMain.extend ( {
	_className:"FBAwardMainExt",

	listView:null,
    gridList:null,
    rankingList:null,

	ctor:function(){
		this._super();
        this.gridList = [];
	},

    Init:function(){
        FBAwardMain.prototype.Init.call( this );
        // this.labAwardCue1.visible = false;
        this.gridAward.visible = false;
        // this.gridAward1.visible = false;

        this.labOne.visible = false;
        this.labTwo.visible = false;
        this.labThree.visible = false;
        this.rankingList = [this.labOne, this.labTwo, this.labThree];

        this.confMap = Q_map.Get(Mgr.sceneMap.nMapId);
        this.zoneType = Mgr.sceneMap.ZoneType();
        // this.zoneId = Mgr.sceneMap.GetZoneModelIdByMapId(Mgr.sceneMap.nMapId);

        // this.InitView();
    },

    InitView:function(){
        var reward;
        if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_KFDR){
            this.labFB1.SetText("多人副本:");
            this.labName.SetText(this.confMap.q_map_name);
            this.labAwardCue.SetText(TextUtil.AddColor("伤害排行", "0xfeff02"));
            // if(!Mgr.monster.curWorldBossInfo)
            //     return;
            reward = JSON.parse(Q_raid.Get(Mgr.crossteam.curzoneModelId).q_item_show);
            this.InitGird(reward);
        }
        else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_LFDR){
            this.labFB1.SetText("英雄崛起:");
            this.labName.SetText(this.confMap.q_map_name);
            this.labAwardCue.SetText(TextUtil.AddColor("伤害排行", "0xfeff02"));
            // if(!Mgr.monster.curWorldBossInfo)
            //     return;
            reward = JSON.parse(Q_timing.Get(21).q_item_show);
            this.InitGird(reward);
        }
    },

    InitGird:function(reward){
		if(!this.listView){
            this.listView = new ccui.ListView();
            this.listView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);//视图滚动方向
            this.listView.setTouchEnabled(true);					//触摸开启
            this.listView.inertiaScrollEnabled = false; 			//滚动惯性
            this.listView.setScrollBarEnabled(false);				//滚动条
            this.listView.setBounceEnabled(true);					//边界回弹
            // this.listView.addEventListener(this._SelectedItemEvent);
            this.imgBg.addChild(this.listView);
		}
        for(var i = 0; i < reward.length; i++){
            if(!this.gridList[i]){
                var grid = new GridItem();
                grid.ParseJson(this.gridAward.jsonobj);
                grid.Init();
                // this.addChild(grid);
                grid.x += i%4 * (grid.uiWidth + 5);
                grid.y -= parseInt(i/4) * (grid.uiHeight + 10);
                this.listView.pushBackCustomItem(grid);
                this.gridList.push(grid);
            }
            var coinInfo = {};
            coinInfo.itemModelId = reward[i].mod;
            coinInfo.itemNum = reward[i].num;
            coinInfo.itemBind = reward[i].bind;
            GridUtil.SetItemGrid(this.gridList[i], coinInfo);
        }
        this.listView.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
        this.listView.setInnerContainerSize(cc.size(reward.length * this.gridAward.uiWidth, this.imgBg.uiHeight));
    },

    RefreshRanking:function(info){
        var i = 0;
        for(; i< info.BossDamageInfos.length; i++){
            this.rankingList[i].visible = true;
            var pro = Math.ceil(info.BossDamageInfos[i].damage/1000/info.totalDamage*100);
            if(i < 3)
                this.rankingList[i].SetHtmlText(TextUtil.FormatStr(this.rankingList[i].GetHtmlText(),
                    [info.BossDamageInfos[i].playerName + "    (" + (pro > 100 ? 100 : pro) + "%)"]));
            else
                break;
        }
        for(; i < 3; i++){
            this.rankingList[i].visible = false;
        }
    },

    UpdateView:function(){
    },

} );
FBAwardMainExt.PanelName = "FBAwardMainExt";
PanelClassDic["FBAwardMainExt"] = FBAwardMainExt;
