var FubenDefeatedExt = FubenDefeated.extend ( {
	_className:"FubenDefeatedExt",
	_timerNum:0,
	_time:0,
	_maskScrollView:null,
	_normalPos:null,
	starMc:null,
	modelPanelType:2,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.setSwallowTouches(true);
	},
	Init:function(){
		FubenDefeated.prototype.Init.call(this);
		var self = this;
		this.btnOut.addClickEventListener(function (event){
			self.OnZoneOut();
		});
		this._InitLocalProperty();
	},
	_InitLocalProperty:function()
	{
		this._normalPos = {
			jian:this.imgJian.getPosition(),
			center:this.imgUp.getPosition(),
		}
		this.imgLost.setAnchorPoint(0.5,0.5);
		this.imgLost.x += this.imgLost.width/2;
		this.imgLost.y += this.imgLost.height/2;
		this.imgTitlebg.setAnchorPoint(0.5,0.5);
		this.imgTitlebg.x += this.imgTitlebg.width/2;
		this.imgTitlebg.y += this.imgTitlebg.height/2;
	},
	_AddMask:function()
	{
		if(this._maskScrollView)
		{
			this._StartActions();
			return;
		}
		var size = this.imgGlow.getContentSize();
		this.imgGlow.visible = false;
		this._maskScrollView = Mgr.crossteam.GetScrollView();
		this._maskScrollView.setContentSize(size);
		this._maskScrollView.x = -size.width/2;
		this._maskScrollView.setInnerContainerSize(size);
		this.imgGlowZhongxin.addChild(this._maskScrollView);
		var self = this;
		if(!this._glow)
		{
			Mgr.uiMgr.LoadOtherRes( "other/danrenfuben" ,
				{
					Callback:function()
					{
						var glow = new ccui.ImageView("other/danrenfuben/image/action2/lay.png",1);
						glow.setPosition(size.width/2,0);
						self._glow = glow;
						self._maskScrollView.addChild(self._glow);
						self._StartActions();
					},
					ErrCallback:function(){
						// complete();
					}
				});
		}
		else
		{
			this._StartActions();
		}
	},
	OnTimer:function () {
		this._time--;
		if( this._time == 0 ){
			Mgr.player.TryStartAutoFight();
			this.OnZoneOut();
			return;
		}
		this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ this._time ] ));
	},

	OnZoneOut:function()
	{
		if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_WD){
			Mgr.zone.SendReqZoneOutToGameMessage();
			Mgr.uiMgr.HidePanel(this);
		}
		else if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_KFDR)
		{
			Mgr.cross.SendReqQuitClientToFightMessage();
		}
		else if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_LFDR)
		{
			Mgr.zone.SendReqZoneOutToGameMessage();
		}
		else{
			Mgr.zone.SendReqZoneOutToGameMessage();
		}
		Mgr.uiMgr.HidePanel(this);
	},
	
	OnHide:function(){
		this._super();
		TimerUtil.ClearTimeUpdate(this._timerNum, this);
		this._time = 0;
		this.HideAction();
	},
	
	OnShow:function(){
		this.ShowActive();
		Mgr.player.TryStopAutoFight();
		var oldtime = this._time;
		this._time = 10;
		this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ this._time ] ));
		if(oldtime <= 0){
			TimerUtil.ClearTimeUpdate(this._timerNum, this);
			this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
		}
	},
	_StartActions:function()
	{
		this._SetParticEffect();
		var time = 0.2;
		//背光光效
		this._glow.opacity = 0;
		var fadeIn = cc.fadeIn(time);
		var rotateby = new cc.RotateBy(10, 360).repeatForever();
		this._glow.runAction(rotateby);
		this._glow.runAction(fadeIn);
		//剑
		this.imgJian.opacity = 0;
		this.imgJian.y = this._normalPos.jian.y-20;
		var fadeIn = cc.fadeIn(time);
		var moveBy = cc.moveBy(time,0,20);
		var spawn = cc.spawn(fadeIn,moveBy);
		this.imgJian.runAction(spawn);
		//center
		this.imgUp.opacity = 0;
		this.imgUp.y-=10;
		var fadeIn = cc.fadeIn(time);
		var moveBy = cc.moveBy(time,0,10);
		var spawn = cc.spawn(fadeIn,moveBy);
		this.imgUp.runAction(spawn);
		//scale
		var scale01 = 0.8;
		var scale02 = 1;
		this.imgTitlebg.scale = scale01;
		this.imgTitlebg.opacity = 0;
		var fadeIn = cc.fadeIn(time);
		var scaleTo = cc.scaleTo(time,scale02,scale02);
		var spawn = cc.spawn(fadeIn,scaleTo);
		this.imgTitlebg.runAction(spawn);

		this.imgLost.opacity = 0;
		this.imgLost.scale = scale01-0.2;
		var fadeIn = cc.fadeIn(time);
		var scaleTo = cc.scaleTo(time,scale02,scale02);
		var spawn = cc.spawn(fadeIn,scaleTo);
		this.imgLost.runAction(spawn);
	},
	_SetParticEffect:function()
	{
		if(this.starMc){
			return;
		}
		//星星球形粒子动画
		this.starMc = new TweenParticleRectMovie(this.imgYan, 3, 0.5, 400, 200);
		this.starMc.x = this.imgYan.x+98;
		this.starMc.y = this.imgYan.y-205;
		this.addChild(this.starMc,this.imgGlowZhongxin.getLocalZOrder());
		this.starMc.setAlpha(0.2, 0.8);
		this.starMc.play();
	},
	_StopActions:function()
	{
		this.starMc.removeThisAll();
		this.starMc.removeFromParent();
		this.starMc=null;
		this._glow.stopAllActions();
	},

	ShowActive:function(){
		this._AddMask();
	},

	HideAction:function(){
		this._StopActions();
	},
} );
FubenDefeatedExt.PanelName = "FubenDefeatedExt";
PanelClassDic["FubenDefeatedExt"] = FubenDefeatedExt;
