/**
 * Created by merlin on 2017/10/6.
 */
var NativeUtil = NativeUtil || {
        GetNetInfo: function () {
            var info;
            if (cc.sys.platform == cc.sys.ANDROID) {
                info = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getNetInfo", "()Ljava/lang/String;");
            }
            else if (cc.sys.platform == cc.sys.IOS) {
                info = jsb.reflection.callStaticMethod("AppController", "getNetInfo");
            }
            if (info)
                return JSON.parse(info);
            return null;
        },

        Copy: function (text) {
            if (cc.sys.platform == cc.sys.ANDROID) {
                jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "copyToClipboard", "(Ljava/lang/String;)V", text);
            }
            else if (cc.sys.platform == cc.sys.IOS) {
                jsb.reflection.callStaticMethod("AppController", "copyToClipboard:", text);
            }
        },


        /***********************************************
         * http模拟ping得到延迟(暂时没用  还是让服务器加个心跳消息  但要注意处理超时的情况)
         **********************************************/
        StartPing: function () {
            TimerUtil.TimeUpdate(this.Ping, this, 3);
        },

        Ping: function () {
            this.pingStartTime = TimerUtil.GetTimer();

            var url = "http://192.168.51.226:7778";
            var xhr = cc.loader.getXMLHttpRequest();
            xhr.open("GET", url, true);
            var self = this;
            xhr.onreadystatechange = xhr.onerror = function () {
                cc.log("---------------->" + xhr.readyState + "   ----   " + (TimerUtil.GetTimer() - self.pingStartTime));
            };
            xhr.send();
        },

        /// 获取APP包名
        getAppPackageName:function(){
            var ret = "";
            if (cc.sys.platform == cc.sys.ANDROID) {
                ret = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getAppPackageName", "()Ljava/lang/String;");
            }else if(cc.sys.platform == cc.sys.IOS) {
                // TODO add this
                //ret = jsb.reflection.callStaticMethod("AppController", "copyToClipboard:", text);
            }

            return ret;
        },

        /// 获取application meta
        getApplicationMetaData:function(key){
            var ret = "";
            if (cc.sys.platform == cc.sys.ANDROID) {
                ret = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getApplicationMetaData", "(Ljava/lang/String;)Ljava/lang/String;", key);
            }else if (cc.sys.platform == cc.sys.IOS) {
                // TODO add this
                //ret = jsb.reflection.callStaticMethod("AppController", "", text);
            }

            return ret;
        },
    };
