﻿/*
 * 
 * 动画全局定义
 * tyevlag
 * 
 */
var EnumActionType = EnumActionType || {};

//EnumActionType.STAND = 0;
//EnumActionType.RUN = 2;
//EnumActionType.JUMP = 3;//起跳
//EnumActionType.STANDBY = 4;
//EnumActionType.CREATE = 5;
//EnumActionType.DIG = 6;
//EnumActionType.GATHER = 7;
//EnumActionType.LEISURE = 8;
//EnumActionType.WOUND = 9;
//EnumActionType.DEAD = 10;
//EnumActionType.ATTACK = 19;
//EnumActionType.CAST = 20;
//EnumActionType.ATTACK3 = 21;
//EnumActionType.COLLIDE = 23;
//EnumActionType.BACKOUT = 24;
//EnumActionType.STAND5 = 100;

EnumActionType.STAND			= 0;
EnumActionType.RUN				= 2;
EnumActionType.JUMP				= 3;    
EnumActionType.JUMP_FLY   		= 4;    //飞行
EnumActionType.JUMP_SKY2    	= 5;    //二段跳
EnumActionType.JUMP_DOWN    	= 6;    //落地
EnumActionType.SIT				= 7;    // 自己打坐
EnumActionType.SITDOUBLE		= 8;    // 双休
EnumActionType.WOUND 			= 9;	// 受伤
EnumActionType.DEAD				= 10;   // 死亡
EnumActionType.WATERSTAND		= 11;	// 水中站立
EnumActionType.WATERRUN     	= 12;	// 水中走
EnumActionType.PROGRESS 		= 13;	// 采集
EnumActionType.WINK_MOVE 		= 14;	// 轻功飞行	
EnumActionType.BEAT_FLAT 		= 15;	// 可被暴扁	
EnumActionType.AC_NIL 			= 17;
EnumActionType.RIDE 			= 18;   // 骑马状态
EnumActionType.ATTACK			= 19;	// 
EnumActionType.ATTACK2         	= 20;    //
EnumActionType.ATTACK3         	= 21;    //
EnumActionType.PARRY        	= 22;     // 格挡准备动作
EnumActionType.PARRY2         	= 23;    // 格挡持续动作
EnumActionType.BACKOUT          = 24;    // 击退
EnumActionType.BACKOUT2        	= 29;    // 击退2
EnumActionType.SING           	= 25;    // 吟唱
EnumActionType.ATTACK4         	= 26;    //
EnumActionType.ATTACK5         	= 27;    //
EnumActionType.STAND2       	= 28;    //
EnumActionType.ATTACK6      	= 30;    //
EnumActionType.ATTACK7      	= 31;    //
EnumActionType.MOVEMOMENT   	= 32;    //

EnumActionType.DOWNHILL         = 51;    // 坠崖

EnumActionType.STAND5 			= 100;   // 特殊

var EnumDefaultResType = EnumDefaultResType || {};

EnumDefaultResType.NONE = 0;
EnumDefaultResType.SCENE_OBJ = 1;

var EnumLoopType = EnumLoopType || {};

EnumLoopType.NONE = -1;
EnumLoopType.LOOP = 1;
EnumLoopType.NOTLOOP = 0;

var EnumActionName = EnumActionName || {};

EnumActionName.STAND 		= "stand";
EnumActionName.RUN 			= "walk";
EnumActionName.JUMP 		= "jump";
EnumActionName.JUMP_FLY		= "jump";
EnumActionName.JUMP_SKY2 	= "jump2";
EnumActionName.JUMP_DOWN 	= "jump3";
EnumActionName.DEAD 		= "death";
EnumActionName.ATTACK 		= "attack";
EnumActionName.ATTACK2 		= "attack2";
EnumActionName.ATTACK3 		= "attack3";
EnumActionName.ATTACK4 		= "attack4";
EnumActionName.ATTACK5 		= "attack5";
EnumActionName.PARRY 		= "parry";
EnumActionName.PARRY2 		= "parry2";
EnumActionName.WOUND 		= "injured";
EnumActionName.SIT 			= "sit";
EnumActionName.SITDOUBLE 	= "sit";
EnumActionName.WATERSTAND 	= "waterstand";
EnumActionName.WATERRUN 	= "waterwalk";
EnumActionName.SING 		= "stand";
EnumActionName.BACKOUT 		= "kneel";
EnumActionName.BACKOUT2 	= "kneel2";
EnumActionName.STAND5 		= "stand5";
EnumActionName.ATTACK6 		= "attack6";
EnumActionName.ATTACK7 		= "attack7";
EnumActionName.MOVEMOMENT	= "attack5";

var MAnimationDefine = MAnimationDefine || {};
var r = MAnimationDefine;
r[EnumActionType.STAND] 		= EnumActionName.STAND;
r[EnumActionType.RUN] 			= EnumActionName.RUN;
r[EnumActionType.JUMP] 			= EnumActionName.JUMP;
r[EnumActionType.JUMP_FLY] 		= EnumActionName.JUMP_FLY;
r[EnumActionType.JUMP_SKY2] 	= EnumActionName.JUMP_SKY2;
r[EnumActionType.JUMP_DOWN] 	= EnumActionName.JUMP_DOWN;
r[EnumActionType.DEAD] 			= EnumActionName.DEAD;
r[EnumActionType.ATTACK] 		= EnumActionName.ATTACK;
r[EnumActionType.ATTACK2] 		= EnumActionName.ATTACK2;
r[EnumActionType.ATTACK3] 		= EnumActionName.ATTACK3;
r[EnumActionType.ATTACK4] 		= EnumActionName.ATTACK4;
r[EnumActionType.ATTACK5] 		= EnumActionName.ATTACK5;
r[EnumActionType.PARRY] 		= EnumActionName.PARRY;
r[EnumActionType.PARRY2] 		= EnumActionName.PARRY2;
r[EnumActionType.WOUND] 		= EnumActionName.WOUND;
r[EnumActionType.SIT] 			= EnumActionName.SIT;
r[EnumActionType.SITDOUBLE] 	= EnumActionName.SITDOUBLE;
r[EnumActionType.WATERSTAND] 	= EnumActionName.WATERSTAND;
r[EnumActionType.WATERRUN] 		= EnumActionName.WATERRUN;
r[EnumActionType.SING] 			= EnumActionName.SING;
r[EnumActionType.BACKOUT] 		= EnumActionName.BACKOUT;
r[EnumActionType.BACKOUT2] 		= EnumActionName.BACKOUT2;
r[EnumActionType.STAND5] 		= EnumActionName.STAND5;
r[EnumActionType.ATTACK6] 		= EnumActionName.ATTACK6;
r[EnumActionType.ATTACK7] 		= EnumActionName.ATTACK7;
r[EnumActionType.MOVEMOMENT] 	= EnumActionName.MOVEMOMENT;

//r[EnumActionType.STAND] = EnumActionName.STAND;
//r[EnumActionType.RUN] = EnumActionName.RUN;		
//r[EnumActionType.DEAD] = EnumActionName.DEAD;
//r[EnumActionType.ATTACK] = EnumActionName.ATTACK;
//r[EnumActionType.CAST] = EnumActionName.ATTACK2;
//r[EnumActionType.ATTACK3] = EnumActionName.ATTACK3;
//r[EnumActionType.WOUND] = EnumActionName.WOUND;
//r[EnumActionType.STANDBY] = EnumActionName.STANDBY;
//r[EnumActionType.COLLIDE] = EnumActionName.COLLIDE;
//r[EnumActionType.CREATE] = EnumActionName.CREATE;
//r[EnumActionType.DIG] = EnumActionName.DIG;
//r[EnumActionType.GATHER] = EnumActionName.GATHER;
//r[EnumActionType.LEISURE] = EnumActionName.LEISURE;	
//r[EnumActionType.STAND5] = EnumActionName.STAND5;

MAnimationDefine.GetActionName = function(type){
	return r[type];
}

//允许最大的动作切换时间
MAnimationDefine.MAX_CHANGE_TIME = 3000;

MAnimationDefine.JUMP_ARR = [ "jump", "jump2", "jump3", "jump4" ];
MAnimationDefine.lastJump = "jump";
MAnimationDefine.GetRandomJump = function(){
	var rand;
	do{
		rand = MAnimationDefine.JUMP_ARR[ToolBase.RamdonRangeInt(1, 4)];
	}
	while( rand === MAnimationDefine.lastJump )
	MAnimationDefine.lastJump = rand;
	return rand;
}
