﻿/*
 * 
 * 动画管理器
 * tyevlag
 * 
 */

var MAnimationMgr = MAnimationMgr || {
	bDispose:false,
	oActionDataMap:{},

	sDefaultBaseUrl:"res/animation/player/0",
	
	// cc.Callfunc
	fCallbackPrepareEnd:null,
	oDefaultActionsDataDir:{},
	defaultActionData:null,
	
	PrepareDefualtAnimationRes:function(endcallback){
		this.defaultActionData = new MAnimationDataDir();
		this.defaultActionData.SetData(this);
		this.defaultActionData.nDirFrameNum = 1;
		this.defaultActionData.nNumdir = 5;
		for (var i = 0; i < 5; i++){
		this.defaultActionData.bLoop = true;
			var tmpFrames = [EngineMgr.uiMgr.GetResByUrl("public/image/default_role.png")];
			this.defaultActionData.aDirAnimList[i] = new cc.Animation(tmpFrames, 1);
			this.defaultActionData.aDirAnimList[i].retain();	//不用cc.animationCache了 一会cocos的一会自己的内存管理 太乱了
		}
		return;
		this.fCallbackPrepareEnd = endcallback;
		this.fCallbackPrepareEnd.retain();
		var defaultactions = ["attack",
		                      "attack2",
		                      "attack3",
		                      "death",
		                      "jump",
		                      "jump2",
		                      "jump3",
		                      "sit",
		                      "stand",
		                      "walk",];	

		for (var i = 0; i < defaultactions.length; ++i) {
			var datadir = new MAnimationDataDir();
			this.oDefaultActionsDataDir[defaultactions[i]] = datadir;
			datadir.SetData(this);
			var action = defaultactions[i];
			var fullurl = this.sDefaultBaseUrl + "/" + action + "/" + action;
			datadir.SetResName(fullurl);
		}
	},
	
	CallbackResLoaded:function(datadir){
		this.CheckDefaultLoadEnd();
	},

	CallbackResLoadError:function(datadir){
		this.CheckDefaultLoadEnd();
	},
	
	CheckDefaultLoadEnd:function(){
		if (this.fCallbackPrepareEnd == null){
			zz.Error("CheckDefaultLoadEnd call err!!!! fCallbackPrepareEnd == null!");
			return;
		}
		
		var count = 0;
		var loadcount = 0;
		for (var k in this.oDefaultActionsDataDir){
			count++;
			if (this.oDefaultActionsDataDir[k].IsLoaded()){
				loadcount++;
			}
		}

		if (count == loadcount){
			zz.Log("动画默认资源已经全部下载完 ..");
			this.nDefaultActionsStateCount = -1;
			this.fCallbackPrepareEnd.execute();
			this.fCallbackPrepareEnd.release();
			this.fCallbackPrepareEnd = null;
		} else {
			// zz.Log("动画默认资源下载状态 " + loadcount + "/" + count);
		}
	},
	
	GetDefaultDataDir:function(actionname){
		return this.defaultActionData;
		if (this.oDefaultActionsDataDir[actionname] != null)
			return this.oDefaultActionsDataDir[actionname];
		return null;	
	},

	/* 获得动画资源，如果没有则加载
	 * 返回一个动画Animation
	 */
	GetAnimation:function( url, completeCallback, datadir ){
		LoadMgr.LoadAnimation( url, datadir, LoadPriority_Common,
				{
					complete:function( data ){
						if ( completeCallback != null )
							completeCallback.call(datadir, data.frames, data.animjson );
				}} );
	},
	
	GetActionData:function(fullurl, owner){
		var data = this.oActionDataMap[fullurl];
		if( data ){
			var delIndex = this.waitDisposeData.indexOf(data);
			if( delIndex != -1 )
				this.waitDisposeData.splice(delIndex, 1);
			data.SetData(owner);
			return data;
		}
		data = new MAnimationDataDir();
		data.SetData(owner);
		this.oActionDataMap[fullurl] = data;
		data.SetResName(fullurl);
		return data;
	},

	waitDisposeData:[],
	timeId:-1,
	ReleaseAnimation:function(datadir){
		datadir.delTime = TimerUtil.GetTimer() + 8000;	//		8秒足够一个技能循环的时间了（内存实在吃紧就只有改为立即释放了）
		this.waitDisposeData.push(datadir);
		if( this.timeId == -1 ){
			this.timeId = TimerUtil.TimeUpdate( this.CheckRelease, this, 2 );
		}
	},

	CheckRelease:function(){
		var now = TimerUtil.GetTimer();
		var len = this.waitDisposeData.length;
		for( var i = len - 1; i >= 0; i-- ){
			var data = this.waitDisposeData[i];
			if( data.delTime < now ){
				this.waitDisposeData.splice(i, 1);
				delete  this.oActionDataMap[data.sUrl];
				data.Dispose();
			}
		}
	}
}