﻿/// <summary>
/// 游戏常量定义，运行后不可修改
/// </summary>

var MGameDefine = {
	CLIENT_RUN:true,

	// 是否移动端发布
	RELEASE_MOBILE:false,

	// 移动模式
	MOVE_TYPE:0,

	// 地图格子宽
	GRID_WIDTH:50,

	// 地图格子高
	GRID_HEIGHT:50,

	// 屏幕适配分辨率
	SCREEN_HEIGHT:750,

	// 屏幕适配分辨率
	SCREEN_WIDTH:1334,

	// UI的图片资源标记为大资源的起始值，打包工具将独立打包此资源
	//UI_RES_IMAGE_BIG_FLAG:131072,

	//寻路到目标限定值
	TO_TARGET_MAX:50,

	// 基本tips显示延迟时间
	UI_TIPS_SHOW_DELAY:0.1,

	// 动画缩放比例
	ANIMATION_SCALE:1,//1/0.7,

	// 地图缩放比例 没有采用整体缩放 整体缩放需要在oSceneRoot外套一个容器进行缩放（不然oSceneRoot移动的坐标也需要缩放，同时场景鼠标点计算都需要缩放，或者缩放UI层的再整体缩放的方式也可以）	--merlin
	MAP_SCALE:1,//1/0.5,

	//充值元宝比例   1:1000
    DEFAULT_RECHARGE_RATE:10,
    getRechargeRate:function(){
        if(this.$rechargeRate == null){
            var g19 = Q_global.Get(19)
            if(g19 && g19.q_string_value){
                this.$rechargeRate = g19.q_string_value * 100
            }
        }
        return this.$rechargeRate || this.DEFAULT_RECHARGE_RATE
    },
}

cc.defineGetterSetter(MGameDefine, "RECHARGE_RATE",MGameDefine.getRechargeRate);