/**
 * Created by merlin on 2016/11/11.
 */
var BlurModelPanel = BlurModelPanel || cc.RenderTexture.extend({
        ctor:function(layerType){
            this._super(cc.visibleRect.width*0.25, cc.visibleRect.height*0.25, cc.Texture2D.PIXEL_FORMAT_RGB888);
            this.setAnchorPoint(0, 0);
            var render = new cc.RenderTexture( cc.visibleRect.width, cc.visibleRect.height, cc.Texture2D.PIXEL_FORMAT_RGB888, gl.DEPTH24_STENCIL8_OES );
            render.begin();
            render.setVirtualViewport(cc.p(0,0), cc.rect(0,0,cc.visibleRect.width*0.25,cc.visibleRect.height*0.25), cc.rect(0,0,cc.visibleRect.width*0.25,cc.visibleRect.height*0.25));
            switch (layerType){
                //二级面板了 应该截pop层叠上去  再有tips层就截Top了
                case UIMgr.PANEL_LAYER_TOP:
                    // Mgr.uiMgr._popLayer.visit();     先屏了 全都只加场景好了 二级面板用黑色半透明
                    // break;
                //普通面板就是场景
                case UIMgr.PANEL_LAYER_POP:
                default:
                    Mgr.sceneLayer.oLayerMap.x = Mgr.sceneLayer.oSceneRoot.x;       //这货的坐标有点日怪的
                    Mgr.sceneLayer.oLayerMap.y = Mgr.sceneLayer.oSceneRoot.y;
                    Mgr.sceneLayer.oLayerMap.visit();
                    Mgr.sceneLayer.oLayerMap.x = 0;
                    Mgr.sceneLayer.oLayerMap.y = 0;
                    break;
            }
            render.end();
            render.getSprite().setAnchorPoint(0, 0);
            Filter.GaussianBlur(render.getSprite(), 2);

            //draw一遍缓存起来 避免shader一直去渲染    （先缩小了在draw了放大效率更高）   -- merlin
            this.setVirtualViewport(cc.p(0,0), cc.rect(0,0,cc.visibleRect.width*0.25,cc.visibleRect.height*0.25), cc.rect(0,0,cc.visibleRect.width*0.25,cc.visibleRect.height*0.25));
            this.begin();
            render.visit();
            this.end();
            this.getSprite().setAnchorPoint(0, 0);
            this.setScale(4.05, 4.05);
             //阻止事件穿透
            var touchListener = {
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: true,
                onTouchBegan: this.OnTouchBegan
            };
            cc.eventManager.addListener(touchListener, this);
        },

        OnTouchBegan:function(touch, event) {
            var target = event.getCurrentTarget();
            if(!target.isVisible() || (!target.IsTouchInside(target,touch))){
                return false;
            }
            return true;
        },

        IsTouchInside: function (owner,touch) {
            return true;
            if(!owner || !owner.getParent()){
                return false;
            }
            var touchLocation = touch.getLocation();
            touchLocation = owner.getParent().convertToNodeSpace(touchLocation);
            return cc.rectContainsPoint(owner.getBoundingBox(), touchLocation);
        }
    });

var BackgroundBlack = cc.LayerColor.extend(
    {
        _panel:null,
        ctor:function(panel)
        {
            this._super(cc.color(0,0,0,140),cc.winSize.width,cc.winSize.height);
            this._panel = panel;
            if(!panel.ignoreTouch) this._AddListener();
        },
        _AddListener:function()
        {
            var self = this;
            this.lister = cc.EventListener.create({
                event:cc.EventListener.TOUCH_ONE_BY_ONE,
                onTouchBegan:function (touch, event) {
                    return true;
                },
                onTouchMoved:function (touch, event) {

                },
                onTouchEnded:function(touch, event){
                    if(self._panel && self._panel.isClosePanel)
                    {
                        EngineMgr.uiMgr.HidePanel(self._panel);
                    }
                }
            });
            this.lister.setSwallowTouches(true);
            cc.eventManager.addListener( this.lister ,this);
        },
        onExit:function()
        {
            this._super();
            if(this.lister)this.lister.setSwallowTouches(false);
        }
    });
