﻿/**
 * UIEdit控件，按钮控件
 */

var MUIEdit = cc.EditBox.extend( {
	ptype:"",
	ctor:function(){
		this.ptype = EnumPanelType.EDIT;
		this._super();
	},
	Init:function(){
		//解析输入框数据
		UIParseUtil.ParseEdit( this , this.jsonobj);
        if (cc.sys.os == "Windows"){
            this.setFontName(GameFont.YAHEI);
		}
		this.setPlaceholderFontName(GameFont.YAHEI);
		this.setFontName(GameFont.YAHEI);
        //this.setFontName(GameFont.DEFAULT);
		this.AddChildren();

        /// 修复第一次点击输入框不显示光标的问题。
        /// 这段代码只是一个未改底层的兼容
        this.visible = false;
        this.visible = true;
	},
	SetText:function (text){
		this.setString( text );
	},
	GetText:function (){
		return this.getString();
	},
    setTextColor:function (color) {         //前面都用的这个
		this.setFontColor(color);
    },
} );
var MUINumberEdit = ccui.Text.extend({
    placeHolder:0,
    delegate:null,
    showPanel:null,
    placeholderColor:null,
	fontColor:null,
    keyBord:null,
    isFirst:false,
    ctor:function(){
        this._super();
    },
    Init:function () {
    	var json=this.jsonobj;
    	//就只设置大小和颜色算了
        var fontSize = json["size"];
        if(fontSize != null && fontSize != 0)
            this.setFontSize(fontSize);
        else
            this.setFontSize(20);
        var color = json["color"];
        if( color ) {
            this.setTextColor(UIUtil.GetCCColor(color));
            this.fontColor=UIUtil.GetCCColor(color);
        }
        else {
            this.setTextColor(UIUtil.GetCCColor(0xffffff));
            this.fontColor=UIUtil.GetCCColor(0xffffff);
		}
        this.placeholderColor= this.fontColor;
        this.ignoreContentAdaptWithSize(false);
        UIParseUtil.WidgetAttributes(this, json, false);
        this.setFontName(GameFont.DEFAULT);
       	this.setTextHorizontalAlignment(1);
        this.setTextVerticalAlignment(1);
        this.setTouchEnabled(true);
        this.setFocusEnabled(true);
        var self=this;
        this.addClickEventListener(function () {
            self.isFirst=true;
            var panel=EngineMgr.uiMgr.ShowPanelByType(JianpanMainExt.PanelName,UIMgr.PANEL_LAYER_TOP);
            panel.SetDelegate(self );
        });
    },
    UpdateByKeyBord:function(idx){
        if(this.isFirst) {
            this.isFirst=false;
            if(idx>=0)
                this.setString(idx);
            else
                this.setString(0);
        }
        else {
            var ediText = this.getString();
            ediText = parseInt(ediText);
            if (!ediText) {
                ediText = 0;
            }
            if (idx < 0) {
                ediText=this.placeHolder;
                this.isFirst=true;
            }
            else {
                ediText = idx + ediText * 10;
            }
            this.setString(ediText);
        }
    },


    setPlaceHolder:function (text) {
        this.placeHolder=text;
        if(this.getString()==""){
            this.setString(text);
            this.setTextColor(this.placeholderColor);
		}
    },
	setString:function (tt) {
        this.setTextColor(this.fontColor);
        if(tt==""){
            tt=this.placeHolder;
            this.setTextColor(this.placeholderColor);
		}
        this._super(tt);
        if(this.delegate)
        	this.delegate.editBoxTextChanged();
        // if(MUINumberEdit.showPanel&&MUINumberEdit.showPanel.GetString()!=this.getString()){
         //    MUINumberEdit.showPanel.SetString(this.getString());
		// }
    },
    setDelegate:function (delegate) {
		this.delegate=delegate;
    },
    setPlaceholderFontColor:function (color) {
		this.placeholderColor=color;
    },
});