﻿/**
 * UIProgressBar控件，按钮控件
 */
var MUIProgressBar = ccui.Widget.extend( {
	ptype:"",
	_bgImg:null,
	_bar:null,
	ctor:function(){
		this.ptype = EnumPanelType.PROGRESS_BAR;
		this._super();
	},

	Init:function(){
		//解析进度表已经刻度输入条
		this.SetBgImg();
		UIParseUtil.ParseProgressBar( this , this.jsonobj);
		this.AddChildren();
	},

	setPercent:function( percent ){
		this._bar.setPercent( percent );
	},
    GetPercent:function () {
       return this._bar.getPercent();
    },

	SetBar:function( bar ){
		this._bar = bar;
		this.addChild( bar );
	},

	SetBgImg:function (){
		var self = this;
		//这个方法并没有什么卵用	cocos进度条扩展性很差	并且之前转换做得不完善 背景不支持三宫图 把进度条和背景分开做成单宫图来使用就行了（有需要的话后面可以改成ProgressTimer）		--merlin
		if(self.jsonobj["backgroundType"] != -1){
			var url = self.jsonobj["images"][0];
			if(self._bgImg == null){
				var isScale9Enable = self.jsonobj["Scale9Enable"] || false;
				var rect = self.jsonobj["backgroundRect"] || null;
				if(isScale9Enable){
					self._bgImg = new cc.Scale9Sprite();
				}else{
					self._bgImg = new cc.Sprite();
				}
				EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
					self._bgImg.initWithSpriteFrameName( url );
					self._bgImg.setContentSize(cc.size(self.jsonobj["Size"].X , self.jsonobj["Size"].Y));
					if(isScale9Enable){
						self._bgImg.setCapInsets(rect);
					}
					self._bgImg.setAnchorPoint( cc.p(0.0, 0.0) );		//initWithTexture会重置anchorPoint
				}, self);
			}
			self.addProtectedChild( self._bgImg );
		}
	},
	ChangeRes:function (url) {
        EngineMgr.uiMgr.GetAsynResByUrl(url, function(bar){
            bar.loadTexture( url, ccui.Widget.PLIST_TEXTURE );
        }, this,this._bar);
    },
	Clone:function () {
		var pp=new MUIProgressBar;
		pp.jsonobj=this.jsonobj;
        pp.init();
        return pp;
    },
    setDirection:function (dir) {
        this._bar.setDirection( dir );
    }
} );
//
var LoadingBarFromTo=cc.ProgressFromTo.extend({
    star:null,
    end:null,
    target:null,
    ctor:function(duration, fromPercentage, toPercentage,tar){
        this.star=fromPercentage;
        this.end=toPercentage;
        this.target=tar;
        this._super(duration, fromPercentage, toPercentage);
    },
    update:function (time) {
        if (this.target  instanceof MUIProgressBar) {
            this.target.setPercent(this.star + (this.end - this.star) * time);
        }
    },
});