﻿var SceneHalo = SceneBaseObject.extend({
    Init:function() {
        this._super();
        this.setName("SceneHalo");
        this.$playerArr = []
    },

    Dispose:function(){
        if(this.$uiModel) this.$uiModel.Dispose()
        this.$uiModel = null;

        this._super();
    },

    OnRecycle:function(){
        if(this.$uiModel) this.$uiModel.Dispose()
        this.$uiModel = null;

        this._super();
    },

    OnRevert:function(){
        this._super();
    },

    OnFrame:function(curTime){
        this._super(curTime);

        if(this.$playerArr.length < 2) return;
        if(this.$uiModel == null) return

        var PA = this.$playerArr[0].GetGridPt()
        var PB = this.$playerArr[1].GetGridPt()

        /// TODO
        var dis = ToolMap.CalcDistance( PA, PB );
        /// grid 距离
        if(dis > 6){
            this.$uiModel.visible = false;
            return
        }
        this.$uiModel.visible = true;

        var gridpt = cc.p(PA.x + (PB.x - PA.x) / 2,PA.y + (PB.y - PA.y) / 2)
        this.SetGridPt(gridpt);
    },
    SetDataWithBean:function(msgb){
        this._super(msgb);

        this.oSid = msgb.oSid
        this.nGid = msgb.nGid

        this.$playerArr = msgb.couple

        /// 更新模型
        this.$playerArr.sort(function(a,b){
            return b.aureoleId - a.aureoleId
        })
        var level = this.$playerArr[0].aureoleId
        if(level == 0) return;

        if(this.$uiModel) this.$uiModel.Dispose()

        this.$uiModel = new UIModel(level,EnumResline.MARRIAGE_HALO);
        this.addChild(this.$uiModel);

        var offset = [
                 [0,-150]
                ,[0,-110]
                ,[0,-110]
                ,[0,-110]
                ,[0,-110]
                ,[0,60]
                ,[0,60]
            ]
        var of = offset[level - EnumMarryResline.HALO]
        this.$uiModel.x = of[0]
        this.$uiModel.y = of[1]

        this.$uiModel.visible = false;
    },
});