﻿	/**
 * 
 * 场景操作管理 yq tyevlag
 * 
 */

var SceneActionMgr = SceneActionMgr || {

	// 当前控制对象
	oCtrlObject:null,
	testid:0,
	moveControl:null,
	Init:function(){

		this.moveControl = {};
		this.moveControl.posstart = null;
		var width = cc.winSize.width / 2;
		var height = cc.winSize.height;
		this.moveControl.offset03 = {xx: 0 , yy: 110};
		this.moveControl.offsetO1 = {xx: width , yy: height};
		this.moveControl.offset02 = {xxd: 300 , xxu: 700 , yy: 100};
		this.moveControl.offset04 = {xxd: 60 , xxu: 255 , yyd:125, yyu:320};
		this.moveControl.isStart = false;
		this.moveControl.isMoving = false;

        zz.Log("创建点击事件!!!");
        var self = this;
        this._mouseListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            onTouchBegan: this.onTouchBegan.bind(this),
            onTouchMoved: this.onTouchMoved.bind(this),
            onTouchEnded: this.onTouched.bind(this),
            onTouchCancelled: this.onTouched.bind(this),
        });

        cc.eventManager.addListener(this._mouseListener, Mgr.sceneLayer.oSceneRoot);

        return this;
    },
    onTouchBegan: function(touch, event) {
        Mgr.touchEffectLayer.CancelMark();

		var pos = touch.getLocation();
		this.moveControl.posstart = pos;
		this.moveControl.isMoving = false;

        var ret = this.OnCheckTouchCondition(touch, event)
        // 屏蔽点击地面移动效果
        if(false && ret){
            this.toucheTime = Date.now();
            this.param = [touch, event];

            if (this.timerId != null) TimerUtil.ClearTimeUpdate(this.timerId);
            this.timerId = TimerUtil.TimeUpdate(this.onTimer, this, 0.1, cc.REPEAT_FOREVER);
        }

        return ret;
    },
    onTouchMoved: function(touch, event) {
        Mgr.touchEffectLayer.CancelMark();

		if ( this.moveControl.posstart.x > this.moveControl.offset02.xxd && this.moveControl.posstart.x < this.moveControl.offset02.xxu && this.moveControl.posstart.y < this.moveControl.offset02.yy ) {
			return;
		}

        if(this.moveControl.isReady2Start){
            this.moveControl.isStart = true;
            this.moveControl.isReady2Start = false;
        }

		if ( this.moveControl.isStart ) {
			this.moveControl.isMoving = true;
			var pos = touch.getLocation();
			CustomControl.HandleMoving( pos );
		}
		
        //this.param = [touch, event];
        //var time = Date.now();
        //if (time - this.toucheTime < 200) return;
        //this.toucheTime = time;
        //this.OnCheckTouchCondition(touch, event);
    },
    onTouched: function(touch, event) {
        Mgr.touchEffectLayer.CancelMark();

		if ( this.moveControl.isStart ) {
			CustomControl.ResetHandleBgPosition();
		}
        this.moveControl.isReady2Start = false;
		this.moveControl.isStart = false;

        if (this.timerId != null) TimerUtil.ClearTimeUpdate(this.timerId);
        this.timerId = null;
    },
    onTimer: function() {
        var touch = this.param[0];
        var event = this.param[1];
        return;
        this.OnCheckTouchCondition(touch, event);
    },
    OnCheckTouchCondition: function(touch, event) {
        if(this.oCtrlObject == null) return false;

        // zz.Log( "点击事件!!!" );
        if (Mgr.chat.isChatPanelOpen) {
            return false;
        }
        var pos = this.MousePosToScenePos(touch.getLocation());
        if (Mgr.chat.IsInChatArea(touch.getLocation())) {
            return false;
        }

        // 既然后续没有移动相关代码关掉这个
//        if (CustomControl.CheckTouchInAndRemark(true)) return false;
        CustomControl.CheckTouchInAndRemark(true);

        this.OnSceneMouseDown(touch, pos, false);
        //Mgr.tips.ShowNotice( "场景点击事件", self.testid, cc.p( 100, 300), 0xffffff, 12, true);
        // self.testid++;
        // if ( self.testid > 8 )
        //  self.testid = 0;
        return true;
    },

	// 场景鼠标按下
	OnSceneMouseDown:function(touch, scenepos, isright){
		var isleft = !isright;
		
		if (this.oCtrlObject == null)
			return;

		var gridpt = ToolMap.PixPt2GridPt(scenepos.x, scenepos.y);

//		var scenePos = this.MousePosToScenePos(event.getLocation());
		// var gridpt = ToolMap.PixPt2GridPt(scenePos.x, scenePos.y);
		Mgr.sceneObj.CheckMouseObj(scenepos);

		// 清除跟随状态
		Mgr.team.followState = false;

		if (isright) {
			// 暂时右键跳
			if (this.oCtrlObject.oCtrlAutoFight != null)
				this.oCtrlObject.oCtrlAutoFight.ClearLockAutoAttackTarget();

			var fPath = [];
			fPath.push(cc.p(this.oCtrlObject.x, -this.oCtrlObject.y));
			fPath.push(ToolMap.GridPt2PixPt(gridpt.x, gridpt.y, true));
			this.oCtrlObject.SetJumpWay(fPath);
			// this.oCtrlObject.SetDownHillWay(fPath);
		} else {
			var pos = touch.getLocation();
			//是否正好点在摇杆 是的话优先移动
			var isRocker = ( pos.x > this.moveControl.offset04.xxd && pos.x < this.moveControl.offset04.xxu && pos.y > this.moveControl.offset04.yyd && pos.y < this.moveControl.offset04.yyu )
            if (Mgr.sceneObj.oMouseObj != null && !isRocker){
                if( this.oCtrlObject == Mgr.mainPlayer ) {
                    this.oCtrlObject.SetActiveState();
                }
				this.ClickObject(Mgr.sceneObj.oMouseObj, isright);
			} else {
	
				if ( pos.x > this.moveControl.offset02.xxd && pos.x < this.moveControl.offset02.xxu && pos.y < this.moveControl.offset02.yy ) {
					return true;
				}
				if ( pos.x < this.moveControl.offsetO1.xx && pos.y < this.moveControl.offsetO1.yy && pos.y > this.moveControl.offset03.yy ) {
                    // 按下时不标记改为滑动后处理
                    // this.moveControl.isStart = true;
					this.moveControl.isReady2Start = true;
					CustomControl.InitHandlePosition( pos );
				}

                //双击停止当前动作
                if(Date.now() - this._lastClickTime < 200){
                    if( this.oCtrlObject == Mgr.mainPlayer ) {
                        this.oCtrlObject.SetActiveState();
                    }
                    if (this.oCtrlObject.oCtrlAutoFight != null){
                        this.oCtrlObject.oCtrlAutoFight.ClearLockAutoAttackTarget();
                    }
                    if(this.oCtrlObject.oCtrlAutoPath){
//                        this.oCtrlObject.oCtrlAutoPath.StopAutoPath();
                    }
                    // 直接标记按起后清理状态
                    this.moveControl.isStart = true;
                }
                this._lastClickTime = Date.now()

				if (this.oCtrlObject.IsCanDoRun()){
					Mgr.player.ShowShortChatState();
					// this.oCtrlObject.oCtrlAutoPath.StopAutoPath();		//屏蔽点地图走路
					// this.oCtrlObject.oCtrlAutoPath.RunToPt(gridpt);
				}
			}
		}
	},
	
	// 场景鼠标抬起
	OnSceneMouseUp:function( event, scenepos, isright ){
		
	},

	// 场景鼠标移动
	OnSceneMouseMove:function(event){
		var scenePos = this.MousePosToScenePos(event.getLocation());
		// var gridpt = ToolMap.PixPt2GridPt(scenePos.x, scenePos.y);
		Mgr.sceneObj.CheckMouseObj(scenePos);
	},

	// 鼠标屏幕坐标转换为场景坐标
	MousePosToScenePos:function(mousepos){
		var sceneroot = Mgr.sceneLayer.oSceneRoot;
		// 把点击坐标转换为对于的场景坐标
		var winh = ToolBase.GetWinHeight();
		var pos = mousepos; // 当前事件发生的光标位置
		pos.y = winh - pos.y;
		pos.x += Math.abs(sceneroot.x);
		pos.y += (Math.abs(sceneroot.y) - winh);
		return pos;
	},
	
	ClickObject:function(mouseObj, isRight){
		if (mouseObj instanceof SceneActiveObject) {
			if (mouseObj instanceof SceneMonster) {
				Mgr.monster.ClickSceneMonster(mouseObj);
			} else if (mouseObj instanceof ScenePlayer) {
				Mgr.player.ClickScenePlayer(mouseObj);
			} else if (mouseObj instanceof SceneNpc) {
				Mgr.npc.ClickSceneNpc(mouseObj);
			}
// if (isRight == false && ((mouseObj instanceof SceneMainPlayer) == false)){
// setLastClickObjTime();
// }
		} else {
			if (mouseObj instanceof SceneItem) {
				Mgr.pickMgr.PickPropItemByHand(mouseObj);
			}
		}
	},

	
	// 鼠标控制移动
	CheckDoControlMove:function(sceneo){
		return false;
	},
	
	// 传奇的shift追击
	CheckDoRush:function(sceneo){
		return false;
	},
	
	OnKeyDown:function(keyCode, event){
		if ( keyCode == cc.KEY.a ){
			Mgr.sceneMap.oMapShow.oThumbnailsTopDis.setVisible(!Mgr.sceneMap.oMapShow.oThumbnailsTopDis.visible);
		}else if ( keyCode == cc.KEY.b ){

//			var texture = EngineMgr.uiMgr.GetResByUrl( "test/role.png" );
//			var spr = new cc.Sprite( texture );
////			spr.initWithSpriteFrame(  );
//			spr.setPosition(400, 400);
//			GameMain.oStageLayer.addChild( spr );

			LoadMgr.LoadTexture("res/ui/image/mytest", this, LoadPriority_Common, {
				complete:function( retMap ){

					var spr = new cc.Sprite( retMap["role2.png"] );
					spr.setPosition(400, 400);
					GameMain.oStageLayer.addChild( spr );

				},
				error:function( err ){}});
			
					
		}else if ( keyCode == cc.KEY.c ){
			
						
			//var animation = new cc.Animation();
			//var frameKeys = [ "40005.png", "40010.png", "40015.png", "40020.png", "40025.png", "40030.png" ];
			//for ( var i = 0; i < 6; i++ ){
			//	var sf = cc.spriteFrameCache.getSpriteFrame( frameKeys[i] );
			//	animation.addSpriteFrame( sf );
			//}
			//
			//animation.setDelayPerUnit(0.15);
			//var action = cc.animate(animation);
			//this.testSpr = cc.Sprite.create();
			//cc.director.getRunningScene().addChild(this.testSpr,1000);
			//this.testSpr.setPosition(300, 300);
			//this.testSpr.runAction(cc.repeatForever(action));
			
//			CCSpriteFrameCache* cache = CCSpriteFrameCache::sharedSpriteFrameCache();

			//向cache中添加plist文件和对应的大图
//			cache->addSpriteFramesWithFile("Jar.plist","Jars.png");
			
		}else if ( keyCode == cc.KEY.d ){
			this.testSpr.stopAllActions();

			
		}else if ( keyCode == cc.KEY.e ){
			Mgr.loginMgr.ReqLoadFinish();
		}else if ( keyCode == cc.KEY.f ){
			var name = "1";
			var type = SoundType.UI;
			var loop = false;
			Mgr.gameSoundMgr.PlaySound(name, type, loop);
		}else if ( keyCode == cc.KEY.g ){
			Mgr.gameSoundMgr.StopSound(1);
		}else if ( keyCode == cc.KEY.h ){
			// 音频测试代码
			Mgr.gameSoundMgr.PlaySoundByID(1);
		}else if ( keyCode == cc.KEY.i ){
			Mgr.sceneMap.DoChangeMap(ToolBase.RamdonRangeInt(1001, 1015), 0);
		}else if ( keyCode == cc.KEY.j ){
			Mgr.gameSoundMgr.PauseSound(1);
		}else if ( keyCode == cc.KEY.k ){
			Mgr.gameSoundMgr.ResumeSound(1);
			//Mgr.sceneMap.oMapShow.TestChangeFunc();
		}else if ( keyCode == cc.KEY.l ){
			Mgr.gameSoundMgr.SetVolume(1,0.5);
		}else if ( keyCode == cc.KEY.m ){
			Mgr.msgMgr.Connect( "192.168.4.57", "7777" );
			zz.Log( "test connect !" );
		}else if ( keyCode == cc.KEY.n ){
		}else if ( keyCode == cc.KEY.o ){
			Mgr.robotMgr.DownHillMonster(cc.p(32 * 50 + 25, 25 * 50 + 25));
		}else if ( keyCode == cc.KEY.p ){
			Mgr.robotMgr.DownHillMonster(cc.p(46 * 50 + 25, 45 * 50 + 25));
		}else if ( keyCode == cc.KEY.q ){
			Mgr.robotMgr.CreateRobotMonster(10);
		}else if ( keyCode == cc.KEY.r ){
			Mgr.login.SendReqLoginMessage( "yq3", "37", 1 );
		}else if ( keyCode == cc.KEY.s ){
			Mgr.player.StartOrStopAutoFight();
		}else if ( keyCode == cc.KEY.t ){
			Mgr.login.SendReqLoadFinishMessage();
		}else if ( keyCode == cc.KEY.u ){
		}else if ( keyCode == cc.KEY.v ){
			// 音频测试代码
			var vol = trG.gain.value;
			vol += 0.1;
			tAudio.SetRightVolume( vol );
			zz.Log( "right:" + vol );
		}else if ( keyCode == cc.KEY.w ){

			Mgr.robotMgr.ClearAll();
		}else if ( keyCode == cc.KEY.x ){
			// 音频测试代码
			var vol = tlG.gain.value;
			vol -= 0.1;
			tAudio.SetLeftVolumef( vol );
			zz.Log( "left:" + vol );
		}else if ( keyCode == cc.KEY.y ){
		}else if ( keyCode == cc.KEY.z ){
			// 音频测试代码
			var vol = tlG.gain.value;
			vol += 0.1;
			tAudio.SetLeftVolumef( vol );
			zz.Log( "left:" + vol );
		}else if ( keyCode == cc.KEY.space ){
			
			
		}else if ( keyCode == cc.KEY.num1 ){
			if (this.particleIdx == undefined){
				this.particleIdx = 0;
			}else{
				this.particleIdx++;
			}
			if (this.particle != undefined){
				Mgr.particleMgr.RemoveASystem(this.particle.id);
			}
			this.particleIdx = this.particleIdx % 4;
			// this.particleIdx = 2;

			if (this.particleIdx == 0){
				this.particle = Mgr.particleMgr.CreateAParticle("test/Rotation.pex", Mgr.mainPlayer, 0);
				Mgr.mainPlayer.AddBottomChild(this.particle);
			}else if (this.particleIdx == 1) {
				this.particle = Mgr.particleMgr.CreateAParticle("test/StarTrail.pex", Mgr.sceneLayer.oSceneRoot, 0);
				Mgr.mainPlayer.AddBottomChild(this.particle);
			}else if (this.particleIdx == 2) {
				this.particle = Mgr.particleMgr.CreateAParticle("test/mulFrame.pex", Mgr.sceneLayer.oSceneRoot, 0);
				this.particle.x = Mgr.mainPlayer.x;
				this.particle.y = Mgr.mainPlayer.y;
				Mgr.sceneLayer.AddBottom(this.particle);
			}else if (this.particleIdx == 3) {
				this.particle = Mgr.particleMgr.CreateAParticle("test/WaterJet.pex", Mgr.sceneLayer.oSceneRoot, 0);
				this.particle.x = Mgr.mainPlayer.x;
				this.particle.y = Mgr.mainPlayer.y;
				Mgr.sceneLayer.AddBottom(this.particle);
			}
			this.particle.Start();

		}else if ( keyCode == cc.KEY.num2 ){// 波浪
			if (Mgr.sceneLayer.oSceneRoot._oWaveFull == null || Mgr.sceneLayer.oSceneRoot._oWaveFull.isActive == false)
				Mgr.sceneLayer.oSceneRoot.WaveFullMe(true);
			else
				Mgr.sceneLayer.oSceneRoot.WaveFullMe(false);
		}else if ( keyCode == cc.KEY.num3){// 曝光
			if (Mgr.sceneLayer.oSceneRoot._oBloom == null || Mgr.sceneLayer.oSceneRoot._oBloom.isActive == false)
				Mgr.sceneLayer.oSceneRoot.BloomMe(true);
			else{
				Mgr.sceneLayer.oSceneRoot._oBloom.renderIdx++;
				if (Mgr.sceneLayer.oSceneRoot._oBloom.renderIdx == 3)
					Mgr.sceneLayer.oSceneRoot.BloomMe(false);
			}
		}else if ( keyCode == cc.KEY.num4 ){// 老照片
			if (Mgr.sceneLayer.oSceneRoot._oSpecia == null || Mgr.sceneLayer.oSceneRoot._oSpecia.isActive == false)
				Mgr.sceneLayer.oSceneRoot.SpeciaMe(true);
			else
				Mgr.sceneLayer.oSceneRoot.SpeciaMe(false);
		}else if ( keyCode == cc.KEY.num5 ){// 置灰
			if (Mgr.sceneLayer.oSceneRoot._oGray == null || Mgr.sceneLayer.oSceneRoot._oGray.isActive == false)
				Mgr.sceneLayer.oSceneRoot.GrayMe(true);
			else
				Mgr.sceneLayer.oSceneRoot.GrayMe(false);
		}else if ( keyCode == cc.KEY.num6 ){// 闪烁
			if (Mgr.sceneLayer.oSceneRoot._oGlowFilter == null || Mgr.sceneLayer.oSceneRoot._oGlowFilter.isActive == false)
				Mgr.sceneLayer.oSceneRoot.GlowFilterMe(true);
			else{
				Mgr.sceneLayer.oSceneRoot.GlowFilterMe(false);
			}
		}else if ( keyCode == cc.KEY.num7){// 光源
			if (Mgr.sceneLayer.oSceneRoot._oPointLight == null || Mgr.sceneLayer.oSceneRoot._oPointLight.isActive == false)
				Mgr.sceneLayer.oSceneRoot.PointLightMe(true);
			else{
				Mgr.sceneLayer.oSceneRoot._oPointLight.renderIdx++;
				if (Mgr.sceneLayer.oSceneRoot._oPointLight.renderIdx == 2)
					Mgr.sceneLayer.oSceneRoot.PointLightMe(false);
			}
		}else if ( keyCode == cc.KEY.num8 ){// 反相
			if (Mgr.sceneLayer.oSceneRoot._oNegative == null || Mgr.sceneLayer.oSceneRoot._oNegative.isActive == false)
				Mgr.sceneLayer.oSceneRoot.NegativeMe(true);
			else{
				Mgr.sceneLayer.oSceneRoot.NegativeMe(false);
			}
		}
	},
	
	OnKeyUp:function(keyCode, event){
	}
};