var Q_activity_groupon = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 活动ID（不能重复，正式服上线后，数据需保留1个月才清理一次，活动ID为永久使用，使用过1次后永久不可继续使用） 注意 1-300之间的ID 都已使用 */
        self.q_id = data.ReadInt();
        /** 活动名称，显示在面板上的活动名字 */
        self.q_name = data.ReadString();
        /** 平台标识（不填表示不限，多个用分好隔开。例如：360wan;youxi) */
        self.q_pingtai = data.ReadString();
        /** 活动类型（0：充值  1：消费）  */
        self.q_activity_type = data.ReadInt();
        /** 单日排名区间(-1表示所有区服） */
        self.q_period = data.ReadInt();
        /** 区别老新服（1新区：开服时间为新服才出现的活动。2旧：开服时间大于5天才出现的活动，0通用） */
        self.q_listimage = data.ReadInt();
        /** 开区多少天后才出来活动 */
        self.q_open_day = data.ReadInt();
        /** 服务器限制，日期前（含日期）开启的服务器才显示该活动   20151212-000000 */
        self.q_serve_limit = data.ReadString();
        /** 参与时间 &领取奖励时间 [[时间配置类型],[开始时间，结束时间]] [yyyyMMddHHmmss，yyyyMMddHHmmss] */
        self.q_timingstart = data.ReadString();
        /** 活动内容介绍，显示在面板上的活动介绍，策划配置。控制在22个字以内。需要支持html代码 */
        self.q_info = data.ReadString();
        /** 团购需要满足的平台条件  [所需元宝数,所需人数] */
        self.q_pingtai_condition = data.ReadString();
        /** 个人领取奖励所需的元宝数 */
        self.q_need_gold = data.ReadInt();
        /** 奖励数量（奖励的json字符串）满足条件可以获取的奖励 */
        self.q_reward = data.ReadString();
        /** resflag例子：[title:57.png,background:1.png,cellhead:meirendengji.png,cellname:dugulingke_0.png,cellnums:3jie.png]      ：title ：为置顶背景图 （other/huodong/tongyong/image/title/ 程序已写）  zhuansheng:; */
        self.q_resflag = data.ReadString();
        /** paging：标签id;标签小图标资源名;标签名(标签上的图片名字);子面板类型     排序；标签页图标；标签页名字；活动类型 */
        self.q_paging = data.ReadString();
        /** 活动顺序（1表示默认在第一排显示，相同的则按照活动ID顺序表示） */
        self.q_top = data.ReadInt();
        /** 是否独立入口（0或者不填，在充值面板内。1,icon名字，1表示有独立入口，以及ICON的名字，调用面板ID) 奖励领取完后，面板消失。第三个值配面板类型（这个值相同的活动会出现在一个面板里面）1_首冲，2_排行榜，3_精彩活动 4 双11  5合服活动 6 转盘兑换  7 天命推演兑换  8：元旦活动】 9 春节活动 10成就活动 15:战斗力提升  9003：全平台充值   16：月末活动 */
        self.q_icon = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_activity_groupon.list = Q_activity_groupon.list|| [];
	/** 配置数据索引*/
	Q_activity_groupon.map = Q_activity_groupon.map || {};
	
	/** 设置配置数据*/
	Q_activity_groupon.SetData = Q_activity_groupon.SetData || function( data ){

		var list = Q_activity_groupon.list;
		var map = Q_activity_groupon.map;

		Q_activity_groupon.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_activity_groupon();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_activity_groupon.GetList = Q_activity_groupon.GetList || function(){
		return Q_activity_groupon.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_activity_groupon.Get = Q_activity_groupon.Get || function( id ){
		return Q_activity_groupon.map[ id ];
	};
})();