var Q_activity_rebate = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 活动ID（不能重复，正式服上线后，数据需保留1个月才清理一次，活动ID为永久使用，使用过1次后永久不可继续使用） 注意 1-300之间的ID 都已使用 */
        self.q_id = data.ReadInt();
        /**  */
        self.q_name = data.ReadString();
        /** 活动类型（0：充值  1：消费）  */
        self.q_activity_type = data.ReadInt();
        /** 参与时间 &领取奖励时间  20151212-000000 */
        self.q_timingstart = data.ReadString();
        /** 领取奖励所需累计充值元宝档次数[[累计金额，返利天数],[累计金额，返利天数],[累计金额，返利天数]] */
        self.q_need_gold = data.ReadString();
        /** 奖励数量（奖励的json字符串）满足条件可以获取的奖励 */
        self.q_reward = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_activity_rebate.list = Q_activity_rebate.list|| [];
	/** 配置数据索引*/
	Q_activity_rebate.map = Q_activity_rebate.map || {};
	
	/** 设置配置数据*/
	Q_activity_rebate.SetData = Q_activity_rebate.SetData || function( data ){

		var list = Q_activity_rebate.list;
		var map = Q_activity_rebate.map;

		Q_activity_rebate.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_activity_rebate();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_activity_rebate.GetList = Q_activity_rebate.GetList || function(){
		return Q_activity_rebate.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_activity_rebate.Get = Q_activity_rebate.Get || function( id ){
		return Q_activity_rebate.map[ id ];
	};
})();