var Q_arena_robot = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 默认名次 */
        self.q_rank = data.ReadInt();
        /** 机器人等级 */
        self.q_level = data.ReadInt();
        /** 战斗力 */
        self.q_fight = data.ReadInt();
        /** 职业类型 */
        self.q_job = data.ReadInt();
        /** 机器人属性 */
        self.q_attribute = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_arena_robot.list = Q_arena_robot.list|| [];
	/** 配置数据索引*/
	Q_arena_robot.map = Q_arena_robot.map || {};
	
	/** 设置配置数据*/
	Q_arena_robot.SetData = Q_arena_robot.SetData || function( data ){

		var list = Q_arena_robot.list;
		var map = Q_arena_robot.map;

		Q_arena_robot.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_arena_robot();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_rank)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_arena_robot.GetList = Q_arena_robot.GetList || function(){
		return Q_arena_robot.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_arena_robot.Get = Q_arena_robot.Get || function( id ){
		return Q_arena_robot.map[ id ];
	};
})();