var Q_backpack_grid = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 所属系统_格子编号 (索引) */
        self.q_backpack_q_grid = data.ReadString();
        /** 所属系统（1背包格子，2仓库格子） */
        self.q_backpack = data.ReadInt();
        /** 格子编号 */
        self.q_grid = data.ReadInt();
        /** 自动成长开格所需时间（单位:秒） */
        self.q_time = data.ReadInt();
        /** 手动开启所需元宝费用 */
        self.q_cost = data.ReadInt();
        /** 成功开启后增加人物经验 */
        self.q_exp = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_backpack_grid.list = Q_backpack_grid.list|| [];
	/** 配置数据索引*/
	Q_backpack_grid.map = Q_backpack_grid.map || {};
	
	/** 设置配置数据*/
	Q_backpack_grid.SetData = Q_backpack_grid.SetData || function( data ){

		var list = Q_backpack_grid.list;
		var map = Q_backpack_grid.map;

		Q_backpack_grid.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_backpack_grid();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_backpack_q_grid)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_backpack_grid.GetList = Q_backpack_grid.GetList || function(){
		return Q_backpack_grid.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_backpack_grid.Get = Q_backpack_grid.Get || function( id ){
		return Q_backpack_grid.map[ id ];
	};
})();