var Q_demonStar = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 副本ID */
        self.q_id = data.ReadInt();
        /** 开放编号 */
        self.q_open_id = data.ReadInt();
        /** 每天可通关次数限制 */
        self.q_challenge_num = data.ReadInt();
        /** 难度级别 */
        self.q_hard = data.ReadInt();
        /** 展示用怪物半身像资源编号 */
        self.q_show_half = data.ReadInt();
        /** 展示用怪物全身像资源编号 */
        self.q_show_monster = data.ReadInt();
        /** 地图存在的怪物及坐标[[id1,x,y][id2,x,y][id3,x,y]] */
        self.q_map_boss = data.ReadString();
        /** 通关BOSSID */
        self.q_win_boss = data.ReadInt();
        /** 副本描述 */
        self.q_introduce = data.ReadString();
        /** 怪物描述 */
        self.q_introduce_monster = data.ReadString();
        /** 展示掉落道具 */
        self.q_item_show = data.ReadString();
        /** 通关奖励 */
        self.q_reward = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_demonStar.list = Q_demonStar.list|| [];
	/** 配置数据索引*/
	Q_demonStar.map = Q_demonStar.map || {};
	
	/** 设置配置数据*/
	Q_demonStar.SetData = Q_demonStar.SetData || function( data ){

		var list = Q_demonStar.list;
		var map = Q_demonStar.map;

		Q_demonStar.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_demonStar();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_demonStar.GetList = Q_demonStar.GetList || function(){
		return Q_demonStar.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_demonStar.Get = Q_demonStar.Get || function( id ){
		return Q_demonStar.map[ id ];
	};
})();