var Q_disguise = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** ID（注意不能超过127） */
        self.q_id = data.ReadInt();
        /** 易容名字 */
        self.q_name = data.ReadString();
        /** 易容面板显示顺序 */
        self.q_order = data.ReadInt();
        /** 显示所需合服次数 */
        self.q_hefu = data.ReadInt();
        /** 易容类型（1：易容） */
        self.q_type = data.ReadInt();
        /** 转职业对应易容 */
        self.q_change = data.ReadInt();
        /** 易容所需的职业（0：通用，1：男，2：女） */
        self.q_job = data.ReadInt();
        /** 激活标记美术资源 */
        self.q_activate_mark = data.ReadInt();
        /** 头像资源编号 */
        self.q_head = data.ReadInt();
        /** 展示资源编号 */
        self.q_show = data.ReadInt();
        /** 激活类型(1:充值（首冲），2：VIP，3：道具激活    4：任务激活） */
        self.q_activate_type = data.ReadInt();
        /** 激活条件 [激活道具，激活道具所需数量]，若为VIP激活，则直接填写VIP等级，若为任务激活，直接填写任务ID */
        self.q_activate_need = data.ReadString();
        /** 激活的技能 */
        self.q_skill = data.ReadInt();
        /** 属性类型 */
        self.q_attribute = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_disguise.list = Q_disguise.list|| [];
	/** 配置数据索引*/
	Q_disguise.map = Q_disguise.map || {};
	
	/** 设置配置数据*/
	Q_disguise.SetData = Q_disguise.SetData || function( data ){

		var list = Q_disguise.list;
		var map = Q_disguise.map;

		Q_disguise.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_disguise();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_disguise.GetList = Q_disguise.GetList || function(){
		return Q_disguise.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_disguise.Get = Q_disguise.Get || function( id ){
		return Q_disguise.map[ id ];
	};
})();