var Q_flyhorse = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 飞行坐骑编号 */
        self.q_id = data.ReadInt();
        /** 飞行坐骑名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 飞行坐骑界面飞行坐骑名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 是否可被攻击(0不允许，1允许） */
        self.q_hit = data.ReadInt();
        /** 被攻击最大损失血量（无论是什么攻击都仅扣除1滴血） */
        self.q_hp_lose = data.ReadInt();
        /** 飞行坐骑头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 飞行坐骑面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用飞行坐骑造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 飞行坐骑特效 */
        self.q_effect = data.ReadInt();
        /** 飞行坐骑描述文本 */
        self.q_introduce = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_flyhorse.list = Q_flyhorse.list|| [];
	/** 配置数据索引*/
	Q_flyhorse.map = Q_flyhorse.map || {};
	
	/** 设置配置数据*/
	Q_flyhorse.SetData = Q_flyhorse.SetData || function( data ){

		var list = Q_flyhorse.list;
		var map = Q_flyhorse.map;

		Q_flyhorse.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_flyhorse();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_flyhorse.GetList = Q_flyhorse.GetList || function(){
		return Q_flyhorse.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_flyhorse.Get = Q_flyhorse.Get || function( id ){
		return Q_flyhorse.map[ id ];
	};
})();