var Q_forbidden_area = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 等级 */
        self.q_id = data.ReadInt();
        /** 对应的BOSS ID */
        self.q_boss = data.ReadInt();
        /** 召唤所需经验（注意：本条经验升满才可召唤） */
        self.q_gold = data.ReadInt();
        /** 普通召唤对应宝箱奖励（随机取1个）  */
        self.q_gift = data.ReadString();
        /** 掉落宝箱数量 */
        self.q_num = data.ReadInt();
        /** 掉落的宝箱模型 */
        self.q_box = data.ReadInt();
        /** 超级召唤奖励 */
        self.q_reward_super = data.ReadString();
        /** 超级召唤所需花费元宝 */
        self.q_member = data.ReadInt();
        /** 对应的超级BOSSid */
        self.q_boss_super = data.ReadInt();
        /** 排行榜奖励 */
        self.q_rank = data.ReadString();
        /** 掉落奖励 */
        self.q_drop = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_forbidden_area.list = Q_forbidden_area.list|| [];
	/** 配置数据索引*/
	Q_forbidden_area.map = Q_forbidden_area.map || {};
	
	/** 设置配置数据*/
	Q_forbidden_area.SetData = Q_forbidden_area.SetData || function( data ){

		var list = Q_forbidden_area.list;
		var map = Q_forbidden_area.map;

		Q_forbidden_area.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_forbidden_area();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_forbidden_area.GetList = Q_forbidden_area.GetList || function(){
		return Q_forbidden_area.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_forbidden_area.Get = Q_forbidden_area.Get || function( id ){
		return Q_forbidden_area.map[ id ];
	};
})();