var Q_item_simpact = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 物品ID */
        self.q_id = data.ReadInt();
        /** 物品名称(最大九个汉字。支持_后缀，后缀部分在客户端不予显示)（物品名称需要唯一，以便在爆率表中使用汉字） */
        self.q_name = data.ReadString();
        /** 使用后关联BUFF编号列表（格式：BUFF编号;BUFF编号;BUFF编号） */
        self.q_buff = data.ReadString();
        /** 使用后增加的属性 */
        self.q_attribute = data.ReadString();
        /** 使用后增加的万分比分子属性  {{系统类型：{属性值：万分比分子},{系统类型：{属性值：万分比分子}}   0为角色，其他的按照具体的资源线类型 */
        self.q_attributeRatios = data.ReadString();
        /** 传送卷轴类型（1为回城卷，2为随即传送卷，3为地图定点传送卷，4为行会回城卷） */
        self.q_transfer = data.ReadInt();
        /** 传送地图ID */
        self.q_transfer_map = data.ReadInt();
        /** 传送地图坐标[[X1,Y1],[X2,Y2]] */
        self.q_transfer_position = data.ReadString();
        /** 魔化属性（类型|属性类型|属性值）类型：  1：魔化  2：附魔 */
        self.q_magic = data.ReadString();
        /** 属于套装几（装备部位0-5为套装1，装备部位6-7为套装2，装备8-9为套装3) */
        self.q_group = data.ReadInt();
        /** 是否属于神装(1是，0 否） */
        self.q_isholy = data.ReadInt();
        /** 血量恢复 */
        self.q_hp_regain = data.ReadInt();
        /** 追加属性条数概率 [0条权重，1条权重，2条权重，3条权重…..]   */
        self.q_extraNum = data.ReadString();
        /** 每条附加增加的属性 */
        self.q_extraAttributes = data.ReadString();
        /** 掉落时随机生成强化等级的几率  [0级权重，1级权重，。。。] */
        self.q_strengthen = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_item_simpact.list = Q_item_simpact.list|| [];
	/** 配置数据索引*/
	Q_item_simpact.map = Q_item_simpact.map || {};
	
	/** 设置配置数据*/
	Q_item_simpact.SetData = Q_item_simpact.SetData || function( data ){

		var list = Q_item_simpact.list;
		var map = Q_item_simpact.map;

		Q_item_simpact.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_item_simpact();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_item_simpact.GetList = Q_item_simpact.GetList || function(){
		return Q_item_simpact.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_item_simpact.Get = Q_item_simpact.Get || function( id ){
		return Q_item_simpact.map[ id ];
	};
})();