var Q_legend_box = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 格子数 */
        self.q_id = data.ReadInt();
        /** 展示的格子类型(1:小箱子，2:中箱子，3:大箱子） */
        self.q_box_type = data.ReadInt();
        /** 每次开箱子最多获得的奖励 */
        self.q_max_num = data.ReadInt();
        /** 必定获得的奖励 */
        self.q_reward_sure = data.ReadString();
        /** 随机获得的奖励 */
        self.q_reward_random = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_legend_box.list = Q_legend_box.list|| [];
	/** 配置数据索引*/
	Q_legend_box.map = Q_legend_box.map || {};
	
	/** 设置配置数据*/
	Q_legend_box.SetData = Q_legend_box.SetData || function( data ){

		var list = Q_legend_box.list;
		var map = Q_legend_box.map;

		Q_legend_box.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_legend_box();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_legend_box.GetList = Q_legend_box.GetList || function(){
		return Q_legend_box.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_legend_box.Get = Q_legend_box.Get || function( id ){
		return Q_legend_box.map[ id ];
	};
})();