var Q_legend_compound = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 锻造级别_所需锻造部位 */
        self.q_id = data.ReadString();
        /** 锻造后部位增加的百分比基础属性（百分比分子） */
        self.q_add_base = data.ReadInt();
        /** 合成所需消耗银两 */
        self.q_siver = data.ReadInt();
        /** 合成所需消耗真气 */
        self.q_magic = data.ReadInt();
        /** 合成所需道具1 */
        self.q_item_one = data.ReadInt();
        /** 道具1数量 */
        self.q_num_one = data.ReadInt();
        /** 合成所需道具2 */
        self.q_item_two = data.ReadInt();
        /** 道具2数量 */
        self.q_num_two = data.ReadInt();
        /** 合成所需道具3 */
        self.q_item_three = data.ReadInt();
        /** 道具3数量 */
        self.q_num_three = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_legend_compound.list = Q_legend_compound.list|| [];
	/** 配置数据索引*/
	Q_legend_compound.map = Q_legend_compound.map || {};
	
	/** 设置配置数据*/
	Q_legend_compound.SetData = Q_legend_compound.SetData || function( data ){

		var list = Q_legend_compound.list;
		var map = Q_legend_compound.map;

		Q_legend_compound.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_legend_compound();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_legend_compound.GetList = Q_legend_compound.GetList || function(){
		return Q_legend_compound.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_legend_compound.Get = Q_legend_compound.Get || function( id ){
		return Q_legend_compound.map[ id ];
	};
})();