var Q_lucky_draw_total = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 类型 4：开服充值抽象  5：正常充值抽奖  3： 消费抽奖 */
        self.q_id = data.ReadInt();
        /** 寻宝名字 */
        self.q_name = data.ReadString();
        /** 寻宝次数 [[寻宝次数，消耗的货币类型，消耗的数量]] */
        self.q_currency_cost = data.ReadString();
        /** 道具寻宝[[寻宝次数，消耗的道具，消耗的道具数量]] */
        self.q_item = data.ReadString();
        /** 是否全平台（0：否，1：是） */
        self.q_public = data.ReadInt();
        /** 物品打折系数（单位：万分比）   价格*（1-折扣值） */
        self.q_discount_number = data.ReadInt();
        /** 折扣时间[[20180425000000,20180427235959],[20180501000000,20180503235959]]    */
        self.q_discount_time = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_lucky_draw_total.list = Q_lucky_draw_total.list|| [];
	/** 配置数据索引*/
	Q_lucky_draw_total.map = Q_lucky_draw_total.map || {};
	
	/** 设置配置数据*/
	Q_lucky_draw_total.SetData = Q_lucky_draw_total.SetData || function( data ){

		var list = Q_lucky_draw_total.list;
		var map = Q_lucky_draw_total.map;

		Q_lucky_draw_total.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_lucky_draw_total();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_lucky_draw_total.GetList = Q_lucky_draw_total.GetList || function(){
		return Q_lucky_draw_total.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_lucky_draw_total.Get = Q_lucky_draw_total.Get || function( id ){
		return Q_lucky_draw_total.map[ id ];
	};
})();