var Q_minimapshow = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 地图编号 */
        self.q_mapid = data.ReadInt();
        /** 怪物("|":区分相同怪物,";":区分不同怪物 10087_100_100 表示：怪物ID为10087的怪物会在对应地图的X,Y坐标分别为100,100的位置刷新，相同类型怪物在同一张地图内会存在多个刷新点，配置的第一个刷新点为小地图上显示的标记位置。当玩家点击怪物名称执行自动寻径逻辑时，如果配置表中相同怪物存在多个刷新点则客户端会让玩家寻径到随机的刷怪点) */
        self.q_monster_coord = data.ReadString();
        /** 适合练级等级（min） */
        self.q_min_lv = data.ReadInt();
        /** 适合练级等级（max） */
        self.q_max_lv = data.ReadInt();
        /** 跨地图寻路点 */
        self.q_movepoint = data.ReadString();
        /** 怪物刷新点不出现在该小地图中 */
        self.q_noappear = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_minimapshow.list = Q_minimapshow.list|| [];
	/** 配置数据索引*/
	Q_minimapshow.map = Q_minimapshow.map || {};
	
	/** 设置配置数据*/
	Q_minimapshow.SetData = Q_minimapshow.SetData || function( data ){

		var list = Q_minimapshow.list;
		var map = Q_minimapshow.map;

		Q_minimapshow.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_minimapshow();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_mapid)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_minimapshow.GetList = Q_minimapshow.GetList || function(){
		return Q_minimapshow.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_minimapshow.Get = Q_minimapshow.Get || function( id ){
		return Q_minimapshow.map[ id ];
	};
})();