var Q_monicker = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 头衔ID */
        self.q_level = data.ReadInt();
        /** 头衔名称  */
        self.q_name = data.ReadString();
        /** 头衔描述  */
        self.q_introduce = data.ReadString();
        /** 升级所需战斗力 */
        self.q_fighting_capacity = data.ReadInt();
        /** 激活所需道具ID [道具ID，道具数量] */
        self.q_activate_item = data.ReadString();
        /** 属性类型 */
        self.q_attribute = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_monicker.list = Q_monicker.list|| [];
	/** 配置数据索引*/
	Q_monicker.map = Q_monicker.map || {};
	
	/** 设置配置数据*/
	Q_monicker.SetData = Q_monicker.SetData || function( data ){

		var list = Q_monicker.list;
		var map = Q_monicker.map;

		Q_monicker.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_monicker();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_level)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_monicker.GetList = Q_monicker.GetList || function(){
		return Q_monicker.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_monicker.Get = Q_monicker.Get || function( id ){
		return Q_monicker.map[ id ];
	};
})();