var Q_morph = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 化妖编号 */
        self.q_modelID = data.ReadInt();
        /** 化妖名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 场景中使用化妖造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 化妖面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 化妖头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 化妖文本描述介绍 */
        self.q_introduce = data.ReadString();
        /** 化妖最大可升星级 */
        self.q_level_max = data.ReadInt();
        /** 激活最低星级 */
        self.q_level_initial = data.ReadInt();
        /** 激活所需碎片 */
        self.q_activate_soul_need = data.ReadInt();
        /** 激活/升星所需灵魂碎片(升到2星所需碎片数量|升到3星所需碎片数量|升到4星所需碎片数量|升到5星所需碎片数量） */
        self.q_up_soul_need = data.ReadString();
        /** 对应的灵魂碎片ID */
        self.q_soulID = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_morph.list = Q_morph.list|| [];
	/** 配置数据索引*/
	Q_morph.map = Q_morph.map || {};
	
	/** 设置配置数据*/
	Q_morph.SetData = Q_morph.SetData || function( data ){

		var list = Q_morph.list;
		var map = Q_morph.map;

		Q_morph.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_morph();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_modelID)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_morph.GetList = Q_morph.GetList || function(){
		return Q_morph.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_morph.Get = Q_morph.Get || function( id ){
		return Q_morph.map[ id ];
	};
})();