var Q_raid = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 副本ID */
        self.q_id = data.ReadInt();
        /** 推荐通关人数 */
        self.q_challenge_num = data.ReadInt();
        /** 副本描述 */
        self.q_introduce = data.ReadString();
        /** 展示的几率掉落道具 */
        self.q_item_show = data.ReadString();
        /** 通关奖励 */
        self.q_daily_reward = data.ReadString();
        /** 副本首次通关奖励 */
        self.q_first_reward = data.ReadString();
        /** 副本名称美术资源 */
        self.q_name_artistic = data.ReadInt();
        /** BOSS挑战时间（单位：秒） */
        self.q_challenge_time = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_raid.list = Q_raid.list|| [];
	/** 配置数据索引*/
	Q_raid.map = Q_raid.map || {};
	
	/** 设置配置数据*/
	Q_raid.SetData = Q_raid.SetData || function( data ){

		var list = Q_raid.list;
		var map = Q_raid.map;

		Q_raid.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_raid();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_raid.GetList = Q_raid.GetList || function(){
		return Q_raid.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_raid.Get = Q_raid.Get || function( id ){
		return Q_raid.map[ id ];
	};
})();