var Q_resline = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 资源线类型_资源线阶数 */
        self.q_id = data.ReadString();
        /** 资源线名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 界面名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 资源线特效 */
        self.q_effect = data.ReadInt();
        /** 资源线描述文本 */
        self.q_introduce = data.ReadString();
        /** 对应的技能格子的技能可被激活 */
        self.q_skill = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_resline.list = Q_resline.list|| [];
	/** 配置数据索引*/
	Q_resline.map = Q_resline.map || {};
	
	/** 设置配置数据*/
	Q_resline.SetData = Q_resline.SetData || function( data ){

		var list = Q_resline.list;
		var map = Q_resline.map;

		Q_resline.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_resline();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_resline.GetList = Q_resline.GetList || function(){
		return Q_resline.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_resline.Get = Q_resline.Get || function( id ){
		return Q_resline.map[ id ];
	};
})();