var Q_shop_base = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** id */
        self.q_shop_id = data.ReadInt();
        /** 商店名称 */
        self.q_shop_name = data.ReadString();
        /** 间隔刷新时间（填0或不填表示及时刷新，有刷新时间就填对应值，配置格式为固定时间刷新，单位：秒 */
        self.q_cd_time = data.ReadInt();
        /** 定时刷新时间（配置格式和活动开启配置表相同） */
        self.q_timing_refresh = data.ReadString();
        /** 刷新消耗的货币类型（填-1 元宝，-2 绑定元宝，-3 经验，-4 声望，-5 荣誉，-6 临时元宝） */
        self.q_cdDeplete_type = data.ReadInt();
        /** 刷新消耗数量（消耗元宝的基数，之后由程序根据基数配置设定每次刷新的递加公式） */
        self.q_cdDeplete_number = data.ReadString();
        /** 道具上架数量是否随机抽取（填0不随机抽取，填1随机抽取） */
        self.q_random = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_shop_base.list = Q_shop_base.list|| [];
	/** 配置数据索引*/
	Q_shop_base.map = Q_shop_base.map || {};
	
	/** 设置配置数据*/
	Q_shop_base.SetData = Q_shop_base.SetData || function( data ){

		var list = Q_shop_base.list;
		var map = Q_shop_base.map;

		Q_shop_base.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_shop_base();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_shop_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_shop_base.GetList = Q_shop_base.GetList || function(){
		return Q_shop_base.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_shop_base.Get = Q_shop_base.Get || function( id ){
		return Q_shop_base.map[ id ];
	};
})();