var Q_shop_data = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 序列号（数据库遍历时调用的主键） */
        self.q_id = data.ReadInt();
        /** 物品上架商店(对应shopID) */
        self.q_data_id = data.ReadInt();
        /** 上架时间段(-1下架，0正常在架，[时间格式写法]限时上架的时间) */
        self.q_rack = data.ReadString();
        /** 物品id(JSON字符串） */
        self.q_goods_id = data.ReadString();
        /** 物品刷新所需最低人物等级(填0无等级限制) */
        self.q_item_level = data.ReadInt();
        /** 物品刷新所需最高人物等级（人物等级段控制） */
        self.q_item_maxlevel = data.ReadInt();
        /** 上架个数（填-1表示无限个数）格式：[[个数概率,个数],[个数概率,个数]] */
        self.q_number = data.ReadString();
        /** 单次购买上限 */
        self.q_Buylimit_one = data.ReadInt();
        /** 消耗货币 格式：[[货币类型,货币数量],[货币类型,货币数量]] */
        self.q_money_cost = data.ReadString();
        /** 物品打折系数（单位：万分比） */
        self.q_discount_number = data.ReadInt();
        /** 是否热卖商品 */
        self.q_hot = data.ReadInt();
        /** 兑所需段位 */
        self.q_otherlimit = data.ReadString();
        /** 是否极品(1:极品，0：普通） */
        self.q_expensive = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_shop_data.list = Q_shop_data.list|| [];
	/** 配置数据索引*/
	Q_shop_data.map = Q_shop_data.map || {};
	
	/** 设置配置数据*/
	Q_shop_data.SetData = Q_shop_data.SetData || function( data ){

		var list = Q_shop_data.list;
		var map = Q_shop_data.map;

		Q_shop_data.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_shop_data();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_shop_data.GetList = Q_shop_data.GetList || function(){
		return Q_shop_data.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_shop_data.Get = Q_shop_data.Get || function( id ){
		return Q_shop_data.map[ id ];
	};
})();