var Q_skill_model = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 技能编号_技能等级 */
        self.q_skillID_q_grade = data.ReadString();
        /** 技能编号 */
        self.q_skillID = data.ReadInt();
        /** 技能等级 */
        self.q_grade = data.ReadInt();
        /** 最大等级 */
        self.q_max_level = data.ReadInt();
        /** 技能名称 */
        self.q_skillName = data.ReadString();
        /** 显示所需人物等级 */
        self.q_show_needgrade = data.ReadInt();
        /** （前端使用）战斗力加成 */
        self.q_fight_bonus = data.ReadInt();
        /** 技能伤害类型（0默认攻击技能，1治疗技能） */
        self.q_hurt_type = data.ReadInt();
        /** 使用者（1人物技能，2怪物技能，3被动触发有施法动作技能） */
        self.q_skill_user = data.ReadInt();
        /** 使用方式（1主动技能，2被动技能） */
        self.q_trigger_type = data.ReadInt();
        /** 触发方式（1在攻击时触发，2在挨打时触发(没做）,3攻击与挨打时都触发（没做），4命中后触发，5 被攻击死亡之前触发  6 暴击后触发） */
        self.q_passive_action = data.ReadInt();
        /** 技能吟唱时间（毫秒，0表示无吟唱时间） */
        self.q_singing_time = data.ReadInt();
        /** 冷却时间（毫秒） */
        self.q_cd = data.ReadInt();
        /** 公共冷却时间 */
        self.q_public_cd = data.ReadInt();
        /** 公共冷却层级 */
        self.q_public_cd_level = data.ReadInt();
        /** 延迟命中时间（单位：毫秒） */
        self.q_delay_time = data.ReadInt();
        /** 使用距离限制（自身与目标之间的距离）（单位：格子）,地面行走魔法表示行走距离 */
        self.q_range_limit = data.ReadInt();
        /** 弹道飞行速度（单位：像素/秒）如果为0,表示无弹道,直接打鼠标指的地方或者直接作用到目标身上.PS：有弹道的话会碰触到任何目标都会触发。 */
        self.q_trajectory_speed = data.ReadInt();
        /** 作用对象（1自己，2友好目标，3敌对目标，4当前目标，5场景中鼠标的当前坐标点，6主人） */
        self.q_target = data.ReadInt();
        /** 作用目标上限 */
        self.q_target_max = data.ReadInt();
        /** 技能伤害系数（万分比分子） */
        self.q_hurt_correct_factor = data.ReadInt();
        /** 技能附加伤害 */
        self.q_ignore_defence = data.ReadInt();
        /** 攻击玩家时，除主目标外的其他目标伤害比例（万分比分子） */
        self.q_hurt_secondary = data.ReadInt();
        /** 属性类型 */
        self.q_attribute = data.ReadString();
        /** 使用后增加的万分比分子属性  {{系统类型：{属性值：万分比分子},{系统类型：{属性值：万分比分子}}   0为角色，其他的按照具体的资源线类型   100：角色宝石系统（宝石只对宝石系统起作用） */
        self.q_attributeRatios = data.ReadString();
        /** 被动触发几率（本处填万分比的分子） 如果是被动技能触发才有效，BUFF触发概率通过BUFF表控制 */
        self.q_passive_prob = data.ReadInt();
        /** 触发后附加的BUFF编号序列（格式：BUFF编号;BUFF编号） */
        self.q_passive_buff = data.ReadString();
        /** 作用范围形状（1单体，2矩形（自身为起点），3扇形，4圆形，5柱行（自身为中心）） */
        self.q_area_shape = data.ReadInt();
        /** 作用范围中心点（1自身为中心，2目标为中心）,如果地面魔法,那么也表示起点 */
        self.q_area_target = data.ReadInt();
        /** 矩形长（像素） */
        self.q_area_length = data.ReadInt();
        /** 矩形宽 */
        self.q_area_width = data.ReadInt();
        /** 扇形开始角度 */
        self.q_sector_start = data.ReadInt();
        /** 扇形结束角度 */
        self.q_secto_end = data.ReadInt();
        /** 扇形半径(像素) */
        self.q_sector_radius = data.ReadInt();
        /** 圆半径(像素) */
        self.q_circular_radius = data.ReadInt();
        /** 是否触发一次战斗公式的伤害（0不触发，1触发） */
        self.q_trigger_figth_hurt = data.ReadInt();
        /** 技能类型（0普通爆发技能，1地面行走魔法(需要配置飞行速度),2地面定点效果，3全屏技能（仅对小怪有效） */
        self.q_skill_ground_type = data.ReadInt();
        /** 技能是否需要引导(1表示需要引导) */
        self.q_guide = data.ReadInt();
        /** 相同地面魔法是否可叠加效果,0可叠加,1不可叠加 */
        self.q_skill_ground_qverlay = data.ReadInt();
        /** 地面魔法作用次数,0不限制,  大于0释放后执行触发效果的次数 (陷阱填1) */
        self.q_skill_act_num = data.ReadInt();
        /** 地面魔法作用间隔时间（单位毫秒，500的倍数） */
        self.q_skill_ground_period = data.ReadInt();
        /** 地面魔法持续时间/引导技能引导时间（毫秒） */
        self.q_skill_time = data.ReadInt();
        /** 所处技能面板大类(0基础，1被动) */
        self.q_panel_type = data.ReadInt();
        /** 受到该列技能克制 */
        self.q_restriction = data.ReadInt();
        /** 是否忽视（个位为1禁止吸血，十位为1禁止闪避） */
        self.q_is_ignore = data.ReadInt();
        /** 升级所需人物等级 */
        self.q_level_up = data.ReadInt();
        /** 技能升级所需熟练度 */
        self.q_upgrade_proficiency = data.ReadInt();
        /** 技能升级所需道具ID */
        self.q_upgrade_item = data.ReadInt();
        /** 技能升级所需道具数量 */
        self.q_upgrade_item_num = data.ReadInt();
        /** 技能描述所需数值 */
        self.q_introduce = data.ReadString();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_skill_model.list = Q_skill_model.list|| [];
	/** 配置数据索引*/
	Q_skill_model.map = Q_skill_model.map || {};
	
	/** 设置配置数据*/
	Q_skill_model.SetData = Q_skill_model.SetData || function( data ){

		var list = Q_skill_model.list;
		var map = Q_skill_model.map;

		Q_skill_model.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_skill_model();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_skillID_q_grade)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_skill_model.GetList = Q_skill_model.GetList || function(){
		return Q_skill_model.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_skill_model.Get = Q_skill_model.Get || function( id ){
		return Q_skill_model.map[ id ];
	};
})();