var Q_treasurehunt = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 顺序 */
        self.q_id = data.ReadInt();
        /** 显示位置（-1:中间，0：不显示，1-9分别从12点位置顺时针） */
        self.q_place = data.ReadInt();
        /** 展示资源 */
        self.q_show = data.ReadInt();
        /** 道具生成 */
        self.q_item_set = data.ReadString();
        /** 掉落比重 */
        self.q_rate = data.ReadInt();
        /** 前100次掉落比重 */
        self.q_rate_previous = data.ReadInt();
        /** 寻宝次数间隔必定出该道具 */
        self.q_period = data.ReadInt();
        /** 本服寻宝次数间隔必定出该道具（仅算元宝寻宝次数） */
        self.q_period_all = data.ReadInt();
        /** 掉落所需最低等级 */
        self.q_level_min = data.ReadInt();
        /** 掉落所需最高等级 */
        self.q_level_max = data.ReadInt();
        /** 是否计入全服几率（1：是，0：否） */
        self.q_record = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_treasurehunt.list = Q_treasurehunt.list|| [];
	/** 配置数据索引*/
	Q_treasurehunt.map = Q_treasurehunt.map || {};
	
	/** 设置配置数据*/
	Q_treasurehunt.SetData = Q_treasurehunt.SetData || function( data ){

		var list = Q_treasurehunt.list;
		var map = Q_treasurehunt.map;

		Q_treasurehunt.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_treasurehunt();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_treasurehunt.GetList = Q_treasurehunt.GetList || function(){
		return Q_treasurehunt.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_treasurehunt.Get = Q_treasurehunt.Get || function( id ){
		return Q_treasurehunt.map[ id ];
	};
})();