var Q_uangel = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 天使挂坠编号 */
        self.q_id = data.ReadInt();
        /** 天使挂坠名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 天使挂坠界面天使挂坠名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 是否可被攻击(0不允许，1允许） */
        self.q_hit = data.ReadInt();
        /** 被攻击最大损失血量（无论是什么攻击都仅扣除1滴血） */
        self.q_hp_lose = data.ReadInt();
        /** 天使挂坠头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 天使挂坠面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用天使挂坠造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 天使挂坠特效 */
        self.q_effect = data.ReadInt();
        /** 天使挂坠描述文本 */
        self.q_introduce = data.ReadString();
        /** 对应的技能格子的技能可被激活 */
        self.q_skill = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_uangel.list = Q_uangel.list|| [];
	/** 配置数据索引*/
	Q_uangel.map = Q_uangel.map || {};
	
	/** 设置配置数据*/
	Q_uangel.SetData = Q_uangel.SetData || function( data ){

		var list = Q_uangel.list;
		var map = Q_uangel.map;

		Q_uangel.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_uangel();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_uangel.GetList = Q_uangel.GetList || function(){
		return Q_uangel.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_uangel.Get = Q_uangel.Get || function( id ){
		return Q_uangel.map[ id ];
	};
})();