var Q_udevil = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 恶魔挂坠编号 */
        self.q_id = data.ReadInt();
        /** 恶魔挂坠名称 */
        self.q_name = data.ReadString();
        /** 名字颜色，支持html语法 */
        self.q_name_color = data.ReadString();
        /** 恶魔挂坠界面恶魔挂坠名称美术字体编号 */
        self.q_name_artistic = data.ReadInt();
        /** 是否可被攻击(0不允许，1允许） */
        self.q_hit = data.ReadInt();
        /** 被攻击最大损失血量（无论是什么攻击都仅扣除1滴血） */
        self.q_hp_lose = data.ReadInt();
        /** 恶魔挂坠头像ICON资源编号 */
        self.q_head_ico_id = data.ReadInt();
        /** 恶魔挂坠面板展示用造型资源编号 */
        self.q_panel_show_id = data.ReadInt();
        /** 场景中使用恶魔挂坠造型资源编号 */
        self.q_scene_show_id = data.ReadInt();
        /** 恶魔挂坠特效 */
        self.q_effect = data.ReadInt();
        /** 恶魔挂坠描述文本 */
        self.q_introduce = data.ReadString();
        /** 对应的技能格子的技能可被激活 */
        self.q_skill = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_udevil.list = Q_udevil.list|| [];
	/** 配置数据索引*/
	Q_udevil.map = Q_udevil.map || {};
	
	/** 设置配置数据*/
	Q_udevil.SetData = Q_udevil.SetData || function( data ){

		var list = Q_udevil.list;
		var map = Q_udevil.map;

		Q_udevil.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_udevil();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_udevil.GetList = Q_udevil.GetList || function(){
		return Q_udevil.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_udevil.Get = Q_udevil.Get || function( id ){
		return Q_udevil.map[ id ];
	};
})();