var ENUM_TOPICBOX = ENUM_TOPICBOX ||
{
	LINGQU:0,//领取
	CAIJI:1,//采集
}
var TopicBoxExt = TopicBox.extend ( {
	_className:"TopicBoxExt",
	_time:5,
	_type:0,
	_percentImg:null,
	_progressSp:null,
	_isClicked:false,
	_resetTimeOutNum:-1,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -100;
	},
	Init:function()
	{
		var self = this;
		TopicBox.prototype.Init.call(this);
		this.labGet.SetFontSize(18);
		this.labGet.x-=2;
		this.imgYuan1.visible = false;
		this.imgBox.setLocalZOrder(200);
		this.btnGet.addClickEventListener(function()
		{
			if(!self._isClicked)
			{
				self._StartAction();
			}
		});
		this.imgBox.setTouchEnabled(true);
		this.imgBox.addClickEventListener(function()
		{
			if(!self._isClicked)
			{
				self._StartAction();
			}
		});
	},
	_HandleGetReward:function() {
		if( this._progressSp ){
			this._progressSp.opacity = 0;
			this._progressSp.stopAllActions();
		}
		this._isClicked = false;
		if ( this._type == ENUM_TOPICBOX.LINGQU )
		{
			Mgr.guild.SendReqGuildAnswerDailyReward();
		}
		this._HideSelf();
	},
	_HideSelf:function()
	{
		EngineMgr.uiMgr.HidePanel(this);
	},
	SetTime:function(time,type, targetId)
	{
		TimerUtil.ClearTimeout(this._resetTimeOutNum);
		this._resetTimeOutNum = -1;
		Mgr.npc.isCollection = true;
		this._time = time;
		this._type = type;
		switch (type)
		{
			case ENUM_TOPICBOX.CAIJI:
			{
				var taskid = Mgr.task.aCurTaskId;
				var text = this.GetTaskText(taskid, targetId);
				if( !text ){
					var list = Mgr.task.allTaskHash.Values();
					for( var i = 0, len = list.length; i < len; i++ ){
						text = this.GetTaskText(list[i].taskModelId, targetId);
						if(text)
							break;
					}
				}
				if(text){
					this.labGet.SetString(text);
				}else{
					this.labGet.SetString("采集中");
				}
				this._StartAction();
				break;
			}
			case ENUM_TOPICBOX.LINGQU:
			{
				this.labGet.SetString("领取");
				break;
			}
			default:break;
		}
		this.labGet.y = -5;
	},
	GetTaskText:function(taskid, targetId){
		var q_data = Q_mission_base.Get(taskid);
		if(q_data){
			var target = Mgr.sceneObj.FindObject(targetId ? targetId.toGID() : 0 );
			var npcId = TaskUtil.GetNpcIdByTask(taskid, EnumTaskState.STATE_UNSUBMIT);
			if( q_data.q_mission_mainType == EnumTaskType.CONQUER )
				npcId = q_data.q_undeal_mission;
			if(target && npcId == target.nBodyModelId){
				if( q_data.q_mission_mainType == EnumTaskType.CONQUER ){
					return "查看中";
				}
				else{
					var name = TextUtil.RemoveHTMLTag(q_data.q_finish_describe);
					return name.substring(0,2)+"中";
				}
			}
		}
		return null;
	},
	//调该方法，自动播放进度动效
	SetInfo:function(data)
	{
		switch (this._type)
		{
			case ENUM_TOPICBOX.CAIJI:
			{
				TimerUtil.TimeUpdate(this._HideSelf,this,this._time,0);
				break;
			}
			case ENUM_TOPICBOX.LINGQU:
			{
				this._StartAction();
				break;
			}
			default:break;
		}
	},
	_StartAction:function()
	{
		this._isClicked = true;
		var self = this;
		if(!this._percentImg)
		{
			var imageRes = "other/bangpaidati/jindu.png";
			EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
				self._percentImg = new cc.Sprite();
				self._percentImg.initWithSpriteFrameName(imageRes);
				self._PlayActionn();
			}, this);
		}
		else
		{
			if( this._progressSp )
				this._progressSp.opacity = 255;
			self._PlayActionn();
		}
	},
	_PlayActionn:function()
	{
		var self = this;
		var progressTo = cc.progressFromTo(this._time,0,100);
		var callfunc = cc.callFunc(function()
		{
			self._HandleGetReward();
		}, this);
		var sequence = cc.sequence(progressTo,callfunc);
		if(!this._progressSp)
		{
			var progressSp = new cc.ProgressTimer(this._percentImg);
			progressSp.type = cc.ProgressTimer.TYPE_RADIAL;
			progressSp.runAction(sequence);
			this.addChild(progressSp, 100);
			var pos = this.imgYuan1.getPosition();
			progressSp.setPosition(pos.x+this.imgYuan1.width/2,pos.y+this.imgYuan1.height/2);
			this._progressSp = progressSp;
		}
		else
		{
			this._progressSp.runAction(sequence);
		}
	},
	
	_ResetCollection:function(){
		Mgr.npc.isCollection = false;
	},
	OnHide:function()
	{
		this._super();
		if(this._type == ENUM_TOPICBOX.LINGQU)
		{
			this._isClicked = false;
			if( this._progressSp ){
				this._progressSp.opacity = 0;
				this._progressSp.stopAllActions();
			}
		}
		if( this._progressSp )
			this._progressSp.setPercentage(0);
		this._resetTimeOutNum = TimerUtil.SetTimeout(this, this._ResetCollection,300);//挂机连续采集的时候有可能出现前端采集完了后端还没完的情况，所以加300毫秒延迟
	}
} );
TopicBoxExt.PanelName = "TopicBoxExt";
PanelClassDic["TopicBoxExt"] = TopicBoxExt;
