var ActivitiesBackGroundExt = ActivitiesBackGround.extend ( {
	_className:"ActivitiesBackGroundExt",
    buttonPanel:null,
    childPanel:null,
	buttonList:null,
    activityHash:null,
    _curSubKey:0,
	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -30;
        this.activityHash = new HashMap();
	},

	Init:function () {
        var self = this;
        ActivitiesBackGround.prototype.Init.call(this);

        if(!this.buttonPanel){
            this.buttonPanel= new ccui.ListView();
            this.buttonPanel.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight - 18));
            this.buttonPanel.setDirection(ccui.ScrollView.DIR_VERTICAL);
            this.buttonPanel.setItemsMargin(6);
            this.buttonPanel.setBounceEnabled(true);
            this.buttonPanel.setScrollBarEnabled(false);
            this.buttonPanel.x += 5;
            this.imgBg.addChild(this.buttonPanel);
        }
        this.buttonList = [];
        this.btnClose.addClickEventListener(function (event) {
			Mgr.uiMgr.HidePanel(self);
        });
    },

    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        isOpen = isOpen || false;
        this.mainPanelKey = mainPanelKey;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        this.activityHash = ActivityUtil.GetHashByTabKey(this.mainPanelKey);//根据tabKey进行排序

        this.UpdateTitle();
        this.UpdateButtonList();

        var subKey = ActivityUtil.GetGuideSubKey(this.mainPanelKey);
        subKey = subKey || this.buttonList[0].sbtn1.data[0].tabKey;
        this.UpdatePanel( isOpen ? subKey : this._curSubKey, isOpen);
	},

    UpdateTitle:function () {
        var url = "other/kaifuhuodong/word/kaifuhuodong.png";
        var ac = this.activityHash.Values()[0][0];
        if(ac){
            var title = ac.GetFlagValue("mainhead");
            if(title)
                url = "other/kaifuhuodong/word/" + title;
        }
        UIUtil.LoadImage(this.img3, url, false, false, false, false);
    },

    UpdateButtonList:function(){
        if(this.buttonPanel){
            this.buttonPanel.removeAllItems();
        }
        var self = this;
        var hash = this.activityHash;
        var hashList = hash.Values();
        for(var i = 0, len = hashList.length; i < len; i++){
            var group = hashList[i];
            // if( group[0].tabKey == EnumActivityKey.S_DOUBLE_RECHARGE )
            //     continue;
            var button;
            if( i < this.buttonList.length )
                button = this.buttonList[i];
            else {
                button = new ActivitiesBtnExt();
                button.LoadPanel();
                button.retain();
                this.buttonList.push(button);
            }
            button.sbtn1.SetText(group[0].tabName);
            button.sbtn1.data = group;
            if(group[0].subPanelType == EnumActivityType.S_BBGS)
                button.UpdateNotice(group.concat(Mgr.dailyactivity.GetActivityByKey(EnumActivityKey.M_BBGS)));
            else 
                button.UpdateNotice(group);
            this.buttonPanel.pushBackCustomItem(button);

            button.sbtn1.addClickEventListener(function (target) {
                self.UpdatePanel(target.data[0].tabKey, false);
            });
        }
    },

    UpdateSingleActivity:function (info) {
        if( this.childPanel ){
            this.childPanel.UpdateSingleActivity(info);
        }

        //更新提示
        for(var i = 0, len = this.buttonList.length; i < len; i++){
            var button = this.buttonList[i];
            if(button.sbtn1.data[0].tabKey == info.tabKey){
                button.UpdateNotice(this.activityHash.Get(info.tabKey));
                break;
            }
        }
    },

    UpdatePanel:function(key, isOpen) {
        if( !isOpen && this.childPanel && this._curSubKey == key ){
            var infoList = this.activityHash.Get(key);
            this.childPanel.SetActivityList(infoList, isOpen);
        }
        else{
            this._curSubKey = key;
            if(this.childPanel){
                this.childPanel.OnHide();
                this.imgTitleBg.removeChild(this.childPanel);
            }
            var infoList = this.activityHash.Get(key);
            var className = ActivityUtil.GetClassBySubType( infoList[0].subPanelType );
            this.childPanel = new className();
            this.childPanel.LoadPanel();
            this.childPanel.SetActivityList(infoList, true);
            this.imgTitleBg.addChild(this.childPanel);
        }
        for(var i = 0, len = this.buttonList.length; i < len; i++){
            var button = this.buttonList[i].sbtn1;
            button.SetButtonState((button.data[0].tabKey == key ? MUICheckBox.STATE_CHECK : MUICheckBox.STATE_UNCHECK ));
        }
    },
} );
ActivitiesBackGroundExt.PanelName = "ActivitiesBackGroundExt";
PanelClassDic["ActivitiesBackGroundExt"] = ActivitiesBackGroundExt;
