var JinRiTeHuiMainExt = JinRiTeHuiMain.extend ( {
	_className:"JinRiTeHuiMainExt",

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffx = -30;
	},

	Init:function () {
		JinRiTeHuiMain.prototype.Init.call(this);
		this.img1.setVisible(false);
		this.labCue2.setVisible(false);
		this.sbtnGouxuan.setVisible(false);

		this.rewardsArr = [];

		var self = this;
		this.btnClose.addClickEventListener(function (sender) {
			Mgr.uiMgr.HidePanel(self);
        });

		this.btnGouMai.addClickEventListener(function (sender) {
			if(self.activity.status == 1){
                Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.activity.activityId, 1);
			}else if(self.activity.status == 2){
                OpenFuncUtil.OpenRecharge();
			}
        });
    },

    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        isOpen = isOpen || false;
        this.mainPanelKey = mainPanelKey;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        var list = Mgr.dailyactivity.GetActivityByKey(this.mainPanelKey);
        this.activity = list[0];

        var rewards = this.activity.GetRewardList();
		for(var i = 0; i < rewards.length; i++){
			if(!this.rewardsArr[i]){
				var cell = UIUtil.CloneUI(this.img1);
				if(cell.parent){
					cell.removeFromParent();
				}
				this.rewardsArr.push(cell);
				this.addChild(cell);
			}

			var grid = this.rewardsArr[i].grid1;
			GridUtil.SetItemGrid(grid, rewards[i]);
			var label = this.rewardsArr[i].labName;
			UIUtil.ConnectLabelHtmlText(label, [rewards[i].GetName()]);
		}
		this.ResetGridPos();

		UIUtil.ConnectLabelHtmlText(this.lab1, [this.activity.introduction]);
        if(!this._timer){
            var leftTime = this.activity.endTime - parseInt(Mgr.login.GetServerTime()/1000);
            var str = TimeUtil.SecondToDHMS2(leftTime);
            UIUtil.ConnectLabelHtmlText(this.labCue1, [str]);
            this._timer = TimerUtil.TimeUpdate(function () {
                leftTime--;
                var str = TimeUtil.SecondToDHMS2(leftTime);
                UIUtil.ConnectLabelHtmlText(this.labCue1, [str]);
            }, this, 1, leftTime);
		}

		switch (this.activity.status){
			case 1:
				this.btnGouMai.setTitleText("领取奖励");
                break;
			case 2:
				this.btnGouMai.setTitleText("充值");
                break;
		}
    },

	ResetGridPos:function () {
		var contentWidth = 550;
		var offset = (contentWidth - this.rewardsArr.length * this.img1.uiWidth) / (this.rewardsArr.length - 1);
		offset = offset > 0 ? offset : 0;

        // var offset = 0;
        // if(this.rewardsArr.length == 1){
        //     offset = contentWidth / 2;
        // }else {
        //     offset = (contentWidth - this.rewardsArr.length * this.img1.uiWidth) / (this.rewardsArr.length - 1);
        // }
        // offset = offset > 0 ? offset : 0;

		for(var i = 0; i < this.rewardsArr.length; i++){
			var grid  = this.rewardsArr[i];
			grid.x = this.img1.x + (grid.uiWidth + offset) * i - 30;
		}
    },
} );
JinRiTeHuiMainExt.PanelName = "JinRiTeHuiMainExt";
PanelClassDic["JinRiTeHuiMainExt"] = JinRiTeHuiMainExt;
