var TuanGouListExt = TuanGouList.extend ( {
	_className:"TuanGouListExt",
    awardList:null,
	ctor:function(){
		this._super();
	},

    Init:function () {
	    var self = this;
        TuanGouList.prototype.Init.call(this);
        this.gridAward.visible = false;
        this.btnGet.addClickEventListener(function (target) {
            if(self.activityInfo.status == 1){
                Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.activityInfo.activityId, 1);
            }
        });
        this.btnGet.setSwallowTouches(false);
    },

    SetData:function (info) {
        this.activityInfo = info;

        if( info.special ){
            var special = info.special[0]
            if(special){
                switch (special.type){
                    case 3:
                        // var need = special.beanInfo.condition[0];
                        var now = special.beanInfo.conditionNum[0];
                        this.labCue.SetText(TextUtil.FormatStr(info.introduction, [now]));
                        break;
                }
            }
        }
        else{
            this.labCue.SetText(info.introduction);
        }

        this.ClearImgList();
        this.awardList = [];
        var awards = info.GetRewardList();
        for(var i = 0, len = awards.length; i < len; i++){
            var grid = new MUIGrid();
            grid.ParseJson(this.gridAward.jsonobj);
            grid.Init();
            var item = awards[i];
            GridUtil.SetItemGrid(grid, item);
            this.imgList.addChild(grid);
            this.awardList.push(grid);
            grid.setSwallowTouches(false);
        }
        this.SetGridPos();
        this.SetButtonStatus(info.status);
    },

    SetButtonStatus:function (status) {
        switch (status){
            case 0:
                this.btnGet.setTitleText("已领取");
                Filter.GrayScale(this.btnGet);
                break;
            case 1:
                this.btnGet.setTitleText("领奖");
                Filter.UnGray(this.btnGet);
                break;
            case 2:
                this.btnGet.setTitleText("领奖");
                Filter.GrayScale(this.btnGet);
                break;
        }
    },

    SetGridPos:function () {
        for(var i = 0, len = this.awardList.length; i < len; i++){
            var grid = this.awardList[i];
            grid.x = this.gridAward.x + (this.gridAward.uiWidth + 2) * i;
        }
    },

    ClearImgList:function () {
        if(this.awardList && this.awardList.length > 0){
            for(var i = 0; i < this.awardList.length; i++){
                var grid = this.awardList[i];
                this.imgList.removeChild(grid);
            }
        }
    },
} );
TuanGouListExt.PanelName = "TuanGouListExt";
PanelClassDic["TuanGouListExt"] = TuanGouListExt;
