var ZhekouListExt = ZhekouList.extend ( {
	_className:"ZhekouListExt",
	ctor:function(){
		this._super();
	},

    Init:function () {
        var self = this;
        ZhekouList.prototype.Init.call(this);
        this.labCue11.visible = false;
        this.btnGet.addClickEventListener(function (target) {
            var price = parseInt(self.detail.GetFlagValue(EnumActivityFlag.F_NEW_PRICE));
            var total = Mgr.mainPlayer.attributeData.TotalGold();
            var vip = parseInt(self.detail.GetFlagValue(EnumActivityFlag.F_VIP));
            if( Mgr.player.mainPlayer.VIP < vip ){
                Mgr.tips.ShowNotice("VIP等级不足！");
            }
            else if(total < price){
                // Mgr.tips.ShowNotice("你的元宝不足");
                AlertExt.NoEnoughGold(price - total);
            }else {
                if( self.detail.status == 0 ){
                    Mgr.tips.ShowNotice("已经卖完了！");
                }
                else{
                    Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self.detail.activityId, 1);
                }
            }
        });
        this.btnGet.setSwallowTouches(false);
    },

    SetData:function (info) {
	    this.detail = info;
        var reward = info.GetRewardList();
        var item = reward[0];
        GridUtil.SetItemGrid(this.gridAward, item);
        this.gridAward.setSwallowTouches(false);
        var vip = info.GetFlagValue("vip");
        if(vip){
            this.imglabNum.SetText(vip);
            if(parseInt(vip) >= 10){
                this.imgXiangou.x = this.imgXiangou.initX + 12;
            }
        }
        this.imgV.visible = vip ? true : false;
        this.imglabNum.visible = vip ? true : false;
        this.imgXiangou.visible = vip ? true : false;
        this.labCue.x = vip ? this.labCue.initX : this.imgV.x;

        var oldprice = info.GetFlagValue("oldprice");
        var newprice = info.GetFlagValue(EnumActivityFlag.F_NEW_PRICE);
        var discout = info.GetFlagValue("zhekou");
        this.labNumber.SetHtmlText(oldprice);
        this.labNumber1.SetHtmlText(newprice);
        if(discout){
            UIUtil.LoadImage( this.imgDiscount, "other/kaifuhuodong/zhekou/" + discout + ".png" );
        }else {
            this.imgDiscount.visible = false;
        }
        this.labCue.SetText(TextUtil.FormatStr(this.labCue.GetHtmlText(), [info.rewardTimes+"/"+info.allTimes]));
        if(info.rewardTimes >= info.allTimes){
            Filter.GrayScale(this.btnGet)
        }
        else{
            Filter.UnGray(this.btnGet)
        }
        this.labName.SetText(item.GetName());
        this.labCue1.SetHtmlText(info.introduction);
    },
} );
ZhekouListExt.PanelName = "ZhekouListExt";
PanelClassDic["ZhekouListExt"] = ZhekouListExt;
