var JinglianRefineStoneExt = JinglianRefineStone.extend ( {
	_className:"JinglianRefineStoneExt",

	listener:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		JinglianRefineStone.prototype.Init.call(this);

		var self = this;
		//if ( !this.listener ) {
		this.listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			onTouchBegan: function (touch, event) {
				if ( self.visible )
					Mgr.uiMgr.HidePanel(self);
				return true;
			},
			onTouchMoved: function (touch, event) {
			},
			onTouchEnded: function (touch, event) {
			}
		});
		//	this.listener.retain();
		//	}
		cc.eventManager.addListener( this.listener ,this);
	},

	SetDate:function ( quility, equipLocation, stoneLocation  ) {
		//this._AddListenEvent();

		var item = null;
		var configList = DuanzaoUtil.GetStoneByType( EnumItemType.RefineStone,stoneLocation );
		if ( configList.length > 0 )
			item = configList[0];

		// icon
		var grid = this.gridIcon;
		var icon = ItemUtil.GetItemIcon(item.q_id, ResUrl.ITEM_SIZE_60)
		icon.x = (grid.uiWidth - icon.width) / 2;
		icon.y = (grid.uiHeight - icon.height) / 2;
		grid.SetGridIcon(icon);
		grid.item = item;

		//获取数量
		var maxNum = 0;
		var data = DuanzaoUtil.GetRefineStoneNumByQuility(quility);
		if (data) {
			for (var j = 0; j != data.length; j++) {
				if (stoneLocation == data[j].location) {
					maxNum = data[j].num;
					break;
				}
			}
		}
		var nextMaxNum = 0;
		var data = DuanzaoUtil.GetRefineStoneNumByQuility(quility + 1);
		if (data) {
			for (var j = 0; j != data.length; j++) {
				if (stoneLocation == data[j].location) {
					nextMaxNum = data[j].num;
					break;
				}
			}
		}
		else {   // 获取不到数据（精炼到最大了） // 显示最大的数据
			var data_cur = DuanzaoUtil.GetRefineStoneNumByQuility(quility);
			if (data_cur) {
				for (var j = 0; j != data_cur.length; j++) {
					if (stoneLocation == data_cur[j].location) {
						nextMaxNum = data_cur[j].num;
						break;
					}
				}
			}
		}


		// 已经使用的数量
		var usedNum = 0;
		var cache = Mgr.equipRefine.GetRefineStones(item.q_type);
		for (var j = 0; j != cache.length; j++) {
			if (cache[j].equipLocation == equipLocation) {
				var list = cache[j].refinelList;
				for (var k = 0; k != list.length; k++) {
					if (list[k] == item.q_id) {
						usedNum = list[k + 1];
						break;
					}
				}
			}
		}
		// attr
		var attrV = DuanzaoUtil.GetAttributeV(item.q_id, 0);

		//name
		this.labName.SetString( item.q_name );
		this.labName.EnableOutline("0x62360f");

		//--
		this.labZhanli.EnableOutline("0x295d1d");
		var str = String(usedNum) + "/" + String( maxNum ) + "个";
		this.labZhanli1.SetString( str );
		this.labZhanli1.EnableOutline("0x295d1d");

		this.labSkillCue.EnableOutline("0x3d1e07");
		 str = String(nextMaxNum) + "个";
		this.labSkillCue1.SetString( str );
		this.labSkillCue1.EnableOutline("0x295d1d");

		//attr
		 str = attrV.str + "  +" + String( attrV.value );
		this.labCue11.SetString( str );
		this.labCue11.EnableOutline("0x295d1d");

		this.labCue1.EnableOutline("0x3d1e07");
		this.labCue111.EnableOutline("0x3d1e07");
	},

	_AddListenEvent:function () {

	},

	OnTouchBegan:function(touch, event){

		Mgr.uiMgr.HidePanel(this);
		return true;

		// 范围外的响应
		// var locPoint = this.convertTouchToNodeSpace(touch);
	 	// var rect = cc.rect(0, 0, this.width, this.height);
		// if(!cc.rectContainsPoint(rect,locPoint)) {
		// 	//Mgr.uiMgr.HidePanel(this);
		// 	return true;
		// }
		// return false;
	},

	OnShow:function (){
	// 	zz.Error("***********************************   start")
	// 	var self = this;
	// 	//if ( !this.listener ) {
	// 		this.listener = cc.EventListener.create({
	// 			event: cc.EventListener.TOUCH_ONE_BY_ONE,
	// 			onTouchBegan: function (touch, event) {
	// 				zz.Error("***********************************")
	// 				Mgr.uiMgr.HidePanel(self);
	// 				return true;
	// 			},
	// 			onTouchMoved: function (touch, event) {
	// 			},
	// 			onTouchEnded: function (touch, event) {
	// 			}
	// 		});
	// 	//	this.listener.retain();
	// //	}
	// 	cc.eventManager.addListener( this.listener ,this);
	},
	OnHide:function(){
		this._super();
		// zz.Error("***********************************   end  " )
		// if ( this.listener ) {
		// 	cc.eventManager.removeListener(this.listener);
		// 	this.listener = null;
		// }
	},
} );
JinglianRefineStoneExt.PanelName = "JinglianRefineStoneExt";
PanelClassDic["JinglianRefineStoneExt"] = JinglianRefineStoneExt;
