var ShenZhuangDaZaoExt = ShenZhuangDaZao.extend ( {
    _className:"ShenZhuangDaZaoExt",
    ctor:function(){
        this._super();
    },

    Init:function(){
        this._super()

        this.lab1.visible = false;
        this.labQiangHua.visible = false;
        this.imgSelect.visible = false;


        this._gridArr = [
            {obj:this.grid1,type:EnumEquipPos.EQUIP_WEAPONS},//武器0
            {obj:this.grid2,type:EnumEquipPos.EQUIP_CLOTHES},//衣服1
            {obj:this.grid3,type:EnumEquipPos.EQUIP_BRACELET_LEFT },//护手
            {obj:this.grid4,type:EnumEquipPos.EQUIP_HUFU_LEFT}, //左护符6
            {obj:this.grid5,type:EnumEquipPos.EQUIP_RING_LEFT}, //左戒指8
            {obj:this.grid6,type:EnumEquipPos.EQUIP_BELT},//腰带3
            {obj:this.grid7,type:EnumEquipPos.EQUIP_HUTUI},//护腿
            {obj:this.grid8,type:EnumEquipPos.EQUIP_SHOES}, //鞋子5
            {obj:this.grid9,type:EnumEquipPos.EQUIP_HUFU_RIGHT}, //右护符7
            {obj:this.grid10,type:EnumEquipPos.EQUIP_RING_RIGHT} //右戒指9
        ];
    },
    InitSubTabConfig:function(){
        var config = [
            { type : EnumItemType.Equip	,text : "角色" },
            { type : EnumItemType.Equip_Shutong	,text : "书童" },
        ];

        return config;
    },
    OnShow:function(){
        this._super();
        GameEventMgr.AddEventListener(this,EnumEventType.GAME_REFINING_RESULT,function(){
            this.SetData();
        })
    },
    OnHide:function(){
        GameEventMgr.RemoveEventListener(this);
        this._super();
    },
    SetData:function(itemType) {
         itemType = itemType || this._itemType;

         var force = itemType != this._itemType;
         this._itemType = itemType;

        this.SetEquips();

        if (!force && this._selectedItemForgeC)
            this.SetCenterEquip();
        else
            this._AutoSelect();   // 每次打开界面均自动选者
    },

    _AutoSelect:function () {
        this.SetCenterEquip(this._gridArr[0].obj.itemForgeC);
    },

    SetEquips:function(){
        var forgeType = this._itemType == EnumItemType.Equip ? EnumItemForgeType.EQUIP_PLAYER:EnumItemForgeType.EQUIP_SHUTONG;
        var list = DuanzaoUtil.GetAllItemForgeListByType(forgeType);
        var self = this;
        for ( var i = 0; i < this._gridArr.length; i++ ) {
            var itemForgeC = list.find(function(v){
                var itemC = Q_item.Get(v.q_item_id);
                return itemC.q_kind == self._gridArr[i].type;
            })

            if(DuanzaoUtil.IsItemComposableWithConfig(itemForgeC)){
              this._StartWarn(this._gridArr[i].obj);
            }else{
              this._EndWarn(this._gridArr[i].obj);
            }

            this._SetEquip( this._gridArr[i].obj, itemForgeC);
        }
    },

    _SetEquip:function ( grid, itemForgeC ) {
        grid.Clean();
        grid.itemForgeC = itemForgeC;

        if (itemForgeC) {
            var item = ItemUtil.ItemIdToItem(itemForgeC.q_item_id);
            GridUtil.SetItemGrid(grid,item, null, null, null, false);
        }
        // callback
        var self = this;
        grid.setTouchEnabled(true);
        grid.addTouchEventListener(function (sender, type) {
            if (type == ccui.Widget.TOUCH_ENDED) {
                if ( sender.itemForgeC ) {
                    if ( self._curSelector ) self._SetSelectEffect( self._curSelector, false )

                    self._curSelector = sender;
                    self._SetSelectEffect( sender, true )

                    self.SetCenterEquip(sender.itemForgeC);
                }
                else
                    Mgr.tips.ShowNotice( "没有装备!");
            }
        });
    },

    _SetSelectEffect:function (grid, visible) {
        if ( !grid.select ) {
            var icon = new MUIImage();
            icon.ParseJson(this.imgSelect.jsonobj);
            icon.Init();
            icon.setPosition(this.imgSelect.getPosition());
            grid.addChild(icon);
            grid.select = icon;
        }
        grid.reorderChild(grid.select, 3);
        grid.select.visible = visible;
    },


    SetCenterEquip:function(itemForgeC) {
        this._selectedItemForgeC = itemForgeC = itemForgeC || this._selectedItemForgeC;

        var grid = this.grid11;
        grid.Clean();

        var itemC
        if(itemForgeC){
            var item = ItemUtil.ItemIdToItem(itemForgeC.q_item_id);
            GridUtil.SetItemGrid(grid,item, null, null, null, true);
            itemC = Q_item.Get(itemForgeC.q_item_id);
        }

        var condition = DuanzaoUtil.GetItemForgeCondition(itemForgeC);
        var textName = itemC ? itemC.q_name : "???";
        var textCondition = "???";
        var textConditionName = "???";
        var textOwn = "???";
        var textFightPower = itemC ? DuanzaoUtil.GetEquipFighting(itemC.q_id,0) : 0;

        var conditionC,composable = true;
        for(var k in condition){
            conditionC = Q_item.Get(k);
            textConditionName = conditionC.q_name;
            textCondition = conditionC.q_name + " x" + condition[k];
            textOwn = Mgr.backpack.GetItemNumber(k);

            if(textOwn < condition[k]) composable = false;
        }

        UIUtil.ConnectLabelHtmlText(this.labWord,[textName]);
        UIUtil.ConnectLabelHtmlText(this.labDaZao,[textCondition]);
        UIUtil.ConnectLabelHtmlText(this.labDaZao1,[textOwn]);
        UIUtil.ConnectLabelHtmlText(this.labNum,[textFightPower]);
        UIUtil.ConnectLabelHtmlText(this.labGet,[textConditionName]);

//        this.labGet.addTouchEventListener(function(){
//            Mgr.uiMgr.ShowPanelByType(RidepanelGetRouteExt.PanelName);
//        })

        this.btnHeCheng.addClickEventListener(function(){
            if(!itemC){
                return;
            }

            if(!composable){
                Mgr.tips.ShowNotice( "材料不足！");
                return;
            }

            Mgr.refining.SendReqComposeGodEquipMessage(0, itemC.q_id, 1, []);
        })
    },


    _EndWarn:function (grid) {
        if (grid.warn) {
            grid.warn.visible = false;
            grid.warn.stopAllActions();
        }
    },

    _StartWarn:function (grid) {
        if ( !grid.warn ) {
            // 可镶嵌
            grid.warn = UIUtil.CloneUI(this.labQiangHua);
            grid.addChild(grid.warn, 1, 20);
        }

        grid.warn.SetString("可打造")

        grid.warn.visible = true;
        grid.warn.setOpacity(255);
        grid.warn.setPosition(this.labQiangHua.getPosition());
        grid.reorderChild(grid.warn, 10);

        // action
        var actionTo = cc.moveBy(1, cc.p(0, grid.height / 4));
        var trace = cc.callFunc(this._OnTrace, this);
        var out = cc.fadeOut(0.5);
        var ina = cc.fadeIn(0.5);
        var rep = cc.sequence(actionTo, out, trace, ina).repeatForever();
        grid.warn.stopAllActions();
        grid.warn.runAction(rep);
    },

    _OnTrace:function (sender) {
        var pos = this.labQiangHua.getPosition();
        sender.x = pos.x;
        sender.y = pos.y;
    },
} );
ShenZhuangDaZaoExt.PanelName = "ShenZhuangDaZaoExt";
PanelClassDic["ShenZhuangDaZaoExt"] = ShenZhuangDaZaoExt;
