var HusongTimeCueExt = HusongTimeCue.extend ( {
	_className:"HusongTimeCueExt",
    _isTimeStart:false,
    _timeNum:0,
	ctor:function(){
		this._super();
        this.layoutCom.layoutType = MLLAYOUT_B;
	},
	Init:function () {
        var self = this;
        HusongTimeCue.prototype.Init.call( this );
        this.labTime.SetColor(EnumFontFormat.COMMON_COLOR04);
        this.btnHusong.addClickEventListener(function () {
            if( Mgr.sceneMap.bChangingState ) return;
            
            Mgr.convoy.ContinueConvoy();
        });
        this.setSwallowTouches(false);
    },
    UpdateTime:function (time) {
        this._timeNum = time;
        if(!this._isTimeStart)
        {
            this._isTimeStart = true;
            this.schedule(this.startCountDown,1);
        }
		this.labTime.SetString(TimeUtil.SecondToDHMS2(time));
        this._SetVisible();
    },
    startCountDown:function()
    {
        cc.log("Mgr.convoy.period=> "+Mgr.convoy.period+" --- "+Mgr.convoy.isHuSong+" -- "+Mgr.sceneMap.nMapId);
        var time = this._timeNum--;
        if(time < 0 ){
            return;
        }

        this.labTime.SetString(TimeUtil.SecondToDHMS2(time));
    },
    _SetVisible:function()
    {
        if(Mgr.zone.IsInZoneMap())
        {
            EngineMgr.uiMgr.HidePanel(this);
        }
        else
        {
            EngineMgr.uiMgr.ShowPanelByType(HusongTimeCueExt.PanelName);
        }
    },
    OnHide:function()
    {
        this._super();
        this.unschedule(this.startCountDown);
        this._isTimeStart = false;
    },
    OnShow:function()
    {
        this.labTime.SetString("00:00:00");
        this._isTimeStart = false;
    }
} );
HusongTimeCueExt.PanelName = "HusongTimeCueExt";
PanelClassDic["HusongTimeCueExt"] = HusongTimeCueExt;
