///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//115101,ReqFightPowerToServer 请求战斗力
//115102,ReqFightPowerBySysToServer 请求各个系统的战斗力

// 接收消息
//115201,ResFightPowerToClient 发送战斗力给客户端
//115202,ResFightPowerSysToClient 发送各个系统战斗力给客户端


////////////////////
// 请求战斗力 //
////////////////////
var ReqFightPowerToServerMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 115101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求各个系统的战斗力 //
////////////////////
var ReqFightPowerBySysToServerMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 115102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 发送战斗力给客户端 //
////////////////////
var ResFightPowerToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 角色id
        this.fightPower = 0; // 总战斗力
	},

	getId:function(){
		return 115201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteVarLong(this.fightPower);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.fightPower = _buf.ReadVarLong();
	},

	action:function(){
		Mgr.fightpower.RecvResFightPowerToClientMessage(this);
	},

});
////////////////////
// 发送各个系统战斗力给客户端 //
////////////////////
var ResFightPowerSysToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.fightPowerList = []; // 各个系统的战斗力{下标0是系统计算器类型1就是战斗力，依次类推} long
	},

	getId:function(){
		return 115202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.fightPowerList.length );
        for (var i = 0; i < this.fightPowerList.length; i++) {
            _buf.WriteLong(this.fightPowerList[i]);
        }
	},
	
	reading:function( _buf ){
        var fightPowerList_length = _buf.ReadShort();
        for (var i = 0; i < fightPowerList_length; i++) {
            this.fightPowerList[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.fightpower.RecvResFightPowerSysToClientMessage(this);
	},

});
// 接收消息注册
MESSAGE_POOL.Add(115201, ResFightPowerToClientMessage);
MESSAGE_POOL.Add(115202, ResFightPowerSysToClientMessage);

