var FulidatingLevelListExt = FulidatingLevelList.extend ( {
	_className:"FulidatingLevelListExt",

	rewardGridList:[],
    reward:null,
    giftId:null,
    level:null,


	ctor:function(){
		this._super();
        this.rewardGridList = [];
	},

    Init:function(){
        FulidatingLevelList.prototype.Init.call(this);
        this.gridAward.visible = false;

		var self = this;
        this.btnGet.addClickEventListener(function(event){
            Mgr.weal.SendReqUpGradeRewardToGameMessage(self.giftId);
        });
    },

    InitGrid:function(){
        for(var i = 0; i < this.reward.length; i++){
            if(!this.rewardGridList[i]){
                var grid = new MUIGrid();
                grid.ParseJson(this.gridAward.jsonobj);
                grid.Init();
                grid.x = this.gridAward.x + grid.uiWidth * i;
                grid.y = this.gridAward.y;
                this.addChild(grid);
                this.rewardGridList.push(grid);
            }
            var coinInfo = {};
            coinInfo.itemModelId = this.reward[i].mod;
            coinInfo.itemNum = this.reward[i].num;
            coinInfo.itemBind = this.reward[i].bind;
            GridUtil.SetItemGrid(this.rewardGridList[i], coinInfo);
        }
    },

    SetData:function(id, level, rewardList){
		this.giftId = id;
        Filter.UnGray(this.btnGet);
        this.btnGet.setTitleText("领取");
        this.labLevel.SetText(level + "级");
		this.reward = JSON.parse(rewardList);
        this.InitGrid();
	},

	IsAward:function(bool){
		if(bool){
            Filter.GrayScale(this.btnGet);
            this.btnGet.setTitleText("已领取");
        }
	},

    IsLevel:function(bool){
        if(bool){
            Filter.GrayScale(this.btnGet);
            this.btnGet.setTitleText("等级不足");
        }
    }
} );
FulidatingLevelListExt.PanelName = "FulidatingLevelListExt";
PanelClassDic["FulidatingLevelListExt"] = FulidatingLevelListExt;
