var FulidatingPanelExt = FulidatingPanel.extend ( {
	_className:"FulidatingPanelExt",

    _btnArray:null,
    _btnPosArray:null,

    panelMgr:null,
    showPanel:null,
    showType:null,

    _listView:null,
    _btnList:[],
    _btnHeight:null,
    _curSelectBtn:null,
    updateList:[],


	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;

		this._btnArray = [];
		this.panelMgr = {};
	},

    Init:function(){
        FulidatingPanel.prototype.Init.call(this);
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -28;

        // this._InitParm();
        this.UpdataWarn();

        var self = this;

        this.btnClose.addClickEventListener(function(event){
            EngineMgr.uiMgr.HidePanelByType( FulidatingPanelExt.PanelName );
        });
    },

    OnShow:function(){
        // var openlist = this._ReposBtns();
        // this.showType = this._RepanelType(this.showType, openlist);
        // if(this.showType == null){
        //     Mgr.tips.ShowNotice("没有开放功能");
        //     return;
        // }
        this.RefreshBtn();
        if(this.showType){
            this.ChangePanel(this.showType);
            this._curSelectBtn.SetSelect(true);
        }
        else{
            this.ChangePanel(FuliTypeEnum.TYPE_EQUIP);
            this._curSelectBtn = this._btnList[0];
            this._curSelectBtn.SetSelect(true);
        }
        this.UpdataWarn();
    },

    Update:function(){

    },

    RefreshBtn:function(){
        // this.imgTanhao.setVisible(false);
        // this._btnArray = [
        //     {btn:this.imgQiandao,   type:FuliTypeEnum.TYPE_SIGN},
        //     {btn:this.imgZaixian,   type:FuliTypeEnum.TYPE_ONLINE},
        //     {btn:this.imgDuanzao,   type:FuliTypeEnum.TYPE_OFFLINE},
        //     {btn:this.imgJinglian,  type:FuliTypeEnum.TYPE_EXCHANGE},
        //     {btn:this.imgIdeal,     type:FuliTypeEnum.TYPE_FEEDBACK}
        // ];

        // this._btnArray = [  {type:FuliTypeEnum.TYPE_EQUIP, name:"红装兑换"},
        //                     {type:FuliTypeEnum.TYPE_LEVEL, name:"等级礼包"},
        //                     {type:FuliTypeEnum.TYPE_SIGN, name:"每日签到"},
        //                     {type:FuliTypeEnum.TYPE_ONLINE, name:"在线奖励"},
        //                     // {type:FuliTypeEnum.TYPE_GETBACK, name:"资源找回"},
        //                     {type:FuliTypeEnum.TYPE_OFFLINE, name:"离线经验"},
        //                     {type:FuliTypeEnum.TYPE_EXCHANGE, name:"激活码兑换"},
        //                     {type:FuliTypeEnum.TYPE_FEEDBACK, name:"意见反馈"}
        // ];
        this._btnArray = [];
        this._btnArray.push({type:FuliTypeEnum.TYPE_EQUIP, name:"红装兑换"});
        this._btnArray.push({type:FuliTypeEnum.TYPE_LEVEL, name:"等级礼包"});
        this._btnArray.push({type:FuliTypeEnum.TYPE_SIGN, name:"每日签到"});
        this._btnArray.push({type:FuliTypeEnum.TYPE_ONLINE, name:"在线奖励"});
        this._btnArray.push({type:FuliTypeEnum.TYPE_OFFLINE, name:"离线经验"});
        this._btnArray.push({type:FuliTypeEnum.TYPE_EXCHANGE, name:"激活码兑换"});
        if(Mgr.weal.canFeedBack == 0)
            this._btnArray.push({type:FuliTypeEnum.TYPE_FEEDBACK, name:"意见反馈"});

        this.InitBtnView();

        // this._btnPosArray = [
        //     this.imgQiandao.getPosition(),
        //     this.imgZaixian.getPosition(),
        //     this.imgDuanzao.getPosition(),
        //     this.imgJinglian.getPosition(),
        //     this.imgIdeal.getPosition()
        // ]
    },

    InitBtnView:function(){
        if(!this._listView){
            this._listView = new ccui.ListView();
            this._listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._listView.setTouchEnabled(true);					//触摸开启
            this._listView.inertiaScrollEnabled = false; 			//滚动惯性
            this._listView.setScrollBarEnabled(false);				//滚动条
            this._listView.setBounceEnabled(true);					//边界回弹
            this._listView.addEventListener(this._SelectedBtnEvent);
            // this._listView.setScrollBarAutoHideTime(1);
            this.imgBg.addChild(this._listView);
        }

        this._listView.removeAllChildren();
        this._btnList = [];

        for(var i = 0; i < this._btnArray.length; i++){
            if(!this._btnList[i]){
                var btn = new FulidatingBtnExt();
                btn.LoadPanel();
                btn.setAnchorPoint(cc.p(0, 0.5));
                btn.x = (this.imgBg.uiWidth - btn.uiWidth)/2;
                btn.y = this.imgBg.uiHeight - (i - 1) * btn.uiHeight;
                this._listView.addChild(btn);
                this._btnList.push(btn);
                this._btnHeight = btn.uiHeight;
                this._btnWidth = btn.uiWidth;
            }
            this._btnList[i].SetData(this._btnArray[i].type, this._btnArray[i].name);
        }
        // this._listView.x = (this.imgBg.uiWidth - this._btnWidth)/2;
        this._listView.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
        // this._listView.setInnerContainerSize(cc.size(this.imgBg.uiWidth, this._btnArray.length * this._btnHeight));
    },

    _SelectedBtnEvent:function(sender, type){
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent.parent;
                if ( parent._curSelectBtn != null) {
                    parent._curSelectBtn.SetSelect(false);
                    parent._curSelectBtn = null;
                }

                var idx = sender.getCurSelectedIndex();
                var btnSelect = sender.getItem(idx);
                parent._curSelectBtn = btnSelect;
                btnSelect.SetSelect(true);
                parent.ChangePanel(btnSelect.type);
                parent.btnSelect = btnSelect;
                break;
            default:
                break;
        }
    },



	ChangePanel:function(type){
        // for(var i = 0; i != this._btnArray.length; i++){
        //     if(this._btnArray[i].type == type)
        //         this._btnArray[i].btn.SetButtonState("check");
        //     else
        //         this._btnArray[i].btn.SetButtonState("uncheck");
        // }

        if(this.showPanel){
            this.showPanel.visible = false;
            if(this.showPanel.StopEffect)
                this.showPanel.StopEffect();
            this.showPanel.OnHide();
            this.removeChild(this.showPanel);
            this.showPanel = null;
        }

        switch(type){
            case FuliTypeEnum.TYPE_EQUIP:
                if(!this.panelMgr[type]){
                    var panel = new DuihuanMainExt();
                    panel.LoadPanel();
                    this.imgTitleBg.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                this.panelMgr[type].OnShow();
                break;
            case FuliTypeEnum.TYPE_LEVEL:
                if(!this.panelMgr[type]){
                    var panel = new LevelGiftMainExt();
                    panel.LoadPanel();
                    this.imgTitleBg.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                this.panelMgr[type].OnShow();
                break;
            case FuliTypeEnum.TYPE_SIGN:
                if(!this.panelMgr[type]){
                    var panel = new QiandaoMainExt();
                    panel.LoadPanel();
                    this.imgTitleBg.addChild(panel);
                    this.panelMgr[type] = panel;
                    Mgr.sign.signPanel = panel;
                }
                this.panelMgr[type].OnShow();
                break;
            case FuliTypeEnum.TYPE_ONLINE:
                if(!this.panelMgr[type]){
                    var panel = new ZaixianMainExt();
                    panel.LoadPanel();
                    this.imgTitleBg.addChild(panel);
                    this.panelMgr[type] = panel;
                    Mgr.sign.onLinePanel = panel;
                }
                this.panelMgr[type].OnShow();
                break;
            case FuliTypeEnum.TYPE_OFFLINE:
                if(!this.panelMgr[type]){
                    var panel = new LixianExpMainExt();
                    panel.LoadPanel();
                    this.imgTitleBg.addChild(panel);
                    this.panelMgr[type] = panel;
                    Mgr.offlineres.offlinePanel = panel;
                }
                this.panelMgr[type].OnShow();
                break;
            case FuliTypeEnum.TYPE_EXCHANGE:
                if(!this.panelMgr[type]){
                    var panel = new JihuomaMainExt();
                    panel.LoadPanel();
                    this.imgTitleBg.addChild(panel);
                    this.panelMgr[type] = panel;
                    Mgr.card.cdKeyPanel = panel;
                }
                Mgr.card.cdKeyPanel.SetData();
                break;
            case FuliTypeEnum.TYPE_FEEDBACK:
                if(!this.panelMgr[type]){
                    var panel = new IdealMainExt();
                    panel.LoadPanel();
                    this.imgTitleBg.addChild(panel);
                    this.panelMgr[type] = panel;
                    // Mgr.card.cdKeyPanel = panel;
                }
                // Mgr.card.cdKeyPanel.SetData();
                break;
            default:
                break;
        }
        this.showType = type;
        this.showPanel = this.panelMgr[type];
        if(this.showPanel){
            //this.showPanel.SetData();
            this.showPanel.setVisible(true);
            if(this.showPanel.AddEffect)
                this.showPanel.AddEffect();
        }

	},

    _RepanelType:function(showtype, opentype){
	    var type = null;
	    if(opentype.length == 0)
	        return;

	    for(var i = 0; i!= opentype.length; i++){
	        if(opentype[i] == showtype){
	            type = opentype[i];
	            break;
            }
        }

        if(type == null)
            type = opentype[0];
        return type;
    },

    _ReposBtns:function(){
	    var btns = [];
	    var types = [];
	    for(var i = 0; i != this._btnArray.length; i++){
	        if(this._btnArray[i].btn.parent)
	            this._btnArray[i].btn.removeFromParent();

	        var main = BtnGroupUtil.MINIMAP2_WELFARE;
	        var type = this._btnArray[i].type;
	        var sub;
	        if(FuliTypeEnum.TYPE_SIGN)
	            sub;
            else if(FuliTypeEnum.TYPE_ONLINE)
                sub;
            else if(FuliTypeEnum.TYPE_OFFLINE)
                sub;
            else if(FuliTypeEnum.TYPE_EXCHANGE)
                sub;

            btns.push(this._btnArray[i].btn);
            types.push(this._btnArray[i].type);
        }
        for(var i = 0; i != btns.length; i++){
	        btns[i].setPosition(this._btnPosArray[i]);
	        this.addChild(btns[i]);
        }
        return types;
    },

    UpdataWarn:function(){
        for(var i = 0; i != this._btnList.length; i++){
            switch(this._btnList[i].type){
                case FuliTypeEnum.TYPE_LEVEL:
                    this.SetButtonWarn(this._btnList[i], Mgr.weal.levelWarn);
                    break;
                case FuliTypeEnum.TYPE_SIGN:
                    this.SetButtonWarn(this._btnList[i], Mgr.sign.signWarn);
                    break;
                case FuliTypeEnum.TYPE_ONLINE:
                    this.SetButtonWarn(this._btnList[i], Mgr.sign.IsShowOnLineWarn());
                    break;
                case FuliTypeEnum.TYPE_OFFLINE:
                    this.SetButtonWarn(this._btnList[i], Mgr.offlineres.IsOfflineWarn());
                    break;
                default:
                    break;
            }
        }
        // if(updateList)
	     //    this.updateList = updateList;
        // for(var j = 0; j < this.updateList.length; j ++){
	     //    var type = this.updateList[j];
        //     for(var i = 0; i != this._btnList.length; i++){
        //         if(this._btnList[i].type == type){
        //             switch(type){
        //                 case FuliTypeEnum.TYPE_LEVEL:
        //                     this.SetButtonWarn(this._btnList[i], Mgr.weal.levelWarn);
        //                     break;
        //                 case FuliTypeEnum.TYPE_SIGN:
        //                     this.SetButtonWarn(this._btnList[i], Mgr.sign.signWarn);
        //                     break;
        //                 case FuliTypeEnum.TYPE_ONLINE:
        //                     this.SetButtonWarn(this._btnList[i], Mgr.sign.IsShowOnLineWarn());
        //                     break;
        //                 case FuliTypeEnum.TYPE_OFFLINE:
        //                     this.SetButtonWarn(this._btnList[i], Mgr.offlineres.IsOfflineWarn());
        //                     break;
        //                 default:
        //                     break;
        //             }
        //         }
        //     }
        // }

    },

    SetButtonWarn:function(widget, visible){
        widget.SetWarn(visible);
    },

    OnHide:function(){
        this._super();
        this.showPanel.OnHide();
        Mgr.weal.SendReqGetLandInfoToGameMessage();
        // this.removeChild(this.showPanel);
        this.showPanel = null;
    }
} );
FulidatingPanelExt.PanelName = "FulidatingPanelExt";
PanelClassDic["FulidatingPanelExt"] = FulidatingPanelExt;
