var IdealMainExt = IdealMain.extend ( {
	_className:"IdealMainExt",

	starArr:null,
	selectStar:null,

	MAXLENGTH:300,

    REWARD_LIST:null,

	ctor:function(){
		this._super();
		this.starArr = [];
	},

    Init:function() {
        IdealMain.prototype.Init.call(this);

        this.starArr = [this.btnStar, this.btnStar1, this.btnStar2, this.btnStar3, this.btnStar4];

        this.InitEdit();
        this.InitGift();

        var self = this;
        for(var i = 0; i != this.starArr.length; i++){
        	this.starArr[i].id = i;
        	this.starArr[i].addClickEventListener(function(){
        		self.selectStar = this.id + 1;
        		for(var j = 0; j != self.starArr.length; j++){
        			if(this.id >= j)
                        self.starArr[j].SetButtonState("check");
        			else
                        self.starArr[j].SetButtonState("uncheck");
				}
			});
		}

		this.btnGo.addClickEventListener(function(){
			var str = self.editTxt.string;
			if(self.selectStar == null){
                Mgr.tips.ShowNotice("请选择满意度");
                return true;
			}
			if(str.length > self.MAXLENGTH){
                Mgr.tips.ShowNotice("输入的字数过多");
                return true;
			}
			Mgr.weal.SendReqFeedBackToGameMessage(self.selectStar, str);
		});
    },

	InitEdit:function(){
        this.editTxt.setPlaceHolder( "请输入意见" );
        // this.labTxt.SetString("请输入意见");
        this.editTxt.setDelegate(this);
        this.editTxt.setInputMode(cc.EDITBOX_INPUT_MODE_ANY);
        this.editTxt.setMaxLength(this.MAXLENGTH);
        this.editTxt.setOpacity(0);
	},

    editBoxTextChanged: function (editBox, text) {
        var ediText = editBox.getString();
        if (this.editTxt == editBox) {
            if ( ediText != "" ) {
                // this.labTxt.SetString( ediText );
                this.editTxt.setPlaceHolder(ediText);
            }
            else
            {
                // this.labTxt.SetString("请输入意见");
                this.editTxt.setPlaceHolder( "请输入意见" );
            }
        }

    },

	InitGift:function(){
		var list = IdealMainExt.REWARD_LIST;
		for(var i = 0; i != list.length; i++){
			var reward = this.gridAward;
            var conItem = new TaskRewardsGridCon();
            conItem.x = reward.x + (reward.width + 10)*i;
            conItem.y = reward.y;
            var item = ItemUtil.ItemIdToItem(list[i].mod, list[i].num, list[i].bind);
            conItem.AddComItem(item, reward);
            conItem.Layout(reward.uiWidth, reward.uiHeight, reward.uiWidth, reward.uiHeight);
            this.addChild(conItem);
		}
	},

	OnHide:function(){
        this._super();
		this.selectStar = null;
        for(var j = 0; j != this.starArr.length; j++){
            this.starArr[j].SetButtonState("uncheck");
        }
        this.editTxt.string = "";
	},

} );
IdealMainExt.PanelName = "IdealMainExt";
PanelClassDic["IdealMainExt"] = IdealMainExt;
