var TaijiFrameExt = TaijiFrame.extend ( {
	_className:"TaijiFrameExt",
	_data:null,
	_getType:false,//0可领奖 1不可领奖 2已领奖
	_rawardCon:null,
	_itemMid:0,
	_isGray:false,//是否变灰
	ctor:function(){
		this._super();
	},

	InitData:function( activeid ){
		this._data = Q_taijizhidian_type.Get(activeid);
		this.labName.SetHtmlText(TextUtil.FormatStr( this.labName.GetHtmlText(), [ this._data.q_name, "0", this._data.q_time ] ));
		this.labExp.SetHtmlText(TextUtil.FormatStr( this.labExp.GetHtmlText(), [ this._data.q_exp ] ));

		//奖励取消
		if(this._rawardCon == null){
			this._rawardCon = new TaskRewardsGridCon();
			this._rawardCon.x = this.gridItem.x;
			this._rawardCon.y = this.gridItem.y;
			this.imgNewfuncBg.addChild(this._rawardCon);
		}

        var rewards = null;
		// try {
         //    rewards = JSON.parse( this._data.q_reward )[0];
		// }catch (e){
		// 	cc.log("---------------rewards init----------"+e.toString())
		// }

		if( rewards != null && this._itemMid != rewards.mod ){
			var item = ItemUtil.ItemIdToItem(rewards.mod,rewards.num,rewards.bind);
			this._rawardCon.Clear();
			this._rawardCon.AddComItem(item,this.gridItem);
			this._rawardCon.Layout( this.gridItem.uiWidth, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
			this._itemMid = rewards.mod;
		}

        // 添加图标
        this.gridItem.Clean();
        var icon = this.GetGossipTaskIconByType(this._data.q_id);
        if(icon){
            EngineMgr.uiMgr.LoadOtherRes("other/xingongnengkaiqi",{
                Callback:function(){},
                ErrCallback:function(){},
            });
            var urlTubiao = "other/xingongnengkaiqi/image/tubiao/" + icon;

            var bg = new MUIImage();
            bg.ignoreContentAdaptWithSize(false);
            bg.setContentSize(cc.size(84,84));
            bg.setAnchorPoint(cc.p(0.5,0.5))
            bg.x = 42;
            bg.y = 42;

            UIUtil.LoadImage(bg, urlTubiao,false,true);
            this.gridItem.AddDisplay(bg);
        }

		var self = this;
		this.addClickEventListener(function () {
			if(self._getType == 0){
				Mgr.gossip.SendReqGossipRewardMessage(self._data.q_id);
			}else if(self._getType == 1){
				if(self._data.q_id == EnumGrossipTaskType.TYPE_DAY){//日常任务
					
				}else if(self._data.q_id == EnumGrossipTaskType.TYPE_GUILD){//帮会任务

				}else if(self._data.q_id == EnumGrossipTaskType.TYPE_EXPZONE){//经验副本
					EngineMgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
					Mgr.zone.battleZoneBackGroundPanel.ChangeView( EnumZoneType.TYPE_JY );
				}else if(self._data.q_id == EnumGrossipTaskType.TYPE_STORYZONE){//剧情副本
					EngineMgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
					Mgr.zone.battleZoneBackGroundPanel.ChangeView( EnumZoneType.TYPE_JQ );
				}else if(self._data.q_id == EnumGrossipTaskType.TYPE_JINJIEZONE){//进阶副本
					EngineMgr.uiMgr.ShowPanelByType(BattlePanelExt.PanelName);
					Mgr.zone.battleZoneBackGroundPanel.ChangeView( EnumZoneType.TYPE_JJ );
				}else if(self._data.q_id == EnumGrossipTaskType.TYPE_TEAMZONE){//组队副本
					var isOpen = BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_MINIMAP1,BtnGroupUtil.MINIMAP1_DUORENFB);
					if(isOpen)
					{
						Mgr.crossteam.RequestZoneListData();
					}
				}else if(self._data.q_id == EnumGrossipTaskType.TYPE_WORLDBOSS){//世界boss
					Mgr.uiMgr.ShowPanelByType(WorldBossPanelExt.PanelName);
				}else if(self._data.q_id == EnumGrossipTaskType.TYPE_HUSONG){//护送绿巨人
					Mgr.convoy.FlyNpc();
				}else if(self._data.q_id == EnumGrossipTaskType.TYPE_JIANGHU){//江湖英雄
                    OpenFuncUtil.OpenJianghuHero();
                }
				EngineMgr.uiMgr.HidePanelByType( TaijiPanelExt.PanelName );
			}else if(self._getType == 2){
				Mgr.tips.ShowNotice("今日已达获取上限，每日５:００重置上限！");
			}
		});
	},

    GetGossipTaskIconByType:function(type){
        var icon = null;
        switch(type){
            case EnumGrossipTaskType.TYPE_DAY:          icon = "jiangyanfuben.png";    break;
            case EnumGrossipTaskType.TYPE_GUILD:        icon = "banghui.png";    break;
            case EnumGrossipTaskType.TYPE_EXPZONE:      icon = "jiangyanfuben.png";    break;
            case EnumGrossipTaskType.TYPE_STORYZONE:    icon = "juqinfuben.png";    break;
            case EnumGrossipTaskType.TYPE_JINJIEZONE:   icon = "jinjiefuben.png";    break;
            case EnumGrossipTaskType.TYPE_TEAMZONE:     icon = "duorenfuben.png";    break;
            case EnumGrossipTaskType.TYPE_WORLDBOSS:    icon = "shijieboss.png";    break;
            case EnumGrossipTaskType.TYPE_HUSONG:       icon = "husong.png";    break;
            case EnumGrossipTaskType.TYPE_JIANGHU:      icon = "wulindahui.png";    break;
            default: break;
        }

        return icon;
    },
	UpdateState:function(){
		var num = 0;
        var val = Mgr.gossip.gossipTaskInfoHash.Get(this._data.q_id);

        this.labName.SetHtmlText(TextUtil.FormatStr( this.labName.GetHtmlText(), [
            this._data.q_name,
            val ? val.count : 0,
            val ? val.countMax : 0 ] ));

        var finished = val && val.count >= val.countMax;
        this.imgCue.visible = finished;

        // NOTE 后续需求，已经没有这些奖励了。注释，默认为1
        this._getType = 1;
        //if( Mgr.gossip.gossipRewardIds.indexOf(this._data.q_id) != -1 ){//已领奖
        //    this._getType = 2;
        //    if(!this._isGray){
        //        Filter.GrayScale(this);
        //        this._isGray = true;
        //    }
        //}else{
        //    if(num >= this._data.q_time)
        //        this._getType = 0;
        //    else
        //        this._getType = 1;
        //    if(this._isGray){
        //        Filter.UnGray(this);
        //        this._isGray = false;
        //    }
        //}
	},
	
	Dispose:function(){
		if(this._rawardCon)
			this._rawardCon.Clear();
		this._itemMid = 0;
	}
} );
TaijiFrameExt.PanelName = "TaijiFrameExt";
PanelClassDic["TaijiFrameExt"] = TaijiFrameExt;
