var TaijiPanelExt = TaijiPanel.extend ( {
	_className:"TaijiPanelExt",
	_panList:null,
	_sbtnList:null,
	_btnTypeArr:null,
	curView:0,
	activityPanel:null,
	dailyPanel:null,
	findPanel:null,
	guildPanel:null,
	jianghuPanel:null,
	_curPanel:null,
	_curBtn:null,
	goldInvestEnd:true,

	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
	},
	
	Init:function(){
		TaijiPanel.prototype.Init.call( this );
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -17;
		Mgr.gossip.taijiPanel = this;
		this.imgCue11.setVisible(false);
		this.imgCue111.setVisible(false);
		this._panList = [];

		// 注册新功能开放监听
		BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_RECHARGE,BtnGroupUtil.RECHARGE_VIP);
		BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_RECHARGE,BtnGroupUtil.RECHARGE_GOLDINVEST);
		BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_RECHARGE,BtnGroupUtil.RECHARGE_CHANGWAN);
		BtnGroupUtil.registerNewFuncOpenedCallback(this, BtnGroupUtil.M_MINIMAP1, BtnGroupUtil.MINIMAP1_SUPER_VIP);

		this.sbtnJiangli=this.sbtnZhaohuei.clone();
		this.sbtnJiangli.buttonText.SetString("奖\n励");
		this.addChild( this.sbtnJiangli );

		this.sbtnTouzi=this.sbtnZhaohuei.clone();
		this.sbtnTouzi.buttonText.SetString("投\n资");
		this.addChild( this.sbtnTouzi );

		this.sbtnChangwan=this.sbtnZhaohuei.clone();
		this.sbtnChangwan.buttonText.SetString("畅\n玩");
		this.addChild( this.sbtnChangwan );

		this.sbtnTequan=this.sbtnZhaohuei.clone();
		this.sbtnTequan.buttonText.SetString("特\n权");
		this.addChild( this.sbtnTequan );

		UIUtil.SetRedTipVisible(this.sbtnJiangli.imgCue, false);
		UIUtil.SetRedTipVisible(this.sbtnTouzi.imgCue, false);
		UIUtil.SetRedTipVisible(this.sbtnChangwan.imgCue, false);
		UIUtil.SetRedTipVisible(this.sbtnTequan.imgCue, false);

		this.sbtnJiangli.buttonText.y -= 3;
		this.sbtnTouzi.buttonText.y -= 3;
		this.sbtnChangwan.buttonText.y -= 3;
		this.sbtnTequan.buttonText.y -= 3;
		
		this.UpdateVipWarn(Mgr.vip.rewardAvailable);

		this._sbtnList = [this.sbtnRichang , this.sbtnXianshi ,this.sbtnZhaohuei, this.sbtnBanghui, this.sbtnJanghu, this.sbtnJiangli, this.sbtnTouzi, this.sbtnChangwan, this.sbtnTequan ];
		this._btnTypeArr = [EnumGrossipType.TYPE_DAY, EnumGrossipType.TYPE_ACTIVITY, EnumGrossipType.TYPE_FIND, EnumGrossipType.TYPE_GUILD, EnumGrossipType.TYPE_JIANGHU, EnumGrossipType.TYPE_JIANGLI,  EnumGrossipType.TYPE_TOUZI,
							 EnumGrossipType.TYPE_CHANGWAN,  EnumGrossipType.TYPE_TEQUAN];
		var self = this;
		for(var i=0; i < this._sbtnList.length; i++){
//			this._sbtnList[i].SetTextColor(EnumFontFormat.BTN_SELECT_COLOR);
//			this._sbtnList[i].SetTextFontSize(EnumFontFormat.CHANNEL_FONTSIZE);
			this._sbtnList[i].buttonText.y -= 2;
			this._sbtnList[i].buttonText.setPositionX(18);
			(function(j){
				self._sbtnList[j].addClickEventListener(function () {
					self.ClickBtn(self._sbtnList[j]);
				});
			})(i);
		}


		var self = this;
//		this.SetDragEnable( true );
		this.btnClose.addClickEventListener(function (event){
//			var command = "&additem 102 10";
//			Mgr.gm.SendReqGmCommandMessage( command );
			EngineMgr.uiMgr.HidePanelByType( TaijiPanelExt.PanelName );
		});
		
		this.btnJia.addClickEventListener(function (event){
			self.UseTimeItem();
		});
	},
	
	UseTimeItem:function (){
		if(Mgr.backpack.GetItemNumber(116) > 0){
			var item = ItemUtil.ItemIdToItem(116,1,1);
			ItemUtil.ShowTips(item,GridTypeEnum.BACKPACK);
		}else{
			var shopItem = Mgr.shop.GetShopItemByMid(116, EnumShopType.GOLD_SHOP);
			if( shopItem ){
				var buyPanel = Mgr.uiMgr.ShowPanelByType(BuyPanelExt.PanelName, UIMgr.PANEL_LAYER_POP);
				shopItem.shopNum = 1;
				buyPanel.SetData(shopItem);
			}
		}
	},

	ClickBtn:function ( btn ){
		if( btn == this.sbtnRichang ){
			this.ChangeView( EnumGrossipType.TYPE_DAY );
		}else if( btn == this.sbtnXianshi ){
			this.ChangeView( EnumGrossipType.TYPE_ACTIVITY );
		}else if( btn == this.sbtnZhaohuei ){
			this.ChangeView(  EnumGrossipType.TYPE_FIND );
		}else if(btn == this.sbtnBanghui){
			this.ChangeView(EnumGrossipType.TYPE_GUILD);
		}else if(btn == this.sbtnJanghu){
			this.ChangeView(EnumGrossipType.TYPE_JIANGHU);
		}else if(btn == this.sbtnJiangli){
			this.ChangeView(EnumGrossipType.TYPE_JIANGLI);
		}else if(btn == this.sbtnTouzi){
			this.ChangeView(EnumGrossipType.TYPE_TOUZI);
		}else if(btn == this.sbtnChangwan){
			this.ChangeView(EnumGrossipType.TYPE_CHANGWAN);
		}else if(btn == this.sbtnTequan){
			this.ChangeView(EnumGrossipType.TYPE_TEQUAN);
		}
	},
	ChangeView:function ( index ){
		if(index == this.curView)
			return;
		this.curView = index;
		if( this._curPanel )
			this._curPanel.OnHide();
		if( this._curBtn )
			this._curBtn.SetButtonState("uncheck");
		this.imgBg.removeAllChildren(false);
		this.imgDikuang.setVisible(false);
		this.imgDikuang1.setVisible(false);
		this.imgXian.visible = true;
		var imageRes = "";
		switch(index){
			case EnumGrossipType.TYPE_ACTIVITY:
				if( this.activityPanel == null ){
					this.activityPanel = new TaijiActivitiesMainExt();
					this.activityPanel.LoadPanel();
					this.activityPanel.retain();
					this.activityPanel.InitPanel();
					this.activityPanel.x = 0;
					this.activityPanel.y = 0;
				}
				this._curPanel = this.activityPanel;
				this._curBtn = this.sbtnXianshi;
				this.imgDikuang.setVisible(true);
				this.imgDikuang1.setVisible(false);
				imageRes = "other/richangrenwu/word/xianshihuodong.png";
				break;
			case EnumGrossipType.TYPE_DAY:
				if( this.dailyPanel == null ){
					this.dailyPanel = new TaijiMainExt();
					this.dailyPanel.LoadPanel();
					this.dailyPanel.retain();
					this.dailyPanel.InitPanel();
					this.dailyPanel.x = 0;
					this.dailyPanel.y = 0;
				}
				this._curPanel = this.dailyPanel;
				this._curBtn = this.sbtnRichang;
				this.imgDikuang.setVisible(true);
				this.imgDikuang1.setVisible(true);
				imageRes = "other/richangrenwu/word/vipshengji.png";
				break;
			case EnumGrossipType.TYPE_FIND:
				if( this.findPanel == null ){
					this.findPanel = new TaijiZhaohueiMainExt();
					this.findPanel.LoadPanel();
					this.findPanel.retain();
					this.findPanel.InitPanel();
					this.findPanel.x = 0;
					this.findPanel.y = 0;
				}
				this._curPanel = this.findPanel;
				this._curBtn = this.sbtnZhaohuei;
				imageRes = "other/richangrenwu/word/ziyuanzhaohui.png";
				break;
			case EnumGrossipType.TYPE_GUILD:
				if( this.guildPanel == null){
					this.guildPanel = new BanghuiZhengbaMainExt();
					this.guildPanel.LoadPanel();
					this.guildPanel.retain();
					this.guildPanel.x = 0;
					this.guildPanel.y = 15;
				}
				this._curPanel = this.guildPanel;
				this._curBtn = this.sbtnBanghui;
				imageRes = "other/richangrenwu/word/banghuizhengba.png";
				break;
			case EnumGrossipType.TYPE_JIANGHU:
				if( this.jianghuPanel == null){
					this.jianghuPanel = new jianghuyingxiongbangExt();
					this.jianghuPanel.LoadPanel();
					this.jianghuPanel.retain();
					this.jianghuPanel.x = 0;
					this.jianghuPanel.y = 200;
				}
				this._curPanel = this.jianghuPanel;
				this._curBtn = this.sbtnJanghu;
				imageRes = "other/richangrenwu/word/jianghuyingxiongbang.png";
				break;
			case EnumGrossipType.TYPE_TOUZI:
				if ( !this.touziPanel ) {
					var panel = new GoldenInvestPanelExt();
					panel.LoadPanel();
					panel.retain();
					panel.x = 0;
					panel.y = -10;
					this.touziPanel = panel;
				}

				this._curPanel = this.touziPanel;
				this._curBtn = this.sbtnTouzi;
				imageRes = "other/touzi/word/yuanbaotouzi.png";
				break;
			case EnumGrossipType.TYPE_CHANGWAN:
				if ( !this.changwanPanel ) {
					var panel = new MonthCardInvestPanelExt();
					panel.LoadPanel();
					panel.retain();
					panel.x = 0;
					panel.y = -10;
					this.changwanPanel = panel;
				}
				this._curPanel = this.changwanPanel;
				this._curBtn = this.sbtnChangwan;
				imageRes = "other/touzi/word/yuekatouzi.png";
				break;
			case EnumGrossipType.TYPE_JIANGLI:
				if ( !this.vipPanel ) {
					var panel = new VipInfoPanelExt();
					panel.LoadPanel();
					panel.retain();
					panel.x = 0;
					panel.y = 0;
					this.vipPanel = panel;
				}
				this.imgXian.visible = false;
				this._curPanel = this.vipPanel;
				this._curBtn = this.sbtnJiangli;
				imageRes = "other/touzi/word/vip.png";
				break;
			case EnumGrossipType.TYPE_TEQUAN:
				if ( !this.tequanPanel ) {
					var panel = new TeQuanPanelExt();
					panel.LoadPanel();
					panel.retain();
					panel.x = 0;
					panel.y = -30;
					this.tequanPanel = panel;
				}
				this._curPanel = this.tequanPanel;
				this._curBtn = this.sbtnTequan;
				imageRes = "other/zhizuntequan/word/zhizuntequan.png";
				break;
			default:
				this._curPanel = null;
				break;
		}

		if(this._curPanel != null){
			this.imgBg.addChild(this._curPanel );
			this._curPanel.OnShow();
		}
		if( this._curBtn != null ){
			this._curBtn.SetButtonState("check");
		}
		UIUtil.LoadImage( this.imgTitle, imageRes );
		
//		this._ShowOrHideListview();
	},
//	_ShowOrHideListview:function()
//	{
//		for ( var i = 0; i < this._sbtnList.length; i++ )
//		{
//			if ( this.curView == this._btnTypeArr[i] )
//			{
//				this._sbtnList[i].SetTextColor(EnumFontFormat.BTN_SELECT_COLOR);
//				this._sbtnList[i].SetTextFontSize(EnumFontFormat.CHANNEL_FONTSIZE);
////				this._sbtnList[i].SetEnableOutline(EnumFontFormat.BTN_SELECT_MIAOBIAN_COLOR,EnumFontFormat.MIAOBIAN_SIZE);
//				this._sbtnList[i].buttonText.setPositionY(15);
//				this._sbtnList[i].buttonText.setPositionX(15);
//			}
//			else
//			{
//				this._sbtnList[i].SetTextColor(EnumFontFormat.BTN_NORMAL_COLOR);
//				this._sbtnList[i].SetTextFontSize(EnumFontFormat.CHANNEL_FONTSIZE);
////				this._sbtnList[i].SetEnableOutline(EnumFontFormat.BTN_NORMAL_MIAOBIAN_COLOR,EnumFontFormat.MIAOBIAN_SIZE);
//				this._sbtnList[i].buttonText.setPositionY(15);
//				this._sbtnList[i].buttonText.setPositionX(15);
//			}
//		}
//	},

	UpdateView:function(index){
		if( this.curView == index ){
			this._curPanel.UpdateView();
		}
	},

	UpdateTime:function(){
		this.labTime.SetHtmlText(TextUtil.FormatStr( this.labTime.GetHtmlText(), [ TextUtil.SecondToHMS2( Mgr.player._exitRemainTime ) ] ));
	},
	
	ShowType:function(type){
		this._curType = type;

		var showType;
		if(type == EnumGrossipType.TYPE_DAY){
			showType = [EnumGrossipType.TYPE_DAY, EnumGrossipType.TYPE_JIANGLI,  EnumGrossipType.TYPE_TOUZI, EnumGrossipType.TYPE_CHANGWAN,  EnumGrossipType.TYPE_TEQUAN];
			Mgr.bank.SendReqBankInfoToGameMessage(1);//等级投资
			Mgr.bank.SendReqBankInfoToGameMessage(2);//月投资
		}else if(type == EnumGrossipType.TYPE_ACTIVITY || type == EnumGrossipType.TYPE_FIND || type == EnumGrossipType.TYPE_GUILD || type == EnumGrossipType.TYPE_JIANGHU){
			showType = [EnumGrossipType.TYPE_ACTIVITY, EnumGrossipType.TYPE_FIND, EnumGrossipType.TYPE_GUILD, EnumGrossipType.TYPE_JIANGHU];
			this.sbtnXianshi.setVisible(true);
			this.sbtnJanghu.setVisible(true);
			this.sbtnBanghui.setVisible(true);
			this.sbtnZhaohuei.setVisible(true);
		}
		for( var i = 0; i < this._btnTypeArr.length; i++ ){
			if( showType.indexOf(this._btnTypeArr[i]) != -1){
				var main = BtnGroupUtil.M_TAIJI;
				var sub = BtnGroupUtil.TAIJI_TAIJI;
				switch(this._btnTypeArr[i]){
					case EnumGrossipType.TYPE_FIND:				main = BtnGroupUtil.M_TAIJI; sub = BtnGroupUtil.TAIJI_RESBACK;break;
					case EnumGrossipType.TYPE_JIANGLI:         main = BtnGroupUtil.M_RECHARGE; sub = BtnGroupUtil.RECHARGE_VIP;break;
					case EnumGrossipType.TYPE_TOUZI:  			main = BtnGroupUtil.M_RECHARGE; sub = BtnGroupUtil.RECHARGE_GOLDINVEST;break;
					case EnumGrossipType.TYPE_CHANGWAN:     	main = BtnGroupUtil.M_RECHARGE; sub = BtnGroupUtil.RECHARGE_CHANGWAN;break;
					case EnumGrossipType.TYPE_TEQUAN:   		main = BtnGroupUtil.M_MINIMAP1; sub = BtnGroupUtil.MINIMAP1_SUPER_VIP;break;
					case EnumGrossipType.TYPE_GUILD:
					case EnumGrossipType.TYPE_JIANGHU:			main = BtnGroupUtil.MINIMAP3_MAP; sub = BtnGroupUtil.MINIMAP3_ZHANCHANGDATING;break;
				}
				this._sbtnList[i].visible = BtnGroupUtil.IsFunctionOpen(main, sub) && ( this._btnTypeArr[i] != EnumGrossipType.TYPE_TOUZI || !this.goldInvestEnd);
			}
			else{
				this._sbtnList[i].visible = false;
			}
		}

		this.ChangeView( type );
		this.ResetPos();
	},

	UpdateTouziBtn:function(){
		this.sbtnTouzi.visible = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_RECHARGE, BtnGroupUtil.RECHARGE_GOLDINVEST) && !this.goldInvestEnd;
		this.ResetPos();
	},

	UpdateVipWarn:function(bool){
		UIUtil.SetRedTipVisible(this.sbtnJiangli.imgCue, bool);
	},
	UpdateGoldWarn:function(bool){
		UIUtil.SetRedTipVisible(this.sbtnTouzi.imgCue, bool);
	},
	UpdateMonthWarn:function(bool){
		UIUtil.SetRedTipVisible(this.sbtnChangwan.imgCue, bool);
	},

	OnNewFuncOpened:function(main,sub){
		this.ShowType(this._curType);
	},
	OnNewFuncOpenedAndChangePanel:function(main,sub){
		if(!main || ! sub) return;
		var type
		switch(main){
			case BtnGroupUtil.M_RECHARGE:
				switch(sub){
					case BtnGroupUtil.RECHARGE_VIP:         type = EnumGrossipType.TYPE_JIANGLI;break;
					case BtnGroupUtil.RECHARGE_GOLDINVEST:  type = EnumGrossipType.TYPE_TOUZI;break;
					case BtnGroupUtil.RECHARGE_CHANGWAN:    type = EnumGrossipType.TYPE_CHANGWAN;break;
					case BtnGroupUtil.MINIMAP1_SUPER_VIP:   type = EnumGrossipType.TYPE_TEQUAN;break;
				}
				break;
		}

		if(!type) return;
		this.ChangePanel(type);
	},

    ResetPos:function () {
        var arr = [];
        for(var i = 0; i < this._sbtnList.length; i++){
            var btn = this._sbtnList[i];
            if(btn.visible){
                arr.push(btn);
            }
        }
        for(var ii = 0; ii < arr.length; ii++)
        {
            arr[ii].y = this._sbtnList[ii].initY;
        }
    },
	
	UpdataFindRedCircle:function(){
		this.imgCue.setVisible(Mgr.offlineres.canFind);
	},
	
	UpdateDaylyCircle:function(){
		UIUtil.SetRedTipVisible( this.imgCue1, Mgr.gossip.canUpTaiji);
		Mgr.player.shortPanel.UpDataTaijizhengWarn();
	},

	OnShow:function(){
//		this.ChangeView(EnumGrossipType.TYPE_DAY);
		this.UpdateTime();
		// this.ResetPos();
		//刷新按钮可找回红圈，需要获取活动信息
		// Mgr.gossip.SendReqGossipInfoMessage();
		Mgr.offlineres.SendReqOpenOfflineResPanelMessage();
	},
	
	OnHide:function(){
		this._super();
		if(this._curPanel != null){
			this._curPanel.OnHide();
		}
		this.curView = 0;
	}
} );
TaijiPanelExt.PanelName = "TaijiPanelExt";
PanelClassDic["TaijiPanelExt"] = TaijiPanelExt;
