var TaijiZhaohueiMainExt = TaijiZhaohueiMain.extend ( {
	_className:"TaijiZhaohueiMainExt",
	_activeRawardItemArr:null,
	_activeRawardItemWaveArr:null,
	_startRewardIndex:0,
	_scrollRewardView:null,
	_rewardCellNum:10,//显示cell个数
	cellW:0,
	cellH:0,
	_rawardWaveArr:null,
	_listLen:0,//活动总条数
	_activeList:null,
	_activeDataHash:null,
	_costType:1,
	_showLen:0,
	_oldBeginIndex:0,
	_realLen:0,
	ctor:function(){
		this._super();
	},

	Init:function(){
		TaijiZhaohueiMain.prototype.Init.call( this );
	},

	RegisterListeners:function(){
		var self = this;
		
		this.sbtnGouxuan1.addClickEventListener(function () {
			self.UpdateCost();
		});
		
		this.sbtnGouxuan.addClickEventListener(function () {
//			var msg = new ReqGmCommandMessage();
//			msg.command = "&CLEARRES";
//			Mgr.msgMgr.Send(msg);
			self.UpdateCost();
		});
	},
	
	UpdateCost:function(){
		var oldtype = this._costType;
		this._costType = (this.sbtnGouxuan1.GetState() == "check" ? 1 : 0);
		if( oldtype != this._costType )
			this.UpdateData();
	},

	InitPanel:function(){
		this._activeRawardItemArr = [];
		this._activeRawardItemWaveArr = [];
		this.InitPageView();
		this.RegisterListeners();
	},

	InitPageView:function(){
		this._scrollRewardView = ccui.ScrollView();
		this._scrollRewardView.setDirection(ccui.ScrollView.DIR_VERTICAL);
		this._scrollRewardView.setTouchEnabled(true);
		this._scrollRewardView.inertiaScrollEnabled=false;
		this._scrollRewardView.setScrollBarEnabled(false);
		this._scrollRewardView.setBounceEnabled(true);
		this.imgBg.addChild(this._scrollRewardView);
	},

	_GetRawardCell:function (wave, right) {
		var rawardcell = null;
		if( this._activeRawardItemWaveArr.length >= (this._rewardCellNum+3) ){
			if(right){
				rawardcell = this._activeRawardItemArr.shift();
				this._activeRawardItemWaveArr.shift();
			}else{
				rawardcell = this._activeRawardItemArr.pop();
				this._activeRawardItemWaveArr.pop();
			}
		}else{
			var cell = new TaijiZhaohueiFrameExt();
			cell.LoadPanel();
			cell.retain();
//			cell.Init();
			this._scrollRewardView.addChild(cell);
			rawardcell = cell;
		}
		if(right){
			this._activeRawardItemArr.push(rawardcell);
			this._activeRawardItemWaveArr.push(wave);
		}else{
			this._activeRawardItemArr.unshift(rawardcell);
			this._activeRawardItemWaveArr.unshift(wave);
		}
		this._oldBeginIndex = this._rawardWaveArr.indexOf(this._activeRawardItemWaveArr[0]);
		return rawardcell;
	},

	_oldper:0,
	SetDate:function () {
		if(!Mgr.offlineres.activeDataHash)
			return;
		this._activeList = Mgr.offlineres.activeDataHash.Values();
		this._listLen = this._activeList.length;
        if(this._listLen)
        	this.labCue11.visible = false;
        else
            this.labCue11.visible = true;
		var oldShowLen = this._showLen;
		// this._showLen = Math.min(this._rewardCellNum, this._listLen);
        this._showLen = this._listLen;
		var posLen = Math.max(this._rewardCellNum, this._listLen);
//		if( !Mgr.offlineres.activeDataHash ){
//			this._activeRawardItemArr = [];
//			this._activeRawardItemWaveArr = [];
//			Mgr.offlineres.activeDataHash = new HashMap();
//		}
		this._rawardWaveArr = [];
		for( var i = 0; i < this._listLen; i++ )
		{
			this._rawardWaveArr.push(this._activeList[ i ].type);
//			Mgr.offlineres.activeDataHash.Put(this._activeList[ i ].type, this._activeList[ i ]);
		}
		this._rawardWaveArr = this._rawardWaveArr.sort(this.ShortGossipIds);
		this._realLen = (this._activeList.length % 2 == 1 ? this._activeList.length + 1 : this._activeList.length);
		if( oldShowLen < this._showLen){
			for( var i = 0; i < this._listLen; i++ )
			{
				if(oldShowLen + i < this._showLen){
					var activeItem = this._GetRawardCell(this._rawardWaveArr[oldShowLen + i],true);
					if(this.imgBg.height > (activeItem.height+7) * Math.ceil(this._listLen / 2))
						activeItem.y = this.imgBg.height + parseInt(( - oldShowLen - i - 2) / 2) * (activeItem.height+7);
					else
						activeItem.y = parseInt((this._realLen - oldShowLen - i - 1) / 2) * (activeItem.height+7);
					activeItem.x = i % 2 * (activeItem.width+7);
					this.cellW = activeItem.width;
					this.cellH = activeItem.height;
				}
			}
		}
		if(this._oldper == 0){
			this._oldper = 1;
			
			this._scrollRewardView.setSize(cc.size(this.cellW*2+14, this.imgBg.height));
			
			this._scrollRewardView.setInnerContainerSize(cc.size(this.cellW*2+14, Math.max(this.imgBg.height, (this.cellH+7) * Math.ceil(this._realLen / 2))));
			var self = this;

			// this._scrollRewardView.addCCSEventListener(function () {
			// 	self.UpdateProgBar(self);
			// });
		}

		this.UpdateData();
	},
	
	SetOneDate:function (id) {
//		var data = Mgr.offlineres.activeDataHash.Get(id);
//		data.count = data.count - 1;
//		Mgr.offlineres.activeDataHash.Put(id, data);
		this.UpdateData();
	},

	UpdateData:function(){
		this._rawardWaveArr = this._rawardWaveArr.sort(this.ShortGossipIds);
		var self = this;
		for(var i = 0; i < this._activeRawardItemWaveArr.length; i++){
			this._activeRawardItemWaveArr[i] = this._rawardWaveArr[ this._oldBeginIndex + i ];
			this._activeRawardItemArr[i].SetActivity( Mgr.offlineres.activeDataHash.Get(this._activeRawardItemWaveArr[i]) );
		}
		this._oldBeginIndex = this._rawardWaveArr.indexOf(this._activeRawardItemWaveArr[0]);
	},

	ShortGossipIds:function(p1,p2) {
		var data1 = Mgr.offlineres.activeDataHash.Get(p1);
		var data2 = Mgr.offlineres.activeDataHash.Get(p2);
		if (p1 < p2){
			if( data1.count <= 0){
				if( data2.count <= 0){
					return -1;
				}else{
					return 1;
				}
			}else{
				if( data2.count <= 0){
					return -1;
				}else{
					return -1;
				}
			}
		}
		else if (p1 == p2)
			return 0;
		else{
			if( data1.count <= 0){
				if( data2.count <= 0){
					return 1;
				}else{
					return 1;
				}
			}else{
				if( data2.count <= 0){
					return -1;
				}else{
					return 1;
				}
			}
		}
	},

	UpdateProgBar:function(){
		var isDown = false;
		var index = -1;
		var oldStarRawardIndex = this._startRewardIndex;
		var barH = (parseInt(this._listLen/2) * this.cellH - 366 + this._scrollRewardView.getInnerContainerPosition().y);
		this._startRewardIndex = barH/this.cellH*2;
		if( this._startRewardIndex < oldStarRawardIndex ){
			index = Math.max(Math.ceil(this._startRewardIndex), 0)-1;
			if( index%2 == 1 )
				index -= 1;
			isDown = false;
		}else if( this._startRewardIndex > oldStarRawardIndex ){
			index = Math.floor(this._startRewardIndex)+this._rewardCellNum+1;
			if( index%2 == 0 )
				index -= 1;
			isDown = true;
		}
		var beginAddIndex = -1;
		var targetIndex = -2;
		if( isDown ){
			var nowLastIndex = this._rawardWaveArr.indexOf(this._activeRawardItemWaveArr[this._activeRawardItemWaveArr.length-1]);
			if( index > nowLastIndex+1 ){
				beginAddIndex = nowLastIndex + 1;
				targetIndex = index;
			}
			for( beginAddIndex; beginAddIndex <= targetIndex; beginAddIndex++){
				if( beginAddIndex > -1 && this._rawardWaveArr[beginAddIndex] && this._activeRawardItemWaveArr.indexOf(this._rawardWaveArr[beginAddIndex]) == -1 ){
					var cell = this._GetRawardCell(this._rawardWaveArr[beginAddIndex],isDown);
					cell.SetActivity(Mgr.offlineres.activeDataHash.Get(this._rawardWaveArr[beginAddIndex]));
					cell.x = beginAddIndex % 2 * (cell.width+7);
					cell.y = parseInt((this._realLen - beginAddIndex - 1) / 2) * (cell.height+7);
				}
			}
		}
		else{
			var nowFirstIndex = this._rawardWaveArr.indexOf(this._activeRawardItemWaveArr[0]);
			if( index < nowFirstIndex-1 && index >= 0 ){
				beginAddIndex = index;
				targetIndex = nowFirstIndex - 1;
			}
			for( targetIndex; targetIndex >= beginAddIndex; targetIndex--){
				if( beginAddIndex > -1 && this._rawardWaveArr[targetIndex] && this._activeRawardItemWaveArr.indexOf(this._rawardWaveArr[targetIndex]) == -1 ){
					var cell = this._GetRawardCell(this._rawardWaveArr[targetIndex],isDown);
					cell.SetActivity(Mgr.offlineres.activeDataHash.Get(this._rawardWaveArr[targetIndex]));
					cell.x = beginAddIndex % 2 * (cell.width+7);
					cell.y = parseInt((tempLen - targetIndex - 1) / 2) * (cell.height+7);
				}
			}
		}
	},

	OnShow:function(){
		Mgr.offlineres.SendReqOpenOfflineResPanelMessage();
		this.SetDate();
//		this.UpdateData();
	},
	
	OnHide:function(){
		this._super();
		for(var i = 0; i < this._activeRawardItemWaveArr.length; i++){
			this._activeRawardItemArr[i].Dispose();
		}
	}
} );
TaijiZhaohueiMainExt.PanelName = "TaijiZhaohueiMainExt";
PanelClassDic["TaijiZhaohueiMainExt"] = TaijiZhaohueiMainExt;
