///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//GuildInfo 帮会信息
//GuildConfig 帮会配置
//MemberInfo 成员信息
//EventInfo 事件信息
//ApplyPlayerInfo 申请入会信息
//GuildBossAwardInfo 帮会boss奖励信息
//GuildSkillInfo 帮会技能
//AnswerRankInfo 答题排名

// 请求消息
//111201,ReqGuildCreate 创建公会
//111203,ReqGuildGetGuildList 获取帮会列表
//111204,ReqGuildApplyAdd 申请加入帮会
//111205,ReqGuildInviteAdd 邀请加入帮会
//111206,ReqGuildGetMemberList 获取成员列表
//111207,ReqGuildAddMember 添加帮会成员
//111208,ReqGuildQuit 退出帮会
//111210,ReqGuildChangePowerLevel 修改职权
//111211,ReqGuildDeleteMember 删除帮会成员
//111212,ReqGuildConfig 修改帮会设置
//111213,ReqGuildChangeAnnouncement 修改公告
//111214,ReqGuildDeleteGuild 解散帮会
//111215,ReqGuildGetEventList 获取帮会事件列表
//111216,ReqUpdateGuildInfo 请求刷新guildInfo
//111217,ReqApplyList 请求申请入帮列表
//111218,ReqLevelUpGuild 请求升级帮会
//111219,ReqChangeGuildFlag 请求更换帮旗
//111220,ReqAgreeInvite 同意帮会邀请
//111222,ReqGuildAutoDistribution 修改帮会boss分配机制设置
//111223,ReqGuildForbiddenBossInfo 请求帮会禁地boss信息
//111225,ReqGuildEnterForbidden 请求进入禁地
//111226,ReqRefreshGuildForbiddenBoss 请求召唤禁地boss
//111227,ReqDispatchItem 分配奖励
//111228,ReqGuildSkillInfo 请求帮会技能信息
//111229,ReqGuildSkillLevelUp 请求升级帮会技能信息
//111230,ReqWelfareState 请求帮会福利领取状态
//111231,ReqWelfareRewardState 请求领取帮会福利奖励
//111235,ReqGuildAnswerDailyReward 请求领取帮会答题日常奖励
//111236,ReqGuildAnswerQuestion 请求回答问题（暂时给语音答题留的接口）
//111301,ReqSendGuildStoreItems 请求帮会仓库列表
//111302,ReqDevoteItem 物品存入仓库
//111303,ReqExchangeItem 兑换物品
//111304,ReqGuildDeleteItem 删除物品
//111237,ReqGuildBossZhaoHuanToGame 提醒帮主副帮主召唤BOSS

// 接收消息
//111101,ResGuildGetGuildListToClient 获取帮会列表返回
//111102,ResGuildApplyAdd 申请加入帮会发给帮会操作人
//111103,ResGuildInviteAdd 邀请加入帮会发给被操作玩家
//111104,ResGuildGetMemberList 获取成员列表返回
//111105,ResGuildGetEventList 获取帮会事件列表返回
//111106,ResGuildGuildInfo 发送单独帮会信息给客户端
//111108,ResGuildHandleResult 帮会操作结果反馈
//111109,ResNoticeGuildBossApply 通知帮主副帮主有新的申请
//111110,ResRoundGuildChange 广播周围玩家帮会信息变化
//111111,ResGuildForbiddenBossInfo 返回帮会禁地boss信息
//111113,ResGuildForbiddenDamageInfo 返回禁地BOSS伤害信息
//111114,ResGuildForbiddenZonePanelInfo 返回禁地BOSS副本追踪面板信息
//111115,ResGuildForbiddenZoneRewardInfo 返回禁地BOSS副本在线奖励信息
//111116,ResBroadcastGuildForbiddenBossRefresh 广播禁地boss召唤
//111117,ResGuildBossAwardList 帮会boss奖励
//111118,ResGuildDeleteCountdownTime 广播工会删除倒计时信息
//111119,ResGuildSkillInfo 返回帮会技能信息
//111120,ResGuildSkillLevelUpResult 返回帮会技能升级结果
//111121,ResWelfareState 返回帮会福利状态
//111126,ResGuildAnswerDailyReward 可以领取日常奖励（活动期间计入地图发送 收到此消息说明可以领奖励）
//111129,ResGuildAnswerRank 答题排名信息
//111127,ResRoundGuildAnnouncementChange 广播帮会公告改变
//111128,ResRejectApplicationGuildToPlayer 工会拒绝玩家申请入帮操作给玩家
//111401,ResSendGuildStoreInfo 发送帮会仓库物品信息
//111402,ResGuildItemAdd 物品信息增加
//111403,ResGuildItemChange 物品信息修正
//111404,ResGuildItemRemove 物品删除
//111130,ResGuildBossZhaoHuanToClient 提醒帮主副帮主召唤BOSS


var GuildInfo = cc.Class.extend({
	ctor:function(){
		this.guildId = null; // 帮会id
        this.guildName = null; // 帮会名
        this.isImperialGuild = 0; // 0不是1是
        this.guildFlagId = 0; // 帮旗Id
        this.bangZhuid = null; // 帮主id
        this.bangZhuName = null; // 帮主名字
        this.bangZhuLevel = 0; // 帮主等级
        this.bangZhuOnline = 0; // 帮主是否在线
        this.guildAnnouncement = null; // 帮会公告
        this.guildAnnouncementTime = 0; // 帮会公告最后更新时间
        this.memberNum = 0; // 成员数量
        this.memberFightPower = 0; // 成员战斗力之和
        this.createTime = 0; // 帮会创建时间
        this.exp = 0; // 帮会经验
        this.level = 0; // 帮会等级
        this.autoJoin = 0; // 是否允许自动加入
        this.fieldCount = 0; // 领地数量
	},

	writing:function( _buf ){
		_buf.WriteLong(this.guildId);
        _buf.WriteString(this.guildName);
        _buf.WriteByte(this.isImperialGuild);
        _buf.WriteVarInt(this.guildFlagId);
        _buf.WriteLong(this.bangZhuid);
        _buf.WriteString(this.bangZhuName);
        _buf.WriteVarInt(this.bangZhuLevel);
        _buf.WriteByte(this.bangZhuOnline);
        _buf.WriteString(this.guildAnnouncement);
        _buf.WriteVarInt(this.guildAnnouncementTime);
        _buf.WriteVarInt(this.memberNum);
        _buf.WriteVarLong(this.memberFightPower);
        _buf.WriteVarInt(this.createTime);
        _buf.WriteVarInt(this.exp);
        _buf.WriteVarInt(this.level);
        _buf.WriteByte(this.autoJoin);
        _buf.WriteVarInt(this.fieldCount);
	},
	
	reading:function( _buf ){
		this.guildId = _buf.ReadLong();
        this.guildName = _buf.ReadString();
        this.isImperialGuild = _buf.ReadByte();
        this.guildFlagId = _buf.ReadVarInt();
        this.bangZhuid = _buf.ReadLong();
        this.bangZhuName = _buf.ReadString();
        this.bangZhuLevel = _buf.ReadVarInt();
        this.bangZhuOnline = _buf.ReadByte();
        this.guildAnnouncement = _buf.ReadString();
        this.guildAnnouncementTime = _buf.ReadVarInt();
        this.memberNum = _buf.ReadVarInt();
        this.memberFightPower = _buf.ReadVarLong();
        this.createTime = _buf.ReadVarInt();
        this.exp = _buf.ReadVarInt();
        this.level = _buf.ReadVarInt();
        this.autoJoin = _buf.ReadByte();
        this.fieldCount = _buf.ReadVarInt();
	},
});
var GuildConfig = cc.Class.extend({
	ctor:function(){
		this.autoJoin = 0; // 帮会自动加入
        this.vipAutoJoin = 0; // vip自动加入
        this.levelLimit = 0; // 加入等级限制
        this.autoDistribution = 0; // 自动分配帮会BOSS奖励（0手动 1自动）
	},

	writing:function( _buf ){
		_buf.WriteByte(this.autoJoin);
        _buf.WriteByte(this.vipAutoJoin);
        _buf.WriteVarInt(this.levelLimit);
        _buf.WriteByte(this.autoDistribution);
	},
	
	reading:function( _buf ){
		this.autoJoin = _buf.ReadByte();
        this.vipAutoJoin = _buf.ReadByte();
        this.levelLimit = _buf.ReadVarInt();
        this.autoDistribution = _buf.ReadByte();
	},
});
var MemberInfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 玩家id
        this.job = 0; // 职业
        this.viplevel = 0; // vip等级
        this.platVip = 0; // 平台vip等级
        this.tencentDomain = 0; // 腾讯登录渠道
        this.playerName = null; // 玩家名
        this.mapModelId = 0; // 所在地图Id
        this.level = 0; // 玩家等级
        this.guildPowerLevel = 0; // 帮会职位等级 0 帮主 1 副帮主 2精英 127帮众
        this.addTime = 0; // 入会时间
        this.lastOnlineTime = 0; // 上次在线时间
        this.fightPower = 0; // 战斗力
        this.isOnline = 0; // 是否在线
        this.devoteValue = 0; // 自己贡献度(非货币！只做记录)
        this.onlineRate = 0; // 在线率(每个月在线天数除以30获得的值)
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteByte(this.job);
        _buf.WriteByte(this.viplevel);
        _buf.WriteVarInt(this.platVip);
        _buf.WriteVarInt(this.tencentDomain);
        _buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.mapModelId);
        _buf.WriteVarInt(this.level);
        _buf.WriteByte(this.guildPowerLevel);
        _buf.WriteVarInt(this.addTime);
        _buf.WriteVarInt(this.lastOnlineTime);
        _buf.WriteVarLong(this.fightPower);
        _buf.WriteByte(this.isOnline);
        _buf.WriteVarInt(this.devoteValue);
        _buf.WriteVarInt(this.onlineRate);
	},
	
	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.job = _buf.ReadByte();
        this.viplevel = _buf.ReadByte();
        this.platVip = _buf.ReadVarInt();
        this.tencentDomain = _buf.ReadVarInt();
        this.playerName = _buf.ReadString();
        this.mapModelId = _buf.ReadVarInt();
        this.level = _buf.ReadVarInt();
        this.guildPowerLevel = _buf.ReadByte();
        this.addTime = _buf.ReadVarInt();
        this.lastOnlineTime = _buf.ReadVarInt();
        this.fightPower = _buf.ReadVarLong();
        this.isOnline = _buf.ReadByte();
        this.devoteValue = _buf.ReadVarInt();
        this.onlineRate = _buf.ReadVarInt();
	},
});
var EventInfo = cc.Class.extend({
	ctor:function(){
		this.eventId = null; // 事件id
        this.messageTime = 0; // 消息时间
        this.messageType = null; // 消息类型
        this.message = null; // 消息内容
	},

	writing:function( _buf ){
		_buf.WriteLong(this.eventId);
        _buf.WriteVarInt(this.messageTime);
        _buf.WriteString(this.messageType);
        _buf.WriteString(this.message);
	},
	
	reading:function( _buf ){
		this.eventId = _buf.ReadLong();
        this.messageTime = _buf.ReadVarInt();
        this.messageType = _buf.ReadString();
        this.message = _buf.ReadString();
	},
});
var ApplyPlayerInfo = cc.Class.extend({
	ctor:function(){
		this.applyerId = null; // 申请人Id
        this.applyerName = null; // 申请人名字
        this.applyerLevel = 0; // 申请人等级
        this.fightPower = 0; // 申请人战斗力
        this.applyTime = null; // 申请时间
	},

	writing:function( _buf ){
		_buf.WriteLong(this.applyerId);
        _buf.WriteString(this.applyerName);
        _buf.WriteVarInt(this.applyerLevel);
        _buf.WriteVarLong(this.fightPower);
        _buf.WriteLong(this.applyTime);
	},
	
	reading:function( _buf ){
		this.applyerId = _buf.ReadLong();
        this.applyerName = _buf.ReadString();
        this.applyerLevel = _buf.ReadVarInt();
        this.fightPower = _buf.ReadVarLong();
        this.applyTime = _buf.ReadLong();
	},
});
var GuildBossAwardInfo = cc.Class.extend({
	ctor:function(){
		this.uniqueId = null; // 唯一id
        this.monsterModel = 0; // 怪物Model
        this.remainTime = 0; // 剩余时间(秒)
        this.bossType = 0; // boss类型(0世界 1副本)
        this.damageInfoList = []; // 伤害列表 BossDamageInfo
        this.itemList = []; // 奖励列表 TempItemInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteVarInt(this.monsterModel);
        _buf.WriteVarInt(this.remainTime);
        _buf.WriteByte(this.bossType);
        _buf.WriteShort( this.damageInfoList.length );
        for (var i = 0; i < this.damageInfoList.length; i++) {
            _buf.WriteBean(this.damageInfoList[i]);
        }
        _buf.WriteShort( this.itemList.length );
        for (var i = 0; i < this.itemList.length; i++) {
            _buf.WriteBean(this.itemList[i]);
        }
	},
	
	reading:function( _buf ){
		this.uniqueId = _buf.ReadLong();
        this.monsterModel = _buf.ReadVarInt();
        this.remainTime = _buf.ReadVarInt();
        this.bossType = _buf.ReadByte();
        var damageInfoList_length = _buf.ReadShort();
        for (var i = 0; i < damageInfoList_length; i++) {
            this.damageInfoList[i] = _buf.ReadBean(BossDamageInfo);
        }
        var itemList_length = _buf.ReadShort();
        for (var i = 0; i < itemList_length; i++) {
            this.itemList[i] = _buf.ReadBean(TempItemInfo);
        }
	},
});
var GuildSkillInfo = cc.Class.extend({
	ctor:function(){
		this.skillModel = 0; // modelId
        this.level = 0; // 等级
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModel);
        _buf.WriteVarInt(this.level);
	},
	
	reading:function( _buf ){
		this.skillModel = _buf.ReadVarInt();
        this.level = _buf.ReadVarInt();
	},
});
var AnswerRankInfo = cc.Class.extend({
	ctor:function(){
		this.playerName = null; // 玩家名
        this.num = 0; // 答对数量
	},

	writing:function( _buf ){
		_buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
		this.playerName = _buf.ReadString();
        this.num = _buf.ReadVarInt();
	},
});
////////////////////
// 获取帮会列表返回 //
////////////////////
var ResGuildGetGuildListToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.guildList = []; // 所有帮会列表 GuildInfo
        this.appliedGuildList = []; // 已申请帮会列表 long
	},

	getId:function(){
		return 111101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.guildList.length );
        for (var i = 0; i < this.guildList.length; i++) {
            _buf.WriteBean(this.guildList[i]);
        }
        _buf.WriteShort( this.appliedGuildList.length );
        for (var i = 0; i < this.appliedGuildList.length; i++) {
            _buf.WriteLong(this.appliedGuildList[i]);
        }
	},
	
	reading:function( _buf ){
        var guildList_length = _buf.ReadShort();
        for (var i = 0; i < guildList_length; i++) {
            this.guildList[i] = _buf.ReadBean(GuildInfo);
        }
        var appliedGuildList_length = _buf.ReadShort();
        for (var i = 0; i < appliedGuildList_length; i++) {
            this.appliedGuildList[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.guild.RecvResGuildGetGuildListToClientMessage(this);
	},

});
////////////////////
// 申请加入帮会发给帮会操作人 //
////////////////////
var ResGuildApplyAddMessage = cc.Class.extend( {
	ctor:function(){
		this.applyPlayerInfoList = []; // 申请列表 ApplyPlayerInfo
	},

	getId:function(){
		return 111102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.applyPlayerInfoList.length );
        for (var i = 0; i < this.applyPlayerInfoList.length; i++) {
            _buf.WriteBean(this.applyPlayerInfoList[i]);
        }
	},
	
	reading:function( _buf ){
        var applyPlayerInfoList_length = _buf.ReadShort();
        for (var i = 0; i < applyPlayerInfoList_length; i++) {
            this.applyPlayerInfoList[i] = _buf.ReadBean(ApplyPlayerInfo);
        }
	},

	action:function(){
		Mgr.guild.RecvResGuildApplyAddMessage(this);
	},

});
////////////////////
// 邀请加入帮会发给被操作玩家 //
////////////////////
var ResGuildInviteAddMessage = cc.Class.extend( {
	ctor:function(){
		this.guildId = null; // 帮会Id
        this.guildName = null; // 帮会名字
        this.inviteName = null; // 邀请人名字
        this.inviteLevel = 0; // 邀请人等级
        this.inviteModeInfo = null; // 邀请人造型信息
	},

	getId:function(){
		return 111103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.guildId);
        _buf.WriteString(this.guildName);
        _buf.WriteString(this.inviteName);
        _buf.WriteVarInt(this.inviteLevel);
        _buf.WriteBean(this.inviteModeInfo);
	},
	
	reading:function( _buf ){
        this.guildId = _buf.ReadLong();
        this.guildName = _buf.ReadString();
        this.inviteName = _buf.ReadString();
        this.inviteLevel = _buf.ReadVarInt();
        this.inviteModeInfo = _buf.ReadBean(PlayerAppearanceInfo);
	},

	action:function(){
		Mgr.guild.RecvResGuildInviteAddMessage(this);
	},

});
////////////////////
// 获取成员列表返回 //
////////////////////
var ResGuildGetMemberListMessage = cc.Class.extend( {
	ctor:function(){
		this.memberList = []; // 所有成员列表 MemberInfo
	},

	getId:function(){
		return 111104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.memberList.length );
        for (var i = 0; i < this.memberList.length; i++) {
            _buf.WriteBean(this.memberList[i]);
        }
	},
	
	reading:function( _buf ){
        var memberList_length = _buf.ReadShort();
        for (var i = 0; i < memberList_length; i++) {
            this.memberList[i] = _buf.ReadBean(MemberInfo);
        }
	},

	action:function(){
		Mgr.guild.RecvResGuildGetMemberListMessage(this);
	},

});
////////////////////
// 获取帮会事件列表返回 //
////////////////////
var ResGuildGetEventListMessage = cc.Class.extend( {
	ctor:function(){
		this.eventList = []; // 帮会事件列表 EventInfo
	},

	getId:function(){
		return 111105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.eventList.length );
        for (var i = 0; i < this.eventList.length; i++) {
            _buf.WriteBean(this.eventList[i]);
        }
	},
	
	reading:function( _buf ){
        var eventList_length = _buf.ReadShort();
        for (var i = 0; i < eventList_length; i++) {
            this.eventList[i] = _buf.ReadBean(EventInfo);
        }
	},

	action:function(){
		Mgr.guild.RecvResGuildGetEventListMessage(this);
	},

});
////////////////////
// 发送单独帮会信息给客户端 //
////////////////////
var ResGuildGuildInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.guildInfo = null; // 单独帮会信息
        this.guildConfig = null; // 帮会配置
        this.memberInfo = null; // 自己的成员信息
        this.deleteCountdown = 0; // 帮会删除时间倒计时
	},

	getId:function(){
		return 111106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.guildInfo);
        _buf.WriteBean(this.guildConfig);
        _buf.WriteBean(this.memberInfo);
        _buf.WriteVarInt(this.deleteCountdown);
	},
	
	reading:function( _buf ){
        this.guildInfo = _buf.ReadBean(GuildInfo);
        this.guildConfig = _buf.ReadBean(GuildConfig);
        this.memberInfo = _buf.ReadBean(MemberInfo);
        this.deleteCountdown = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.guild.RecvResGuildGuildInfoMessage(this);
	},

});
////////////////////
// 帮会操作结果反馈 //
////////////////////
var ResGuildHandleResultMessage = cc.Class.extend( {
	ctor:function(){
		this.handleType = 0; // 操作类型(0创建 1帮会没得了)
        this.other = null; // 其他参数
	},

	getId:function(){
		return 111108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.handleType);
        _buf.WriteString(this.other);
	},
	
	reading:function( _buf ){
        this.handleType = _buf.ReadByte();
        this.other = _buf.ReadString();
	},

	action:function(){
		Mgr.guild.RecvResGuildHandleResultMessage(this);
	},

});
////////////////////
// 通知帮主副帮主有新的申请 //
////////////////////
var ResNoticeGuildBossApplyMessage = cc.Class.extend( {
	ctor:function(){
		this.applyPlayerInfo = null; // 申请人信息
        this.inviteModeInfo = null; // 申请人造型信息
	},

	getId:function(){
		return 111109;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.applyPlayerInfo);
        _buf.WriteBean(this.inviteModeInfo);
	},
	
	reading:function( _buf ){
        this.applyPlayerInfo = _buf.ReadBean(ApplyPlayerInfo);
        this.inviteModeInfo = _buf.ReadBean(PlayerAppearanceInfo);
	},

	action:function(){
		Mgr.guild.RecvResNoticeGuildBossApplyMessage(this);
	},

});
////////////////////
// 广播周围玩家帮会信息变化 //
////////////////////
var ResRoundGuildChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 玩家Id
        this.guildId = null; // 帮会Id
        this.guildName = null; // 帮会名称
	},

	getId:function(){
		return 111110;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteLong(this.guildId);
        _buf.WriteString(this.guildName);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.guildId = _buf.ReadLong();
        this.guildName = _buf.ReadString();
	},

	action:function(){
		Mgr.guild.RecvResRoundGuildChangeMessage(this);
	},

});
////////////////////
// 返回帮会禁地boss信息 //
////////////////////
var ResGuildForbiddenBossInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.callTimes = 0; // 今日已经召唤次数
        this.bossDie = 0; // boss是否已被击杀
        this.playerName = null; // 上一轮boss超级召唤的玩家名
	},

	getId:function(){
		return 111111;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.callTimes);
        _buf.WriteVarInt(this.bossDie);
        _buf.WriteString(this.playerName);
	},
	
	reading:function( _buf ){
        this.callTimes = _buf.ReadVarInt();
        this.bossDie = _buf.ReadVarInt();
        this.playerName = _buf.ReadString();
	},

	action:function(){
		Mgr.guild.RecvResGuildForbiddenBossInfoMessage(this);
	},

});
////////////////////
// 返回禁地BOSS伤害信息 //
////////////////////
var ResGuildForbiddenDamageInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.damageInfo = []; // 伤害列表 BossDamageInfo
	},

	getId:function(){
		return 111113;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.damageInfo.length );
        for (var i = 0; i < this.damageInfo.length; i++) {
            _buf.WriteBean(this.damageInfo[i]);
        }
	},
	
	reading:function( _buf ){
        var damageInfo_length = _buf.ReadShort();
        for (var i = 0; i < damageInfo_length; i++) {
            this.damageInfo[i] = _buf.ReadBean(BossDamageInfo);
        }
	},

	action:function(){
		Mgr.guild.RecvResGuildForbiddenDamageInfoMessage(this);
	},

});
////////////////////
// 返回禁地BOSS副本追踪面板信息 //
////////////////////
var ResGuildForbiddenZonePanelInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.countdowm = 0; // 剩余时间
        this.zhaohuanTime = 0; // 召唤时间（秒）
        this.nextFlushTime = 0; // 下次BOSS刷新时间（秒）
        this.zhaohuanState = 0; // 今日召唤状态（1是召唤了0是未召唤）
        this.killNums = 0; // 今日Boss击杀次数
	},

	getId:function(){
		return 111114;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.countdowm);
        _buf.WriteVarInt(this.zhaohuanTime);
        _buf.WriteVarInt(this.nextFlushTime);
        _buf.WriteVarInt(this.zhaohuanState);
        _buf.WriteVarInt(this.killNums);
	},
	
	reading:function( _buf ){
        this.countdowm = _buf.ReadVarInt();
        this.zhaohuanTime = _buf.ReadVarInt();
        this.nextFlushTime = _buf.ReadVarInt();
        this.zhaohuanState = _buf.ReadVarInt();
        this.killNums = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.guild.RecvResGuildForbiddenZonePanelInfoMessage(this);
	},

});
////////////////////
// 返回禁地BOSS副本在线奖励信息 //
////////////////////
var ResGuildForbiddenZoneRewardInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.zhenqi = 0; // 奖励真气
        this.exp = 0; // 奖励经验
	},

	getId:function(){
		return 111115;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zhenqi);
        _buf.WriteVarInt(this.exp);
	},
	
	reading:function( _buf ){
        this.zhenqi = _buf.ReadVarInt();
        this.exp = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.guild.RecvResGuildForbiddenZoneRewardInfoMessage(this);
	},

});
////////////////////
// 广播禁地boss召唤 //
////////////////////
var ResBroadcastGuildForbiddenBossRefreshMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111116;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.guild.RecvResBroadcastGuildForbiddenBossRefreshMessage(this);
	},

});
////////////////////
// 帮会boss奖励 //
////////////////////
var ResGuildBossAwardListMessage = cc.Class.extend( {
	ctor:function(){
		this.guildBossAwardInfoList = []; // 奖励信息列表 GuildBossAwardInfo
	},

	getId:function(){
		return 111117;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.guildBossAwardInfoList.length );
        for (var i = 0; i < this.guildBossAwardInfoList.length; i++) {
            _buf.WriteBean(this.guildBossAwardInfoList[i]);
        }
	},
	
	reading:function( _buf ){
        var guildBossAwardInfoList_length = _buf.ReadShort();
        for (var i = 0; i < guildBossAwardInfoList_length; i++) {
            this.guildBossAwardInfoList[i] = _buf.ReadBean(GuildBossAwardInfo);
        }
	},

	action:function(){
		Mgr.guild.RecvResGuildBossAwardListMessage(this);
	},

});
////////////////////
// 广播工会删除倒计时信息 //
////////////////////
var ResGuildDeleteCountdownTimeMessage = cc.Class.extend( {
	ctor:function(){
		this.countdownTime = 0; // -1表示取消倒计时 大于0表是正在进行倒计时(秒)
	},

	getId:function(){
		return 111118;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.countdownTime);
	},
	
	reading:function( _buf ){
        this.countdownTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.guild.RecvResGuildDeleteCountdownTimeMessage(this);
	},

});
////////////////////
// 返回帮会技能信息 //
////////////////////
var ResGuildSkillInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.skills = []; // 技能列表 GuildSkillInfo
	},

	getId:function(){
		return 111119;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.skills.length );
        for (var i = 0; i < this.skills.length; i++) {
            _buf.WriteBean(this.skills[i]);
        }
	},
	
	reading:function( _buf ){
        var skills_length = _buf.ReadShort();
        for (var i = 0; i < skills_length; i++) {
            this.skills[i] = _buf.ReadBean(GuildSkillInfo);
        }
	},

	action:function(){
		Mgr.guild.RecvResGuildSkillInfoMessage(this);
	},

});
////////////////////
// 返回帮会技能升级结果 //
////////////////////
var ResGuildSkillLevelUpResultMessage = cc.Class.extend( {
	ctor:function(){
		this.skill = null; // 技能
        this.result = 0; // 结果 1成功 0失败
	},

	getId:function(){
		return 111120;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.skill);
        _buf.WriteVarInt(this.result);
	},
	
	reading:function( _buf ){
        this.skill = _buf.ReadBean(GuildSkillInfo);
        this.result = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.guild.RecvResGuildSkillLevelUpResultMessage(this);
	},

});
////////////////////
// 返回帮会福利状态 //
////////////////////
var ResWelfareStateMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 0未领取 1已领取
	},

	getId:function(){
		return 111121;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.state);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.guild.RecvResWelfareStateMessage(this);
	},

});
////////////////////
// 可以领取日常奖励（活动期间计入地图发送 收到此消息说明可以领奖励） //
////////////////////
var ResGuildAnswerDailyRewardMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111126;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.guild.RecvResGuildAnswerDailyRewardMessage(this);
	},

});
////////////////////
// 答题排名信息 //
////////////////////
var ResGuildAnswerRankMessage = cc.Class.extend( {
	ctor:function(){
		this.ranks = []; // 排名信息 AnswerRankInfo
        this.sum = 0; // 答题正确总数
	},

	getId:function(){
		return 111129;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.ranks.length );
        for (var i = 0; i < this.ranks.length; i++) {
            _buf.WriteBean(this.ranks[i]);
        }
        _buf.WriteVarInt(this.sum);
	},
	
	reading:function( _buf ){
        var ranks_length = _buf.ReadShort();
        for (var i = 0; i < ranks_length; i++) {
            this.ranks[i] = _buf.ReadBean(AnswerRankInfo);
        }
        this.sum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.guild.RecvResGuildAnswerRankMessage(this);
	},

});
////////////////////
// 广播帮会公告改变 //
////////////////////
var ResRoundGuildAnnouncementChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.announcement = null; // 公告内容
	},

	getId:function(){
		return 111127;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.announcement);
	},
	
	reading:function( _buf ){
        this.announcement = _buf.ReadString();
	},

	action:function(){
		Mgr.guild.RecvResRoundGuildAnnouncementChangeMessage(this);
	},

});
////////////////////
// 工会拒绝玩家申请入帮操作给玩家 //
////////////////////
var ResRejectApplicationGuildToPlayerMessage = cc.Class.extend( {
	ctor:function(){
		this.guildId = null; // 工会id
	},

	getId:function(){
		return 111128;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.guildId);
	},
	
	reading:function( _buf ){
        this.guildId = _buf.ReadLong();
	},

	action:function(){
		Mgr.guild.RecvResRejectApplicationGuildToPlayerMessage(this);
	},

});
////////////////////
// 发送帮会仓库物品信息 //
////////////////////
var ResSendGuildStoreInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.maxCell = 0; // 最大格子
        this.items = []; // 物品信息列表 ItemInfo
	},

	getId:function(){
		return 111401;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.maxCell);
        _buf.WriteShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
	},
	
	reading:function( _buf ){
        this.maxCell = _buf.ReadVarInt();
        var items_length = _buf.ReadShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(ItemInfo);
        }
	},

	action:function(){
		Mgr.guild.RecvResSendGuildStoreInfoMessage(this);
	},

});
////////////////////
// 物品信息增加 //
////////////////////
var ResGuildItemAddMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型(1-获得新物品)
        this.item = null; // 物品信息
	},

	getId:function(){
		return 111402;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteBean(this.item);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.item = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.guild.RecvResGuildItemAddMessage(this);
	},

});
////////////////////
// 物品信息修正 //
////////////////////
var ResGuildItemChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型(1-获得新物品)
        this.item = null; // 物品信息
	},

	getId:function(){
		return 111403;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteBean(this.item);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.item = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.guild.RecvResGuildItemChangeMessage(this);
	},

});
////////////////////
// 物品删除 //
////////////////////
var ResGuildItemRemoveMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
	},

	getId:function(){
		return 111404;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
	},

	action:function(){
		Mgr.guild.RecvResGuildItemRemoveMessage(this);
	},

});
////////////////////
// 提醒帮主副帮主召唤BOSS //
////////////////////
var ResGuildBossZhaoHuanToClientMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111130;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.guild.RecvResGuildBossZhaoHuanToClientMessage(this);
	},

});
////////////////////
// 创建公会 //
////////////////////
var ReqGuildCreateMessage = cc.Class.extend( {
	ctor:function(){
		this.guildName = null; // 公会名字
        this.costType = 0; // 消耗类型(0银两1元宝)
	},

	getId:function(){
		return 111201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.guildName);
        _buf.WriteByte(this.costType);
	},
	
	reading:function( _buf ){
        this.guildName = _buf.ReadString();
        this.costType = _buf.ReadByte();
	},

});
////////////////////
// 获取帮会列表 //
////////////////////
var ReqGuildGetGuildListMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 申请加入帮会 //
////////////////////
var ReqGuildApplyAddMessage = cc.Class.extend( {
	ctor:function(){
		this.guildId = null; // 帮会id
	},

	getId:function(){
		return 111204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.guildId);
	},
	
	reading:function( _buf ){
        this.guildId = _buf.ReadLong();
	},

});
////////////////////
// 邀请加入帮会 //
////////////////////
var ReqGuildInviteAddMessage = cc.Class.extend( {
	ctor:function(){
		this.InvitedPlayerId = null; // 邀请者Id
	},

	getId:function(){
		return 111205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.InvitedPlayerId);
	},
	
	reading:function( _buf ){
        this.InvitedPlayerId = _buf.ReadLong();
	},

});
////////////////////
// 获取成员列表 //
////////////////////
var ReqGuildGetMemberListMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 添加帮会成员 //
////////////////////
var ReqGuildAddMemberMessage = cc.Class.extend( {
	ctor:function(){
		this.guildId = null; // 帮会Id
        this.playerId = null; // 被操作玩家ID
        this.argee = 0; // 是否同意(0 否 1 是)
	},

	getId:function(){
		return 111207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.guildId);
        _buf.WriteLong(this.playerId);
        _buf.WriteByte(this.argee);
	},
	
	reading:function( _buf ){
        this.guildId = _buf.ReadLong();
        this.playerId = _buf.ReadLong();
        this.argee = _buf.ReadByte();
	},

});
////////////////////
// 退出帮会 //
////////////////////
var ReqGuildQuitMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 修改职权 //
////////////////////
var ReqGuildChangePowerLevelMessage = cc.Class.extend( {
	ctor:function(){
		this.userId = null; // 被操作玩家ID
        this.newPowerLevel = 0; // 新职权
	},

	getId:function(){
		return 111210;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.userId);
        _buf.WriteByte(this.newPowerLevel);
	},
	
	reading:function( _buf ){
        this.userId = _buf.ReadLong();
        this.newPowerLevel = _buf.ReadByte();
	},

});
////////////////////
// 删除帮会成员 //
////////////////////
var ReqGuildDeleteMemberMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 被操作玩家ID
	},

	getId:function(){
		return 111211;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
	},

});
////////////////////
// 修改帮会设置 //
////////////////////
var ReqGuildConfigMessage = cc.Class.extend( {
	ctor:function(){
		this.config = null; // 帮会配置
	},

	getId:function(){
		return 111212;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.config);
	},
	
	reading:function( _buf ){
        this.config = _buf.ReadBean(GuildConfig);
	},

});
////////////////////
// 修改公告 //
////////////////////
var ReqGuildChangeAnnouncementMessage = cc.Class.extend( {
	ctor:function(){
		this.guildBulletin = null; // 帮会公告
	},

	getId:function(){
		return 111213;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.guildBulletin);
	},
	
	reading:function( _buf ){
        this.guildBulletin = _buf.ReadString();
	},

});
////////////////////
// 解散帮会 //
////////////////////
var ReqGuildDeleteGuildMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 1请求解散 0取消解散
	},

	getId:function(){
		return 111214;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 获取帮会事件列表 //
////////////////////
var ReqGuildGetEventListMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111215;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求刷新guildInfo //
////////////////////
var ReqUpdateGuildInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111216;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求申请入帮列表 //
////////////////////
var ReqApplyListMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111217;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求升级帮会 //
////////////////////
var ReqLevelUpGuildMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111218;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求更换帮旗 //
////////////////////
var ReqChangeGuildFlagMessage = cc.Class.extend( {
	ctor:function(){
		this.flagModel = 0; // 帮旗Id
	},

	getId:function(){
		return 111219;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.flagModel);
	},
	
	reading:function( _buf ){
        this.flagModel = _buf.ReadVarInt();
	},

});
////////////////////
// 同意帮会邀请 //
////////////////////
var ReqAgreeInviteMessage = cc.Class.extend( {
	ctor:function(){
		this.isAgree = 0; // 0 拒绝 1 同意
        this.inviteGuildId = null; // 邀请的帮会id
	},

	getId:function(){
		return 111220;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.isAgree);
        _buf.WriteLong(this.inviteGuildId);
	},
	
	reading:function( _buf ){
        this.isAgree = _buf.ReadByte();
        this.inviteGuildId = _buf.ReadLong();
	},

});
////////////////////
// 修改帮会boss分配机制设置 //
////////////////////
var ReqGuildAutoDistributionMessage = cc.Class.extend( {
	ctor:function(){
		this.autoDistribution = 0; // 自动分配帮会BOSS奖励（0手动 1自动）
	},

	getId:function(){
		return 111222;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.autoDistribution);
	},
	
	reading:function( _buf ){
        this.autoDistribution = _buf.ReadByte();
	},

});
////////////////////
// 请求帮会禁地boss信息 //
////////////////////
var ReqGuildForbiddenBossInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111223;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求进入禁地 //
////////////////////
var ReqGuildEnterForbiddenMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111225;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求召唤禁地boss //
////////////////////
var ReqRefreshGuildForbiddenBossMessage = cc.Class.extend( {
	ctor:function(){
		this.refreshType = 0; // 0普通召唤 1超级召唤
	},

	getId:function(){
		return 111226;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.refreshType);
	},
	
	reading:function( _buf ){
        this.refreshType = _buf.ReadByte();
	},

});
////////////////////
// 分配奖励 //
////////////////////
var ReqDispatchItemMessage = cc.Class.extend( {
	ctor:function(){
		this.awardUniqueIds = []; // 奖励列表唯一id long
        this.tempItemId = []; // 物品唯一Id列表 long
        this.toPlayerId = null; // 分配给玩家的唯一id
        this.autoType = 0; // 自动分配类型(0手动1是在线率2是战斗力3是贡献值4是参与者随机分配)
	},

	getId:function(){
		return 111227;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.awardUniqueIds.length );
        for (var i = 0; i < this.awardUniqueIds.length; i++) {
            _buf.WriteLong(this.awardUniqueIds[i]);
        }
        _buf.WriteShort( this.tempItemId.length );
        for (var i = 0; i < this.tempItemId.length; i++) {
            _buf.WriteLong(this.tempItemId[i]);
        }
        _buf.WriteLong(this.toPlayerId);
        _buf.WriteVarInt(this.autoType);
	},
	
	reading:function( _buf ){
        var awardUniqueIds_length = _buf.ReadShort();
        for (var i = 0; i < awardUniqueIds_length; i++) {
            this.awardUniqueIds[i] = _buf.ReadLong();
        }
        var tempItemId_length = _buf.ReadShort();
        for (var i = 0; i < tempItemId_length; i++) {
            this.tempItemId[i] = _buf.ReadLong();
        }
        this.toPlayerId = _buf.ReadLong();
        this.autoType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求帮会技能信息 //
////////////////////
var ReqGuildSkillInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111228;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求升级帮会技能信息 //
////////////////////
var ReqGuildSkillLevelUpMessage = cc.Class.extend( {
	ctor:function(){
		this.skillModelId = 0; // 技能modelId
	},

	getId:function(){
		return 111229;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.skillModelId);
	},
	
	reading:function( _buf ){
        this.skillModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求帮会福利领取状态 //
////////////////////
var ReqWelfareStateMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111230;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取帮会福利奖励 //
////////////////////
var ReqWelfareRewardStateMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111231;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取帮会答题日常奖励 //
////////////////////
var ReqGuildAnswerDailyRewardMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111235;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求回答问题（暂时给语音答题留的接口） //
////////////////////
var ReqGuildAnswerQuestionMessage = cc.Class.extend( {
	ctor:function(){
		this.answer = null; // 答案
	},

	getId:function(){
		return 111236;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.answer);
	},
	
	reading:function( _buf ){
        this.answer = _buf.ReadString();
	},

});
////////////////////
// 请求帮会仓库列表 //
////////////////////
var ReqSendGuildStoreItemsMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111301;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 物品存入仓库 //
////////////////////
var ReqDevoteItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = []; // 物品Id long
	},

	getId:function(){
		return 111302;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.itemId.length );
        for (var i = 0; i < this.itemId.length; i++) {
            _buf.WriteLong(this.itemId[i]);
        }
	},
	
	reading:function( _buf ){
        var itemId_length = _buf.ReadShort();
        for (var i = 0; i < itemId_length; i++) {
            this.itemId[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// 兑换物品 //
////////////////////
var ReqExchangeItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.num = 0; // 兑换数量
	},

	getId:function(){
		return 111303;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.num = _buf.ReadVarInt();
	},

});
////////////////////
// 删除物品 //
////////////////////
var ReqGuildDeleteItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.isDelete = 0; // 0 取消删除 1确认删除
	},

	getId:function(){
		return 111304;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteByte(this.isDelete);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.isDelete = _buf.ReadByte();
	},

});
////////////////////
// 提醒帮主副帮主召唤BOSS //
////////////////////
var ReqGuildBossZhaoHuanToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 111237;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(111101, ResGuildGetGuildListToClientMessage);
MESSAGE_POOL.Add(111102, ResGuildApplyAddMessage);
MESSAGE_POOL.Add(111103, ResGuildInviteAddMessage);
MESSAGE_POOL.Add(111104, ResGuildGetMemberListMessage);
MESSAGE_POOL.Add(111105, ResGuildGetEventListMessage);
MESSAGE_POOL.Add(111106, ResGuildGuildInfoMessage);
MESSAGE_POOL.Add(111108, ResGuildHandleResultMessage);
MESSAGE_POOL.Add(111109, ResNoticeGuildBossApplyMessage);
MESSAGE_POOL.Add(111110, ResRoundGuildChangeMessage);
MESSAGE_POOL.Add(111111, ResGuildForbiddenBossInfoMessage);
MESSAGE_POOL.Add(111113, ResGuildForbiddenDamageInfoMessage);
MESSAGE_POOL.Add(111114, ResGuildForbiddenZonePanelInfoMessage);
MESSAGE_POOL.Add(111115, ResGuildForbiddenZoneRewardInfoMessage);
MESSAGE_POOL.Add(111116, ResBroadcastGuildForbiddenBossRefreshMessage);
MESSAGE_POOL.Add(111117, ResGuildBossAwardListMessage);
MESSAGE_POOL.Add(111118, ResGuildDeleteCountdownTimeMessage);
MESSAGE_POOL.Add(111119, ResGuildSkillInfoMessage);
MESSAGE_POOL.Add(111120, ResGuildSkillLevelUpResultMessage);
MESSAGE_POOL.Add(111121, ResWelfareStateMessage);
MESSAGE_POOL.Add(111126, ResGuildAnswerDailyRewardMessage);
MESSAGE_POOL.Add(111129, ResGuildAnswerRankMessage);
MESSAGE_POOL.Add(111127, ResRoundGuildAnnouncementChangeMessage);
MESSAGE_POOL.Add(111128, ResRejectApplicationGuildToPlayerMessage);
MESSAGE_POOL.Add(111401, ResSendGuildStoreInfoMessage);
MESSAGE_POOL.Add(111402, ResGuildItemAddMessage);
MESSAGE_POOL.Add(111403, ResGuildItemChangeMessage);
MESSAGE_POOL.Add(111404, ResGuildItemRemoveMessage);
MESSAGE_POOL.Add(111130, ResGuildBossZhaoHuanToClientMessage);

