var GuildMemberItemExt = GuildMemberItem.extend ( {
	_className:"GuildMemberItemExt",

	_info:null,
	_guildId:null,
	_imgJobList:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		GuildMemberItem.prototype.Init.call(this);
	},

	SetData:function ( data, boo ) {
		this.Clear();
		this._info = data;
		// 底板黄红交替
		if (boo)
			this.imgBghuang.setVisible(true);
		else
			this.imgBghong.setVisible(true);

		// vip
		var vip = Mgr.player.mainPlayer.viplevel;
		var isVip =  vip > 0 ? true:false;
		this.imgVip.setVisible(isVip);

		// sex
		var sex = Mgr.player.mainPlayer.job;
		if ( sex == EnumJobType.MAN )
			this.imgMan.setVisible(true);
		else
			this.imgWoman.setVisible(true);

		// job
		var color = null, outLine = null;
		var job = data.guildPowerLevel;
		if (job == GuildEnum.MEMBER_GUILDER) {
			color = "0x853d07";
			this.imgBangZhu.setVisible(true);
		}
		else if ( job == GuildEnum.MEMBER_SECONDGUILDER ) {
			color = "0x853d07";
			this.imgFuBangZhu.setVisible(true);
		}
		else if ( job == GuildEnum.MEMBER_ELITE ) {
			color = "0x853d07";
			this.imgJingYing.setVisible(true);
		}
		else if ( job == GuildEnum.MEMBER_MENBER ) {
			color = "0x853d07";
			this.labMember.SetString("成员");
		}

		// state
		var str;
		var state = data.isOnline;
		if ( !state ) {
			Filter.GrayScale(this);

			color = "0xA4A4A4";

			// time
			var second = Mgr.login.GetServerTime()/1000 - data.lastOnlineTime;
			if ( second > 0 ) {

				var time;
				var D = Math.floor(second / (24*60*60));
				var H =  Math.floor(second/60/60%24);
				var M = Math.floor(second/60%60);
				var S = Math.floor(second%60);

				if(D>0){
					time = D+"天"+H+"时"+M+"分";
				}
				else if(H>0){
					time = H+"时"+M+"分";
				}
				else if(M>0){
					time = M+"分";
				}
				else {
					time = "0分";
				}

				//var time = TimeUtil.SecondToDHMS(second);
				str = time + "前离线"
			}
		}
		else {
			str = "在线";
			Filter.UnGray(this);
		}
		this.labState.SetString(str);
		this.labState.SetColor( color );

		this.labMember.SetColor( color );

		// name
		var str = data.playerName;
		this.labName.SetString(str);
		this.labName.SetColor( color );

		// level
		this.labLevel.SetString(data.level);
		this.labLevel.SetColor( color );

		// fight
		this.labPower.SetString(data.fightPower);
		this.labPower.SetColor( color );

		// gongxian
		this.labGongxian.SetString(data.devoteValue);
		this.labGongxian.SetColor( color );
	},

	SetSelect:function (sel) {
		this.imgGuang.setVisible(sel);
	},

	GetData:function () {
		return this._info;
	},

	Clear:function () {
		this.imgBghuang.setVisible(false);
		this.imgBghong.setVisible(false);
		this.imgGuang.setVisible(false);

		this.imgVip.setVisible(false);
		this.imgWoman.setVisible(false);
		this.imgMan.setVisible(false);

		this.labName.SetString("");

		this.imgBangZhu.setVisible(false);
		this.imgFuBangZhu.setVisible(false);
		this.imgJingYing.setVisible(false);
		this.labMember.SetString("");

		this.labLevel.SetString("");
		this.labPower.SetString("");
		this.labGongxian.SetString("");
		this.labState.SetString("");
	},
} );
GuildMemberItemExt.PanelName = "GuildMemberItemExt";
PanelClassDic["GuildMemberItemExt"] = GuildMemberItemExt;
