var GuildNoticePanelExt = GuildNoticePanel.extend ( {
	_className:"GuildNoticePanelExt",

	_maxStr:70,
	modelPanelType:2,
	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		GuildNoticePanel.prototype.Init.call(this);
		var gap = 4;
		this.labCue.x+= gap+2;
		this.labCue.y-= gap;
		this.editCue.x+= gap+2;
		this.editCue.y-= gap;
		this._InitParam();

		this.btnClose.addClickEventListener(function (event) {
			Mgr.uiMgr.HidePanel(self);
		});
		this.btn2.addClickEventListener(function (event) {
			Mgr.uiMgr.HidePanel(self);
		});
		this.btn1.addClickEventListener(function (event) {
			var notice = self.editCue.getString();
			Mgr.guild.SendReqGuildChangeAnnouncementMessage( notice );
		});
	},

	_InitParam:function () {
		this.labCue.SetString( "请输入公告内容" );
		//this.labCue.setPlaceHolder( "请输入公告内容" );
		this.editCue.setMaxLength(this._maxStr);
		this.editCue.setDelegate(this);
		this.editCue.setOpacity(0);

		this._BrushStrings();
	},

	editBoxTextChanged: function (editBox, text) {
		var self = this;
		var ediText = editBox.getString();
		if (self.editCue == editBox) {
			if ( ediText != "" ) {
				self.labCue.SetString( ediText );
			}
			else
			{
				self.labCue.SetString( "请输入公告内容" );
			}
			self._BrushStrings();
		}
	},

	_BrushStrings:function () {
		var str = this.editCue.getString();
		this.labNum.SetString(str.length+"/"+this._maxStr);
	},
} );
GuildNoticePanelExt.PanelName = "GuildNoticePanelExt";
PanelClassDic["GuildNoticePanelExt"] = GuildNoticePanelExt;
