var GenChongMainExt = GenChongMain.extend ( {
	_className:"GenChongMainExt",

	_listView:null,
	_itemList:null,
    _curSelectBtn:null,

    type:null,
    showModelId:null,
    model:null,
    id:null,

    isActivat:false,
    isFollow:false,


	ctor:function(){
		this._super();
		this._itemList = [];
	},

    Init:function (){
        GenChongMain.prototype.Init.call( this );
        var self = this;

        this.type = HuanhuaType.TYPE_PET;

        this.setTouchEnabled( false );

        this.labCue3.setTouchEnabled(true);
        this.labCue3.addTouchEventListener(function(sender,type)
        {
            if ( type == ccui.Widget.TOUCH_BEGAN )
            {
            }
            else if ( type == ccui.Widget.TOUCH_ENDED )
            {
            }
            else if ( type == ccui.Widget.TOUCH_CANCELED )
            {
            }
        });
        setTimeout(function(){
            self.imgBg.getVirtualRenderer().setBlendFunc( cc.BlendFunc.ALPHA_PREMULTIPLIED );       //etc压缩的时候边缘处理有点问题  先这样简单处理
        }, 500);

        this.InitView();
        this.InitItem();
    },

    InitView:function(){
        if(!this._listView){
            this._listView = new ccui.ListView();
            this._listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._listView.setTouchEnabled(true);					//触摸开启
            this._listView.inertiaScrollEnabled = false; 			//滚动惯性
            this._listView.setScrollBarEnabled(false);				//滚动条
            this._listView.setBounceEnabled(true);					//边界回弹
            // this._listView.setScrollBarAutoHideTime(1);
            this._listView.addEventListener(this._SelectedBtnEvent);
            this.imgBg1.addChild(this._listView);
        }
    },

	InitItem:function(){
		var list = Q_illusion.GetList();
        list.sort(function(a, b){ return a.q_order - b.q_order; });
		var t = 0;
		for(var i = 0; i < list.length; i++){
			if(list[i].q_type == HuanhuaType.TYPE_PET && list[i].q_order != -1){
                if(!this._itemList[t]){
                    var item = new GenChongFrameExt();
                    item.LoadPanel();
                    item.x = 0;
                    item.y = item.uiHeight*(list.length-i-1);
                    item.idx = t;
                    this._height = item.uiHeight;
                    this._listView.addChild(item);
                    this._itemList.push(item);
                }
                this._itemList[t].SetData(list[i]);
				t++;
			}
		}
        this._listView.setSize(cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
        this._listView.setInnerContainerSize(cc.size(this.imgBg1.uiWidth, list.length * this._height));
        this.countHight = (this._itemList.length - 1) * this._height;
	},

    _SelectedBtnEvent:function(sender, type){
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent.parent;
                if (parent._curSelectBtn != null) {
                    parent._curSelectBtn.SetSelect(false);
                    parent._curSelectBtn = null;
                }

                var idx = sender.getCurSelectedIndex();
                var btnSelect = sender.getItem(idx);
                parent._curSelectBtn = btnSelect;
                parent.ChangePetInfo();
                btnSelect.SetSelect(true);
                parent.btnSelect = btnSelect;
                break;
            default:
        }
	},

    scrollToICurSelect:function () {
        // var prent=this._curSelectBtn.y/this.countHight;
        var prent = (this._curSelectBtn.idx*this._height)/this.countHight;
        this._listView.scrollToPercentVertical((prent*100), 0.5, true);
    },

    SetType:function(type){
        this.type = type;
        if( this._curSelectBtn )
            this._curSelectBtn.SetSelect(false);
        this._curSelectBtn = null;
        this.RefreshPanel();
    },

	ChangePetInfo:function(){
	    this.scrollToICurSelect();
		this.labZhandouli1.SetText(this._curSelectBtn.power);
		this.labGongji1.SetText(this._curSelectBtn.attack);
        this.labFangyu1.SetText(this._curSelectBtn.defense);
        this.labHP1.SetText(this._curSelectBtn.hp);
        this.labName1.SetText(this._curSelectBtn.spAttri);
        this.labCue3.SetText(this._curSelectBtn.getPosStr);
        this.labName.SetText(this._curSelectBtn.petName);
        this.ShowModel(this._curSelectBtn.modelId);
        this.imgDiKuang.visible = this._curSelectBtn.isFollow;
        this.id = this._curSelectBtn.id;
        // this.imgDiBg.visible = this._curSelectBtn.isFollow;

        this.showModelId = this._curSelectBtn.modelId;
        this.isActivat = this._curSelectBtn.isActivat;
        this.isFollow = this._curSelectBtn.isFollow;

        var panel = Mgr.uiMgr.GetPanelByType(GenChongPanelExt.PanelName);
        if(panel){
            panel.RefreshBtn();
        }
	},

    RefreshPanel:function(){
        for(var i = 0; i < this._itemList.length; i++){
            var item = this._itemList[i];
            var illusion = Mgr.illusion.GetIllusion(this.type, item.data.q_id);

            item.isAward = illusion != null;
            item.SetActivat(illusion != null);
            if( Mgr.illusion.IsShowIllusion(this.type, item.data.q_id) ){
                if( !this._curSelectBtn )
                    this._curSelectBtn = item;
                item.SetWear(true);
            }
            else{
                item.SetWear(false);
            }
         
            item.SetWarn(Mgr.illusion.IsCanActivate(this.type, item.data.q_id));
        }
        if(!this._curSelectBtn){
            this._curSelectBtn = this._itemList[0];
        }
        this._curSelectBtn.SetSelect(true);
        this.ChangePetInfo();
    },

    ChangeShow:function(id){
        for(var i = 0; i < this._itemList.length; i++){
            this._itemList[i].SetWear(id == this._itemList[i].id);
        }
        this.ChangePetInfo();
    },

    ShowModel:function(showId){
        if(!this.model){
            this.model = new UIModel(showId, HuanhuaType.TYPE_PET);
            this.model.x = 50;
            this.imgModel.addChild(this.model);
        }
        else{
            this.model.SetModelId(showId);
        }
    },

    OnShow:function(){
        Mgr.illusion.onIllusionDataChange.add(this.RefreshPanel, this);
        Mgr.illusion.onIllusionShowChange.add(this.ChangeShow, this);
    },

    OnHide:function(){
        Mgr.illusion.onIllusionDataChange.remove(this.RefreshPanel, this);
        Mgr.illusion.onIllusionShowChange.remove(this.ChangeShow, this);
    },

} );
GenChongMainExt.PanelName = "GenChongMainExt";
PanelClassDic["GenChongMainExt"] = GenChongMainExt;
