var BossDoubleExt = BossDouble.extend ( {
	_className:"BossDoubleExt",
	_timer:null,
    _timeArr:null,
	ctor:function(){
		this._super();
	},

    Init:function () {
      BossDouble.prototype.Init.call(this);
      this._timeArr = [this.imglab1, this.imglab2, this.imglab3];
      for(var i = 0, len = this._timeArr.length; i < len; i++){
          this._timeArr[i]._align = 2;
          this._timeArr[i].x -= 10;
          this._timeArr[i].y += 7;
      }
    },

    SetActivityList:function (info) {
        var leftTime = info[0].endTime - parseInt(Mgr.login.GetServerTime()/1000);
        this.SetTimeLabel(leftTime);
        this._timer = TimerUtil.TimeUpdate(function () {
            leftTime--;
            this.SetTimeLabel(leftTime);
        }, this, 1, leftTime);
    },

	SetTimeLabel:function (leftTime) {
        var timeArr = TimeUtil.SecondToDHMS4(leftTime);
        for( var i = 0; i < timeArr.length - 1; i++){
            this._timeArr[i].SetText(timeArr[i]);
        }
    },

    OnHide:function () {
		if(this._timer){
			TimerUtil.ClearTimeUpdate(this._timer);
		}
    }
} );
BossDoubleExt.PanelName = "BossDoubleExt";
PanelClassDic["BossDoubleExt"] = BossDoubleExt;
