var InvestPlanFrameExt = InvestPlanFrame.extend ( {
	_className:"InvestPlanFrameExt",

    rewardGridList:null,

	ctor:function(){
		this._super();
		this.rewardGridList = [];
	},

    Init:function(){
        InvestPlanFrame.prototype.Init.call(this);

        this.imgGet.visible = false;
        this.gridAward.visible = false;
    },

	SetData:function(day, list) {
		this.labDay.SetHtmlText(TextUtil.FormatStr(this.labDay.GetHtmlText(), [day]));

		for(var i = 0; i < list.length; i++){
            if(!this.rewardGridList[i]){
                var grid = new MUIGrid();
                grid.ParseJson(this.gridAward.jsonobj);
                grid.Init();
                grid.x = this.gridAward.x + grid.uiWidth * i;
                grid.y = this.gridAward.y;
                this.imgFrame.addChild(grid);
                this.rewardGridList.push(grid);
            }
            var coinInfo = {};
            coinInfo.itemModelId = list[i].mod;
            coinInfo.itemNum = list[i].num;
            coinInfo.itemBind = list[i].bind;
            GridUtil.SetItemGrid(this.rewardGridList[i],coinInfo);
		}
    },
} );
InvestPlanFrameExt.PanelName = "InvestPlanFrameExt";
PanelClassDic["InvestPlanFrameExt"] = InvestPlanFrameExt;
