var MonthCardInvestPanelExt = MonthCardInvestPanel.extend ( {
	_className:"MonthCardInvestPanelExt",

	// 可领取天数
	enDays:null,
	// 已领取天数
	getedDays:null,

	cellPanel:null,
	cellList:null,
	isInvest:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		MonthCardInvestPanel.prototype.Init.call(this);

		var investGold = JSON.parse( Q_global.Get( 1141 ).q_string_value)[0];
		this.labCue.SetText("仅需投资"+ investGold+"元宝，大量返利每日领！多倍回馈，开服必购！");

		this.btnInvest.addClickEventListener(function (event) {
			if ( self.isInvest ) {
				Mgr.uiMgr.GetPanelByType( TaijiPanelExt.PanelName ).ChangeView( EnumGrossipType.TYPE_TOUZI );
			}
			else {
				var array = JSON.parse( Q_global.Get( 1141 ).q_string_value );
				if ( parseInt(array[0]) > Mgr.mainPlayer.attributeData.Allgold() ) {
					// Mgr.tips.ShowNotice("元宝不足" + array[0]);
					AlertExt.NoEnoughGold(parseInt(array[0]) - Mgr.mainPlayer.attributeData.Allgold());
				}else {
                    Mgr.bank.SendReqBankBuyMonthToGameMessage();
				}
			}
		});
	},

	GetSortList:function () {
		var _sortList = [];
		var days = JSON.parse(Q_global.Get( 1141 ).q_string_value)[1];
		cc.log("days:               " + days);
		for ( var i = 0; i <= days; i++ ) {
			var status = this._GetItemStatus(i);
			_sortList.push({ day:i, status:status });
		}
		_sortList.sort(this._SortFunc);
		return _sortList;
	},

	//判断数字的第X位是否是大于0的
	_OperatorsSame:function( num, pos) {
		return (num & (1 << (pos))) > 0;
	},

	// get item status
	_GetItemStatus:function ( order ) {
		if ( this.isInvest ) {
			if ( this._OperatorsSame( this.getedDays, order ) ) {  // 已领取
				return InvestTypeEnum.INVEST_STATUS_GETED;
			}
			else {
				if ( order <= this.enDays )  // 能够领取
					return InvestTypeEnum.INVEST_STATUS_ENGET;
				else
					return InvestTypeEnum.INVEST_STATUS_UNREACH;
			}
		}
		else
			return InvestTypeEnum.INVEST_STATUS_UNREACH;
	},

	_SortFunc:function(a, b) {
		if (a.status > b.status) {
			return 1;
		}
		else if ( a.status == b.status ) {
			if ( a.day > b.day ) {
				return 1;
			}
		}
		return 0;
	},

	SetData:function (msg) {
        this.isInvest = false;
        this.labInvest.visible = true;
        this.labInvest1.visible = false;
        if ( msg.buyMonthTime > 0 ) {   // 已购买月卡
			Filter.GrayScale(this.btnInvest);
            this.isInvest = true;
            this.getedDays = msg.flage;

            // var second = Mgr.login.GetServerTime()/1000 - 5 * 3600;
			var second = Mgr.login.GetServerTime()/1000;
            var day = second / 3600 / 24;
            this.enDays = day - msg.buyMonthTime;
            if ( this.enDays <= 0 )  // 后推5小时,需补齐
                this.enDays = 0;
            this.enDays += 1;

            this.labInvest.visible = false;
            this.labInvest1.visible = true;
        }

        this.cellList = this.GetSortList();

		if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
            tableView.uiWidth=this.imgBg1.uiWidth;
            tableView.uiHeight=this.imgBg1.uiHeight;
            this.cellPanel = tableView;
            this.imgBg1.addChild(tableView);
		}
		this.cellPanel.reloadData();
    },

	OnShow:function () {
		Mgr.bank.SendReqBankInfoToGameMessage(2);
	},

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(1042,115);
    },

    tableCellAtIndex: function (table, idx) {
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item=new MonthCardInvestRewardItemExt();
            item.LoadPanel();
            cell.item=item;
            cell.addChild(item);
        }
        cell.item.SetData(this.cellList[idx].day, this.cellList[idx].status);
        return cell;
    },

    numberOfCellsInTableView: function (table) {
        return this.cellList.length;
    }
} );
MonthCardInvestPanelExt.PanelName = "MonthCardInvestPanelExt";
PanelClassDic["MonthCardInvestPanelExt"] = MonthCardInvestPanelExt;
