///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//Killtopinfo 击杀排行榜info

// 请求消息
//131201,ReqkingguildClientToGame 请求帮会领地战面板信息
//131202,ReqkingguildEnterClientToGame 请求帮会领地战进入战场
//131203,ReqkingguildGetRewardToGame 请求帮会领地战领取奖励

// 接收消息
//131101,ReskingguildGameToClinet 发送帮会领地战面板信息
//131102,ReskingguildTopGameToClinet 发送帮会领地战排行榜信息（战场用）
//131103,ReskingguildTaskGameToClinet 发送帮会领地战场信息（战场用


var Killtopinfo = cc.Class.extend({
	ctor:function(){
		this.playerid = null; // 玩家ID
        this.name = null; // 玩家名字
        this.killnum = 0; // 击杀人数
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.killnum);
	},
	
	reading:function( _buf ){
		this.playerid = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.killnum = _buf.ReadVarInt();
	},
});
////////////////////
// 发送帮会领地战面板信息 //
////////////////////
var ReskingguildGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.ocname = []; // 上次占领的帮派名称按次序取 string
        this.canfight = 0; // 是否能参与活动（活动中才发，1是表示能参与）
        this.canget = 0; // 领地领今日是否可领取奖励(0是不可领取，1是可领取，2是已领取)
	},

	getId:function(){
		return 131101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.ocname.length );
        for (var i = 0; i < this.ocname.length; i++) {
            _buf.WriteString(this.ocname[i]);
        }
        _buf.WriteVarInt(this.canfight);
        _buf.WriteVarInt(this.canget);
	},
	
	reading:function( _buf ){
        var ocname_length = _buf.ReadShort();
        for (var i = 0; i < ocname_length; i++) {
            this.ocname[i] = _buf.ReadString();
        }
        this.canfight = _buf.ReadVarInt();
        this.canget = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.kingguild.RecvReskingguildGameToClinetMessage(this);
	},

});
////////////////////
// 发送帮会领地战排行榜信息（战场用） //
////////////////////
var ReskingguildTopGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.toplist = []; // 排行榜信息 Killtopinfo
	},

	getId:function(){
		return 131102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.toplist.length );
        for (var i = 0; i < this.toplist.length; i++) {
            _buf.WriteBean(this.toplist[i]);
        }
	},
	
	reading:function( _buf ){
        var toplist_length = _buf.ReadShort();
        for (var i = 0; i < toplist_length; i++) {
            this.toplist[i] = _buf.ReadBean(Killtopinfo);
        }
	},

	action:function(){
		Mgr.kingguild.RecvReskingguildTopGameToClinetMessage(this);
	},

});
////////////////////
// 发送帮会领地战场信息（战场用 //
////////////////////
var ReskingguildTaskGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.ocguildname = null; // 本领地，占领者帮派名称
        this.ocguildlist = []; // 所有领地，占领帮会id（长度可以为0） long
        this.remandtime = 0; // 剩余时间
	},

	getId:function(){
		return 131103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.ocguildname);
        _buf.WriteShort( this.ocguildlist.length );
        for (var i = 0; i < this.ocguildlist.length; i++) {
            _buf.WriteLong(this.ocguildlist[i]);
        }
        _buf.WriteVarInt(this.remandtime);
	},
	
	reading:function( _buf ){
        this.ocguildname = _buf.ReadString();
        var ocguildlist_length = _buf.ReadShort();
        for (var i = 0; i < ocguildlist_length; i++) {
            this.ocguildlist[i] = _buf.ReadLong();
        }
        this.remandtime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.kingguild.RecvReskingguildTaskGameToClinetMessage(this);
	},

});
////////////////////
// 请求帮会领地战面板信息 //
////////////////////
var ReqkingguildClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 131201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求帮会领地战进入战场 //
////////////////////
var ReqkingguildEnterClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneid = 0; // 请求进入的战场的副本id
	},

	getId:function(){
		return 131202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneid);
	},
	
	reading:function( _buf ){
        this.zoneid = _buf.ReadVarInt();
	},

});
////////////////////
// 请求帮会领地战领取奖励 //
////////////////////
var ReqkingguildGetRewardToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 131203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(131101, ReskingguildGameToClinetMessage);
MESSAGE_POOL.Add(131102, ReskingguildTopGameToClinetMessage);
MESSAGE_POOL.Add(131103, ReskingguildTaskGameToClinetMessage);

