var KingguildModMgr = KingguildModMgr || cc.Class.extend({

    stateInfo: null,
    battleInfo : null,

    endTime:0,

    ctor: function() {},

    RecvReskingguildGameToClinetMessage: function(msg) {
        cc.log("-----------------1 " + JSON.stringify(msg));


        this.stateInfo = msg;
        var panel = Mgr.uiMgr.GetPanelByType(TaijiPanelExt.PanelName);
        if (panel) {
            panel.UpdateView(EnumGrossipType.TYPE_GUILD);
        }
    },

    RecvReskingguildTopGameToClinetMessage: function(msg) {
        cc.log("-----------------2 " + JSON.stringify(msg));
    },

    RecvReskingguildTaskGameToClinetMessage: function(msg) {
        this.battleInfo = msg;

        this.endTime = Mgr.login.GetServerTime()/1000  + msg.remandtime;
        cc.log("-----------------3 " + JSON.stringify(msg));
    },

    /// 活动类型传活动大厅中的type值
    SendReqkingguildClientToGameMessage: function(msg) {
        var msg = new ReqkingguildClientToGameMessage();
        Mgr.msgMgr.Send(msg);
    },

    SendReqkingguildEnterClientToGameMessage: function(data) {

        var msg = new ReqkingguildEnterClientToGameMessage();
        for (var key in data) {
            msg[key] = data[key];
        }

        Mgr.msgMgr.Send(msg);
    },

    SendReqkingguildGetRewardToGameMessage: function(data) {
        var msg = new ReqkingguildGetRewardToGameMessage();
        Mgr.msgMgr.Send(msg);

    },

    OnMapStartChanged:function(mapId,type){
        if(type == -1) return;

        // 如果飞进了帮会争霸副本
        var zoneType = Mgr.sceneMap.GetZoneTypeByMapId(mapId);
        if(zoneType == EnumZoneType.TYPE_KINGGUID){
            Mgr.uiMgr.HidePanelByType(TaijiPanelExt.PanelName);
        }
    },
    OnMapReadyChanged:function(){
        // 如果飞进了帮会争霸副本
        if(Mgr.sceneMap.ZoneType() != EnumZoneType.TYPE_KINGGUID){
            return;
        }

    },
    OnMapChanged:function(){
        // 如果飞进了帮会争霸副本
        if(Mgr.sceneMap.ZoneType() != EnumZoneType.TYPE_KINGGUID){
            return;
        }
        // 找点怪打打
        var list = Mgr.sceneObj.oRoundMonsterList.oHashList.aList;
        var boss,normal
        for(var v of list){
            if(!v.IsDeadState()){
                if( v.IsBoss() ){
                    boss = v;
                }else{
                    normal = v;
                }
            }
        }
        if(boss) {
            Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, boss.oServPt, AutoPathParam.CreateAutoFight());
        }else if(normal) {
            Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, normal.oServPt, AutoPathParam.CreateAutoFight());
        }
    },

    canAttackMonster:function(){
        if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_KINGGUID){
            if( this.battleInfo && this.battleInfo.ocguildlist ){
                for( var i = 0, len = this.battleInfo.ocguildlist.length; i < len; i++ ){
                    if( Mgr.player.mainPlayer.guildId.Equal(this.battleInfo.ocguildlist[i]) )       //如果有占领帮旗 就不打怪了
                        return false;
                }
            }
        }
        return true;
    }
});