var ShuiJingShopPanelExt = ShuiJingShopPanel.extend ( {
	_className:"ShuiJingShopPanelExt",

	_listView:null,
	_itemlist:[],

	ctor:function(){
		this._super();
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
        this.isShowTween = true;
	},

	Init:function(){
        ShuiJingShopPanel.prototype.Init.call(this);

        this.InitList();

        this.imgKuang.setTouchEnabled(true);
        this.imgKuang.addClickEventListener(function () {
            var panel=Mgr.uiMgr.ShowPanelByType(MoneyTipsExt.PanelName,UIMgr.PANEL_LAYER_POP);
            panel.SetMoney(ShopUtil.GetMoneyTypeByShop(EnumShopType.CRYSTAL_SHOP));
            var pos =this.getWorldPosition();
            panel.x=pos.x;
            panel.y=pos.y+40;
        });

        this.btnClose.addClickEventListener(function(){
            EngineMgr.uiMgr.HidePanelByType(ShuiJingShopPanelExt.PanelName);
        });
	},

    OnShow:function(){
        this._super();
        Mgr.shop.SendReqShopListMessage(EnumShopType.CRYSTAL_SHOP);
        this.ArryGoods();
    },

	InitList:function(){
		if(!this._listView){
            this._listView = new ccui.ScrollView();
            this._listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._listView.setTouchEnabled(true);					//触摸开启
            this._listView.inertiaScrollEnabled = false; 			//滚动惯性
            this._listView.setScrollBarEnabled(false);				//滚动条
            this._listView.setBounceEnabled(true);					//边界回弹
            this.imgContent.addChild(this._listView);
		}
	},

    ArryGoods:function(){
		var list = Mgr.shop.GetGoodsByHs(EnumShopType.CRYSTAL_SHOP);
        if (list == null) {
            Mgr.shop.witeShop=6;
            Mgr.shop.SendReqShopListMessage(EnumShopType.CRYSTAL_SHOP);
            return;
        }

        this.UpdateMoney();

        var _height = 0;
        for(var i = 0; i < list.length; i++){
        	if(!this._itemlist[i]){
                var item = new ShuiJingShoplistExt();
                item.LoadPanel();
                _height = item.uiHeight;
                item.x = i%2*item.uiWidth;
                item.y = Math.ceil(list.length/2)*_height - Math.ceil((i+1)/2)*_height;
                this._listView.addChild(item);
                this._itemlist.push(item);
			}
            this._itemlist[i].SetGoods(list[i]);
		}
        this._listView.setSize(cc.size(this.imgContent.uiWidth, this.imgContent.uiHeight));
        this._listView.setInnerContainerSize(cc.size(this.imgContent.uiWidth, Math.ceil(list.length/2) * _height));
	},

    UpdateMoney:function(){
        var attribute = Mgr.mainPlayer.attributeData;
        this.labShuZi.SetString(TextUtil.NumberCutLength( attribute.GetAttribute(EnumMoney.CRYSTAL, AttributeData.Money),7));
    },

} );
ShuiJingShopPanelExt.PanelName = "ShuiJingShopPanelExt";
PanelClassDic["ShuiJingShopPanelExt"] = ShuiJingShopPanelExt;
