﻿var MailModMgr = MailModMgr || cc.Class.extend({
	mailList:null,
	mailPanel:null,
	shortcutPanel:null,
	ctor:function() {

	},

	RecvResAllMailsMessage:function(msg) {
		this.mailList = this._GetMailList();
		var isNewMail = false;
		var count = 0;
		var len = msg.mailBriefInfos.length;
		for ( var i = 0; i < len; i++ )
		{
			msg.mailBriefInfos[i].isSelected = false;
			msg.mailBriefInfos[i].isReaded = false;
			msg.mailBriefInfos[i].isChecked = false;
			this.mailList.Put(msg.mailBriefInfos[i].mailInfoId,msg.mailBriefInfos[i]);
			if(!msg.mailBriefInfos[i].isReceive&& msg.mailBriefInfos[i].items.length>0)
			{
				isNewMail = true;
				count++;
			}
		}
		if(this._GetShortcutPanel())
		{
			this._GetShortcutPanel().GetNewMailNotice(isNewMail,count);
		}
	},

	RecvResMailDetailInfoMessage:function(msg) {
		var yjPanel = this._GetMailpanel();
		if( yjPanel && yjPanel.visible )
		{
			yjPanel.youjianPanel.SetData(msg.mailDetailInfo);
		}
	},

	RecvResRecevieNewMailMessage:function(msg) {
		msg.mailInstance.isSelected = false;
		msg.mailInstance.isReaded = false;
		msg.mailInstance.isChecked = false;
		this._GetMailList().Put(msg.mailInstance.mailInfoId,msg.mailInstance);

        this.UpdateNewMailNotice();

        // 获取到新邮件的一些自动处理
        var mail = msg.mailInstance;
        switch(mail.type){
            case EnumMailType.CROSS_TEAM_ZONE:
                // 跨服组队副本奖励直接打开自动领取,都可以不加入到列表吧
                if(!mail.isReceive){
                    Mgr.mail.SendReqReceiveMailMessage([mail.mailInfoId]);
                    return;
                }
            default:break;
        }
	},
    /// 更新新邮件提示
    UpdateNewMailNotice:function(){
        var isNewMail = false;
        var count = 0;
        var items = this.mailList.Values();
        for(var i = 0,len = items.length; i<len;i++ )
        {
            if(!items[i].isReceive && items[i].items.length > 0)
            {
                isNewMail = true;
                count++
            }
        }
        if(this._GetShortcutPanel())
        {
            this._GetShortcutPanel().GetNewMailNotice(isNewMail,count);
        }
    },

	RecvResGetMailAttachmentSueccessMessage:function(msg) {
        var mailList = this._GetMailList();
        var mail = mailList.Get(msg.mailId);
        /// 默认自动删除处理
        if(mail && mail.type == EnumMailType.CROSS_TEAM_ZONE){
            mailList.Remove(msg.mailId);
            this.UpdateNewMailNotice();
        }

        var yjPanel = this._GetMailpanel();
        if(yjPanel && yjPanel.youjianPanel) yjPanel.youjianPanel.ReceivedUpdateInfo(msg);
	},

	SendReqGetMailAttachmentMessage:function(id) {
		var msg=new ReqGetMailAttachmentMessage();
		msg.mailId=id;
		Mgr.msgMgr.Send( msg );
	},

	SendReqReceiveMailMessage:function(id) {
		var msg = new ReqReceiveMailMessage();
		msg.mailIds=id;
		Mgr.msgMgr.Send( msg );
	},
	SendReqRDelMailMessage:function(mailIds) {
		var msg = new ReqRDelMailMessage();
		msg.mailIds = mailIds;
		Mgr.msgMgr.Send(msg);
	},

	SendResSendMailPublicToGameMessage:function(msg) {
	},
	_GetMailpanel:function()
	{
		if( !this.mailPanel)
		{
			this.mailPanel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
		}
		return this.mailPanel;
	},
	_GetMailList:function()
	{
		if( !this.mailList )
		{
			this.mailList = new HashMap();
		}
		return this.mailList;
	},
	_GetShortcutPanel:function()
	{
		if(!this.shortcutPanel)
		{
			this.shortcutPanel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName);
		}
		return this.shortcutPanel;
	}
});