var QiuHunExt = QiuHun.extend ( {
    _className:"QiuHunExt",
    ctor:function(){
        this._super();
        this.modelPanelType = 2
    },
    Init:function(){
        this._super();

        this.btnClose.addClickEventListener(_=>{
            Mgr.marriage.SendReqProposeResponseMessage(this.data.fromPlayerId,this.data.marriageType,false)
            EngineMgr.uiMgr.HidePanel(this)
        });
        this.btn1.addClickEventListener(_=>{
            Mgr.marriage.SendReqProposeResponseMessage(this.data.fromPlayerId,this.data.marriageType,true)
            EngineMgr.uiMgr.HidePanel(this)
        });

        this.gridArr = [ this.grid1 ]
        this.$X = this.grid1.x + this.grid1.width / 2
        this.$Y = this.grid1.y + this.grid1.height / 2
    },
    SetData:function(data){
        this.data = data

        var index = data.marriageType
        var v = Mgr.player.mainPlayer.job == 1 ? "她" : "他"

        var MARRIAGE_NAME = ["温馨婚礼","喜庆婚礼","豪华婚礼",]
        var globalC24 = Q_global.Get(20024)
        var awards = JSON.parse(globalC24.q_string_value)
        awards = awards[index]
        awards = awards.filter(v=>{
            return v.job == null || v.job == Mgr.player.mainPlayer.job;
        })

        for(let i = 0;i < Math.max(this.gridArr.length,awards.length);++i){
            let grid = this.gridArr[i]
            if(!grid){
                grid = UIUtil.CloneUI(this.grid1)
                this.grid1.parent.addChild(grid)
                this.gridArr[i] = grid;
            }
            if(awards[i]){
                var item = ItemUtil.ItemConfigToItem(awards[i]);
                GridUtil.SetItemGrid(grid, item);

                grid.visible = true
            }else{
                grid.visible = false
            }
        }
        /// 显示的
        var array = this.gridArr.filter(v=>v.visible);
        var interval = 90
        var width = array.length * interval / 2
        array.forEach((v,k)=>{
            v.x = this.$X - width + k * interval
        })

        UIUtil.ConnectLabelHtmlText(this.lab1,[data.fromPlayerName,v,MARRIAGE_NAME[index]])
    },
} );
QiuHunExt.PanelName = "QiuHunExt";
PanelClassDic["QiuHunExt"] = QiuHunExt;
