var MarriageModMgr = MarriageModMgr || cc.Class.extend({ 
    ctor:function() {
		this.onGiftInfo = new signals.Signal();
    },

    CheckMarryGiftWarn:function(){
        if(this.giftState == -1
            || this.giftState == -2
        ) return false;

        if(!this.giftRecord) return false;

        var data = this.giftRecord.find(v=>{
            var isSelf = v.playerId.Equal(Mgr.player.mainPlayer.sid);
            return isSelf;
        })
        if(!data) return false;

        var getTime = data.time;
        var date = Mgr.login.GetServerDate();
        var getDate = new Date();
        getDate.setFullYear(parseInt(getTime/10000));
        getDate.setMonth(parseInt(getTime/100)%100 - 1);
        getDate.setDate(getTime%100);
        getDate.setHours(0);
        getDate.setMinutes(0);
        getDate.setSeconds(0);

        var index = Math.floor((date.getTime() - getDate.getTime()) / 86400000);
        var isGot = Mgr.marriage.giftState >> index & 0x1;
        return Array.from({length:index + 1}).findIndex((v,k)=>{
            return !(Mgr.marriage.giftState >> k & 0x1);
        }) != -1
    },

    GetMarriageInfo:function(){ return this.$marriageInfo; },

    /// 求婚通知
    RecvResProposeNoticeMessage:function(msg) {
        cc.log("RecvResProposeNoticeMessage",msg.fromPlayerId, msg.fromPlayerName, msg.marriageType);

        var p = EngineMgr.uiMgr.ShowPanelByType(QiuHunExt.PanelName)
        if(p) p.SetData(msg)
    },

    RecvResMarriagePanelMessage:function(msg) {
        var beMarried = this.$marriageInfo;
        this.$marriageInfo = {
            $time			: 0					,
            marryId			: msg.marryId		,
            marriageType	: msg.marriageType	,
            marryTime		: msg.marryTime		,
            divorceTime		: msg.divorceTime	,
            targetName		: (msg.playerJob1 != Mgr.player.mainPlayer.job)?msg.playerName1:msg.playerName2,
            targetJob		: (msg.playerJob1 != Mgr.player.mainPlayer.job)?msg.playerJob1:msg.playerJob2,
            mineName		: (msg.playerJob1 == Mgr.player.mainPlayer.job)?msg.playerName1:msg.playerName2,
            resData			: (msg.playerJob1 != Mgr.player.mainPlayer.job)?msg.resDataA:msg.resDataB,
            mineResData			: (msg.playerJob1 != Mgr.player.mainPlayer.job)?msg.resDataB:msg.resDataA,
            getResLevel : function(type){
                for(let i = 0;i < this.resData.length;i+=2){
                    if(this.resData[i] == type) return this.resData[i + 1]
                }
                return 0;
            },
            getMyResLevel : function(type){
                for(let i = 0;i < this.mineResData.length;i+=2){
                    if(this.mineResData[i] == type) return this.mineResData[i + 1]
                }
                return 0;
            },
            getTargetId:function(){
                return (msg.playerJob1 != Mgr.player.mainPlayer.job)?msg.playerId1:msg.playerId2
            },
            getTargetFightPower:function(){
                var p = (msg.playerJob1 != Mgr.player.mainPlayer.job)?msg.playerFightPowerA:msg.playerFightPowerB
                return p.toString(10) || "0"
            },
            getTargetBrief:function(){
                this.updateTargetBrief()

                return this.targetBrief;
            },
            getTargetLevel:function(){
                return (msg.playerJob1 != Mgr.player.mainPlayer.job)?msg.playerLevelA:msg.playerLevelB
            },
            setTargetBrief:function(target){
                this.targetBrief = target
            },
            updateTargetBrief:function(){
                if(new Date() - this.$time < 30000) return;
                this.$time = new Date();

                Mgr.player.SendReqPlayerBriefMessage([
                    this.getTargetId()
                ],EnumBriefType.MARRIAGE);
            },
        }

        switch(msg.sendType){
            case 0:{
                this.$marriageInfo.updateTargetBrief()
            } break;
            case 1:{
                this.$marriageInfo.updateTargetBrief()
                if(!beMarried){
                    EngineMgr.uiMgr.ShowPanelByType(XiJieLiangYuanExt.PanelName)
                }else{
                    Mgr.tips.ShowNotice("再次求婚成功")
                }
            } break;
            case 2:{
                this.$marriageInfo = null;
                Mgr.tips.ShowNotice("你已经离婚了")
            } break;
        }

        GameEventMgr.DispatchEvent(msg.getId(),msg)

        /// 更新自己的场景效果
        var player = Mgr.sceneObj.FindObject(Mgr.mainPlayer.nGid );
        switch(msg.sendType){
            case 0:
            case 1:{
                var list = Q_marry_aureole.GetList()

                let lvl = list.find(v=>{
                    return this.$marriageInfo.getMyResLevel(v.q_id) > 0
                })
                player.spouseName = this.$marriageInfo.targetName
                player.marryExteriorId = 0
                player.aureoleId = lvl ? lvl.q_id : 0
                player.marriageId = this.$marriageInfo.marryId
                break
            }
            case 2:
                player.spouseName = ""
                player.marryExteriorId = 0
                player.aureoleId = 0
                player.marriageId = null
                break;
        }
        player.SetSpouseNameShow(player.spouseName)
        if(player.marriageId){
             Mgr.sceneObj.CreateHalo(player);
        }else{
             Mgr.sceneObj.DeleteHalo({
                marriageId : beMarried.marryId,
             })
        }
    },
    /// 他人结婚通知
    RecvResMarriageNoticePanelMessage:function(msg){
        if(this.$marriageInfo && msg.marryId.Equal(this.$marriageInfo.marryId)){
            return
        }
        var p = EngineMgr.uiMgr.ShowPanelByType(MarriageCongratulateExt.PanelName);
        p.SetData(msg)
    },

	/**
	 * 离婚通知
	 * @param msg
	 * @constructor
	 */
	RecvResDivorceNoticeMessage:function(msg) {
        var self = this
        var str = "您的对象向你提出了离婚请求，是否同意？"
        AlertExt.Show(str, TipsEnum.BUTTON_SURE_AND_FALSE, {
            _onFunc: function() {
                self.SendReqDivorceResponseMessage(1)
            }.bind(this),
            _offFunc: function() {
                self.SendReqDivorceResponseMessage(0)
            }
        });
        AlertExt.SetButtonTitle("同意","不同意")
	},

    RecvResChangeTokenSucMessage:function(msg) {
        GameEventMgr.DispatchEvent(msg.getId(),msg)
    },

	RecvResProposeValidSucMessage:function(msg) {
        GameEventMgr.DispatchEvent(msg.getId())

        if(this.$marriageType != null){
            this.SendReqProposeMessage(msg.toPlayerId,this.$marriageType,1)
            this.$marriageType = null
        }
	},

	RecvResNoticeVisitorMessage:function(msg) {
	},

	RecvResVisitZoneMarryInfoMessage:function(msg) {
	},

	RecvResMarryExteriorInfoMessage:function(msg) {
		var player = Mgr.sceneObj.FindObject(msg.playerId);
		if( player ){
			player.marryExteriorId = info.exteriorId;
			player.RefreshShowBody();
		}
	},

	RecvResMarryGiftInfoMessage:function(msg) {
		this.giftState = msg.state;
		this.giftRecord = [];
		for( var i = 0; i < msg.timeA.length; i++ )
			this.giftRecord.push({time:msg.timeA[i], playerId:msg.AId});
		for( var i = 0; i < msg.timeB.length; i++ )
			this.giftRecord.push({time:msg.timeB[i], playerId:msg.BId});
		this.giftRecord.sort((a, b)=>a.time-b.time);
		this.onGiftInfo.dispatch();
	},

    RecvResConfessionPanelInfoMessage:function(msg){
        GameEventMgr.DispatchEvent(msg.getId(),msg)
    },

    RecvResConfessionRankingMessage:function(msg){
        GameEventMgr.DispatchEvent(msg.getId(),msg)
    },
    /// 表白广播
    RecvResConfessionInfoBroadcastMessage:function(msg){
        /// 过滤自己
        if(msg.senderId.Equal(Mgr.player.mainPlayer.sid)){
            return
        }

        var p = EngineMgr.uiMgr.ShowPanelByType(BiaoBaiEffectPanelExt.PanelName)
        if(p) p.SetData(msg)
    },

	/**
	 * 发起求婚
	 * @param id
	 * @param type
	 * @constructor
	 */
	SendReqProposeMessage:function(id, type,validType) {
        this.$marriageType = type

		var msg = new ReqProposeMessage();
		msg.toPlayerId = id;
		msg.marriageType = type;
		msg.validType = validType;
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 回应求婚
	 * @param id
	 * @param type
	 * @param agree
	 * @constructor
	 */
	SendReqProposeResponseMessage:function(id, type, agree) {
		var msg = new ReqProposeResponseMessage();
		msg.fromPlayerId = id;
		msg.marriageType = type;
		msg.isAgree = agree;
		Mgr.msgMgr.Send(msg);
	},

	SendReqChangeTokenMessage:function(msg) {
        var msg = new ReqChangeTokenMessage();
        msg.itemModel = 0;
        Mgr.msgMgr.Send(msg);
	},

	/**
	 * 请求离婚  ( 0协议离婚  1强制离婚 )
	 * @param type
	 * @constructor
	 */
	SendReqDivorceMessage:function(type) {
		var msg = new ReqDivorceMessage();
		msg.type = type;
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 回应离婚  ( 0不同意  1同意 )
	 * @param agree
	 * @constructor
	 */
	SendReqDivorceResponseMessage:function(agree) {
		var msg = new ReqDivorceResponseMessage();
		msg.isAgree = agree;
		Mgr.msgMgr.Send(msg);
	},

	SendReqVisitWeddingMessage:function(msg) {	
	},

	/**
	 * 穿戴外线
	 * @param showId
	 * @constructor
	 */
	SendReqChangMarryExteriorMessage:function(showId) {
		var msg = new ReqChangMarryExteriorMessage();
		msg.exteriorId = showId;
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 购买投资
	 * @constructor
	 */
	SendReqBuyGiftMessage:function() {
		Mgr.msgMgr.Send(new ReqBuyGiftMessage());
	},

	/**
	 * 领取投资奖励
	 * @param day
	 * @constructor
	 */
	SendReqGetGiftMessage:function(day) {
		var msg = new ReqGetGiftMessage();
		msg.day = day;
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 结婚礼包升级
	 * @param id
	 * @param type
	 * @constructor
	 */
	SendReqAgainProposeMessage:function(id, type,validType) {
        this.$marriageType = type

		var msg = new ReqAgainProposeMessage();
		msg.toPlayerId = id;
		msg.marriageType = type;
		msg.validType = 0;
		Mgr.msgMgr.Send(msg);
	},

    /// 请求表白
    SendReqConfessionToPlayerMessage:function(targetId,itemId,content){
        var msg = new ReqConfessionToPlayerMessage()
        msg.reciveId = targetId; // 目标玩家的id
        msg.itemModel = itemId; // 表白道具
        msg.content = content; // 表白内容
        Mgr.msgMgr.Send(msg);

        GameEventMgr.DispatchEvent(msg.getId(),msg)
    },
    /// 请求表白墙信息
    SendReqConfessionPanelInfoMessage:function(type,start,num){
        var msg = new ReqConfessionPanelInfoMessage();
        msg.type = type; // 1所有的表白，2我的表白，3对我的表白
        msg.start = start; // 开始索引 0开始
        msg.limit = num; // 请求的长度
        Mgr.msgMgr.Send(msg);
    },
    /// 请求表白排行信息
    SendReqConfessionRanking:function(type){
        var msg = new ReqConfessionRankingMessage();
        msg.type = type; // 1男榜 2女榜
        Mgr.msgMgr.Send(msg);
    },
    SendReqMarriageZhuFuMessage:function(marryId,opType){
        var msg = new ReqMarriageZhuFuMessage()
        msg.marryId = marryId;
        msg.opType = opType;
        Mgr.msgMgr.Send(msg);
    },
});