var FuBenPanelExt = FuBenPanel.extend ( {
    _className:"FuBenPanelExt",
    ctor:function(){
        this._super();

        this.$type = EnumZoneType.TYPE_QINGYUAN
    },
    GetStoryConfig:function(){
        if(this.$storyC) return this.$storyC;
        /// 预先不知道是那个配置
        var zoneArr = Q_zone.GetList();
        zoneArr = zoneArr.filter(v=>v.q_zone_type == this.$type);
        var zoneC = zoneArr.find(v=>Q_story.Get(v.q_id))

        this.$storyC = Q_story.Get(zoneC.q_id)
        return this.$storyC;
    },

    Init:function(){
        this._super();

        this.btnWenHao.addClickEventListener(_=>{
            AlertTipsExt.Show(
                "1.需要夫妻<font color='#0900d1'>双方组队<font color='#3a2707'>方可将进入夫妻副本.\n"
                + "2.副本掉落婚戒升级材料,通关科获得更多材料奖励.\n"
                + "3.夫妻每天有<font color='#0900d1'>一次<font color='#3a2707'>免费的副本进入次数,也可以花费元宝购买额外进入次数.\n"
            );
        })
        UIUtil.ConnectLabelHtmlText(this.labword111		,["必须伴侣组队才可进入副本，任意一方购买次数，另一方可获得相应次数"])
        /// 购买次数
        this.btnJiahao.addClickEventListener(_=>{
            var data = Mgr.zoneteam.GetZoneTeamInfo(this.$type)

            var buynum = data ? data.buynum : 0
            var storyC = this.GetStoryConfig()

            if(buynum >= storyC.q_num_buy){
                Mgr.tips.ShowNotice("今日可购买次数已用尽！！！");
                return;
            }

            var cost = JSON.parse(storyC.q_cost_buy)
            cost = cost[buynum][0]

            var str = TextUtil.FormatStr("是否花费{@}元宝购买一次进入副本机会？",[cost]);
            AlertExt.Show(str, TipsEnum.BUTTON_SURE_AND_FALSE, {
                _onFunc: function() {
                    Mgr.zoneteam.SendReqZoneTeamBuyClinetToGameMessage(this.$type);
                }.bind(this),
                _offFunc: function() {}
            });
        })
        this.btnQuit.addClickEventListener(_=>{
            /// 退出队伍
            Mgr.zoneteam.SendReqZoneTeamLeaveClientToGameMessage(this.$type);
        })
        this.btnStart.addClickEventListener(_=>{
            var data = Mgr.zoneteam.GetZoneTeamInfo(this.$type)
            var leftnum = data ? data.leftnum : 0
            if(leftnum == 0){
                Mgr.tips.ShowNotice("可用次数不足！！！");
                return
            }

            /// 开始战斗
            Mgr.zoneteam.SendReqZoneTeamStarClientToGameMessage(this.$type);
        })
        this.btnCreate.addClickEventListener(this.OnActionCreate$Invite.bind(this));

        this.gridArr = [ this.grid1 ]
        this.$X = this.grid1.x + this.grid1.width / 2
        this.$Y = this.grid1.y + this.grid1.height / 2

        /// 更新道具显示
        this.UpdateAwardsPreview()
    },
    OnShow:function(){
        this._super();

        GameEventMgr.AddEventListener(this,EnumEventType.GAME_ZONETEAM_UPDATE_TEAMINFO,this.OnUpdateTeamInfo.bind(this))

        /// 更新队伍信息
        Mgr.zoneteam.SendReqZoneTeamClientToGameMessage(this.$type);

        this.$initial = false;
        this.UpdateTeamView()
    },
    OnHide:function(){
        this._super();

        GameEventMgr.RemoveEventListener(this);
    },
    OnUpdateTeamInfo:function(msg){
        if(msg.zonetype != this.$type) return;

        this.$initial = true;
        this.UpdateTeamView()
    },
    /// 创建队伍并邀请对方
    OnActionCreate$Invite:function(){
        var MI = Mgr.marriage.GetMarriageInfo()
        if(!MI){
            Mgr.tips.ShowNotice("对不起，未结婚无法准备。");
            return
        }
        /// 等待
        if(!this.$initial){
            return;
        }

        var data = Mgr.zoneteam.GetZoneTeamInfo(this.$type)
        var MT = data && data.getMyTeam()
        var TT = data && data.getPlayerTeamInfo(MI.getTargetId())

        var myTeam = data && data.getMyTeam()
        if(MT){
            if(TT){
                if(MT.teamId.Equal(TT.teamId)){
                    // 理论不会出现
                }else{
                    /// 离开当前队伍加入之
                    Mgr.zoneteam.SendReqZoneTeamLeaveClientToGameMessage(this.$type);
                    Mgr.zoneteam.SendReqZoneTeamJoinClientToGameMessage(
                        TT.teamId
                        ,true
                        ,this.$type
                    )
                }
            }else{
                ///对方没有队伍要求邀请他
                Mgr.zoneteam.SendReqZoneTeamInvitePlayerToGameMessage(
                    MI.getTargetId()
                    , this.$type
                )
            }
        }else{
            if(TT){
                /// 我没有队伍对方有加入之
                Mgr.zoneteam.SendReqZoneTeamJoinClientToGameMessage(
                    TT.teamId
                    ,true
                    ,this.$type
                )
            }else{
                /// 我没有队伍对方有也没有，创建并要求他
                Mgr.zoneteam.SendReqZoneTeamCreatClientToGameMessage(
                    false   /// 只要要求玩家才能进入
                    ,false  /// 自动开始
                    ,this.$type
                )
                Mgr.zoneteam.SendReqZoneTeamInvitePlayerToGameMessage(
                    MI.getTargetId()
                    , this.$type
                )
            }
        }
    },
    /// 更新道具显示
    UpdateAwardsPreview:function(){
        var storyC = this.GetStoryConfig()
        var awards = JSON.parse(storyC.q_item_show)
        for(let i = 0;i < Math.max(this.gridArr.length,awards.length);++i){
            let grid = this.gridArr[i]
            if(!grid){
                grid = UIUtil.CloneUI(this.grid1)
                this.grid1.parent.addChild(grid)
                this.gridArr[i] = grid;
            }
            let award = awards[i]
            if(award){
                var item = ItemUtil.ItemIdToItem(award[0],award[1],award[2]);
                GridUtil.SetItemGrid(grid, item);

                grid.visible = true
            }else{
                grid.visible = false
            }
        }
        /// 显示的
        var array = this.gridArr.filter(v=>v.visible);
        var interval = 90
        var width = array.length * interval / 2
        array.forEach((v,k)=>{
            v.x = this.$X - width + k * interval
        })
    },
    UpdateTeamView:function(){
        var MI = Mgr.marriage.GetMarriageInfo()

        var data = Mgr.zoneteam.GetZoneTeamInfo(this.$type)
        var TT,MT = data && data.getMyTeam()

        UIUtil.ConnectLabelHtmlText(this.labword	,[data ? data.leftnum : 0])

        UIUtil.LoadImage( this.imgHead, ResUrl.GetSmallPlayerHeadUrl(Mgr.player.mainPlayer.job),false,true);
        UIUtil.ConnectLabelHtmlText(this.labname1	,[Mgr.player.mainPlayer.name, !MT?"(未准备)":""])
        this.imglab11.SetText(Mgr.fightpower.fightPower)

        if(MI){
            this.imgzudui.visible = true
            TT = data && MI && data.getPlayerTeamInfo(MI.getTargetId())
            UIUtil.LoadImage( this.imgHead1, ResUrl.GetSmallPlayerHeadUrl(MI.targetJob),false,true);
            UIUtil.ConnectLabelHtmlText(this.labname	,[MI.targetName, !TT?"(未准备)":""])
            this.imglab1.SetText(MI.getTargetFightPower())
        }else{
            this.imgzudui.visible = false
        }

        this.imgzhanli1.visible = MT
        this.imgzhanli.visible = TT

        var ready = MT && TT && MT.teamId.Equal(TT.teamId) && this.$initial;
        this.btnQuit.visible = MT
        this.btnStart.visible = ready
        this.btnCreate.visible = !ready
    },
} );
FuBenPanelExt.PanelName = "FuBenPanelExt";
PanelClassDic["FuBenPanelExt"] = FuBenPanelExt;
