var MarriageMainExt = MarriageMain.extend ( {
    _className:"MarriageMainExt",
    ctor:function(){
        this._super();
        this.modelPanelType = 2
    },
    Init:function(){
        this._super();

        this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));

        this.tabArr = [
            { type : 1	,name:"结婚"	,class : JieHunPanelExt	, x: -2,y:2,},
            { type : 6	,name:"婚戒"	,class : HunJiePanelExt	},
            { type : 2	,name:"副本"	,class : FuBenPanelExt 	},
            { type : 3	,name:"表白"	,class : BiaoBaiPanelExt	, x : 0	, y : 2	,},
            { type : 4	,name:"相思"	,class : XiangSiPanelExt	},
            { type : 5	,name:"光环"	,class : GuangHuanPanelExt	},
        ]
        var btnTem = this.sbtnJieHun
        var imgTem = this.imgBar1
        this.tabArr.forEach((v,k)=>{
            let btn = k === 0 ? btnTem : null;
            let img = k === 0 ? imgTem : null;

            if(!btn){
                btn = UIUtil.CloneUI(btnTem);
                btnTem.parent.addChild(btn);
            }else{
                btn.imgTujianWarn = this.imgTujianWarn;
            }
            if(!img){
                img = UIUtil.CloneUI(imgTem);
                imgTem.parent.addChild(img);
            }
            btn.SetText( v.name );
            btn.addClickEventListener(this.ChangePanel.bind(this,v.type));

            v.img = img;
            v.btn = btn;
            v.warn = btn.imgTujianWarn
        })
    },
    OnShow:function(){
        this._super();
        GameEventMgr.AddEventListener(this,new ResMarriagePanelMessage().getId(),this.OnCheckTabOpened.bind(this))

        this.OnCheckTabOpened();
        this.ChangePanel(this.selectedDuanzaoType);

        this.UpdateWarn();
    },
    OnHide:function(){
        this._super();
        GameEventMgr.RemoveEventListener(this);
    },
    OnCheckTabOpened:function(){
        var initY1 = this.tabArr[0].btn.y;
        var initY2 = this.tabArr[0].img.y;
        this.tabArr.forEach(function(v){
            let ret = true
            if(v.type == 6){
                ret = Mgr.marriage.GetMarriageInfo()
            }
            v.btn.visible = ret;
            if(ret){
                v.btn.y = initY1;
                v.img.y = initY2;
                initY1 -= 83;
                initY2 -= 83;
            }
        });
    },
    ChangePanel:function(type){
        // 判断开放则重选
        var btnC = this.tabArr.find(v=>v.type == type);
        if(!(btnC && btnC.btn.visible)){
            btnC = this.tabArr.find(v=>v.btn.visible);
            type = btnC && btnC.type;
        }
        this.selectedDuanzaoType = type;

        this.tabArr.forEach(function(v){
            v.btn.SetButtonState(v.type == type?"check":"uncheck");
        })

         // 中间内容
        var curPanel = this._curPanel;
        if(curPanel){
            curPanel.visible = false;
            if(curPanel.OnHide) curPanel.OnHide();
        }

        var config = this.tabArr.find(function(v){
            return v.type == type;
        });
        if(config){
            curPanel = config.panel;
            if(!curPanel && config.class){
                let p = new config.class();
                p.LoadPanel()
                p.x = config.x || 0
                p.y = config.y || 0
                this.imgContent.addChild(p)
                curPanel = config.panel = p;
            }
        }
        if(curPanel){
            this._curPanel = curPanel;
            curPanel.visible = true;
            if(curPanel.OnShow) curPanel.OnShow();
        }
    },
    /// 更新提醒
    UpdateWarn:function(){
        this.tabArr.forEach(v=>{
            if(!v.btn.visible) return;
            v.warn.visible = MarriageUtil.CheckRESWarn(v.type);
        });
    },
} );
MarriageMainExt.PanelName = "MarriageMainExt";
PanelClassDic["MarriageMainExt"] = MarriageMainExt;
