﻿var BossType = BossType || {
    //0：不显示，1：世界野外BOSS，2：地宫BOSS  3：地宫VIP 4：BOSS之家 5通缉BOSS   6 百服庆典通缉  7 恶人谷  8：年兽
    TYPE_FIELDBOSS:1,

    TYPE_DUNGEONBOSS:2,

    TYPE_DUNGEONVIPBOSS:3,

    TYPE_ERENGU:7,

    TYPE_VIPERENGU:12,
};

var BosssPanelType = BosssPanelType || {
    WORLDBOSS:1,
    ERENGU:3,
    ZHUJIANTIANXIA:4,
    VIP4ERENGU:5,
    VIP10ERENGU:6,
};

var MonsterModMgr = MonsterModMgr || cc.Class.extend({
        bossPanel: null,
        isBossDie: false,
        isFindBoss: false,
        worldBossList: null,
        worldPublicBossList: null,
        vip4ErenguBossList:null,
        vip10ErenguBossList:null,
        guildBossList: null,
        xuanShangBossList:null,
        concernBossList: null,      //关注了的Boss   k mapId  v  time   点击关注的时候压进去就好
        erenguV4BossList:null,
        erenguV10BossList:null,
        belongIco: null,           //掉落归属图标
        isFirst: true,             //登录的时候会发一个先不用
        briefPanel: null,
        GUISHU_TAG: 12345,
        curWorldBossInfo:null,
        showType:0,
        killBossNum:0,
        ctor: function () {
            this.worldBossList = new HashMap();
            this.concernBossList = new HashMap();
            this.erenguV4BossList = new HashMap();
            this.erenguV10BossList = new HashMap();
            this.worldPublicBossList = new HashMap();
            this.vip4ErenguBossList = [];
            this.vip10ErenguBossList = [];
            this.guildBossList = new HashMap();
            this.xuanShangBossList = new HashMap();
            TimerUtil.TimeUpdate(this.OnFrame, this, 1);
        },

        RecvResMonsterHpChangeMessage: function (msg) {
            this.isFindBoss = true;
            var obj = Mgr.sceneObj.FindObject(msg.monsterId.toGID());
            if (obj) {
                // var needChangeAction = mons.bossType == MonsterTypeEnum.NORMAL && mons.curHP > msg.currentHp;//普通怪物并且是血量减少了
                // if ( needChangeAction && monsV.canChangeAction( GlobalConsts.EA_WOUND ) )
                // 	monsV.setStateShow( GlobalConsts.EA_WOUND );
                obj.UpdateHp(msg.currentHp);
                Mgr.map.UpdateHp(obj);
            }
        },

        RecvResMonsterMpChangeMessage: function (msg) {

        },

        RecvResMonsterSpChangeMessage: function (msg) {
        },

        RecvResMonsterMaxHpChangeMessage: function (msg) {
            var obj = Mgr.sceneObj.FindObject(msg.monsterId.toGID());
            if (obj) {
                obj.UpdateHp(msg.currentHp, msg.maxHp);
                Mgr.map.UpdateHp(obj);
            }
        },

        RecvResMonsterMaxMpChangeMessage: function (msg) {
        },

        RecvResMonsterMaxSpChangeMessage: function (msg) {
        },

        RecvResMonsterSpeedChangeMessage: function (msg) {
            var obj = Mgr.sceneObj.FindObject(msg.monsterId.toGID());
            if (obj) {
                obj.SetMoveSpeed(msg.speed);
            }
        },

        RecvResMonsterDieMessage: function (msg) {
            TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  this._ResMonsterDieMessage, [msg], this, 0, TimeTaskMgr.TYPE_SCENE );
        },
        _ResMonsterDieMessage:function(msg){
            var gid = msg.monsterId.toGID();
            var state = msg.die;
            var killerGid = msg.killer.toGID();
            var stormType = msg.type;
            var model;
            var mons = Mgr.sceneObj.FindObject(gid);

            if (gid == Mgr.mainPlayer.oCtrlAutoFight.nAutoAttackGID)	//现在怪物死亡不会发FightFailed 锁定的怪物死亡直接clear
                Mgr.mainPlayer.oCtrlAutoFight.ClearAttackDelay();

            if (mons) {
                Mgr.player.roleHeadPanel.BossDie(mons);
                mons.UpdateHp(0);
                mons.hprate = 0;
                mons.DoDeadState();
                Mgr.map.CheckTargetOnRemove(mons);
                if (state == 3 || state == 4) {	// 3死亡  4死亡等待  2假死
                    this._HandleMosterDie(msg.monsterId);
                    if( state == 4 ){
                        model = Q_monster.Get(mons.nBodyModelId);
                        if (model) {
                            var killer = Mgr.sceneObj.FindObject(killerGid);
                            if (killer)
                                FlyBackEffect.Create(killer, mons, stormType)
                        }
                        this.BeginTweenDel(mons);
                        var zoneType = Mgr.sceneMap.ZoneType();
                        if((Mgr.monster.IsInMonsterMap() && Mgr.sceneMap.nMapId != 50001 && Mgr.sceneMap.nMapId != 50002 && Mgr.sceneMap.nMapId != 1002 && Mgr.sceneMap.nMapId != 1003) ||
                            zoneType == EnumZoneType.TYPE_JQ || zoneType == EnumZoneType.TYPE_JJ ||
                            zoneType == EnumZoneType.TYPE_JY || zoneType == EnumZoneType.TYPE_WD
                            || zoneType == EnumZoneType.TYPE_VIP || zoneType == EnumZoneType.TYPE_KFDR ||
                            zoneType == EnumZoneType.TYPE_LFDR || zoneType == EnumZoneType.TYPE_GUILDBOSS){
                            var obj = Mgr.sceneObj.FindObject(msg.monsterId.toGID());
                            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                            panel.__panel.UpdateLabel(obj.nBodyModelId);
                        }
                    }
                }
            }
        },
        _HandleMosterDie: function (monsterId) {
            if (Mgr.monster.IsInMonsterMap() && Mgr.sceneMap.nMapId != 1003 && Mgr.sceneMap.nMapId != 1002) {
                var obj = Mgr.sceneObj.FindObject(monsterId.toGID());
                this.isBossDie = true;
                this.isFindBoss = false;
                //暂时屏蔽    boss死亡后弹出提示  退出副本
                // var monster = Q_boss_world.Get(obj.nBodyModelId);
                // if (monster) {
                //     AlertExt.Show("BOSS挑战完成", TipsEnum.BUTTON_SURE_AND_FALSE,
                //         {
                //             _onFunc: function () {
                //                 Mgr.map.SendReqReturnToPreviousMapMessage();
                //             },
                //         }, 1);
                // }
//                Mgr.task._taskTrackPanel.ShowWorldBossInfo(obj, 1);
//                Mgr.task._taskTrackPanel.HideActiveData();
                Mgr.task._taskTrackPanel.UpdateView();
            }
        },
        RecvResMonsterReviveMessage: function (msg) {
            TimeTaskMgr.AddTask( TimeTaskMgr.NORMAL_PRIORITY,  this._ResMonsterReviveMessage, [msg], this, 0, TimeTaskMgr.TYPE_SCENE );
        },
        _ResMonsterReviveMessage:function(msg){
            this.isBossDie = false;
            this.isFindBoss = true;
            Mgr.sceneObj.CreateMonster(msg.monster);
            if (!Mgr.monster.IsInMonsterMap() && Mgr.monster.concernBossList.Get(msg.monster.monsterModelId)) {
                var panel = EngineMgr.uiMgr.ShowPanelByType(GuildBossMarkExt.PanelName, UIMgr.PANEL_LAYER_POP);
                var boos = msg.monster;
                var bossInfo = Q_monster.Get(boos.monsterModelId);
                panel.SetModel("BOSS 刷新", function () {
                    EngineMgr.uiMgr.HidePanelByType(GuildBossMarkExt.PanelName);
                    Mgr.monster.FindBoss(boos);
                }, bossInfo.q_name + "Lv." + bossInfo.q_grade);
            }
            else if (Mgr.monster.IsInMonsterMap()) {
                Mgr.task._taskTrackPanel.UpdateView()
            }
        },

        RecvResMonsterSayMessage: function (msg) {
        },

        RecvResMonsterDoubleNoticeMessage: function (msg) {
        },

        RecvResMonsterHpRateChangeMessage: function (msg) {
            var obj = Mgr.sceneObj.FindObject(msg.monsterId.toGID());
            if (obj) {
                obj.hpRate = msg.currentHpRate;		//理论上这里要根据血条数更新血条 页游这里没做
                obj.nCurHp = obj.nMaxHp;
                Mgr.map.UpdateHp(obj);
            }
        },

        RecvResWGBossListToClientMessage: function (msg) {
            cc.log("世界和帮会boss信息 " + msg.type);
            for (var i = 0; i < msg.worldbossList.length; ++i) {
                var info = msg.worldbossList[i];
                // cc.log("=============" + info.type + "" + info.bossWordType  +"   " + info.monsterModelId)
                if (info.type == 3) {
                    var boss = Q_boss_world.Get(info.monsterModelId);
                    if (boss && boss.q_boss_type == 2) {          //1本服  2跨服
                        this.worldPublicBossList.Put(info.monsterModelId, info);
                    }
                    else if(boss && boss.q_boss_type == BossType.TYPE_FIELDBOSS)
                    {
                        this.worldBossList.Put(info.monsterModelId, info);
                        if(this.concernBossList.Get(info.monsterModelId))
                            this.concernBossList.Put(info.monsterModelId, info);
                        // cc.log("==========monsterModelId : " + info.monsterModelId)
                    }
                    else if(boss && boss.q_boss_type == 5){
                        this.xuanShangBossList.Put(info.monsterModelId, info);
                    }
                    else if(boss && boss.q_boss_type == BossType.TYPE_VIPERENGU){
                        if(info.monsterModelId < 170 ){
                            var idex = this.isInArray(this.vip4ErenguBossList,info);
                            if(idex < 0)
                                this.vip4ErenguBossList.push(info);
                            else
                                this.vip4ErenguBossList[idex] = info;
                            if(this.erenguV4BossList.Get(info.monsterModelId))
                                this.erenguV4BossList.Put(info.monsterModelId, info);
                        }
                        else{
                            var idex = this.isInArray(this.vip10ErenguBossList,info);
                            if(idex < 0)
                                this.vip10ErenguBossList.push(info);
                            else
                                this.vip10ErenguBossList[idex] = info;
                            if(this.erenguV10BossList.Get(info.monsterModelId))
                                this.erenguV10BossList.Put(info.monsterModelId, info);
                        }
                    }
                }
                else {
                    this.guildBossList.Put(info.monsterModelId, info);
                }

                if (this.careList) {
                    for (var k = 0; k < this.careList.length; ++k) {
                        if (info.monsterModelId == this.careList[k]) {
                            this.concernBossList.Put(info.monsterModelId, info);
                            // if (info.status < 300 && info.status != 0) {
                            //     var panel = EngineMgr.uiMgr.ShowPanelByType(GuildBossMarkExt.PanelName, UIMgr.PANEL_LAYER_POP);
                            //     var boos = info;
                            //     var bossInfo = Q_monster.Get(boos.monsterModelId);
                            //     panel.SetModel("BOSS 刷新", function () {
                            //         EngineMgr.uiMgr.HidePanelByType(GuildBossMarkExt.PanelName);
                            //         Mgr.monster.FindBoss(boos);
                            //     }, bossInfo.q_name + "Lv." + bossInfo.q_grade);
                            // }
                            break;
                        }
                    }
                }

                // if(info.status<300&&info.status!=0){
                // 	//直接提示有BOSS快刷新了让他打开BOSS面板比较好
                // 	Mgr.tips.ShowNotice( "有BOSS即将刷新", 5, cc.p( 100, 300));
                // 	//EngineMgr.uiMgr.ShowPanelByType(WorldBossCueExt.PanelName,UIMgr.PANEL_LAYER_POP);
                // 	//this.briefPanel.SetData(info);
                // }
            }

            Mgr.map.miniMapPanel.UpdateWLQDWarn();//刷武林庆典红点

            var list = this.concernBossList.Values();
            list = list.concat(this.erenguV4BossList.Values());
            list = list.concat(this.erenguV10BossList.Values());
            for (var j = 0; j < list.length; ++j) {
                if (list[j].status == 0) {
                    //提示
                    var panel = EngineMgr.uiMgr.ShowPanelByType(GuildBossMarkExt.PanelName, UIMgr.PANEL_LAYER_POP);
                    (function(j){
                        panel.SetModel("BOSS 刷新", function () {
                            EngineMgr.uiMgr.HidePanelByType(GuildBossMarkExt.PanelName);
                            Mgr.monster.FindBoss(list[j]);
                        }, Q_monster.Get(list[j].monsterModelId).q_name + "Lv." + Q_monster.Get(list[j].monsterModelId).q_grade);
                    })(j);
                }
            }

            if(Mgr.uiMgr.IsPanelShow(Mgr.luckydraw.guangwuPanel) && Mgr.luckydraw.guangwuPanel._curType == 55){
                Mgr.luckydraw.guangwuPanel.panelMgr[55].RefreshPanel(this.xuanShangBossList);
            }


            this.careList = null;
            var panel = EngineMgr.uiMgr.GetPanelByType(WorldBossPanelExt.PanelName);
            if(panel)
                panel.SetNum(msg.killBossNum);
            this.killBossNum = msg.killBossNum;
            this.clearnum = msg.clearnum;
            if (this.isFirst) {
                this.isFirst = false;
                return;
            }
        },

        isInArray:function(arr,value){
            for(var i = 0; i < arr.length; i++){
                if(value.monsterModelId === arr[i].monsterModelId){
                    return i;
                }
            }
            return -1;
        },

        RecvResWGBossInfoToClientMessage: function (msg) {
            //单独收到的BOSS
            if (Mgr.monster.concernBossList.Get(msg.wgBossInfo.monsterModelId) && msg.notifyType == 1) {
                {
                    var panel = EngineMgr.uiMgr.ShowPanelByType(GuildBossMarkExt.PanelName, UIMgr.PANEL_LAYER_POP);
                    var boos = msg.wgBossInfo;
                    var bossInfo = Q_monster.Get(boos.monsterModelId);
                    panel.SetModel("BOSS 刷新", function () {
                        EngineMgr.uiMgr.HidePanelByType(GuildBossMarkExt.PanelName);
                        Mgr.monster.FindBoss(boos);
                    }, bossInfo.q_name + "Lv." + bossInfo.q_grade);
                }
            }

            if (msg.wgBossInfo.type == 3) {
                var boss = Q_boss_world.Get(msg.wgBossInfo.monsterModelId);
                if (boss && boss.q_boss_type == 2) {          //1本服  2跨服
                    this.worldPublicBossList.Put(msg.wgBossInfo.monsterModelId, msg.wgBossInfo);
                }
                else if(boss && boss.q_boss_type == BossType.TYPE_FIELDBOSS)
                {
                    this.worldBossList.Put(msg.wgBossInfo.monsterModelId, msg.wgBossInfo);
                    // cc.log("==========monsterModelId : " + info.monsterModelId)
                }
                else if(boss && boss.q_boss_type == 5){
                    this.xuanShangBossList.Put(msg.wgBossInfo.monsterModelId, msg.wgBossInfo);
                }
                else if(boss && boss.q_boss_type == BossType.TYPE_VIPERENGU){
                    if(msg.wgBossInfo.monsterModelId < 170 ){
                        var idex = this.isInArray(this.vip4ErenguBossList,msg.wgBossInfo);
                        if(idex < 0)
                            this.vip4ErenguBossList.push(msg.wgBossInfo);
                        else
                            this.vip4ErenguBossList[idex] = msg.wgBossInfo;
                        if(this.erenguV4BossList.Get(msg.wgBossInfo.monsterModelId))
                            this.erenguV4BossList.Put(msg.wgBossInfo.monsterModelId, msg.wgBossInfo);
                    }
                    else{
                        var idex = this.isInArray(this.vip10ErenguBossList,msg.wgBossInfo);
                        if(idex < 0)
                            this.vip10ErenguBossList.push(msg.wgBossInfo);
                        else
                            this.vip10ErenguBossList[idex] = msg.wgBossInfo;
                        if(this.erenguV10BossList.Get(msg.wgBossInfo.monsterModelId))
                            this.erenguV10BossList.Put(msg.wgBossInfo.monsterModelId, msg.wgBossInfo);
                    }
                }
            }
            // else if(msg.wgBossInfo.type == 6){
            //     if(msg.wgBossInfo.monsterModelId < 170 ){
            //         var idex = this.isInArray(this.vip4ErenguBossList,msg.wgBossInfo);
            //         if(idex < 0)
            //             this.vip4ErenguBossList.push(msg.wgBossInfo);
            //         else
            //             this.vip4ErenguBossList[idex] = msg.wgBossInfo;
            //         if(this.erenguV4BossList.Get(info.monsterModelId))
            //             this.erenguV4BossList.Put(info.monsterModelId, info);
            //     }
            //     else{
            //         var idex = this.isInArray(this.vip10ErenguBossList,msg.wgBossInfo);
            //         if(idex < 0)
            //             this.vip10ErenguBossList.push(msg.wgBossInfo);
            //         else
            //             this.vip10ErenguBossList[idex] = msg.wgBossInfo;
            //         if(this.erenguV10BossList.Get(info.monsterModelId))
            //             this.erenguV10BossList.Put(info.monsterModelId, info);
            //     }
            // }

            if(Mgr.monster.IsInMonsterMap() && Mgr.sceneMap.nMapId != 50001 && Mgr.sceneMap.nMapId != 50002
                && Mgr.sceneMap.nMapId != 1003 && Mgr.sceneMap.nMapId != 1002){
                var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                if(panel.__panel.UpdateBossHead)
                    panel.__panel.UpdateBossHead(msg.wgBossInfo);
            }
            else if(Mgr.monster.IsInMonsterMap() && (Mgr.sceneMap.nMapId == 50001 || Mgr.sceneMap.nMapId == 50002
                && Mgr.sceneMap.nMapId != 1003 && Mgr.sceneMap.nMapId != 1002)){
                var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                if(panel.__panel && panel.__panel.UpdateVipErenGuBossLabel)
                    panel.__panel.UpdateVipErenGuBossLabel(msg.wgBossInfo);
            }

            Mgr.map.miniMapPanel.UpdateWLQDWarn();//刷武林庆典红点
        },
        _damageInfos: null,
        RecvResBossDamageInfosToClientMessage: function (msg) {//SetBelongShowIco
            // for(var i = 0; i < msg.BossDamageInfos.length; i++){
            //     cc,log( msg.BossDamageInfos[i].playerName + "   " + msg.BossDamageInfos[i].damage)
            // }
            if(Mgr.monster.IsInMonsterMap()){
                // cc.log("铸剑天下 排名 " + Mgr.task._taskTrackPanel.__teamPanel)
                if((Mgr.sceneMap.nMapId == 1003 || Mgr.sceneMap.nMapId == 1002) && Mgr.task._taskTrackPanel.__teamPanel){
                    // Mgr.task._taskTrackPanel.__teamPanel.RefreshRanking(msg);
                    var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                    panel.__teamPanel.RefreshRanking(msg);
                }
                else{
                    var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                    panel.__teamPanel.RefreshRanking(msg);
                }
            }
            if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_KFDR){
                var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                panel.__teamPanel.RefreshRanking(msg);
            }
            if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_GUILDBOSS){
                var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                panel.__teamPanel.RefreshRanking(msg);
            }

            this._damageInfos = msg;
            //屏蔽掉落归属
            // var isRankChanged = this._IsRankChanged(msg);//排名改变则刷新
            // if (this.IsInMonsterMap() && isRankChanged) {
            //     this._HandleBossDamageInfo();
            // }
        },

        undergroundBossInfos:null,
		RecvResUndergroundBossPanelInfosToClientMessage:function(msg){
			cc.log("===============发送地宫boss刷新信息===============  "  + msg.refreshTime  +"  "  + msg.bossInfos.length +"  "  +  Mgr.sceneMap.nMapId);
			var list = [];
			for(var i = 0; i < msg.bossInfos.length; i++){
                var item = {q_monster: msg.bossInfos[i].modeldId, q_num: 1, q_order: i, q_center_x: msg.bossInfos[i].x, q_center_y: msg.bossInfos[i].y, isLive: msg.bossInfos[i].alive};
                list.push(item);
            }
            this.undergroundBossInfos = msg.bossInfos;
			if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_ERENGU){
                // if(Mgr.task._taskTrackPanel.__panel.RefreshBossInfo){
                //     Mgr.task._taskTrackPanel.__panel.RefreshBossInfo(msg);
                // }
                var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                panel.__panel.InitView(list);
                // panel.__panel.SetTime(Q_zone.Get(Mgr.zone._curZoneId).q_exist_time/1000);
            }
            else if(Mgr.monster.IsInMonsterMap() && (Mgr.sceneMap.nMapId == 1003 || Mgr.sceneMap.nMapId == 1002)){
                // if(Mgr.task._taskTrackPanel.__panel.RefreshBossInfo){
                //     Mgr.task._taskTrackPanel.__panel.RefreshBossInfo(msg);
                // }
                this.refreshTime = msg.refreshTime;
                var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                panel.__panel.InitView(list);
            }
            //
			// for(var i = 0; i < msg.bossInfos.length; i++){
			// 	cc.log("  modeldId " + msg.bossInfos[i].modeldId)
			// 	cc.log(msg.bossInfos[i].modeldId)
			// 	cc.log(msg.bossInfos[i].x)
			// 	cc.log(msg.bossInfos[i].y)
			// 	cc.log(msg.bossInfos[i].alive)
			// }
		},

        GetNextBossInfo:function(){
            if( this.undergroundBossInfos ){
                for( var i = 0, len = this.undergroundBossInfos.length; i < len; i++ ){
                    var info = this.undergroundBossInfos[i];
                    if( info.alive == 1 )
                        return info;
                }
            }
            return null;
        },

		RecvResMyBossDamageInfoToClientMessage:function(msg){
			// cc.log("===============发送自己对BOSS伤害信息===============  "  + msg.totalDamage);
		},

        RecvResUndergroundBossAllDieToClientMessage:function(msg){
            if (Mgr.sceneMap.nMapId == 1003 || Mgr.sceneMap.nMapId == 1002){
                Mgr.tips.ShowNotice("首领全部死亡，退出活动地图");
                Mgr.map.SendReqReturnToPreviousMapMessage();
            }
        },

        SendReqQueryBossListMessage: function (type, bosstype) {
            this.isBossDie = false;
            var msg = new ReqQueryBossListMessage();
            // if (!type) {
            //     msg.type = 0;
            // }
            // else {
            //     msg.type = type;
            // }
            // if (!bosstype) {
            //     msg.bossWordType = 0;
            // }
            // else {
            //     msg.bossWordType = bosstype;
            // }
            msg.type = type;
            msg.bossType = bosstype;
            Mgr.msgMgr.Send(msg);
        },

        SendReqErrorMonsterToGameMessage: function (msg) {

        },

        //单独请求
        SendReqQueryBossAloneMessage: function (monsterID, mapID, line) {
            var msg = new ReqQueryBossAloneMessage();
            msg.monsterModel = monsterID; // 怪物ModelId
            msg.mapModel = mapID; // 地图ModelId
            msg.lineId = line; // 地图线
            Mgr.msgMgr.Send(msg);
        },
        /// 请求手动清理疲劳值
        SendReqClearKillMonsterNumMessage:function(type){
            var msg = new ReqClearKillMonsterNumMessage();
            msg.type = type;
            Mgr.msgMgr.Send(msg);
        },

        // RecvResMyBossDamageInfoToClientMessage:function(msg){
        //     zz.Error("this message is not in handle  -->  RecvResMyBossDamageInfoToClientMessage");
        // },

        ///////////////////////////////////////////////
        ClickSceneMonster: function (monster) {
            if (monster.IsDeadState() == false) {//} && monster.nCurHp > 0){
                Mgr.map.SelTarget(monster);
                Mgr.mainPlayer.oCtrlAutoFight.SetLockAutoAttackTarget(monster);
            }
        },

        _delTimeIds: null,
        _delRemoveHash: null,
        BeginTweenDel: function (obj) {
            this.StopTweenDel(obj.nGid);
            if (!this._delTimeIds)
                this._delTimeIds = new HashMap();
            var delay = 1.5;
            if (obj.IsBoss())
                delay = 3;
            var timeId = TimerUtil.SetTimeout(this, this.OnTweenEnd, delay * 1000, obj);
            this._delTimeIds.Put(obj.nGid, timeId);
        },

        OnTweenEnd: function (obj) {
            this._delTimeIds.Remove(obj.nGid);
            if (!this._delRemoveHash)
                this._delRemoveHash = new HashMap();
            this._delRemoveHash.Put(obj.nGid, TimerUtil.SetTimeout(Mgr.sceneObj, Mgr.sceneObj.DeleteObject, 3000, obj.nGid));
            obj.RemoveAllSkillEffect();
            obj.removeFromParent();
            obj.oShadow.removeFromParent();
        },

        StopTweenDel: function (gid, stopFly) {
            var monster = Mgr.sceneObj.FindObject(gid);
            if( monster && monster.flyEffect && stopFly )
                monster.flyEffect.OnFlyEnd();
            if (this._delTimeIds) {
                var timeId = this._delTimeIds.Get(gid);
                if (timeId)
                    TimerUtil.ClearTimeout(timeId);
            }
            if (this._delRemoveHash) {
                var timeId = this._delRemoveHash.Get(gid);
                if (timeId)
                    TimerUtil.ClearTimeout(timeId);
                this._delRemoveHash.Remove(gid);
            }
        },
        UpBossTime: function () {
            //本服BOSS
            var list = this.worldBossList.Values();
            for (var i = 0; i < list.length; ++i) {
                var time = list[i].status;
                if (time <= 0) {
                    continue;
                }
                else {
                    list[i].status--;
                }
            }
            //跨服的
            list = this.worldPublicBossList.Values();
            for (var i = 0; i < list.length; ++i) {
                var time = list[i].status;
                if (time <= 0) {
                    continue;
                }
                else {
                    list[i].status--;
                }
            }
            //vip4恶人谷
            list = this.vip4ErenguBossList;
            for (var i = 0; i < list.length; ++i) {
                var time = list[i].status;
                if (time <= 0) {
                    continue;
                }
                else {
                    list[i].status--;
                }
            }
            //vip7恶人谷
            list = this.vip10ErenguBossList;
            for (var i = 0; i < list.length; ++i) {
                var time = list[i].status;
                if (time <= 0) {
                    continue;
                }
                else {
                    list[i].status--;
                }
            }

            //更新关注时间
            list = this.concernBossList.Values();
            list = list.concat(this.erenguV4BossList.Values());
            list = list.concat(this.erenguV10BossList.Values());
            for (var i = 0; i < list.length; ++i) {
                if (list[i].status > 0 && list[i].status < 3) {// 0-3秒提示
                    //提示
                    var panel = EngineMgr.uiMgr.ShowPanelByType(GuildBossMarkExt.PanelName, UIMgr.PANEL_LAYER_POP);
                    (function(i){
                        panel.SetModel("BOSS 刷新", function () {
                            EngineMgr.uiMgr.HidePanelByType(GuildBossMarkExt.PanelName);
                            Mgr.monster.FindBoss(list[i]);
                        }, Q_monster.Get(list[i].monsterModelId).q_name + "Lv." + Q_monster.Get(list[i].monsterModelId).q_grade);
                    })(i);
                }
            }
        },
        OnFrame: function () {
            this.UpBossTime();
            var panel = Mgr.uiMgr.GetPanelByType(WorldBossPanelExt.PanelName);
            if(panel && (panel.showType == BosssPanelType.WORLDBOSS ||panel.showType == BosssPanelType.VIP4ERENGU||panel.showType == BosssPanelType.VIP10ERENGU)){
                panel.showPanel.OnFrame();
            }
        },
        FindBoss: function (info) {
            var config = Q_boss_world.Get(info.monsterModelId);
            if (config && config.q_boss_type == 1) {
                var gridpt = new cc.p(config.q_appear_x, config.q_appear_y);
                Mgr.mainPlayer.oCtrlAutoPath.targetMapId = config.q_appear_map;
                Mgr.mainPlayer.oCtrlAutoPath.targetPos = gridpt;
                Mgr.mainPlayer.oCtrlAutoPath.autoMapParam = AutoPathParam.CreateAutoFight();
                Mgr.map.SendReqGoldMapTransMessage(config.q_appear_map);
                Mgr.monster.curWorldBossInfo = info;
                // Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(info.mapModelId, gridpt,  AutoPathParam.CreateAutoFight());
            }
            else if(config && config.q_boss_type == 12){
                if(config.q_boss_id < 170){
                    Mgr.map.SendReqGoldMapTransMessage(50001);
                    // EngineMgr.uiMgr.HidePanelByType( WorldBossPanelExt.PanelName );
                }
                else{
                    Mgr.map.SendReqGoldMapTransMessage(50002);
                    // EngineMgr.uiMgr.HidePanelByType( WorldBossPanelExt.PanelName );
                }
            }
        },
        _monsterMapList: null,
        IsInMonsterMap: function () {
            if (!this._monsterMapList) {
                this._monsterMapList = new HashMap();
                var list = Q_boss_world.GetList();
                for (var i = 0; i < list.length; i++) {
                    //if(list[i].q_boss_type == 2)//跨服BOSS
                    {
                        this._monsterMapList.Put(list[i].q_appear_map, list[i]);
                    }
                }
            }
            return this._monsterMapList.Get(Mgr.sceneMap.nMapId);
        },
        //掉落归属展示
        _HandleBossDamageInfo: function () {
            var msg = this._damageInfos;
            if (!msg) {
                return;
            }
            if (msg.totalDamage > 0) {
                var list = msg.BossDamageInfos;
                var count = 0;
                list.sort(function (a, b) {
                    return b.damage - a.damage;
                });
                for (var i = 0; i < list.length; i++) {
                    var player = Mgr.sceneObj.FindObject(list[i].playerId.toGID());
                    if (player) {
                        this._currentBelongerId = list[i].playerId;
                        count = i;
                        if (!player.getChildByTag(this.GUISHU_TAG)) {
                            var guishu = this._GetDiaoluoGuishuIco();
                            player.addChild(guishu, 10, this.GUISHU_TAG);
                        }
                        break;
                    }
                }
            }
        },
        _GetDiaoluoGuishuIco: function () {
            var url = "other/zhujiemian/image/diaoluoguishu.png";
            var guishu = ccui.ImageView.create(url, 1);
            guishu.y = 250;
            return guishu;
        },
        _currentBelongerId: null,
        _IsRankChanged: function (msg) {
            if (!this._currentBelongerId) {
                return true;
            }
            var list = msg.BossDamageInfos;
            list.sort(function (a, b) {
                return b.damage - a.damage;
            });
            for (var i = 0; i < list.length; i++) {
                if (i == 0 && list[i].playerId.toGID() == this._currentBelongerId.toGID()) {
                    return false;
                }
                else {
                    var player = Mgr.sceneObj.FindObject(this._currentBelongerId.toGID());
                    if (player) {
                        var guishu = player.getChildByTag(this.GUISHU_TAG);
                        if (guishu) {
                            player.removeChildByTag(this.GUISHU_TAG);
                        }
                        return true;
                    }
                }
            }
            return true;
        },
        RemoveBossDamageBelongTag: function (otherPlayer) {
            this._currentBelongerId = null;
            if (!Mgr.player.mainPlayer.sid) {
                return;
            }
            var player = Mgr.sceneObj.FindObject(Mgr.player.mainPlayer.sid.toGID());
            if (player) {
                var guishu = player.getChildByTag(this.GUISHU_TAG);
                if (guishu) {
                    player.removeChildByTag(this.GUISHU_TAG);
                }
            }
            if (otherPlayer) {
                var guishu = otherPlayer.getChildByTag(this.GUISHU_TAG);
                if (guishu) {
                    otherPlayer.removeChildByTag(this.GUISHU_TAG);
                }
            }
        },

        GetWorldBossIdByMapId:function(mapId){
            var list = Q_boss_world.GetList();
            for(var i = 0; i < list.length; i++){
                if(list[i].q_appear_map == mapId){
                    if(!this.curWorldBossInfo)
                        this.curWorldBossInfo = {};
                    this.curWorldBossInfo.monsterModelId = list[i].q_boss_id;
                    return true;
                }
            }
            return false;
        }
    });