﻿var OfflineresModMgr = OfflineresModMgr || cc.Class.extend({
    activeDataHash:null,
    canFind:false,
    canFindNum:0,
    reqDay:null,

	_exp:0,

	offlinePanel:null,



	ctor:function() {	
//		this._super();
// 		this._offlineAward = {};
	},

	RecvResOfflineAwardPanelMessage:function(msg) {
        this._exp = msg.offlineAward.exp;
        this.UpdataOfflineWarn();
        
        if (this.offlinePanel)
            this.offlinePanel.SetData(msg.offlineAward.totalTime, msg.offlineAward.exp);
    },

	IsOfflineWarn:function(){
    	if(this._exp > 0)
    		return true;
    	return false;
	},

	UpdataOfflineWarn:function(){
        var panel = Mgr.uiMgr.GetPanelByType( MiniMapPanelExt.PanelName );
        if ( panel )
            panel.UpdataFuliWarn(FuliTypeEnum.TYPE_OFFLINE);
	},

	RecvResOfflineResPanelMessage:function(msg) {
		var infos = [];
		var aaa = msg;
		for(var i = 0; i < msg.zoneBackInfo.length; i++){
			if(msg.zoneBackInfo[i].state > 0)
				infos.push(msg.zoneBackInfo[i]);
		}
		if( !this.activeDataHash ){
			this.activeDataHash = new HashMap();
		}
		this._listLen = infos.length;
		this.canFindNum = 0;
		for( var i = 0; i < this._listLen; i++ )
		{
			if(!(infos[ i ].state == 0 || (infos[ i ].state == 1 && infos[ i ].count == 0 ))){
				this.activeDataHash.Put(infos[ i ].type, infos[ i ]);
				if(infos[ i ].count > 0)
					this.canFindNum ++;
			}
		}
		if(this.canFindNum>0)
			this.canFind = true;
		else
			this.canFind = false;
		if(Mgr.gossip.taijiPanel && Mgr.uiMgr.IsPanelShow( Mgr.gossip.taijiPanel )){
			Mgr.gossip.taijiPanel.UpdataFindRedCircle();
			if(Mgr.gossip.taijiPanel.curView == EnumGrossipType.TYPE_FIND)
				Mgr.gossip.taijiPanel.findPanel.SetDate();
		}
	},

	RecvResGetOfflineSucMessage:function(msg) {
        var data = this.activeDataHash.Get(msg.type);
        data.count = 0;
        this.activeDataHash.Put(msg.type, data);
        this.canFindNum--;
        if(this.canFindNum>0)
            this.canFind = true;
        else
            this.canFind = false;
        if(Mgr.gossip.taijiPanel && Mgr.uiMgr.IsPanelShow( Mgr.gossip.taijiPanel ) ){
            Mgr.gossip.taijiPanel.UpdataFindRedCircle();
            if(Mgr.gossip.taijiPanel.curView == EnumGrossipType.TYPE_FIND)
                Mgr.gossip.taijiPanel.findPanel.SetOneDate(msg.type);
        }
	},

	SendReqGetOfflineAwardMessage:function(multiple) {
    	var msg = new ReqGetOfflineAwardMessage();
    	msg.multiple = multiple;
        Mgr.msgMgr.Send( msg );
	},

	SendReqGetOfflineResZoneBackMessage:function(id,costType) {
        var msg = new ReqGetOfflineResZoneBackMessage();
        msg.type = id;
        msg.costType = costType;
        Mgr.msgMgr.Send( msg );
	},

	SendReqGetOfflineOneKeyMessage:function(msg) {	
	},

	SendReqOpenOfflineResPanelMessage:function() {	
		var date = Mgr.login.GetServerDate();
		if( this.reqDay == null || (date.getDate() == this.reqDay.getDate() && date.getHours() >= 5 && this.reqDay.getHours() <= 5) || (date.getDate() > this.reqDay.getDate() && date.getHours() >= 5) ){//早上5点刷新
			var msg = new ReqOpenOfflineResPanelMessage();
			Mgr.msgMgr.Send( msg );
			this.R = date;
		}
	},

	SendReqOpenOfflineAwardPanelMessage:function() {
        Mgr.msgMgr.Send(new ReqOpenOfflineAwardPanelMessage());
	}
});