var ChengHaoListExt = ChengHaoList.extend ( {
	_className: "ChengHaoListExt" ,
	_btnArr:[],
	_parentIndex:0,
	ctor: function (data,_parentIndex) {
		this.data = data;
		this._parentIndex = _parentIndex;
		this._super();
	} ,
	Init: function () {
		ChengHaoList.prototype.Init.call( this );
		this.setSwallowTouches(false);
		this._SetProperty();
		this._ChangeButton(-1);
		this._HandelButton();
		this._SetInfo();
		this._SetTempTextTitle(this.data);
		cc.log("init_data.q_id=> "+this.data.q_id);
	} ,
	_SetProperty: function ()
	{
		this._btnArr = [this.btnJiHuo,this.btnUp,this.btnDown];
		this.imgCue.visible = false;
		this.imgChengHao.ignoreContentAdaptWithSize(true);
	},
	_SetTempTextTitle:function(data) {
		var eff = this.getChildByTag(1000);
		if(eff)
		{
			SkillEffect.Delete(eff);
		}
		if ( data.q_art_type == 0 )//图片
		{
			this.imgChengHao.visible = true;
			var url = "other/zhujiemian/chenghao/"+data.q_art+".png";
			EngineMgr.uiMgr.GetAsynResByUrl( url, function(){
				this.imgChengHao.loadTexture(url, 1);
			}, this)

		}
		else if ( data.q_art_type == 1 )//特效
		{
			//TimerUtil.TimeUpdate(function()
			//{
			//	this._AddAnimationEff();
			//}.bind(this),this,0.2,1);//不给个延时第一次进来，动画类型的称号无法显�			this.imgChengHao.visible = false;
            // 不给延迟，延迟会导致快速刷新时，删除不及时
            this._AddAnimationEff();
		}
	},
	_AddAnimationEff:function()
	{
		this.imgChengHao.visible = false;
		var title = EffectUtil.GetShowEffect(this.data.q_art, EffectUtil.ENUM_TYPE_UI, true ,-1);
		title.x = 130
		title.y = 58
		this.addChild(title,100,1000);
	},
	_HandelButton:function()
	{
		var self = this;
		for(var i = 0; i < this._btnArr.length;i++ )
		{
			this._btnArr[i].index = i;
			this._btnArr[i].addTouchEventListener(function(target,state)
			{
				if(state == ccui.Widget.TOUCH_ENDED)
				{
					self._ChangeButton(target.index,target);
				}
			});
		}
		//this.setTouchEnabled(true);
		//this.addClickEventListener(function()
		//{
		//	EngineMgr.uiMgr.ShowPanelByType(ChenghaoTipsPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
		//	var panel = Mgr.uiMgr.GetPanelByType(ChenghaoTipsPanelExt.PanelName);
		//	panel.UpdateInformation(self.data);
		//});
	},
	_SetInfo:function()
	{
		this.imgWeihuode.visible = false;
		var pData = Mgr.player.mainPlayer;
		if(pData.titleId == this.data.q_id)
		{
			this._ChangeButton(2);
			this.imgCue.visible = true;
		}
		else if(pData.titleId != this.data.q_id && Mgr.title.titleList.Get(this.data.q_id))
		{
			this._ChangeButton(1);
			this.imgCue.visible = false;
		}
		else
		{
			this._ChangeButton(0);
			this.imgCue.visible = false;
			var str = this.data.q_activate_item;
			if(str != null){
                var regexp = /\d+/;
                var id = Number(str.match(regexp));
                var regext1 = /,\d+/;
                var numArr = str.match(regext1);
                var needNum = numArr[0].substring(1,numArr[0].length);
                var cNum = Mgr.title.GetTouxianUpItemCount(id);
                if(cNum>=needNum)
                {
                    this._ChangeButton(0);
                }
                else
                {
                    this._ChangeButton(-1);
                    this.imgWeihuode.visible = true;
                }
			}
		}
	},
	_ChangeButton:function(index,target)
	{
		for(var i = 0; i < this._btnArr.length; i++ )
		{
			if(index == i)
			{
				this._btnArr[i].visible = true;
			}
			else
			{
				this._btnArr[i].visible = false;
			}
		}
		if(!target){return;}
		cc.log("index= "+index+" q_id=> "+this.data.q_id);
		switch (index)
		{
			case 0://激活
			{
				Mgr.title.SendReqActivateTitleMessage(this.data.q_id);
				break;
			}
			case 1://穿戴
			{
				Mgr.title.SendReqUseTitleMessage(this.data.q_id,1);
				break;
			}
			case 2://卸下
			{
				Mgr.title.SendReqUseTitleMessage(this.data.q_id,0);
				break;
			}
			default : break;
		}
	},
	UpdateInfo:function(data,_parentIndex)
	{
		//if(data.q_id == this.data.q_id){return;}
		this.data = data;
		this._parentIndex = _parentIndex;
		this._SetInfo();
        this._SetTempTextTitle(data);
	}
} );
ChengHaoListExt.PanelName = "ChengHaoListExt";
PanelClassDic["ChengHaoListExt"] = ChengHaoListExt;
