var ChengHaoPanelExt = ChengHaoPanel.extend ( {
	_className: "ChengHaoPanelExt" ,
	_listviewArr: [] ,
	_btnArr: [] ,
	index: 0 ,
	_btnStates: [MUICheckBox.STATE_CHECK , MUICheckBox.STATE_UNCHECK] ,
	ctor: function () {
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.setSwallowTouches(false);
	} ,
	Init: function () {
		ChengHaoPanel.prototype.Init.call( this );
		if(!this._listView){
			this._listView = new ccui.ScrollView();
			this._listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
			this._listView.setTouchEnabled(true);					//触摸开启
			this._listView.setScrollBarEnabled(false);				//滚动条
			this._listView.setBounceEnabled(true);					//边界回弹
			this._listView.setAnchorPoint(0, 1);
			this._listView.x = this.sbtnGot.x - 10;
			this._listView.y = this.sbtnGot.y + this.sbtnGot.uiHeight + 5;
			this._listView.setContentSize(cc.size(this.sbtnGot.uiWidth + 10, 410));
			this.addChild(this._listView);
		}
		this._HandleButton();
		this._HandleTableview();
	} ,
	_HandleButton: function () {
		var self = this;
		this.btnClose.addClickEventListener( function () {
			EngineMgr.uiMgr.HidePanel( self );
		} );
		var list = Mgr.title.GetTitleData();
		this.sbtnGot.removeFromParent();
		this.sbtnHuoDong.removeFromParent();
		this.sbtnVIP.removeFromParent();
		this.sbtnChengJiu.removeFromParent();
		this.imgCue.removeFromParent();
		this.imgCue1.removeFromParent();
		this.imgCue2.removeFromParent();
		this._btnArr = [this.sbtnGot , this.sbtnHuoDong , this.sbtnVIP , this.sbtnChengJiu];
		var totalH = ( this.sbtnGot.uiHeight + 3 ) * list.length + 5;
		this._listView.setInnerContainerSize(cc.size(this.sbtnGot.uiWidth + 10, totalH));
		for (var i = 0; i < list.length; i ++) {
			if( !this._btnArr[i] ){
				this._btnArr[i] = this.sbtnGot.clone();
			}
			var btn = this._btnArr[i];
			btn.index = i;
			btn.x = 10;
			btn.y = totalH - 5 - ( i + 1) * ( btn.uiHeight + 3 );
			btn.SetTextFontSize( EnumFontFormat.FONTSIZE_BUTTON );
			if( list[i] && list[i].length )
				btn.SetText( list[i][0].q_subfield_name );
			btn.addTouchEventListener( function (target , state)
			{
				if ( state == ccui.Widget.TOUCH_ENDED )
				{
					if(self.index == target.index)
					{
						return;
					}
					self.index = target.index;
					self.UpdateTableview();
					self._ChangeButton( target.index );
				}
			} );
			var redPoint = this.imgCue.clone();
			redPoint.y = btn.uiHeight - redPoint.uiHeight + 10;
			redPoint.x = -15;
			redPoint.visible = false;
			btn.redPoint = redPoint;
			btn.addChild( redPoint );

			this._listView.addChild(btn);
		}
	} ,
	_ChangeButton: function (index) {
		for (var i = 0; i < this._btnArr.length; i ++) {
			if ( index == i ) {
				this._btnArr[i].SetButtonState( this._btnStates[0] );
				this._btnArr[i].SetTextColor( EnumFontFormat.COMMON_COLOR01 );
			}
			else {
				this._btnArr[i].SetButtonState( this._btnStates[1] );
				this._btnArr[i].SetTextColor( EnumFontFormat.COMMON_COLOR02 );
			}
		}
		this.labCue1.visible = false;
		if(index == 0)
		{
			this._SetLabCue1Visible();
		}
	} ,
	RefreshList: function () {
		this._Show();
	} ,
	_HandleTableview: function ()
	{
		this.index = 0;
		this.q_titleData = Mgr.title.GetTitleData();

		this._GetGotData();
        this._SortData();
		this._RefreshTitleArr();
		var tableview = new cc.TableView(this,cc.size(this.imgRight.width,this.imgRight.height - 16));
		tableview.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
		tableview.setDelegate(this);
		tableview.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
		tableview.y = 10;
		this.imgRight.addChild(tableview);
		tableview.setBounceable(true);
		this.tableview = tableview;

	},
	UpdateTableview:function()
	{
		this.tableview.reloadData();
	},
	tableCellTouched: function (table, cell) {
		var data = cell.getChildren()[0].data;
		EngineMgr.uiMgr.ShowPanelByType(ChenghaoTipsPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
		var panel = Mgr.uiMgr.GetPanelByType(ChenghaoTipsPanelExt.PanelName);
		panel.UpdateInformation(data);
	},

	tableCellSizeForIndex: function (table, idx) {
		return cc.size(590,114);
	},
	tableCellAtIndex: function (table, idx) {
		var cell = table.dequeueCell();
		if (!cell) {
			cell=cc.Sprite();
			var item=new ChengHaoListExt(this.q_titleData[this.index][idx],this.index);
			item.LoadPanel();
			cell.item=item;
			cell.addChild(item);
		} else {
			cell.item.UpdateInfo(this.q_titleData[this.index][idx],this.index);
		}
		return cell;
	},
	numberOfCellsInTableView: function (table) {
		var len = this.q_titleData[this.index].length;
		return len;
	},
	_GetGotData:function()
	{
		var itemList = Mgr.title.GetTitleListData().Values();
		itemList.sort(function(a,b)
		{
			return a.q_id - b.q_id;
		});
		this.q_titleData[0] = itemList;
	},
	_RefreshTitleArr:function()
	{
		//var len = this.q_titleData.length;
		//for(var i = 0; i < len;i++)
		//{
		//	var item = this.q_titleData[i];
		//	for(var j = 0,len01=item.length; j<len01; j++)
		//	{
		//		if(item[j])
		//		{
		//			var bool = Mgr.title.titleList.Get(item[j].q_id);
		//			if(bool)
		//			{
		//				this.q_titleData[i].splice(j,1);
		//			}
		//		}
		//	}
		//}
		this._ControlRedPoint();
	},
	_ControlRedPoint:function()
	{
		var len = this.q_titleData.length;
		for(var i = 1; i < len;i++)
		{
			this._btnArr[i].redPoint.visible = false;
			var item = this.q_titleData[i];
			for(var j = 0,len01=item.length; j<len01; j++)
			{
				var str = item[j].q_activate_item;
                if(!str){
                    continue;
                }
				var regexp = /\d+/;
				var id = Number(str.match(regexp));
				var regext1 = /,\d+/;
				var numArr = str.match(regext1);
				var needNum = numArr[0].substring(1,numArr[0].length);
				var cNum = Mgr.backpack.GetItemNumber(id);
				var bool = Mgr.title.titleList.Get(id);
				if(cNum>=needNum &&!bool)
				{
					this._btnArr[i].redPoint.visible = true;
				}
			}
		}
		var panel = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName );
		if(panel && panel.visible)
		{
			panel._equipPanel.ShowChengHaoRedPoint();
		}
	},
	_SetLabCue1Visible:function()
	{
		this.labCue1.visible = false;
		if(this.q_titleData[0].length<1)
		{
			this.labCue1.visible = true;
		}
	},
	_SortData:function()
	{
		for(var i = 0; i<this.q_titleData.length;i++)
		{
			for(var j = 0; j <this.q_titleData[i].length;j++)
			{
				if(!this.q_titleData[i][j])
				{
					this.q_titleData[i].splice(j,1);
					continue;
				}
				this.q_titleData[i][j].gotNum = 0;
				var str = this.q_titleData[i][j].q_activate_item;
                if(!str){
                    continue;
                }
				var regexp = /\d+/;
				var id = Number(str.match(regexp));
				var cNum = Mgr.title.GetTouxianUpItemCount(id);
				if(cNum>0)
				{
					this.q_titleData[i][j].gotNum = 2;
				}
				var item = Mgr.title.titleList.Get(id);
				if(item)
				{
					this.q_titleData[i][j].gotNum = 1;
				}
			}
		}
		for(var i = 0; i<this.q_titleData.length;i++)
		{
			this.q_titleData[i].sort(function(a,b)
			{
				return b.gotNum - a.gotNum;
			});
		}
	},
	_Show:function()
	{
		this._RefreshTitleArr();
		this._GetGotData();
		this._SortData();
		this.UpdateTableview();
		this._SetLabCue1Visible();
	},
	OnShow:function()
	{
		this.index = 0;
		this._ChangeButton(0);
		this._Show();
	}
} );
ChengHaoPanelExt.PanelName = "ChengHaoPanelExt";
PanelClassDic["ChengHaoPanelExt"] = ChengHaoPanelExt;








