var TouXianPanelExt = TouXianPanel.extend ( {
	_className:"TouXianPanelExt",
	_data:null,
	_upNeedPower:0,
	_currentItemCount:0,
	_needItemsCount:0,
	_isNeedTool:false,
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
	},
	Init:function()
	{
		TouXianPanel.prototype.Init.call(this);
		this._HandleButton();
		this._SetBaseProperty();
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnClose.addClickEventListener(function(){
			Mgr.title.SendReqHeadTitleInfoMessage();
			EngineMgr.uiMgr.HidePanel(self);
		});
		//晋升
		this.btnJinSheng.addClickEventListener(function()
		{
			if(Mgr.fightpower.fightPower<self._upNeedPower)
			{
				Mgr.tips.ShowNotice("战力不足");
				return;
			}
			else if(self._currentItemCount<self._needItemsCount&&this._isNeedTool)
			{
				Mgr.tips.ShowNotice("所需道具不足");
				return;
			}
			Mgr.title.SendReqHeadTitleUpLevelMessage();
		});
	},
	UpdateInformation:function(data)
	{
		if(data)
		{
			//data = data ? data : Q_monicker.Get(1);
			this._data = data;
			if(data.q_level + 1 < 10)
			{
				this._SetCurrentData(data);
				var dataUp = Q_monicker.Get(data.q_level+1);
				this._SetCurrentDataUp(dataUp);
			}
			else
			{
				this._SetCurrentData(data);
				this._SetCurrentDataUp(data);
			}
		}
		else
		{
			var dataUp = Q_monicker.Get(1);
			this._SetCurrentDataUp(dataUp);
			this.labName.SetString("无");
			this.labAtk.SetString("0");
			this.labDef.SetString("0");
			this.labHp.SetString("0");
			this.labName.visible = true;
			this.img1.visible = false;
		}
	},
	_SetCurrentData:function(data)
	{
		// var name = TextUtil.RemoveHTMLTag(data.q_name);
		// this.labName1.SetString("【"+name+"】");
		this.labName.visible = false;
		this.img1.visible = true;
		UIUtil.LoadImage( this.img1, "other/touxian/word/" + data.q_level + ".png");
		this._SetData(data.q_attribute,this.labAtk,this.labDef,this.labHp);
	},
	_SetCurrentDataUp:function(data)
	{
		// var name = TextUtil.RemoveHTMLTag(data.q_name);
		// this.labName2.SetString("【"+name+"】");
		UIUtil.LoadImage( this.img2, "other/touxian/word/" + data.q_level + ".png");
		this._SetData(data.q_attribute,this.labAtk1,this.labDef1,this.labHp1);
		this.labNeed.SetString(Mgr.fightpower.fightPower);
		this.labTotal.SetString("/"+data.q_fighting_capacity);
		this._SetTextColor(Mgr.fightpower.fightPower,data.q_fighting_capacity,this.labNeed);
		this._upNeedPower = data.q_fighting_capacity;
		this._SetNeedUpItem(data);
	},
	_SetData:function(str,attackTxt,defendTxt,hpTxt)
	{
		str = str.substring( 1 , str.length - 1 );
		var array = str.split( "," );
		for (var i = 0; i < array.length; ++ i)
		{
			array[i] = array[i].split( ":" );
			switch (array[i][0])
			{
				case "1":
					attackTxt.SetString("+" + array[i][1] );
					break;
				case "2":
					defendTxt.SetString("+" + array[i][1] );
					break;
				case "7":
					hpTxt.SetString("+" + array[i][1] );
					break;
				defend:break;
			}
		}
	},
	_ConctrolToolShow:function(isShow)
	{
		this.lab5.visible = isShow;
		this.grid1.visible = isShow;
		this.labNum.visible = isShow;
		this.labNum1.visible = isShow;
	},
	_SetNeedUpItem:function(data)
	{
		var str = 	data.q_activate_item;
		if(JSON.parse(str ).length<1)
		{
			this._isNeedTool = false;
			this._ConctrolToolShow(false);
			return;
		}
		this._isNeedTool = true;
		this._ConctrolToolShow(true);
		var regexp = /,\d+/;
		var mm = str.match(regexp);
		var needItemCount = String(mm).replace(",","");
		var regexp01 = /\d+/;
		var nn = str.match(regexp01);
		var itemModelId = Number(nn);
		var needItem = ItemUtil.ItemIdToItem(itemModelId,1);
		GridUtil.SetItemGrid(this.grid1,needItem,null,null,null,null,false);
		this._currentItemCount = Mgr.title.GetTouxianUpItemCount(itemModelId);
		this._needItemsCount = needItemCount;
		this.labNum.SetString(this._currentItemCount);
		this.labNum1.SetString("/"+needItemCount);
		this._SetTextColor(this._currentItemCount,needItemCount,this.labNum);
		if(needItemCount>=100)
		{
			this.labNum.x =769;
			this.labNum1.x = 812;
		}
		else if(needItemCount>=10 && needItemCount<100)
		{
			this.labNum.x =771;
			this.labNum1.x = 822;
		}
	},
	_SetTextColor:function(currentN,needN,label)
	{
		if ( currentN >= needN )
		{
			label.SetColor( EnumFontFormat.COMMON_COLOR04 );
		}
		else
		{
			label.SetColor( EnumFontFormat.COMMON_COLOR09 );
		}
	},
	OnShow:function()
	{
		Mgr.title.SendReqHeadTitleInfoMessage();
	},
	_SetBaseProperty:function()
	{
		this.labNeed.SetColor(EnumFontFormat.COMMON_COLOR09);
		this.labTotal.SetColor(EnumFontFormat.COMMON_COLOR01);
		this.labNum.SetColor(EnumFontFormat.COMMON_COLOR01);
		this.labNum1.SetColor(EnumFontFormat.COMMON_COLOR01);
		this.btnJinSheng.SetTitleTextColor(EnumFontFormat.COMMON_COLOR05);
		this.btnJinSheng.SetTitleTextFontSize(EnumFontFormat.FONTSIZE_BUTTON);
	}
} );
TouXianPanelExt.PanelName = "TouXianPanelExt";
PanelClassDic["TouXianPanelExt"] = TouXianPanelExt;
