var ZhufuzhiInfoExt = ZhufuzhiInfo.extend ( {
	_className:"ZhufuzhiInfoExt",

	_restTime:null,
	_timerNum:null,

	_callBack:null,
	_listView:null,

	ctor:function(){
		this._super();
		this._restTime = 0;
		this._timerNum = 0;
	},

	Init:function() {
		var self = this;
		ZhufuzhiInfo.prototype.Init.call(this);

		this.labCue.SetLeading(11);
		this.gridItem.visible = false;
		this._CreateList();

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
			if ( self._callBack )
				self._callBack();
		});
		this.btnJixu.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});
		this.btnShaohou.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
			if ( self._callBack )
				self._callBack();
		});
	},

	_CreateList:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg1.width, this.imgBg1.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false);
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.setPosition(0,0);
		//list.addEventListener(this._SelectedItemEvent);
		this.imgBg1.addChild(list);
		this._listView = list;
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	SetData:function (type, callBack) {
		this._callBack = callBack;

		var mgr = Mgr.resline.GetMgrByType(type);

		var key = type.toString() + "_" + mgr.GetMaxModelId().toString() + "_" + mgr.GetStars().toString();
		var resUp = Q_resline_up.Get( key );
		var str = mgr.nowBlessnum.toString() + "/" + resUp.q_blessnum_limit.toString();
		this.labRate.SetString(str)
		//UIUtil.ConnectLabelHtmlText(this.labRate, [ mgr.nowBlessnum, 100 ]);

		var rate = parseFloat(mgr.nowBlessnum / resUp.q_blessnum_limit);
		this.progJindutiao.setPercent(rate*100)

		// time
		this._restTime = 0;
		if ( resUp.q_reset_time > 0 )
			this._restTime = Math.floor( (mgr.clearDate - Mgr.login.GetServerTime())/1000 );

		if ( this._restTime > 0 ) {
			if( this._timerNum == 0 )
				this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
		}
		this.OnTimer();

		// reward
		var q_base = Q_resline_up.Get( type + "_" + (mgr.GetLayer()+1) + "_" + mgr.GetStars().toString());
		if ( q_base.q_reward )
		var idArr = JSON.parse( q_base.q_reward );
		this._listView.removeAllItems();
		if( idArr ){
			for ( var i = 0; i != idArr.length; i++ ) {
				var json = idArr[i];
				var mid = json.mod;
				var num = json.num?json.num:0;
				var bind = json.bind?json.bind:0;

				var grid = this.gridItem.Clone();
				this._AddItem(grid);
				var item = ItemUtil.ItemIdToItem(mid,num, bind);
				GridUtil.SetItemGrid(grid,item,null,bind );
			}
		}
		// // skill
		// this.gridItem.Clean();
		// this.gridItem.setTouchEnabled(false)
		// var q_base = Q_resline.Get( type + "_" + (mgr.GetLayer()+1));
		// if ( q_base.q_skill ) {
		// 	var skillid = q_base.q_skill;
		// 	var reslineVo = new Object();
		// 	reslineVo.reslinetype = type;
		// 	reslineVo.reslinelayer = (mgr.GetLayer()+1);
		// 	var lv = mgr.GetSysSkillLev( skillid );
		// 	GridUtil.SetSkillGridByMID( this.gridItem, skillid, lv, reslineVo );
		// }
	},

	OnTimer:function () {
		this._restTime--;
		if ( this._restTime <= 0 )
		{
			this._restTime = 0;
			TimerUtil.ClearTimeUpdate(this._timerNum, this);
			this._timerNum = 0;
		}
		var second = this._restTime;
		var H =  Math.floor(second/3600);
		var M = Math.floor(second/60%60);
		var S = Math.floor(second%60);
		UIUtil.ConnectLabelHtmlText(this.labTime, [H,M,S]);
	},
} );
ZhufuzhiInfoExt.PanelName = "ZhufuzhiInfoExt";
PanelClassDic["ZhufuzhiInfoExt"] = ZhufuzhiInfoExt;
