var RedPacketInfoExt = RedPacketCue.extend ( {
	_className:"RedPacketInfoExt",

    _listView:null,
    _listInfo:null,
    _bestPlayerId:null,

	ctor:function(){
		this._super();
	},

    Init:function(){
        RedPacketCue.prototype.Init.call(this);
        var self = this;
        this.imglabNum.SetAlign(LableAlign.RIGHT);
        this.imglabNum.x = this.imglabNum.x - 10;
        this.imglabNum.y = this.imglabNum.y + 3;
        this.btnClose.addClickEventListener(function(event){
            EngineMgr.uiMgr.HidePanel(self);
        });

        var tableView = new cc.TableView(this,cc.size(this.imgList.uiWidth, this.imgList.uiHeight));
        tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
        tableView.setDelegate(this);
        tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
        tableView.x=this.imgList.x;
        tableView.y=this.imgList.y;
        tableView.uiWidth=this.imgList.uiWidth;
        tableView.uiHeight=this.imgList.uiHeight;
        this._listView=tableView;
        this.addChild(tableView);

        this.imglabNum.y -= this.imglabNum.uiHeight/2;
    },

    SetData:function(info){
        this._listInfo = info.reveivers;
        this._bestPlayerId = info.bestPlayerid;
        UIUtil.ConnectLabelHtmlText(this.labGold, [info.itemNum]);
        this.imglabNum.SetString(info.myNum);

        if(this._listView){
            this._listView.reloadData();
        }
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(435,70);
    },
    tableCellAtIndex: function (table, idx) {
        var info = this._listInfo;
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            var item=new RedPacketListInfoExt();
            item.LoadPanel();
            cell.item=item;
            cell.addChild(item);
        }
        cell.item.imgBg.setVisible(idx % 2 == 0);
        cell.item.SetData(info[idx], this._bestPlayerId);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this._listInfo ? this._listInfo.length : 0;
    }
} );
RedPacketInfoExt.PanelName = "RedPacketInfoExt";
PanelClassDic["RedPacketInfoExt"] = RedPacketInfoExt;
