/**
 * 资源线辅助处理
 */
var ReslineUtil = ReslineUtil || {
        _reslineBase:null,
        _reslineBaseUp:null,
        DEFAULTSUFFIX:"_0",
        GetDynamicReslineNums:function()
        {
                var count = 0;
                for( var key in  this.ReslineData())
                        count ++;

                return count;
        },
        /**
        * 获取资源线基本数据集合
        * @return
        */
        GetReslineContainer:function(reslineType)
        {
                return this.ReslineData()[reslineType];
        },
        /**
        * 获取对应资源线升阶数据集合
        * @return
        */
        GetReslineUpVector:function(reslineType)
        {
                var resUpData = this.ReslineUpData();
                return resUpData[reslineType];
        },
        ReslineData:function()
        {
                if ( this._reslineBase == null )
                {
                        this._reslineBase = new Array();

                        var con = Q_resline.GetList();
                        for ( var i = 0; i < con.length; i ++ ) {
                                var q_resline = con[i];
                                var type = q_resline.q_id.split("_")[0];

                                if ( this._reslineBase[type] == null )
                                        this._reslineBase[type] = new Array();

                                this._reslineBase[type].push(q_resline);
                        }
                }
                return this._reslineBase;
        },
        ReslineUpData:function()
        {
            if ( this._reslineBaseUp == null )
            {
                    this._reslineBaseUp = new Array();
                    var con = Q_resline_up.GetList();
                    for ( var i = 0; i < con.length; i ++ ) {
                    	var q_resline = con[i];
                    	if ( q_resline == null )
                		{
                    		cc.log("q_resline==null is impossible:" + i);
                    		continue;
                		}
                    	
                    	var type = q_resline.q_modelID.split("_")[0];

                    	if ( this._reslineBaseUp[type] == null )
                    		this._reslineBaseUp[type] = new Array();

                    	this._reslineBaseUp[type].push(q_resline);
					}
            }
            return this._reslineBaseUp;
        }
}