///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//139201,ReqResourceEquipSetToGame 穿戴装备
//139202,ReqResourceEquipClearToGame 卸下装备

// 接收消息
//139101,ResResourceEquipChangeToClient 资源线装备改变


////////////////////
// 资源线装备改变 //
////////////////////
var ResResourceEquipChangeToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.resourceType = 0; // 资源线类型
        this.type = 0; // 操作类型(0穿戴1脱下)
        this.pos = 0; // 位置(0到3)
        this.equipInfo = null; // 装备信息
	},

	getId:function(){
		return 139101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.resourceType);
        _buf.WriteByte(this.type);
        _buf.WriteByte(this.pos);
        _buf.WriteBean(this.equipInfo);
	},
	
	reading:function( _buf ){
        this.resourceType = _buf.ReadByte();
        this.type = _buf.ReadByte();
        this.pos = _buf.ReadByte();
        this.equipInfo = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.resourceequip.RecvResResourceEquipChangeToClientMessage(this);
	},

});
////////////////////
// 穿戴装备 //
////////////////////
var ReqResourceEquipSetToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.resourceType = 0; // 资源线类型
        this.pos = 0; // 位置(0到3)
        this.itemmodelid = null; // 要穿戴的装备唯一ID
	},

	getId:function(){
		return 139201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.resourceType);
        _buf.WriteByte(this.pos);
        _buf.WriteLong(this.itemmodelid);
	},
	
	reading:function( _buf ){
        this.resourceType = _buf.ReadByte();
        this.pos = _buf.ReadByte();
        this.itemmodelid = _buf.ReadLong();
	},

});
////////////////////
// 卸下装备 //
////////////////////
var ReqResourceEquipClearToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.resourceType = 0; // 资源线类型
        this.pos = 0; // 位置(0到3))
	},

	getId:function(){
		return 139202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.resourceType);
        _buf.WriteByte(this.pos);
	},
	
	reading:function( _buf ){
        this.resourceType = _buf.ReadByte();
        this.pos = _buf.ReadByte();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(139101, ResResourceEquipChangeToClientMessage);

