var ShenBingMainExt = ShenBingMain.extend ( {
	_className:"ShenBingMainExt",

    showType:1,

    skillGridList:null,
    materGridList:null,

    leftModel:null,
    centerModel:null,
    rightModel:null,

    choseMaterId:null,

    materHash:null,


	ctor:function(){
		this._super();
		this.skillGridList = [];
		this.materGridList = [];
		this.materHash = new HashMap();
	},

    Init:function(){
        ShenBingMain.prototype.Init.call(this);

        this.grid1.visible = false;
        this.labShengJi.visible = false;
        this.grid2.visible = false;
        this.labNum4.visible = false;

        this.grid1.visible = false;
        this.labShengJi.visible = false;
        this.labJieSuo.visible = false;
        this.labWeiJieSuo.visible = false;

        this.img1.setLocalZOrder(100);
        this.img2.setLocalZOrder(100);
        this.img3.setLocalZOrder(100);
        this.imgCue.setLocalZOrder(100);

        this.sbtnGouxuan.visible = false;
        this.lab1.visible = false;

        this.RegisterListeners();
	},

    OnShow:function(){
	    this.AutoChoseEnableType();
    },

    AutoChoseEnableType:function(){
        for(var i = 1; i < 5; i++){
            if(this.IsEnableUp(i)){
                this.showType = i;
                break;
            }
        }
        this.RefreshAllInfo();
        this.IsEnableUp(this.showType); // 第二次为了选择拥有的石头
    },

    IsEnableUp:function(id){
	    if(this.materHash.Size() <= 0){
            var list = Q_godarms_base.GetList();
            for(var i = 0; i < list.length; i++){
                var materInfo = JSON.parse(list[i].q_item_cost);
                this.materHash.Put(list[i].q_id, materInfo)
            }
        }

        var info = this.materHash.Get(id);
        //逆向遍历  优先选择大的
        for(var j = info.length - 1; j >= 0; j--){
            if(Mgr.backpack.GetItemNumber(info[j][0]) > 0){
                this.ChoseMater(info[j][0]);
                return true;
            }
        }
        //没有石头，默认选择最大
        this.ChoseMater(info[info.length - 1][0]);
        return false;
    },

    RegisterListeners:function(){
	    var self = this;
        this.btnLeft.addClickEventListener( function(e){
            self.leftHandler();
        });
        this.btnRight.addClickEventListener(function(e){
            self.rightHandler();
        });

        this.btn1.addClickEventListener(function(e){
            if(!self.choseMaterId){
                Mgr.tips.ShowNotice("请选择锤炼材料");
                return;
            }
            var num = Mgr.backpack.GetItemNumber(self.choseMaterId);
            if(num <= 0){
                Mgr.tips.ShowNotice("材料不足");
                return;
            }
            var list = [self.choseMaterId, num];
            Mgr.godarm.SendReqUpGodArmToGameMessage(self.showType, list);
        });


        this.btn2.addClickEventListener(function(){
            if(self.showType == 4)
                Mgr.uiMgr.ShowPanelByType(RechargePanelExt.PanelName).ChangePanel(RechargeTypeEnum.TYPE_RECHARGE);
            else
                Mgr.uiMgr.ShowPanelByType(ShopMainExt.PanelName);
        });
    },

    RefreshAllInfo:function(){
	    var info = Mgr.godarm.godArmDataInfoList.Get(this.showType);
        var id = this.showType + "_" + info.level;
	    var data = Q_godarms_up.Get(id);
	    var baseData = Q_godarms_base.Get(this.showType);
        UIUtil.ConnectLabelHtmlText(this.labLv, [info.level]);
        UIUtil.ConnectLabelHtmlText(this.labNumber, [info.exp, data.q_exp]);
        this.labNum3.SetText((data.q_exp - info.exp) + "经验");
        this.imgJindutiao.setPercent(info.exp/data.q_exp*100);
        this.labNum.SetText(parseInt(Mgr.fightpower.GetFightPower(data.q_attribute)));
        this.labShenBing.SetText(baseData.q_name_word);

        if(this.showType == 4 && Mgr.player.rechargeInfo.all <= 0)
            this.btn2.visible = false;
        else
            this.btn2.visible = true;


        this.ChoseMater(-1);
        this.RefreshGrid(baseData, info.level);
        this.RefreshAttrib(data);
        this.RefreshUIModel();
    },

    RefreshInfo:function(){

    },

    RefreshProgressBar:function(){

    },

    RefreshTitle:function(){
	    switch (this.showType){
        }
    },

    RefreshGrid:function(baseData, level){
	    var info = baseData;
	    var materInfo = JSON.parse(info.q_item_cost);
        var i = 0;
	    for(; i < materInfo.length; i++){
	        if(!this.materGridList[i]){
                var grid = this.grid2.Clone();
                grid.x = (this.imgDi1.uiWidth - this.grid2.uiWidth*materInfo.length)/2 + this.grid2.uiWidth*i;
                this.imgDi1.addChild(grid);
                this.materGridList.push(grid);

                var label = this.labNum4.clone();
                label.x = grid.x + this.labNum4.x - this.grid2.x;
                this.imgDi1.addChild(label);
                grid.label = label;
            }
            var coinInfo = {};
            coinInfo.itemModelId = materInfo[i][0];
            coinInfo.itemNum = Mgr.backpack.GetItemNumber(materInfo[i][0]);
            // coinInfo.itemBind = materInfo[i].bind;
            this.materGridList[i].itemIdx = materInfo[i][0];
            GridUtil.SetItemGrid(this.materGridList[i], coinInfo, null, null, null, false, null, null, true);
            this.materGridList[i].label.SetText(materInfo[i][1]);
            this.materGridList[i].setTouchEnabled(true);
            var self = this;
            (function(i){
                self.materGridList[i].addTouchEventListener(function(sender, type){
                    if(type == ccui.Widget.TOUCH_ENDED){
                        self.ChoseMater(materInfo[i][0]);
                    }
                });
            }(i))
        }

        var skillInfo = JSON.parse(info.q_skill_activate);
        i =0;
	    for(; i < skillInfo.length; i++){
	        if(!this.skillGridList[i]){
                var grid = this.grid1.Clone();
                this.imgDi.addChild(grid);
                this.skillGridList.push(grid);

                // var label = this.labShengJi.clone();
                // this.imgDi.addChild(label);
                // grid.label = label;

                var labJieSuo = this.labJieSuo.clone();
                this.imgDi.addChild(labJieSuo);
                grid.labJieSuo = labJieSuo;

                var labWeiJieSuo = this.labWeiJieSuo.clone();
                this.imgDi.addChild(labWeiJieSuo);
                grid.labWeiJieSuo = labWeiJieSuo;
            }

            this.skillGridList[i].x = (this.imgDi.uiWidth - this.grid1.uiWidth*skillInfo.length)/2 + this.grid1.uiWidth*i;
            // this.skillGridList[i].label.x = this.skillGridList[i].x +  this.labShengJi.x - this.grid1.x;
            this.skillGridList[i].labJieSuo.x = this.skillGridList[i].x + this.labJieSuo.x - this.grid1.x;
            this.skillGridList[i].labWeiJieSuo.x = this.skillGridList[i].x + this.labWeiJieSuo.x - this.grid1.x;

            this.skillGridList[i].labWeiJieSuo.SetText(skillInfo[i][0] + "阶解锁");

            this.skillGridList[i].visible = true;
            // this.skillGridList[i].label.visible = true;
            if(level >= skillInfo[i][0]){
                this.skillGridList[i].labJieSuo.visible = true;
                this.skillGridList[i].labWeiJieSuo.visible = false
            }
            else{
                this.skillGridList[i].labJieSuo.visible = false;
                this.skillGridList[i].labWeiJieSuo.visible = true
            }

            // var coinInfo = {};
            // coinInfo.itemModelId = skillInfo[i][0];
            // // coinInfo.itemNum = skillInfo[i].num;
            // // coinInfo.itemBind = skillInfo[i].bind;
            // GridUtil.SetItemGrid(this.materGridList[i], coinInfo);
            // this.skillGridList[i].label.SetText(skillInfo[i][1]);
            var skillLv = (level - parseInt(skillInfo[i][0])) >= 0? 1 : 0;
            GridUtil.SetSkillGridByMID( GridInteractionType.NORMALSKILLSHOW, this.skillGridList[i], skillInfo[i][1], skillLv);
        }
        for(; i < this.skillGridList.length; i++){
            this.skillGridList[i].visible = false;
            // this.skillGridList[i].label.visible = false;
            this.skillGridList[i].labJieSuo.visible = false;
            this.skillGridList[i].labWeiJieSuo.visible = false;
        }
    },

    ChoseMater:function(id){
	    if(id < 0){
            this.choseMaterId = null;
            this.labCaiLiao.SetText("未选择");
        }
        else{
            this.choseMaterId = id;
            this.labCaiLiao.SetText(Q_item.Get(id).q_name)
        }

        for(var i = 0; i < this.materGridList.length; i++){
	        if(this.materGridList[i].itemIdx == this.choseMaterId){
	            this.imgCue.x = this.materGridList[i].x;
	            break;
            }
        }
    },

    RefreshAttrib:function(data){
	    var str = data.q_attribute.substring(1, data.q_attribute.length-1);
        var array=str.split(",");
        var attName, attNum, spName, spNum;
        for(var i=0;i<array.length;++i){
            array[i]=array[i].split(":");
            switch (array[i][0]){
                case "1":
                    attName = "攻击";
                    attNum = array[i][1];
                    break;
                case "2":
                    attName = "防御";
                    attNum = array[i][1];
                    break;
                case "3":
                    attName = "暴击值";
                    attNum = array[i][1];
                    break;
                case "7":
                    attName = "生命";
                    attNum = array[i][1];
                    break;
                case "10":
                    spName = "附加伤害";
                    spNum = array[i][1];
                    break;
                case "13":
                    spName = "生命恢复";
                    spNum = array[i][1];
                    break;
                case "14":
                    spName = "暴击伤害";
                    this.spAttri = "暴击伤害加成" + parseInt(array[i][1])/100 + "%";
                    spNum = parseInt(array[i][1])/100 + "%";
                    break;
                case "15":
                    spName = "暴击减免";
                    spNum = parseInt(array[i][1])/100 + "%";
                    break;
                default:
                    break;
            }
        }

        this.labGongJi.SetText(attName);
        this.labNum1.SetText(attNum);
        this.labShangHai.SetText(spName);
        this.labNum2.SetText(spNum);
    },

    leftHandler:function(){
        this.showType = (this.showType + 1) < 5 ? (this.showType + 1) : 1;
	    this.RefreshAllInfo();
    },

    rightHandler:function(){
        this.showType = (this.showType - 1) > 0 ? (this.showType - 1) : 4;
        this.RefreshAllInfo();
    },

    RefreshUIModel:function(){
	    var self = this;
        var centerId = this.showType;
        var leftId = (centerId - 1) > 0 ? (centerId - 1) : 4;
        var rightId = (centerId + 1) < 5 ? (centerId + 1) : 1;
	    var leftData =  Q_godarms_base.Get(leftId);
        var centerData =  Q_godarms_base.Get(centerId);
        var rightData =  Q_godarms_base.Get(rightId);
        if(!this.leftModel){
            var leftModel = new MAnimationObject();
            this.imgKuang1.addChild(leftModel);
            this.leftModel = leftModel;
            this.leftModel.x = this.imgKuang1.uiWidth/2;
            this.leftModel.y = this.imgKuang1.uiHeight/2;
        }
        this.leftModel.setScale(this.imgKuang1.uiWidth/this.imgKuang.uiWidth);
        this.leftModel.sCurActionName = null;
        this.leftModel.sResUrlBase = "res/animation/effect/ui/" + leftData.q_show;
        this.leftModel.DoAction("stand5", 4);
        this.imgKuang1.setTouchEnabled(true);
        this.imgKuang1.addTouchEventListener(function(sender,type){
            if (type == ccui.Widget.TOUCH_ENDED) {
                self.rightHandler();
            }
        });
        if(this.IsEnableUp(leftId))
            this.img3.visible = true;
        else
            this.img3.visible = false;


        if(!this.centerModel){
            var centerModel = new MAnimationObject();
            this.imgKuang.addChild(centerModel);
            this.centerModel = centerModel;
            this.centerModel.x = this.imgKuang.uiWidth/2;
            this.centerModel.y = this.imgKuang.uiHeight/2;
        }
        this.centerModel.setScale(1);
        this.centerModel.sCurActionName = null;
        this.centerModel.sResUrlBase = "res/animation/effect/ui/" + centerData.q_show;
        this.centerModel.DoAction("stand5", 4);
        if(this.IsEnableUp(centerId))
            this.img1.visible = true;
        else
            this.img1.visible = false;

        if(!this.rightModel){
            var rightModel = new MAnimationObject();
            this.imgKuang2.addChild(rightModel);
            this.rightModel = rightModel;
            this.rightModel.x = this.imgKuang2.uiWidth/2;
            this.rightModel.y = this.imgKuang2.uiHeight/2;
        }
        this.rightModel.setScale(this.imgKuang2.uiWidth/this.imgKuang.uiWidth);
        this.rightModel.sCurActionName = null;
        this.rightModel.sResUrlBase = "res/animation/effect/ui/" + rightData.q_show;
        this.rightModel.DoAction("stand5", 4);
        this.imgKuang2.setTouchEnabled(true);
        this.imgKuang2.addTouchEventListener(function(sender,type){
            if (type == ccui.Widget.TOUCH_ENDED) {
                self.leftHandler();
            }
        });
        if(this.IsEnableUp(rightId))
            this.img2.visible = true;
        else
            this.img2.visible = false;
    }
} );
ShenBingMainExt.PanelName = "ShenBingMainExt";
PanelClassDic["ShenBingMainExt"] = ShenBingMainExt;
