var SkillData = cc.Class.extend({
	_skillInfo:null,
	
	ctor:function(info){
		if( info )
			this._skillInfo = info;
	},
	
	Model:function( level ){
		if( !level )
			level = this._skillInfo.skillLevel;
		return Q_skill_model.Get(this._skillInfo.skillModelId + "_" + level);
	},
	
	FullModel:function(){
		return this.Model(this.FullLevel());
	},
	
	UpModel:function(){
		return this.Model(this._skillInfo.skillLevel + 1);
	},
	
	SetBaseLevel:function(level){
		this._skillInfo.skillLevel = level;
	},
	
	FullLevel:function(){
		return this._skillInfo.skillLevel || 1;
	},

	PublicModel:function(){
		return Q_skill_public.Get(this._skillInfo.skillModelId);
	},
	
	IsPassiveSkill:function(){
		return this.Model().q_trigger_type == 2;
	},
	
	Name:function(){
		return this.Model().q_skillName;
	},
	
	Mid:function(){
		return this._skillInfo.skillModelId;
	},

	ExpAddOne:function(){
		if( this._skillInfo.skillExp < this.Model().q_upgrade_proficiency )
			this._skillInfo.skillExp++;
	},
	
	Exp:function () {
		return this._skillInfo.skillExp;
	},
	
});

var SkillVo = cc.Class.extend({
	skilltype:0,
	skillmid:0,
	skilllv:0,
})