var SpecialType = SpecialType ||{
    /**
     * 全部购买
     */
    ALL_BUY:104,
    /**
     * 绿砖
     */
    GREEN_BUY:101,
    /**
     * 紫砖
     */
    VIOLET_BUY:102,
    /**
     * 皇砖
     */
    YELLOW_BUY:103,
};

var SpecialReceiveType = SpecialReceiveType ||{
    /**
     * 不可领取
     */
    CANT_GET:0,
    /**
     * 可以领取
     */
    CAN_GET:1,
    /**
     * 已经领取
     */
    IS_GET:2,
}

var SpecialModMgr = SpecialModMgr || cc.Class.extend({

    SpecialPanel:null,
    timeId:0,
    _curTime:null,
    _passTime:null,

	ctor:function() {	
	},

	RecvResSpecialDataInfoToClientMessage:function(msg) {
		if(msg.specialDataInfo.infoList.length && this.timeId == 0)
            this.timeId = TimerUtil.TimeUpdate(this.UpdateTime, this, 1);
    	if(this.SpecialPanel){
    		this.SpecialPanel.RefreshPanel(msg.specialDataInfo.infoList);
		}
        var panel = Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName);
        panel.UpdateSpecialWarn(false);
		for(var i = 0; i < msg.specialDataInfo.infoList.length; i++){
    		if(msg.specialDataInfo.infoList[i].state == SpecialReceiveType.CAN_GET){
                if (panel)
                    panel.UpdateSpecialWarn(true);
			}
		}
	},

    UpdateTime:function(){
        this._curTime = Mgr.login.GetServerTime();
        if(this.SpecialPanel){
            this.SpecialPanel.UpdateTime(this._passTime);
        }
        this._passTime = this._curTime;
	},

	SendReqSpecialDataInfoToGameMessage:function() {
		var msg = new ReqSpecialDataInfoToGameMessage();
		Mgr.msgMgr.Send(msg);
	},

	SendReqBuySpecialToGameMessage:function(type) {
		var msg = new ReqBuySpecialToGameMessage();
		msg.type = type;
        Mgr.msgMgr.Send(msg);
	},

	SendReqGetSpecialAwardToGameMessage:function(type) {
        var msg = new ReqGetSpecialAwardToGameMessage();
        msg.type = type;
        Mgr.msgMgr.Send(msg);
	}
});