﻿var StallModMgr = StallModMgr || cc.Class.extend({
		backPanel:null,
		itemTip:null,
		itemAdjustmentPanel:null,               // 上架
		findGoodsList:null,                     // 搜索到的物品
		backItemList:null,                    // 背包中的物品
		sellGoodsList:null,                  // 自己卖的物品
		notesList:null,
		maxType:null,
		minType:null,
		pricePanel:null,
		ctor:function() {
			this.sellGoodsList=[];
	},

	RecvResStallGoodsMessage:function(msg) {
		if(msg.maxType == 1 && msg.minType == 0){
			for(var i = 0; i < msg.stallGoodsInfoList.length; i++){
				var iteminfor = msg.stallGoodsInfoList[i].iteminfo;
				if(Q_item.Get(iteminfor.itemModelId).q_location != 0){
					msg.stallGoodsInfoList.splice(i,1);
				}
			}
		}
		Mgr.stall.backPanel.findPanel.SetData(msg.stallGoodsInfoList);
        Mgr.stall.backPanel.findPanel.SetText(msg.searchType);
	}
	,

	RecvResStallInfoMessage:function(msg) {
		this.sellGoodsList=msg.stallInfo.stallgoodsinfo;
		if(Mgr.stall.backPanel)
			Mgr.stall.backPanel.myStallPanel.SetData();
	},

	RecvResChangeStallNameMessage:function(msg) {
	},

	RecvResStallGoodsSearchMessage:function(msg) {
		Mgr.stall.backPanel.findPanel.SetData(msg.stallGoodsInfoList);
	},

	RecvResLookStallLogMessage:function(msg) {
		this.notesList=msg.stallLogList.reverse();
		Mgr.stall.backPanel.logPanel.Update();
	},

	RecvResStallItemPriceMessage:function(msg){
		if(this.pricePanel == StallPriceUpdateEnum.STALL || this.pricePanel == StallPriceUpdateEnum.STORE) {
			if( Mgr.tips.itemTip)
				Mgr.tips.itemTip.UpdatePriceInfo(msg.stallItemPriceInfo);
			if(Mgr.tips.equipTip)
				Mgr.tips.equipTip.UpdatePriceInfo(msg.stallItemPriceInfo);
			if(Mgr.tips.normalTip)
				Mgr.tips.normalTip.UpdatePriceInfo(msg.stallItemPriceInfo);
		}
		if(this.pricePanel==StallPriceUpdateEnum.BACKPACK)
			Mgr.backpack.UpdatePriceInfo(msg.stallItemPriceInfo);
		// if(Mgr.uiMgr.IsPanelShow(Mgr.stall.itemAdjustmentPanel))
		// Mgr.stall.itemAdjustmentPanel.UpdatePriceInfo(self.price);
	},



	SendReqStallGoodsOpenMessage:function(max,min) {
		var msg = new ReqStallGoodsOpenMessage();
		this.maxType=max;
		this.minType=min;
        //if(min==99) min=null;
		msg.maxType = max;
		msg.minType = min;
		Mgr.msgMgr.Send( msg );
	},

	SendReqStallInfoMessage:function(id) {
		var msg = new ReqStallInfoMessage();
		msg.playerId=id;
		Mgr.msgMgr.Send( msg );
	},

	SendReqStallADDGoodsMessage:function(id,money,num) {
		var msg = new ReqStallADDGoodsMessage();
		msg.goodsId=id;
		msg.gold=money;
		msg.num=num;
		Mgr.msgMgr.Send( msg );
	},

	SendReqStallDeleteGoodsMessage:function(id) {
		var msg = new ReqStallDeleteGoodsMessage();
		msg.goodsId=id;
		Mgr.msgMgr.Send( msg );
	},

	SendReqStallChangeGoodsMessage:function(id,oldMoney,oldGold,oldNum,newMoney,newGold) {
		var msg = new  ReqStallChangeGoodsMessage();
		msg.goodsId = id;
		msg.oldMoney = oldMoney;
		msg.oldGold = oldGold;
		msg.oldNum = oldNum;
		msg.newMoney = newMoney;
		msg.newGold = newGold;
		Mgr.msgMgr.Send( msg );
	},

	SendReqStallBuyMessage:function(playerId,goodsIndex,gold,num,goodsId) {
		var msg=new ReqStallBuyMessage();
		msg.playerId = playerId; // 摆摊的玩家ID
		msg.goodsIndex = goodsIndex; // 商品索引(验证用)
		msg.gold = gold; // 商品元宝价格
		msg.num = num; // 商品数量(验证用)
		msg.goodsId = goodsId; // 商品道具唯一ID，-1元宝，-2金币
		Mgr.msgMgr.Send( msg );
	},

	SendReqChangeStallNameMessage:function(name) {
		var msg = new ReqChangeStallNameMessage();
		msg.name=name;
		Mgr.msgMgr.Send( msg );
	},

	SendReqStallSearchMessage:function(name) {
		var msg = new ReqStallSearchMessage();
		msg.goodsName=name;
		msg.isDefaultSearch=0;
		Mgr.msgMgr.Send( msg );
	},

	SendReqLookStallLogMessage:function() {
		var msg = new ReqLookStallLogMessage();
		Mgr.msgMgr.Send( msg );
	},

	SendReqStallItemPriceMessage:function(id,type){
		this.pricePanel=type;
		var msg = new ReqStallItemPriceMessage();
		msg.modelId=id;
		Mgr.msgMgr.Send( msg );
	},
	RefreshGoods:function(){
		this.SendReqStallGoodsOpenMessage(this.maxType,this.minType);
	},
	StallItemShowTips:function (item,type) {
		var q_item = Q_item.Get(item.iteminfo.itemModelId);
		var panel;
		if(ItemUtil.IsEquip( q_item.q_type )) {
            panel = EngineMgr.uiMgr.ShowPanelByType(EquipTipsPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
			// if(q_item.q_type==EnumItemType.Equip)
			// 	panel = EngineMgr.uiMgr.ShowPanelByType(EquipTipsPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
			// else
			// 	panel= EngineMgr.uiMgr.ShowPanelByType(ItemTipsPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
		}
		else
			panel= EngineMgr.uiMgr.ShowPanelByType(ItemTipsExt.PanelName,UIMgr.PANEL_LAYER_TOP);
		panel.Update(item,type);
	}
});
var StallPriceUpdateEnum = StallPriceUpdateEnum || {
		STALL:1,
		BACKPACK:2,
		STORE:3,
	};