var TanweiShangjiaExt = TanweiShangjia.extend ( {
	_className:"TanweiShangjiaExt",
	barW:170,
	sellNum:0,
	price:0,
	touchPos:null,
	infoList:null,
	keyBord:null,
	ctor:function(){
		this._super();
		Mgr.stall.itemAdjustmentPanel=this;
		this.layoutCom.layoutType = MLLAYOUT_C;
	},
	Init:function(){
		TanweiShangjia.prototype.Init.call( this );
		var self=this;


        var ee=new MUINumberEdit();
        ee.jsonobj=this.editTxt.jsonobj;
        ee.Init();
        this.imgDikuang.removeChild(this.editTxt);
        this.imgDikuang.addChild(ee);
        this.editTxt=ee;

		this.editTxt.setPlaceHolder("输入物品总价");
		this.editTxt.setPlaceholderFontColor(UIUtil.GetCCColor(0xb8a085));
		//旁边的三个也直接弄出来
		this.infoList=[];
		var boxH=97;
		for(var i=0;i<3;++i){
			this.infoList[i]=new TanweiDanjiaFrameExt();
			this.infoList[i].LoadPanel();
			this.infoList[i].y=250-i*boxH;
			this.imgBg1.addChild(this.infoList[i]);
		}

		this.btnClose.addClickEventListener(function(){
			EngineMgr.uiMgr.HidePanelByType(TanweiShangjiaExt.PanelName);
		});
		this.btnJian.addClickEventListener(function(){
			if(self.sellNum>1){
				self.sellNum--;
				self.Update();
			}
		});
		this.btnJia.addClickEventListener(function(){
			if(self.sellNum<self.item.itemNum){
				self.sellNum++;
				self.Update();
			}
		});
		this.imgJiantou.setTouchEnabled(true);
		this.imgJiantou.addTouchEventListener(function(target,type){
			if(type==0){
				self.touchPos=null;
			}
			if(type==1){
				var pos = target.getTouchMovePosition().x;
				if(self.touchPos)
				{
					var posX=self.imgJiantou.x+pos-self.touchPos;
					if(posX>(self.barW-12))
						posX=self.barW-12;
					if(posX<-12)
						posX=-12;
					self.imgJiantou.x=posX;
					self._UpdateByPercent();
				}
				self.touchPos=pos;
			}
			if(type==2){
				self.Update();
			}
		});

		this.btnShangjia.addClickEventListener(function(){
			if( Mgr.stall.sellGoodsList.length>=8){
				Mgr.tips.ShowNotice( "最多只能同时上架8个物品");
                EngineMgr.uiMgr.HidePanelByType(TanweiShangjiaExt.PanelName);
				return;
			}
			if(self.price==0){
                Mgr.tips.ShowNotice( "价格不能为空");
                return;
			}
            EngineMgr.uiMgr.HidePanelByType(TanweiShangjiaExt.PanelName);
			Mgr.stall.SendReqStallADDGoodsMessage(self.item.itemId,self.price,self.sellNum);
		});

		this.setSwallowTouches(true);
		//self.editTxt.setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC );
        self.editTxt.setDelegate(this);
		// this.keyBord=new JianpanMainExt();
		// this.keyBord.LoadPanel();
		// this.keyBord.x=195;
		// this.keyBord.y=-55;
		// this.img1.addChild(this.keyBord);
		// this.keyBord.setVisible(false);
	},
	// Listener:function(sender,type){
	// 	var ediText = sender.getString();
	// 	switch(type)
	// 	{
	// 		case 0:
	// 			Mgr.stall.itemAdjustmentPanel.keyBord.setVisible(true);
	// 			break;
	// 		case 1:
	// 			Mgr.stall.itemAdjustmentPanel.keyBord.setVisible(false);
	// 			break;
	// 		case 2:
	// 			var newCharNum=ediText[ediText.length-1].charCodeAt();
	// 			if(58<newCharNum||47>newCharNum){
	// 				ediText=ediText.substring(0,ediText.length-1);
	// 				sender.setString(ediText);
	// 			}
	// 			break;
	// 		case 3:
	// 			break;
	// 	}
	// 	if(ediText=="")    sender.setString(0);
	// 	Mgr.stall.itemAdjustmentPanel._UpDateMoney();
	// },
    editBoxTextChanged :function(){
        var ediText = this.editTxt.getString();
        if(parseInt(ediText)>9999999){
            this.editTxt.setString(9999999);
            return;
        }
        Mgr.stall.itemAdjustmentPanel._UpDateMoney();
    },

	SetData:function(item){
		this.item=item;
		this.sellNum=item.itemNum;
		this.price=0;
		Mgr.stall.SendReqStallItemPriceMessage(item.itemModelId);
		this.labName.SetString(item.GetName());
        this.labName.x= 110 - item.GetName().length*12;
		var color=ItemUtil.GetNameColorById(item.itemModelId);
		this.labName.SetColor(color[0]);
		//this.labName.EnableOutline(color[1],2);
		this.labNumber.SetString(0);
		this.editTxt.setString("");
		//this.editTxt.setTextHorizontalAlignment(1);
		GridUtil.SetItemGrid(this.gridItem,item);
		this.Update();
		if(Mgr.stall.sellGoodsList)
		UIUtil.ConnectLabelHtmlText(this.labCue,[8-Mgr.stall.sellGoodsList.length]);
		else UIUtil.ConnectLabelHtmlText(this.labCue,[8]);            //背包用的时候还没有收到这个消息

		UIUtil.ConnectLabelHtmlText(this.labVip,[Mgr.player.mainPlayer.VIP]);
		//vip
		// var pp=Q_vip.Get(Mgr.player.mainPlayer.VIP);
		// if(pp)
         //    UIUtil.ConnectLabelHtmlText(this.labCue3,[Q_vip.Get(Mgr.player.mainPlayer.VIP).q_deal_tax_rate]);
		// else  UIUtil.ConnectLabelHtmlText(this.labCue3,[35]);
		if(Mgr.player.mainPlayer.VIP>=2){
			this.labShui1.setVisible(true);
            this.labShui.setVisible(false);
		}else {
            this.labShui.setVisible(true);
            this.labShui1.setVisible(false);
		}

	},
	Update:function(){
		if(this.sellNum<1){
            this.sellNum=1;
		}
		this.labCue1.SetString(this.sellNum);
		var percent=this.sellNum/this.item.itemNum;
		percent=percent.toFixed(2);
		this.progJindutia.setPercent(percent*100);
		this.imgJiantou.x=percent*this.barW-12;
	},
	_UpdateByPercent:function(){
		var percent=(this.imgJiantou.x+12)/170;
		this.progJindutia.setPercent(percent*100);
		this.sellNum=Math.floor(this.item.itemNum*percent);
		this.labCue1.SetString(this.sellNum);
		if(this.sellNum>0)
			this.labNumber.SetString(Math.floor(this.price/this.sellNum));
		else
			this.labNumber.SetString(0);
		this.Update();
	},
	UpdatePriceInfo:function(info){
		if(info.lastPrice==0){
            this.labMoney.SetString("暂无成交记录");
            this.imgGold2.setVisible(false);
		}else {
            this.labMoney.SetString(TextUtil.NumberCutLength( info.lastPrice,4));
            this.imgGold2.setVisible(true);
		}
		for(var i=0;i<3;++i){
			this.infoList[i].setVisible(false);
		}
		for(var i=0;i<info.minPrices.length;++i){
			this.infoList[i].SetData(info.minPrices[i],this.item);
		}
		this.labTag.setVisible(!info.minPrices.length);

	},
	_UpDateMoney:function(){
		var ediText = this.editTxt.getString();
		if(ediText!="") {
            this.price = parseInt(ediText);
            if (!this.price)
                this.price = 0;
        }else {
            this.price=0;
		}
        this.labNumber.SetString(Math.ceil(this.price/this.sellNum));
	},
});
TanweiShangjiaExt.PanelName = "TanweiShangjiaExt";
PanelClassDic["TanweiShangjiaExt"] = TanweiShangjiaExt;
