var StepModMgr = StepModMgr || cc.Class.extend({ 
    ctor:function() {
        this.$boxId = 0
        this.$layer = 0
        this.$double = false
        this.$awards = []

        this.$itemMid = 0
    },

    GetRequestItemAmount:function(){
        if(this.$itemMid == 0){
            let global = Q_global.Get(20005)
            let itemMod = JSON.parse(global ? global.q_string_value : "[]")
            this.$itemMid = typeof itemMod == "object" && itemMod[0] || 0
        }

        return Mgr.backpack.GetItemNumber(this.$itemMid);
    },

    GetLayerAward:function(){
        var global = Q_global.Get(20004)
        return JSON.parse(global ? global.q_string_value : "")
    },
    GetCurrentLayerAward:function(){
        var awards = this.GetLayerAward()
        var award = awards.find(v=>this.$layer <= v[0])
        return award || [0,[]]
    },

    GetCurrentLayerAwardByBoxId:function(){
        return[ this.throwResultParam.awardInfo ]
    },
    OnBackpackRefreshed:function(mid){
        if(this.$itemMid != mid) return

        var array = ActivityUtil.GetActivityBySubPanelType(EnumActivityKey.M_KAI_FU, EnumActivityType.S_BBGS);
        if(array && array.length > 0){
            Mgr.map.miniMapPanel.UpdateActivityButton(Mgr.dailyactivity._keyHash.Values());

            array.forEach(v=>{
                v.status = this.GetRequestItemAmount() > 0 ? 1 : 2;

                var panel = Mgr.dailyactivity._panelHash.Get(v.mainPanelKey);
                if (Mgr.uiMgr.IsPanelShow(panel)) {
                    panel.UpdateSingleActivity(v);
                }
            })
        }
    },
    RecvResStepDataInfoToClientMessage:function(msg) {
        this.stepDataInfo = msg.stepDataInfo
        this.$layer = msg.stepDataInfo.layer
        this.$boxId = msg.stepDataInfo.boxId
        this.$double = msg.stepDataInfo.doubleFlage
        this.$awards = msg.stepDataInfo.awardInfos

        /// 跨层处理
        if(this.$tResult == this.throwResultParam){
            this.throwResultParam = null
        }
        this.$tResult = this.throwResultParam

        GameEventMgr.DispatchEvent(msg.getId())
    },

    RecvResThrowResultToClientMessage:function(msg) {
        var param = {
            upgraded : msg.layer != this.$layer,
            oldBoxId : this.$boxId,
            boxId : msg.boxId,
            layer : msg.layer,
            num : msg.num,
            awardInfo : msg.awardInfo,
        }

        this.$layer = msg.layer
        this.$boxId = msg.boxId

        var award = this.$awards[this.$boxId - 1]
        this.$double = award && award.mod == 888


        this.throwResult = msg
        this.throwResultParam = param

        GameEventMgr.DispatchEvent(msg.getId())
    },

    SendReqStepDataInfoToGameMessage:function(msg) {
        var msg = new ReqStepDataInfoToGameMessage();
        Mgr.msgMgr.Send( msg );
    },

    SendReqThrowToGameMessage:function(msg) {
        var msg = new ReqThrowToGameMessage();
        Mgr.msgMgr.Send( msg );
    }
});