var StoreGridListExt = StoreGridList.extend ( {
	_className:"StoreGridListExt",
	itemHs:null,
	parentPanel:null,
	gridList:null,
	isClicked:false,
	ctor:function(){
		this._super();
	},
	Init:function(){
		StoreGridList.prototype.Init.call( this );
		this.gridList=[this.grid1,this.grid3,this.grid2,this.grid4,this.grid5,this.grid6,this.grid7,this.grid8];
		for(var i=0;i<8;++i){
			this.gridList[i].setTouchEnabled(true);
			this.gridList[i].SetSwallow(false);
			this.gridList[i].InitGrid(GridTypeEnum.XUNBAOSTORE);
		}
		this.setSwallowTouches(false);
	},
	SetParent:function(panel){
		this.parentPanel=panel;
	},
	ClickEvent:function (target) {
        if(this.isClicked){
            this.isClicked = false;
            this.parentPanel.ShowEffect(target);
            ItemUtil.ShowTips(target.gridData,target.gridType);
        }
    },
	SetData:function(idx){
		var num=idx*8;
		var gNum = this.parentPanel.gridNum;
		var itemLists=this.parentPanel.itemHs;
		for (var k = 0; k < 8; ++k) {
			this.gridList[k].Clean();
			Mgr.store.showHash.Remove( this.gridList[k].nn);
            this.gridList[k].nn=num;
            Mgr.store.showHash.Put( this.gridList[k].nn,this.gridList[k]);
			if(num==this.parentPanel.showNum){
                this.parentPanel.ShowEffect(this.gridList[k]);
			} else if(this.gridList[k]==this.parentPanel.showGrid){
                this.parentPanel.HideEffect();
			}
            if(!this.parentPanel.showGrid){
                this.parentPanel.ShowEffect(this.gridList[k]);
            }
			if(num<gNum) {
				var item = itemLists.Get(num++);
				this.gridList[k].setVisible(true);
				if (item) {
					if(!Mgr.store.choose) {
                        Mgr.store.choose=item;
                        this.parentPanel.ShowEffect(this.gridList[k]);
					}
					GridUtil.SetItemGrid(this.gridList[k],item,null,null,null,false);                          //就先用tip 展示
				}
				else {
					GridUtil.SetGridInteraction(this.gridList[k],GridInteractionType.BLACK);
				}
			}
			else {
				this.gridList[k].setVisible(false);
			}
			var self=this;
            this.gridList[k].addClickEventListener(function (target) {
                Mgr.store.choose=target.gridData;
                if(self.isClicked){
                    self.isClicked = false;
                    self.parentPanel.HideEffect();
                    if(Mgr.store.choose){
                        if (Mgr.backpack.GetEmptyGrid())
                            Mgr.store.SendReqStoreToBagMessage(Mgr.store.choose.itemId, 0, EnumStore.LUCKY);
                        else
                            Mgr.tips.ShowNotice( "角色背包剩余空间不足，无法取出");
					}
                }else {
                    TimerUtil.SetTimeout(self, self.ClickEvent, 250, target);
                    self.isClicked = true;
                }
            });
		}
	},
} );
StoreGridListExt.PanelName = "StoreGridListExt";
PanelClassDic["StoreGridListExt"] = StoreGridListExt;
