var TaskXuanShangRenWuExt = TaskXuanShangRenWu.extend ( {
    _className:"TaskXuanShangRenWuExt",
    ctor:function(){
        this._super();
        this.layoutCom.layoutType = MLLAYOUT_L;
        this.layoutCom.layoutOffx = 30;
    },

    Init:function(){
        this._super();

        var self = this;
        this.btnClose.addClickEventListener(function(){
            Mgr.uiMgr.HidePanel(self);
        });
        this.btnGo.addClickEventListener(function(){
            Mgr.uiMgr.HidePanel(self);
            Mgr.task.AutoTask(self.data.taskModelId);
        });
        this.btn1.addClickEventListener(function(){
            Mgr.uiMgr.HidePanel(self);
            Mgr.task.SendReqfinishTaskMessage(self.data.taskModelId);
        });
    },

    RefreshView:function(data){
        if(data && data.taskModelId && this.data.taskModelId){
            this.UpdateView(data,false);
        }
    },

    UpdateView:function(data,finished){
        data = data || this.data;

        this.data = data;

        var taskC = Q_mission_base.Get(data.taskModelId);

        var descStr = taskC.q_finish_describe.replace(/：/g,"");
        descStr = TextUtil.RemoveHTMLTag(descStr);

        var missionCompleted = TaskUtil.CheckTaskComplate(data.taskModelId, data) == EnumTaskState.STATE_UNSUBMIT;

        var rate = [0,1];
        if( taskC.q_mission_type == NpcSubTaskType.TASK_MONSTER
            || taskC.q_mission_type == NpcSubTaskType.TASK_COLLECT_PROPS
        ){
            var ret = TaskUtil.GetTaskComplate(data.taskModelId, data);
            rate = ret && ret [0] || rate;
        }else if(taskC.q_mission_type == NpcSubTaskType.TASK_PASS_ZONE){
            rate = missionCompleted ? [1,1]:[0,1];
        }else if(taskC.q_mission_type == NpcSubTaskType.TASK_TALK){
            rate = [1,1];
        }

        UIUtil.ConnectLabelHtmlText(this.labMingCheng1,[taskC.q_name || "???"]);
        UIUtil.ConnectLabelHtmlText(this.labNeiRong1, [
            descStr,
            rate[0],
            rate[1],
            ]);
        UIUtil.ConnectLabelHtmlText(this.labXuanShang,[
            Mgr.task.rewardTaskTimes,
            taskC.q_completions || "???"
        ]);

        // reward
        var rewardItems = TaskUtil.GetConquerMissionRewards(taskC,Mgr.task.rewardTaskTimes >= taskC.q_completions - 1);
        GridUtil.SetItemGrid(this.grid1,rewardItems[3]);
        GridUtil.SetItemGrid(this.grid2,rewardItems[0]);
        GridUtil.SetItemGrid(this.grid3,rewardItems[1]);
        GridUtil.SetItemGrid(this.grid4,rewardItems[2]);

        this.grid1.visible = rewardItems[3];
        this.grid2.visible = rewardItems[0];
        this.grid3.visible = rewardItems[1];
        this.grid4.visible = rewardItems[2];

        this.btnGo.visible = !finished;
        this.btn1.visible = finished;
    },
} );

TaskXuanShangRenWuExt.PanelName = "TaskXuanShangRenWuExt";
PanelClassDic["TaskXuanShangRenWuExt"] = TaskXuanShangRenWuExt;
