var TeamCreatePanelExt = TeamCreatePanel.extend ( {
	_className:"TeamCreatePanelExt",

	_playerModule:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		TeamCreatePanel.prototype.Init.call(this);

        self.sbtnGouxuan.addClickEventListener(function (event) {
			var infor = Mgr.plugset.GetPlugSetInfo();
            infor.autoInvite = this.GetState() == MUICheckBox.STATE_CHECK;
            Mgr.plugset.SendReqPlugSetInfoMessage(infor);
        });

        self.sbtnGouxuan1.addClickEventListener(function (event) {
            var infor = Mgr.plugset.GetPlugSetInfo();
            infor.autoAgree = this.GetState() == MUICheckBox.STATE_CHECK;
            Mgr.plugset.SendReqPlugSetInfoMessage(infor);
        });

        self.btnChuangjian.addClickEventListener(function (event){
			Mgr.team.SendReqCreateTeamMessage();
		});
        self.btnKuaisu.addClickEventListener(function (event){
			Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName).ChangePanel( TeamEnum.PANEL_TEAM_QUICK_TEAM );
		});
	},

	_UpdataPanel:function () {
		var job = Mgr.player.mainPlayer.job;
		this._AddPlayerModule(job);

		// name
		var name = Mgr.player.mainPlayer.name;
		this.labName.SetString(name);

		// level
		var level = Mgr.player.mainPlayer.attributeData.level;
		this.labLv1.SetString(level);
	},

	_AddPlayerModule:function( job )
	{
		// if ( this._playerModule ){this._playerModule.removeFromParent();this._playerModule = null;}
		// var obj = new MAnimationObject();
		// obj.sResUrlBase = "res/animation/effect/ui/player/" + job;
		// obj.DoAction("stand", 4, EnumDefaultResType.NONE);
		// this.imgModel.addChild(obj);
		// this._playerModule = obj;
        var info = Mgr.player.mainPlayer;
        if(!this._playerModel){
            this._playerModel = new UIModel(SceneObjUtil.GetBodyIdByInfo(info));
            this.imgModel.addChild(this._playerModel);
		}else {
        	this._playerModel.RemoveAll();
        	this._playerModel.SetModelId(SceneObjUtil.GetBodyIdByInfo(info));
		}

        if(info.armorShowId != 0){
            var wingId = ScenePlayer.prototype._Getnresid(info.armorShowId);
            this._playerModel.AddWing(wingId);
        }
        for( var i = 0; i < info.playerResLineInfo.length; i++ ){
            var resline = info.playerResLineInfo[i];
            if(resline.type == EnumResline.GUANGWU){
                this._playerModel.AddWeapon(SceneObjUtil.GetGodWeaponResId(info.showIllusionInfo, true) || resline.modelid, info.nJobId);
                break;
			}
        }
        this._playerModel._animGroup.CheckPartZOrder();
	},

	OnShow:function () {
		this._UpdataPanel();
	},
} );
TeamCreatePanelExt.PanelName = "TeamCreatePanelExt";
PanelClassDic["TeamCreatePanelExt"] = TeamCreatePanelExt;
