var TeamMemberInfoPanelExt = TeamMemberInfoPanel.extend ( {
	_className:"TeamMemberInfoPanelExt",

	_briefInfo:null,

	_btnPt:null,
	_btnList:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		TeamMemberInfoPanel.prototype.Init.call(this);

		this.InitParam();

		this.btnClose.addClickEventListener(function (event) {
			EngineMgr.uiMgr.HidePanel(self);
		});

		this.btnXiaoxi.addClickEventListener(function (event) {   // 打开私聊
			Mgr.chat.curChatChannel = EnumChatChannelType.TEAM;
			Mgr.chat.ShowHideChatPanel(true);

			Mgr.uiMgr.HidePanel(self);
			Mgr.uiMgr.HidePanelByType(TeamPanelExt.PanelName);

			//var panel = Mgr.uiMgr.ShowPanelByType( ChatPanelExt.PanelName );
			//Mgr.chat.curChatChannel = EnumChatChannelType.SOUND;
			//panel.ShowChatMsg();
		});
		this.btnGroup.addClickEventListener(function (event) {
			Mgr.guild.SendReqGuildInviteAddMessage(self._briefInfo.playerid);  // 帮会邀请没有示意图
		});
		this.btnFriend.addClickEventListener(function (event) {
			Mgr.friend.SendReqApplyFriendMessage( self._briefInfo.playerid );
		});
		this.btnXinxi.addClickEventListener(function (event) {
			// 角色详情界面
			var panel = Mgr.uiMgr.ShowPanelByType( OtherRolePanelExt.PanelName );
			panel.SetData(self._briefInfo, EnumDetails.OPEN_MODE_NORMAL);
		});
		this.btnDrop.addClickEventListener(function (event) {
			Mgr.team.SendReqKickTeamMessage(self._briefInfo.playerid);
			EngineMgr.uiMgr.HidePanel(self);
		});
	},

	InitParam:function () {
		this._btnPt = [this.btnXiaoxi.getPosition(),this.btnGroup.getPosition(),
			this.btnFriend.getPosition(),this.btnXinxi.getPosition(),this.btnDrop.getPosition()];
		this._btnList = [this.btnXiaoxi,this.btnFriend,this.btnGroup, this.btnXinxi,this.btnDrop];
		for ( var i = 0; i != this._btnList.length; i++ ) {
			this._btnList[i].retain();
			this._btnList[i].removeFromParent();
		}
	},

	SetData:function (memberId) {
		Mgr.player.SendReqPlayerBriefMessage([memberId],EnumBriefType.TEAM_MAP_INVISITE);
	},

	SetPlayerBriefMsg:function (briefInfo) {
		this._briefInfo = briefInfo;
		// name
		this.labName.SetString(briefInfo.playerName);
		// level
		this.labLevel1.SetString(briefInfo.level);
		// fight
		this.labFight1.SetString(briefInfo.fightpower);

		// team number
		var num = Mgr.team.teamInfo.memberinfo.length;
		var str = num + "/3";
		this.labTeamNum1.SetString(str);

		this.RepBtnPos();
	},

	RepBtnPos:function () {
		for ( var i = 0; i != this._btnList.length; i++ ) {
			if ( this._btnList[i].parent )
				this._btnList[i].removeFromParent();
		}

		var array = [this.btnXiaoxi, this.btnXinxi,this.btnDrop];

		// add friend
		if ( !Mgr.friend.GetFriendList().Get( this._briefInfo.playerid ) )
			array.splice(1, 0, this.btnFriend);

		// guild invist
		var isGuild = false;
		if ( !this._briefInfo.guildName && !Mgr.player.mainPlayer.guildId.IsZero()) {
			var info = Mgr.guild.guildMembers.Get(Mgr.player.mainPlayer.sid);
			if ( info && (info.guildPowerLevel == GuildEnum.MEMBER_GUILDER || info.guildPowerLevel == GuildEnum.MEMBER_SECONDGUILDER ))
				isGuild = true;
		}
		if ( isGuild )
			array.splice(1, 0, this.btnGroup);

		for ( var i = 0; i != array.length; i++ ) {
			var pt_x = this._btnPt[i].x;
			var pt_y = this._btnPt[i].y;
			array[i].setPosition(pt_x, pt_y);
			this.addChild(array[i]);
		}
	},
} );
TeamMemberInfoPanelExt.PanelName = "TeamMemberInfoPanelExt";
PanelClassDic["TeamMemberInfoPanelExt"] = TeamMemberInfoPanelExt;
