var TeamShenqingPanelExt = TeamShenqingPanel.extend ( {
	_className:"TeamShenqingPanelExt",

	// 链表三件套
	_listView : null,
	_itemContainer:null,
	_curSelectItem:null,

	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this._itemContainer = [];
	},

	Init:function() {
		var self = this;
		TeamShenqingPanel.prototype.Init.call(this);

		this.btnQingkong.addClickEventListener(function (event) {
			Mgr.team.applyList.Clear();
			self._listView.removeAllChildren(true);
			Mgr.uiMgr.GetPanelByType(TeamPanelExt.PanelName).UpdataWarn();
		});

		this._InitParam();
	},

	_InitParam:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg.width, this.imgBg.height));
		list.setTouchEnabled(true);
		list.setScrollBarEnabled(false)
		list.setBounceEnabled(true);
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.setPosition(0,0);

		this.imgBg.addChild(list);
		this._listView = list;
	},

	_UpdataPanel:function () {
		this.SetData();
	},

	SetData:function () {
		var hash = Mgr.team.applyList;
		this._LaodItems(hash.Values());
	},

	_LaodItems:function (list) {
		// list
		this._listView.removeAllChildren(true);
		var str;
		if ( list.length <= 0 ) {
			str = "似乎没有人申请加入队伍！";
			this.imgCue.visible = true;
		}
		else {
			str = "选择你喜欢的队友加入队伍吧！";
			this.imgCue.visible = false;
		}
		this.labCue.SetString(str);

		for ( var i = 0; i != list.length; i++ ) {
			var item;
			if ( i < this._itemContainer.length ) {
				item = this._itemContainer[i];
			}
			else {
				item = new TeamShenqingListExt();
				item.LoadPanel();
				item.retain();
				this._itemContainer.push(item);
			}
			item.SetData( list[i] );
			this._AddItem(item);
		}

		// select
		//this._ResetSelectItem();
		//if ( this._curSelectItem )
		//	this._curSelectItem.SetSelect(true);
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	OnShow:function () {
		this._UpdataPanel();
	},
} );
TeamShenqingPanelExt.PanelName = "TeamShenqingPanelExt";
PanelClassDic["TeamShenqingPanelExt"] = TeamShenqingPanelExt;
