var TeamTuchInfoExt = TeamTuchInfo.extend ( {
	_className:"TeamTuchInfoExt",
	_btnArr:[],
	_playerId:null,
	_leaderBtnArr:[],
	_leaderBtnArr01:[],
	_normalBtnArr:[],
	_normalBtnArr01:[],
	ctor:function(){
		this._super();
	},
	Init:function()
	{
		TeamTuchInfo.prototype.Init.call(this);
		this._SetLocalProperty();
		this._SetTouchListener();
	},
	_SetLocalProperty:function()
	{
		this.btnGensui.setTitleText("跟随队长");
		if(Mgr.team.followState)
		{
			this.btnGensui.setTitleText("取消跟随");
		}
		this._btnArr = [this.btnGensui,this.btnAddFriend,this.btnShenqing,this.btnQingli,this.btnOut,this.btnWeiren,this.btnJiesan];
		this._leaderBtnArr = [
			{pos:this.btnJiesan.getPosition(),btn:this.btnJiesan},
			{pos:this.btnWeiren.getPosition(),btn:this.btnOut},
			{pos:this.btnQingli.getPosition(),btn:this.btnWeiren},
			{pos:this.btnShenqing.getPosition(),btn:this.btnQingli},
			{pos:this.btnOut.getPosition(),btn:this.btnAddFriend}
		];
		this._leaderBtnArr01 = [
			{pos:this.btnJiesan.getPosition(),btn:this.btnJiesan},
			{pos:this.btnWeiren.getPosition(),btn:this.btnOut},
			{pos:this.btnQingli.getPosition(),btn:this.btnWeiren},
			{pos:this.btnShenqing.getPosition(),btn:this.btnQingli}
		];
		this._normalBtnArr = [
			{pos:this.btnJiesan.getPosition(),btn:this.btnOut},
			{pos:this.btnWeiren.getPosition(),btn:this.btnAddFriend},
			{pos:this.btnQingli.getPosition(),btn:this.btnGensui}
		];
		this._normalBtnArr01 = [
			{pos:this.btnJiesan.getPosition(),btn:this.btnOut},
			{pos:this.btnWeiren.getPosition(),btn:this.btnGensui}
		];
		var self = this;
		for( var i = 0; i < this._btnArr.length; i++ )
		{
			this._btnArr[i].type = i;
			this._btnArr[i].addClickEventListener(function(target){self._HandleButtonEvent(target.type);});
		}
	},
	ShowPanelByPos:function(pos,parent,isLeader)
	{
		this._playerId = parent.playerId
		var size = cc.size(this.width,195);
		var isFrend = this._GetIsFriend(this._playerId);
		var normalArr = [];
		var leaderArr = [];
		if(isFrend)
		{
			size = isLeader ? cc.size(this.width,254) : cc.size(this.width,134);
			normalArr = this._normalBtnArr01;
			leaderArr = this._leaderBtnArr01;
		}
		else
		{
			size = isLeader ? cc.size(this.width,314) : cc.size(this.width,195);
			normalArr = this._normalBtnArr;
			leaderArr = this._leaderBtnArr;
		}
		this.setContentSize(size);
		this.setPosition(pos.x+parent.width+10,pos.y-this.height+30);
		this._HandleBtnPos(isLeader,normalArr,leaderArr);
	},
	_GetIsFriend:function(playerId)
	{
		return Mgr.friend.friendList.Get(playerId);
	},
	_HandleBtnPos:function(isLeader,normalArr,leaderArr)
	{
		for(var i = 0; i < this._btnArr.length;i++ )
		{
			this._btnArr[i].visible = false;//TODO
		}
		if(isLeader)
		{
			for(var i = 0;i < leaderArr.length;i++)
			{
				leaderArr[i].btn.visible = true;
				leaderArr[i].btn.setPosition(leaderArr[i].pos);
			}
		}
		else
		{
			for(var i = 0;i < normalArr.length;i++)
			{
				normalArr[i].btn.visible = true;
				normalArr[i].btn.setPosition(normalArr[i].pos);
			}
		}
	},
	_SetTeamplayerFollow:function()
	{
		var isFollow = Mgr.team.followState;
		if(isFollow)
		{
			Mgr.team.ClearFollowListen();
			this.btnGensui.setTitleText("跟随队长");
		}
		else
		{
			Mgr.team.StartFollow();
			this.btnGensui.setTitleText("取消跟随");
		}
	},
	_HandleButtonEvent:function(type)
	{
		var playerId = this._playerId;
		switch (type)
		{
			case 0://跟随
			{
				this._SetTeamplayerFollow();
				break;
			}
			case 1://加好友
			{
				Mgr.friend.SendReqApplyFriendMessage(playerId);
				break;
			}
			case 2://申请带队，（多余的按钮，不处理,游戏中隐藏）
			{
				break;
			}
			case 3://请离队伍
			{
				Mgr.team.SendReqKickTeamMessage(playerId);
				break;
			}
			case 4://退出队伍
			{
				Mgr.team.SendReqLeaveTeamMessage(1);
				break;
			}
			case 5://委任队长
			{
				var teamId = Mgr.team.teamInfo.teamId;
				Mgr.team.SendReqAppointGameMessage(teamId,playerId);
				break;
			}
			case 6://解散队伍
			{
				Mgr.team.SendReqDismissTeamToGameMessage();
				break;
			}
			default : break;
		}
		this._HideSelf();
	},
	_SetTouchListener:function()
	{
		var self = this;
		this.listener = cc.EventListener.create(
		{
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			onTouchBegan: function (touch, event)
			{
				self._HideSelf();
				return true;
			}
		});
		cc.eventManager.addListener(this.listener, this);
	},
	_HideSelf:function()
	{
		EngineMgr.uiMgr.HidePanel(this);
	}
} );
TeamTuchInfoExt.PanelName = "TeamTuchInfoExt";
PanelClassDic["TeamTuchInfoExt"] = TeamTuchInfoExt;
