var BanghuiZhengbaMainExt = BanghuiZhengbaMain.extend({
    _className: "BanghuiZhengbaMainExt",

    selectedType: 0,
    model: null,

    ctor: function() {
        this._super();
    },

    Init: function() {
        this._super();

        this.gridAward.visible = false;
        this.rewardsGrid = new TaskRewardsGridCon();
        this.addChild(this.rewardsGrid);
        this.rewardsGrid.x = this.gridAward.x;
        this.rewardsGrid.y = this.gridAward.y;

        this.btnGo.addClickEventListener(this._onBtnClicked_Go.bind(this));

        this.config = [
            { btn: this.btn1, type: 0, zoneid: 12003 },
            { btn: this.btn2, type: 1, zoneid: 12004  },
            { btn: this.btn3, type: 2, zoneid: 12005 },
            { btn: this.btn31, type: 3, zoneid: 12006 },
        ]
        for (var v of this.config) {
            v.btn.addClickEventListener(this._onBtnClicked_Group.bind(this));
        }

        this.imgBox.addClickEventListener(this._onBtnClicked_Award.bind(this));
        this.imgBox1.addClickEventListener(this._onBtnClicked_Award1.bind(this));
        this.imgBox2.addClickEventListener(this._onBtnClicked_Award1.bind(this));
        this.imgBox3.addClickEventListener(this._onBtnClicked_Award1.bind(this));

        this.UpdateView();

        var self = this;
        this.imgTips.visible = false;
        this.reorderChild(this.imgTips, 1000);
        this.lab3.setTouchEnabled(true);
        this.lab3.addTouchEventListener(function(sender, type){
            if ( type == ccui.Widget.TOUCH_BEGAN )
            {
            }
            else if ( type == ccui.Widget.TOUCH_ENDED )
            {
                if(self.imgTips.visible)
                    self.imgTips.visible = false;
                else
                    self.imgTips.visible = true;
            }
            else if ( type == ccui.Widget.TOUCH_CANCELED )
            {
            }
        });

        this.btnOut.addClickEventListener(function(event){
            self.imgTips.visible = false;
        });
    },
    _onBtnClicked_Award: function(sender, type) {
        Mgr.kingneutral.SendReqGetkingNeutralAwardClientToGameMessage();
    },
    _onBtnClicked_Award1: function(sender, type) {
        Mgr.kingguild.SendReqkingguildGetRewardToGameMessage();
    },
    _onBtnClicked_Go: function() {
        if (this.selectedType == 0) {
            //            if(Mgr.kingneutral.stateInfo)

            Mgr.kingneutral.SendReqkingneutralEnterClientToGameMessage();
        } else {
            // if (Mgr.kingguild.stateInfo && Mgr.kingguild.stateInfo.canfight == 1) {
                Mgr.kingguild.SendReqkingguildEnterClientToGameMessage({
                    zoneid: this.config[this.selectedType].zoneid,
                });
            // } else {
            //     Mgr.tips.ShowNotice("战场未开启！！！");
            // }
        }
    },
    _onBtnClicked_Group: function(sender) {
        for (var v of this.config) {
            if (v.btn === sender) {
                this.selectedType = v.type;
                break;
            }
        }
        this.OnTypeSelected();
    },

    OnShow: function() {
        this.UpdateView();

        Mgr.kingguild.SendReqkingguildClientToGameMessage();
        Mgr.kingneutral.SendReqkingneutralClientToGameMessage();
    },
    OnHide: function() {

        if (this.model) {
            this.model.Dispose();
            this.model = null;
        }
    },
    OnTypeSelected: function() {
        this.rewardsGrid.Clear();

        var config
        if (this.selectedType == 0) {
            config = Q_timing.Get(10);
        } else {
            config = Q_timing.Get(9);
        }
        if (config && config.q_item_show != "") {
            var rewards = JSON.parse(config.q_item_show);
            if (rewards && rewards.length > 0) {
                for (var v of rewards) {
                    var item = ItemUtil.ItemIdToItem(v.mod, v.num, 0);
                    this.rewardsGrid.AddComItem(item, this.gridAward);
                }
                this.rewardsGrid.Layout(this.gridAward.uiWidth * rewards.length,
                    this.gridAward.uiHeight, this.gridAward.uiWidth, this.gridAward.uiHeight);
            } else {
                this.rewardsGrid.visible = false;
            }

            var curDate = Mgr.login.GetServerDate();
            var today = curDate.getDay();

            var dayArr = JSON.parse(config.q_day);
            var minDay = 0xFF;
            for (var v of dayArr) {
                var day = parseInt(v);
                if (day == 7) day = 0;

                if (day == -1 || today == day) {
                    minDay = 0;
                    break;
                }
                minDay = Math.min(minDay, (day + 7 - today) % 7);
            }

            curDate.setDate(curDate.getDate() + minDay);
            UIUtil.ConnectLabelHtmlText(this.labTime, [TimeUtil.GetDateStr(curDate.getTime() / 1000, "yyyy年MM月dd日")]);
        } else {
            this.rewardsGrid.visible = false;

            UIUtil.ConnectLabelHtmlText(this.labTime, ["???"])
        }
    },
    UpdateView: function() {
        this.OnTypeSelected();

        UIUtil.ConnectLabelHtmlText(this.labName, [Mgr.kingneutral.stateInfo && Mgr.kingneutral.stateInfo.captainname || "虚位以待"])
        UIUtil.ConnectLabelHtmlText(this.labCue, [Mgr.kingneutral.stateInfo && Mgr.kingneutral.stateInfo.guildname || "虚位以待"])
        UIUtil.ConnectLabelHtmlText(this.labCue2, [Mgr.kingguild.stateInfo && Mgr.kingguild.stateInfo.ocname[0] || "虚位以待"])
        UIUtil.ConnectLabelHtmlText(this.labCue3, [Mgr.kingguild.stateInfo && Mgr.kingguild.stateInfo.ocname[1] || "虚位以待"])
        UIUtil.ConnectLabelHtmlText(this.labCue4, [Mgr.kingguild.stateInfo && Mgr.kingguild.stateInfo.ocname[2] || "虚位以待"])

        var roleId = Mgr.kingneutral.stateInfo
            && Mgr.kingneutral.stateInfo.captainname != null
            && Mgr.kingneutral.stateInfo.job == 0 ? 31006 : 31008;
        if (!this.model){
            var model = new UIModel(roleId,EnumResline.PLAYER);
            model.x = this.imgModel.width / 2;
            this.imgModel.addChild(model);
            this.model = model;
        }else{
            this.model.SetModelId(roleId,EnumResline.PLAYER);
        }

        var guildId = Mgr.player.mainPlayer.guildId;
        var guildInfo = Mgr.guild.guildMap.Get(guildId.hexValue);
        var guildName = guildInfo ? guildInfo.guildName : "";

        for (var i = 0; i < 3; i++) {
            if (Mgr.kingguild.stateInfo &&
                Mgr.kingguild.stateInfo.ocname[i] == guildName) {
                this["imgBox" + (i + 1)].visible = true;

                if (Mgr.kingguild.stateInfo.canget == 1) {
                    this["labGot" + (i + 1)].visible = false;
                    this["imgBox" + (i + 1)].setTouchEnabled(true);
                } else {
                    this["labGot" + (i + 1)].visible = true;
                    this["imgBox" + (i + 1)].setTouchEnabled(false);
                }
            } else {
                this["imgBox" + (i + 1)].visible = false;
            }
        }

        if (Mgr.kingneutral.stateInfo &&
            Mgr.kingneutral.stateInfo.guildname == guildName) {
            this.imgBox.visible = true;
            if (Mgr.kingneutral.stateInfo.isAward == 1) {
                this.labGot.visible = false;
                this.imgBox.setTouchEnabled(true);
            } else {
                this.labGot.visible = true;
                this.imgBox.setTouchEnabled(false);
            }
        } else {
            this.imgBox.visible = false;
        }
    },
});
BanghuiZhengbaMainExt.PanelName = "BanghuiZhengbaMainExt";
PanelClassDic["BanghuiZhengbaMainExt"] = BanghuiZhengbaMainExt;