var TimeActivitiesPanelExt = TimeActivitiesPanel.extend({
    _className: "TimeActivitiesPanelExt",
    ctor: function() {
        this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
    },

    Init: function() {
        this._super();

        this.btnClose.addClickEventListener(function(){
             EngineMgr.uiMgr.HidePanel(this);
        }.bind(this));

        this.config = [
            {btn : this.sbtnBanghuizhengba, panelName:BanghuiZhengbaMainExt.PanelName,},
            {btn : this.sbtnBanghuizhengba1, panelName:jianghuyingxiongbangExt.PanelName,},

            ];
        for(var v of this.config){
            v.btn.addClickEventListener(this._onBtnClicked_Tabs.bind(this));
        };

        this._onBtnClicked_Tabs(this.config[0].btn);
    },

    _onBtnClicked_Tabs:function(sender,handled){
        sender.SetButtonState("check");

        for(var v of this.config){
            if(sender == v.btn){
                if(!this[v.panelName]) {
                    var panel = new PanelClassDic[v.panelName]();
                    panel.LoadPanel();

                    this.imgTitleBg.addChild(panel);
                    if(v.x && v.y){
                        panel.x = v.x;
                        panel.y = v.y;
                    }
                    this[v.panelName] = panel;
                }
                this[v.panelName].visible = true;
                this[v.panelName].OnShow();
            }else{
                if(handled) v.btn.SetButtonState("uncheck");
                if(this[v.panelName]) {
                    this[v.panelName].visible = false;
                    this[v.panelName].OnHide();
                }
            }
        }
    },

    OnShow:function(){
    },
    OnHide:function(){
        this._super();
    },
    ChangeView:function(index){
        index = index || 0;
        this._onBtnClicked_Tabs(this.config[index].btn,true);
    },
    UpdateView:function(){
         for(var v of this.config){
            if(this[v.panelName] && this[v.panelName].visible  ) {
                this[v.panelName].UpdateView();
            }
         }
    },
});
TimeActivitiesPanelExt.PanelName = "TimeActivitiesPanelExt";
PanelClassDic["TimeActivitiesPanelExt"] = TimeActivitiesPanelExt;