var JiLuFrameExt = JiLuFrame.extend ( {
	_className:"JiLuFrameExt",

    _view:null,
    _vScrollView:null,
    _vScrollView1:null,
    _vScrollView2:null,

    _infoList:null,
    _InfoItemList:[],
    _InfoItemList1:[],
    _InfoItemList2:[],

    _btnList:null,

	_type:1,
    personInfo:null,
    allInfo:null,

	ctor:function(){
		this._super();
	},

    Init:function () {
        JiLuFrame.prototype.Init.call(this);

        this._btnList = [
            {btn: this.imgJiLu, type: 1},
            {btn: this.imgJiLu1, type: 2},
            {btn: this.imgJiLu2, type: 3},
        ];

        this.img1.visible = false;
        this.labCue11.SetHtmlText("<font color=\"#3a2707\">每次寻宝 10 元宝进入奖池，每次抽奖有概率抽取奖池元宝");

        var self = this;
        for(var i = 0; i < this._btnList.length; i++){
            this._btnList[i].btn.SetButtonState("uncheck");
            (function(i){
                self._btnList[i].btn.addClickEventListener(function (sender) {
                    self._type = self._btnList[i].type;
                    self.RefreshList();
                });
            })(i);
        }

        this.imgJiLu1.SetText("个人记录");

        this.InitListView();
    },

	OnShow:function(){
	    this.RefreshList();
	},

	InitListView:function(){
        if(!this._vScrollView){
            this._vScrollView = new ccui.ListView();
            this._vScrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._vScrollView.setTouchEnabled(true);					//触摸开启
            this._vScrollView.inertiaScrollEnabled = false; 			//滚动惯性
            this._vScrollView.setScrollBarEnabled(true);				//滚动条
            this._vScrollView.setBounceEnabled(true);					//边界回弹
            this.imgDi.addChild(this._vScrollView);
        }

        if(!this._vScrollView1){
            this._vScrollView1 = new ccui.ListView();
            this._vScrollView1.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._vScrollView1.setTouchEnabled(true);					//触摸开启
            this._vScrollView1.inertiaScrollEnabled = false; 			//滚动惯性
            this._vScrollView1.setScrollBarEnabled(true);				//滚动条
            this._vScrollView1.setBounceEnabled(true);					//边界回弹
            this.imgDi.addChild(this._vScrollView1);
        }

        if(!this._vScrollView2){
            this._vScrollView2 = new ccui.ListView();
            this._vScrollView2.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
            this._vScrollView2.setTouchEnabled(true);					//触摸开启
            this._vScrollView2.inertiaScrollEnabled = false; 			//滚动惯性
            this._vScrollView2.setScrollBarEnabled(true);				//滚动条
            this._vScrollView2.setBounceEnabled(true);					//边界回弹
            this.imgDi.addChild(this._vScrollView2);
        }
	},

	RefreshList:function(){
		var showInfo = [];

        var allInfo = Mgr.luckydraw.guangwuPanel.allInfo;
        var personInfo = Mgr.luckydraw.guangwuPanel.personInfo;
        if(personInfo)
            this.personInfo = personInfo;
        if(allInfo)
            this.allInfo = allInfo;

        if(this._view)
            this._view.visible = false;
		switch(this._type){
            case 1:
                if(this.allInfo)
                    showInfo = this.allInfo.RecordBests;
                this._view = this._vScrollView;
                this._infoList = this._InfoItemList;
                break;
            case 2:
                if(this.personInfo)
                    showInfo = this.personInfo.records;
                else {
                    if(this.allInfo){
                        var temp = [];
                        for(var i = 0, len = this.allInfo.records.length; i < len; i++){
                            var record = this.allInfo.records[i];
                            if(record.playerId.toGID() == Mgr.player.mainPlayer.sid.toGID()){
                                temp.push(record);
                            }
                        }
                        showInfo = temp;
                    }
                }
                this._view = this._vScrollView1;
                this._infoList = this._InfoItemList1;
                break;
            case 3:
                if(this.allInfo)
                    showInfo = this.allInfo.records;
                this._view = this._vScrollView2;
                this._infoList = this._InfoItemList2;
                break;
		}
        this._view.visible = true;
		var i = 0;
        for(i; i != this._btnList.length; i++){
            if(this._btnList[i].type == this._type)
                this._btnList[i].btn.SetButtonState("check");
            else
                this._btnList[i].btn.SetButtonState("uncheck");
        }
		for(i = 0; i < showInfo.length; i++){
			if(!this._infoList[i]){
                var panel = this._getTextLabel();
                this._view.pushBackCustomItem(panel);
                this._infoList.push(panel);
			}
            this.SetData(this._infoList[i].label, showInfo[i]);
		}
        this._view.setSize(cc.size(this.imgDi.uiWidth, this.imgDi.uiHeight));
        this._view.setInnerContainerSize(cc.size(this.imgDi.uiWidth, showInfo.length * this.img1.uiHeight/2));
	},

	_getTextLabel:function(){
		var node = new MUIImage();
        node.ParseJson(this.img1.jsonobj);
        node.Init();
        node.removeAllChildren()
		var img = new MUIImage();
        img.ParseJson(this.imgDian.jsonobj);
        img.Init();
        img.y = img.y-this.img1.uiHeight/2;
        var label = new MUILabel();
        label.ParseJson(this.lab1.jsonobj);
        label.Init();
        label.y = label.y-this.img1.uiHeight/2;
        node.addChild(img);
        node.addChild(label);
        node.label = label;
        node.setContentSize(cc.size(this.img1.uiWidth, this.img1.uiHeight/2));
        return node;
	},

    SetData:function(label, info){
        var item = Q_item.Get(info.briefItemInfo.itemModelId);
        var str = "";
        str += "【" + info.playerName + "】获得:  ";
        str += TextUtil.AddColor(item.q_name + "*" + info.briefItemInfo.num, ItemUtil.GetNameColorById(info.briefItemInfo.itemModelId));
        label.SetText(str);
    },

    OnHide:function(){
        // this._vScrollView.removeAllChildren();
        // this._InfoItemList = [];
    },
} );
JiLuFrameExt.PanelName = "JiLuFrameExt";
PanelClassDic["JiLuFrameExt"] = JiLuFrameExt;
