var JiFenDuiHuanMainExt = JiFenDuiHuanMain.extend ( {
	_className:"JiFenDuiHuanMainExt",
	_curShowType:0,   //0 - 积分， 1 - 商城
	ctor:function(){
		this._super();
	},

	Init:function () {
		JiFenDuiHuanMain.prototype.Init.call(this);

		// this.imgTanhao1 = UIUtil.AddButtonRedTip(this.imgShangCheng);
		// this.imgTanhao1.x = 0;
		var self = this;
		this.imgDuiHuan.addClickEventListener(function (sender) {
			self.ShowJiFenPanel();
        });

		this.imgShangCheng.addClickEventListener(function (sender) {
			self.ShowShopPanel();
        });
    },

	SetData:function (info) {
		this._data = info;
		UIUtil.ConnectLabelHtmlText(this.labCue, [info.score]);
		this.RefreshJiFenRedWarn();
		// this.RefreshShopRedWarn();

		if(this._curShowType == 0){
			this.ShowJiFenPanel();
		}else if(this._curShowType == 1){
			this.ShowShopPanel();
		}
    },

	ShowJiFenPanel:function () {
		this._curShowType = 0;

		this.labCue.setVisible(true);
        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgContent.uiWidth, this.imgContent.uiHeight - 8));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.setTouchEnabled(true);
            tableView.y += 5;
            this.cellPanel=tableView;
            this.imgContent.addChild(tableView);
        }

        if(Mgr.luckydraw.xingYunPanel){
        	this.jiFenInfos = Mgr.luckydraw.xingYunPanel.GetInfosByTabKey(2);
            this.totalNum = this.jiFenInfos ? Math.ceil(this.jiFenInfos.length / 2) : 0;
		}

		if(this.shopPanel){
        	this.shopPanel.setVisible(false);
		}
		this.cellPanel.setVisible(true);
        this.cellPanel.reloadData();
    },

	ShowShopPanel:function () {
		this._curShowType = 1;

		this.labCue.setVisible(false);
		if(!this.shopPanel){
			var panel = new DuiHuanShangChengMainExt();
			panel.LoadPanel();
			panel.retain();
			panel.y -= 70;
			this.imgContent.addChild(panel);
			this.shopPanel = panel;
		}

		this.shopPanel.SetData();
		if(this.cellPanel){
			this.cellPanel.setVisible(false);
		}
		this.shopPanel.setVisible(true);
    },

	RefreshJiFen:function (ac) {
		for(var i = 0; i < this.totalNum; i++){
			var cell = this.cellPanel.cellAtIndex(i);
			if(cell){
				if(cell.leftItem._data.activityId == ac.activityId){
					cell.leftItem.SetData(ac, this._data.score);
					break;
				}
				if(cell.rightItem._data.activityId == ac.activityId){
					cell.rightItem.SetData(ac, this._data.score);
                    break;
				}
			}
		}
		this.RefreshJiFenRedWarn();
    },

	RefreshShop:function (ac) {
		var score = Mgr.mainPlayer.attributeData.GetAttribute(EnumMoney.LUCKY_GOLD, AttributeData.Money);
		UIUtil.ConnectLabelHtmlText(this.shopPanel.labShuZi, [score]);
    },

    RefreshJiFenRedWarn:function () {
        var jfInfos = Mgr.luckydraw.xingYunPanel.GetInfosByTabKey(2);
        var warn = false;
        for(var i = 0, len = jfInfos.length; i < len; i++){
        	if(jfInfos[i].status == 1){
        		warn = true;
        		break;
			}
		}
		this.imgTanhao.setVisible(warn);
    },

	RefreshShopRedWarn:function () {
        var scInfos = Mgr.luckydraw.xingYunPanel.GetInfosByTabKey(3);
        var warn = false;
        for(var i = 0, len = scInfos.length; i < len; i++){
            if(scInfos[i].status == 1){
                warn = true;
                break;
            }
        }
		this.imgTanhao1.setVisible(warn);
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(1069, 114);
    },
    tableCellAtIndex: function (table, idx) {
		var leftData = this.jiFenInfos[idx * 2];
		var rightData = this.jiFenInfos[idx * 2 + 1];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            if(leftData){
                var leftItem = new JiFenJiangLiFrameExt();
                leftItem.LoadPanel();
                leftItem.setTouchEnabled(false);
                cell.leftItem = leftItem;
                cell.addChild(leftItem);
			}

			if(rightData){
                var rightItem = new JiFenJiangLiFrameExt();
                rightItem.LoadPanel();
                rightItem.setTouchEnabled(false);
                rightItem.x += rightItem.uiWidth - 8;
                cell.rightItem = rightItem;
                cell.addChild(rightItem);
			}
        }
        cell.leftItem.SetData(leftData, this._data.score);
        cell.rightItem.SetData(rightData, this._data.score);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
} );
JiFenDuiHuanMainExt.PanelName = "JiFenDuiHuanMainExt";
PanelClassDic["JiFenDuiHuanMainExt"] = JiFenDuiHuanMainExt;
