var YoujianMainExt = YoujianMain.extend ( {
	_className:"YoujianMainExt",
	_btnPos:[],
	_tableview:null,
	selectItemArr:null,
	_currentY:0,
	ctor:function(){
		this._super();
	},
	Init:function()
	{
		YoujianMain.prototype.Init.call(this);
		this.setPosition(5,-100);
		this.InitListView();
		this._SetLocalProperty();
		this._SetBaseProperty();
		this._HandleButton();
		this._SetGoldAndBGold();
		this._ClearGrid();
		this._HandleTableview();
		this._InitListviewData();
		this.setSwallowTouches(false);
	},

	InitListView:function(){
		this._listView = new ccui.ListView();
		this._listView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);//视图滚动方向
		this._listView.setTouchEnabled(true);					//触摸开启
		this._listView.inertiaScrollEnabled = false; 			//滚动惯性
		this._listView.setScrollBarEnabled(false);				//滚动条
		this._listView.setBounceEnabled(true);					//边界回弹
		this._listView.setSize(cc.size(700, this.gridItem0.uiHeight));
		this._listView.x = this.gridItem0.x - 10;
		this._listView.y = this.gridItem0.y;
		this.imgBg.addChild(this._listView);
	},

	_SetLocalProperty:function()
	{
		this.listCount = 0;
		this._gridArr = [
			this.gridItem0,
			this.gridItem1,
			this.gridItem2,
			this.gridItem3,
			this.gridItem4,
			this.gridItem5
		];
		for( var i = 0; i < this._gridArr.length; i++ ){
			this._gridArr[i].removeFromParent();
			this._listView.pushBackCustomItem(this._gridArr[i]);
		}
		this.isChecked = false;
		this.selectedItem = null;
		this.yjPanel = this._GetYoujianPanel();
		this._btnPos = [this.btnShanchu.getPosition(),this.btnGet.getPosition()];
		this.selectItemArr = new HashMap();
	},
	_HandleButton:function()
	{
		var self = this;
		this.btnShanchu.addClickEventListener(function()
		{
			self.DelateMail();
		});
		this.btnGet.addClickEventListener(function()
		{
			self.ReceiveMail();
		});
		this.sbtnGouxuan.addClickEventListener(function()
		{
			self._HandleGouxuan();
		});
	},
	_InitListviewData:function()
	{
		var data = Mgr.mail.mailList;
		if(data&&data.Size()>0)
		{
			var listData = Mgr.mail.mailList.Values();
            listData.sort(function (a, b) {
                return b.sendTime - a.sendTime;
            });
			this.UpdateInformation();
			this.labCue.visible = false;
			Mgr.mail.SendReqGetMailAttachmentMessage(listData[0].mailInfoId);
		}
		else
		{
			this.labCue.visible = true;
			this._ClearPanel();
		}
	},
	UpdateInformation:function(mailInfoId)
	{
		this._CheckAndDeleteListviewItem();
	},
	//读取邮件成功后的回调
	SetData:function(data)
	{
		//cc.log("data=> "+JSON.stringify(data));
		var data = data;
		this.imgDikuang.visible = false;
		this.labName.SetString(data.senderName ? data.senderName : "系统邮件");
		this.labTitle.SetString(data.subject);
		this.labcontent.SetString(data.content);
		this._ClearGrid();
		var aLen = data.attachments.length;
		if (aLen > 0 )
		{
			var itemsArr = [];
			var attachments = data.attachments;
			for(var i = 0; i < aLen;i++)
			{
				if(attachments[i].tempItemInfo.mod == EnumItemId.GOLD || attachments[i].tempItemInfo.mod == EnumItemId.BIND_GOLD)
				{
					this._SetGoldAndBGold(attachments[i].tempItemInfo)
					this.imgDikuang.visible = true;
				}
				else
				{
					itemsArr.push(attachments[i].tempItemInfo);
				}
			}
			this._listView.setInnerContainerSize(cc.size(itemsArr.length * this.gridItem0.uiWidth, this.gridItem0.uiHeight));
			for ( var i = 0; i < itemsArr.length; i++ )
			{
				if( i >= this._gridArr.length ){
					var grid = new MUIGrid();
					grid.ParseJson(this.gridItem0.jsonobj);
					grid.Init();
					this._listView.pushBackCustomItem(grid);
					this._gridArr.push(grid);
				}
				this._gridArr[i].visible = true;
				var dd = itemsArr[i];
				var item = ItemUtil.ItemIdToItem(dd.mod,dd.num,dd.isbind);
				GridUtil.SetItemGrid(this._gridArr[i],item,dd.mod,dd.isbind);
				if( data.isReceive )
					Filter.GrayScale(this._gridArr[i]);
			}
		}
		else
		{
			this._SetBtnGetVisible(false);
			this.imgDikuang.visible = false;
		}
		if(aLen>0 && !data.isReceive)
		{
			this._SetBtnGetVisible(true);
		}
		else
		{
			this._SetBtnGetVisible(false);
		}
		Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).CheckMailReceive();
		this._SetMailReadedFlag(data);
		if(Mgr.mail.mailList.Values().length == 0)
		{
			this.labCue.visible = true;
			this._ClearPanel();
		}
		else
		{
			this.labCue.visible = false;
		}
	},
	_SetBtnGetVisible:function(isShow)
	{
		this.btnGet.visible = isShow;
		if(isShow)
		{
			this.btnShanchu.setPosition(this._btnPos[0]);
		}
		else
		{
			this.btnShanchu.setPosition(this._btnPos[1]);
		}
	},
	_HandleGouxuan:function()
	{
		this.selectItemArr.Clear();
		this._ClearItemsSelected();
		var items =[];
		var itemArr = this._tableview.getContainer().getChildren();
		for(var i = 0,len = itemArr.length; i < len; i++ )
		{
			var item = itemArr[i].getChildren()[0];
			items.push(item);
		}
		if ( this.isChecked )
		{
			this.sbtnGouxuan.SetButtonState( this.sbtnGouxuan._btnStates[0] );
			this.isChecked = false;
			for (var i = 0 , len = items.length; i < len; i ++)
			{
				Mgr.mail.mailList.Get(items[i].data.mailInfoId).isChecked = false;
			}
		}
		else
		{
			this.sbtnGouxuan.SetButtonState( this.sbtnGouxuan._btnStates[1] );
			this.isChecked = true;
			for (var i = 0 , len = items.length; i < len; i ++)
			{
				Mgr.mail.mailList.Get(items[i].data.mailInfoId).isChecked = true;
			}
		}
		this.UpdateTableview();
	},
	_ClearGrid:function()
	{
		for ( var i = 0; i < this._gridArr.length; i++ )
		{
			this._gridArr[i].stopAllActions();
			this._gridArr[i].visible = false;
		}
	},
	SetSelectedItem:function(item)
	{
		this.selectedItem = item;
	},
	//删除邮件
	DelateMail:function()
	{
		if(Mgr.mail.mailList.Values().length<1){ return;}
		var selectedItem = this._GetSelectedItem();
		var len = selectedItem.length;
		var isPiliang = false;
		if(len < 1)
		{
			if(!this.selectedItem)
			{
				Mgr.tips.ShowNotice("您没选中邮件");
				return;
			}
			if( this.selectedItem.data.isReceive || (this.selectedItem.imgOpen.visible && this.selectedItem.data.items.length==0 ))
			{
				var mailids = [this.selectedItem.data.mailInfoId];
				this._DeleteOption(this.selectedItem,isPiliang);
				Mgr.mail.SendReqRDelMailMessage(mailids);
			}
			else
			{
				Mgr.tips.ShowNotice("邮件内有未领取道具，无法删除");
			}
		}
		else //批量处理
		{
			var mailids = [];
			var items = [];
			var readCount = 0;
			for (var i = 0; i < len; i++ )
			{
				if(selectedItem[i].imgOpen.visible)
				{
					readCount++;
				}
				if ((!selectedItem[i].data.isReceive && selectedItem[i].data.items.length>0)||!selectedItem[i].imgOpen.visible )
				{
					continue;
				}
				mailids.push(selectedItem[i].data.mailInfoId);
				items.push(selectedItem[i]);
			}
			if(items.length == 0)
			{
				if(readCount != len)
				{
					Mgr.tips.ShowNotice("邮件尚未阅读，无法删除");
				}
				else
				{
					Mgr.tips.ShowNotice("邮件内有未领取道具，无法删除");
				}
				return;
			}
			var lenn = Mgr.mail.mailList.Size();
			if(lenn == items.length)
			{
				isPiliang = true;
			}
			for (var i = 0; i < items.length; i++ )
			{
				this._DeleteOption(items[i],isPiliang);
			}
			Mgr.mail.SendReqRDelMailMessage(mailids);
		}
		this.sbtnGouxuan.SetButtonState(this.sbtnGouxuan._btnStates[0]);
		this.isChecked = false;
	},
	_DeleteOption:function(item,isPiliang)
	{
		this._currentY = 0;
		this._ClearPanel();
		Mgr.mail.mailList.Remove(item.data.mailInfoId);
		this.selectItemArr.Remove(item.data.mailInfoId);
		var len = Mgr.mail.mailList.Values().length;
		if( len > 0 && !isPiliang)
		{
			Mgr.mail.SendReqGetMailAttachmentMessage(Mgr.mail.mailList.Values()[0].mailInfoId);
		}
		else
		{
			this.labCue.visible = true;
			this._ClearPanel();
		}
		this._ClearItemsSelected();
		Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).CheckMailReceive();
		this.UpdateTableview();
	},
	_ClearItemsSelected:function()
	{
		var items = Mgr.mail.mailList.Values();
		for (var i = 0 , len = items.length; i < len; i ++)
		{
			items[i].isChecked = false;
		}
	},
	_ClearPanel:function()
	{
		this.labName.SetString("");
		this.labTitle.SetString("");
		this.labcontent.SetString("");
		this.imgDikuang.visible = false;
		this._ShowGridItem(false);
	},
	_ShowGridItem:function(isShow)
	{
		var items = this._gridArr;
		for(var i = 0; i < items.length; i++)
		{
			items[i].visible = isShow;
		}
	},
	_GetSelectedItem:function()
	{
		var itemArr = [];
		var items = this.selectItemArr.Values();
		for (var i = 0,len = items.length; i < len; i++ )
		{
			itemArr.push(items[i]);
		}
		return itemArr;
	},
	//领取邮件
	ReceiveMail:function()
	{
		if(Mgr.mail.mailList.Size()<1){return;}
		var selectedItem = this._GetSelectedItem();
		var len = selectedItem.length;
		if(len < 1)
		{
			if(!this.selectedItem)
			{
				Mgr.tips.ShowNotice("您没选中邮件");
				return;
			}
			if( !this.selectedItem.data.isReceive)
			{
				var mailids = [this.selectedItem.data.mailInfoId];
				Mgr.mail.SendReqReceiveMailMessage(mailids);
			}
		}
		else //批量处理
		{
			var mailids = [];
			for (var i = 0; i < len; i++ )
			{
				mailids.push(selectedItem[i].data.mailInfoId);
			}
			Mgr.mail.SendReqReceiveMailMessage(mailids);
		}
	},
	//领取邮件成功后的刷新操作
	ReceivedUpdateInfo:function(msg)
	{
		var mailId = msg.mailId;
		var item = Mgr.mail.mailList.Get(mailId);
		if(item)
		{
			item.isReceive = 1;
		}
		this.selectItemArr.Clear();
		this._ClearItemsSelected();
		this.UpdateTableview();
		this.sbtnGouxuan.SetButtonState(this.sbtnGouxuan._btnStates[0]);
		this.isChecked = false;
		this._SetBtnGetVisible(false);
		Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName).CheckMailReceive();

		for ( var i = 0; i < this._gridArr.length; i++ )
		{
			if( this._gridArr[i].visible )
				Filter.GrayScale(this._gridArr[i]);
		}

        /// 针对有的又见默认领去附件删除的。默认选取
        if(!item){
            if(Mgr.mail.mailList.Values().length == 0){
                this.labCue.visible = true;
            }else{
                Mgr.mail.SendReqGetMailAttachmentMessage(Mgr.mail.mailList.Values()[0].mailInfoId);
                this.labCue.visible = false;
            }
        }
	},
	//当item大于100条的时候自动删除最老的item
	_CheckAndDeleteListviewItem:function()
	{
		var items = Mgr.mail.mailList.Values();
		var len = items.length;
		if(len > 100)
		{
			for(var i = 100;i<len; i++ )
			{
				Mgr.mail.mailList.Remove(items[i].mailInfoId);
				this.selectItemArr.Remove(items[i].mailInfoId);
			}
		}
		this.UpdateTableview();
	},
	//附件中的元宝和绑定元宝
	_SetGoldAndBGold:function(item)
	{
		if(item)
		{
			this.labGold1.SetString(item.num);
		}
		else
		{
			this.labGold1.SetString(0);
		}
	},
	OnShow:function()
	{
		this.UpdateTableview();
		if(Mgr.mail.mailList.Values().length == 0)
		{
			this.labCue.visible = true;
		}
		else
		{
			Mgr.mail.SendReqGetMailAttachmentMessage(Mgr.mail.mailList.Values()[0].mailInfoId);
			this.labCue.visible = false;
		}
	},
	//设置邮件已读标志
	_SetMailReadedFlag:function(data)
	{
		var items = Mgr.mail.mailList.Values();
		for(var i = 0,len = items.length; i<len; i++)
		{
			items[i].isSelected = false;
		}
		var item = Mgr.mail.mailList.Get(data.mailInfoId);
		if(item)
		{
			item.isReaded = true;
			item.isSelected = true;
		}
		this.UpdateTableview();
	},
	_GetYoujianPanel:function()
	{
		this.yjPanel = this;
		return this.yjPanel;
	},
	_SetBaseProperty:function()
	{
		this.labFajianren.SetColor(EnumFontFormat.COMMON_COLOR02);
		this.labFajianren.SetFontSize(22);
		this.labBiaoti.SetColor(EnumFontFormat.COMMON_COLOR02);
		this.labBiaoti.SetFontSize(22);
		this.labCue.SetColor(EnumFontFormat.COMMON_COLOR08);
		this.labCue.SetFontSize(24);
		this.labName.SetColor(EnumFontFormat.COMMON_COLOR03);
		this.labName.SetFontSize(22);
		this.labTitle.SetColor(EnumFontFormat.COMMON_COLOR03);
		this.labTitle.SetFontSize(22);
		this.labcontent.SetColor(EnumFontFormat.COMMON_COLOR03);
		this.labcontent.SetFontSize(22);
		this.labGold1.SetColor(EnumFontFormat.COMMON_COLOR03);
		this.labGold1.SetFontSize(24);
		this.labAll.SetColor(EnumFontFormat.COMMON_COLOR02);
		this.labAll.SetFontSize(22);
		this.labcontent.SetMultiline(10);
	},
	_HandleTableview:function()
	{
		var tableview = new cc.TableView(this,cc.size(370+50,505));
		tableview.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
		tableview.setDelegate(this);
		tableview.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
		this.addChild(tableview);
		tableview.reloadData();
		tableview.setBounceable(true);
		tableview.setPosition(-2,100);
		this._tableview = tableview;
	},
	UpdateTableview:function()
	{
		this._tableview.reloadData();
		var ct = this._tableview.getContainer();
		var hh = ct.getContentSize().height;
		if(hh>515)
		{
			ct.y = this._currentY;
			this._tableview.scrollViewDidScroll(this);
		}
	},
	tableCellTouched: function (table, cell) {
	},
	tableCellHighlight:function(table, cell){
	},
	tableCellUnhighlight:function(table, cell){
	},
	tableCellWillRecycle:function(table, cell){
		var ct = table.getContainer();
		this._currentY = ct.y;
	},
	tableCellSizeForIndex: function (table, idx) {
		return cc.size(364,91);
	},
	tableCellAtIndex: function (table, idx) {
		var cell = table.dequeueCell();
		var data = Mgr.mail.mailList.Values().sort(function (a, b) {
            return b.sendTime - a.sendTime;
        })[idx];
		if (!cell) {
			cell=cc.Sprite();
			var item=new YoujianFrameExt(data);
			item.LoadPanel();
			cell.item=item;
			cell.addChild(item);
		} else {
			cell.item.UpdateInfo(data);
		}
		return cell;
	},
	numberOfCellsInTableView: function (table) {
		return Mgr.mail.mailList.Size();
	},
} );
YoujianMainExt.PanelName = "YoujianMainExt";
PanelClassDic["YoujianMainExt"] = YoujianMainExt;












