var ActiveMarkExt = GuildBossMark.extend ( {
	_className:"ActiveMarkExt",
	_type:0,
	ctor:function(){
		this._super();
        this.layoutCom.layoutType = MLLAYOUT_RB;
        this.layoutCom.layoutOffy = 200;
        this.layoutCom.layoutOffx = -318;
	},

    GetActivityIcon:function(type){
        var url = null;
        switch (type)
        {
            case EnumZoneActiveType.TYPE_GUARDCPITAL:
            {
                url = "other/zhujiemian/huodongicon/swjc_btn.png";
                break;
            }
            case EnumZoneActiveType.TYPE_SWORD:
            {
                url = "other/zhujiemian/huodongicon/hslj_btn.png";
                break;
            }
            case EnumZoneActiveType.TYPE_GUILD:
            {
                url = "other/zhujiemian/huodongicon/bhdt_btn.png";
                break;
            }
            case EnumZoneActiveType.TYPE_GUILDBOSS:
            {
                url = "other/zhujiemian/huodongicon/bangpaishouling.png";
                break;
            }
            case EnumZoneActiveType.TYPE_ZONE:
            {
                url = "other/zhujiemian/huodongicon/yingxiongjueqi.png";
                break;
            }
            case EnumZoneActiveType.TYPE_HUSONG:
            {
                url = "other/zhujiemian/huodongicon/hs_btn.png";
                break;
            }
            case EnumZoneActiveType.TYPE_KINGGUID:
            {
                url = "other/zhujiemian/huodongicon/bangpaizhengba.png";
                break;
            }
            case EnumZoneActiveType.TYPE_KINGNEUTRAL   :
            {
                url = "other/zhujiemian/huodongicon/wangchenglingdi.png";
                break;
            }
            case EnumZoneActiveType.TYPE_MASTERBUCKET:{
                url = "other/zhujiemian/huodongicon/zmdb_btn.png";
                break;
            }
            case EnumZoneActiveType.TYPE_WORLDBOSS:{
                url = "other/zhujiemian/huodongicon/sjBOSS_btn.png";
                break;
            }
            case EnumZoneActiveType.TYPE_ZHUJIANTIANXIA:{
                url = "other/zhujiemian/huodongicon/zhujiantianxia.png";
                break;
            }
            case EnumZoneActiveType.TYPE_ERENGU:{
                url = "other/zhujiemian/huodongicon/erengu.png";
                break;
            }

            default :break;
        }

        return url;
    },

	SetType:function(type,info){
		this._type = type;
		var url = "";
		var data = Mgr.activeMark.GetDataByType(type,info);

        var url = this.GetActivityIcon(type)
		this.lab2.visible = false;
		if(data)
		{
			this.lab2.visible = true;
			this.lab2.SetString(data.q_time);
		}
		var imgMode = this.imgIcon;
		EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
			imgMode.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
		}, imgMode);
	},

	Init:function() {
		var self = this;
		GuildBossMark.prototype.Init.call(this);

		this.btnClose.addClickEventListener(function (event) {
			self.visible = false;
		});
		this.btnJoin.addClickEventListener(function (event) {
            var exitZone = false;
            if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_KFDR){
                Mgr.cross.SendReqQuitClientToFightMessage();
                exitZone = true;
            }else if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_LFDR){
                Mgr.zone.SetCurrentZoneType(-1);
                Mgr.zone.SendReqZoneOutToGameMessage();
                exitZone = true;
            }else if(Mgr.monster.IsInMonsterMap()){
                Mgr.map.SendReqReturnToPreviousMapMessage();
                exitZone = true;
            }else if( Mgr.sceneMap.ZoneType() ){
                Mgr.zone.SendReqZoneOutToGameMessage();
                exitZone = true;
            }

            /// 先退出当前再进入下一个
            if(exitZone){
                Mgr.activeMark.GotoActivityOnMapChanged(self._type);
            }else{
                Mgr.activeMark.GotoActivity(self._type);
            }

            self.visible = false;
		});
	},
	OnShow:function()
	{
	}
} );
ActiveMarkExt.PanelName = "ActiveMarkExt";
PanelClassDic["ActiveMarkExt"] = ActiveMarkExt;