var FBAwardPanelExt = FBAwardPanel.extend ( {
	_className:"FBAwardPanelExt",

    gridList:null,
    firstGridList:null,
    nowWave:null,

	ctor:function(){
		this._super();
		this.gridList = [];
		this.firstGridList = [];
	},

    Init:function(){
        FBAwardPanel.prototype.Init.call( this );
        this.btnGet.visible = false;
        this.labAwardCue1.visible = false;
        this.gridAward.visible = false;
        this.gridAward1.visible = false;

        this.confMap = Q_map.Get(Mgr.sceneMap.nMapId);
        this.zoneType = Mgr.sceneMap.ZoneType();
        // this.zoneId = Mgr.sceneMap.GetZoneModelIdByMapId(Mgr.sceneMap.nMapId);
        var self = this;
        this.btnGet.addClickEventListener(function(event){
            if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JY){
                Mgr.zone.SendReqExpFirstRewardToGameMessage(self.nowWave);
            }
        });

        // this.InitView();
    },

    InitView:function(isFirst){
	    var reward;
	    if(Mgr.zone.IsInZoneMap()){
            switch(this.zoneType){
                case EnumZoneType.TYPE_JQ:
                    this.labFB1.SetText("剧情副本");
                    this.labAwardCue.SetText("通关奖励");
                    // this.labAwardCue1.SetText("随机奖励");
                    // if(Mgr.zone.juqingZoneMax > Mgr.zone._curZoneId)
                    //     reward = JSON.parse(Q_story.Get(Mgr.zone._curZoneId).q_reward);
                    // else
                    //     reward = JSON.parse(Q_story.Get(Mgr.zone._curZoneId).q_first_reward);
                    reward = JSON.parse(Q_story.Get(Mgr.zone._curZoneId).q_first_reward);
                    this.InitGird(reward);
                    break;
                case EnumZoneType.TYPE_JJ:
                    this.labFB1.SetText("进阶副本");
                    this.labAwardCue.SetText("通关奖励");
                    // this.labAwardCue1.SetText("随机奖励");
                    reward = JSON.parse(Q_story.Get(Mgr.zone._curZoneId).q_reward);
                    this.InitGird(reward);
                    break;
                case EnumZoneType.TYPE_JY:
                    this.labFB1.SetText("经验副本");
                    this.labAwardCue.SetText("通关奖励");
                    // this.labAwardCue1.SetText("随机奖励");
                    reward = JSON.parse(Q_exp_zone.Get(Mgr.zone.jingyanDeployNum).q_reward);
                    this.InitGird(reward);
                    this.UpdateView();
                    break;
                case EnumZoneType.TYPE_WD:
                    this.labFB1.SetText("问鼎江湖");
                    // this.labAwardCue1.SetText("随机奖励");
                    if(Mgr.zonejianghu.jianghuMaxWave >= Mgr.zone.jingyanDeployNum){
                        this.labAwardCue.SetText("通关奖励");
                        reward = JSON.parse(Q_temple.Get(Mgr.zone.jingyanDeployNum).q_reward_daily);
                    }
                    else{
                        this.labAwardCue.SetText("首通奖励");
                        reward = JSON.parse(Q_temple.Get(Mgr.zone.jingyanDeployNum).q_reward_first);
                    }
                    this.InitGird(reward);
                    break;
                case EnumZoneType.TYPE_VIP:
                    this.labFB1.SetText("VIP副本");
                    this.labAwardCue.SetText("通关奖励");
                    // this.labAwardCue1.SetText("随机奖励");
                    reward = JSON.parse(Q_story.Get(Mgr.zone._curZoneId).q_reward);
                    this.InitGird(reward);
                    break;
            }
        }
        else if(Mgr.monster.IsInMonsterMap()){
            this.labFB1.SetText("世界首领");
            this.labAwardCue.SetText("通关奖励");
            this.labAwardCue1.SetText("随机奖励");
        }
    },

    InitGird:function(reward){
	    for(var i = 0; i < reward.length; i++){
	        if(!this.gridList[i]){
	            var grid = new GridItem();
                grid.ParseJson(this.gridAward.jsonobj);
                grid.Init();
                this.addChild(grid);
                grid.x += i%4 * (grid.uiWidth + 5);
                grid.y -= parseInt(i/4) * (grid.uiHeight + 10);
                this.gridList.push(grid);
            }
            var coinInfo = {};
            coinInfo.itemModelId = reward[i].mod;
            coinInfo.itemNum = reward[i].num;
            coinInfo.itemBind = reward[i].bind;
            GridUtil.SetItemGrid(this.gridList[i], coinInfo);
        }
    },

    InitFirstGird:function(reward){
        for(var i = 0; i < reward.length; i++){
            if(!this.firstGridList[i]){
                var grid = new GridItem();
                grid.ParseJson(this.gridAward1.jsonobj);
                grid.Init();
                this.addChild(grid);
                grid.x += i%4 * (grid.uiWidth + 5);
                grid.y -= parseInt(i/4) * (grid.uiHeight + 10);
                this.firstGridList.push(grid);
            }
            var coinInfo = {};
            coinInfo.itemModelId = reward[i].mod;
            coinInfo.itemNum = reward[i].num;
            coinInfo.itemBind = reward[i].bind;
            GridUtil.SetItemGrid(this.firstGridList[i], coinInfo);
        }
        this.btnGet.x = this.firstGridList[reward.length - 1].x + this.firstGridList[reward.length - 1].uiWidth + 5;
        this.btnGet.y = this.firstGridList[reward.length - 1].y + 5;
    },

    UpdateView:function(){
        var reward;
        if(Mgr.zone.IsInZoneMap()){
            switch(this.zoneType){
                case EnumZoneType.TYPE_JQ:
                    break;
                case EnumZoneType.TYPE_JJ:
                    break;
                case EnumZoneType.TYPE_JY:
                    this.labFB1.SetText("经验副本");
                    this.labAwardCue.SetText("通关奖励");
                    var str = "";
                    if(Mgr.zone.jingyanFristRewardWave.length > 0){
                        str = Mgr.zone.jingyanFristRewardWave[Mgr.zone.jingyanFristRewardWave.length - 1] + 5;
                    }
                    else{
                        str = 5;
                    }
                    this.nowWave = str;
                    if(Mgr.zone.jingyanMaxWave >= this.nowWave || Mgr.zone.jingyanDeployNum > this.nowWave){
                        this.btnGet.visible = true;
                        Mgr.task._taskTrackPanel.UpdateAwardWarn(true);
                    }
                    else{
                        this.btnGet.visible = false;
                        Mgr.task._taskTrackPanel.UpdateAwardWarn(false);
                    }
                    reward = JSON.parse(Q_exp_zone.Get(str).q_reward_first);
                    this.InitFirstGird(reward);
                    this.labAwardCue1.visible = true;
                    this.labAwardCue1.SetText("首通第" + TextUtil.AddColor(str, "00eefd") + "波奖励");
                    break;
                case EnumZoneType.TYPE_WD:
                    break;
                case EnumZoneType.TYPE_VIP:
                    break;
            }
        }
        else if(Mgr.monster.IsInMonsterMap()){
        }
    },
} );
FBAwardPanelExt.PanelName = "FBAwardPanelExt";
PanelClassDic["FBAwardPanelExt"] = FBAwardPanelExt;
