var DuorenPanelExt = DuorenPanel.extend ( {
	_className:"DuorenPanelExt",
	isShowTween : true,
	mainPanel:null,
	zonetype:0,
	_timerNum:0,
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -28;
	},
	Init:function()
	{
		DuorenPanel.prototype.Init.call(this);
		this.labCue.SetColor(EnumFontFormat.COMMON_COLOR02);
		this._HandleButton();
		this._AddMainPanel();
	},
	_HandleButton:function() {
		var self = this;
		this.btnClose.setLocalZOrder(100);
		this.btnClose.addClickEventListener( function () {
			self.ClosePanel();
		} );
	},
	_AddMainPanel:function()
	{
		var mainPanel = new DuorenTeamMainExt();
		mainPanel.LoadPanel();
		this.addChild(mainPanel);
		this.mainPanel = mainPanel;
	},
	ClosePanel:function()
	{
		Mgr.crossteam.isCancelReady = false;
		EngineMgr.uiMgr.HidePanel( this );
	},
	ShowContentByType:function(type)
	{
		this.zonetype = type;
		// cc.log("=======ShowContentByType=========" + type)
		if(type == EnumZoneType.TYPE_LFDR)
		{
			//Mgr.zoneteam.RequestZoneListData();
			this.mainPanel.SetReward();
			this.labTitlle.visible = true;
			this.labTitlle1.visible = false;
		}
		else if(type == EnumZoneType.TYPE_KFDR)
		{
			//Mgr.crossteam.RequestZoneListData();
			this.labTitlle.visible = false;
			this.labTitlle1.visible = true;
			Mgr.crosszone.SendReqCrossZonePanelMessage();
		}

		this._ClearTime();
		this._timerNum = TimerUtil.TimeUpdate(this._SetRefreshTimer, this, 3);
	},
	//每隔三秒刷新一次面板
	_SetRefreshTimer:function()
	{
		if(this.zonetype == EnumZoneType.TYPE_LFDR)
		{
			Mgr.zoneteam.SendReqZoneTeamClientToGameMessage();
		}
		else if(this.zonetype == EnumZoneType.TYPE_KFDR)
		{
			if(this.mainPanel.selectedItem)
			{
				var msg = {
					zoneModelId : this.mainPanel.selectedItem.data.base.zoneModelid, // 绑定副本模版(0表示所有副本)
					startNum : 0, // 第几个开始
					num : 30, // 需要显示几个
					type : 0, // 0所有 1允许加入的队伍
				}
				Mgr.crossteam.SendReqCrossTeamsForZoneModelClientToGameMessage(msg);
			}
		}
	},
	OnShow:function()
	{
        this.mainPanel.OnShow();
	},
	OnHide:function()
	{
		this._super();
		this._ClearTime();
        this.mainPanel.OnHide();
	},
	_ClearTime:function()
	{
        if(this._timerNum) TimerUtil.ClearTimeUpdate(this._timerNum);
        this._timerNum = null;
	}
} );
DuorenPanelExt.PanelName = "DuorenPanelExt";
PanelClassDic["DuorenPanelExt"] = DuorenPanelExt;


















