var DuorenSmallListInfoExt = DuorenSmallListInfo.extend ( {
	_className: "DuorenSmallListInfoExt" ,
	detailPanel: null ,
	index:0,
	data:null,
	_gridArr:[],
	ctor: function (data) {
		this._super();
		this.data = data;
	} ,
	Init: function () {
		DuorenSmallListInfo.prototype.Init.call( this );
		var self = this;
		//this._AddDetailPanel();
		this.SetData(this.data);
		this._SetReward(this.data);
		this.imgBg.setTouchEnabled(true);
		this.imgBg.addTouchEventListener(function(target,state)
		{
			if(state == ccui.Widget.TOUCH_ENDED)
			{
				self._HandleClickEvent();
			}
		});
	} ,
	_HandleClickEvent:function()
	{
		var pLevel = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
		if(pLevel >= this.data.detail.q_level)
		{
			if(!this.detailPanel)
			{
				this._AddDetailPanel();
			}
			this.ShowDetailEvent();
		}
		else
		{
			Mgr.tips.ShowNotice("等级不足");
		}
	},
	_AddDetailPanel: function () {
		var detailPanel = new DuorenBigListInfoExt();
		detailPanel.LoadPanel();
		this.addChild( detailPanel );
		this.detailPanel = detailPanel;
		this._gridArr = [
			detailPanel.gridItem,
			detailPanel.gridItem2,
			detailPanel.gridItem3,
			detailPanel.gridItem4,
			detailPanel.gridItem5,
		]
		this._HandleClickEvent();
	},
	ShowDetailEvent:function(target,state)
	{
		if(!this.detailPanel)
		{
			this._AddDetailPanel();
		}
		this.detailPanel.SetData(this.data);
		this._SetRewardDetail();
		this.UpdateContentSize(true);
		Mgr.crossteam.RefreshScrollviewSize(this.index);
		this._GetMainPanel().ShowOrHideTeamlist(this.data.base.zoneModelid);
	},
	UpdateContentSize:function(isDetail)
	{
		if(!this.detailPanel)
		{
			return;
			//this._AddDetailPanel();
		}
		var gap = 0;
		var height = this.imgBg.height+gap;
		if(isDetail)
		{
			height = this.detailPanel.height+gap;
		}
		this.imgBg.visible = !isDetail;
		this.detailPanel.visible = isDetail;
		this.imgBg.y = height - this.imgBg.height>>1;
		this.detailPanel.y = height - this.detailPanel.height>>1;
		this.setContentSize( this.width , height );
	},
	_GetMainPanel:function()
	{
		return Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName ).mainPanel
	},
	SetIndex:function(index)
	{
		this.index = index;
	},
	SetData:function(data)
	{
		//Profiler.Start("start---------------------------------------xixixii__0");
		this.data = data;
		this.labFBname.SetString(data.detail.q_name);
		this.labNumber.SetString(data.detail.q_level);
		this.labNumber1.SetString(EnumCrossteamType.TEAM_MEM_NUMBER);
		//this.detailPanel.SetData(data);
		//Profiler.Stop("start---------------------------------------xixixii__0");
		this._SetGray();
	},
	_SetGray:function()
	{
		var pLevel = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
		if(this.data.detail.q_level > pLevel)
		{
			Filter.GrayScale(this);
		}
		else
		{
			Filter.UnGray(this);
		}
	},
	_SetReward:function(data)
	{
		if(data.item)
		{
			var str = "每次通关奖励：";
			var reward02 = JSON.parse(data.item.q_daily_reward)[0];//每日通关奖励
			var isOverLevel = Mgr.crosszone.crosszonePanelList.Get(data.item.q_id ).isOver;
			if(!isOverLevel)
			{
				reward02 = JSON.parse(data.item.q_first_reward)[0];
				str = "首次通关奖励：";
			}
			var data02 = ItemUtil.ItemIdToItem(reward02.mod,reward02.num);
			GridUtil.SetItemGrid(this.gridItem1,data02);
			this.labCue1.SetString(str);
		}
	},
	_SetRewardDetail:function()
	{
		var data = this.data;
		if(data.item)
		{
			var reward01 = JSON.parse(data.item.q_item_show);//几率掉落奖励

            for(var i = 0;i<reward01.length; i++)
            {
                var data01 = ItemUtil.ItemIdToItem(reward01[i].mod,reward01[i].num);
                GridUtil.SetItemGrid(this._gridArr[i],data01,null,null,null,null,false);
            }

            for(;i<this._gridArr.length;i++){
                this._gridArr[i].visible = false;
            }

            //old,需要根据每个格子具体的掉落奖品来生成格子
			// for(var i = 0,len = this._gridArr.length;i<len; i++)
			// {
			// 	var data01 = ItemUtil.ItemIdToItem(reward01[i].mod,reward01[i].num);
			// 	GridUtil.SetItemGrid(this._gridArr[i],data01,null,null,null,null,false);
			// }
			var str = "每次通关奖励：";
			var reward02 = JSON.parse(data.item.q_daily_reward)[0];//每日通关奖励
			var isOverLevel = Mgr.crosszone.crosszonePanelList.Get(data.item.q_id ).isOver;
			if(!isOverLevel)
			{
				reward02 = JSON.parse(data.item.q_first_reward)[0];
				str = "首次通关奖励：";
			}
			var data02 = ItemUtil.ItemIdToItem(reward02.mod,reward02.num);
			GridUtil.SetItemGrid(this.detailPanel.gridItem1,data02);
			this.detailPanel.labCue1.SetString(str);
		}
	}
});
DuorenSmallListInfoExt.PanelName = "DuorenSmallListInfoExt";
PanelClassDic["DuorenSmallListInfoExt"] = DuorenSmallListInfoExt;
