var ExpFubenWinExt = FubenWin.extend ( {
	_className:"ExpFubenWinExt",
	_rawardCon:null,
	_timerNum:0,
	_time:0,
	_nowWave:0,
	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.setSwallowTouches(true);
	},

	SetInfo:function(nowWave){
		this._nowWave = nowWave;
		this.UpdateRaward();

		this._time = 10;
		this.OnTimer();
		TimerUtil.ClearTimeUpdate(this._timerNum, this);
		this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
		var self = this;
		this.btnOk.addClickEventListener(function (event){
			self.OutZone();
		});

		this.UpdateBtnState();
	},

	OutZone:function(){
		Mgr.zone.SendReqZoneOutToGameMessage();
	},

	UpdateRaward:function(){
		var oldWave = Mgr.zone.jingyanEntermapWave;
		if(this._rawardCon == null){
			UIUtil.UIRemoveSelf(this.gridItem);
			this._rawardCon = new TaskRewardsGridCon();
			this.imgBg.addChild(this._rawardCon);
		}
		this._rawardCon.Clear();
		var rawardStr = "";
		var zoneData = null;
		var rewardHash = {};
		var dropRawards = null;
		if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JY){
			for( oldWave; oldWave <= this._nowWave; oldWave++ ){
				zoneData = Q_exp_zone.Get(oldWave);
				rawardStr = JSON.parse( zoneData.q_reward );
                for ( i = 0; i < rawardStr.length ; i ++){
                    var v = rawardStr[i];
                    rewardHash[v.mod] = rewardHash[v.mod] || 0;
                    rewardHash[v.mod] += v.num;
                }
			}
			zoneData = Q_exp_zone.Get(oldWave);
			dropRawards = Mgr.drop.GetDropSimpleItemInfos(zoneData.q_zone);
			this.btnGo.setVisible(true);
			this.btnOk.x = this.btnOk.initX;
		}else if( Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_SWORD ){
			rawardStr =  JSON.parse( Q_global.Get(1036).q_string_value)[0];
            for ( i = 0; i < rawardStr.length ; i ++){
                var v = rawardStr[i];
                rewardHash[v.mod] = rewardHash[v.mod] || 0;
                rewardHash[v.mod] += v.num;
            }
			this.btnGo.setVisible(false);
			this.btnOk.x = (this.imgBg.uiWidth - this.btnOk.width)/2;
		}
		if( rawardStr == "" && dropRawards == null ){
			this._rawardCon.setVisible(false);
			this.labJiangli.setVisible(false);
		}
		else{
			this.labJiangli.setVisible(true);
			var count = 0;
			var i = 0;
			for(var k in rewardHash){
                var v = rewardHash[k];
				var item = ItemUtil.ItemIdToItem(k,v);
				this._rawardCon.AddComItem(item,this.gridItem);
				count++;
			}

			if( dropRawards ){
				for ( i = 0; i < dropRawards.length ; i ++){
					var item = ItemUtil.ItemIdToItem(dropRawards[ i ].itemModelId,dropRawards[ i ].num);
					this._rawardCon.AddComItem(item,this.gridItem);
					count++;
				}
			}

			if ( count > 0 ){
				this._rawardCon.Layout( this.gridItem.uiWidth * count, this.gridItem.uiHeight, this.gridItem.uiWidth, this.gridItem.uiHeight );
				this._rawardCon.x = ( this.imgBg.uiWidth - this.gridItem.uiWidth * count ) / 2;
				this._rawardCon.y = this.gridItem.y;
			}
		}
	},

	UpdateBtnState:function(){
		if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JY){
			this.btnGo.setVisible(false);
			this.btnOk.x = (this.imgBg.uiWidth - this.btnOk.uiWidth)/2;
		}
	},

	OnTimer:function () {
		this._time--;
		if( this._time == 0 ){
			this.OutZone();
			TimerUtil.ClearTimeUpdate(this._timerNum, this);
			return;
		}
		this.labCue1.SetHtmlText(TextUtil.FormatStr( this.labCue1.GetHtmlText(), [ this._time ] ));
	},
	
	OnHide:function(){
		this._super();
		TimerUtil.ClearTimeUpdate(this._timerNum, this);
		this._rawardCon.Clear();
		this._zoneModelId = 0;
		this._nowWave = 0;
	}
} );
ExpFubenWinExt.PanelName = "ExpFubenWinExt";
PanelClassDic["ExpFubenWinExt"] = ExpFubenWinExt;
